import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.util.Vector;

public class JDPAlphaLayout extends JDPClassLayout {
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPSelectDSN targetDSN;
   JDPSelectColumns target;
   JDPSelectTable tableTarget;
   JDPLayoutMgr targetLayoutMgr;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPScrollPanel ScrollPanel1;
   Label Label;
   Label Label0;
   Label Label1;
   JDPComboBox commPort;
   JDPComboBox baudRate;
   JDPComboBox serviceProviderColumn;
   JDPComboBox pagerPINColumn;
   Label Label2;
   Label Label5;
   TextArea message;
   JDPButtons JDPButtons1;

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPAlphaLayout" + super.componentName;
      var1.restoreObject(this.commPort, var2, "commPort");
      var1.restoreObject(this.baudRate, var2, "baudRate");
      var1.restoreObject(this.serviceProviderColumn, var2, "serviceProviderColumn");
      var1.restoreObject(this.pagerPINColumn, var2, "pagerPINColumn");
      var1.restoreObject(this.message, var2, "message");
      return true;
   }

   void loadLayoutComponent() {
      if (this.targetLayoutMgr != null && !this.targetLayoutMgr.projectLoading) {
         if (super.thisBranch.leaves.size() > 0) {
            this.targetLayoutMgr.lView.removeSelectedBranch();
         }

         if (this.target.columns.countItems() > 0) {
            JDPTreeBranch[] var1 = new JDPTreeBranch[1];
            JDPTreeBranch[] var3 = this.targetLayoutMgr.layoutTree.getTreeBranch(super.thisBranch.thisObject);
            boolean var4 = this.targetLayoutMgr.projectLoading;
            this.targetLayoutMgr.projectLoading = true;
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Ctl";
            var1[0].compType = "JDPAlphaSender";
            var1[0].icon = 36;
            Object var2 = null;
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var2);
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Msg";
            var1[0].compType = "TextArea";
            var1[0].icon = 15;
            TextArea var27 = new TextArea(this.message.getText(), 4, 30);
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var27);
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Pnl";
            var1[0].compType = "Panel";
            var1[0].icon = 24;
            Panel var28 = new Panel();
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var28);
            JDPTreeBranch var5 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Btns";
            var1[0].compType = "JDPButtons";
            var1[0].icon = 17;
            String[] var6 = new String[]{"Send"};
            int[] var7 = new int[]{44};
            JDPButtons var29 = new JDPButtons(super.user, var6, var7, JDPButtons.HORIZONTAL);
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var29);
            JDPTreeBranch var8 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Pnl1";
            var1[0].compType = "Panel";
            var1[0].icon = 24;
            Panel var30 = new Panel();
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var30);
            JDPTreeBranch var9 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Merge";
            var1[0].compType = "JDPList";
            var1[0].icon = 21;
            JDPList var31 = new JDPList(super.user);
            if (this.target != null) {
               String[] var10 = this.target.columns.getSelectedItems();
               ((JDPList)var31).loadList(var10, var10);
            } else {
               ((JDPList)var31).removeAll();
            }

            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var31);
            JDPTreeBranch var32 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            var32.text = new String[1];
            var32.text[0] = var32.name + "Main|R|";
            String[] var10000 = var32.text;
            var10000[0] = var10000[0] + this.targetLayoutMgr.gSource.createComment("Load Merge List");
            var10000 = var32.text;
            var10000[0] = var10000[0] + "\tpublic void " + var32.name + "Main() {\r\n\r\n";
            var10000 = var32.text;
            var10000[0] = var10000[0] + "\t\t" + var32.name + " = new JDPList(user);\r\n";
            var10000 = var32.text;
            var10000[0] = var10000[0] + "\t\tString[] columns = {\"";
            String[] var11 = this.target.columns.getSelectedItems();

            for(int var12 = 0; var12 < var11.length; ++var12) {
               if (var12 > 0) {
                  var10000 = var32.text;
                  var10000[0] = var10000[0] + "\",\"";
               }

               var10000 = var32.text;
               var10000[0] = var10000[0] + var11[var12];
            }

            var10000 = var32.text;
            var10000[0] = var10000[0] + "\"};\r\n";
            var10000 = var32.text;
            var10000[0] = var10000[0] + "\t\t" + var32.name + ".loadList(columns, columns);\r\n";
            var10000 = var32.text;
            var10000[0] = var10000[0] + "\r\n\t}\r\n";
            var8.treeVector = new Vector();
            JDPTreePicker var33 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
            int[] var13 = new int[]{4, 1, 2, 1};
            var33.setIcons(var13);
            var33.setRoot("Component Events", true);
            JDPTreeBranch var14 = var33.treeRoot;
            Object[] var15 = new Object[]{null, "Methods"};
            String[] var16 = new String[]{null, "Drop here to attach this component/method to this Event"};
            var33.setDropKeys(var15);
            var33.setDragAndDrop((boolean[])null);
            var33.setDropMessages(var16);
            String[] var17 = new String[]{null, null, null, null};
            int var18 = 0;

            do {
               var17[0] = "ACTION_BTN_" + Integer.toString(var18);
               boolean[] var19 = new boolean[]{true, true, true, false};
               var33.setIcons(var13);
               var33.setExpanded(var19);
               var33.addEntry(var17, var13, "ACTION_BTN_" + Integer.toString(var18));
               ++var18;
            } while(var18 < 1);

            var8.treeVector.addElement(var14);
            var13[2] = 36;
            var17[1] = super.thisBranch.name + "Ctl1";
            if (JDPJagg.useJaggServer) {
               var17[2] = "setDSN(String)";
               var33.addEntry(var17, var13, var17[2]);
               JDPTreeBranch var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setDSN(\"" + this.targetDSN.datasource.getText() + "\");";
               String[] var51 = new String[]{"String"};
               this.loadParameters(var35, var51);
               var17[2] = "setJdbcDriver(String)";
               var33.addEntry(var17, var13, var17[2]);
               var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setJdbcDriver(\"" + this.targetDSN.jdbcdriver.getText() + "\");";
               this.loadParameters(var35, var51);
               var17[2] = "setJdbcPrefix(String)";
               var33.addEntry(var17, var13, var17[2]);
               var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setJdbcPrefix(\"" + this.targetDSN.jdbcprefix.getText() + "\");";
               this.loadParameters(var35, var51);
               var17[2] = "setJdbcSuffix(String)";
               var33.addEntry(var17, var13, var17[2]);
               var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setJdbcSuffix(\"" + this.targetDSN.jdbcsuffix.getText() + "\");";
               this.loadParameters(var35, var51);
               var17[2] = "setUID(String)";
               var33.addEntry(var17, var13, var17[2]);
               var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setUID(\"" + this.targetDSN.userid.getText() + "\");";
               this.loadParameters(var35, var51);
               var17[2] = "setPWD(String)";
               var33.addEntry(var17, var13, var17[2]);
               var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setPWD(\"" + this.targetDSN.password.getText() + "\");";
               this.loadParameters(var35, var51);
               var17[2] = "setCSTR(String)";
               var33.addEntry(var17, var13, var17[2]);
               var35 = var33.getLastAddedBranch();
               var35.text = new String[1];
               var35.text[0] = var17[1] + ".setCSTR(\"" + this.targetDSN.connectstring.getText() + "\");";
               this.loadParameters(var35, var51);
            } else {
               var17[2] = "setDSN(String)";
               var33.addEntry(var17, var13, var17[2]);
               JDPTreeBranch var42 = var33.getLastAddedBranch();
               var42.text = new String[1];
               var42.text[0] = var17[1] + ".setDSN(\"" + this.targetDSN.datasource.getText() + "\");";
               String[] var52 = new String[]{"String"};
               this.loadParameters(var42, var52);
               var17[2] = "setCSTR(String)";
               var33.addEntry(var17, var13, var17[2]);
               var42 = var33.getLastAddedBranch();
               var42.text = new String[1];
               var42.text[0] = var17[1] + ".setCSTR(\"" + this.targetDSN.connectstring.getText() + "\");";
               this.loadParameters(var42, var52);
            }

            var17[2] = "setCommPort(String)";
            var33.addEntry(var17, var13, var17[2]);
            JDPTreeBranch var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            var44.text[0] = var17[1] + ".setCommPort(" + this.commPort.getSelectedItem() + ");";
            String[] var53 = new String[]{"int"};
            this.loadParameters(var44, var53);
            var17[2] = "setBaudRate(String)";
            var33.addEntry(var17, var13, var17[2]);
            var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            var44.text[0] = var17[1] + ".setBaudRate(" + this.baudRate.getSelectedItem() + ");";
            var53[0] = "int";
            this.loadParameters(var44, var53);
            var17[2] = "setSQL(String)";
            var33.addEntry(var17, var13, var17[2]);
            var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            String var20 = this.serviceProviderColumn.getSelectedItem();
            this.jaggSQL.setDSN(this.targetDSN.datasource.getText());
            if (super.user.u.sqlRequiresChange(this.jaggSQL, 0)) {
               var20 = var20 + " aa";
            }

            var20 = var20 + ", " + this.pagerPINColumn.getSelectedItem();
            if (super.user.u.sqlRequiresChange(this.jaggSQL, 0)) {
               var20 = var20 + " ab";
            }

            for(int var21 = 0; var21 < var11.length; ++var21) {
               var20 = var20 + ",";
               var20 = var20 + var11[var21];
            }

            var44.text[0] = var17[1] + ".setSQL(\"SELECT " + var20 + " \");";
            var53[0] = "String";
            this.loadParameters(var44, var53);
            var17[2] = "setFromWhereClause(String)";
            var33.addEntry(var17, var13, var17[2]);
            var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            String var56 = this.targetLayoutMgr.gSource.createFromWhereClause(this.targetDSN, this.tableTarget, this.target);
            var44.text[0] = var17[1] + ".setFromWhereClause(\"" + var56 + "\");";
            this.loadParameters(var44, var53);
            var17[2] = "setMergeColumns(String)";
            var33.addEntry(var17, var13, var17[2]);
            var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            var44.text[0] = "String[] columns = {\"";

            for(int var22 = 0; var22 < var11.length; ++var22) {
               if (var22 > 0) {
                  var10000 = var44.text;
                  var10000[0] = var10000[0] + "\",\"";
               }

               var10000 = var44.text;
               var10000[0] = var10000[0] + var11[var22];
            }

            var10000 = var44.text;
            var10000[0] = var10000[0] + "\"};\r\n";
            var10000 = var44.text;
            var10000[0] = var10000[0] + var17[1] + ".setMergeColumns(columns);";
            this.loadParameters(var44, var53);
            var17[2] = "setMessage(String)";
            var33.addEntry(var17, var13, var17[2]);
            var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            var44.text[0] = var17[1] + ".setMessage(" + super.thisBranch.name + "Msg1.getText());";
            this.loadParameters(var44, var53);
            var17[2] = "sendMultipleMessage()";
            var33.addEntry(var17, var13, var17[2]);
            var44 = var33.getLastAddedBranch();
            var44.text = new String[1];
            var44.text[0] = var17[1] + ".sendMultipleMessage();";
            var32.treeVector = new Vector();
            JDPTreePicker var57 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
            var57.setIcons(var13);
            var57.setRoot("Component Events", true);
            var14 = var57.treeRoot;
            var57.setDropKeys(var15);
            var57.setDragAndDrop((boolean[])null);
            var57.setDropMessages(var16);
            boolean[] var23 = new boolean[]{true, true, true, false};
            var57.setExpanded(var23);
            var32.treeVector.addElement(var14);
            var17[0] = "LIST_SELECT";
            var13[2] = 15;
            var17[1] = super.thisBranch.name + "Msg1";
            var17[2] = "replaceText(String,int,int)";
            var57.addEntry(var17, var13, var17[2]);
            JDPTreeBranch var24 = var57.getLastAddedBranch();
            var24.text = new String[1];
            var24.text[0] = var17[1] + ".replaceText(\"@\" + " + super.thisBranch.name + "Merge1.getSelectedItem()," + super.thisBranch.name + "Msg1.getSelectionStart()," + super.thisBranch.name + "Msg1.getSelectionEnd());";
            String[] var25 = new String[]{"String", "int", "int"};
            this.loadParameters(var24, var25);
            this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var5));
            this.targetLayoutMgr.lView.removeSelectedLeaf();
            this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var9));
            this.targetLayoutMgr.lView.removeSelectedLeaf();
            this.targetLayoutMgr.reDraw();
            this.targetLayoutMgr.projectLoading = var4;
            JDPTreeBranch var26 = var3[var3.length - 1];
            var26.expanded = false;
            this.targetLayoutMgr.setProperties(var26);
            this.targetLayoutMgr.interactionMgr.loadMethodTree(var26, false);
            if (!this.targetLayoutMgr.projectLoading) {
               this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var26));
               this.targetLayoutMgr.setButton("Layout");
               this.targetLayoutMgr.reDraw();
            }
         }
      }

   }

   void loadParameters(JDPTreeBranch var1, String[] var2) {
      this.targetLayoutMgr.interactionMgr.loadParameterTree(var1, var2);
   }

   void InitComponents() {
      if (this.target != null) {
         String[] var1 = this.target.columns.getSelectedItems();
         this.serviceProviderColumn.loadChoice(var1, var1);
         this.pagerPINColumn.loadChoice(var1, var1);
      } else {
         this.serviceProviderColumn.clear();
         this.pagerPINColumn.clear();
      }
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPAlphaLayout" + super.componentName;
      var1.saveObject(this.commPort, var2, "commPort");
      var1.saveObject(this.baudRate, var2, "baudRate");
      var1.saveObject(this.serviceProviderColumn, var2, "serviceProviderColumn");
      var1.saveObject(this.pagerPINColumn, var2, "pagerPINColumn");
      var1.saveObject(this.message, var2, "message");
      return true;
   }

   void refresh() {
      this.retrieveColumns();
      this.InitComponents();
      this.restoreSelections();
   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.tableTarget = (JDPSelectTable)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target instanceof JDPButton) {
               String var2 = (String)var1.arg;
               if (var2.equals("Accept")) {
                  this.saveSelections();
                  this.loadLayoutComponent();
               }
            }

            return false;
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      super.moduleName = "AlphaLayout";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
      }

      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Define Alpha column and default settings");
      this.Panel1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label = new Label("Modem Comm Port:", 0);
      this.commPort = new JDPComboBox(var1, "", 5);
      this.commPort.setEditable(false);
      int var4 = 1;

      do {
         this.commPort.addItem(Integer.toString(var4));
         ++var4;
      } while(var4 <= 16);

      this.commPort.select("3");
      this.Label0 = new Label("Default Baud Rate:", 0);
      this.baudRate = new JDPComboBox(var1, "", 10);
      this.baudRate.setEditable(false);
      this.baudRate.addItem("300");
      this.baudRate.addItem("600");
      this.baudRate.addItem("1200");
      this.baudRate.addItem("2400");
      this.baudRate.addItem("9600");
      this.baudRate.addItem("14400");
      this.baudRate.addItem("19200");
      this.baudRate.addItem("38400");
      this.baudRate.addItem("56000");
      this.baudRate.addItem("128000");
      this.baudRate.addItem("256000");
      this.Label1 = new Label("Service Provider:", 0);
      this.serviceProviderColumn = new JDPComboBox(var1, "", 20);
      this.serviceProviderColumn.setEditable(false);
      this.Label2 = new Label("Pager PIN:", 0);
      this.pagerPINColumn = new JDPComboBox(var1, "", 20);
      this.pagerPINColumn.setEditable(false);
      this.Label5 = new Label("Default Message:", 0);
      this.message = new TextArea("", 6, 40);
      String[] var7 = new String[]{"Accept", "Reset"};
      int[] var5 = new int[]{JDPButton.getIconValue("Go"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var7, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Main.setLayout(new BorderLayout());
      this.Main.setFont(new Font("Helvetica", 0, 11));
      this.Main.setForeground(var1.u._cvtcolor("Black"));
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label);
      this.ScrollPanel1.add("Right", this.commPort);
      this.ScrollPanel1.add("Left", this.Label0);
      this.ScrollPanel1.add("Right", this.baudRate);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.serviceProviderColumn);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.pagerPINColumn);
      this.ScrollPanel1.add("Left", this.Label5);
      this.ScrollPanel1.add("Right", this.message);
      this.Panel1.add("South", this.JDPButtons1);
      this.Label.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.commPort, "Comm Port", "Choose the comm port that your server modem is on");
      this.Label0.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.baudRate, "Default Baud Rate", "Choose the default baud rate for modem connections to the service provider");
      this.Label1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.serviceProviderColumn, "Service Provider column", "Choose the column from the tables that contains the Service Provider name or phone number");
      this.Label2.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.pagerPINColumn, "Pager PIN Number", "Choose the column from the tables that contains the Pager PIN number");
      this.Label5.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.message, "Default message", "Enter the default message to be sent (Optional)");
      this.InitComponents();
      Vector var6 = new Vector();
      var6.addElement(super.moduleName + super.componentName);
      var6.addElement(this);
      var1.gParm.addElement(var6);
      this.refresh();
   }
}
