import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Vector;

public class JDPDataSourceMaint extends Panel {
   JDPUser user;
   JDPDatabaseMaint target;
   int itemIndex;
   boolean insertRequested = false;
   boolean deleteRequested = false;
   TextField datasourcename;
   TextField userid;
   TextField password;

   JDPDataSourceMaint(JDPUser var1, Panel var2, String var3, JDPDatabaseMaint var4) {
      this.user = var1;
      this.target = var4;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      JDPScrollPanel var8 = new JDPScrollPanel();
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      this.datasourcename = new TextField("", 25);
      this.userid = new TextField(var1.cust.username, 12);
      this.password = new TextField(var1.cust.password, 12);
      this.password.setEchoCharacter('*');
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Datasource Name:", Color.black));
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Username:", Color.black));
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Password:", Color.black));
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new JDPLineLayout());
      ((Container)var10).add("Left", this.datasourcename);
      ((Container)var8).add("Right", var10);
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new JDPLineLayout());
      ((Container)var11).add("Left", this.userid);
      ((Container)var8).add("Right", var11);
      Panel var12 = new Panel();
      ((Container)var12).setLayout(new JDPLineLayout());
      ((Container)var12).add("Left", this.password);
      ((Container)var8).add("Right", var12);
      ((Container)var7).add("Center", var8);
      if (var3.compareTo("Inquiry") == 0) {
         this.datasourcename.setEditable(false);
      } else {
         String[] var13 = new String[]{"Apply"};
         int[] var14 = new int[]{0};
         ((Container)this).add("South", new JDPButtons(var1, var13, var14, JDPButtons.HORIZONTAL));
      }

      ((Container)var5).add("Center", var7);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Datasource Maintenance", var5, "North"));
      ((Component)var2).paintAll(((Component)var2).getGraphics());
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.datasourcename)) {
                     this.user.u.cursor(this.userid);
                     return true;
                  }

                  if (var1.target.equals(this.userid)) {
                     this.user.u.cursor(this.password);
                     return true;
                  }

                  if (var1.target.equals(this.password)) {
                     this.user.u.cursor(this.datasourcename);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.datasourcename)) {
                     this.user.u.cursor(this.password);
                     return true;
                  }

                  if (var1.target.equals(this.password)) {
                     this.user.u.cursor(this.userid);
                     return true;
                  }

                  if (var1.target.equals(this.userid)) {
                     this.user.u.cursor(this.datasourcename);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2.trim().compareTo("Apply") == 0) {
                  if (this.checkFields()) {
                     if (this.insertRequested) {
                        this.saveData();
                     } else {
                        this.saveData();
                     }
                  }

                  return true;
               }

               return true;
            } else {
               if (var1.target instanceof TextField) {
                  this.checkFields();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   boolean saveData() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.user.jaggSQL.getSEP();
      String var3 = "";
      JDPJagg var4 = new JDPJagg(this.user.jaggPath);
      var4.setDSN(this.datasourcename.getText());
      String var5 = "DSN=" + this.datasourcename.getText() + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";";
      var4.setCSTR(var5);
      if (this.insertRequested) {
         String var6 = this.user.u.getDataSourceType(var4);
         if (var6 == null) {
            this.user.u.setSqlMessage(var4, var3);
            return false;
         }
      }

      String[] var8 = this.target.tree.getSelectedBranch();
      if (this.insertRequested) {
         var3 = "INSERT INTO JDPDataSrc (SourceName) VALUES('" + this.datasourcename.getText() + "')";
      } else if (this.deleteRequested) {
         var3 = "DELETE FROM JDPDataSrc WHERE SourceName='" + var8[1] + "'";
      }

      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var1 = this.user.jaggSQL.execSQL(var3, var2);
      if (var1 == -1) {
         this.user.u.setSqlMessage(this.user.jaggSQL, var3);
         return false;
      } else {
         if (var1 == 1) {
            if (this.insertRequested) {
               this.user.mainmsg.setStatusMsg("Datasource successfully added.", 3);
            } else if (this.deleteRequested) {
               this.user.mainmsg.setStatusMsg("Datasource successfully removed.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.user.jaggSQL, var3);
         }

         this.target.loadDataSources();
         if (this.insertRequested) {
            this.target.tree.nothingChanged = false;
            this.target.tree.repaint();
         }

         this.insertRequested = false;
         this.deleteRequested = false;
         ((CardLayout)this.target.cardPanel.getLayout()).show(this.target.cardPanel, "Normal");
         return true;
      }
   }

   void clearFields() {
      this.datasourcename.setText("");
   }

   boolean checkFields() {
      return this.user.u.ischaracter(this.datasourcename, this.user.mainmsg, "Please enter a Datasource name");
   }
}
