import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.List;
import java.awt.Panel;
import java.awt.Rectangle;
import java.awt.TextField;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPDatabaseMaint extends JDPClassLayout {
   JDPTreePicker tree;
   JDPTreeBranch treeRoot;
   JDPTextGrid tableContents;
   JDPPopupMessage popuppanel;
   JDPDragItem dragPanel;
   JDPPopupMenu popup;
   JDPTreeBranch popupMain;
   JDPTreeBranch popupMains;
   JDPTreeBranch popupGroups;
   JDPTreeBranch popupRemoveGroups;
   JDPTreeBranch popupTemplates;
   JDPTreeBranch popupTemplate;
   JDPTreeBranch popupTables;
   JDPTreeBranch popupTable;
   JDPTemplateMaint templateMaint;
   JDPGroupMaint groupMaint;
   JDPSelectDSN datasourceMaint;
   int itemIndex;
   int columnCount = 7;
   String currentType;
   int totalRows;
   String[][] saveCurrentText;
   Hashtable connectionStrings;
   Panel passwordPanel;
   TextField tablename;
   Vector[] pullDownListV;
   List[] pullDownList;
   TextField userid;
   TextField password;
   Panel cardPanel;
   String[] dataSource;
   String[] jdbcDriver;
   String[] jdbcPrefix;
   String[] jdbcSuffix;

   boolean createPopupMenus() {
      this.popup.addEntry("Add a Database...");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupMain = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("Add a Database...");
      this.popup.addEntry("Remove Database");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupMains = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Group...");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupGroups = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Template...");
      this.popup.addEntry("Remove Group");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupRemoveGroups = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Template...");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupTemplates = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Template...");
      this.popup.addEntry("Edit Template...");
      this.popup.addEntry("Remove Template");
      this.popup.addEntry("Copy Template...");
      this.popupTemplate = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Table...");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupTables = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Table...");
      this.popup.addEntry("Edit...");
      this.popup.addEntry("Drop");
      this.popup.addEntry("Copy Table...");
      this.popupTable = this.popup.getMenuTree();
      return true;
   }

   void loadChoices() {
   }

   void clearFields() {
      this.tablename.setText("");
      this.loadEmptyGrid();
   }

   void loadEmptyGrid() {
      this.tableContents.currentText = new String[this.columnCount][50];
      this.tableContents.cellChanged = null;
      this.tableContents.rowChanged = null;
      this.tableContents.columnSelected = null;
      this.setGridSettings();
      this.tableContents.columnHeader[4] = "Key";
      this.tableContents.columnProtected[4] = true;
      this.tableContents.pullDownList[4][0] = this.pullDownList[5];
      this.tableContents.columnWidth[4] = 36;
      this.tableContents.columnHeader[5] = "Nulls";
      this.tableContents.columnWidth[5] = 36;
      this.tableContents.columnProtected[5] = true;
      this.tableContents.pullDownList[5][0] = this.pullDownList[6];
      this.tableContents.columnHeader[6] = "Default";
      this.tableContents.columnWidth[6] = 100;
      this.tableContents.newTable();
   }

   void setGridSettings() {
      this.tableContents.columnHeader = new String[this.columnCount];
      this.tableContents.columnHeaderStyle = new int[this.columnCount];
      this.tableContents.columnStyle = new int[this.columnCount];
      this.tableContents.columnHeaderColor = new Color[this.columnCount];
      this.tableContents.columnColor = new Color[this.columnCount];
      this.tableContents.columnBGColor = new Color[this.columnCount];
      this.tableContents.columnProtected = new boolean[this.columnCount];
      this.tableContents.columnWidth = new int[this.columnCount];
      this.tableContents.rightJustify = new boolean[this.columnCount];
      this.tableContents.rowHeader = null;
      this.tableContents.columnHeight = null;
      this.tableContents.isPullDownCol = new boolean[this.columnCount];
      this.tableContents.pullDownList = new List[this.columnCount][1];

      for(int var1 = 0; var1 < this.columnCount; ++var1) {
         this.tableContents.columnHeaderStyle[var1] = 1;
         this.tableContents.columnStyle[var1] = 0;
         this.tableContents.columnHeaderColor[var1] = Color.black;
         this.tableContents.columnColor[var1] = Color.black;
         this.tableContents.columnBGColor[var1] = Color.white;
         this.tableContents.columnStyle[var1] = 0;
      }

      this.tableContents.columnHeader[0] = "Column Name";
      this.tableContents.columnHeader[1] = "Data Type";
      this.tableContents.columnHeader[2] = "Size";
      this.tableContents.columnHeader[3] = "Dec";
      this.pullDownListV = new Vector[this.columnCount];
      this.pullDownList = new List[this.columnCount];
      this.tableContents.isPullDownCol[1] = true;
      this.tableContents.pullDownList[1][0] = new List();
      JDPUtils.loadODBCList(this.tableContents.pullDownList[1][0]);
      this.tableContents.columnProtected[1] = true;
      this.tableContents.isPullDownCol[4] = true;
      this.pullDownList[4] = new List();
      if (this.columnCount == 7) {
         this.pullDownList[5] = new List();
         this.pullDownList[5].addItem("No");
         this.pullDownList[5].addItem("Yes");
         this.pullDownListV[5] = new Vector();
         this.pullDownListV[5].addElement("N");
         this.pullDownListV[5].addElement("Y");
         this.tableContents.isPullDownCol[5] = true;
         this.pullDownList[6] = new List();
         this.pullDownList[6].addItem("No");
         this.pullDownList[6].addItem("Yes");
         this.pullDownListV[6] = new Vector();
         this.pullDownListV[6].addElement("N");
         this.pullDownListV[6].addElement("Y");
      }

      this.tableContents.columnWidth[0] = 83;
      this.tableContents.columnWidth[1] = 80;
      this.tableContents.columnWidth[2] = 30;
      this.tableContents.columnWidth[3] = 36;
      this.tableContents.rightJustify[2] = true;
      this.tableContents.rightJustify[3] = true;
   }

   int getIndex(String var1) {
      for(int var2 = 0; var2 < this.dataSource.length; ++var2) {
         if (var1.equals(this.dataSource[var2])) {
            return var2;
         }
      }

      return -1;
   }

   boolean updateTable() {
      int var1 = 0;
      Vector var2 = new Vector();
      JDPJagg var3 = new JDPJagg(super.user.jaggPath);
      var3.getSEP();
      String var4 = "";
      super.user.mainmsg.setStatusMsg("Saving...", 0);
      String[] var5 = this.tree.getSelectedBranch();
      String var6 = var5[1];
      var3.setDSN(var6);
      String var7 = (String)this.connectionStrings.get(var5[1]);
      String var8 = null;
      if (this.passwordPanel.isVisible()) {
         var7 = null;
      }

      if (var7 == null) {
         var8 = "DSN=" + var6 + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";";
         var7 = var8;
      }

      int var9 = this.getIndex(var5[1]);
      var3.setJdbcDriver(this.jdbcDriver[var9]);
      var3.setJdbcPrefix(this.jdbcPrefix[var9]);
      var3.setJdbcSuffix(this.jdbcSuffix[var9]);
      var3.setCSTR(var7);
      String var10 = super.user.u.getDataSourceType(var3);
      if (var10 == null) {
         super.user.mainmsg.setStatusMsg("Please enter a username and password to connect to this Database.", 20);
         ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Password");
         this.userid.requestFocus();
         this.userid.selectAll();
         return false;
      } else {
         String var11 = "text";
         String var12 = "date";
         String var13 = "float";
         String var14 = "int";
         String var15 = " NULL";
         if (var10.indexOf(JDPJagg.MSSQLSERVER) >= 0) {
            var11 = "text";
            var12 = "datetime";
            var13 = "decimal";
         } else if (var10.indexOf(JDPJagg.SYBASE) < 0 && var10.indexOf(JDPJagg.SYBASE10) < 0) {
            if (var10.indexOf(JDPJagg.ANYWHERE) >= 0) {
               var11 = "text";
               var12 = "datetime";
               var13 = "decimal";
            } else if (var10.indexOf(JDPJagg.FOXPRO) >= 0) {
               var11 = "memo";
               var13 = "int";
               var15 = "";
            } else if (var10.indexOf(JDPJagg.ORACLE) >= 0) {
               var11 = "long";
               var13 = "decimal";
            } else if (var10.indexOf(JDPJagg.DB2) >= 0) {
               var11 = "long varchar";
               var13 = "decimal";
            }
         } else {
            var11 = "text";
            var12 = "datetime";
            var13 = "decimal";
         }

         if (var10.indexOf(JDPJagg.SOLIDSERVER) >= 0) {
            var11 = "long varchar";
            var13 = "decimal";
         }

         if (var10.indexOf(JDPJagg.LOTUS) >= 0) {
            var11 = "long varchar";
            var13 = "decimal";
            var14 = "integer";
         }

         if (var10.indexOf(JDPJagg.INFORMIX) >= 0) {
            var11 = "varchar(255)";
            var13 = "decimal";
            var14 = "integer";
         }

         if (var10.indexOf(JDPJagg.CLOUDSCAPE) >= 0) {
            var15 = "";
            var11 = "varchar(" + Integer.toString(Integer.MAX_VALUE) + ")";
         }

         boolean var16 = false;
         int var17 = 0;
         if (this.saveCurrentText != null && !this.tablename.isEditable()) {
            var17 = this.saveCurrentText[0].length;
            var16 = true;
            if (!this.tablename.isEditable()) {
               label238:
               for(int var18 = 0; var18 < var17; ++var18) {
                  int var19 = 0;

                  while(this.tableContents.currentText[var19][var18].equals(this.saveCurrentText[var19][var18])) {
                     ++var19;
                     if (var19 >= 3) {
                        continue label238;
                     }
                  }

                  var16 = false;
               }
            }
         }

         int var35 = 0;
         if (var16) {
            var4 = "ALTER TABLE " + this.tablename.getText() + " ADD ";
            var35 = var17;
         } else {
            if (var17 > 0 && !this.saveTable(this.tablename.getText())) {
               if (var8 != null) {
                  super.user.mainmsg.setStatusMsg("Please enter a username and password to connect to this Database.", 20);
                  ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Password");
                  this.userid.requestFocus();
                  this.userid.selectAll();
               }

               return false;
            }

            var4 = "CREATE TABLE " + this.tablename.getText() + " ( ";
            var35 = 0;
         }

         boolean var37 = true;

         for(int var20 = var35; var20 < this.tableContents.currentText[0].length; ++var20) {
            if (this.tableContents.currentText[0][var20] != null && !this.tableContents.currentText[0][var20].equals("")) {
               if (!var37) {
                  var4 = var4 + ", ";
               }

               var37 = false;
               var4 = var4 + super.user.u.replace(this.tableContents.currentText[0][var20], " ", "") + " ";
               String var21 = this.tableContents.currentText[1][var20];
               int var22 = JDPUtils.getODBCValue(this.tableContents.currentText[1][var20]);
               if (JDPUtils.isOdbcMemo(var22)) {
                  var4 = var4 + var11;
               } else if (JDPUtils.isOdbcBinary(var22)) {
                  var4 = var4 + "image";
               } else if (JDPUtils.isOdbcChar(var22)) {
                  var4 = var4 + var21;
                  var4 = var4 + " (" + this.tableContents.currentText[2][var20] + ")";
               } else if (JDPUtils.isOdbcDate(var22)) {
                  var4 = var4 + var12;
               } else if (JDPUtils.isOdbcFloat(var22)) {
                  var4 = var4 + var13;
                  if (!var13.equals("int")) {
                     var4 = var4 + " (" + this.tableContents.currentText[2][var20] + "," + this.tableContents.currentText[3][var20] + ")";
                  }
               } else if (JDPUtils.isOdbcInt(var22)) {
                  var4 = var4 + var14;
               } else {
                  var4 = var4 + var21;
               }

               if (this.tableContents.currentText[5][var20].equals("Yes")) {
                  var4 = var4 + var15;
               }

               if (this.tableContents.currentText[6][var20] != null && !this.tableContents.currentText[6][var20].equals("")) {
                  if (!JDPUtils.isOdbcChar(var22) && !JDPUtils.isOdbcDate(var22)) {
                     var4 = var4 + " DEFAULT(" + this.tableContents.currentText[6][var20] + ")";
                  } else {
                     var4 = var4 + " DEFAULT('" + this.tableContents.currentText[6][var20] + "')";
                  }
               }
            }
         }

         if (var16) {
            super.user.mainmsg.setStatusMsg("Altering table...", 0);
            var1 = var3.execSQL(var4, var2);
            if (var1 == -1) {
               if (var8 != null) {
                  super.user.mainmsg.setStatusMsg("Please enter a username and password to connect to this Database.", 20);
                  ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Password");
                  this.userid.requestFocus();
                  this.userid.selectAll();
               } else {
                  super.user.u.setSqlMessage(var3, var4);
               }

               return false;
            }
         } else {
            var4 = var4 + ")";
            super.user.mainmsg.setStatusMsg("Creating new table...", 0);
            var1 = var3.execSQL(var4, var2);
            if (var1 == -1) {
               super.user.u.setSqlMessage(var3, var4);
               if (var17 > 0) {
                  this.restoreTable(this.tablename.getText());
               }

               return false;
            }

            if (var17 > 0) {
               var4 = "INSERT INTO " + this.tablename.getText() + " ( ";
               var37 = true;

               for(int var40 = 0; var40 < this.tableContents.currentText[0].length; ++var40) {
                  if (this.tableContents.currentText[0][var40] != null && !this.tableContents.currentText[0][var40].equals("")) {
                     if (!var37) {
                        var4 = var4 + ", ";
                     }

                     var37 = false;
                     var4 = var4 + this.tableContents.currentText[0][var40] + " ";
                  }
               }

               var4 = var4 + ") SELECT ";
               var37 = true;
               boolean var41 = false;
               if (var17 > this.tableContents.currentText[0].length) {
                  var17 = this.tableContents.currentText[0].length;
               }

               for(int var42 = 0; var42 < var17; ++var42) {
                  if (this.saveCurrentText[0][var42] != null && !this.saveCurrentText[0][var42].equals("") && this.tableContents.currentText[0][var42] != null && !this.tableContents.currentText[0][var42].equals("")) {
                     if (!var37) {
                        var4 = var4 + ", ";
                     }

                     var37 = false;
                     var4 = var4 + this.saveCurrentText[0][var42] + " ";
                     var41 = true;
                  }
               }

               for(int var43 = var17; var43 < this.tableContents.currentText[0].length; ++var43) {
                  if (this.tableContents.currentText[0][var43] != null && !this.tableContents.currentText[0][var43].equals("")) {
                     if (!var37) {
                        var4 = var4 + ", ";
                     }

                     var37 = false;
                     int var44 = JDPUtils.getODBCValue(this.tableContents.currentText[1][var43]);
                     if (JDPUtils.isOdbcChar(var44)) {
                        var4 = var4 + "' '";
                     } else if (JDPUtils.isOdbcDate(var44)) {
                        var4 = var4 + "' '";
                     } else {
                        var4 = var4 + "0";
                     }
                  }
               }

               var4 = var4 + " FROM tmp88934";
               if (var41) {
                  super.user.mainmsg.setStatusMsg("Restoring existing table data...", 0);
                  var1 = var3.execSQL(var4, var2);
                  if (var1 == -1) {
                     super.user.u.setSqlMessage(var3, var4);
                     super.user.mainmsg.setStatusMsg("Saving old data...", 0);
                     var4 = "SELECT * INTO O" + this.tablename.getText() + " FROM tmp88934";
                     var1 = var3.execSQL(var4, var2);
                     this.loadTables();
                     if (var1 >= 0) {
                        super.user.mainmsg.setStatusMsg("Old data has been saved to O" + this.tablename.getText() + ".   " + Integer.toString(var1) + " rows were written", 20);
                     } else {
                        super.user.u.setSqlMessage(var3, var4);
                     }

                     this.dropTable("tmp88934");
                     return false;
                  }
               }

               this.dropTable("tmp88934");
            }
         }

         if (var8 != null) {
            this.connectionStrings.put(var6, var8);
         }

         return true;
      }
   }

   boolean restoreTable(String var1) {
      int var2 = 0;
      Vector var3 = new Vector();
      JDPJagg var4 = new JDPJagg(super.user.jaggPath);
      var4.getSEP();
      String var5 = "";
      super.user.mainmsg.setStatusMsg("Create table failed - Restoring original table data...", 0);
      var5 = "SELECT * INTO " + var1 + " FROM tmp88934";
      String[] var6 = this.tree.getSelectedBranch();
      String var7 = var6[1];
      var4.setDSN(var7);
      int var8 = this.getIndex(var6[1]);
      var4.setJdbcDriver(this.jdbcDriver[var8]);
      var4.setJdbcPrefix(this.jdbcPrefix[var8]);
      var4.setJdbcSuffix(this.jdbcSuffix[var8]);
      var4.setCSTR("DSN=" + var7 + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";");
      var2 = var4.execSQL(var5, var3);
      if (var2 == -1) {
         super.user.u.setSqlMessage(var4, var5);
         return false;
      } else {
         this.dropTable("tmp88934");
         return true;
      }
   }

   void loadTables() {
      int var2 = 0;
      Vector var3 = new Vector();
      JDPJagg var4 = new JDPJagg(super.user.jaggPath);
      String var5 = var4.getSEP();
      int var6 = 0;
      String var8 = "";
      String[] var9 = this.tree.getSelectedBranch();
      String var10 = var9[1];
      String var11 = var9[2];
      if (var11.equals("Tables")) {
         var11 = "TABLE";
      }

      if (var11.equals("Views")) {
         var11 = "VIEW";
      }

      super.user.mainmsg.setStatusMsg("Loading Table definitions, please wait...", 0);
      var4.setDSN(var10);
      String var12 = (String)this.connectionStrings.get(var9[1]);
      String var13 = null;
      if (this.passwordPanel.isVisible()) {
         var12 = null;
      }

      if (var12 == null) {
         var13 = "DSN=" + var10 + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";";
         var12 = var13;
      }

      int var14 = this.getIndex(var10);
      var4.setJdbcDriver(this.jdbcDriver[var14]);
      var4.setJdbcPrefix(this.jdbcPrefix[var14]);
      var4.setJdbcSuffix(this.jdbcSuffix[var14]);
      var4.setCSTR(var12);
      if (!JDPJagg.useJaggServer) {
         var4.setFCTNP(";;;" + var11 + ";");
      } else {
         var4.setFCTNP(";;;" + var11 + ";");
      }

      var4.setFCTN("SQLTables");
      var4.setMRW("100000");
      var2 = var4.execSQL(var8, var3);
      if (var2 == -1) {
         super.user.mainmsg.setStatusMsg("Please enter a username and password to connect to this Database.", 20);
         ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Password");
         this.userid.requestFocus();
         this.userid.selectAll();
      } else {
         ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Normal");
         if (var13 != null) {
            this.connectionStrings.put(var10, var13);
         }

         Object[] var15 = new Object[]{null, null, null, "Tables"};
         Object var16 = null;
         this.tree.setDropKeys(var15);
         this.tree.setDropMessages((String[])var16);
         var6 = var4.getRowCount();
         var4.getColumnCount();
         int[] var17 = new int[]{4, 3, 2, 1};
         this.tree.setIcons(var17);
         String[] var18 = new String[]{var10, null, null};

         for(int var19 = 0; var19 < var6; ++var19) {
            String var7 = (String)var3.elementAt(var19);
            if (var7 != null && var7.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var7, var5);
               var1.nextToken().trim();
               String var20 = var1.nextToken().trim();
               String var21;
               if (var20.length() > 0) {
                  var21 = var20 + "." + var1.nextToken().trim();
               } else {
                  var21 = var1.nextToken().trim();
               }

               var11 = var1.nextToken().trim();
               if (var11.equals("TABLE")) {
                  var18[1] = "Tables";
                  var18[2] = var21;
                  this.tree.addEntry(var18);
               }

               if (var11.equals("VIEW")) {
                  var18[1] = "Views";
                  var18[2] = var21;
                  this.tree.addEntry(var18);
               }
            }
         }

         this.tree.repaint();
         this.tree.setDropKeys((Object[])null);
         this.tree.setDropMessages((String[])null);
         super.user.mainmsg.clearStatusMsg();
      }
   }

   void loadDataSources() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = super.user.jaggSQL.getSEP();
      int var5 = 0;
      int var6 = 0;
      String var8 = "";
      super.user.mainmsg.setStatusMsg("Loading Databases...", 0);
      var8 = "SELECT * FROM JDPDataSrc";
      super.user.jaggSQL.setFCTN("");
      var2 = super.user.jaggSQL.execSQL(var8, var3);
      var5 = super.user.jaggSQL.getRowCount();
      var6 = super.user.jaggSQL.getColumnCount();
      super.user.jaggSQL.setFCTN("");
      if (var2 == -1) {
         super.user.mainmsg.setStatusMsg("Connection to JAGG Server failed. Check JDPJagg.exe is installed in CGI directory.", 0);
         System.out.println("JDPSelectDSN/loadList ERR: " + super.user.jaggSQL.getError());
      } else {
         Object[] var9 = new Object[]{null, null, "Templates"};
         String[] var10 = new String[]{null, null, "Drop template to create a table from this template"};
         this.tree.setDropMessages(var10);
         this.dataSource = new String[var5];
         this.jdbcDriver = new String[var5];
         this.jdbcPrefix = new String[var5];
         this.jdbcSuffix = new String[var5];
         String[] var11 = new String[3];

         for(int var12 = 0; var12 < var5; ++var12) {
            String var7 = (String)var3.elementAt(var12);
            if (var7 != null && var7.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var7);
               int[] var13 = new int[]{4, 3, 2, 1};
               this.tree.setIcons(var13);
               var11 = new String[3];
               String var14 = var1.nextToken(var4).trim();
               var11[0] = var14;
               var11[1] = "Tables";
               var11[2] = "";
               this.tree.setDropKeys(var9);
               this.tree.addEntry(var11);
               this.tree.setDropKeys((Object[])null);
               var11[0] = var14;
               var11[1] = "Views";
               var11[2] = "";
               this.tree.addEntry(var11);
               this.dataSource[var12] = var14;
               this.jdbcDriver[var12] = var1.nextToken(var4).trim();
               this.jdbcPrefix[var12] = var1.nextToken(var4).trim();
               this.jdbcSuffix[var12] = var1.nextToken(var4).trim();
            }
         }

         this.tree.nothingChanged = false;
         this.tree.repaint();
         this.tree.setDropMessages((String[])null);
         super.user.mainmsg.clearStatusMsg();
      }
   }

   boolean checkFields() {
      String var1 = this.tablename.getText();
      var1 = super.user.u.replace(var1, " ", "");
      this.tablename.setText(var1);
      return super.user.u.ischaracter(this.tablename, super.user.mainmsg, "Please enter a name");
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectTopPanel) {
               return true;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.userid)) {
                     super.user.u.cursor(this.password);
                     return true;
                  }

                  if (var1.target.equals(this.password)) {
                     super.user.u.cursor(this.userid);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.userid)) {
                     super.user.u.cursor(this.password);
                     return true;
                  }

                  if (var1.target.equals(this.password)) {
                     super.user.u.cursor(this.userid);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 501:
            this.dragPanel.postEvent(var1);
            if (this.popup.isVisible()) {
               this.popup.hideMenu();
               return true;
            }

            return false;
         case 502:
            if (this.dragPanel.isVisible()) {
               this.dragPanel.postEvent(var1);
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 506:
            this.dragPanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPTreePicker) {
               String[] var11 = this.tree.getSelectedBranch();
               String var17 = (String)var1.arg;
               if (var17.equals("BranchOpen")) {
                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 2 && (var11[2].equals("Tables") || var11[2].equals("Views"))) {
                     this.loadTables();
                     return true;
                  }
               } else if (var17.equals("BranchSelect")) {
                  int[] var21 = this.tree.getSelectedBranchIcons();
                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 2 && var11[2].equals("Tables")) {
                     this.popup.setMenuTree(this.popupTables);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }

                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 2 && !var11[2].equals("Tables") && !var11[2].equals("Views")) {
                     String var23 = this.tree.getLeafName(0);
                     if (var23 != null && !var23.equals("")) {
                        this.popup.setMenuTree(this.popupTemplates);
                     } else {
                        this.popup.setMenuTree(this.popupRemoveGroups);
                     }

                     this.popup.display(var1.x, var1.y);
                     return true;
                  }

                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 1 && var21[1] == 0) {
                     this.popup.setMenuTree(this.popupGroups);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }

                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 0 && var21[0] == 4 && JDPJagg.useJaggServer) {
                     this.popup.setMenuTree(this.popupMain);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }

                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 1 && var21[1] == 3 && JDPJagg.useJaggServer) {
                     this.popup.setMenuTree(this.popupMains);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }
               } else if (var17.equals("LeafSelect")) {
                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 3 && var11[2].equals("Tables")) {
                     this.popup.setMenuTree(this.popupTable);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }

                  if (var1.target.equals(this.tree) && this.tree.currentBranchLvl == 3 && !var11[2].equals("Tables") && !var11[2].equals("Views")) {
                     this.popup.setMenuTree(this.popupTemplate);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }
               }
            }

            return false;
         case 1001:
            String[] var2 = this.tree.getSelectedBranch();
            if (var1.target instanceof JDPTreePicker) {
               if (var1.target.equals(this.tree) && (var2[2].equals("Tables") || var2[2].equals("Views")) && this.tree.currentBranchLvl == 3) {
                  ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Normal");
                  this.loadGrid((String[])null);
                  return true;
               } else {
                  int[] var16 = this.tree.getSelectedBranchIcons();
                  if (var1.target.equals(this.tree) && var16[1] == 0 && this.tree.currentBranchLvl == 3) {
                     ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Template");
                     this.templateMaint.loadData((String[])null);
                     return true;
                  }

                  return true;
               }
            } else {
               if (var1.target instanceof Button) {
                  String var12 = (String)var1.arg;
                  if (var12.trim().compareTo("Save") == 0) {
                     if (this.checkFields() && this.updateTable()) {
                        this.loadTables();
                        String[] var20 = this.tree.getSelectedBranch();
                        var20[3] = this.tablename.getText();
                        this.tree.nothingChanged = false;
                        this.tree.select(var20, 3);
                        this.tree.repaint();
                        this.loadGrid(var20);
                     }

                     return true;
                  }

                  if (var12.trim().compareTo("Reset") == 0) {
                     this.loadGrid((String[])null);
                     return true;
                  }
               }

               if (var1.target instanceof JDPButton) {
                  String var15 = (String)var1.arg;
                  if (var15.trim().compareTo("Connect") == 0) {
                     this.loadDataSources();
                     ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Normal");
                     return true;
                  }

                  return true;
               } else if (var1.target instanceof Choice) {
                  return true;
               } else if (var1.target instanceof TextField) {
                  this.loadTables();
                  this.checkFields();
                  return true;
               } else if (var1.target instanceof JDPPopupMenu) {
                  String[] var14 = this.popup.getSelectedBranch();
                  this.popup.hideMenu();
                  if (var14[0].equals("New Table...")) {
                     this.tablename.setEditable(true);
                     this.tablename.setText("");
                     this.loadEmptyGrid();
                     return true;
                  } else if (var14[0].equals("Edit...")) {
                     this.tablename.setEditable(false);
                     this.loadGrid((String[])null);
                     return true;
                  } else if (var14[0].equals("Copy Table...")) {
                     this.tablename.setEditable(true);
                     this.tablename.setText("");
                     this.loadGrid((String[])null);
                     this.tablename.setEditable(true);
                     this.tablename.setText("");
                     return true;
                  } else if (var14[0].equals("Drop")) {
                     if (this.dropTable(this.tablename.getText())) {
                        this.tree.removeBranch(this.tree.getSelectedBranch());
                        this.loadEmptyGrid();
                     }

                     this.tablename.setEditable(false);
                     this.tablename.setText("");
                     return true;
                  } else if (var14[0].equals("Refresh") && this.tree.currentBranchLvl == 0) {
                     this.loadDataSources();
                     return true;
                  } else {
                     int[] var19 = this.tree.getSelectedBranchIcons();
                     if (var14[0].equals("Refresh") && var19[1] != 3) {
                        this.loadDataSources();
                        return true;
                     } else if (var14[0].equals("Refresh") && var19[1] != 0) {
                        this.loadTables();
                        return true;
                     } else if (var14[0].equals("Refresh") && var19[1] == 0) {
                        this.templateMaint.loadGroups();
                        this.templateMaint.loadTemplates();
                        return true;
                     } else if (var14[0].equals("Add a Database...")) {
                        ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Database");
                        return true;
                     } else if (var14[0].compareTo("Remove Database") == 0) {
                        this.datasourceMaint.dataSources.select(this.tree.getSelectedBranch()[1]);
                        this.datasourceMaint.removeItem();
                        this.tree.removeBranch(this.tree.getSelectedBranch());
                        return true;
                     } else if (var14[0].equals("New Group...")) {
                        ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Group");
                        this.groupMaint.insertRequested = true;
                        this.groupMaint.clearFields();
                        return true;
                     } else if (var14[0].compareTo("Remove Group") == 0) {
                        this.groupMaint.insertRequested = false;
                        this.groupMaint.deleteRequested = true;
                        this.groupMaint.saveData();
                        this.tree.removeBranch(this.tree.getSelectedBranch());
                        return true;
                     } else if (var14[0].equals("New Template...")) {
                        ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Template");
                        this.templateMaint.insertRequested = true;
                        this.templateMaint.clearFields();
                        this.templateMaint.a_templtype.select(var2[1]);
                        this.templateMaint.a_groupname.select(var2[2]);
                        if (this.templateMaint.valuea_templtype.elementAt(this.templateMaint.a_templtype.getSelectedIndex()).equals("E")) {
                           ((CardLayout)this.templateMaint.tabMainPanel.getLayout()).show(this.templateMaint.tabMainPanel, "E");
                        } else {
                           ((CardLayout)this.templateMaint.tabMainPanel.getLayout()).show(this.templateMaint.tabMainPanel, "blank");
                        }

                        this.templateMaint.tabPanelMain.select(0);
                        this.templateMaint.templateDetail.currentType = var2[1].substring(0, 1);
                        this.templateMaint.templateDetail.setGridSettings();
                        this.templateMaint.templateDetail.loadEmptyGrid();
                        return true;
                     } else if (var14[0].compareTo("Edit Template...") == 0) {
                        this.templateMaint.loadData((String[])null);
                        return true;
                     } else {
                        if (var14[0].compareTo("Copy Template...") != 0) {
                           if (var14[0].compareTo("Remove Template") == 0) {
                              this.templateMaint.insertRequested = false;
                              this.templateMaint.deleteRequested = true;
                              this.templateMaint.saveData();
                              this.templateMaint.clearFields();
                              this.templateMaint.templateDetail.setGridSettings();
                              this.templateMaint.templateDetail.loadEmptyGrid();
                              this.templateMaint.tabPanelMain.select(0);
                              this.tree.removeBranch(this.tree.getSelectedBranch());
                              return true;
                           }

                           return true;
                        }

                        this.templateMaint.insertRequested = true;
                        this.templateMaint.a_templtype.select(var2[1]);
                        this.templateMaint.a_groupname.select(var2[2]);
                        this.templateMaint.tabPanelMain.select(0);

                        for(int var22 = 0; var22 < this.templateMaint.templateDetail.totalRows; ++var22) {
                           this.templateMaint.templateDetail.tableContents.rowChanged[var22] = true;
                        }

                        this.templateMaint.templateDetail.totalRows = 0;
                        return true;
                     }
                  }
               } else if (!(var1.target instanceof JDPDragItem)) {
                  return false;
               } else {
                  Rectangle var13 = this.dragPanel.getDragRectangle();
                  var13.x -= this.tree.xOffset - this.tree.dragXoffset;
                  var13.y -= this.tree.yOffset - this.tree.dragYoffset;
                  String[] var18 = this.tree.getBranch(var13);
                  String var5 = (String)this.tree.getDropKey(var13);
                  Rectangle var6 = this.dragPanel.getDropRectangle();
                  String[] var7 = this.tree.getBranch(var6);
                  if (var5 != null && var7 != null && var18 != null) {
                     this.tree.select(var7, 2);
                     this.tree.nothingChanged = false;
                     this.tree.repaint();
                     if (var5.equals("Templates")) {
                        ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Normal");
                        this.loadEmptyGrid();
                        this.templateMaint.loadData(var18);
                        System.arraycopy(this.templateMaint.templateDetail.tableContents.currentText, 0, this.tableContents.currentText, 0, this.templateMaint.templateDetail.tableContents.currentText.length);
                        this.saveCurrentText = null;
                        this.tableContents.newTable();
                        this.tablename.setEditable(true);
                        this.tablename.setText(var18[3]);
                     }

                     if (var5.equals("Tables")) {
                        ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "Template");
                        String var8 = var18[3];
                        int var9 = var8.indexOf(".");
                        if (var9 >= 0) {
                           var8 = var8.substring(var9 + 1);
                        }

                        this.templateMaint.insertRequested = true;
                        this.templateMaint.a_templname.setEditable(true);
                        this.templateMaint.a_templname.setText(var8);
                        this.templateMaint.a_templdesc.setEditable(true);
                        this.templateMaint.a_templdesc.setText(var8);
                        this.templateMaint.a_templtype.select(var7[1]);
                        this.templateMaint.a_groupname.select(var7[2]);
                        if (this.templateMaint.valuea_templtype.elementAt(this.templateMaint.a_templtype.getSelectedIndex()).equals("E")) {
                           ((CardLayout)this.templateMaint.tabMainPanel.getLayout()).show(this.templateMaint.tabMainPanel, "E");
                        } else {
                           ((CardLayout)this.templateMaint.tabMainPanel.getLayout()).show(this.templateMaint.tabMainPanel, "blank");
                        }

                        this.templateMaint.tabPanelMain.select(0);
                        this.loadGrid(var18);
                        this.templateMaint.templateDetail.currentType = var7[1].substring(0, 1);
                        this.templateMaint.templateDetail.setGridSettings();
                        this.templateMaint.templateDetail.loadEmptyGrid();
                        System.arraycopy(this.tableContents.currentText, 0, this.templateMaint.templateDetail.tableContents.currentText, 0, this.tableContents.currentText.length);
                        this.templateMaint.templateDetail.tableContents.newTable();

                        for(int var10 = 0; var10 < this.templateMaint.templateDetail.tableContents.currentText[0].length; ++var10) {
                           if (this.templateMaint.templateDetail.tableContents.currentText[0][var10] != null && !this.templateMaint.templateDetail.tableContents.currentText[0][var10].equals("")) {
                              this.templateMaint.templateDetail.tableContents.rowChanged[var10] = true;
                           }
                        }

                        this.templateMaint.templateDetail.totalRows = 0;
                     }

                     return true;
                  }

                  return false;
               }
            }
         case 1005:
            if (!(var1.target instanceof JDPTextGrid)) {
               return false;
            } else {
               int var3 = this.tableContents.getPrevRow();
               if (this.tableContents.currentText[0][var3] != null && !this.tableContents.currentText[0][var3].equals("")) {
                  if (this.tableContents.getPrevColumn() != 1 && this.tableContents.currentText[1][var3].equals("")) {
                     this.tableContents.currentText[1][var3] = "Char";
                     if (this.tableContents.currentText[2][var3].equals("")) {
                        this.tableContents.currentText[2][var3] = "10";
                     }

                     this.tableContents.currentText[3][var3] = "";
                     this.tableContents.fieldProtected[3][var3] = true;
                     this.tableContents.repaint();
                  }

                  if (this.tableContents.getPrevColumn() == 1) {
                     this.tableContents.nothingChanged = false;
                     int var4 = JDPUtils.getODBCValue(this.tableContents.currentText[1][var3]);
                     if (JDPUtils.isOdbcChar(var4) && !JDPUtils.isOdbcMemo(var4)) {
                        if (this.tableContents.currentText[2][var3].equals("")) {
                           this.tableContents.currentText[2][var3] = "10";
                        }

                        this.tableContents.currentText[3][var3] = "";
                        this.tableContents.fieldProtected[3][var3] = true;
                        this.tableContents.repaint();
                     } else if (!JDPUtils.isOdbcMemo(var4) && !JDPUtils.isOdbcInt(var4) && !JDPUtils.isOdbcDate(var4) && !JDPUtils.isOdbcBinary(var4)) {
                        if (this.tableContents.currentText[2][var3].equals("")) {
                           this.tableContents.currentText[2][var3] = "10";
                        }

                        if (this.tableContents.currentText[3][var3].equals("")) {
                           this.tableContents.currentText[3][var3] = "2";
                        }

                        this.tableContents.fieldProtected[2][var3] = false;
                        this.tableContents.fieldProtected[3][var3] = false;
                        this.tableContents.repaint();
                     } else {
                        this.tableContents.currentText[2][var3] = "";
                        this.tableContents.fieldProtected[2][var3] = true;
                        this.tableContents.currentText[3][var3] = "";
                        this.tableContents.fieldProtected[3][var3] = true;
                        this.tableContents.repaint();
                     }
                  }

                  return true;
               }

               return true;
            }
         default:
            return false;
      }
   }

   void loadGrid(String[] var1) {
      int var3 = 0;
      int var5 = 0;
      String var7 = "";
      JDPJagg var8 = new JDPJagg(super.user.jaggPath);
      String var9 = var8.getSEP();
      new Vector();
      new Vector();
      this.setGridSettings();
      this.tableContents.columnHeader[4] = "Key";
      this.tableContents.columnProtected[4] = true;
      this.tableContents.pullDownList[4][0] = this.pullDownList[5];
      this.tableContents.columnWidth[4] = 36;
      this.tableContents.columnHeader[5] = "Nulls";
      this.tableContents.columnWidth[5] = 36;
      this.tableContents.columnProtected[5] = true;
      this.tableContents.pullDownList[5][0] = this.pullDownList[6];
      this.tableContents.columnHeader[6] = "Default";
      this.tableContents.columnWidth[6] = 100;
      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      String[] var10;
      if (var1 != null) {
         var10 = var1;
      } else {
         var10 = this.tree.getSelectedBranch();
      }

      String var11 = var10[3];
      int var12 = var11.indexOf(".");
      if (var12 >= 0) {
         var11 = var11.substring(var12 + 1);
      }

      this.tablename.setText(var11);
      int var13 = this.getIndex(var10[1]);
      var8.setDSN(var10[1]);
      String var14 = (String)this.connectionStrings.get(var10[1]);
      String var15 = null;
      if (this.passwordPanel.isVisible()) {
         var14 = null;
      }

      if (var14 == null) {
         var15 = "DSN=" + var10[1] + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";";
         var14 = var15;
      }

      var8.setJdbcDriver(this.jdbcDriver[var13]);
      var8.setJdbcPrefix(this.jdbcPrefix[var13]);
      var8.setJdbcSuffix(this.jdbcSuffix[var13]);
      var8.setCSTR(var14);
      var8.setFCTN("SQLColumns");
      this.tablename.setEditable(false);
      String var16 = ";;" + this.tablename.getText() + ";;";
      var8.setFCTNP(var16);
      Vector var4 = new Vector();
      var3 = var8.execSQL(var7, var4);
      if (var3 == -1) {
         super.user.u.setSqlMessage(var8, var7);
      } else {
         if (var15 != null) {
            this.connectionStrings.put(var10[1], var15);
         }

         this.totalRows = var8.getRowCount();
         var5 = var8.getRowCount() + 20;
         this.tableContents.currentText = new String[this.columnCount][var5];
         this.tableContents.fieldProtected = new boolean[this.columnCount][var5];
         this.tableContents.cellChanged = null;
         this.tableContents.rowChanged = null;
         this.tableContents.columnSelected = null;

         for(int var17 = 0; var17 < var5 - 20; ++var17) {
            String var6 = (String)var4.elementAt(var17);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var6);
               var2.nextToken(var9).trim();
               var2.nextToken(var9).trim();
               var2.nextToken(var9).trim();
               this.tableContents.currentText[0][var17] = var2.nextToken(var9).trim();
               int var18 = Integer.parseInt(var2.nextToken(var9).trim());
               this.tableContents.currentText[1][var17] = JDPUtils.getODBCValue(var18);
               var2.nextToken(var9).trim();
               var2.nextToken(var9).trim();
               this.tableContents.currentText[2][var17] = var2.nextToken(var9).trim();
               this.tableContents.currentText[3][var17] = var2.nextToken(var9).trim();
               var2.nextToken(var9).trim();
               this.tableContents.currentText[4][var17] = "No";
               String var19 = var2.nextToken(var9).trim();
               this.tableContents.currentText[5][var17] = "No";
               if (var19.equals("1")) {
                  this.tableContents.currentText[5][var17] = "Yes";
               }

               var2.nextToken(var9).trim();
               if (JDPUtils.isOdbcChar(var18) && !JDPUtils.isOdbcMemo(var18)) {
                  if (this.tableContents.currentText[2][var17].equals("")) {
                     this.tableContents.currentText[2][var17] = "10";
                  }

                  this.tableContents.currentText[3][var17] = "";
                  this.tableContents.fieldProtected[3][var17] = true;
               } else if (!JDPUtils.isOdbcMemo(var18) && !JDPUtils.isOdbcInt(var18) && !JDPUtils.isOdbcDate(var18) && !JDPUtils.isOdbcBinary(var18)) {
                  if (this.tableContents.currentText[2][var17].equals("")) {
                     this.tableContents.currentText[2][var17] = "10";
                  }

                  if (this.tableContents.currentText[3][var17].equals("")) {
                     this.tableContents.currentText[3][var17] = "2";
                  }

                  this.tableContents.fieldProtected[2][var17] = false;
                  this.tableContents.fieldProtected[3][var17] = false;
               } else {
                  this.tableContents.currentText[2][var17] = "";
                  this.tableContents.fieldProtected[2][var17] = true;
                  this.tableContents.currentText[3][var17] = "";
                  this.tableContents.fieldProtected[3][var17] = true;
               }

               if (this.tableContents.currentText[5][var17] == null || this.tableContents.currentText[5][var17].equals("")) {
                  this.tableContents.currentText[5][var17] = "No";
               }
            }
         }

         this.tableContents.newTable();
         this.saveCurrentText = new String[this.columnCount][var5 - 20];

         for(int var22 = 0; var22 < var5 - 20; ++var22) {
            for(int var23 = 0; var23 < this.columnCount; ++var23) {
               this.saveCurrentText[var23][var22] = this.tableContents.currentText[var23][var22];
            }
         }

         super.user.mainmsg.clearStatusMsg();
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      this.dragPanel = new JDPDragItem(var1, this);
      ((Container)var2).add(this.dragPanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      this.cardPanel = new Panel();
      this.cardPanel.setLayout(new CardLayout());
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new BorderLayout());
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new BorderLayout());
      JDPScrollPanel var12 = new JDPScrollPanel();
      this.passwordPanel = new JDPScrollPanel();
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new BorderLayout());
      this.popup = new JDPPopupMenu(var1, this);
      ((Container)var2).add(this.popup);
      this.createPopupMenus();
      this.tablename = new TextField("", 22);
      this.userid = new TextField(var1.cust.username, 12);
      this.password = new TextField(var1.cust.password, 12);
      this.password.setEchoCharacter('*');
      this.loadChoices();
      this.tree = new JDPTreePicker(var1, var2, this.dragPanel);
      ((Container)var12).add("Left", new JDPWrapLabel(var1, "Name:", Color.black));
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout());
      ((Container)var14).add("Left", this.tablename);
      ((Container)var12).add("Right", var14);
      this.passwordPanel.add("Left", new JDPWrapLabel(var1, "Username:", Color.black));
      Panel var15 = new Panel();
      ((Container)var15).setLayout(new JDPLineLayout());
      ((Container)var15).add("Left", this.userid);
      ((Container)var15).add("Left", new JDPWrapLabel(var1, "Password:", Color.black));
      ((Container)var15).add("Left", this.password);
      this.passwordPanel.add("Right", var15);
      this.cardPanel.add("Normal", var8);
      this.cardPanel.add("Password", this.passwordPanel);
      this.cardPanel.add("Template", var11);
      this.cardPanel.add("Group", var10);
      this.cardPanel.add("Database", var9);
      ((Container)var6).add("Center", this.cardPanel);
      ((Container)var8).add("North", var12);
      ((Container)var8).add("Center", var7);
      this.templateMaint = new JDPTemplateMaint(var1, var11, var3, this);
      ((Container)var11).add("Center", this.templateMaint);
      this.groupMaint = new JDPGroupMaint(var1, var10, var3, this);
      ((Container)var10).add("Center", this.groupMaint);
      this.datasourceMaint = new JDPSelectDSN();
      this.datasourceMaint.InitClass(var1, var2, "JDPDatabaseMaint");
      this.datasourceMaint.enterNewDatasource();
      ((Container)var9).add("Center", this.datasourceMaint);
      this.tableContents = new JDPTextGrid(var1);
      ((Container)var7).add("Center", this.tableContents);
      if (var3.compareTo("Inquiry") == 0) {
         this.tablename.setEditable(false);
         String[] var16 = new String[]{""};
         ((Container)var7).add("South", new JDPButtons(var1, var16, JDPButtons.HORIZONTAL));
      } else {
         this.tablename.setEditable(false);
         String[] var19 = new String[]{"Save", "Reset"};
         int[] var17 = new int[]{0, 6};
         JDPButtons var18 = new JDPButtons(var1, var19, var17, JDPButtons.HORIZONTAL);
         ((Container)var7).add("South", var18);
         this.popuppanel.addComponent(var18.button[0], "Save changes", "Save changes to the database");
         this.popuppanel.addComponent(var18.button[1], "Undo changes", "Restore previous settings");
      }

      ((Container)var4).add("Center", var6);
      this.tree.setMinWidth(200);
      int[] var20 = new int[]{4, 3, 2, 1};
      this.tree.setIcons(var20);
      ((Container)var13).add("Center", this.tree);
      ((Container)var4).add("West", var13);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Database Maintenance", var4, "North"));
      ((Component)var2).paintAll(((Component)var2).getGraphics());
      var1.gParm.addElement(this);
      this.loadDataSources();
      this.connectionStrings = new Hashtable();
   }

   boolean dropTable(String var1) {
      boolean var2 = false;
      Vector var3 = new Vector();
      JDPJagg var4 = new JDPJagg(super.user.jaggPath);
      var4.getSEP();
      String var5 = "";
      var5 = "DROP TABLE " + var1;
      String[] var6 = this.tree.getSelectedBranch();
      String var7 = var6[1];
      var4.setDSN(var7);
      int var8 = this.getIndex(var6[1]);
      var4.setJdbcDriver(this.jdbcDriver[var8]);
      var4.setJdbcPrefix(this.jdbcPrefix[var8]);
      var4.setJdbcSuffix(this.jdbcSuffix[var8]);
      var4.setCSTR("DSN=" + var7 + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";");
      var4.execSQL(var5, var3);
      return true;
   }

   boolean saveTable(String var1) {
      int var2 = 0;
      Vector var3 = new Vector();
      JDPJagg var4 = new JDPJagg(super.user.jaggPath);
      var4.getSEP();
      String var5 = "";
      super.user.mainmsg.setStatusMsg("Saving existing table data...", 0);
      this.dropTable("tmp88934");
      var5 = "SELECT * INTO tmp88934 FROM " + var1;
      String[] var6 = this.tree.getSelectedBranch();
      String var7 = var6[1];
      var4.setDSN(var7);
      int var8 = this.getIndex(var6[1]);
      var4.setJdbcDriver(this.jdbcDriver[var8]);
      var4.setJdbcPrefix(this.jdbcPrefix[var8]);
      var4.setJdbcSuffix(this.jdbcSuffix[var8]);
      var4.setCSTR("DSN=" + var7 + ";UID=" + this.userid.getText() + ";PWD=" + this.password.getText() + ";");
      var2 = var4.execSQL(var5, var3);
      if (var2 == -1) {
         super.user.u.setSqlMessage(var4, var5);
         return false;
      } else {
         this.dropTable(var1);
         return true;
      }
   }
}
