import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;

public class JDPDefineAll extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPCardPanel CardPanel1;
   JDPDefineClass defClass;
   JDPDefineConstructor defConstructor;
   JDPDefineMethod defMethod;
   JDPDefineVar defVariable;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.CardPanel1 = new JDPCardPanel();
      this.defClass = new JDPDefineClass();
      this.defClass.InitClass(var1, var2, var3);
      this.defConstructor = new JDPDefineConstructor();
      this.defConstructor.InitClass(var1, var2, var3);
      this.defMethod = new JDPDefineMethod();
      this.defMethod.InitClass(var1, var2, var3);
      this.defVariable = new JDPDefineVar();
      this.defVariable.InitClass(var1, var2, var3);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.CardPanel1);
      this.CardPanel1.add("defClass", this.defClass);
      this.CardPanel1.add("defConstructor", this.defConstructor);
      this.CardPanel1.add("defMethod", this.defMethod);
      this.CardPanel1.add("defVariable", this.defVariable);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1005:
            if (var1.target.equals(this.defClass)) {
               this.sendLostFocus();
               return true;
            } else if (var1.target.equals(this.defConstructor)) {
               this.sendLostFocus();
               return true;
            } else if (var1.target.equals(this.defMethod)) {
               this.sendLostFocus();
               return true;
            } else {
               if (var1.target.equals(this.defVariable)) {
                  this.sendLostFocus();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void setSourceItem(JDPSourceItem var1) {
      if (var1 != null) {
         if (var1.type == 0) {
            this.defClass.setSourceItem(var1);
            this.CardPanel1.setSelectedComp("defClass");
         } else if (var1.type == 1) {
            this.defConstructor.setSourceItem(var1);
            this.CardPanel1.setSelectedComp("defConstructor");
         } else if (var1.type == 2) {
            this.defMethod.setSourceItem(var1);
            this.CardPanel1.setSelectedComp("defMethod");
         } else {
            if (var1.type == 3) {
               this.defVariable.setSourceItem(var1);
               this.CardPanel1.setSelectedComp("defVariable");
            }

         }
      }
   }

   public JDPSourceItem getSourceItem() {
      if (this.CardPanel1.getSelectedComp().equals("defClass")) {
         return this.defClass.getSourceItem();
      } else if (this.CardPanel1.getSelectedComp().equals("defConstructor")) {
         return this.defConstructor.getSourceItem();
      } else if (this.CardPanel1.getSelectedComp().equals("defMethod")) {
         return this.defMethod.getSourceItem();
      } else {
         return this.CardPanel1.getSelectedComp().equals("defVariable") ? this.defVariable.getSourceItem() : null;
      }
   }

   public void sendLostFocus() {
      Event var1 = new Event(this, 1005, (Object)null);
      ((Component)this).getParent().postEvent(var1);
   }

   public JDPSourceItem updateSourceItem(JDPSourceItem var1) {
      if (this.CardPanel1.getSelectedComp().equals("defClass")) {
         return this.defClass.updateSourceItem(var1);
      } else if (this.CardPanel1.getSelectedComp().equals("defConstructor")) {
         return this.defConstructor.updateSourceItem(var1);
      } else if (this.CardPanel1.getSelectedComp().equals("defMethod")) {
         return this.defMethod.updateSourceItem(var1);
      } else {
         return this.CardPanel1.getSelectedComp().equals("defVariable") ? this.defVariable.updateSourceItem(var1) : null;
      }
   }
}
