import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Vector;

public class JDPDefineConstructor extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPScrollPanel ScrollPanel1;
   Label Label3;
   Panel Panel3;
   TextField constructorDesc;
   Checkbox publicCheck;
   Panel Panel4;
   JDPTextGrid paramGrid;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Constructor Definition");
      this.Panel1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label3 = new Label("Description:", 0);
      this.Panel3 = new Panel();
      this.constructorDesc = new TextField("", 50);
      this.publicCheck = new Checkbox("public");
      this.Panel4 = new Panel();
      this.paramGrid = new JDPTextGrid(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("North", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.Panel3);
      this.Panel3.setLayout(new JDPLineLayout());
      this.Panel3.add("Left", this.constructorDesc);
      this.Panel3.add("Left", this.publicCheck);
      this.Panel1.add("Center", this.Panel4);
      this.Panel4.setLayout(new BorderLayout());
      this.Panel4.add("North", this.paramGrid);
      this.paramGrid.setTableDimensions(3, 50);
      this.paramGrid.setRowHeaderOn(false);
      this.paramGrid.setColumnHeader(0, "Parameter Type");
      this.paramGrid.setColumnHeader(1, "Name");
      this.paramGrid.setColumnHeader(2, "Description");
      this.paramGrid.setColumnWidth(0, 100);
      this.paramGrid.setColumnWidth(1, 100);
      this.paramGrid.setColumnWidth(2, 1000);
      this.paramGrid.setMinimumHeight(91);
      this.paramGrid.setColumnHeaderStyle(0, 0);
      this.paramGrid.setColumnHeaderStyle(1, 0);
      this.paramGrid.setColumnHeaderStyle(2, 0);
      this.paramGrid.setPullDownCol(0, true);
      this.paramGrid.setScrollSouthDisabled(true);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.constructorDesc)) {
                  this.user.u.cursor(this.publicCheck);
               }

               if (var1.target.equals(this.publicCheck)) {
                  this.user.u.cursor(this.constructorDesc);
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.constructorDesc)) {
                  this.user.u.cursor(this.publicCheck);
                  return true;
               }

               if (var1.target.equals(this.publicCheck)) {
                  this.user.u.cursor(this.constructorDesc);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.publicCheck)) {
               this.sendLostFocus();
               return true;
            }

            return false;
         case 1005:
            if (var1.target.equals(this.constructorDesc)) {
               this.sendLostFocus();
               return true;
            } else {
               if (var1.target.equals(this.paramGrid)) {
                  this.sendLostFocus();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
      this.loadParameterTypes();
   }

   public void setPublic(boolean var1) {
      this.publicCheck.setState(var1);
   }

   public boolean getPublic() {
      return this.publicCheck.getState();
   }

   public void setConstructorDesc(String var1) {
      this.constructorDesc.setText(var1);
   }

   public String getConstructorDesc() {
      return this.constructorDesc.getText();
   }

   public void setParameterTypes(Vector var1) {
      int var2 = 0;
      if (var1 != null) {
         for(var2 = 0; var2 < var1.size(); ++var2) {
            this.paramGrid.setText((String)var1.elementAt(var2), 0, var2);
         }
      }

      while(var2 < this.paramGrid.getTableRows()) {
         this.paramGrid.setText("", 0, var2);
         ++var2;
      }

   }

   public void setParameterNames(Vector var1) {
      int var2 = 0;
      if (var1 != null) {
         for(var2 = 0; var2 < var1.size(); ++var2) {
            this.paramGrid.setText((String)var1.elementAt(var2), 1, var2);
         }
      }

      while(var2 < this.paramGrid.getTableRows()) {
         this.paramGrid.setText("", 1, var2);
         ++var2;
      }

   }

   public void setParameterDescriptions(Vector var1) {
      int var2 = 0;
      if (var1 != null) {
         for(var2 = 0; var2 < var1.size(); ++var2) {
            this.paramGrid.setText((String)var1.elementAt(var2), 2, var2);
         }
      }

      while(var2 < this.paramGrid.getTableRows()) {
         this.paramGrid.setText("", 2, var2);
         ++var2;
      }

   }

   public Vector getParameterTypes() {
      Vector var1 = new Vector();

      for(int var2 = 0; var2 < this.paramGrid.getTableRows() && !this.paramGrid.getText(0, var2).equals(""); ++var2) {
         var1.addElement(this.paramGrid.getText(0, var2));
      }

      return var1;
   }

   public Vector getParameterNames() {
      Vector var1 = new Vector();

      for(int var2 = 0; var2 < this.paramGrid.getTableRows() && !this.paramGrid.getText(1, var2).equals(""); ++var2) {
         var1.addElement(this.paramGrid.getText(1, var2));
      }

      return var1;
   }

   public Vector getParameterDescriptions() {
      Vector var1 = new Vector();

      for(int var2 = 0; var2 < this.paramGrid.getTableRows() && !this.paramGrid.getText(2, var2).equals(""); ++var2) {
         var1.addElement(this.paramGrid.getText(2, var2));
      }

      return var1;
   }

   public void loadParameterTypes() {
      List var1 = new List();
      var1.addItem("int");
      var1.addItem("boolean");
      var1.addItem("String");
      var1.addItem("long");
      var1.addItem("float");
      var1.addItem("JDPJob");
      this.paramGrid.newTable();
      this.paramGrid.setPullDownColType(0, 0);
      this.paramGrid.setPullDownList(0, 0, var1);
   }

   public void setSourceItem(JDPSourceItem var1) {
      if (var1.type == 1) {
         this.setPublic(var1.ispublic);
         this.setParameterTypes(var1.parmTypes);
         this.setParameterNames(var1.parmNames);
         this.setParameterDescriptions(var1.parmDescs);
         this.setConstructorDesc(var1.description);
      }
   }

   public JDPSourceItem getSourceItem() {
      JDPSourceItem var1 = new JDPSourceItem();
      return this.updateSourceItem(var1);
   }

   public void sendLostFocus() {
      Event var1 = new Event(this, 1005, (Object)null);
      ((Component)this).getParent().postEvent(var1);
   }

   public JDPSourceItem updateSourceItem(JDPSourceItem var1) {
      var1.type = 1;
      var1.ispublic = this.getPublic();
      var1.parmTypes = this.getParameterTypes();
      var1.parmNames = this.getParameterNames();
      var1.parmDescs = this.getParameterDescriptions();
      var1.description = this.getConstructorDesc();
      return var1;
   }
}
