import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Window;

public class JDPDialog extends Dialog {
   Container parent;
   JDPUser user;

   Rectangle getBoundsValue() {
      Rectangle var1;
      if (this.user.jdpMainWindow == null) {
         var1 = this.user.JDesignerPro.bounds();
      } else {
         var1 = this.user.jdpMainWindow.bounds();
      }

      return var1;
   }

   void setProperties() {
      ((Component)this).setBackground(JDPUtils.getControlColor());
      ((Dialog)this).setResizable(false);
      ((Component)this).setFont(this.user.plainFont);
   }

   public JDPDialog(JDPUser var1, Container var2) {
      super((Frame)(var1.jdpMainWindow == null ? new Frame() : var1.jdpMainWindow), "", true);
      this.user = var1;
      this.parent = var2;
      short var3 = 250;
      short var4 = 250;
      Rectangle var5 = this.getBoundsValue();
      int var6 = var5.x + (var5.width - var3) / 2;
      int var7 = var5.y + (var5.height - var4) / 2;
      ((Component)this).reshape(var6, var7, var3, var4);
      this.setProperties();
   }

   public JDPDialog(JDPUser var1, String var2, Container var3) {
      super((Frame)(var1.jdpMainWindow == null ? new Frame() : var1.jdpMainWindow), var2, true);
      this.user = var1;
      this.parent = var3;
      short var4 = 250;
      short var5 = 250;
      Rectangle var6 = this.getBoundsValue();
      int var7 = var6.x + (var6.width - var4) / 2;
      int var8 = var6.y + (var6.height - var5) / 2;
      ((Component)this).reshape(var7, var8, var4, var5);
      this.setProperties();
   }

   public JDPDialog(JDPUser var1, String var2, Container var3, boolean var4) {
      super((Frame)(var1.jdpMainWindow == null ? new Frame() : var1.jdpMainWindow), var2, var4);
      this.user = var1;
      this.parent = var3;
      short var5 = 250;
      short var6 = 250;
      Rectangle var7 = this.getBoundsValue();
      int var8 = var7.x + (var7.width - var5) / 2;
      int var9 = var7.y + (var7.height - var6) / 2;
      ((Component)this).reshape(var8, var9, var5, var6);
      this.setProperties();
   }

   public JDPDialog(JDPUser var1, String var2) {
      super((Frame)(var1.jdpMainWindow == null ? new Frame() : var1.jdpMainWindow), var2, true);
      this.user = var1;
      this.parent = this.parent;
      short var3 = 250;
      short var4 = 250;
      short var5 = 150;
      short var6 = 150;
      ((Component)this).reshape(var5, var6, var3, var4);
      this.setProperties();
   }

   public void display() {
      ((Window)this).pack();
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
      int var1 = ((Container)this).preferredSize().height;
      int var2 = ((Container)this).preferredSize().width;
      Rectangle var3 = this.getBoundsValue();
      int var4 = var3.x + (var3.width - var2) / 2;
      int var5 = var3.y + (var3.height - var1) / 2;
      ((Component)this).reshape(var4, var5, var2, var1);
      ((Dialog)this).show();
   }

   public boolean handleEvent(Event var1) {
      if (var1.id == 201) {
         ((Window)this).dispose();
         return true;
      } else {
         this.parent.handleEvent(var1);
         return false;
      }
   }
}
