import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.Vector;

public class JDPEmailLayout extends JDPClassLayout {
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPSelectDSN targetDSN;
   JDPSelectColumns target;
   JDPSelectTable tableTarget;
   JDPLayoutMgr targetLayoutMgr;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPScrollPanel ScrollPanel1;
   Label Label1;
   JDPComboBox emailColumn;
   Vector valueemailColumn;
   Label Label2;
   TextField mailServer;
   Label Label3;
   TextField returnAddress;
   Label Label4;
   TextField messageSubject;
   Label Label5;
   TextArea message;
   JDPButtons JDPButtons1;

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPEmailLayout" + super.componentName;
      var1.restoreObject(this.emailColumn, var2, "emailColumn");
      var1.restoreObject(this.mailServer, var2, "mailServer");
      var1.restoreObject(this.returnAddress, var2, "returnAddress");
      var1.restoreObject(this.messageSubject, var2, "messageSubject");
      var1.restoreObject(this.message, var2, "message");
      return true;
   }

   void loadLayoutComponent() {
      if (this.targetLayoutMgr != null && !this.targetLayoutMgr.projectLoading) {
         if (super.thisBranch.leaves.size() > 0) {
            this.targetLayoutMgr.lView.removeSelectedBranch();
         }

         if (this.target.columns.countItems() > 0) {
            JDPTreeBranch[] var1 = new JDPTreeBranch[1];
            JDPTreeBranch[] var3 = this.targetLayoutMgr.layoutTree.getTreeBranch(super.thisBranch.thisObject);
            boolean var4 = this.targetLayoutMgr.projectLoading;
            this.targetLayoutMgr.projectLoading = true;
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Ctl";
            var1[0].compType = "JDPEmailSender";
            var1[0].icon = 35;
            Object var2 = null;
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var2);
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Msg";
            var1[0].compType = "TextArea";
            var1[0].icon = 15;
            TextArea var26 = new TextArea(this.message.getText(), 4, 30);
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var26);
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Pnl";
            var1[0].compType = "Panel";
            var1[0].icon = 24;
            Panel var27 = new Panel();
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var27);
            JDPTreeBranch var5 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Btns";
            var1[0].compType = "JDPButtons";
            var1[0].icon = 17;
            String[] var6 = new String[]{"Send"};
            int[] var7 = new int[]{35};
            JDPButtons var28 = new JDPButtons(super.user, var6, var7, JDPButtons.HORIZONTAL);
            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var28);
            JDPTreeBranch var8 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            if (this.returnAddress.getText().equals("") || this.messageSubject.getText().equals("")) {
               var1[0] = new JDPTreeBranch();
               var1[0].name = super.thisBranch.name + "Scroll";
               var1[0].compType = "JDPScrollPanel";
               var1[0].icon = 24;
               JDPScrollPanel var29 = new JDPScrollPanel(true);
               this.targetLayoutMgr.saveBranchName = null;
               this.targetLayoutMgr.checkDragNDrop(var1, var3, var29);
               JDPTreeBranch var9 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               JDPTreeBranch[] var10 = this.targetLayoutMgr.layoutTree.getTreeBranch(var9);
               if (this.returnAddress.getText().equals("")) {
                  var1[0] = new JDPTreeBranch();
                  var1[0].name = super.thisBranch.name + "Lbl";
                  var1[0].compType = "Label";
                  var1[0].icon = 14;
                  Label var30 = new Label("Return Address:", 0);
                  this.targetLayoutMgr.saveBranchName = null;
                  this.targetLayoutMgr.checkDragNDrop(var1, var10, var30);
                  var1[0] = new JDPTreeBranch();
                  var1[0].name = super.thisBranch.name + "Rtn";
                  var1[0].compType = "TextField";
                  var1[0].icon = 15;
                  TextField var31 = new TextField("", 30);
                  this.targetLayoutMgr.saveBranchName = null;
                  this.targetLayoutMgr.checkDragNDrop(var1, var10, var31);
               }

               if (this.messageSubject.getText().equals("")) {
                  var1[0] = new JDPTreeBranch();
                  var1[0].name = super.thisBranch.name + "Lbl";
                  var1[0].compType = "Label";
                  var1[0].icon = 14;
                  Label var32 = new Label("Subject:", 0);
                  this.targetLayoutMgr.saveBranchName = null;
                  this.targetLayoutMgr.checkDragNDrop(var1, var10, var32);
                  var1[0] = new JDPTreeBranch();
                  var1[0].name = super.thisBranch.name + "Sbj";
                  var1[0].compType = "TextField";
                  var1[0].icon = 15;
                  TextField var33 = new TextField("", 30);
                  this.targetLayoutMgr.saveBranchName = null;
                  this.targetLayoutMgr.checkDragNDrop(var1, var10, var33);
               }
            }

            var1[0] = new JDPTreeBranch();
            var1[0].name = super.thisBranch.name + "Merge";
            var1[0].compType = "JDPList";
            var1[0].icon = 21;
            JDPList var34 = new JDPList(super.user);
            if (this.target != null) {
               String[] var35 = this.target.columns.getSelectedItems();
               ((JDPList)var34).loadList(var35, var35);
            } else {
               ((JDPList)var34).removeAll();
            }

            this.targetLayoutMgr.saveBranchName = null;
            this.targetLayoutMgr.checkDragNDrop(var1, var3, var34);
            JDPTreeBranch var36 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            var36.text = new String[1];
            var36.text[0] = var36.name + "Main|R|";
            String[] var10000 = var36.text;
            var10000[0] = var10000[0] + this.targetLayoutMgr.gSource.createComment("Load Merge List");
            var10000 = var36.text;
            var10000[0] = var10000[0] + "\tpublic void " + var36.name + "Main() {\r\n\r\n";
            var10000 = var36.text;
            var10000[0] = var10000[0] + "\t\t" + var36.name + " = new JDPList(user);\r\n";
            var10000 = var36.text;
            var10000[0] = var10000[0] + "\t\tString[] columns = {\"";
            String[] var37 = this.target.columns.getSelectedItems();

            for(int var11 = 0; var11 < var37.length; ++var11) {
               if (var11 > 0) {
                  var10000 = var36.text;
                  var10000[0] = var10000[0] + "\",\"";
               }

               var10000 = var36.text;
               var10000[0] = var10000[0] + var37[var11];
            }

            var10000 = var36.text;
            var10000[0] = var10000[0] + "\"};\r\n";
            var10000 = var36.text;
            var10000[0] = var10000[0] + "\t\t" + var36.name + ".loadList(columns, columns);\r\n";
            var10000 = var36.text;
            var10000[0] = var10000[0] + "\r\n\t}\r\n";
            var8.treeVector = new Vector();
            JDPTreePicker var38 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
            int[] var12 = new int[]{4, 1, 2, 1};
            var38.setIcons(var12);
            var38.setRoot("Component Events", true);
            JDPTreeBranch var13 = var38.treeRoot;
            Object[] var14 = new Object[]{null, "Methods"};
            String[] var15 = new String[]{null, "Drop here to attach this component/method to this Event"};
            var38.setDropKeys(var14);
            var38.setDragAndDrop((boolean[])null);
            var38.setDropMessages(var15);
            String[] var16 = new String[]{null, null, null, null};
            int var17 = 0;

            do {
               var16[0] = "ACTION_BTN_" + Integer.toString(var17);
               boolean[] var18 = new boolean[]{true, true, true, false};
               var38.setIcons(var12);
               var38.setExpanded(var18);
               var38.addEntry(var16, var12, "ACTION_BTN_" + Integer.toString(var17));
               ++var17;
            } while(var17 < 1);

            var8.treeVector.addElement(var13);
            var12[2] = 35;
            var16[1] = super.thisBranch.name + "Ctl1";
            if (JDPJagg.useJaggServer) {
               var16[2] = "setDSN(String)";
               var38.addEntry(var16, var12, var16[2]);
               JDPTreeBranch var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setDSN(\"" + this.targetDSN.datasource.getText() + "\");";
               String[] var57 = new String[]{"String"};
               this.loadParameters(var40, var57);
               var16[2] = "setJdbcDriver(String)";
               var38.addEntry(var16, var12, var16[2]);
               var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setJdbcDriver(\"" + this.targetDSN.jdbcdriver.getText() + "\");";
               this.loadParameters(var40, var57);
               var16[2] = "setJdbcPrefix(String)";
               var38.addEntry(var16, var12, var16[2]);
               var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setJdbcPrefix(\"" + this.targetDSN.jdbcprefix.getText() + "\");";
               this.loadParameters(var40, var57);
               var16[2] = "setJdbcSuffix(String)";
               var38.addEntry(var16, var12, var16[2]);
               var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setJdbcSuffix(\"" + this.targetDSN.jdbcsuffix.getText() + "\");";
               this.loadParameters(var40, var57);
               var16[2] = "setUID(String)";
               var38.addEntry(var16, var12, var16[2]);
               var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setUID(\"" + this.targetDSN.userid.getText() + "\");";
               this.loadParameters(var40, var57);
               var16[2] = "setPWD(String)";
               var38.addEntry(var16, var12, var16[2]);
               var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setPWD(\"" + this.targetDSN.password.getText() + "\");";
               this.loadParameters(var40, var57);
               var16[2] = "setCSTR(String)";
               var38.addEntry(var16, var12, var16[2]);
               var40 = var38.getLastAddedBranch();
               var40.text = new String[1];
               var40.text[0] = var16[1] + ".setCSTR(\"" + this.targetDSN.connectstring.getText() + "\");";
               this.loadParameters(var40, var57);
            } else {
               var16[2] = "setDSN(String)";
               var38.addEntry(var16, var12, var16[2]);
               JDPTreeBranch var47 = var38.getLastAddedBranch();
               var47.text = new String[1];
               var47.text[0] = var16[1] + ".setDSN(\"" + this.targetDSN.datasource.getText() + "\");";
               String[] var58 = new String[]{"String"};
               this.loadParameters(var47, var58);
               var16[2] = "setCSTR(String)";
               var38.addEntry(var16, var12, var16[2]);
               var47 = var38.getLastAddedBranch();
               var47.text = new String[1];
               var47.text[0] = var16[1] + ".setCSTR(\"" + this.targetDSN.connectstring.getText() + "\");";
               this.loadParameters(var47, var58);
            }

            var16[2] = "setMailServer(String)";
            var38.addEntry(var16, var12, var16[2]);
            JDPTreeBranch var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            var49.text[0] = var16[1] + ".setMailServer(\"" + this.mailServer.getText() + "\");";
            String[] var59 = new String[]{"String"};
            this.loadParameters(var49, var59);
            var16[2] = "setSQL(String)";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            String var19 = this.emailColumn.getSelectedItem();
            this.jaggSQL.setDSN(this.targetDSN.datasource.getText());
            if (super.user.u.sqlRequiresChange(this.jaggSQL, 0)) {
               var19 = var19 + " aa";
            }

            for(int var20 = 0; var20 < var37.length; ++var20) {
               var19 = var19 + ",";
               var19 = var19 + var37[var20];
            }

            var49.text[0] = var16[1] + ".setSQL(\"SELECT " + var19 + " \");";
            var59[0] = "String";
            this.loadParameters(var49, var59);
            var16[2] = "setFromWhereClause(String)";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            String var61 = this.targetLayoutMgr.gSource.createFromWhereClause(this.targetDSN, this.tableTarget, this.target);
            var49.text[0] = var16[1] + ".setFromWhereClause(\"" + var61 + "\");";
            this.loadParameters(var49, var59);
            var16[2] = "setReturnAddress(String)";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            if (this.returnAddress.getText().equals("")) {
               var49.text[0] = var16[1] + ".setReturnAddress(" + super.thisBranch.name + "Rtn1.getText());";
            } else {
               var49.text[0] = var16[1] + ".setReturnAddress(\"" + this.returnAddress.getText() + "\");";
            }

            this.loadParameters(var49, var59);
            var16[2] = "setMessageSubject(String)";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            if (this.messageSubject.getText().equals("")) {
               var49.text[0] = var16[1] + ".setMessageSubject(" + super.thisBranch.name + "Sbj1.getText());";
            } else {
               var49.text[0] = var16[1] + ".setMessageSubject(\"" + this.messageSubject.getText() + "\");";
            }

            this.loadParameters(var49, var59);
            var16[2] = "setMergeColumns(String)";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            var49.text[0] = "String[] columns = {\"";

            for(int var21 = 0; var21 < var37.length; ++var21) {
               if (var21 > 0) {
                  var10000 = var49.text;
                  var10000[0] = var10000[0] + "\",\"";
               }

               var10000 = var49.text;
               var10000[0] = var10000[0] + var37[var21];
            }

            var10000 = var49.text;
            var10000[0] = var10000[0] + "\"};\r\n";
            var10000 = var49.text;
            var10000[0] = var10000[0] + var16[1] + ".setMergeColumns(columns);";
            this.loadParameters(var49, var59);
            var16[2] = "setMessage(String)";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            var49.text[0] = var16[1] + ".setMessage(" + super.thisBranch.name + "Msg1.getText());";
            this.loadParameters(var49, var59);
            var16[2] = "sendMultipleMessage()";
            var38.addEntry(var16, var12, var16[2]);
            var49 = var38.getLastAddedBranch();
            var49.text = new String[1];
            var49.text[0] = var16[1] + ".sendMultipleMessage();";
            var36.treeVector = new Vector();
            JDPTreePicker var62 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
            var62.setIcons(var12);
            var62.setRoot("Component Events", true);
            var13 = var62.treeRoot;
            var62.setDropKeys(var14);
            var62.setDragAndDrop((boolean[])null);
            var62.setDropMessages(var15);
            boolean[] var22 = new boolean[]{true, true, true, false};
            var62.setExpanded(var22);
            var36.treeVector.addElement(var13);
            var16[0] = "LIST_SELECT";
            var12[2] = 15;
            var16[1] = super.thisBranch.name + "Msg1";
            var16[2] = "replaceText(String,int,int)";
            var62.addEntry(var16, var12, var16[2]);
            JDPTreeBranch var23 = var62.getLastAddedBranch();
            var23.text = new String[1];
            var23.text[0] = var16[1] + ".replaceText(\"@\" + " + super.thisBranch.name + "Merge1.getSelectedItem()," + super.thisBranch.name + "Msg1.getSelectionStart()," + super.thisBranch.name + "Msg1.getSelectionEnd());";
            String[] var24 = new String[]{"String", "int", "int"};
            this.loadParameters(var23, var24);
            this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var5));
            this.targetLayoutMgr.lView.removeSelectedLeaf();
            this.targetLayoutMgr.reDraw();
            this.targetLayoutMgr.projectLoading = var4;
            JDPTreeBranch var25 = var3[var3.length - 1];
            var25.expanded = false;
            this.targetLayoutMgr.setProperties(var25);
            this.targetLayoutMgr.interactionMgr.loadMethodTree(var25, false);
            if (!this.targetLayoutMgr.projectLoading) {
               this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var25));
               this.targetLayoutMgr.setButton("Layout");
               this.targetLayoutMgr.reDraw();
            }
         }
      }

   }

   void loadParameters(JDPTreeBranch var1, String[] var2) {
      this.targetLayoutMgr.interactionMgr.loadParameterTree(var1, var2);
   }

   void InitComponents() {
      if (this.target != null) {
         String[] var1 = this.target.columns.getSelectedItems();
         this.emailColumn.loadChoice(var1, var1);
      } else {
         this.emailColumn.clear();
      }
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPEmailLayout" + super.componentName;
      var1.saveObject(this.emailColumn, var2, "emailColumn");
      var1.saveObject(this.mailServer, var2, "mailServer");
      var1.saveObject(this.returnAddress, var2, "returnAddress");
      var1.saveObject(this.messageSubject, var2, "messageSubject");
      var1.saveObject(this.message, var2, "message");
      return true;
   }

   void refresh() {
      this.retrieveColumns();
      this.InitComponents();
      this.restoreSelections();
   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.tableTarget = (JDPSelectTable)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target instanceof JDPButton) {
               String var2 = (String)var1.arg;
               if (var2.equals("Accept")) {
                  this.saveSelections();
                  this.loadLayoutComponent();
               }
            }

            return false;
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      super.moduleName = "EmailLayout";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
      }

      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Define Email column and default settings");
      this.Panel1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label1 = new Label("Email Address:", 0);
      this.emailColumn = new JDPComboBox(var1, "", 20);
      this.emailColumn.setEditable(false);
      this.Label2 = new Label("Mail server address:", 0);
      this.mailServer = new TextField("", 25);
      this.Label3 = new Label("Return Address:", 0);
      this.returnAddress = new TextField("", 25);
      this.Label4 = new Label("Default Subject:", 0);
      this.messageSubject = new TextField("", 40);
      this.Label5 = new Label("Default Message:", 0);
      this.message = new TextArea("", 6, 40);
      String[] var4 = new String[]{"Accept", "Reset"};
      int[] var5 = new int[]{JDPButton.getIconValue("Go"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Main.setLayout(new BorderLayout());
      this.Main.setFont(new Font("Helvetica", 0, 11));
      this.Main.setForeground(var1.u._cvtcolor("Black"));
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.emailColumn);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.mailServer);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.returnAddress);
      this.ScrollPanel1.add("Left", this.Label4);
      this.ScrollPanel1.add("Right", this.messageSubject);
      this.ScrollPanel1.add("Left", this.Label5);
      this.ScrollPanel1.add("Right", this.message);
      this.Panel1.add("South", this.JDPButtons1);
      this.Label1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.emailColumn, "Email column", "Choose the column from the tables that contains the Send To email address");
      this.Label2.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.mailServer, "Mail Server Domain Name", "Enter the domain name of the mailserver that will handle the email");
      this.Label3.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.returnAddress, "Default return address", "Enter the default return address for sending email");
      this.Label4.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.messageSubject, "Default message subject", "Enter the default message subject");
      this.Label5.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.message, "Default message", "Enter the default message to be sent (Optional)");
      this.InitComponents();
      Vector var6 = new Vector();
      var6.addElement(super.moduleName + super.componentName);
      var6.addElement(this);
      var1.gParm.addElement(var6);
      this.refresh();
   }
}
