public class JDPEmailSender {
   JDPUser user;
   // $FF: renamed from: s JDPSaveProps
   JDPSaveProps field_0;
   JDPJagg jaggSQL;

   public void setMailServer(String var1) {
      this.field_0.saveObject("mailServer", var1);
   }

   public void setToAddress(String var1) {
      this.field_0.saveObject("toAddress", var1);
   }

   public void setAttachment(String var1) {
      this.field_0.saveObject("attachment", var1);
   }

   public void setPWD(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setPWD(var1);
   }

   public void setJdbcPrefix(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setJdbcPrefix(var1);
   }

   public void setReturnAddress(String var1) {
      this.field_0.saveObject("returnAddress", var1);
   }

   public void setMessage(String var1) {
      this.field_0.saveObject("message", var1);
   }

   public void setFromWhereClause(String var1) {
      this.field_0.saveObject("whereClause", var1);
   }

   public void sendSingleMessage() {
      this.field_0.saveObject("messageFunction", "sendSingleMessage");
      new JDPSubmitJob(this.user, this.jaggSQL, "JDPMessageSvr", this.field_0, (Object)null);
      this.user.mainmsg.setStatusMsg("Email job submitted", 5);
   }

   public void setSQL(String var1) {
      this.field_0.saveObject("SQL", var1);
   }

   public void sendMultipleMessage() {
      this.field_0.saveObject("messageFunction", "sendBulkMail");
      if (this.jaggSQL != null) {
         new JDPSubmitJob(this.user, this.jaggSQL, "JDPMessageSvr", this.field_0, (Object)null);
         this.user.mainmsg.setStatusMsg("Email job submitted", 5);
      } else {
         this.user.mainmsg.setStatusMsg("Cannot submit Mail job. Jagg instance is null", 15);
      }
   }

   public void setJdbcDriver(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setJdbcDriver(var1);
   }

   public void setCSTR(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setCSTR(var1);
   }

   public void setUID(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setUID(var1);
   }

   public JDPEmailSender(JDPUser var1) {
      this.user = var1;
      this.field_0 = new JDPSaveProps(var1);
   }

   public JDPEmailSender(JDPUser var1, JDPJagg var2) {
      this.user = var1;
      this.jaggSQL = var2;
      this.field_0 = new JDPSaveProps(var1);
   }

   public void setMergeColumns(String[] var1) {
      this.field_0.saveObject("columns", var1);
   }

   public void setDSN(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setDSN(var1);
   }

   public void setJdbcSuffix(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setJdbcSuffix(var1);
   }

   public void setMessageSubject(String var1) {
      this.field_0.saveObject("messageSubject", var1);
   }
}
