import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Vector;

public class JDPGroupMaint extends Panel {
   JDPUser user;
   JDPDatabaseMaint target;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   TextField groupname;
   TextField groupdesc;

   void clearFields() {
      this.groupname.setText("");
      this.groupdesc.setText("");
   }

   void retrieveHandle() {
      for(int var1 = 0; var1 < this.user.gParm.size(); ++var1) {
      }

   }

   boolean saveData() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.user.jaggSQL.getSEP();
      String var3 = "";
      String[] var4 = this.target.tree.getSelectedBranch();
      if (this.insertRequested) {
         var3 = "INSERT INTO JDPTmpGrp (JDPSystem, templtype, groupname, " + "groupdesc) VALUES('" + this.user.JDPSystem + "','" + var4[1].substring(0, 1) + "','" + this.groupname.getText() + "', " + "'" + this.groupdesc.getText() + "')";
      } else {
         if (this.itemIndex < 0) {
            this.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         if (this.deleteRequested) {
            var3 = "DELETE FROM JDPTmpGrp" + " WHERE JDPSystem='" + this.user.JDPSystem + "'" + " AND templtype='" + var4[1].substring(0, 1) + "'" + " AND groupdesc='" + var4[2] + "'";
         }
      }

      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var1 = this.user.jaggSQL.execSQL(var3, var2);
      if (var1 == -1) {
         this.user.u.setSqlMessage(this.user.jaggSQL, var3);
         return false;
      } else {
         if (var1 == 1) {
            if (this.insertRequested) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (this.deleteRequested) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.user.jaggSQL, var3);
         }

         this.target.templateMaint.loadGroups();
         if (this.insertRequested) {
            this.target.tree.nothingChanged = false;
            this.target.tree.repaint();
         }

         this.insertRequested = false;
         this.deleteRequested = false;
         return true;
      }
   }

   public JDPGroupMaint(JDPUser var1, Panel var2, String var3, JDPDatabaseMaint var4) {
      this.user = var1;
      this.target = var4;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      JDPScrollPanel var8 = new JDPScrollPanel();
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      this.groupname = new TextField("", 20);
      this.groupdesc = new TextField("", 40);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Group Name:", Color.black));
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Description:", Color.black));
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new JDPLineLayout());
      ((Container)var10).add("Left", this.groupname);
      ((Container)var8).add("Right", var10);
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new JDPLineLayout());
      ((Container)var11).add("Left", this.groupdesc);
      ((Container)var8).add("Right", var11);
      ((Container)var7).add("Center", var8);
      this.groupname.setForeground(Color.black);
      this.groupdesc.setForeground(Color.black);
      this.groupname.setBackground(Color.white);
      this.groupdesc.setBackground(Color.white);
      if (var3.compareTo("Inquiry") == 0) {
         this.groupname.setEditable(false);
         this.groupdesc.setEditable(false);
      } else {
         String[] var12 = new String[]{"Apply"};
         int[] var13 = new int[]{0};
         ((Container)this).add("South", new JDPButtons(var1, var12, var13, JDPButtons.HORIZONTAL));
      }

      ((Container)var5).add("Center", var7);
      String[] var18 = new String[]{"Group Name", "Description"};
      String[] var19 = new String[]{"groupname", "groupdesc"};
      String[][] var14 = new String[2][8];
      var14[0][0] = "Begins with";
      var14[0][1] = "Contains";
      var14[1][0] = "Begins with";
      var14[1][1] = "Contains";
      String[][] var15 = new String[2][8];
      var15[0][0] = "like";
      var15[0][1] = "like";
      var15[1][0] = "like";
      var15[1][1] = "like";
      boolean[] var16 = new boolean[]{true, true};
      int[] var17 = new int[]{24, 54};
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Template Group Maintenance", var5, "North"));
      ((Component)var2).paintAll(((Component)var2).getGraphics());
      var1.gParm.addElement(this);
   }

   boolean checkFields() {
      if (!this.user.u.ischaracter(this.groupname, this.user.mainmsg, "Please enter a group name")) {
         return false;
      } else {
         return this.user.u.ischaracter(this.groupdesc, this.user.mainmsg, "Please enter a group description");
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.groupname)) {
                     this.user.u.cursor(this.groupdesc);
                     return true;
                  }

                  if (var1.target.equals(this.groupdesc)) {
                     this.user.u.cursor(this.groupname);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.groupdesc)) {
                     this.user.u.cursor(this.groupname);
                     return true;
                  }

                  if (var1.target.equals(this.groupname)) {
                     this.user.u.cursor(this.groupdesc);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2.trim().compareTo("Apply") == 0) {
                  if (this.checkFields()) {
                     if (this.insertRequested) {
                        this.saveData();
                     } else {
                        this.saveData();
                     }
                  }

                  return true;
               }

               return true;
            } else {
               if (var1.target instanceof TextField) {
                  this.checkFields();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }
}
