import java.util.Hashtable;

public class JDPHtmlTag {
   static Hashtable tagHashTable = new Hashtable(10);
   public String name;
   public boolean hasEndTag;
   public boolean breaks;
   // $FF: renamed from: id short
   public short field_0;
   public static final int UNKNOWN = 0;
   // $FF: renamed from: A int
   public static final int field_1 = 1;
   public static final int ADDRESS = 2;
   // $FF: renamed from: B int
   public static final int field_2 = 3;
   public static final int BASE = 4;
   public static final int BODY = 5;
   // $FF: renamed from: BR int
   public static final int field_3 = 6;
   public static final int CITE = 7;
   public static final int CODE = 8;
   // $FF: renamed from: DL int
   public static final int field_4 = 9;
   // $FF: renamed from: DD int
   public static final int field_5 = 10;
   public static final int DFN = 11;
   public static final int DIR = 12;
   // $FF: renamed from: DT int
   public static final int field_6 = 13;
   // $FF: renamed from: EM int
   public static final int field_7 = 14;
   // $FF: renamed from: H1 int
   public static final int field_8 = 15;
   // $FF: renamed from: H2 int
   public static final int field_9 = 16;
   // $FF: renamed from: H3 int
   public static final int field_10 = 17;
   // $FF: renamed from: H4 int
   public static final int field_11 = 18;
   // $FF: renamed from: H5 int
   public static final int field_12 = 19;
   // $FF: renamed from: H6 int
   public static final int field_13 = 20;
   public static final int HEAD = 21;
   // $FF: renamed from: HR int
   public static final int field_14 = 22;
   public static final int HTML = 23;
   // $FF: renamed from: I int
   public static final int field_15 = 24;
   public static final int IMG = 25;
   public static final int ISINDEX = 26;
   public static final int KBD = 27;
   // $FF: renamed from: LI int
   public static final int field_16 = 28;
   public static final int MENU = 29;
   public static final int NEXTID = 30;
   // $FF: renamed from: OL int
   public static final int field_17 = 31;
   // $FF: renamed from: P int
   public static final int field_18 = 32;
   public static final int PRE = 33;
   public static final int SAMP = 34;
   public static final int STRONG = 35;
   public static final int TITLE = 36;
   // $FF: renamed from: TT int
   public static final int field_19 = 37;
   // $FF: renamed from: U int
   public static final int field_20 = 38;
   // $FF: renamed from: UL int
   public static final int field_21 = 39;
   public static final int BLOCKQUOTE = 40;
   public static final int TEXTAREA = 41;
   public static final int APP = 42;
   public static final int PLAINTEXT = 43;
   public static final int COMMENT = 44;
   public static final int FORM = 45;
   public static final int INPUT = 46;
   public static final int SELECT = 47;
   public static final int VAR = 48;
   public static final int OPTION = 49;
   public static final int CENTER = 50;
   public static final int FONT = 51;
   public static final int BASEFONT = 52;
   public static final int NTAGS = 53;
   // $FF: renamed from: PL int
   public static final int field_22 = 54;
   public static final int COLOR = 55;
   public static final int SUP = 56;

   public String toString() {
      return this.getClass().getName() + "[" + this.name + "]";
   }

   static {
      new JDPHtmlTag("a", true, 1);
      new JDPHtmlTag("address", true, true, 2);
      new JDPHtmlTag("b", true, 3);
      new JDPHtmlTag("base", false, 4);
      new JDPHtmlTag("body", true, true, 5);
      new JDPHtmlTag("br", false, true, 6);
      new JDPHtmlTag("center", true, false, 50);
      new JDPHtmlTag("cite", true, 7);
      new JDPHtmlTag("code", true, 8);
      new JDPHtmlTag("color", true, 55);
      new JDPHtmlTag("dl", true, true, 9);
      new JDPHtmlTag("dd", false, true, 10);
      new JDPHtmlTag("dfn", true, 11);
      new JDPHtmlTag("dir", true, true, 12);
      new JDPHtmlTag("dt", false, true, 13);
      new JDPHtmlTag("em", true, 14);
      new JDPHtmlTag("font", true, 51);
      new JDPHtmlTag("h1", true, true, 15);
      new JDPHtmlTag("h2", true, true, 16);
      new JDPHtmlTag("h3", true, true, 17);
      new JDPHtmlTag("h4", true, true, 18);
      new JDPHtmlTag("h5", true, true, 19);
      new JDPHtmlTag("h6", true, true, 20);
      new JDPHtmlTag("head", true, true, 21);
      new JDPHtmlTag("hr", false, true, 22);
      new JDPHtmlTag("html", true, true, 23);
      new JDPHtmlTag("i", true, 24);
      new JDPHtmlTag("isindex", false, 26);
      new JDPHtmlTag("kbd", true, 27);
      new JDPHtmlTag("li", false, true, 28);
      new JDPHtmlTag("menu", true, true, 29);
      new JDPHtmlTag("nextid", false, 30);
      new JDPHtmlTag("ol", true, true, 31);
      new JDPHtmlTag("p", false, true, 32);
      new JDPHtmlTag("pre", true, true, 33);
      new JDPHtmlTag("samp", true, 34);
      new JDPHtmlTag("strong", true, 35);
      new JDPHtmlTag("sup", true, 56);
      new JDPHtmlTag("title", true, true, 36);
      new JDPHtmlTag("tt", true, 37);
      new JDPHtmlTag("u", true, 38);
      new JDPHtmlTag("ul", true, true, 39);
      new JDPHtmlTag("pl", true, true, 54);
      new JDPHtmlTag("blockquote", true, true, 40);
      new JDPHtmlTag("plaintext", false, 43);
      new JDPHtmlTag("<comment>", false, true, 44);
      new JDPHtmlTag("form", true, false, 45);
      new JDPHtmlTag("textarea", true, false, 41);
      new JDPHtmlTag("input", false, false, 46);
      new JDPHtmlTag("select", true, false, 47);
      new JDPHtmlTag("var", true, 48);
      new JDPHtmlTag("option", false, false, 49);
      new JDPHtmlTag("img", false, 25);
      new JDPHtmlTag("app", false, 42);
   }

   public static JDPHtmlTag lookup(String var0) {
      JDPHtmlTag var1 = (JDPHtmlTag)tagHashTable.get(var0);
      if (var1 == null) {
         var1 = new JDPHtmlTag(var0, false, false, 0);
      }

      return var1;
   }

   public JDPHtmlTag(String var1, boolean var2, boolean var3, int var4) {
      tagHashTable.put(var1, this);
      this.name = var1;
      this.hasEndTag = var2;
      this.breaks = var3;
      this.field_0 = (short)var4;
   }

   public JDPHtmlTag(String var1, boolean var2, int var3) {
      this(var1, var2, false, var3);
   }
}
