import java.util.Enumeration;
import java.util.Hashtable;

public class JDPHtmlTagRef {
   public JDPHtmlTag tag;
   public int pos;
   public boolean isEnd;
   Hashtable attributes;

   public String getAttribute(String var1) {
      return this.attributes == null ? null : (String)this.attributes.get(var1.toLowerCase());
   }

   public String toString() {
      String var1 = this.tag.name;
      if (this.isEnd) {
         var1 = "/" + var1;
      }

      return this.getClass().getName() + "[" + var1 + ": pos = " + this.pos + "]";
   }

   public String toExternalForm() {
      String var1 = this.isEnd ? "</" : "<";
      var1 = var1 + this.tag.name;
      String var3;
      if (this.attributes != null) {
         for(Enumeration var2 = this.attributes.keys(); var2.hasMoreElements(); var1 = var1 + var3 + "=\"" + this.attributes.get(var3) + "\"") {
            var3 = (String)var2.nextElement();
            var1 = var1 + " ";
         }
      }

      var1 = var1 + ">";
      return var1;
   }

   public void addAttribute(String var1, String var2) {
      if (this.attributes == null) {
         this.attributes = new Hashtable(1);
      }

      this.attributes.put(var1, var2);
   }

   public JDPHtmlTagRef(JDPHtmlTag var1, int var2, boolean var3) {
      this.tag = var1;
      this.pos = var2;
      this.isEnd = var3;
   }
}
