import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPInstanceMgr extends JDPClassLayout {
   JDPLayoutMgr target;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   Panel targetPanel;
   JDPDragItem dragPanel;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel2;
   Panel Panel1;
   JDPTreePicker Constructors;
   JDPTreePicker Parameters;
   JDPTreePicker Objects;
   Panel ParametersPanel;
   JDPButtons JDPButtons1;
   JDPScrollPanel constantPanel;
   Label constantLabel;
   TextField constantValue;
   JDPChoice constantChoice;
   JDPChoice layoutChoice;
   int constructorIndex;
   String[] layoutEntry;
   int[] icons;
   Component baseComponent;
   Object thisComponent;
   String compType;
   String compPosition;
   String[] text;
   String[][] properties;
   Vector treeVector;
   static Vector constructorCache;
   boolean justReloaded;

   Class getClass(JDPTreeBranch var1) {
      return this.getClass(var1.compType, var1.thisObject);
   }

   Class getClass(String var1) {
      return this.getClass(var1, (Object)null);
   }

   Class getClass(String var1, Object var2) {
      Class var3 = null;
      if (var1.indexOf(" ") > 0) {
         var1 = var1.substring(0, var1.indexOf(" "));
      }

      if (var1.equals("int")) {
         return Integer.TYPE;
      } else if (var1.equals("boolean")) {
         return Boolean.TYPE;
      } else if (var1.equals("char")) {
         return Character.TYPE;
      } else if (var1.equals("byte")) {
         return Byte.TYPE;
      } else if (var1.equals("short")) {
         return Short.TYPE;
      } else if (var1.equals("long")) {
         return Long.TYPE;
      } else if (var1.equals("float")) {
         return Float.TYPE;
      } else if (var1.equals("double")) {
         return Double.TYPE;
      } else if (var1.equals("void")) {
         return Void.TYPE;
      } else {
         if (var2 != null && !(var2 instanceof String)) {
            var1 = var2.toString();
         }

         if (var1.equals("String")) {
            var1 = "java.lang.String";
         }

         if (var2 != null && var2 instanceof String) {
            var1 = "java.lang.String";
         }

         if (var1.equals("JDPGridLayout")) {
            var1 = "JDPTextGrid";
         }

         if (var1.equals("JDPChartLayout")) {
            var1 = "JDPChart";
         }

         if (var1.indexOf("[") > 0) {
            var1 = var1.substring(0, var1.indexOf("["));
         }

         if (var1.indexOf(" ") > 0) {
            var1 = var1.substring(0, var1.indexOf(" "));
         }

         if (var1.indexOf("@") > 0) {
            var1 = var1.substring(0, var1.indexOf("@"));
         }

         try {
            var3 = Class.forName(var1);
         } catch (Exception var6) {
            ((Throwable)var6).printStackTrace();
         }

         return var3;
      }
   }

   public void restoreBranchObjects(JDPTreeBranch var1) {
      String var2 = var1.name.trim();
      if (var2.startsWith("String (")) {
         String var3 = var2.substring(9, var2.length() - 2);
         var1.thisObject = new String(var3);
      } else if (var2.startsWith("LayoutManager (")) {
         String var5 = var2.substring(15, var2.length() - 1);
         if (var5.equals("BorderLayout")) {
            var1.thisObject = new BorderLayout();
         } else if (var5.equals("GridLayout")) {
            var1.thisObject = new GridLayout(1, 1);
         } else if (var5.equals("FlowLayout")) {
            var1.thisObject = new FlowLayout();
         } else if (var5.equals("JDPLineLayout")) {
            var1.thisObject = new JDPLineLayout();
         } else if (var5.equals("JDPRowLayout")) {
            var1.thisObject = new JDPRowLayout();
         } else {
            var1.thisObject = new BorderLayout();
         }
      } else if (var2.startsWith("int (")) {
         String var6 = var2.substring(5, var2.length() - 1);
         var1.thisObject = new Integer(var6);
      } else if (var2.startsWith("boolean (")) {
         String var7 = var2.substring(9, var2.length() - 1);
         if (var7.equals("true")) {
            var1.thisObject = new Boolean(true);
         } else {
            var1.thisObject = new Boolean(false);
         }
      } else if (var2.startsWith("byte (")) {
         String var8 = var2.substring(6, var2.length() - 1);
         var1.thisObject = new Byte(var8);
      } else if (var2.startsWith("char (")) {
         String var9 = var2.substring(6, 7);
         var1.thisObject = new Character(var9.charAt(0));
      } else if (var2.startsWith("short (")) {
         String var10 = var2.substring(7, var2.length() - 1);
         var1.thisObject = new Short(var10);
      } else if (var2.startsWith("long (")) {
         String var11 = var2.substring(6, var2.length() - 1);
         var1.thisObject = new Long(var11);
      } else if (var2.startsWith("float (")) {
         String var12 = var2.substring(7, var2.length() - 1);
         var1.thisObject = new Float(var12);
      } else if (var2.startsWith("double (")) {
         String var13 = var2.substring(8, var2.length() - 1);
         var1.thisObject = new Double(var13);
      } else {
         var1.thisObject = this.locateObject(var1);
      }

      if (var1.leaves != null) {
         for(int var14 = 0; var14 < var1.leaves.size(); ++var14) {
            JDPTreeBranch var4 = (JDPTreeBranch)var1.leaves.elementAt(var14);
            this.restoreBranchObjects(var4);
         }
      }

   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = super.moduleName + super.componentName;
      this.constructorIndex = -1;
      this.Parameters.setRoot("", false);
      var1.restoreObject(this.Parameters.treeRoot, var2, "Parms");
      this.constructorIndex = var1.restoreObject(this.constructorIndex, var2, "conIdx", 0);
      this.Parameters.resetSelections();
      this.Parameters.reDraw();
      this.setConstantDisplay((JDPTreeBranch)null);
      if (this.constructorIndex >= 0) {
         this.Constructors.select(this.constructorIndex);
      }

      this.restoreBranchObjects(this.Parameters.treeRoot);
      if (this.target.projectLoading) {
         this.createNewInstance();
      }

      return true;
   }

   public void loadParameterTree(String var1) {
      this.Parameters.setRoot("Constructor Parameters", true);
      int[] var2 = new int[]{8, 1, 2, 1};
      String[] var3 = new String[]{"", null, null, null};
      boolean[] var4 = new boolean[]{true, false, true, false};
      this.Parameters.setIcons(var2);
      this.Parameters.setExpanded(var4);
      int var5 = 0;
      int var6 = var1.indexOf("(");
      if (var6 >= 0) {
         String var7 = var1.substring(var6);
         StringTokenizer var8 = new StringTokenizer(var7, ",()");

         while(var8.hasMoreTokens()) {
            ++var5;
            var3[0] = var8.nextToken();

            for(var2[1] = 1; this.Parameters.addEntry(var3, var2, var3[0]); var3[0] = var3[0] + " ") {
            }
         }
      } else {
         var3[0] = var1;
         var2[1] = 1;
         this.Parameters.addEntry(var3, var2, var3[0]);
      }

      this.Parameters.reDraw();
      this.Objects.setRoot("Choose an Object or method", true);
   }

   Vector retrieveConstructors(String var1) {
      if (constructorCache == null) {
         constructorCache = new Vector();
      }

      for(int var2 = 0; var2 < constructorCache.size(); ++var2) {
         Vector var3 = (Vector)constructorCache.elementAt(var2);
         String var4 = (String)var3.elementAt(0);
         if (var4.equals(var1)) {
            return (Vector)var3.elementAt(1);
         }
      }

      Vector var5 = new Vector();
      this.jaggSQL.loadSettings(super.user);
      this.jaggSQL.setFCTN("JavaBeanGetConstructors");
      this.jaggSQL.setFCTNP(var1 + ";");
      this.jaggSQL.execSQL("", var5);
      Vector var6 = new Vector();
      var6.addElement(var1);
      var6.addElement(var5);
      constructorCache.addElement(var6);
      return var5;
   }

   public void createNewInstance() {
      JDPTreeBranch var1 = null;
      JDPTreeBranch var2 = null;
      Object var3 = null;
      Object var4 = null;
      Object var5 = null;
      Object var6 = null;

      try {
         Class var7 = Class.forName(this.Constructors.treeRoot.name);
         if (System.getProperty("java.version").startsWith("1.0")) {
            var6 = var7.newInstance();
         } else {
            Constructor[] var8 = var7.getConstructors();
            int var9 = this.Parameters.treeRoot.leaves.size();
            Object[] var10 = new Object[var9];

            for(int var11 = 0; var11 < var9; ++var11) {
               var1 = (JDPTreeBranch)this.Parameters.treeRoot.leaves.elementAt(var11);
               if (var1.leaves.size() > 0) {
                  var2 = (JDPTreeBranch)var1.leaves.elementAt(0);
                  var10[var11] = var2.thisObject;
                  if (var2.leaves != null && var2.leaves.size() == 1) {
                     JDPTreeBranch var17 = (JDPTreeBranch)var2.leaves.elementAt(0);
                     if (var17.thisObject == null) {
                        var17.thisObject = this.locateObject(var2);
                     }

                     Class[] var18 = new Class[0];
                     var5 = new Object[0];
                     if (var17.leaves != null && var17.leaves.size() >= 1) {
                        var18 = new Class[var17.leaves.size()];
                        var5 = new Object[var17.leaves.size()];

                        for(int var12 = 0; var12 < var18.length; ++var12) {
                           JDPTreeBranch var13 = (JDPTreeBranch)var17.leaves.elementAt(var12);
                           if (var13.leaves != null && var13.leaves.size() >= 1) {
                              JDPTreeBranch var14 = (JDPTreeBranch)var13.leaves.elementAt(0);
                              var18[var12] = this.getClass(var14);
                              ((Object[])var5)[var12] = var14.thisObject;
                           }
                        }
                     }

                     if (var17.thisObject != null) {
                        Class var22 = this.getClass(var17);
                        Method var24 = var22.getMethod(var17.name.substring(0, var17.name.length() - 2), var18);
                        var10[var11] = var24.invoke(var17.thisObject, (Object[])var5);
                     } else if (var2.thisObject != null) {
                        Class var23 = this.getClass(var2);
                        Method var25 = var23.getMethod(var2.name.substring(0, var2.name.length()), var18);
                        Object[] var10000 = new Object[1];
                        var10[var11] = var25.invoke(var2.thisObject, (Object[])var5);
                     } else {
                        super.user.mainmsg.setStatusMsg("Could not invoke method on Object to create new instance", 20);
                     }
                  }
               }
            }

            if (var10.length == 0) {
               var6 = var7.newInstance();
            } else if (var1.name.equals("Create from other object")) {
               var6 = var2.thisObject;
            } else if (var10 != null && var10.length > 0 && var10[0] != null) {
               var6 = var8[this.constructorIndex].newInstance(var10);
            } else {
               var6 = var2.thisObject;
            }
         }
      } catch (Exception var16) {
         super.user.mainmsg.setStatusMsg("Failed to create a new instance of the selected object with the required parameters", 15);
         System.out.println("exception: " + ((Throwable)var16).getLocalizedMessage());
         ((Throwable)var16).toString();
         ((Throwable)var16).printStackTrace();
         return;
      }

      JDPTreeBranch var21 = this.target.cMgr.currentBranch;
      if (this.target.projectLoading) {
         this.target.lView.removeSelectedLeaf();
         this.target.lView.addEntry(this.layoutEntry, this.icons, this.baseComponent, var6, this.compType, this.compPosition, this.text, this.properties, this.treeVector);
         var21 = this.target.lView.tree.getLastAddedBranch();
      } else {
         var21.thisObject = var6;
         this.target.interactionMgr.loadMethodTree(var21, false);
      }

      var21.relatedComps = new Panel[1];
      var21.relatedComps[0] = this;
      if (this.justReloaded && this.properties != null) {
         var21.text = this.text;
         var21.properties = this.properties;
         this.target.cMgr.updateProperties(0);
      }

      if (!(var6 instanceof Component) && var21.compPosition != null && !var21.compPosition.equals("")) {
         var21.compPosition = "";
         var21.properties = null;
         this.target.cMgr.setProperties(var21);
      }

      this.justReloaded = false;
      if (!this.target.projectLoading) {
         this.target.reLoadComponents(this.target.compTree);
      }

   }

   Object locateObject(JDPTreeBranch var1) {
      JDPTreeBranch[] var2 = this.target.layoutTree.getTreeBranch(var1.name);
      if (var2 != null) {
         return var2[var2.length - 1].thisObject;
      } else if (var1.name.equals("user")) {
         return super.user;
      } else if (var1.name.equals("user.cust")) {
         return super.user.cust;
      } else if (var1.name.equals("user.u")) {
         return super.user.u;
      } else {
         return var1.name.equals("user.mainmsg") ? super.user.mainmsg : null;
      }
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = super.moduleName + super.componentName;
      var1.saveObject(this.Parameters.treeRoot, var2, "Parms");
      var1.saveObject(this.constructorIndex, var2, "conIdx", 0);
      return true;
   }

   public void setParameterObject(JDPTreeBranch[] var1, JDPTreeBranch[] var2, int var3, int var4) {
      int[] var5 = new int[21];
      var5[0] = 8;
      var5[1] = 1;
      var5[2] = 2;
      var5[3] = 1;
      String[] var6 = new String[20];
      boolean[] var7 = new boolean[21];

      for(int var8 = 0; var8 < var7.length; ++var8) {
         var7[var8] = true;
      }

      this.Parameters.setIcons(var5);
      this.Parameters.setExpanded(var7);

      for(int var12 = 0; var12 < var4; ++var12) {
         var6[var12] = var2[var12 + 1].name;
      }

      if (var3 == 3) {
         String var13 = var1[var1.length - 1].name;
         String var9 = var13.substring(var13.indexOf("("));
         var13 = var13.substring(0, var13.indexOf("(")) + "()";
         var6[var4] = var1[var1.length - 3].name.trim();
         var6[var4 + 1] = var13;
         var5[var4 + 1] = var1[var1.length - 3].icon;
         var5[var4 + 2] = 2;
         var2[var4].expanded = true;
         var2[var4].leaves = null;
         var2[var4].leaves = new Vector();
         if (var9.length() > 2) {
            var7[var4 + 2] = true;
            this.Parameters.setExpanded(var7);
         }

         this.Parameters.addEntry(var6, var5, var1[var3].name);
         JDPTreeBranch var10 = this.Parameters.getLastAddedBranch();
         this.Parameters.getTreeBranch(var10)[var4 + 1].iconImage = var1[var1.length - 3].iconImage;
         var10.thisObject = this.locateObject(var1[1]);
         StringTokenizer var11 = new StringTokenizer(var9, "(),");

         while(var11.hasMoreTokens()) {
            var6[var4 + 2] = var11.nextToken();
            var5[var4 + 3] = 1;
            this.Parameters.addEntry(var6, var5, var6[var4 + 2]);
         }
      } else if (var3 == 1) {
         var6[var4] = var1[var1.length - 1].name.trim();
         var5[var4 + 1] = var1[var1.length - 1].icon;
         var2[var4].expanded = true;
         var2[var4].leaves = null;
         var2[var4].leaves = new Vector();
         this.Parameters.addEntry(var6, var5, var1[1].name);
         JDPTreeBranch var15 = this.Parameters.getLastAddedBranch();
         var15.thisObject = var1[1].thisObject;
         if (var15.name.equals("user")) {
            var15.thisObject = super.user;
         }
      }

      this.Parameters.reDraw();
      this.setConstantDisplay(var2[var4]);
   }

   void refresh() {
      if (super.thisBranch != null && super.thisBranch.relatedComps != null && super.thisBranch.relatedComps[0] == this) {
         if (super.thisBranch != null) {
            this.loadConstructors(super.thisBranch.compType);
         }

         this.restoreSelections();
         String[] var1 = this.target.lView.tree.getSelectedBranch();
         if (var1 != null) {
            this.layoutEntry = new String[var1.length - 1];

            for(int var2 = 0; var2 < var1.length - 1; ++var2) {
               this.layoutEntry[var2] = var1[var2 + 1];
            }

            this.icons = this.target.lView.tree.getSelectedBranchIcons();
            JDPTreeBranch var3 = this.target.lView.tree.getCurrentBranch();
            if (var3 != null) {
               this.compType = var3.compType;
               this.text = var3.text;
               this.properties = var3.properties;
               this.justReloaded = true;
            }
         }

      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.Constructors)) {
                  super.user.u.cursor(this.Parameters);
                  return true;
               }

               if (var1.target.equals(this.Parameters)) {
                  super.user.u.cursor(this.Objects);
                  return true;
               }

               if (var1.target.equals(this.Objects)) {
                  super.user.u.cursor(this.JDPButtons1);
                  return true;
               }

               if (var1.target.equals(this.JDPButtons1)) {
                  super.user.u.cursor(this.Constructors);
                  return true;
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.Constructors)) {
                  super.user.u.cursor(this.Objects);
                  return true;
               }

               if (var1.target.equals(this.Parameters)) {
                  super.user.u.cursor(this.Constructors);
                  return true;
               }

               if (var1.target.equals(this.Objects)) {
                  super.user.u.cursor(this.Parameters);
                  return true;
               }

               if (var1.target.equals(this.JDPButtons1)) {
                  super.user.u.cursor(this.Objects);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            String var2 = (String)var1.arg;
            if (!var1.target.equals(this.Parameters) || this.Parameters.getSelectedLvl() != 1 && this.Parameters.getSelectedLvl() != 4) {
               if (var1.target.equals(this.Objects) && this.Objects.getSelectedLvl() == 1 && var2.equals("BranchOpen")) {
                  JDPTreeBranch var3 = this.Objects.getCurrentBranch();
                  String var4 = this.Parameters.getSelectedItem().trim();
                  if (var4.equals("Create from other object")) {
                     var4 = this.Constructors.treeRoot.name;
                  }

                  if (var3.leaves.size() <= 2) {
                     this.target.interactionMgr.loadSourceBuilderTree(this.Objects, var4, var3);
                  }

                  return true;
               } else if (var1.target.equals(this.Objects) && (this.Parameters.getSelectedLvl() == 1 || this.Parameters.getSelectedLvl() == 4) && (this.Objects.getSelectedLvl() == 1 || this.Objects.getSelectedLvl() == 3) && !var2.equals("BranchOpen")) {
                  this.setParameterObject(this.Objects.getTreeBranch(this.Objects.getCurrentBranch()), this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Objects.getSelectedLvl(), this.Parameters.getSelectedLvl());
                  return true;
               } else {
                  return false;
               }
            } else {
               this.setConstantDisplay(this.Parameters.getCurrentBranch());
               this.loadObjectTree(this.target.compTree, this.Parameters.getSelectedItem().trim());
               return true;
            }
         case 1001:
            if (var1.target.equals(this.Constructors) && this.Constructors.getSelectedLvl() == 1) {
               this.constructorIndex = this.Constructors.getSelectedIndex();
               this.loadParameterTree(this.Constructors.getSelectedItem());
               this.target.setAppChanged(true);
               return true;
            } else {
               if (!var1.target.equals(this.Parameters) || this.Parameters.getSelectedLvl() != 1 && this.Parameters.getSelectedLvl() != 4) {
                  if (!var1.target.equals(this.Objects) || this.Parameters.getSelectedLvl() != 1 && this.Parameters.getSelectedLvl() != 4 || this.Objects.getSelectedLvl() != 1 && this.Objects.getSelectedLvl() != 3) {
                     if (var1.target.equals(this.JDPButtons1.button[0])) {
                        if (this.constantPanel.isVisible()) {
                           this.setConstantValue(this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Parameters.getSelectedLvl());
                        }

                        this.saveSelections();
                        this.createNewInstance();
                        this.target.setAppChanged(true);
                        this.Parameters.reDraw();
                        return true;
                     }

                     if (var1.target.equals(this.JDPButtons1.button[1])) {
                        this.target.lView.removeSelectedLeaf();
                        this.target.setButton("Layout");
                        return true;
                     }

                     if (var1.target.equals(this.constantChoice)) {
                        this.setConstantValue(this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Parameters.getSelectedLvl());
                        this.target.setAppChanged(true);
                        this.Parameters.reDraw();
                        return true;
                     }

                     if (var1.target.equals(this.layoutChoice)) {
                        this.setConstantValue(this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Parameters.getSelectedLvl());
                        this.target.setAppChanged(true);
                        this.Parameters.reDraw();
                        return true;
                     }

                     if (var1.target.equals(this.constantValue)) {
                        this.setConstantValue(this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Parameters.getSelectedLvl());
                        this.Parameters.reDraw();
                        this.target.setAppChanged(true);
                        return true;
                     }

                     return false;
                  }

                  this.setParameterObject(this.Objects.getTreeBranch(this.Objects.getCurrentBranch()), this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Objects.getSelectedLvl(), this.Parameters.getSelectedLvl());
                  this.target.setAppChanged(true);
                  return true;
               }

               this.setConstantDisplay(this.Parameters.getCurrentBranch());
               this.loadObjectTree(this.target.compTree, this.Parameters.getSelectedItem().trim());
               this.target.setAppChanged(true);
               return true;
            }
         case 1005:
            if (var1.target.equals(this.constantValue)) {
               this.setConstantValue(this.Parameters.getTreeBranch(this.Parameters.getCurrentBranch()), this.Parameters.getSelectedLvl());
               this.Parameters.reDraw();
               this.target.setAppChanged(true);
               return true;
            }

            return true;
         default:
            return false;
      }
   }

   public void loadObjectTree(JDPTreeBranch var1, String var2) {
      int[] var3 = new int[]{4, 8, 1};
      String[] var4 = new String[]{"", null, null, null};
      boolean[] var5 = new boolean[]{true, false, true, false};
      this.Objects.setIcons(var3);
      this.Objects.setExpanded(var5);
      if (var2.equals("Create from other object")) {
         var2 = this.Constructors.treeRoot.name;
      }

      if (var1.equals(this.target.compTree)) {
         this.Objects.setRoot("Choose an Object or method", true);
         if (this.Parameters.getSelectedLvl() == 1) {
            this.target.interactionMgr.loadSourceBuilderTree(this.Objects, var2);
         }

         this.Objects.treeRoot.name = "Choose an Object or method";
         if (var2.equals("LayoutManager")) {
            var4[0] = var2 + " (\"BorderLayout\")";
            var3[1] = 8;
            this.Objects.addEntry(var4, var3, var4[0]);
         }

         if (var2.equals("String")) {
            var4[0] = var2 + " (\"String\")";
            var3[1] = 8;
            this.Objects.addEntry(var4, var3, var4[0]);
         }

         if (var2.equals("int") || var2.equals("short") || var2.equals("long") || var2.equals("float") || var2.equals("double")) {
            var4[0] = var2 + " (0)";
            var3[1] = 8;
            this.Objects.addEntry(var4, var3, var4[0]);
         }

         if (var2.equals("boolean")) {
            var4[0] = var2 + " (true)";
            var3[1] = 8;
            this.Objects.addEntry(var4, var3, var4[0]);
         }

         if (var2.equals("byte")) {
            var4[0] = var2 + " (c)";
            var3[1] = 8;
            this.Objects.addEntry(var4, var3, var4[0]);
         }

         if (var2.equals("char")) {
            var4[0] = var2 + " (b)";
            var3[1] = 8;
            this.Objects.addEntry(var4, var3, var4[0]);
         }
      }

      if (!var1.equals(this.target.layoutTree.getCurrentBranch())) {
         if (!var1.compType.equals(var2) && (!var1.compType.startsWith("java") || !var1.compType.endsWith(var2) || var2.equals("Create from other object"))) {
            if (var1.thisObject != null) {
               try {
                  Class var9 = var1.thisObject.getClass();
                  if (var9 == null) {
                     var9 = Class.forName(var1.compType);
                  }

                  for(; var9 != null; var9 = var9.getSuperclass()) {
                     if (var9.getName().equals(var2) || var9.getName().startsWith("java") && var9.getName().endsWith(var2)) {
                        var4[0] = var1.name + " ";
                        var3[1] = var1.icon;
                        this.Objects.addEntry(var4, var3, var4[0]);
                        JDPTreeBranch var7 = this.Objects.getLastAddedBranch();
                        var7.iconImage = var1.iconImage;
                     }
                  }
               } catch (Exception var8) {
               }
            }
         } else {
            var4[0] = var1.name + " ";
            var3[1] = var1.icon;
            this.Objects.addEntry(var4, var3, var4[0]);
            JDPTreeBranch var6 = this.Objects.getLastAddedBranch();
            var6.thisObject = var1.thisObject;
            var6.iconImage = var1.iconImage;
         }
      }

      if (var1.leaves != null) {
         for(int var10 = 0; var10 < var1.leaves.size(); ++var10) {
            JDPTreeBranch var11 = (JDPTreeBranch)var1.leaves.elementAt(var10);
            this.loadObjectTree(var11, var2);
         }
      }

      this.Objects.reDraw();
   }

   void addEntry(String[] var1, int[] var2, Component var3, Object var4, String var5, String var6, String[] var7, String[][] var8, Vector var9) {
      this.layoutEntry = var1;
      this.icons = var2;
      this.baseComponent = var3;
      this.thisComponent = var4;
      this.compType = var5;
      this.compPosition = var6;
      this.text = var7;
      this.properties = var8;
      this.treeVector = var9;
   }

   public void setConstantDisplay(JDPTreeBranch var1) {
      this.constantPanel.remove(this.constantValue);
      this.constantPanel.remove(this.constantChoice);
      this.constantPanel.remove(this.layoutChoice);
      this.ParametersPanel.remove(this.constantPanel);
      if (var1 == null) {
         this.Main.layout();
         this.Main.paintAll(this.Main.getGraphics());
      } else {
         var1.name.trim();
         String var2 = "";
         if (var1.leaves != null && var1.leaves.size() == 1) {
            JDPTreeBranch var3 = (JDPTreeBranch)var1.leaves.elementAt(0);
            String var4 = var3.name.trim();
            int var5 = var4.indexOf("(") + 1;
            if (var4.startsWith("LayoutManager (")) {
               var2 = var4.substring(var5, var4.length() - 1);
               this.constantLabel.setText("Layout:  ");
               this.layoutChoice.select(var2);
               this.constantPanel.add("Right", this.layoutChoice);
               this.ParametersPanel.add("South", this.constantPanel);
               this.ParametersPanel.layout();
               this.ParametersPanel.paintAll(this.ParametersPanel.getGraphics());
               this.Main.layout();
               this.Main.paintAll(this.Main.getGraphics());
               this.layoutChoice.requestFocus();
               return;
            }

            if (var4.startsWith("boolean (")) {
               var2 = var4.substring(var5, var4.length() - 1);
               this.constantLabel.setText("Boolean value:  ");
               this.constantChoice.select(var2);
               this.constantPanel.add("Right", this.constantChoice);
               this.ParametersPanel.add("South", this.constantPanel);
               this.ParametersPanel.layout();
               this.ParametersPanel.paintAll(this.ParametersPanel.getGraphics());
               this.Main.layout();
               this.Main.paintAll(this.Main.getGraphics());
               this.constantChoice.requestFocus();
               return;
            }

            if (var4.startsWith("char (")) {
               var2 = var4.substring(var5, var5 + 1);
               this.constantLabel.setText("Character value:  ");
               this.constantValue.setText(var2);
               this.constantPanel.add("Right", this.constantValue);
               this.ParametersPanel.add("South", this.constantPanel);
               this.ParametersPanel.layout();
               this.ParametersPanel.paintAll(this.ParametersPanel.getGraphics());
               this.Main.layout();
               this.Main.paintAll(this.Main.getGraphics());
               this.constantValue.selectAll();
               this.constantValue.requestFocus();
               return;
            }

            if (var4.startsWith("String (")) {
               var2 = var4.substring(var5 + 1, var4.length() - 2);
               this.constantLabel.setText(var4.substring(0, 1).toUpperCase() + var4.substring(1, var5 - 2) + " value:  ");
               this.constantValue.setText(var2);
               this.constantPanel.add("Right", this.constantValue);
               this.ParametersPanel.add("South", this.constantPanel);
               this.ParametersPanel.layout();
               this.ParametersPanel.paintAll(this.ParametersPanel.getGraphics());
               this.Main.layout();
               this.Main.paintAll(this.Main.getGraphics());
               this.constantValue.selectAll();
               this.constantValue.requestFocus();
               return;
            }

            if (var4.startsWith("int (") || var4.startsWith("byte (") || var4.startsWith("short (") || var4.startsWith("long (") || var4.startsWith("float (") || var4.startsWith("double (")) {
               var2 = var4.substring(var5, var4.length() - 1);
               this.constantLabel.setText(var4.substring(0, 1).toUpperCase() + var4.substring(1, var5 - 2) + " value:  ");
               this.constantValue.setText(var2);
               this.constantPanel.add("Right", this.constantValue);
               this.ParametersPanel.add("South", this.constantPanel);
               this.ParametersPanel.layout();
               this.ParametersPanel.paintAll(this.ParametersPanel.getGraphics());
               this.Main.layout();
               this.Main.paintAll(this.Main.getGraphics());
               this.constantValue.selectAll();
               this.constantValue.requestFocus();
            }
         }

      }
   }

   public boolean loadConstructors(String var1) {
      boolean var2 = false;
      boolean var3 = true;
      if (super.thisBranch == null || super.thisBranch.relatedComps == null || super.thisBranch.relatedComps[0] != this) {
         var3 = false;
      }

      Vector var4 = this.retrieveConstructors(var1);
      if (var3) {
         this.Constructors.setRoot(var1, true);
      }

      int[] var5 = new int[]{4, 8};
      String[] var6 = new String[1];

      for(int var7 = 0; var7 < var4.size(); ++var7) {
         if (!((String)var4.elementAt(var7)).equals(" ")) {
            StringTokenizer var8 = new StringTokenizer((String)var4.elementAt(var7), this.jaggSQL.getSEP());
            var6[0] = "(";
            int var9 = var8.countTokens() - 1;
            var8.nextToken();

            for(int var10 = 0; var10 < var9; ++var10) {
               if (var10 > 0) {
                  var6[0] = var6[0] + ",";
               }

               var6[0] = var6[0] + JDPInteractionMgr.convertParm(var8.nextToken());
            }

            var6[0] = var6[0] + ")";
            if (var6[0].equals("()")) {
               var2 = true;
            }

            if (var3) {
               this.Constructors.addEntry(var6, var5, var6[0]);
            }
         }
      }

      if (var3) {
         var6[0] = "Create from other object";
         this.Constructors.addEntry(var6, var5, var6[0]);
         if (var6[0].equals("()")) {
            this.Constructors.selectLastAddedBranch();
         }

         this.Constructors.sortTree();
         this.Constructors.reDraw();
         this.Parameters.setRoot("Constructor Parameters", true);
         this.Objects.setRoot("Choose an Object or method", true);
      }

      return var2;
   }

   public void setConstantValue(JDPTreeBranch[] var1, int var2) {
      if (var1 != null && (var2 == 1 || var2 == 4)) {
         JDPTreeBranch var3 = (JDPTreeBranch)var1[var2].leaves.elementAt(0);
         String var4 = var3.name.trim();
         if (var4.startsWith("String (")) {
            var3.thisObject = new String(this.constantValue.getText());
            var3.name = "String (\"" + this.constantValue.getText() + "\")";
         } else if (var4.startsWith("LayoutManager (")) {
            if (this.layoutChoice.getSelectedItem().equals("BorderLayout")) {
               var3.thisObject = new BorderLayout();
            } else if (this.layoutChoice.getSelectedItem().equals("GridLayout")) {
               var3.thisObject = new GridLayout(1, 1);
            } else if (this.layoutChoice.getSelectedItem().equals("FlowLayout")) {
               var3.thisObject = new FlowLayout();
            } else if (this.layoutChoice.getSelectedItem().equals("JDPLineLayout")) {
               var3.thisObject = new JDPLineLayout();
            } else if (this.layoutChoice.getSelectedItem().equals("JDPRowLayout")) {
               var3.thisObject = new JDPRowLayout();
            } else {
               var3.thisObject = new BorderLayout();
            }

            var3.name = "LayoutManager (" + this.layoutChoice.getSelectedItem() + ")";
         } else if (var4.startsWith("int (")) {
            var3.thisObject = new Integer(this.constantValue.getText());
            var3.name = "int (" + this.constantValue.getText() + ")";
         } else if (var4.startsWith("boolean (")) {
            if (this.constantChoice.getSelectedItem().equals("true")) {
               var3.thisObject = new Boolean(true);
            } else {
               var3.thisObject = new Boolean(false);
            }

            var3.name = "boolean (" + this.constantChoice.getSelectedItem() + ")";
         } else if (var4.startsWith("byte (")) {
            var3.thisObject = new Byte(this.constantValue.getText());
            var3.name = "byte (" + this.constantValue.getText() + ")";
         } else if (var4.startsWith("char (")) {
            var3.thisObject = new Character(this.constantValue.getText().charAt(0));
            var3.name = "char (" + this.constantValue.getText() + ")";
         } else if (var4.startsWith("short (")) {
            var3.thisObject = new Short(this.constantValue.getText());
            var3.name = "short (" + this.constantValue.getText() + ")";
         } else if (var4.startsWith("long (")) {
            var3.thisObject = new Long(this.constantValue.getText());
            var3.name = "long (" + this.constantValue.getText() + ")";
         } else if (var4.startsWith("float (")) {
            var3.thisObject = new Float(this.constantValue.getText());
            var3.name = "float (" + this.constantValue.getText() + ")";
         } else {
            if (var4.startsWith("double (")) {
               var3.thisObject = new Double(this.constantValue.getText());
               var3.name = "double (" + this.constantValue.getText() + ")";
            }

         }
      }
   }

   public void InitClass(JDPUser var1, JDPLayoutMgr var2, String var3) {
      super.user = var1;
      this.target = var2;
      this.targetPanel = this;
      this.dragPanel = var2.dragPanel;
      super.moduleName = "JDPInstanceMgr";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
      }

      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this.targetPanel);
      this.targetPanel.add(this.popuppanel);
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Define a new Instance");
      this.Panel2 = new Panel();
      this.Panel1 = new Panel();
      this.Constructors = new JDPTreePicker(var1);
      int[] var4 = new int[]{4, 8};
      this.Constructors.setIcons(var4);
      this.Constructors.setRoot("Constructors", true);
      this.Parameters = new JDPTreePicker(var1);
      int[] var5 = new int[]{8, 1, 2, 1};
      this.Parameters.setIcons(var5);
      this.Parameters.setRoot("Parameters", true);
      this.ParametersPanel = new Panel();
      this.ParametersPanel.setLayout(new BorderLayout());
      this.Objects = new JDPTreePicker(var1);
      this.Objects.setIcons(var4);
      this.Objects.setRoot("Objects", true);
      this.constantPanel = new JDPScrollPanel();
      this.constantLabel = new Label("String value:   ", 0);
      this.constantPanel.add("Left", this.constantLabel);
      this.constantValue = new TextField("", 10);
      this.constantChoice = new JDPChoice();
      this.constantChoice.addItem("true");
      this.constantChoice.addItem("false");
      this.layoutChoice = new JDPChoice();
      this.layoutChoice.addItem("BorderLayout");
      this.layoutChoice.addItem("GridLayout");
      this.layoutChoice.addItem("FlowLayout");
      this.layoutChoice.addItem("JDPLineLayout");
      this.layoutChoice.addItem("JDPRowLayout");
      String[] var6 = new String[]{"Accept", "Cancel"};
      int[] var7 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var6, var7, JDPButtons.getAlignmentValue("Horizontal"));
      this.Main.setLayout(new GridLayout(1, 3));
      this.Main.setFont(new Font("Helvetica", 0, 11));
      this.Main.setForeground(var1.u._cvtcolor("Black"));
      ((Container)this).add("Center", this.Main);
      this.Main.add(this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.Panel1);
      this.Panel1.setLayout(new GridLayout(1, 3));
      this.Panel1.add(this.Constructors);
      this.ParametersPanel.add("Center", this.Parameters);
      this.Panel1.add(this.ParametersPanel);
      this.Panel1.add(this.Objects);
      this.Panel2.add("South", this.JDPButtons1);
      this.Constructors.setBackground(var1.u._cvtcolor("White"));
      this.popuppanel.addComponent(this.Constructors, "Choose a constructor", "Choose a contructor to use to create an instance of this Object");
      this.Parameters.setBackground(var1.u._cvtcolor("White"));
      this.popuppanel.addComponent(this.Parameters, "Select each parameter", "Select each parameter and choose the Object to use to create the instance");
      this.Objects.setBackground(var1.u._cvtcolor("White"));
      this.popuppanel.addComponent(this.Objects, "Choose an Object", "Select the Object to pass for this parameter to create the new Instance");
      this.popuppanel.addComponent(this.JDPButtons1.button[0], "Accept Definition", "Accept this definition and create the new Instance");
      this.popuppanel.addComponent(this.JDPButtons1.button[1], "Cancel", "Cancel the creation of the instance of the new Object");
      Vector var8 = new Vector();
      var8.addElement(super.moduleName + super.componentName);
      var8.addElement(this);
      var1.gParm.addElement(var8);
   }
}
