import java.net.InetAddress;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPJaggUserMgr extends Thread {
   JDPSubsystemMgr manager;
   JDPJagg jaggSQL;
   Vector users;
   String lastJDPSystem = "";
   Hashtable userList;

   public JDPJaggUserMgr(JDPSubsystemMgr var1) {
      super(var1.mainThreadGroup, "JDPJaggUserMgr");
      this.manager = var1;
      this.users = new Vector();
   }

   public void run() {
      while(!this.manager.shutdownRequested) {
         try {
            Thread.sleep(10000L);
         } catch (Exception var1) {
         }
      }

   }

   public void checkUsers() {
      for(int var1 = 0; var1 < this.users.size(); ++var1) {
         JDPJaggUser var10000 = (JDPJaggUser)this.users.elementAt(var1);
      }

   }

   public JDPJaggUser getUser(InetAddress var1, int var2, String var3) {
      if (var3.equals("")) {
         var2 = -2;
      }

      if (var1 == null) {
         try {
            var1 = InetAddress.getLocalHost();
         } catch (Exception var6) {
         }
      }

      for(int var4 = 0; var4 < this.users.size(); ++var4) {
         JDPJaggUser var5 = (JDPJaggUser)this.users.elementAt(var4);

         try {
            if (!var3.equals("")) {
               if (var1 == null && var5.getInetAddress() == null) {
                  if (var5.getJDPUser() == -1) {
                     var5.setJDPUser(var2);
                  }

                  return var5;
               }

               if (var5.getInetAddress().equals(var1) && (var5.getJDPUser() == var2 || var5.getJDPUser() == -1 || var2 == -1) && var5.getJDPSystem().equals(var3)) {
                  if (var2 != -1) {
                     var5.setJDPUser(var2);
                  }

                  return var5;
               }
            } else if (var5.getInetAddress().equals(var1) && var5.getJDPUser() == var2 && var5.getJDPSystem().equals(var3)) {
               return var5;
            }
         } catch (Exception var7) {
            return var5;
         }
      }

      JDPJaggUser var8 = new JDPJaggUser(var1, var2, var3);
      this.users.addElement(var8);
      return var8;
   }

   public void removeUser(JDPJaggUser var1) {
      this.users.removeElement(var1);
   }

   public String getUsersIPAddresses() {
      String var1 = " " + this.manager.jaggSQL.getSEP();
      StringBuffer var2 = new StringBuffer();

      try {
         if (this.users != null) {
            for(int var3 = 0; var3 < this.users.size(); ++var3) {
               JDPJaggUser var4 = (JDPJaggUser)this.users.elementAt(var3);
               var2.append(Integer.toString(var4.getJDPUser()));
               var2.append(var1);

               try {
                  if (var4.getInetAddress() != null) {
                     var2.append(var4.getInetAddress().getHostAddress());
                  } else {
                     var2.append("127.0.0.1");
                  }
               } catch (Exception var5) {
                  var2.append("127.0.0.1");
               }

               var2.append(var1);
               var2.append(var4.getJDPSystem());
               var2.append(var1);
               var2.append(Long.toString(var4.getIdleFor()));
               var2.append(var1);
            }
         }
      } catch (Exception var6) {
         ((Throwable)var6).printStackTrace();
      }

      return var2.toString();
   }

   public String getUsers() {
      String var1 = " " + this.manager.jaggSQL.getSEP();
      StringBuffer var2 = new StringBuffer();

      try {
         if (this.users != null) {
            for(int var3 = 0; var3 < this.users.size(); ++var3) {
               JDPJaggUser var4 = (JDPJaggUser)this.users.elementAt(var3);
               var2.append(Integer.toString(var4.getJDPUser()));
               var2.append(var1);

               try {
                  if (var4.getInetAddress() != null) {
                     var2.append(var4.getInetAddress().getHostAddress());
                  } else {
                     var2.append("127.0.0.1");
                  }
               } catch (Exception var6) {
                  var2.append("127.0.0.1");
               }

               var2.append(var1);

               try {
                  if (var4.getInetAddress() != null) {
                     var2.append(var4.getInetAddress().getHostName());
                  } else {
                     var2.append("127.0.0.1");
                  }
               } catch (Exception var5) {
                  var2.append("127.0.0.1");
               }

               var2.append(var1);
               var2.append(var4.getJDPSystem());
               var2.append(var1);
               if (var4.getLastConnectionEnd() != null) {
                  var2.append(Long.toString(var4.getLastConnectionEnd().getTime()));
               } else {
                  var2.append("0");
               }

               var2.append(var1);
               var2.append(Long.toString(var4.getLastConnectionDuration()));
               var2.append(var1);
               var2.append(Long.toString(var4.getIdleFor()));
               var2.append(var1);
               var2.append(Integer.toString(var4.getTotalRequests()));
               var2.append(var1);
               var2.append(Long.toString(var4.getBytesReceived()));
               var2.append(var1);
               var2.append(Long.toString(var4.getBytesTransmitted()));
               var2.append(var1);
               var2.append(Integer.toString(var4.getUserStatus()));
               var2.append(var1);
               var2.append(this.getUserDetails(var4.getJDPSystem(), var4.getJDPUser()));
            }
         }
      } catch (Exception var7) {
         ((Throwable)var7).printStackTrace();
      }

      return var2.toString();
   }

   public String getUserDetails(String var1, int var2) {
      if (this.userList == null) {
         this.userList = new Hashtable();
      }

      String var3 = this.manager.jaggSQL.getSEP();
      String var4 = var1 + Integer.toString(var2);
      String var5 = (String)this.userList.get(var4);
      if (var5 == null) {
         if (!var1.equals("") && var2 > 0) {
            if (!var1.equals(this.lastJDPSystem)) {
               String var11 = this.manager.getJDPSystemSetup(var1);
               if (var11 == null) {
                  return "";
               }

               this.jaggSQL = this.manager.setupJaggInstance(var11);
               this.lastJDPSystem = var1;
            }

            Vector var12 = new Vector();
            String var13;
            if (this.manager.NDSPath == null) {
               var13 = "SELECT status,firstname,username,password,lastname,address1,address2,city,state,zipcode,country,cardnum,cardexpiry,cardname,phonenum,emailaddr,alphsvcph,alphpgrnum FROM JDPUser WHERE (userid = " + Integer.toString(var2) + ") ";
            } else {
               var13 = "SELECT JDP:status,`Given Name`,CN,CN,Surname,JDP:address1,JDP:address2,JDP:city,JDP:state,JDP:zipcode,JDP:country,JDP:cardnum,JDP:cardexpiry,JDP:cardname,`Telephone Number`,`Email Address`,JDP:alphsvcph,JDP:alphpgrnum FROM User WHERE JDP:userid = " + Integer.toString(var2);
               this.jaggSQL.setFCTN("NDSexecSQL");
            }

            int var8 = this.jaggSQL.execSQL(var13, var12);
            if (var8 > 0) {
               this.jaggSQL.setFCTN("");
               StringTokenizer var9 = new StringTokenizer((String)var12.elementAt(0), var3);
               StringBuffer var10 = new StringBuffer();

               while(var9.hasMoreTokens()) {
                  var10.append(var9.nextToken());
                  var10.append(var3);
               }

               var5 = var10.toString();
               this.userList.put(var4, var5);
            }
         } else {
            StringBuffer var6 = new StringBuffer();

            for(int var7 = 0; var7 < 18; ++var7) {
               var6.append(" " + var3);
            }

            var5 = var6.toString();
            this.userList.put(var4, var5);
         }
      }

      return var5;
   }
}
