import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPJobLogInquiry extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   Panel Panel2;
   Panel Columns1;
   Panel Panel5;
   JDPScrollPanel ScrollPanel1;
   Label EVENTNAMELabel1;
   TextField EVENTNAME1;
   Label EVTSOURCELabel1;
   TextField EVTSOURCE1;
   Label CATEGORYLabel1;
   TextField CATEGORY1;
   Label USERLabel1;
   TextField USER1;
   Label COMPUTERLabel1;
   TextField COMPUTER1;
   Label QUEUEDATELabel1;
   TextField QUEUEDATE1;
   Label JOBQUEUELabel1;
   TextField JOBQUEUE1;
   Label SUBSYSTEMLabel1;
   TextField SUBSYSTEM1;
   JDPScrollPanel ScrollPanel2;
   Label EVENTIDLabel1;
   TextField EVENTID1;
   Label STARTDATELabel1;
   TextField STARTDATE1;
   Label ENDDATELabel1;
   TextField ENDDATE1;
   Label TOTALTIMELabel1;
   TextField TOTALTIME1;
   Label FINALSTSLabel1;
   TextField FINALSTS1;
   Label NOTIFIEDLabel1;
   TextField NOTIFIED1;
   Label NOTIFYVIALabel1;
   TextField NOTIFYVIA1;
   Panel Panel6;
   Label EVENTLOGLabel1;
   TextArea EVENTLOG1;
   JDPButtons JDPButtons1;
   Panel Panel3;
   Panel Panel4;
   JDPChoice Choice1;
   Vector valueChoice1;
   JDPWhereClause SearchPanel1;
   JDPCardPanel CardPanel1;
   JDPSearchResults ResultList1;
   JDPSearchResults ResultList2;
   Vector statusVectorCode;
   Vector statusVectorDesc;
   Vector notifiedVectorCode;
   Vector notifiedVectorDesc;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Job Log Inquiry");
      this.Panel1 = new Panel();
      this.Panel2 = new Panel();
      this.Columns1 = new Panel();
      this.Panel5 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.EVENTNAMELabel1 = new Label("Job Name:", 0);
      this.EVENTNAME1 = new TextField("EVENTNAME", 25);
      this.EVTSOURCELabel1 = new Label("Source:", 0);
      this.EVTSOURCE1 = new TextField("EVTSOURCE", 25);
      this.CATEGORYLabel1 = new Label("Type:", 0);
      this.CATEGORY1 = new TextField("CATEGORY", 25);
      this.USERLabel1 = new Label("User:", 0);
      this.USER1 = new TextField("USERNAME", 25);
      this.COMPUTERLabel1 = new Label("Computer:", 0);
      this.COMPUTER1 = new TextField("COMPUTER", 25);
      this.QUEUEDATELabel1 = new Label("Queued:", 0);
      this.QUEUEDATE1 = new TextField("QUEUEDATE", 25);
      this.JOBQUEUELabel1 = new Label("Job Queue:", 0);
      this.JOBQUEUE1 = new TextField("JOBQUEUE", 25);
      this.SUBSYSTEMLabel1 = new Label("Subsystem:", 0);
      this.SUBSYSTEM1 = new TextField("SUBSYSTEM", 25);
      this.ScrollPanel2 = new JDPScrollPanel();
      this.EVENTIDLabel1 = new Label("Job Number:", 0);
      this.EVENTID1 = new TextField("EVENTID", 25);
      this.STARTDATELabel1 = new Label("Started:", 0);
      this.STARTDATE1 = new TextField("STARTDATE", 25);
      this.ENDDATELabel1 = new Label("Completed:", 0);
      this.ENDDATE1 = new TextField("ENDDATE", 25);
      this.TOTALTIMELabel1 = new Label("Duration:", 0);
      this.TOTALTIME1 = new TextField("TOTALTIME", 25);
      this.FINALSTSLabel1 = new Label("Status:", 0);
      this.FINALSTS1 = new TextField("FINALSTS", 25);
      this.NOTIFIEDLabel1 = new Label("Notified:", 0);
      this.NOTIFIED1 = new TextField("NOTIFIED", 25);
      this.NOTIFYVIALabel1 = new Label("Notified Via:", 0);
      this.NOTIFYVIA1 = new TextField("NOTIFYVIA", 25);
      this.Panel6 = new Panel();
      this.EVENTLOGLabel1 = new Label("Job Log:", 0);
      this.EVENTLOG1 = new TextArea("EVENTLOG", 6, 40);
      String[] var4 = new String[]{"Clear this Job from log", "Clear complete log"};
      int[] var5 = new int[]{JDPButton.getIconValue("Delete"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Panel3 = new Panel();
      this.Panel4 = new Panel();
      this.Choice1Main();
      this.SearchPanel1Main();
      this.CardPanel1 = new JDPCardPanel();
      this.ResultList1Main();
      this.ResultList2Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.Columns1);
      this.Columns1.setLayout(new BorderLayout());
      this.Columns1Main();
      this.Columns1.add("North", this.Panel5);
      this.Panel5.setLayout(new GridLayout(1, 2));
      this.Panel5.add(this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.EVENTNAMELabel1);
      this.ScrollPanel1.add("Right", this.EVENTNAME1);
      this.ScrollPanel1.add("Left", this.EVTSOURCELabel1);
      this.ScrollPanel1.add("Right", this.EVTSOURCE1);
      this.ScrollPanel1.add("Left", this.CATEGORYLabel1);
      this.ScrollPanel1.add("Right", this.CATEGORY1);
      this.ScrollPanel1.add("Left", this.USERLabel1);
      this.ScrollPanel1.add("Right", this.USER1);
      this.ScrollPanel1.add("Left", this.COMPUTERLabel1);
      this.ScrollPanel1.add("Right", this.COMPUTER1);
      this.ScrollPanel1.add("Left", this.QUEUEDATELabel1);
      this.ScrollPanel1.add("Right", this.QUEUEDATE1);
      this.ScrollPanel1.add("Left", this.JOBQUEUELabel1);
      this.ScrollPanel1.add("Right", this.JOBQUEUE1);
      this.ScrollPanel1.add("Left", this.SUBSYSTEMLabel1);
      this.ScrollPanel1.add("Right", this.SUBSYSTEM1);
      this.Panel5.add(this.ScrollPanel2);
      this.ScrollPanel2.add("Left", this.EVENTIDLabel1);
      this.ScrollPanel2.add("Right", this.EVENTID1);
      this.ScrollPanel2.add("Left", this.STARTDATELabel1);
      this.ScrollPanel2.add("Right", this.STARTDATE1);
      this.ScrollPanel2.add("Left", this.ENDDATELabel1);
      this.ScrollPanel2.add("Right", this.ENDDATE1);
      this.ScrollPanel2.add("Left", this.TOTALTIMELabel1);
      this.ScrollPanel2.add("Right", this.TOTALTIME1);
      this.ScrollPanel2.add("Left", this.FINALSTSLabel1);
      this.ScrollPanel2.add("Right", this.FINALSTS1);
      this.ScrollPanel2.add("Left", this.NOTIFIEDLabel1);
      this.ScrollPanel2.add("Right", this.NOTIFIED1);
      this.ScrollPanel2.add("Left", this.NOTIFYVIALabel1);
      this.ScrollPanel2.add("Right", this.NOTIFYVIA1);
      this.Columns1.add("Center", this.Panel6);
      this.Panel6.setLayout(new BorderLayout());
      this.Panel6.add("North", this.EVENTLOGLabel1);
      this.Panel6.add("Center", this.EVENTLOG1);
      this.Panel2.add("South", this.JDPButtons1);
      this.Panel1.add("West", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("North", this.Panel4);
      this.Panel4.setLayout(new BorderLayout());
      this.Panel4.add("South", this.Choice1);
      this.Panel4.add("Center", this.SearchPanel1);
      this.Panel3.add("Center", this.CardPanel1);
      this.CardPanel1.add("ResultList1", this.ResultList1);
      this.CardPanel1.add("ResultList2", this.ResultList2);
      this.EVENTNAMELabel1.setFont(new Font("Helvetica", 1, 11));
      this.EVENTNAME1.setEditable(false);
      this.popuppanel.addComponent(this.EVENTNAME1, "", "The name of the event that was run.");
      this.EVENTNAME1.setEditable(false);
      this.EVTSOURCELabel1.setFont(new Font("Helvetica", 1, 11));
      this.EVTSOURCE1.setEditable(false);
      this.popuppanel.addComponent(this.EVTSOURCE1, "", "The source of the event.");
      this.EVTSOURCE1.setEditable(false);
      this.CATEGORYLabel1.setFont(new Font("Helvetica", 1, 11));
      this.CATEGORY1.setEditable(false);
      this.popuppanel.addComponent(this.CATEGORY1, "Category", "");
      this.CATEGORY1.setEditable(false);
      this.USERLabel1.setFont(new Font("Helvetica", 1, 11));
      this.USER1.setEditable(false);
      this.popuppanel.addComponent(this.USER1, "", "The user that initiated the event.");
      this.USER1.setEditable(false);
      this.COMPUTERLabel1.setFont(new Font("Helvetica", 1, 11));
      this.COMPUTER1.setEditable(false);
      this.popuppanel.addComponent(this.COMPUTER1, "", "The computer that the event was initiated from.");
      this.COMPUTER1.setEditable(false);
      this.QUEUEDATELabel1.setFont(new Font("Helvetica", 1, 11));
      this.QUEUEDATE1.setEditable(false);
      this.popuppanel.addComponent(this.QUEUEDATE1, "", "The date/time that the event was queued.");
      this.JOBQUEUELabel1.setFont(new Font("Helvetica", 1, 11));
      this.JOBQUEUE1.setEditable(false);
      this.popuppanel.addComponent(this.JOBQUEUE1, "", "The Job Queue to which the event was submitted.");
      this.JOBQUEUE1.setEditable(false);
      this.SUBSYSTEMLabel1.setFont(new Font("Helvetica", 1, 11));
      this.SUBSYSTEM1.setEditable(false);
      this.popuppanel.addComponent(this.SUBSYSTEM1, "", "The Subsystem in which the event ran.");
      this.SUBSYSTEM1.setEditable(false);
      this.EVENTIDLabel1.setFont(new Font("Helvetica", 1, 11));
      this.EVENTID1.setEditable(false);
      this.popuppanel.addComponent(this.EVENTID1, "", "The unique event id that was assigned by the System when it was submitted to the Job Queue.");
      this.EVENTID1.setEditable(false);
      this.STARTDATELabel1.setFont(new Font("Helvetica", 1, 11));
      this.STARTDATE1.setEditable(false);
      this.popuppanel.addComponent(this.STARTDATE1, "", "The date/time that the event started in the Subsystem.");
      this.STARTDATE1.setEditable(false);
      this.ENDDATELabel1.setFont(new Font("Helvetica", 1, 11));
      this.ENDDATE1.setEditable(false);
      this.popuppanel.addComponent(this.ENDDATE1, "", "The date/time that the event completed.");
      this.ENDDATE1.setEditable(false);
      this.TOTALTIMELabel1.setFont(new Font("Helvetica", 1, 11));
      this.TOTALTIME1.setEditable(false);
      this.popuppanel.addComponent(this.TOTALTIME1, "", "The total duration of the event.");
      this.TOTALTIME1.setEditable(false);
      this.FINALSTSLabel1.setFont(new Font("Helvetica", 1, 11));
      this.FINALSTS1.setEditable(false);
      this.popuppanel.addComponent(this.FINALSTS1, "", "The final status of the event.");
      this.FINALSTS1.setEditable(false);
      this.NOTIFIEDLabel1.setFont(new Font("Helvetica", 1, 11));
      this.NOTIFIED1.setEditable(false);
      this.popuppanel.addComponent(this.NOTIFIED1, "", "The user to whom notification was made upon event completion.");
      this.NOTIFIED1.setEditable(false);
      this.NOTIFYVIALabel1.setFont(new Font("Helvetica", 1, 11));
      this.NOTIFYVIA1.setEditable(false);
      this.popuppanel.addComponent(this.NOTIFYVIA1, "", "The media that was used to notify the user.");
      this.NOTIFYVIA1.setEditable(false);
      this.EVENTLOGLabel1.setFont(new Font("Helvetica", 1, 11));
      this.EVENTLOG1.setEditable(false);
      this.popuppanel.addComponent(this.EVENTLOG1, "", "The output of the event.");
      this.EVENTLOG1.setEditable(false);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.EVENTNAME1)) {
                  this.user.u.cursor(this.EVTSOURCE1);
               }

               if (var1.target.equals(this.EVTSOURCE1)) {
                  this.user.u.cursor(this.CATEGORY1);
               }

               if (var1.target.equals(this.CATEGORY1)) {
                  this.user.u.cursor(this.USER1);
               }

               if (var1.target.equals(this.USER1)) {
                  this.user.u.cursor(this.COMPUTER1);
               }

               if (var1.target.equals(this.COMPUTER1)) {
                  this.user.u.cursor(this.QUEUEDATE1);
               }

               if (var1.target.equals(this.QUEUEDATE1)) {
                  this.user.u.cursor(this.JOBQUEUE1);
               }

               if (var1.target.equals(this.JOBQUEUE1)) {
                  this.user.u.cursor(this.SUBSYSTEM1);
               }

               if (var1.target.equals(this.SUBSYSTEM1)) {
                  this.user.u.cursor(this.EVENTID1);
               }

               if (var1.target.equals(this.EVENTID1)) {
                  this.user.u.cursor(this.STARTDATE1);
               }

               if (var1.target.equals(this.STARTDATE1)) {
                  this.user.u.cursor(this.ENDDATE1);
               }

               if (var1.target.equals(this.ENDDATE1)) {
                  this.user.u.cursor(this.TOTALTIME1);
               }

               if (var1.target.equals(this.TOTALTIME1)) {
                  this.user.u.cursor(this.FINALSTS1);
               }

               if (var1.target.equals(this.FINALSTS1)) {
                  this.user.u.cursor(this.NOTIFIED1);
               }

               if (var1.target.equals(this.NOTIFIED1)) {
                  this.user.u.cursor(this.NOTIFYVIA1);
               }

               if (var1.target.equals(this.NOTIFYVIA1)) {
                  this.user.u.cursor(this.EVENTLOG1);
               }

               if (var1.target.equals(this.EVENTLOG1)) {
                  this.user.u.cursor(this.EVENTNAME1);
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.EVENTNAME1)) {
                  this.user.u.cursor(this.EVENTLOG1);
                  return true;
               }

               if (var1.target.equals(this.EVTSOURCE1)) {
                  this.user.u.cursor(this.EVENTNAME1);
                  return true;
               }

               if (var1.target.equals(this.CATEGORY1)) {
                  this.user.u.cursor(this.EVTSOURCE1);
                  return true;
               }

               if (var1.target.equals(this.USER1)) {
                  this.user.u.cursor(this.CATEGORY1);
                  return true;
               }

               if (var1.target.equals(this.COMPUTER1)) {
                  this.user.u.cursor(this.USER1);
                  return true;
               }

               if (var1.target.equals(this.QUEUEDATE1)) {
                  this.user.u.cursor(this.COMPUTER1);
                  return true;
               }

               if (var1.target.equals(this.JOBQUEUE1)) {
                  this.user.u.cursor(this.QUEUEDATE1);
                  return true;
               }

               if (var1.target.equals(this.SUBSYSTEM1)) {
                  this.user.u.cursor(this.JOBQUEUE1);
                  return true;
               }

               if (var1.target.equals(this.EVENTID1)) {
                  this.user.u.cursor(this.SUBSYSTEM1);
                  return true;
               }

               if (var1.target.equals(this.STARTDATE1)) {
                  this.user.u.cursor(this.EVENTID1);
                  return true;
               }

               if (var1.target.equals(this.ENDDATE1)) {
                  this.user.u.cursor(this.STARTDATE1);
                  return true;
               }

               if (var1.target.equals(this.TOTALTIME1)) {
                  this.user.u.cursor(this.ENDDATE1);
                  return true;
               }

               if (var1.target.equals(this.FINALSTS1)) {
                  this.user.u.cursor(this.TOTALTIME1);
                  return true;
               }

               if (var1.target.equals(this.NOTIFIED1)) {
                  this.user.u.cursor(this.FINALSTS1);
                  return true;
               }

               if (var1.target.equals(this.NOTIFYVIA1)) {
                  this.user.u.cursor(this.NOTIFIED1);
                  return true;
               }

               if (var1.target.equals(this.EVENTLOG1)) {
                  this.user.u.cursor(this.NOTIFYVIA1);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.JDPButtons1ClearLog(this.EVENTNAME1.getText());
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               this.JDPButtons1ClearLog((String)null);
               return true;
            } else if (var1.target.equals(this.Choice1)) {
               if (this.Choice1.getSelectedKey().equals("E")) {
                  this.CardPanel1.setSelectedComp("ResultList1");
               }

               if (this.Choice1.getSelectedKey().equals("S")) {
                  this.CardPanel1.setSelectedComp("ResultList2");
               }

               return true;
            } else if (var1.target.equals(this.SearchPanel1)) {
               if (this.Choice1.getSelectedKey().equals("E")) {
                  this.ResultList1.clearList();
                  this.ResultList1.setFromWhereClause(this.SearchPanel1.getFromWhereClause());
                  this.ResultList1.loadList();
                  this.convertTimes(this.ResultList1);
               }

               if (this.Choice1.getSelectedKey().equals("S")) {
                  this.ResultList2.clearList();
                  this.ResultList2.setFromWhereClause(this.SearchPanel1.getFromWhereClause());
                  this.ResultList2.loadList();
                  this.convertTimes(this.ResultList2);
               }

               return true;
            } else if (var1.target.equals(this.ResultList1)) {
               this.Columns1Load(this.ResultList1.getSelectedKey());
               return true;
            } else {
               if (var1.target.equals(this.ResultList2)) {
                  this.Columns1Load(this.ResultList2.getSelectedKey());
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void convertTimes(JDPSearchResults var1) {
      JDPTreeBranch var7 = var1.tree.treeRoot;

      for(int var8 = 0; var8 < var7.leaves.size(); ++var8) {
         JDPTreeBranch var9 = (JDPTreeBranch)var7.leaves.elementAt(var8);

         for(int var10 = 0; var10 < var9.leaves.size(); ++var10) {
            JDPTreeBranch var11 = (JDPTreeBranch)var9.leaves.elementAt(var10);

            for(int var12 = 0; var12 < var11.leaves.size(); ++var12) {
               JDPTreeBranch var13 = (JDPTreeBranch)var11.leaves.elementAt(var12);
               long var2 = Long.valueOf(var13.name);
               int var5 = (int)var2 / 3600000;
               String var4 = Integer.toString((int)(var2 - (long)(var5 * 3600000)) / '\uea60');
               String var6 = "am";
               if (var5 > 11) {
                  var6 = "pm";
               }

               if (var5 > 12) {
                  var5 -= 12;
               }

               if (var5 == 0) {
                  var5 = 12;
               }

               if (var4.length() == 1) {
                  var4 = "0" + var4;
               }

               var13.name = Integer.toString(var5) + ":" + var4 + " " + var6;
            }
         }
      }

   }

   public void MainMethod() {
   }

   public void setSearchOn(String var1) {
      this.SearchPanel1.setChooseFrom(var1);
   }

   public void setMatchUsing(String var1) {
      this.SearchPanel1.setMatchUsing(var1);
   }

   public void setMatchConstant(String var1) {
      this.SearchPanel1.setMatchConstant(var1);
   }

   public void newSearch() {
      this.SearchPanel1.buildWhereClause();
      Event var1 = new Event(this.SearchPanel1, 1001, "");
      ((Component)this).postEvent(var1);
   }

   public void locateAndLoadJob(int var1) {
      String[] var2 = new String[]{Integer.toString(var1)};
      if (this.Choice1.getSelectedKey().equals("E")) {
         this.ResultList1.setSelectedKey(var2);
      } else {
         this.ResultList2.setSelectedKey(var2);
      }

      this.Columns1Load(var2);
   }

   public void Columns1Main() {
      this.Columns1LoadChoices();
      this.Columns1ClearFields();
   }

   public void Columns1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var7 = "SELECT EVENTID,EVENTNAME,EVTSOURCE,CATEGORY,USERNAME,COMPUTER,QUEUEDATE,QUEUETIME,JOBQUEUE,SUBSYSTEM,STARTDATE,STARTTIME,ENDDATE,ENDTIME,NOTIFIED,NOTIFYVIA,TOTALTIME,FINALSTS,EVENTLOG FROM JDPEvtLo WHERE (1=1)";
         if (var1.length > 0 && var1[0] != null) {
            var7 = var7 + " AND EVENTID=" + var1[0] + "";
         }

         this.jaggSQL.loadSettings(this.user);
         this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
         var3 = this.jaggSQL.execSQL(var7, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var7);
         } else {
            String var8 = "";
            String var9 = "";
            String var10 = "";
            String var11 = "";
            String var12 = "";
            String var13 = "";
            String var14 = "";
            String var15 = "";
            String var16 = "";
            String var17 = "";
            if (var3 >= 1) {
               String var6 = (String)var4.elementAt(0);
               if (var6 != null && var6.trim().compareTo("") != 0) {
                  StringTokenizer var2 = new StringTokenizer(var6, var5);
                  this.EVENTID1.setText(var2.nextToken().trim());
                  this.EVENTNAME1.setText(var2.nextToken().trim());
                  this.EVTSOURCE1.setText(var2.nextToken().trim());
                  this.CATEGORY1.setText(var2.nextToken().trim());
                  this.USER1.setText(var2.nextToken().trim());
                  this.COMPUTER1.setText(var2.nextToken().trim());
                  var8 = var2.nextToken().trim();
                  var11 = var2.nextToken().trim();
                  this.JOBQUEUE1.setText(var2.nextToken().trim());
                  this.SUBSYSTEM1.setText(var2.nextToken().trim());
                  var9 = var2.nextToken().trim();
                  var12 = var2.nextToken().trim();
                  var10 = var2.nextToken().trim();
                  var13 = var2.nextToken().trim();
                  var15 = var2.nextToken().trim();
                  var16 = var2.nextToken().trim();
                  var14 = var2.nextToken().trim();
                  var17 = var2.nextToken().trim();
                  this.EVENTLOG1.setText(var2.nextToken().trim());
               }

               if (var3 > 1) {
                  this.user.mainmsg.setStatusMsg(JDPLang.get("Message1"), 10);
               } else {
                  this.user.mainmsg.clearStatusMsg();
               }

               long var18 = Long.valueOf(var14);
               long var20 = var18 / 86400000L;
               long var22 = (var18 - var20 * 24L * 3600000L) / 3600000L;
               long var24 = (var18 - var20 * 24L * 3600000L - var22 * 3600000L) / 60000L;
               long var26 = (var18 - var20 * 24L * 3600000L - var22 * 3600000L - var24 * 60000L) / 1000L;
               String var28 = "";
               if (var20 > 0L) {
                  var28 = var28 + Long.toString(var20) + " dys ";
               }

               var28 = var28 + Long.toString(var22) + " hr " + Long.toString(var24) + " min " + Long.toString(var26) + " secs";
               if (var14.equals("0")) {
                  this.TOTALTIME1.setText("");
               } else {
                  this.TOTALTIME1.setText(var28);
               }

               this.FINALSTS1.setText((String)this.statusVectorDesc.elementAt(this.statusVectorCode.indexOf(var17)));
               this.NOTIFIED1.setText((String)this.notifiedVectorDesc.elementAt(this.notifiedVectorCode.indexOf(var15)));
               if (var8.equals("0")) {
                  this.QUEUEDATE1.setText("");
               } else {
                  this.QUEUEDATE1.setText((new Date(Long.valueOf(var8) + Long.valueOf(var11))).toString());
               }

               if (var9.equals("0")) {
                  this.STARTDATE1.setText("");
               } else {
                  this.STARTDATE1.setText((new Date(Long.valueOf(var9) + Long.valueOf(var12))).toString());
               }

               if (var10.equals("0")) {
                  this.ENDDATE1.setText("");
               } else {
                  this.ENDDATE1.setText((new Date(Long.valueOf(var10) + Long.valueOf(var13))).toString());
               }

               if (this.NOTIFIED1.getText().equals("")) {
                  this.NOTIFYVIA1.setText("");
                  return;
               }

               if (var16.equals("E")) {
                  this.NOTIFYVIA1.setText("EMail");
                  return;
               }

               if (var16.equals("P")) {
                  this.NOTIFYVIA1.setText("Pager");
                  return;
               }

               if (var16.equals("B")) {
                  this.NOTIFYVIA1.setText("EMail and Pager");
                  return;
               }
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message2"), 10);
               this.Columns1ClearFields();
            }

         }
      } else {
         this.Columns1ClearFields();
      }
   }

   public boolean Columns1updateRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "U") : false;
   }

   public boolean Columns1insertRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "I") : false;
   }

   public boolean Columns1removeRow(String[] var1) {
      return this.Columns1Save(var1, "D");
   }

   boolean Columns1Save(String[] var1, String var2) {
      int var3 = 0;
      Vector var4 = new Vector();
      this.jaggSQL.getSEP();
      String var5 = "";
      Object var6 = null;
      if (var2.equals("I")) {
         var5 = "INSERT INTO JDPEvtLo (EVENTID, JDPSYSTEM, EVENTNAME, EVTSOURCE, CATEGORY, USERNAME, COMPUTER, QUEUEDATE, QUEUETIME, JOBQUEUE, SUBSYSTEM, STARTDATE, STARTTIME, ENDDATE, ENDTIME, NOTIFIED, NOTIFYVIA, TOTALTIME, FINALSTS, EVENTLOG) VALUES(" + JDPUtils.tonum(this.EVENTID1.getText()) + ", " + "'', " + "'" + this.user.u.replace(this.EVENTNAME1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.EVTSOURCE1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.CATEGORY1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.USER1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.COMPUTER1.getText(), "'", "''") + "', " + "'" + JDPDate.format(this.QUEUEDATE1.getText()) + "', " + "0, " + "'" + this.user.u.replace(this.JOBQUEUE1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.SUBSYSTEM1.getText(), "'", "''") + "', " + "'" + JDPDate.format(this.STARTDATE1.getText()) + "', " + "0, " + "'" + JDPDate.format(this.ENDDATE1.getText()) + "', " + "0, " + "" + JDPUtils.tonum(this.NOTIFIED1.getText()) + ", " + "'" + this.user.u.replace(this.NOTIFYVIA1.getText(), "'", "''") + "', " + "" + JDPUtils.tonum(this.TOTALTIME1.getText()) + ", " + "'" + this.user.u.replace(this.FINALSTS1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.EVENTLOG1.getText(), "'", "''") + "')";
      } else {
         if (var1 == null || var1.length == 0) {
            this.user.mainmsg.setStatusMsg(JDPLang.get("Message3"), 5);
            return false;
         }

         if (var2.equals("D")) {
            var5 = "DELETE FROM JDPEvtLo WHERE EVENTID=" + var1[0];
         } else {
            var5 = "UPDATE JDPEvtLo SET QUEUEDATE = '" + JDPDate.format(this.QUEUEDATE1.getText()) + "'" + " WHERE EVENTID=" + var1[0];
         }
      }

      this.jaggSQL.loadSettings(this.user);
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      var3 = this.jaggSQL.execSQL(var5, var4);
      if (var3 == 0 && var6 != null) {
         String[] var7 = new String[]{JDPLang.get("Reload"), JDPLang.get("Update")};
         int[] var8 = new int[]{6, 0};
         JDPMessageDialog var9 = new JDPMessageDialog(this.user, this.user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), var7, var8);
         ((JDPDialog)var9).display();
         if (var9.getPressedButton() != 1) {
            this.Columns1Load(var1);
            return true;
         }

         var4 = new Vector();
         var3 = this.jaggSQL.execSQL((String)var6, var4);
      }

      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var5);
         return false;
      } else {
         if (var3 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message4"), 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message5"), 3);
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message6"), 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var5);
         }

         if (var6 != null) {
            this.Columns1Load(var1);
         }

         return true;
      }
   }

   public void Columns1ClearFields() {
      this.EVENTID1.setText("");
      this.EVENTNAME1.setText("");
      this.EVTSOURCE1.setText("");
      this.CATEGORY1.setText("");
      this.USER1.setText("");
      this.COMPUTER1.setText("");
      this.QUEUEDATE1.setText("");
      this.JOBQUEUE1.setText("");
      this.SUBSYSTEM1.setText("");
      this.STARTDATE1.setText("");
      this.ENDDATE1.setText("");
      this.NOTIFIED1.setText("");
      this.NOTIFYVIA1.setText("");
      this.TOTALTIME1.setText("");
      this.FINALSTS1.setText("");
      this.EVENTLOG1.setText("");
   }

   void Columns1LoadChoices() {
      String var2 = this.jaggSQL.getSEP();
      this.jaggSQL.loadSettings(this.user);
      this.statusVectorCode = new Vector();
      this.statusVectorDesc = new Vector();
      this.statusVectorCode.addElement("1");
      this.statusVectorDesc.addElement("Created");
      this.statusVectorCode.addElement("2");
      this.statusVectorDesc.addElement("Queued");
      this.statusVectorCode.addElement("3");
      this.statusVectorDesc.addElement("Held on Queue");
      this.statusVectorCode.addElement("4");
      this.statusVectorDesc.addElement("Active");
      this.statusVectorCode.addElement("5");
      this.statusVectorDesc.addElement("Held in Subsystem");
      this.statusVectorCode.addElement("9");
      this.statusVectorDesc.addElement("Incomplete");
      this.statusVectorCode.addElement("10");
      this.statusVectorDesc.addElement("Complete");
      Vector var3 = new Vector();
      this.jaggSQL.execSQL("SELECT userid, username FROM JDPUser", var3);
      this.notifiedVectorCode = new Vector();
      this.notifiedVectorDesc = new Vector();
      this.notifiedVectorCode.addElement("-1");
      this.notifiedVectorDesc.addElement("");

      for(int var4 = 0; var4 < var3.size(); ++var4) {
         StringTokenizer var1 = new StringTokenizer((String)var3.elementAt(var4), var2);
         this.notifiedVectorCode.addElement(var1.nextToken().trim());
         this.notifiedVectorDesc.addElement(var1.nextToken().trim());
      }

   }

   public boolean Columns1CheckFields() {
      return true;
   }

   public void JDPButtons1ClearLog(String var1) {
      boolean var2 = false;
      Vector var3 = new Vector();
      this.jaggSQL.getSEP();
      String var4 = "DELETE FROM JDPEvtLo WHERE JDPSystem = '" + this.user.JDPSystem + "' ";
      if (var1 != null) {
         var4 = var4 + " AND EventName = '" + var1 + "'";
      }

      this.jaggSQL.loadSettings(this.user);
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      this.jaggSQL.execSQL(var4, var3);
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message12"), 6);
      this.ResultList1.clearList();
      this.ResultList1.setFromWhereClause(this.SearchPanel1.getFromWhereClause());
      this.ResultList1.loadList();
      this.convertTimes(this.ResultList1);
      this.ResultList2.clearList();
      this.ResultList2.setFromWhereClause(this.SearchPanel1.getFromWhereClause());
      this.ResultList2.loadList();
      this.convertTimes(this.ResultList2);
   }

   public void Choice1Main() {
      if (this.Choice1 == null) {
         this.Choice1 = new JDPChoice();
      }

      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.loadSettings(this.user);
      String[] var2 = new String[]{"Job Name / Started", "Started / Job Name", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var3 = new String[]{"E", "S", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.Choice1.loadChoice(var2, var3);
   }

   public void SearchPanel1Main() {
      String[] var1 = new String[17];
      String[] var2 = new String[17];
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      var1[0] = "Job Number";
      var2[0] = "EVENTID";
      var1[1] = "Job Name";
      var2[1] = "EVENTNAME";
      var1[2] = "Source";
      var2[2] = "EVTSOURCE";
      var1[3] = "Type";
      var2[3] = "CATEGORY";
      var1[4] = "User";
      var2[4] = "USERNAME";
      var1[5] = "Computer";
      var2[5] = "COMPUTER";
      var1[6] = "Queue Date";
      var2[6] = "QUEUEDATE";
      var1[7] = "Job Queue";
      var2[7] = "JOBQUEUE";
      var1[8] = "Subsystem";
      var2[8] = "SUBSYSTEM";
      var1[9] = "Start Date";
      var2[9] = "STARTDATE";
      var1[10] = "End Date";
      var2[10] = "ENDDATE";
      var1[11] = "Notified";
      var2[11] = "NOTIFIED";
      var1[12] = "Notifed Via";
      var2[12] = "NOTIFYVIA";
      var1[13] = "Final status";
      var2[13] = "FINALSTS";
      var1[14] = "Job Log";
      var2[14] = "EVENTLOG";
      var1[15] = "Objecttype";
      var2[15] = "OBJECTTYPE";
      var1[16] = "Object";
      var2[16] = "OBJECT";
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      ((Vector)var3.elementAt(0)).addElement("Greater than");
      ((Vector)var4.elementAt(0)).addElement(">");
      ((Vector)var3.elementAt(0)).addElement("Less than");
      ((Vector)var4.elementAt(0)).addElement("<");
      ((Vector)var3.elementAt(0)).addElement("Equal to");
      ((Vector)var4.elementAt(0)).addElement("=");
      ((Vector)var3.elementAt(1)).addElement("Begins with");
      ((Vector)var4.elementAt(1)).addElement("like");
      ((Vector)var3.elementAt(1)).addElement("Contains");
      ((Vector)var4.elementAt(1)).addElement("like");
      ((Vector)var3.elementAt(2)).addElement("Begins with");
      ((Vector)var4.elementAt(2)).addElement("like");
      ((Vector)var3.elementAt(2)).addElement("Contains");
      ((Vector)var4.elementAt(2)).addElement("like");
      ((Vector)var3.elementAt(3)).addElement("Begins with");
      ((Vector)var4.elementAt(3)).addElement("like");
      ((Vector)var3.elementAt(3)).addElement("Contains");
      ((Vector)var4.elementAt(3)).addElement("like");
      ((Vector)var3.elementAt(4)).addElement("Begins with");
      ((Vector)var4.elementAt(4)).addElement("like");
      ((Vector)var3.elementAt(4)).addElement("Contains");
      ((Vector)var4.elementAt(4)).addElement("like");
      ((Vector)var3.elementAt(5)).addElement("Begins with");
      ((Vector)var4.elementAt(5)).addElement("like");
      ((Vector)var3.elementAt(5)).addElement("Contains");
      ((Vector)var4.elementAt(5)).addElement("like");
      ((Vector)var3.elementAt(6)).addElement("Equal to");
      ((Vector)var4.elementAt(6)).addElement("=");
      ((Vector)var3.elementAt(6)).addElement("Greater than");
      ((Vector)var4.elementAt(6)).addElement(">");
      ((Vector)var3.elementAt(6)).addElement("Less than");
      ((Vector)var4.elementAt(6)).addElement("<");
      this.jaggSQL.loadSettings(this.user);
      JDPLoadChoice var5 = new JDPLoadChoice(this.user, this.jaggSQL, (Object)null, "", "", "", "", -1);
      var5.loadChoice((Vector)var3.elementAt(7), "QUEUENAME", "QUEUENAME", "JDPQUEUE", "(1=1)", (Vector)var4.elementAt(7), 12);
      var5.loadChoice((Vector)var3.elementAt(8), "SUBSYSNAME", "SUBSYSNAME", "JDPSUBS", "(1=1)", (Vector)var4.elementAt(8), 12);
      ((Vector)var3.elementAt(9)).addElement("Equal to");
      ((Vector)var4.elementAt(9)).addElement("=");
      ((Vector)var3.elementAt(9)).addElement("Greater than");
      ((Vector)var4.elementAt(9)).addElement(">");
      ((Vector)var3.elementAt(9)).addElement("Less than");
      ((Vector)var4.elementAt(9)).addElement("<");
      ((Vector)var3.elementAt(10)).addElement("Equal to");
      ((Vector)var4.elementAt(10)).addElement("=");
      ((Vector)var3.elementAt(10)).addElement("Greater than");
      ((Vector)var4.elementAt(10)).addElement(">");
      ((Vector)var3.elementAt(10)).addElement("Less than");
      ((Vector)var4.elementAt(10)).addElement("<");
      var5.loadChoice((Vector)var3.elementAt(11), "USERNAME", "USERID", "JDPUSER", "(1=1)", (Vector)var4.elementAt(11), 8);
      ((Vector)var3.elementAt(12)).addElement("Email");
      ((Vector)var4.elementAt(12)).addElement("='E'");
      ((Vector)var3.elementAt(12)).addElement("Pager");
      ((Vector)var4.elementAt(12)).addElement("='P'");
      ((Vector)var3.elementAt(12)).addElement("Both");
      ((Vector)var4.elementAt(12)).addElement("='B'");
      ((Vector)var3.elementAt(13)).addElement("Complete");
      ((Vector)var4.elementAt(13)).addElement("=10");
      ((Vector)var3.elementAt(13)).addElement("Incomplete");
      ((Vector)var4.elementAt(13)).addElement("=9");
      ((Vector)var3.elementAt(14)).addElement("Begins with");
      ((Vector)var4.elementAt(14)).addElement("like");
      ((Vector)var3.elementAt(14)).addElement("Contains");
      ((Vector)var4.elementAt(14)).addElement("like");
      ((Vector)var3.elementAt(15)).addElement("Application");
      ((Vector)var4.elementAt(15)).addElement("='A'");
      ((Vector)var3.elementAt(15)).addElement("Java Class");
      ((Vector)var4.elementAt(15)).addElement("='C'");
      ((Vector)var3.elementAt(15)).addElement("Job Stream");
      ((Vector)var4.elementAt(15)).addElement("='J'");
      ((Vector)var3.elementAt(16)).addElement("Greater than");
      ((Vector)var4.elementAt(16)).addElement(">");
      ((Vector)var3.elementAt(16)).addElement("Less than");
      ((Vector)var4.elementAt(16)).addElement("<");
      ((Vector)var3.elementAt(16)).addElement("Equal to");
      ((Vector)var4.elementAt(16)).addElement("=");
      int[] var6 = new int[17];
      boolean[] var7 = new boolean[17];
      var6[0] = 17;
      var7[0] = false;
      var6[1] = 22;
      var7[1] = true;
      var6[2] = 22;
      var7[2] = true;
      var6[3] = 22;
      var7[3] = true;
      var6[4] = 22;
      var7[4] = true;
      var6[5] = 22;
      var7[5] = true;
      var6[6] = 12;
      var7[6] = true;
      var6[7] = 0;
      var7[7] = true;
      var6[8] = 0;
      var7[8] = true;
      var6[9] = 12;
      var7[9] = true;
      var6[10] = 12;
      var7[10] = true;
      var6[11] = 0;
      var7[11] = false;
      var6[12] = 0;
      var7[12] = true;
      var6[13] = 0;
      var7[13] = true;
      var6[14] = 42;
      var7[14] = true;
      var6[15] = 3;
      var7[15] = true;
      var6[16] = 102;
      var7[16] = true;
      this.SearchPanel1 = new JDPWhereClause(this.user, super.targetPanel, "", true, "", var1, var2, var3, var4, (String[][])null, (String[][])null, var6, var7, "FROM JDPEVTLO WHERE (1=1)");
      this.SearchPanel1.setDSNType(this.user.u.getDataSourceType(this.jaggSQL));
      this.SearchPanel1.setDataType(0, 8);
      this.SearchPanel1.setDataType(1, 12);
      this.SearchPanel1.setDataType(2, 12);
      this.SearchPanel1.setDataType(3, 12);
      this.SearchPanel1.setDataType(4, 12);
      this.SearchPanel1.setDataType(5, 12);
      this.SearchPanel1.setDataType(6, 9);
      this.SearchPanel1.setDataType(7, 12);
      this.SearchPanel1.setDataType(8, 12);
      this.SearchPanel1.setDataType(9, 9);
      this.SearchPanel1.setDataType(10, 9);
      this.SearchPanel1.setDataType(11, 8);
      this.SearchPanel1.setDataType(12, 12);
      this.SearchPanel1.setDataType(13, 8);
      this.SearchPanel1.setDataType(14, -1);
      this.SearchPanel1.setDataType(15, 12);
      this.SearchPanel1.setDataType(16, 12);
   }

   public void ResultList1Main() {
      String var1 = "EVENTID";
      String[] var2 = new String[]{"STARTDATE DESC", "STARTTIME DESC"};
      String var3 = "JDPSYSTEM = '" + this.user.JDPSystem + "'";
      String[] var4 = new String[]{"Job Name"};
      String[] var5 = new String[]{"EVENTNAME"};
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.loadSettings(this.user);
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, var6, false, var1, var2, var3, var4, var5, var5, "", false, "Total Entries:");
      int[] var7 = new int[26];
      var7[0] = 4;
      var7[1] = 1;
      var7[2] = 37;
      var7[3] = 37;
      this.ResultList1.setMinWidth(160);
      this.ResultList1.setIcons(var7);
      this.ResultList1.setFromWhereClause(" FROM JDPEVTLO WHERE JDPSYSTEM = '" + this.user.JDPSystem + "'");
      this.ResultList1.clearList("Job Name / Started");
   }

   public void ResultList2Main() {
      String var1 = "EVENTID";
      String[] var2 = new String[]{"EVENTNAME", "STARTTIME DESC"};
      String var3 = "JDPSYSTEM = '" + this.user.JDPSystem + "'";
      String[] var4 = new String[]{"Startdate"};
      String[] var5 = new String[]{"STARTDATE DESC"};
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.loadSettings(this.user);
      this.ResultList2 = new JDPSearchResults(this.user, super.targetPanel, true, var6, false, var1, var2, var3, var4, var5, var5, "", false, "Total Entries:");
      int[] var7 = new int[26];
      var7[0] = 4;
      var7[1] = 37;
      var7[2] = 1;
      var7[3] = 37;
      this.ResultList2.setMinWidth(160);
      this.ResultList2.setIcons(var7);
      this.ResultList2.setFromWhereClause(" FROM JDPEVTLO WHERE JDPSYSTEM = '" + this.user.JDPSystem + "'");
      this.ResultList2.clearList("Started / Job Name");
   }
}
