import java.awt.Color;
import java.awt.TextComponent;
import java.awt.TextField;
import java.util.Vector;

public class JDPLayoutGenerator {
   JDPUser user;
   String layoutName;
   String outputFile;
   String[] stoken;
   String dataSource;
   String connectString;
   JDPSelectDSN targetDSN;
   JDPSelectTable targetTable;
   JDPSelectColumns targetColumns;
   JDPSearchLayout targetSearch;
   JDPListLayout targetList;
   JDPScreenLayout targetScreen;
   JDPScreenSettings targetSettings;
   JDPGridSettings targetGridSettings;
   JDPSelectReportDef targetReportDef;
   JDPGridLayout targetGrid;
   JDPSelectChartDef targetChartDef;
   JDPChartLayout targetChart;
   JDPChoiceLayout targetChoice;
   String[] fields;
   String[] fieldSql;
   String[] updatefields;
   String[] insertfields;
   int[] updateindexes;
   int[] dataType;
   int[] gridDataType;
   boolean[] gridIsIdentity;
   int[] indexes;
   int[] indexes2;
   int[] iindexes;
   String[] keys;
   int[] keyDataType;
   boolean[] keyIsIdentity;
   String[] keysSQL;
   String[] keyType;
   String[] keysUpdate;
   int[] keyDataTypeUpdate;
   boolean[] keyIsIdentityUpdate;
   String[] keysSQLUpdate;
   String[] keyTypeUpdate;
   String iconsText;
   String[] buttons;
   String[] buttonsText;
   int totalItems;
   String outputText;
   boolean finishedBuild;
   int totalLines;
   int maxWriteChars = 900;
   int lineIndex;
   StringBuffer str;
   String selectedFields;

   String switchField(String var1) {
      String var2 = var1;
      if (var1.indexOf(".") > 0) {
         for(int var3 = 0; var3 < this.targetTable.joinConditions.countItems(); ++var3) {
            String var4 = this.targetTable.joinConditions.getItem(var3);
            int var5 = var4.indexOf(var1);
            if (var5 >= 0) {
               int var6 = var4.indexOf(".");
               if (var6 == var5 + 1) {
                  var6 = var4.substring(var5 + 2).indexOf(".") + var5 + 2;
                  var1 = var4.substring(var6 - 1);
               } else {
                  int var7 = var4.indexOf(" ");
                  var1 = var4.substring(0, var7);
               }
               break;
            }
         }
      }

      int var8 = this.targetColumns.columns.getItem(var1);
      if (var8 < 0 || !this.targetColumns.columns.isSelected(var8)) {
         var1 = var2;
      }

      return var1;
   }

   boolean readyToBuild3() {
      if (this.targetColumns != null && this.targetColumns.keys.getSelectedIndexes().length >= 1) {
         if (this.targetSearch != null && this.targetList == null) {
            this.user.mainmsg.setStatusMsg("You must configure a Result List if you have configured a Search Panel.", 8);
            return false;
         } else if (this.targetScreen != null && this.targetScreen.lastLine >= 0) {
            for(int var1 = 0; var1 <= this.targetScreen.columns.countItems(); ++var1) {
               this.targetScreen.columns.deselect(var1);
            }

            for(int var10 = 0; var10 <= this.targetScreen.lastLine; ++var10) {
               for(int var2 = 0; var2 < this.targetScreen.maxcolumns; ++var2) {
                  try {
                     int var3 = this.targetScreen.screenOrder[var10][var2];
                     if (var3 >= 0) {
                        this.targetScreen.columns.select(var3);
                     }
                  } catch (Exception var9) {
                  }
               }
            }

            this.fields = this.targetScreen.columns.getSelectedItems();
            this.dataType = new int[this.fields.length];
            String[] var11 = this.targetColumns.columns.getSelectedItems();
            int[] var12 = this.targetColumns.columns.getSelectedIndexes();

            for(int var13 = 0; var13 < this.fields.length; ++var13) {
               for(int var4 = 0; var4 < var11.length; ++var4) {
                  if (this.fields[var13].equals(var11[var4])) {
                     this.dataType[var13] = this.targetColumns.columnDatatype[var12[var4]];
                     break;
                  }
               }

               this.fields[var13] = this.user.u.strip(this.fields[var13]);
            }

            this.indexes = this.targetScreen.columns.getSelectedIndexes();
            this.indexes2 = new int[this.targetGridSettings.columns.countItems()];

            for(int var14 = 0; var14 < this.indexes2.length; ++var14) {
               this.indexes2[var14] = -1;
            }

            int var15 = 0;
            int var16 = 0;

            for(int var5 = 0; var5 < this.indexes2.length; ++var5) {
               if (!this.targetGridSettings.fieldActive[var5]) {
                  ++var16;
               } else {
                  for(int var6 = 0; var6 < this.targetGrid.tableContents.columnOrder.length; ++var6) {
                     if (this.targetGrid.tableContents.columnOrder[var6] == var15) {
                        this.indexes2[var6] = var15 + var16;
                     }
                  }

                  ++var15;
               }
            }

            String[] var17 = new String[var15];
            this.fieldSql = new String[var15];
            this.gridDataType = new int[var15];
            this.gridIsIdentity = new boolean[var15];
            int var18 = 0;

            for(int var7 = 0; var7 < this.indexes2.length; ++var7) {
               if (this.indexes2[var7] >= 0) {
                  var17[var18] = this.targetGridSettings.columns.getItem(this.indexes2[var7]);
                  this.fieldSql[var18] = this.targetGridSettings.fieldSql[this.indexes2[var7]];
                  this.gridDataType[var18] = this.targetColumns.columnDatatype[this.targetGridSettings.columnIndexes[this.indexes2[var7]]];
                  this.gridIsIdentity[var18] = this.targetColumns.columnIsIdentity[this.targetGridSettings.columnIndexes[this.indexes2[var7]]];
                  ++var18;
               }
            }

            int var20 = 0;
            if (var17[0].indexOf(".") > 0) {
               for(int var8 = 0; var8 < var17.length; ++var8) {
                  if (var17[var8] != null && var17[var8].indexOf("a.") >= 0) {
                     ++var20;
                  }
               }
            } else {
               var20 = var17.length;
            }

            this.updatefields = new String[var20];
            this.updateindexes = new int[var20];
            var18 = 0;

            for(int var21 = 0; var21 < var17.length; ++var21) {
               if (var17[var21] != null && (var17[var21].indexOf(".") < 0 || var17[var21].indexOf("a.") >= 0)) {
                  if (var17[var21].indexOf(".") > 0) {
                     this.updatefields[var18] = var17[var21].substring(2);
                  } else {
                     this.updatefields[var18] = var17[var21];
                  }

                  this.updateindexes[var18] = var21;
                  ++var18;
               }

               if (var17[var21] != null) {
                  var17[var21] = this.user.u.strip(var17[var21]);
               }
            }

            this.setKeyFields();
            if (this.layoutName.equals("JDPLayout23")) {
               for(int var22 = 0; var22 < this.fields.length; ++var22) {
                  if (this.indexes[var22] < this.targetSettings.actualCompName.length) {
                     this.fields[var22] = this.user.u.strip(this.targetSettings.actualCompName[this.indexes[var22]]);
                  }
               }
            }

            return true;
         } else {
            this.user.mainmsg.setStatusMsg("You have not selected any columns to be displayed.", 8);
            return false;
         }
      } else {
         this.user.mainmsg.setStatusMsg("You must specify a unique key for the selected table.", 8);
         return false;
      }
   }

   String getQuote(int var1) {
      if (JDPUtils.isOdbcDate(var1) && this.targetDSN.dsnType.indexOf(JDPJagg.FOXPRO) >= 0) {
         return "#";
      } else {
         return !JDPUtils.isOdbcChar(var1) && !JDPUtils.isOdbcDate(var1) ? "" : "'";
      }
   }

   boolean buildJava() {
      int var1 = 1;
      int var2 = 0;
      int var3 = 0;
      String var4 = "";
      String var5;
      if (this.outputFile.startsWith("Prelim")) {
         var5 = this.user.JDesignerPro.JDPDirectory + "Temp" + JDesignerPro.serverSeparator + this.outputFile.trim() + ".java";
      } else {
         var5 = this.user.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator + "Wizard" + JDesignerPro.serverSeparator + this.outputFile.trim() + ".java";
      }

      this.outputText = "";
      int var6 = 0;
      int var7 = 0;
      int var8 = 0;
      boolean var9 = false;
      String var10 = "w+";
      this.iconsText = "";
      this.buttons = new String[20];
      this.buttonsText = new String[20];
      this.user.mainmsg.setStatusMsg("Loading source template file...", 0);
      String var11 = this.user.u.readFromFile(this.user.JDesignerPro.JDPDirectory + "Applications/Layouts/" + this.layoutName.trim() + ".java");
      int var12 = var11.length();
      char[] var13 = new char[var12 * 10];
      this.user.mainmsg.setStatusMsg("Loading source template file...", 0);

      try {
         for(int var20 = var11.indexOf("\n", var8); var20 >= 0; var20 = var11.indexOf("\n", var8)) {
            var4 = var11.substring(var8, var20 + 1);
            if (var2 != var3) {
               this.user.mainmsg.setStatusMsg("Source generation " + Integer.toString(var2) + "% complete...", 0);
            }

            var3 = var2;
            var4 = this.parseLine(var4);
            var2 = var1++ * 100 / this.totalLines;
            if (var2 > 100) {
               var2 = 100;
            }

            if (var4 != null) {
               var7 = var4.length();
               var4.getChars(0, var7, var13, var6);
               var6 += var7;
            }

            var8 = var20 + 1;
         }

         this.outputText = new String(var13, 0, var6);
         Object var21 = null;
         this.finishedBuild = true;
         this.user.mainmsg.setStatusMsg("Source generation 100% complete... writing...", 0);
         if (!this.user.u.writeToFile(var5, this.outputText, var10)) {
            System.out.println("failed");
            return false;
         }

         this.user.mainmsg.setStatusMsg("New Java source created.", 5);
      } catch (Exception var16) {
         this.user.mainmsg.setStatusMsg("Parsing Error occurred. Please send Java console output to BulletProof.", 30);
         System.out.println("Parsing error at parse index: " + Integer.toString(this.lineIndex));
         System.out.println("Line being parsed is: ");
         if (var4 != null) {
            System.out.println(var4);
         }

         System.out.println("Line output so far is: ");
         if (this.str != null) {
            System.out.println(this.str);
         }

         ((Throwable)var16).printStackTrace();
         return false;
      }

      this.user.JDesignerPro.gc();
      return true;
   }

   void setHandle(JDPClassLayout var1) {
      if (var1 instanceof JDPSelectDSN) {
         this.targetDSN = (JDPSelectDSN)var1;
      }

      if (var1 instanceof JDPSelectTable) {
         this.targetTable = (JDPSelectTable)var1;
      }

      if (var1 instanceof JDPSelectColumns) {
         this.targetColumns = (JDPSelectColumns)var1;
      }

      if (var1 instanceof JDPSearchLayout) {
         this.targetSearch = (JDPSearchLayout)var1;
      }

      if (var1 instanceof JDPListLayout) {
         this.targetList = (JDPListLayout)var1;
      }

      if (var1 instanceof JDPScreenLayout) {
         this.targetScreen = (JDPScreenLayout)var1;
      }

      if (var1 instanceof JDPScreenSettings) {
         this.targetSettings = (JDPScreenSettings)var1;
      }

      if (var1 instanceof JDPGridSettings) {
         this.targetGridSettings = (JDPGridSettings)var1;
      }

      if (var1 instanceof JDPSelectReportDef) {
         this.targetReportDef = (JDPSelectReportDef)var1;
      }

      if (var1 instanceof JDPSelectChartDef) {
         this.targetChartDef = (JDPSelectChartDef)var1;
      }

      if (var1 instanceof JDPChartLayout) {
         this.targetChart = (JDPChartLayout)var1;
      }

      if (var1 instanceof JDPGridLayout) {
         this.targetGrid = (JDPGridLayout)var1;
      }

      if (var1 instanceof JDPChoiceLayout) {
         this.targetChoice = (JDPChoiceLayout)var1;
      }

   }

   boolean readyToBuild4() {
      this.indexes2 = new int[this.targetGridSettings.columns.countItems()];

      for(int var1 = 0; var1 < this.indexes2.length; ++var1) {
         this.indexes2[var1] = -1;
      }

      int var6 = 0;
      int var2 = 0;

      for(int var3 = 0; var3 < this.indexes2.length; ++var3) {
         if (!this.targetGridSettings.fieldActive[var3]) {
            ++var2;
         } else {
            for(int var4 = 0; var4 < this.targetGrid.tableContents.columnOrder.length; ++var4) {
               if (this.targetGrid.tableContents.columnOrder[var4] == var6) {
                  this.indexes2[var4] = var6 + var2;
               }
            }

            ++var6;
         }
      }

      this.fields = new String[var6];
      this.fieldSql = new String[var6];
      this.gridDataType = new int[var6];
      this.gridIsIdentity = new boolean[var6];
      int var7 = 0;

      for(int var8 = 0; var8 < this.indexes2.length; ++var8) {
         if (this.indexes2[var8] >= 0) {
            this.fields[var7] = this.targetGridSettings.columns.getItem(this.indexes2[var8]);
            this.fieldSql[var7] = this.targetGridSettings.fieldSql[this.indexes2[var8]];
            this.gridDataType[var7] = this.targetColumns.columnDatatype[this.targetGridSettings.columnIndexes[this.indexes2[var8]]];
            this.gridIsIdentity[var7] = this.targetColumns.columnIsIdentity[this.targetGridSettings.columnIndexes[this.indexes2[var8]]];
            ++var7;
         }
      }

      int var9 = 0;
      if (this.fields[0].indexOf(".") > 0) {
         for(int var5 = 0; var5 < this.fields.length; ++var5) {
            if (this.fields[var5] != null && this.fields[var5].indexOf("a.") >= 0) {
               ++var9;
            }
         }
      } else {
         var9 = this.fields.length;
      }

      for(int var11 = 0; var11 < this.fields.length; ++var11) {
         this.fields[var11] = this.user.u.strip(this.fields[var11]);
      }

      this.setKeyFields();
      return true;
   }

   void setLayoutName(String var1) {
      this.layoutName = var1;
   }

   String cvtKey(String var1, int var2) {
      return JDPUtils.sqlConvert(var1, var2, this.targetDSN.dsnType);
   }

   void getInsertFields() {
      this.iindexes = this.targetColumns.columns.getSelectedIndexes();
      String[] var1 = this.targetColumns.columns.getSelectedItems();
      int var2 = var1.length;
      if (var2 > 0) {
         if (var1[0].indexOf(".") > 0) {
            var2 = 0;

            for(int var3 = 0; var3 < var1.length && var1[var3].indexOf("a.") >= 0; ++var3) {
               var1[var3] = var1[var3].substring(2);
               ++var2;
            }
         }

         this.insertfields = new String[var2];
         System.arraycopy(var1, 0, this.insertfields, 0, var2);
      }
   }

   boolean readyToBuild2() {
      if (this.targetColumns != null && this.targetColumns.keys.getSelectedIndexes().length >= 1) {
         this.indexes2 = new int[this.targetGridSettings.columns.countItems()];

         for(int var1 = 0; var1 < this.indexes2.length; ++var1) {
            this.indexes2[var1] = -1;
         }

         int var6 = 0;
         int var2 = 0;

         for(int var3 = 0; var3 < this.indexes2.length; ++var3) {
            if (!this.targetGridSettings.fieldActive[var3]) {
               ++var2;
            } else {
               for(int var4 = 0; var4 < this.targetGrid.tableContents.columnOrder.length; ++var4) {
                  if (this.targetGrid.tableContents.columnOrder[var4] == var6) {
                     this.indexes2[var4] = var6 + var2;
                  }
               }

               ++var6;
            }
         }

         this.fields = new String[var6];
         this.fieldSql = new String[var6];
         this.gridDataType = new int[var6];
         this.gridIsIdentity = new boolean[var6];
         int var7 = 0;

         for(int var9 = 0; var9 < this.indexes2.length; ++var9) {
            if (this.indexes2[var9] >= 0) {
               this.fields[var7] = this.targetGridSettings.columns.getItem(this.indexes2[var9]);
               this.fieldSql[var7] = this.targetGridSettings.fieldSql[this.indexes2[var9]];
               this.gridDataType[var7] = this.targetColumns.columnDatatype[this.targetGridSettings.columnIndexes[this.indexes2[var9]]];
               this.gridIsIdentity[var7] = this.targetColumns.columnIsIdentity[this.targetGridSettings.columnIndexes[this.indexes2[var9]]];
               ++var7;
            }
         }

         int var10 = 0;
         if (this.fields[0].indexOf(".") > 0) {
            for(int var5 = 0; var5 < this.fields.length; ++var5) {
               if (this.fields[var5].indexOf("a.") >= 0) {
                  ++var10;
               }
            }
         } else {
            var10 = this.fields.length;
         }

         this.updatefields = new String[var10];
         this.updateindexes = new int[var10];
         var7 = 0;

         for(int var11 = 0; var11 < this.fields.length; ++var11) {
            if (this.fields[var11].indexOf(".") < 0 || this.fields[var11].indexOf("a.") >= 0) {
               if (this.fields[var11].indexOf(".") > 0) {
                  this.updatefields[var7] = this.fields[var11].substring(2);
               } else {
                  this.updatefields[var7] = this.fields[var11];
               }

               this.updateindexes[var7] = var11;
               ++var7;
            }

            this.fields[var11] = this.user.u.strip(this.fields[var11]);
         }

         this.setKeyFields();
         return true;
      } else {
         this.user.mainmsg.setStatusMsg("You must specify a unique key for the selected table.", 8);
         return false;
      }
   }

   JDPLayoutGenerator(JDPUser var1, String var2, String var3) {
      this.user = var1;
      this.layoutName = var2;
      this.outputFile = var3;
      this.stoken = new String[10];
      this.retrieveVectors();
      this.str = new StringBuffer(5000);
      if (JDPJagg.useJaggServer) {
         this.maxWriteChars = 100000;
      }

   }

   boolean readyToBuild() {
      if (!this.layoutName.equals("JDPLayout16") && !this.layoutName.equals("JDPLayout17") && !this.layoutName.equals("JDPLayout18")) {
         if (this.targetColumns != null && this.targetColumns.tableName != null && this.targetColumns.tableName[0] != null) {
            if (!this.layoutName.equals("JDPLayout1") && !this.layoutName.equals("JDPLayout11") && !this.layoutName.equals("JDPLayout21")) {
               if (!this.layoutName.equals("JDPLayout2") && !this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22")) {
                  if (!this.layoutName.equals("JDPLayout3") && !this.layoutName.equals("JDPLayout23")) {
                     if (!this.layoutName.equals("JDPLayout4") && !this.layoutName.equals("JDPLayout14") && !this.layoutName.equals("JDPLayout24")) {
                        if (!this.layoutName.equals("JDPLayout5") && !this.layoutName.equals("JDPLayout15") && !this.layoutName.equals("JDPLayout25")) {
                           return false;
                        } else {
                           this.getInsertFields();
                           return this.readyToBuild5();
                        }
                     } else {
                        this.getInsertFields();
                        return this.readyToBuild4();
                     }
                  } else {
                     this.getInsertFields();
                     return this.readyToBuild3();
                  }
               } else {
                  this.getInsertFields();
                  return this.readyToBuild2();
               }
            } else {
               this.getInsertFields();
               return this.readyToBuild1();
            }
         } else {
            return false;
         }
      } else {
         return this.targetChoice != null && this.targetChoice.textchoicesql.getText() != null;
      }
   }

   synchronized String parseSource(String var1) {
      String var2 = "";
      String var3 = "";
      int var4 = var1.length();
      int var5 = 0;
      boolean var6 = false;
      char[] var7 = new char[var4 * 10];
      int var8 = 0;
      int var9 = 0;
      this.user.mainmsg.setStatusMsg("Creating source...", 0);

      try {
         for(int var16 = var1.indexOf("\n", var5); var16 >= 0; var16 = var1.indexOf("\n", var5)) {
            var3 = var1.substring(var5, var16 + 1);
            var3 = this.parseLine(var3);
            var9 = var3.length();
            var3.getChars(0, var9, var7, var8);
            var8 += var9;
            var5 = var16 + 1;
         }

         var2 = new String(var7, 0, var8);
         Object var17 = null;
      } catch (Exception var12) {
         this.user.mainmsg.setStatusMsg("Parsing Error occurred. Please send Java console output to BulletProof.", 30);
         System.out.println("Parsing error at parse index: " + Integer.toString(this.lineIndex));
         System.out.println("Line being parsed is: ");
         if (var3 != null) {
            System.out.println(var3);
         }

         System.out.println("Line output so far is: ");
         if (this.str != null) {
            System.out.println(this.str);
         }

         ((Throwable)var12).printStackTrace();
         return "";
      }

      this.user.JDesignerPro.gc();
      this.user.mainmsg.clearStatusMsg();
      return var2;
   }

   boolean readyToBuild1() {
      if (this.targetColumns != null && this.targetColumns.keys.getSelectedIndexes().length >= 1) {
         if (this.targetSearch != null && this.targetList == null) {
            this.user.mainmsg.setStatusMsg("You must configure a Result List if you have configured a Search Panel.", 8);
            return false;
         } else if (this.targetScreen != null && this.targetScreen.lastLine >= 0) {
            for(int var1 = 0; var1 < this.targetScreen.columns.countItems(); ++var1) {
               this.targetScreen.columns.deselect(var1);
            }

            for(int var8 = 0; var8 <= this.targetScreen.lastLine; ++var8) {
               for(int var2 = 0; var2 < this.targetScreen.maxcolumns; ++var2) {
                  try {
                     int var3 = this.targetScreen.screenOrder[var8][var2];
                     if (var3 >= 0) {
                        this.targetScreen.columns.select(var3);
                     }
                  } catch (Exception var7) {
                  }
               }
            }

            this.fields = this.targetScreen.columns.getSelectedItems();
            this.indexes = this.targetScreen.columns.getSelectedIndexes();
            int var9 = 0;
            if (this.fields[0].indexOf(".") > 0) {
               for(int var10 = 0; var10 < this.fields.length && this.fields[var10].indexOf("a.") >= 0; ++var10) {
                  ++var9;
               }
            } else {
               var9 = this.fields.length;
            }

            this.updatefields = new String[var9];
            this.updateindexes = new int[var9];
            int var11 = 0;
            this.dataType = new int[this.fields.length];
            String[] var12 = this.targetColumns.columns.getSelectedItems();
            int[] var4 = this.targetColumns.columns.getSelectedIndexes();

            for(int var5 = 0; var5 < this.fields.length; ++var5) {
               for(int var6 = 0; var6 < var12.length; ++var6) {
                  if (this.fields[var5].equals(var12[var6])) {
                     this.dataType[var5] = this.targetColumns.columnDatatype[var4[var6]];
                     break;
                  }
               }

               if (var5 < var9) {
                  if (this.fields[var5].indexOf(".") > 0) {
                     this.updatefields[var5] = this.fields[var5].substring(2);
                  } else {
                     this.updatefields[var5] = this.fields[var5];
                  }

                  this.updateindexes[var11] = var5;
                  ++var11;
               }

               this.fields[var5] = this.user.u.strip(this.fields[var5]);
            }

            this.setKeyFields();
            if (this.layoutName.equals("JDPLayout11") || this.layoutName.equals("JDPLayout21")) {
               for(int var13 = 0; var13 < this.fields.length; ++var13) {
                  if (this.indexes[var13] < this.targetSettings.actualCompName.length) {
                     this.fields[var13] = this.user.u.strip(this.targetSettings.actualCompName[this.indexes[var13]]);
                  }
               }
            }

            return true;
         } else {
            this.user.mainmsg.setStatusMsg("You have not selected any columns to be displayed.", 8);
            return false;
         }
      } else {
         this.user.mainmsg.setStatusMsg("You must specify a unique key for the selected table.", 8);
         return false;
      }
   }

   void setKeyFields() {
      int[] var1 = this.targetColumns.getKeyIndexes(this.targetColumns.keys);
      this.keyDataType = new int[var1.length];
      this.keyIsIdentity = new boolean[var1.length];
      this.keys = this.targetColumns.keys.getSelectedItems();
      this.keysSQL = this.targetColumns.keys.getSelectedItems();
      this.keyType = new String[var1.length];

      for(int var2 = 0; var2 < this.keys.length; ++var2) {
         this.keyDataType[var2] = this.targetColumns.columnDatatype[var1[var2]];
         this.keyIsIdentity[var2] = this.targetColumns.columnIsIdentity[var1[var2]];
         if (this.targetGridSettings != null) {
            for(int var6 = 0; var6 < this.targetGridSettings.columns.countItems(); ++var6) {
               if (this.keys[var2].indexOf(".") > 0) {
                  this.keys[var2] = this.keys[var2].substring(2);
               }

               if (this.keys[var2].equals(this.targetGridSettings.columns.getItem(var6))) {
                  this.keysSQL[var2] = this.targetGridSettings.fieldSql[var6];
                  this.keyType[var2] = this.targetGridSettings.fieldType[var6];
               }
            }
         } else if (this.targetSettings != null) {
            for(int var3 = 0; var3 < this.targetSettings.columns.countItems(); ++var3) {
               if (this.keys[var2].indexOf(".") > 0) {
                  this.keys[var2] = this.keys[var2].substring(2);
               }

               if (this.keys[var2].equals(this.targetSettings.columns.getItem(var3))) {
                  this.keysSQL[var2] = this.targetSettings.fieldSql[var3];
                  this.keyType[var2] = this.targetSettings.fieldType[var3];
               }
            }
         }
      }

      int[] var5 = this.targetColumns.getKeyIndexes(this.targetColumns.keysUpdate);
      this.keyDataTypeUpdate = new int[var5.length];
      this.keyIsIdentityUpdate = new boolean[var5.length];
      this.keysUpdate = this.targetColumns.keysUpdate.getSelectedItems();
      this.keysSQLUpdate = this.targetColumns.keysUpdate.getSelectedItems();
      this.keyTypeUpdate = new String[var5.length];

      for(int var7 = 0; var7 < this.keysUpdate.length; ++var7) {
         this.keyDataTypeUpdate[var7] = this.targetColumns.columnDatatype[var5[var7]];
         this.keyIsIdentityUpdate[var7] = this.targetColumns.columnIsIdentity[var5[var7]];
         if (this.targetGridSettings != null) {
            for(int var8 = 0; var8 < this.targetGridSettings.columns.countItems(); ++var8) {
               if (this.keysUpdate[var7].indexOf(".") > 0) {
                  this.keysUpdate[var7] = this.keysUpdate[var7].substring(2);
               }

               if (this.keysUpdate[var7].equals(this.targetGridSettings.columns.getItem(var8))) {
                  this.keysSQLUpdate[var7] = this.targetGridSettings.fieldSql[var8];
                  this.keyTypeUpdate[var7] = this.targetGridSettings.fieldType[var8];
               }
            }
         } else if (this.targetSettings != null) {
            for(int var4 = 0; var4 < this.targetSettings.columns.countItems(); ++var4) {
               if (this.keysUpdate[var7].indexOf(".") > 0) {
                  this.keysUpdate[var7] = this.keysUpdate[var7].substring(2);
               }

               if (this.keysUpdate[var7].equals(this.targetSettings.columns.getItem(var4))) {
                  this.keysSQLUpdate[var7] = this.targetSettings.fieldSql[var4];
                  this.keyTypeUpdate[var7] = this.targetSettings.fieldType[var4];
               }
            }
         }
      }

   }

   synchronized String parseLine(String var1) throws Exception {
      if (var1.length() < 3) {
         return var1;
      } else if (!var1.startsWith(">")) {
         return var1;
      } else if (var1.substring(1, 4).equals("XXX")) {
         this.totalLines = Integer.parseInt(var1.substring(4, 8)) + 1;
         return null;
      } else {
         this.lineIndex = Integer.parseInt(var1.substring(1, 4));
         var1 = var1.substring(4);
         int var4 = var1.indexOf("<");
         int var5 = 0;
         int var6 = 0;

         while(var4 >= 0) {
            this.stoken[var6++] = var1.substring(var5, var4);
            var4 = var1.indexOf(">", var4);
            if (var4 >= 0) {
               var5 = var4 + 1;
               var4 = var1.indexOf("<", var5);
            }
         }

         this.stoken[var6] = var1.substring(var5);
         this.str.setLength(0);
         if (this.lineIndex >= 100) {
            this.parseLine100(var1, this.stoken, this.lineIndex);
            return this.str.toString();
         } else {
            switch (this.lineIndex) {
               case 1:
               case 2:
               case 3:
               case 30:
               case 54:
                  break;
               case 4:
               case 12:
               case 43:
               case 44:
                  int var45 = -1;
                  boolean var54 = true;
                  if (this.lineIndex == 4) {
                     String var58 = this.targetSettings.lockingColumn.getSelectedItem();
                     if (var58 != null && !var58.equals("")) {
                        this.str.append(this.stoken[0] + "String " + this.user.u.strip(var58) + "Lock" + this.stoken[1]);
                     }
                  }

                  for(int var59 = 0; var59 <= this.targetScreen.lastLine; ++var59) {
                     for(int var62 = 0; var62 < this.targetScreen.maxcolumns; ++var62) {
                        try {
                           int var69 = this.targetScreen.screenOrder[var59][var62];
                           if (var69 >= 0 && var69 != this.targetScreen.screenOrder[var59][var62 + 1]) {
                              String var91 = this.targetColumns.columnLength[this.targetSettings.columnIndexes[var69]].trim();
                              if ((var59 > 0 || var62 > 0) && this.str.length() > 0 && this.str.charAt(this.str.length() - 1) != '\n') {
                                 this.str.append("\r");
                              }

                              switch (this.lineIndex) {
                                 case 4:
                                    if (this.targetSettings.fieldType[var69].equals("RadioButtons")) {
                                       for(int var104 = 0; var104 < JDPChoiceLayout.maxChoices; ++var104) {
                                          if (this.targetSettings.thisChoicePanel.textChoiceValue[var69][var104].trim().length() > 0) {
                                             this.str.append(this.stoken[0] + "Checkbox");
                                             this.str.append(" " + this.user.u.strip(this.targetScreen.columns.getItem(var69)));
                                             if (var104 > 0) {
                                                this.str.append(Integer.toString(var104));
                                             }

                                             this.str.append(this.stoken[1]);
                                          }
                                       }
                                    } else {
                                       this.str.append(this.stoken[0] + this.targetSettings.fieldType[var69]);
                                       this.str.append(" " + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + this.stoken[1]);
                                    }

                                    if (this.targetSettings.fieldType[var69].equals("JDPChoice")) {
                                       this.str.append(this.stoken[0] + "Vector value" + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + this.stoken[1]);
                                    }
                                    break;
                                 case 12:
                                    String var103 = this.user.u.strip(this.targetScreen.columns.getItem(var69));
                                    if (this.targetSettings.fieldType[var69].equals("TextField")) {
                                       this.str.append(this.stoken[0] + var103 + this.stoken[1]);
                                       this.str.append(this.targetSettings.fieldType[var69]);
                                       this.str.append("(\"\"," + var91 + ")");
                                       this.str.append(this.stoken[2]);
                                    } else if (this.targetSettings.fieldType[var69].equals("TextArea")) {
                                       this.str.append(this.stoken[0] + var103 + this.stoken[1]);
                                       this.str.append(this.targetSettings.fieldType[var69]);
                                       this.str.append("(\"\"," + this.targetSettings.textAreaRows[var69] + "," + var91 + ")");
                                       this.str.append(this.stoken[2]);
                                    } else if (!this.targetSettings.fieldType[var69].equals("JDPComboBox") && !this.targetSettings.fieldType[var69].equals("JDPSpinner") && !this.targetSettings.fieldType[var69].equals("JDPDate")) {
                                       if (this.targetSettings.fieldType[var69].equals("Checkbox")) {
                                          this.str.append(this.stoken[0] + var103 + this.stoken[1]);
                                          this.str.append(this.targetSettings.fieldType[var69]);
                                          this.str.append("(\"" + this.targetSettings.checkboxLabel[var69] + "\")");
                                          this.str.append(this.stoken[2]);
                                       } else if (this.targetSettings.fieldType[var69].equals("RadioButtons")) {
                                          this.str.append(this.stoken[0] + "CheckboxGroup " + var103 + "Cbg" + this.stoken[1]);
                                          this.str.append("CheckboxGroup()");
                                          this.str.append(this.stoken[2]);

                                          for(int var117 = 0; var117 < JDPChoiceLayout.maxChoices; ++var117) {
                                             if (this.targetSettings.thisChoicePanel.textChoiceValue[var69][var117].trim().length() > 0) {
                                                this.str.append(this.stoken[0] + var103);
                                                if (var117 > 0) {
                                                   this.str.append(Integer.toString(var117));
                                                }

                                                this.str.append(this.stoken[1]);
                                                this.str.append("Checkbox");
                                                this.str.append("(\"" + this.targetSettings.thisChoicePanel.textChoiceValue[var69][var117].trim() + "\"," + var103 + "Cbg,false)");
                                                this.str.append(this.stoken[2]);
                                             }
                                          }
                                       } else {
                                          this.str.append(this.stoken[0] + var103 + this.stoken[1]);
                                          this.str.append(this.targetSettings.fieldType[var69]);
                                          this.str.append("()");
                                          this.str.append(this.stoken[2]);
                                       }
                                    } else {
                                       this.str.append(this.stoken[0] + var103 + this.stoken[1]);
                                       this.str.append(this.targetSettings.fieldType[var69]);
                                       this.str.append("(user,\"\"," + var91 + ")");
                                       this.str.append(this.stoken[2]);
                                    }
                                    break;
                                 case 43:
                                    if ((this.targetSettings.fieldType[var69].equals("JDPChoice") || this.targetSettings.fieldType[var69].equals("JDPComboBox")) && this.targetSettings.thisChoicePanel.valuesFrom[var69].equals("Fields entered here")) {
                                       if (this.targetSettings.fieldType[var69].equals("JDPChoice")) {
                                          this.str.append("\r\n\t\tvalue" + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + " = new Vector(); \r\n");
                                       }

                                       int var116 = 0;

                                       for(int var126 = 0; var126 < JDPChoiceLayout.maxChoices; ++var126) {
                                          if (this.targetSettings.thisChoicePanel.textChoiceValue[var69][var126].trim().length() > 0 || var126 == 0) {
                                             this.str.append("\t\t" + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + ".addItem(\"");
                                             this.str.append(this.targetSettings.thisChoicePanel.textChoiceValue[var69][var126] + "\"); \r\n");
                                             if (this.targetSettings.fieldType[var69].equals("JDPChoice")) {
                                                this.str.append("\t\tvalue" + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + ".addElement(\"" + this.targetSettings.thisChoicePanel.actualChoiceValue[var69][var126] + "\"); \r\n");
                                             }

                                             ++var116;
                                          }
                                       }
                                    }
                                    break;
                                 case 44:
                                    if (this.targetSettings.fieldType[var69].equals("JDPChoice") && this.targetSettings.thisChoicePanel.valuesFrom[var69].equals("Database table/columns")) {
                                       this.str.append("\r\n\t\tvalue" + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + " = new Vector(); \r\n");
                                       this.str.append(this.stoken[0] + this.user.u.strip(this.targetScreen.columns.getItem(var69)) + this.stoken[1]);
                                       this.str.append(this.targetSettings.thisChoicePanel.textChoiceSql[var69] + this.stoken[2]);
                                       this.str.append(this.targetSettings.thisChoicePanel.columnActualList[var69] + this.stoken[3]);
                                       this.str.append(this.targetSettings.thisChoicePanel.tableList[var69] + this.stoken[4]);
                                       this.str.append(this.targetSettings.thisChoicePanel.tableWhereClause[var69] + this.stoken[5]);
                                       this.str.append(this.user.u.strip(this.targetScreen.columns.getItem(var69)) + this.stoken[6]);
                                    }

                                    if (this.targetSettings.fieldType[var69].equals("JDPComboBox") && this.targetSettings.thisChoicePanel.valuesFrom[var69].equals("Database table/columns")) {
                                       this.str.append(this.stoken[0] + this.user.u.strip(this.fields[var69]) + this.stoken[1]);
                                       this.str.append(this.targetSettings.thisChoicePanel.textChoiceSql[var69] + this.stoken[2]);
                                       this.str.append(this.targetSettings.thisChoicePanel.textChoiceSql[var69] + this.stoken[3]);
                                       this.str.append(this.targetSettings.thisChoicePanel.tableList[var69] + this.stoken[4]);
                                       this.str.append(this.targetSettings.thisChoicePanel.tableWhereClause[var69] + "\",");
                                       this.str.append("null" + this.stoken[6]);
                                    }
                              }

                              var45 = var69;
                           }
                        } catch (Exception var28) {
                        }
                     }
                  }

                  if (this.layoutName.equals("JDPLayout3") && this.lineIndex == 4 && var45 >= 0) {
                     for(int var60 = 0; var60 < this.targetScreen.columns.countItems(); ++var60) {
                        if (!this.targetScreen.columns.isSelected(var60)) {
                           this.str.append(this.stoken[0] + "TextField" + " " + this.user.u.strip(this.targetScreen.columns.getItem(var60)) + this.stoken[1]);
                        }
                     }
                  }

                  if (this.layoutName.equals("JDPLayout3") && this.lineIndex == 12 && var45 >= 0) {
                     for(int var61 = 0; var61 < this.targetScreen.columns.countItems(); ++var61) {
                        if (!this.targetScreen.columns.isSelected(var61)) {
                           this.str.append(this.stoken[0] + this.user.u.strip(this.targetScreen.columns.getItem(var61)) + this.stoken[1] + "TextField");
                           this.str.append("(\"\",20)");
                           this.str.append(this.stoken[2]);
                        }
                     }
                  }
                  break;
               case 5:
                  this.str.append(this.stoken[0]);
                  this.selectedFields = "";

                  for(int var67 = 0; var67 < this.keysSQL.length; ++var67) {
                     if (this.targetList == null || this.targetList.uniqueTree.isSelected(var67)) {
                        if (var67 > 0) {
                           this.str.append(",");
                        }

                        String var89 = this.switchField(this.keysSQL[var67]);
                        this.str.append(var89);
                        String var214 = this.selectedFields;
                        this.selectedFields = var214 + var89 + " ";
                     }
                  }

                  this.str.append(this.stoken[1]);
                  boolean var53 = true;
                  if (this.targetList != null) {
                     for(int var68 = 0; var68 < this.targetList.includeTree.countItems(); ++var68) {
                        String var90 = this.switchField(this.targetList.includeTree.getItem(var68));
                        if (!var53) {
                           this.str.append(",");
                        }

                        this.str.append("\"" + var90 + "\"");
                        String var215 = this.selectedFields;
                        this.selectedFields = var215 + var90 + " ";
                        var53 = false;
                     }
                  }

                  this.str.append(this.stoken[2]);
                  break;
               case 6:
                  if (this.targetList != null) {
                     int[] var44 = this.targetList.columns.getSelectedIndexes();

                     for(int var65 = 0; var65 < var44.length; ++var65) {
                        String var213 = this.selectedFields;
                        this.selectedFields = var213 + this.switchField(this.targetList.psortChoiceSql[var44[var65]]) + " ";
                     }
                  }

                  this.str.append(this.stoken[0] + "FROM ");
                  int[] var66 = this.targetTable.stables.getSelectedIndexes();
                  boolean var52 = true;
                  if (var66.length == 0 || this.selectedFields.indexOf("a.") >= 0) {
                     this.str.append(this.targetTable.tables.getSelectedItem());
                     if (var66.length > 0) {
                        this.str.append(" a");
                     }

                     if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                        this.str.append(" (NOLOCK)");
                     }

                     var52 = false;
                  }

                  for(int var87 = 0; var87 < var66.length; ++var87) {
                     if (this.targetTable.stableAlias[var66[var87]].equals("") || this.selectedFields.indexOf(this.targetTable.stableAlias[var66[var87]] + ".") >= 0) {
                        if (!var52) {
                           this.str.append(",");
                        }

                        this.str.append(this.targetTable.stables.getItem(var66[var87]));
                        this.str.append(" " + this.targetTable.stableAlias[var66[var87]]);
                        if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                           this.str.append(" (NOLOCK)");
                        }

                        var52 = false;
                     }
                  }

                  this.str.append(" WHERE ");
                  if (this.targetTable.joinConditions.countItems() != 0) {
                     for(int var88 = 0; var88 < this.targetTable.joinConditions.countItems(); ++var88) {
                        String var102 = this.targetTable.joinConditions.getItem(var88);
                        int var115 = var102.substring(2).indexOf(".") + 1;
                        if (this.selectedFields.indexOf(var102.substring(0, 2)) >= 0 && this.selectedFields.indexOf(var102.substring(var115, var115 + 2)) >= 0) {
                           this.str.append(var102 + " AND ");
                        }
                     }
                  }

                  if (this.targetList != null && this.targetList.pfromwhereclause.getText().length() != 0) {
                     this.str.append(this.targetList.pfromwhereclause.getText() + this.stoken[1]);
                  } else {
                     this.str.append("(1=1)" + this.stoken[1]);
                  }
                  break;
               case 7:
                  if (this.targetList == null) {
                     this.str.append(this.stoken[0] + "0" + this.stoken[1]);
                  } else {
                     int[] var43 = this.targetList.columns.getSelectedIndexes();
                     this.str.append(this.stoken[0] + Integer.toString(var43.length) + this.stoken[1]);
                  }
                  break;
               case 8:
                  if (this.targetList != null) {
                     int[] var42 = this.targetList.columns.getSelectedIndexes();

                     for(int var86 = 0; var86 < var42.length; ++var86) {
                        this.str.append(this.stoken[0] + Integer.toString(var86) + this.stoken[1] + this.targetList.psortChoiceSql[var42[var86]]);
                        if (this.targetList.psortOrder[var42[var86]].equals("Descending")) {
                           this.str.append(" DESC");
                        }

                        this.str.append(this.stoken[2]);
                     }
                  }
                  break;
               case 9:
                  if (this.targetList != null) {
                     this.str.append(this.stoken[0]);
                     int[] var41 = this.targetList.columns.getSelectedIndexes();

                     for(int var85 = 0; var85 < var41.length; ++var85) {
                        if (var85 > 0) {
                           this.str.append(",");
                        }

                        this.str.append("\"" + this.targetList.psortChoiceText[var41[var85]] + "\"");
                     }

                     this.str.append(this.stoken[1]);
                  } else {
                     this.str.append(this.stoken[0] + "\"\"" + this.stoken[1]);
                  }
                  break;
               case 10:
                  if (this.targetList != null) {
                     if (this.targetList.displayCount.getSelectedItem().equals("Yes")) {
                        this.str.append(this.stoken[0] + "true" + this.stoken[1]);
                     } else {
                        this.str.append(this.stoken[0] + "false" + this.stoken[1]);
                     }
                  } else {
                     this.str.append(this.stoken[0] + "false" + this.stoken[1]);
                  }
                  break;
               case 11:
                  if (this.targetList != null) {
                     this.str.append(this.stoken[0] + this.targetList.pcounttext.getText() + this.stoken[1]);
                  } else {
                     this.str.append(this.stoken[0] + "" + this.stoken[1]);
                  }
                  break;
               case 13:
                  for(int var84 = 0; var84 < this.targetScreen.centerTopPanel.length; ++var84) {
                     for(int var101 = 0; var101 <= this.targetScreen.lastLine; ++var101) {
                        if (this.targetScreen.panelPos[this.targetScreen.screenOrderL[var101]] == var84) {
                           TextField var114 = (TextField)this.targetScreen.componentL[this.targetScreen.screenOrderL[var101]];
                           if (var114 != null) {
                              String var124 = this.targetSettings.fieldLabelColor[this.targetScreen.screenOrderL[var101]];
                              var124 = var124.substring(0, 1).toLowerCase() + var124.substring(1);
                              this.str.append(this.stoken[0] + Integer.toString(var84) + this.stoken[1] + ((TextComponent)var114).getText() + this.stoken[2] + var124 + this.stoken[3]);
                           }
                        }
                     }
                  }
                  break;
               case 14:
                  for(int var64 = 0; var64 < this.targetScreen.centerTopPanel.length; ++var64) {
                     for(int var83 = 0; var83 <= this.targetScreen.lastLine; ++var83) {
                        boolean var51 = true;
                        boolean var100 = false;

                        for(int var113 = 0; var113 < this.targetScreen.maxcolumns; ++var113) {
                           try {
                              int var57 = this.targetScreen.screenOrder[var83][var113];
                              if (var57 >= 0 && this.targetScreen.panelPos[var57] == var64) {
                                 if (!var51) {
                                    this.str.append("\r\n");
                                 }

                                 if (var51) {
                                    this.str.append("\t\tPanel centerR" + Integer.toString(var83) + " = new Panel();\r\n\t\t");
                                    this.str.append("centerR" + Integer.toString(var83) + ".setLayout(new JDPLineLayout(3));\r\n");
                                    var51 = false;
                                 }

                                 this.str.append("\t\tcenterR" + Integer.toString(var83) + ".add(\"Left\",");
                                 if (var57 != this.targetScreen.screenOrder[var83][var113 + 1]) {
                                    this.str.append(this.user.u.strip(this.targetScreen.columns.getItem(var57)));
                                 } else {
                                    String var122 = this.targetSettings.fieldLabelColor[var57];
                                    var122 = var122.substring(0, 1).toLowerCase() + var122.substring(1);
                                    this.str.append("new JDPWrapLabel(user,\"");
                                    TextField var128 = (TextField)this.targetScreen.componentL[var57];
                                    this.str.append(((TextComponent)var128).getText() + "\",Color." + var122 + ")");
                                 }

                                 this.str.append(");\r\n");
                                 var100 = true;
                              }
                           } catch (Exception var26) {
                           }
                        }

                        if (var100) {
                           this.str.append(this.stoken[0] + Integer.toString(var64) + this.stoken[1] + Integer.toString(var83) + this.stoken[2]);
                        }
                     }
                  }
                  break;
               case 15:
                  this.str.append(this.stoken[0]);
                  if (this.iconsText.length() > 0) {
                     this.iconsText = this.iconsText.substring(0, this.iconsText.length() - 1);
                  }

                  this.str.append(this.stoken[1]);
                  break;
               case 16:
                  if (this.targetSearch == null) {
                     this.str.append(this.stoken[0] + "0" + this.stoken[1]);
                  } else {
                     int[] var40 = this.targetSearch.columns.getSelectedIndexes();
                     this.str.append(this.stoken[0] + Integer.toString(var40.length) + this.stoken[1]);
                  }
                  break;
               case 17:
                  if (this.targetSearch != null) {
                     int[] var39 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var82 = 0; var82 < var39.length; ++var82) {
                        this.str.append(this.stoken[0] + Integer.toString(var82) + this.stoken[1] + this.targetSearch.pchooseFrom[var39[var82]] + this.stoken[2]);
                     }
                  }
                  break;
               case 18:
                  if (this.targetSearch != null) {
                     int[] var38 = this.targetSearch.columns.getSelectedIndexes();
                     this.str.append(this.stoken[0] + Integer.toString(var38.length) + this.stoken[1]);
                  } else {
                     this.str.append(this.stoken[0] + "0" + this.stoken[1]);
                  }
                  break;
               case 19:
                  if (this.targetSearch != null) {
                     int[] var37 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var81 = 0; var81 < var37.length; ++var81) {
                        String var99 = this.targetSearch.columns.getItem(var37[var81]);
                        if (this.layoutName.equals("JDPLayout1")) {
                           for(int var111 = 0; var111 < this.targetSettings.columns.countItems(); ++var111) {
                              if (var99.equals(this.targetSettings.columns.getItem(var111))) {
                                 var99 = this.targetSettings.fieldSql[var111];
                                 break;
                              }
                           }
                        }

                        if (this.layoutName.equals("JDPLayout2") || this.layoutName.equals("JDPLayout4")) {
                           for(int var112 = 0; var112 < this.targetGridSettings.columns.countItems(); ++var112) {
                              if (var99.equals(this.targetGridSettings.columns.getItem(var112))) {
                                 var99 = this.targetGridSettings.fieldSql[var112];
                                 break;
                              }
                           }
                        }

                        this.str.append(this.stoken[0] + Integer.toString(var81) + this.stoken[1] + var99 + this.stoken[2]);
                     }
                  }
                  break;
               case 20:
                  if (this.targetSearch != null) {
                     int[] var36 = this.targetSearch.columns.getSelectedIndexes();
                     this.totalItems = 8;
                     this.str.append("\t\tJDPLoadChoice lc = new JDPLoadChoice(user,jaggSQL,null,\"\",\"\",\"\",\"\",-1);\r\n");

                     for(int var80 = 0; var80 < var36.length; ++var80) {
                        this.str.append(this.stoken[0]);
                     }
                  }
                  break;
               case 21:
                  if (this.targetSearch != null) {
                     int[] var35 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var79 = 0; var79 < var35.length; ++var79) {
                        if (this.targetSearch.thisChoicePanel.valuesFrom[var35[var79]].equals("Fields entered here")) {
                           for(int var98 = 0; var98 < JDPChoiceLayout.maxChoices; ++var98) {
                              if (this.targetSearch.thisChoicePanel.textChoiceValue[var35[var79]][var98] != null && this.targetSearch.thisChoicePanel.textChoiceValue[var35[var79]][var98].length() > 0) {
                                 this.str.append(this.stoken[0] + Integer.toString(var79) + this.stoken[1] + this.targetSearch.thisChoicePanel.textChoiceValue[var35[var79]][var98] + this.stoken[2]);
                              }
                           }
                        } else {
                           int var56 = var35[var79];
                           this.str.append("\r\n\t\tlc.loadChoice((Vector)pmatchUsing.elementAt(" + Integer.toString(var79) + "),\"");
                           this.str.append(this.targetSearch.thisChoicePanel.textChoiceSql[var56] + "\",\"");
                           this.str.append(this.targetSearch.thisChoicePanel.columnActualList[var56] + "\",\"");
                           this.str.append(this.targetSearch.thisChoicePanel.tableList[var56] + "\",\"");
                           this.str.append(this.targetSearch.thisChoicePanel.tableWhereClause[var56] + "\",");
                           this.str.append("(Vector)pactualmatchUsing.elementAt(" + Integer.toString(var79) + "),");
                           this.str.append(Integer.toString(this.targetSearch.odbcType[var56]) + ");\r\n");
                        }
                     }
                  }
                  break;
               case 22:
                  if (this.targetSearch != null) {
                     int[] var34 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var78 = 0; var78 < var34.length; ++var78) {
                        this.str.append(this.stoken[0]);
                     }
                  }
                  break;
               case 23:
                  if (this.targetSearch != null) {
                     int[] var33 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var77 = 0; var77 < var33.length; ++var77) {
                        if (this.targetSearch.thisChoicePanel.valuesFrom[var33[var77]].equals("Fields entered here")) {
                           for(int var97 = 0; var97 < JDPChoiceLayout.maxChoices; ++var97) {
                              if (this.targetSearch.thisChoicePanel.actualChoiceValue[var33[var77]][var97] != null && this.targetSearch.thisChoicePanel.textChoiceValue[var33[var77]][var97].length() > 0) {
                                 this.str.append(this.stoken[0] + Integer.toString(var77) + this.stoken[1] + this.targetSearch.thisChoicePanel.actualChoiceValue[var33[var77]][var97] + this.stoken[2]);
                              }
                           }
                        }
                     }
                  }
                  break;
               case 24:
                  if (this.targetSearch != null) {
                     int[] var32 = this.targetSearch.columns.getSelectedIndexes();
                     this.str.append(this.stoken[0] + Integer.toString(var32.length) + this.stoken[1]);
                  } else {
                     this.str.append(this.stoken[0] + "0" + this.stoken[1]);
                  }
                  break;
               case 25:
                  if (this.targetSearch != null) {
                     int[] var31 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var76 = 0; var76 < var31.length; ++var76) {
                        if (this.targetSearch.constantIsString[var31[var76]]) {
                           this.str.append(this.stoken[0] + Integer.toString(var76) + this.stoken[1] + "true" + this.stoken[2]);
                        } else {
                           this.str.append(this.stoken[0] + Integer.toString(var76) + this.stoken[1] + "false" + this.stoken[2]);
                        }
                     }
                  }
                  break;
               case 26:
                  if (this.targetSearch != null) {
                     int[] var30 = this.targetSearch.columns.getSelectedIndexes();
                     this.str.append(this.stoken[0] + Integer.toString(var30.length) + this.stoken[1]);
                  } else {
                     this.str.append(this.stoken[0] + "0" + this.stoken[1]);
                  }
                  break;
               case 27:
                  if (this.targetSearch != null) {
                     int[] var3 = this.targetSearch.columns.getSelectedIndexes();

                     for(int var75 = 0; var75 < var3.length; ++var75) {
                        this.str.append(this.stoken[0] + Integer.toString(var75) + this.stoken[1] + Integer.toString(this.targetSearch.constantLength[var3[var75]]) + this.stoken[2]);
                     }
                  }
                  break;
               case 28:
                  if (this.targetSearch != null) {
                  }
                  break;
               case 29:
                  String var74 = "false";
                  if (this.targetList != null) {
                     if (this.targetList.useTree.getSelectedItem().equals("Tree Structure")) {
                        var74 = "true";
                     }

                     this.str.append(this.stoken[0] + var74 + this.stoken[1] + "false" + this.stoken[2] + this.targetList.pinitChoice + this.stoken[3]);
                  } else {
                     this.str.append(this.stoken[0] + var74 + this.stoken[1] + "false" + this.stoken[2] + "" + this.stoken[3]);
                  }
                  break;
               case 31:
               case 38:
               case 45:
                  boolean var50 = true;
                  int var7 = -1;
                  int var9 = 0;
                  int var10 = -1;

                  for(int var63 = 0; var63 < this.targetScreen.centerTopPanel.length; ++var63) {
                     for(int var72 = 0; var72 <= this.targetScreen.lastLine; ++var72) {
                        for(int var95 = 0; var95 < this.targetScreen.maxcolumns; ++var95) {
                           try {
                              var9 = this.targetScreen.screenOrder[var72][var95];
                              if (var9 >= 0 && var9 != this.targetScreen.screenOrder[var72][var95 + 1] && this.targetScreen.panelPos[var9] == var63) {
                                 if (var10 == -1 && this.targetScreen.panelPos[var9] == var63 + 1 && var9 != this.targetScreen.screenOrder[var72][var95 + 1]) {
                                    var10 = var9;
                                 }

                                 switch (this.lineIndex) {
                                    case 31:
                                       if (var7 >= 0) {
                                          this.str.append(this.stoken[0] + this.user.u.strip(this.targetScreen.columns.getItem(var7)) + this.stoken[1] + this.user.u.strip(this.targetScreen.columns.getItem(var9)) + this.stoken[2]);
                                       }
                                       break;
                                    case 38:
                                       if (var7 >= 0) {
                                          this.str.append(this.stoken[0] + this.user.u.strip(this.targetScreen.columns.getItem(var9)) + this.stoken[1] + this.user.u.strip(this.targetScreen.columns.getItem(var7)) + this.stoken[2]);
                                       }
                                       break;
                                    case 45:
                                       int var109 = this.targetColumns.columnDatatype[this.targetSettings.columnIndexes[var9]];
                                       boolean var121 = this.targetColumns.columnIsIdentity[this.targetSettings.columnIndexes[var9]];
                                       if ((this.targetSettings.fieldType[var9].equals("TextField") || this.targetSettings.fieldType[var9].equals("TextArea") || this.targetSettings.fieldType[var9].equals("JDPSpinner")) && !var121) {
                                          String var127 = this.user.u.strip(this.targetScreen.columns.getItem(var9));
                                          if (JDPUtils.isOdbcChar(var109) && this.targetSettings.fieldRequired[this.indexes[var72]].equals("Yes")) {
                                             this.str.append(this.stoken[0] + "ischaracter" + this.stoken[1] + var127 + this.stoken[2] + this.targetSettings.fieldErrorMsg[this.indexes[var72]] + this.stoken[3]);
                                          }

                                          if (JDPUtils.isOdbcInt(var109) && this.targetSettings.fieldRequired[this.indexes[var72]].equals("Yes")) {
                                             this.str.append(this.stoken[0] + "isnumeric" + this.stoken[1] + var127 + this.stoken[2] + this.targetSettings.fieldErrorMsg[this.indexes[var72]] + this.stoken[3]);
                                          }

                                          if (JDPUtils.isOdbcFloat(var109) && this.targetSettings.fieldRequired[this.indexes[var72]].equals("Yes")) {
                                             this.str.append(this.stoken[0] + "isfloat" + this.stoken[1] + var127 + this.stoken[2] + this.targetSettings.fieldErrorMsg[this.indexes[var72]] + this.stoken[3]);
                                          }

                                          if (JDPUtils.isOdbcDate(var109) && this.targetSettings.fieldRequired[this.indexes[var72]].equals("Yes")) {
                                             this.str.append(this.stoken[0] + "isvalidDate" + this.stoken[1] + var127 + this.stoken[2] + this.targetSettings.fieldErrorMsg[this.indexes[var72]] + this.stoken[3]);
                                          }
                                       }
                                 }

                                 var7 = var9;
                              }
                           } catch (Exception var27) {
                           }
                        }
                     }

                     String var73 = this.user.u.strip(this.targetScreen.columns.getItem(var7));
                     String var96 = this.user.u.strip(this.targetScreen.columns.getItem(var10));
                     String var110 = this.user.u.strip(this.targetScreen.columns.getItem(this.targetScreen.screenOrder[0][0]));
                     if (this.lineIndex == 31 && var7 >= 0) {
                        if (this.targetScreen.centerTopPanel.length > 1) {
                           if (var63 == this.targetScreen.centerTopPanel.length - 1) {
                              this.str.append(this.stoken[0] + var73 + this.stoken[1] + var110 + "); tabPanel.loadNextTab(" + this.stoken[2]);
                           } else if (var10 >= 0) {
                              this.str.append(this.stoken[0] + var73 + this.stoken[1] + var96 + "); tabPanel.loadNextTab(" + this.stoken[2]);
                           }
                        } else {
                           this.str.append(this.stoken[0] + var73 + this.stoken[1] + var110 + this.stoken[2]);
                        }
                     }

                     if (this.lineIndex == 38 && var7 >= 0) {
                        if (this.targetScreen.centerTopPanel.length > 1) {
                           if (var63 == this.targetScreen.centerTopPanel.length - 1) {
                              this.str.append(this.stoken[0] + var110 + this.stoken[1] + var73 + "); tabPanel.loadPrevTab(" + this.stoken[2]);
                           } else if (var10 >= 0) {
                              this.str.append(this.stoken[0] + var96 + this.stoken[1] + var73 + "); tabPanel.loadPrevTab(" + this.stoken[2]);
                           }
                        } else {
                           this.str.append(this.stoken[0] + var110 + this.stoken[1] + var73 + this.stoken[2]);
                        }
                     }

                     var10 = -1;
                     var7 = -1;
                  }
                  break;
               case 32:
                  boolean var94 = false;
                  this.selectedFields = "";
                  this.str.append(this.stoken[0] + "\"SELECT ");
                  String var108 = this.targetSettings.lockingColumn.getSelectedItem();
                  if (var108 != null && !var108.equals("")) {
                     this.str.append(var108);
                     if (this.user.u.sqlRequiresChange(this.targetDSN.jaggSQL, 0)) {
                        this.str.append(" l" + var108);
                     }

                     this.str.append(",\" +\r\n\t\t\t\t\t\"");
                  }

                  for(int var15 = 0; var15 < this.fields.length; ++var15) {
                     if (this.indexes[var15] < this.targetSettings.fieldType.length) {
                        if (var15 > 0) {
                           this.str.append(",\" +\r\n\t\t\t\t\t\"");
                        }

                        this.str.append(this.targetSettings.fieldSql[this.indexes[var15]]);
                        String var211 = this.selectedFields;
                        this.selectedFields = var211 + this.targetSettings.fieldSql[this.indexes[var15]] + " ";
                     }
                  }

                  if (this.layoutName.equals("JDPLayout3")) {
                     for(int var118 = 0; var118 < this.targetScreen.columns.countItems(); ++var118) {
                        if (var118 < this.indexes.length && this.indexes[var118] < this.targetSettings.fieldType.length && !this.targetScreen.columns.isSelected(var118)) {
                           this.str.append(",\" +\r\n\t\t\t\t\t\"");
                           this.str.append(this.switchField(this.targetSettings.fieldSql[var118]));
                           if (this.selectedFields.indexOf(this.switchField(this.targetSettings.fieldSql[var118])) >= 0 && this.user.u.sqlRequiresChange(this.targetDSN.jaggSQL, 0)) {
                              this.str.append(" a" + this.switchField(this.user.u.strip(this.targetSettings.fieldSql[var118])));
                           }
                        }
                     }
                  }

                  this.str.append("\" +\r\n\t\t\t\t\t\" FROM ");

                  for(int var119 = 0; var119 < this.keysSQL.length; ++var119) {
                     String var212 = this.selectedFields;
                     this.selectedFields = var212 + this.switchField(this.keysSQL[var119]) + " ";
                  }

                  String var120 = null;
                  String var16 = "";

                  for(int var17 = 0; var17 < this.targetTable.joinConditions.countItems(); ++var17) {
                     if (this.targetTable.joinConditions.getItem(var17).indexOf("*=") > 0) {
                        var120 = "left";
                        var16 = this.targetTable.joinConditions.getItem(var17);
                     }

                     if (this.targetTable.joinConditions.getItem(var17).indexOf("=*") > 0) {
                        var120 = "right";
                        var16 = this.targetTable.joinConditions.getItem(var17);
                     }
                  }

                  String var129 = "";
                  String var18 = "";
                  boolean var48 = true;
                  int[] var11 = this.targetTable.stables.getSelectedIndexes();
                  if (var11.length == 0 || this.selectedFields.indexOf("a.") >= 0) {
                     var129 = this.targetTable.tables.getSelectedItem();
                     if (var11.length > 0) {
                        var129 = var129 + " a";
                     }

                     if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                        var129 = var129 + " (NOLOCK)";
                     }

                     var48 = false;
                  }

                  for(int var161 = 0; var161 < var11.length; ++var161) {
                     if (this.selectedFields.indexOf(this.targetTable.stableAlias[var11[var161]] + ".") >= 0) {
                        if (var120 == null && !var48) {
                           var18 = var18 + ",";
                        }

                        var18 = var18 + this.targetTable.stables.getItem(var11[var161]);
                        var18 = var18 + " " + this.targetTable.stableAlias[var11[var161]];
                        if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                           var18 = var18 + " (NOLOCK)";
                        }

                        var48 = false;
                     }
                  }

                  if (var120 == null) {
                     this.str.append(var129);
                     this.str.append(var18);
                  } else if (var120.equals("left")) {
                     this.str.append("{oj ");
                     this.str.append(var129);
                     this.str.append(" LEFT OUTER JOIN ");
                     this.str.append(var18);
                     this.str.append(" ON ");
                     this.str.append(this.user.u.replace(var16, "*", ""));
                     this.str.append("}");
                  } else if (var120.equals("right")) {
                     this.str.append("{oj ");
                     this.str.append(var18);
                     this.str.append(" LEFT OUTER JOIN ");
                     this.str.append(var129);
                     this.str.append(" ON ");
                     this.str.append(this.user.u.replace(var16, "*", ""));
                     this.str.append("}");
                  }

                  var48 = true;
                  if (this.targetTable.joinConditions.countItems() > 0) {
                     for(int var162 = 0; var162 < this.targetTable.joinConditions.countItems(); ++var162) {
                        if (!this.targetTable.joinConditions.getItem(var162).equals(var16)) {
                           String var187 = this.targetTable.joinConditions.getItem(var162);
                           int var199 = var187.substring(2).indexOf(".") + 1;
                           if (this.selectedFields.indexOf(var187.substring(0, 2)) >= 0 && this.selectedFields.indexOf(var187.substring(var199, var199 + 2)) >= 0) {
                              if (var48) {
                                 this.str.append("\" +\r\n\t\t\t\t\t\" WHERE ");
                              }

                              if (!var48) {
                                 this.str.append("\" +\r\n\t\t\t\t\t\" AND ");
                              }

                              this.str.append(this.targetTable.joinConditions.getItem(var162));
                              var48 = false;
                           }
                        }
                     }

                     if (!var48) {
                        this.str.append("\"");
                     }
                  }

                  if (this.targetList != null) {
                     for(int var163 = 0; var163 < this.keys.length; ++var163) {
                        if (!this.layoutName.equals("JDPLayout11") && !this.layoutName.equals("JDPLayout21") && !this.layoutName.equals("JDPLayout23") && (this.targetList.uniqueTree.isSelected(var163) || this.targetList.useTree.getSelectedItem().equals("List"))) {
                           if (var48) {
                              this.str.append("\" +\r\n\t\t\t\t\t\" WHERE ");
                           }

                           if (!var48) {
                              this.str.append(" +\r\n\t\t\t\t\t\t\t\" AND ");
                           }

                           var48 = false;
                           this.str.append(this.cvtKey(this.switchField(this.keysSQL[var163]), this.keyDataType[var163]) + "=");
                           String var188 = this.getQuote(this.keyDataType[var163]);
                           this.str.append(var188);
                           this.str.append("\" + searchResults.recordKey" + Integer.toString(var163) + "[itemIndex]");
                           this.str.append("+ \"" + var188 + "\" ");
                        }
                     }
                  }

                  if (this.layoutName.equals("JDPLayout11") || this.layoutName.equals("JDPLayout21") || this.layoutName.equals("JDPLayout23")) {
                     for(int var164 = 0; var164 < this.keys.length; ++var164) {
                        if (var48) {
                           this.str.append("\" +\r\n\t\t\t\t\t\" WHERE (1=1)\"");
                        }

                        var48 = false;
                        this.str.append(";\r\n\t\tif (keys.length > " + Integer.toString(var164) + " && keys[" + Integer.toString(var164) + "] != null) SQL += \" AND " + this.cvtKey(this.keysSQL[var164], this.keyDataType[var164]) + "=");
                        String var189 = this.getQuote(this.keyDataType[var164]);
                        this.str.append(var189);
                        if (JDPUtils.isOdbcBinary(this.keyDataType[var164])) {
                           this.str.append("0x");
                        }

                        this.str.append("\" + keys[" + Integer.toString(var164) + "]");
                        this.str.append("+ \"");
                        this.str.append(var189);
                        this.str.append("\" ");
                     }
                  }

                  if (var48) {
                     this.str.append("\"");
                  }

                  this.str.append(this.stoken[1]);
                  break;
               case 33:
                  String var107 = this.targetSettings.lockingColumn.getSelectedItem();
                  if (var107 != null && !var107.equals("")) {
                     String var158 = "";
                     if (this.targetSettings.thisBranch != null) {
                        var158 = this.targetSettings.thisBranch.name;
                     }

                     this.str.append("\t\t\t\t" + var158 + this.user.u.strip(var107) + "Lock = stok.nextToken(sep).trim(); \r\n");
                  }

                  for(int var159 = 0; var159 < this.fields.length; ++var159) {
                     if (this.indexes[var159] < this.targetSettings.fieldType.length) {
                        if (!this.targetSettings.fieldType[this.indexes[var159]].equals("TextField") && !this.targetSettings.fieldType[this.indexes[var159]].equals("TextArea") && !this.targetSettings.fieldType[this.indexes[var159]].equals("JDPComboBox") && !this.targetSettings.fieldType[this.indexes[var159]].equals("JDPSpinner")) {
                           if (this.targetSettings.fieldType[this.indexes[var159]].equals("JDPDate")) {
                              this.str.append(this.stoken[0] + this.fields[var159] + ".setText(JDPDate.format(Long.valueOf(stok.nextToken().trim()).longValue()));\r\n");
                           } else if (this.targetSettings.fieldType[this.indexes[var159]].equals("JDPChoice")) {
                              this.str.append(this.stoken[0] + this.fields[var159] + ".selectKey(stok.nextToken().trim());\r\n");
                           } else if (this.targetSettings.fieldType[this.indexes[var159]].equals("Checkbox")) {
                              this.str.append("\t\t\t\ttempText = stok.nextToken(sep).trim(); \r\n");
                              this.str.append("\t\t\t\t" + this.fields[var159] + ".setState(tempText.equals(\"" + this.targetSettings.checkedValue[this.indexes[var159]] + "\"));\r\n");
                           }
                        } else {
                           this.str.append(this.stoken[0] + this.fields[var159] + this.stoken[1]);
                        }

                        if (this.targetSettings.fieldType[this.indexes[var159]].equals("RadioButtons")) {
                           this.str.append("\t\t\t\ttempText = stok.nextToken(sep).trim(); \r\n");
                           this.str.append("\t\t\t\t" + this.fields[var159] + ".setState(tempText.equals(\"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var159]][0] + "\"));\r\n");

                           for(int var186 = 1; var186 < JDPChoiceLayout.maxChoices; ++var186) {
                              if (this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var159]][var186].trim().length() > 0) {
                                 this.str.append("\t\t\t\t" + this.fields[var159] + Integer.toString(var186) + ".setState(tempText.equals(\"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var159]][var186] + "\"));\r\n");
                              }
                           }
                        }
                     }
                  }

                  if (this.layoutName.equals("JDPLayout3")) {
                     for(int var160 = 0; var160 < this.targetScreen.columns.countItems(); ++var160) {
                        if (!this.targetScreen.columns.isSelected(var160)) {
                           this.str.append(this.stoken[0] + "if (stok.hasMoreTokens()) " + this.user.u.strip(this.targetScreen.columns.getItem(var160)) + this.stoken[1]);
                        }
                     }
                  }
                  break;
               case 34:
                  this.str.append(this.stoken[0] + "\"INSERT INTO " + this.targetColumns.tableName[0] + " (");
                  boolean var46 = true;

                  for(int var156 = 0; var156 < this.insertfields.length; ++var156) {
                     if (!this.targetColumns.columnIsIdentity[this.iindexes[var156]]) {
                        boolean var184 = true;

                        for(int var197 = 0; var197 < this.updatefields.length; ++var197) {
                           if (this.insertfields[var156].equals(this.updatefields[var197])) {
                              var184 = false;
                           }

                           if (this.insertfields[var156].equals(this.updatefields[var197]) && this.targetSettings.includeInUpdateSql[this.indexes[var197]].equals("No")) {
                              var184 = true;
                           }
                        }

                        if (!var184) {
                           if (!var46) {
                              this.str.append(", \" +\r\n\t\t\t\t\t\"");
                           }

                           var46 = false;
                           this.str.append(this.insertfields[var156]);
                        }
                     }
                  }

                  this.str.append(") VALUES(");
                  var46 = true;

                  for(int var157 = 0; var157 < this.insertfields.length; ++var157) {
                     if (!this.targetColumns.columnIsIdentity[this.iindexes[var157]]) {
                        boolean var185 = true;
                        boolean var198 = true;

                        for(int var203 = 0; var203 < this.updatefields.length; ++var203) {
                           if (this.insertfields[var157].equals(this.updatefields[var203])) {
                              var198 = false;
                           }

                           if (this.insertfields[var157].equals(this.updatefields[var203]) && this.targetSettings.includeInUpdateSql[this.indexes[var203]].equals("No")) {
                              var198 = true;
                           }

                           if (this.insertfields[var157].equals(this.updatefields[var203]) && this.targetSettings.includeInUpdateSql[this.indexes[var203]].equals("Yes")) {
                              if (!var46) {
                                 this.str.append(", \" +\r\n\t\t\t\t\t\"");
                              }

                              var46 = false;
                              var185 = false;
                              boolean var92 = false;
                              if (JDPUtils.isOdbcChar(this.dataType[var203])) {
                                 var92 = true;
                              }

                              String var206 = "";
                              if (JDPUtils.isOdbcDate(this.dataType[var203])) {
                                 String[] var24 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                                 this.str.append(var24[0]);
                                 var206 = var24[1];
                              } else if (var92) {
                                 this.str.append("'");
                              }

                              if (!this.targetSettings.fieldType[this.indexes[var203]].equals("TextField") && !this.targetSettings.fieldType[this.indexes[var203]].equals("TextArea") && !this.targetSettings.fieldType[this.indexes[var203]].equals("JDPComboBox") && !this.targetSettings.fieldType[this.indexes[var203]].equals("JDPSpinner") && !this.targetSettings.fieldType[this.indexes[var203]].equals("JDPDate")) {
                                 if (this.targetSettings.fieldType[this.indexes[var203]].equals("JDPChoice")) {
                                    this.str.append("\" + " + this.fields[var203] + ".getSelectedKey() + ");
                                 } else if (this.targetSettings.fieldType[this.indexes[var203]].equals("Checkbox")) {
                                    this.str.append("\" + (" + this.fields[var203] + ".getState() ? \"" + this.targetSettings.checkedValue[var203] + "\" : \"" + this.targetSettings.uncheckedValue[var203] + "\") + ");
                                 } else if (this.targetSettings.fieldType[this.indexes[var203]].equals("RadioButtons")) {
                                    int var208 = 1;
                                    this.str.append("\" + (" + this.fields[var203] + ".getState() ? \"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var203]][0].trim() + "\" : ");

                                    for(int var25 = 1; var25 < JDPChoiceLayout.maxChoices; ++var25) {
                                       if (this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var203]][var25].trim().length() > 0) {
                                          this.str.append("(" + this.fields[var203] + Integer.toString(var25) + ".getState() ? \"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var203]][var25].trim() + "\" : ");
                                          ++var208;
                                       }
                                    }

                                    this.str.append("\" \"");

                                    for(int var210 = 0; var210 < var208; ++var210) {
                                       this.str.append(")");
                                    }

                                    this.str.append(" + ");
                                 }
                              } else if (JDPUtils.isOdbcNum(this.dataType[var203]) && !this.targetSettings.fieldEditMask[this.indexes[var203]].equals("")) {
                                 this.str.append("\" + JDPMaskEditMain.stripFloat(" + this.fields[var203] + ") + ");
                              } else if (JDPUtils.isOdbcDate(this.dataType[var203])) {
                                 this.str.append(this.fields[var203] + ".getText()");
                              } else if (JDPUtils.isOdbcBinary(this.dataType[var203])) {
                                 this.str.append("0x0\" + " + this.fields[var203] + ".getText() + ");
                              } else if (var92) {
                                 this.str.append("\" + user.u.replace(" + this.fields[var203] + ".getText(),\"'\",\"''\") + ");
                              } else {
                                 this.str.append("\" + JDPUtils.tonum(" + this.fields[var203] + ".getText()) + ");
                              }

                              if (!JDPUtils.isOdbcDate(this.dataType[var203])) {
                                 this.str.append("\"");
                                 if (var92) {
                                    this.str.append("'");
                                 }
                              }

                              this.str.append(var206);
                              break;
                           }
                        }

                        if (!var198 && var185) {
                           if (!var46) {
                              this.str.append(", \" +\r\n\t\t\t\t\t\"");
                           }

                           var46 = false;
                           boolean var93 = false;
                           int var204 = this.targetColumns.columnDatatype[this.iindexes[var157]];
                           if (JDPUtils.isOdbcChar(var204)) {
                              var93 = true;
                           }

                           String var207 = "";
                           if (JDPUtils.isOdbcDate(var204)) {
                              String[] var209 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                              this.str.append(var209[0]);
                              var207 = var209[1];
                              this.str.append("\"" + this.targetSettings.fieldDefault[var157] + "\"");
                           } else if (var93) {
                              this.str.append("'" + this.user.u.replace(this.targetSettings.fieldDefault[var157], "'", "''") + "'");
                           } else if (this.targetSettings.fieldDefault[var157].equals("")) {
                              this.str.append("0");
                           } else {
                              this.str.append(this.targetSettings.fieldDefault[var157]);
                           }

                           this.str.append(var207);
                        }
                     }
                  }

                  this.str.append(")\"");
                  this.str.append(this.stoken[1]);
                  break;
               case 35:
                  this.str.append(this.stoken[0] + "\"DELETE FROM " + this.targetColumns.tableName[0]);
                  this.str.append("\" +\r\n\t\t\t\t\t\" WHERE ");

                  for(int var154 = 0; var154 < this.keysUpdate.length; ++var154) {
                     if (var154 > 0) {
                        this.str.append(" +\r\n\t\t\t\t\t\" AND ");
                     }

                     if (this.keysSQLUpdate[var154].indexOf(".") > 0) {
                        this.str.append(this.cvtKey(this.keysSQLUpdate[var154].substring(2), this.keyDataTypeUpdate[var154]) + "=");
                     } else {
                        this.str.append(this.cvtKey(this.keysSQLUpdate[var154], this.keyDataTypeUpdate[var154]) + "=");
                     }

                     String var183 = this.getQuote(this.keyDataTypeUpdate[var154]);
                     this.str.append(var183);
                     if (JDPUtils.isOdbcBinary(this.keyDataTypeUpdate[var154])) {
                        this.str.append("0x");
                     }

                     if (!this.layoutName.equals("JDPLayout11") && !this.layoutName.equals("JDPLayout21") && !this.layoutName.equals("JDPLayout23")) {
                        this.str.append("\" + searchResults.recordKey" + Integer.toString(var154) + "[itemIndex]");
                     } else {
                        this.str.append("\" + keys[" + Integer.toString(var154) + "]");
                     }

                     this.str.append("+ \"");
                     this.str.append(var183);
                     this.str.append("\" ");
                  }

                  this.str.append(this.stoken[1]);
                  String var106 = this.targetSettings.lockingColumn.getSelectedItem();
                  if (var106 != null && !var106.equals("")) {
                     String var155 = "";
                     if (this.targetSettings.thisBranch != null) {
                        var155 = this.targetSettings.thisBranch.name;
                     }

                     if (var106.indexOf(".") > 0) {
                        var106 = var106.substring(2);
                     }

                     this.str.append("\t\t\t\tprevSQL = SQL;\r\n\t\t\t\tif (" + var155 + this.user.u.strip(var106) + "Lock != null) {\r\n\t\t\t\t\t");
                     this.str.append("SQL += \" AND " + var106 + " = \" + " + var155 + this.user.u.strip(var106) + "Lock");
                     this.str.append(";\r\n\t\t\t\t}\r\n");
                  }
                  break;
               case 36:
                  this.str.append(this.stoken[0] + "\"UPDATE " + this.targetColumns.tableName[0] + " SET ");
                  boolean var8 = true;

                  for(int var151 = 0; var151 < this.updatefields.length; ++var151) {
                     if (this.indexes[var151] < this.targetSettings.fieldType.length && !this.targetColumns.columnIsIdentity[this.targetSettings.columnIndexes[this.indexes[var151]]] && this.targetSettings.includeInUpdateSql[this.indexes[var151]].equals("Yes")) {
                        boolean var181 = true;

                        for(int var2 = 0; var2 < this.keysUpdate.length; ++var2) {
                           if (this.keysUpdate[var2].equals(this.updatefields[var151])) {
                              var181 = false;
                              break;
                           }
                        }

                        if (var181 && this.targetSettings.fieldEditable[this.indexes[var151]].equals("Yes")) {
                           if (!var8) {
                              this.str.append(", \" +\r\n\t\t\t\t\t\"");
                           }

                           var8 = false;
                           this.str.append(this.updatefields[var151] + " = ");
                           boolean var13 = false;
                           if (JDPUtils.isOdbcChar(this.dataType[var151])) {
                              var13 = true;
                           }

                           String var196 = "";
                           if (JDPUtils.isOdbcDate(this.dataType[var151])) {
                              String[] var201 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                              this.str.append(var201[0]);
                              var196 = var201[1];
                           } else if (var13) {
                              this.str.append("'");
                           }

                           if (JDPUtils.isOdbcBinary(this.dataType[var151])) {
                              this.str.append("0x0");
                           }

                           if (!this.targetSettings.fieldType[this.indexes[var151]].equals("TextField") && !this.targetSettings.fieldType[this.indexes[var151]].equals("TextArea") && !this.targetSettings.fieldType[this.indexes[var151]].equals("JDPComboBox") && !this.targetSettings.fieldType[this.indexes[var151]].equals("JDPSpinner") && !this.targetSettings.fieldType[this.indexes[var151]].equals("JDPDate")) {
                              if (this.targetSettings.fieldType[this.indexes[var151]].equals("JDPChoice")) {
                                 this.str.append("\" + " + this.fields[var151] + ".getSelectedKey() + ");
                              } else if (this.targetSettings.fieldType[this.indexes[var151]].equals("Checkbox")) {
                                 this.str.append("\" + (" + this.fields[var151] + ".getState() ? \"" + this.targetSettings.checkedValue[var151] + "\" : \"" + this.targetSettings.uncheckedValue[var151] + "\") + ");
                              } else if (this.targetSettings.fieldType[this.indexes[var151]].equals("RadioButtons")) {
                                 int var202 = 1;
                                 this.str.append("\" + (" + this.fields[var151] + ".getState() ? \"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var151]][0].trim() + "\" : ");

                                 for(int var23 = 1; var23 < JDPChoiceLayout.maxChoices; ++var23) {
                                    if (this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var151]][var23].trim().length() > 0) {
                                       this.str.append("(" + this.fields[var151] + Integer.toString(var23) + ".getState() ? \"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var151]][var23].trim() + "\" : ");
                                       ++var202;
                                    }
                                 }

                                 this.str.append("\" \"");

                                 for(int var205 = 0; var205 < var202; ++var205) {
                                    this.str.append(")");
                                 }

                                 this.str.append(" + ");
                              }
                           } else if (JDPUtils.isOdbcNum(this.dataType[var151]) && !this.targetSettings.fieldEditMask[this.indexes[var151]].equals("")) {
                              this.str.append("\" + JDPMaskEditMain.stripFloat(" + this.fields[var151] + ") + ");
                           } else if (JDPUtils.isOdbcDate(this.dataType[var151])) {
                              this.str.append(this.fields[var151] + ".getText()");
                           } else if (JDPUtils.isOdbcBinary(this.dataType[var151])) {
                              this.str.append("\" + " + this.fields[var151] + ".getText() + ");
                           } else if (var13) {
                              this.str.append("\" + user.u.replace(" + this.fields[var151] + ".getText(),\"'\",\"''\") + ");
                           } else {
                              this.str.append("\" + JDPUtils.tonum(" + this.fields[var151] + ".getText()) + ");
                           }

                           if (!JDPUtils.isOdbcDate(this.dataType[var151])) {
                              this.str.append("\"");
                              if (var13) {
                                 this.str.append("'");
                              }
                           }

                           this.str.append(var196);
                        }
                     }
                  }

                  String var14 = this.targetSettings.lockingColumn.getSelectedItem();
                  if (var14 != null && !var14.equals("")) {
                     if (var14.indexOf(".") > 0) {
                        var14 = var14.substring(2);
                     }

                     this.str.append("\" +\r\n\t\t\t\t\t\"," + var14 + " = " + var14 + " + 1");
                  }

                  this.str.append("\" +\r\n\t\t\t\t\t\" WHERE ");

                  for(int var152 = 0; var152 < this.keysUpdate.length; ++var152) {
                     if (var152 > 0) {
                        this.str.append(" +\r\n\t\t\t\t\t\" AND ");
                     }

                     if (this.keysSQLUpdate[var152].indexOf(".") > 0) {
                        this.str.append(this.cvtKey(this.keysSQLUpdate[var152].substring(2), this.keyDataTypeUpdate[var152]) + "=");
                     } else {
                        this.str.append(this.cvtKey(this.keysSQLUpdate[var152], this.keyDataTypeUpdate[var152]) + "=");
                     }

                     String var182 = this.getQuote(this.keyDataTypeUpdate[var152]);
                     this.str.append(var182);
                     if (JDPUtils.isOdbcBinary(this.keyDataTypeUpdate[var152])) {
                        this.str.append("0x");
                     }

                     if (!this.layoutName.equals("JDPLayout11") && !this.layoutName.equals("JDPLayout21") && !this.layoutName.equals("JDPLayout23")) {
                        this.str.append("\" + searchResults.recordKey" + Integer.toString(var152) + "[itemIndex]");
                     } else {
                        this.str.append("\" + keys[" + Integer.toString(var152) + "]");
                     }

                     this.str.append("+ \"");
                     this.str.append(var182);
                     this.str.append("\" ");
                  }

                  this.str.append(this.stoken[1]);
                  var14 = this.targetSettings.lockingColumn.getSelectedItem();
                  if (var14 != null && !var14.equals("")) {
                     String var153 = "";
                     if (this.targetSettings.thisBranch != null) {
                        var153 = this.targetSettings.thisBranch.name;
                     }

                     if (var14.indexOf(".") > 0) {
                        var14 = var14.substring(2);
                     }

                     this.str.append("\t\t\t\tprevSQL = SQL;\r\n\t\t\t\tif (" + var153 + this.user.u.strip(var14) + "Lock != null) {\r\n\t\t\t\t\t");
                     this.str.append("SQL += \" AND " + var14 + " = \" + " + var153 + this.user.u.strip(var14) + "Lock");
                     this.str.append(";\r\n\t\t\t\t}\r\n");
                  }
                  break;
               case 37:
                  for(int var150 = 0; var150 < this.fields.length; ++var150) {
                     if (this.indexes[var150] < this.targetSettings.fieldType.length) {
                        if (!this.targetSettings.fieldType[this.indexes[var150]].equals("TextField") && !this.targetSettings.fieldType[this.indexes[var150]].equals("TextArea") && !this.targetSettings.fieldType[this.indexes[var150]].equals("JDPComboBox") && !this.targetSettings.fieldType[this.indexes[var150]].equals("JDPSpinner") && !this.targetSettings.fieldType[this.indexes[var150]].equals("JDPDate")) {
                           if (this.targetSettings.fieldType[this.indexes[var150]].equals("JDPChoice")) {
                              this.str.append(this.stoken[0] + this.fields[var150] + ".select(0);\r\n");
                           } else if (this.targetSettings.fieldType[this.indexes[var150]].equals("Checkbox")) {
                              this.str.append(this.stoken[0] + this.fields[var150] + ".setState(false);\r\n");
                           }
                        } else if (this.layoutName.equals("JDPLayout3")) {
                           this.str.append(this.stoken[0] + "if ((" + this.fields[var150] + ".isEditable()) || clearKey) " + this.fields[var150] + this.stoken[1] + this.targetSettings.fieldDefault[this.indexes[var150]] + this.stoken[2]);
                        } else {
                           this.str.append(this.stoken[0] + this.fields[var150] + this.stoken[1] + this.targetSettings.fieldDefault[this.indexes[var150]] + this.stoken[2]);
                        }

                        if (this.targetSettings.fieldType[this.indexes[var150]].equals("RadioButtons")) {
                           this.str.append(this.stoken[0] + this.fields[var150] + ".setState(false);\r\n");

                           for(int var180 = 1; var180 < JDPChoiceLayout.maxChoices; ++var180) {
                              if (this.targetSettings.thisChoicePanel.textChoiceValue[this.indexes[var150]][var180].trim().length() > 0) {
                                 this.str.append(this.stoken[0] + this.fields[var150] + Integer.toString(var180) + ".setState(false);\r\n");
                              }
                           }
                        }
                     }
                  }
                  break;
               case 39:
                  for(int var149 = 0; var149 < this.fields.length; ++var149) {
                     if (this.indexes[var149] < this.targetSettings.fieldTextColor.length) {
                        String var178 = this.targetSettings.fieldTextColor[this.indexes[var149]];
                        var178 = var178.substring(0, 1).toLowerCase() + var178.substring(1);
                        if (this.targetSettings.fieldType[this.indexes[var149]].equals("RadioButtons")) {
                           this.str.append(this.stoken[0] + this.fields[var149] + this.stoken[1] + var178 + this.stoken[2]);

                           for(int var195 = 1; var195 < JDPChoiceLayout.maxChoices; ++var195) {
                              if (this.targetSettings.thisChoicePanel.textChoiceValue[this.indexes[var149]][var195].trim().length() > 0) {
                                 this.str.append(this.stoken[0] + this.fields[var149] + Integer.toString(var195) + this.stoken[1] + var178 + this.stoken[2]);
                              }
                           }
                        } else {
                           this.str.append(this.stoken[0] + this.fields[var149] + this.stoken[1] + var178 + this.stoken[2]);
                        }
                     }
                  }
                  break;
               case 40:
                  for(int var148 = 0; var148 < this.fields.length; ++var148) {
                     if (this.indexes[var148] < this.targetSettings.fieldBackColor.length) {
                        String var176 = this.targetSettings.fieldBackColor[this.indexes[var148]];
                        if (!this.targetSettings.fieldType[this.indexes[var148]].equals("TextArea") && !this.targetSettings.fieldType[this.indexes[var148]].equals("Checkbox") && !this.targetSettings.fieldType[this.indexes[var148]].equals("RadioButtons") && !this.targetSettings.fieldType[this.indexes[var148]].equals("JDPDate") || !var176.equals("White")) {
                           var176 = var176.substring(0, 1).toLowerCase() + var176.substring(1);
                           this.str.append(this.stoken[0] + this.fields[var148] + this.stoken[1] + var176 + this.stoken[2]);
                        }

                        if (this.targetSettings.fieldType[this.indexes[var148]].equals("Checkbox")) {
                           this.str.append(this.stoken[0] + this.fields[var148] + ".setFont(user.boldFont" + this.stoken[2]);
                        }

                        if (this.targetSettings.fieldType[this.indexes[var148]].equals("RadioButtons")) {
                           this.str.append(this.stoken[0] + this.fields[var148] + ".setFont(user.boldFont" + this.stoken[2]);

                           for(int var194 = 1; var194 < JDPChoiceLayout.maxChoices; ++var194) {
                              if (this.targetSettings.thisChoicePanel.textChoiceValue[this.indexes[var148]][var194].trim().length() > 0) {
                                 this.str.append(this.stoken[0] + this.fields[var148] + Integer.toString(var194) + ".setFont(user.boldFont" + this.stoken[2]);
                              }
                           }
                        }
                     }
                  }
                  break;
               case 41:
                  for(int var147 = 0; var147 < this.fields.length; ++var147) {
                     if (this.indexes[var147] < this.targetSettings.fieldType.length && (this.targetSettings.fieldType[this.indexes[var147]].equals("TextField") || this.targetSettings.fieldType[this.indexes[var147]].equals("TextArea") || this.targetSettings.fieldType[this.indexes[var147]].equals("JDPComboBox") || this.targetSettings.fieldType[this.indexes[var147]].equals("JDPSpinner") || this.targetSettings.fieldType[this.indexes[var147]].equals("JDPDate"))) {
                        this.str.append(this.stoken[0] + this.fields[var147] + this.stoken[1]);
                     }
                  }
                  break;
               case 42:
                  for(int var146 = 0; var146 < this.fields.length; ++var146) {
                     if (this.indexes[var146] < this.targetSettings.fieldType.length) {
                        if (!this.targetSettings.fieldType[this.indexes[var146]].equals("TextField") && !this.targetSettings.fieldType[this.indexes[var146]].equals("TextArea") && !this.targetSettings.fieldType[this.indexes[var146]].equals("JDPComboBox") && !this.targetSettings.fieldType[this.indexes[var146]].equals("JDPSpinner") && !this.targetSettings.fieldType[this.indexes[var146]].equals("JDPDate")) {
                           if ((this.targetSettings.fieldType[this.indexes[var146]].equals("JDPChoice") || this.targetSettings.fieldType[this.indexes[var146]].equals("Checkbox")) && this.layoutName.equals("JDPLayout3")) {
                              this.str.append(this.stoken[0] + this.fields[var146] + ".disable(" + this.stoken[2]);
                           }
                        } else if (this.targetSettings.fieldEditable[this.indexes[var146]].equals("No")) {
                           this.str.append(this.stoken[0] + this.fields[var146] + this.stoken[1] + "false" + this.stoken[2]);
                        }

                        if (this.targetSettings.fieldType[this.indexes[var146]].equals("RadioButtons") && this.layoutName.equals("JDPLayout3")) {
                           this.str.append(this.stoken[0] + this.fields[var146] + ".disable(" + this.stoken[2]);

                           for(int var175 = 1; var175 < JDPChoiceLayout.maxChoices; ++var175) {
                              if (this.targetSettings.thisChoicePanel.textChoiceValue[this.indexes[var146]][var175].trim().length() > 0) {
                                 this.str.append(this.stoken[0] + this.fields[var146] + Integer.toString(var175) + ".disable(" + this.stoken[2]);
                              }
                           }
                        }
                     }
                  }
                  break;
               case 46:
                  for(int var71 = 0; var71 < this.buttons.length; ++var71) {
                     if (this.buttons[var71] != null) {
                        this.str.append(this.stoken[0]);
                        this.str.append(Integer.toString(var71));
                        this.str.append(this.stoken[1]);
                        this.str.append(this.buttons[var71]);
                        this.str.append(this.stoken[2]);
                        this.str.append(this.buttonsText[var71]);
                        this.str.append(this.stoken[3]);
                     }
                  }
                  break;
               case 47:
                  this.str.append(this.stoken[0] + this.iconsText + this.stoken[1]);
                  break;
               case 48:
                  for(int var145 = 0; var145 < this.fields.length; ++var145) {
                     if (this.indexes[var145] < this.targetSettings.fieldType.length) {
                        this.str.append(this.stoken[0] + this.fields[var145] + this.stoken[1] + this.targetSettings.mousePtrText[this.indexes[var145]]);
                        this.str.append(this.stoken[2] + this.targetSettings.statusBarText[this.indexes[var145]] + this.stoken[3]);
                     }
                  }
                  break;
               case 49:
                  for(int var144 = 0; var144 < this.indexes2.length; ++var144) {
                     if (this.indexes2[var144] >= 0) {
                        int var174 = this.indexes2[var144];
                        if (this.targetGridSettings.fieldType[var174].equals("JDPChoice") || this.targetGridSettings.fieldType[var174].equals("JDPComboBox")) {
                           this.str.append(this.stoken[0] + Integer.toString(var144) + this.stoken[1]);
                        }
                     }
                  }
                  break;
               case 50:
                  for(int var143 = 0; var143 < this.indexes2.length; ++var143) {
                     if (this.indexes2[var143] >= 0) {
                        int var173 = this.indexes2[var143];
                        if ((this.targetGridSettings.fieldType[var173].equals("JDPChoice") || this.targetGridSettings.fieldType[var173].equals("JDPComboBox")) && this.targetGridSettings.thisChoicePanel.valuesFrom[var173].equals("Fields entered here")) {
                           if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                              this.str.append("\r\n\t\tvalue" + this.user.u.strip(this.targetGridSettings.columns.getItem(var173)) + " = new Vector(); \r\n");
                           } else {
                              this.str.append("\r\n\t\ttableContents.pullDownValue[" + Integer.toString(var143) + "][0] = new Vector(); \r\n");
                           }

                           int var193 = 0;

                           for(int var200 = 0; var200 < JDPChoiceLayout.maxChoices; ++var200) {
                              if (this.targetGridSettings.thisChoicePanel.textChoiceValue[var173][var200] != null && this.targetGridSettings.thisChoicePanel.textChoiceValue[var173][var200].trim().length() > 0 || var200 == 0) {
                                 this.str.append("\t\ttableContents.pullDownList[" + Integer.toString(var143) + "][0].addItem(\"");
                                 this.str.append(this.targetGridSettings.thisChoicePanel.textChoiceValue[var173][var200] + "\"); \r\n");
                                 if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                                    this.str.append("\t\tvalue" + this.user.u.strip(this.targetGridSettings.columns.getItem(var173)) + ".addElement(\"" + this.targetGridSettings.thisChoicePanel.actualChoiceValue[var173][var200] + "\"); \r\n");
                                 } else {
                                    this.str.append("\t\ttableContents.pullDownValue[" + Integer.toString(var143) + "][0].addElement(\"" + this.targetGridSettings.thisChoicePanel.actualChoiceValue[var173][var200] + "\"); \r\n");
                                 }

                                 ++var193;
                              }
                           }
                        }
                     }
                  }
                  break;
               case 51:
                  for(int var142 = 0; var142 < this.indexes2.length; ++var142) {
                     if (this.indexes2[var142] >= 0) {
                        int var172 = this.indexes2[var142];
                        if ((this.targetGridSettings.fieldType[var172].equals("JDPChoice") || this.targetGridSettings.fieldType[var172].equals("JDPComboBox")) && this.targetGridSettings.thisChoicePanel.valuesFrom[var172].equals("Database table/columns")) {
                           if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                              this.str.append("\r\n\t\tvalue" + this.user.u.strip(this.targetGridSettings.columns.getItem(var172)) + " = new Vector(); \r\n");
                           } else {
                              this.str.append("\r\n\t\ttableContents.pullDownValue[" + Integer.toString(var142) + "][0] = new Vector(); \r\n");
                           }

                           this.str.append(this.stoken[0] + Integer.toString(var142) + this.stoken[1]);
                           this.str.append(this.targetGridSettings.thisChoicePanel.textChoiceSql[var172] + this.stoken[2]);
                           this.str.append(this.targetGridSettings.thisChoicePanel.columnActualList[var172] + this.stoken[3]);
                           this.str.append(this.targetGridSettings.thisChoicePanel.tableList[var172] + this.stoken[4]);
                           this.str.append(this.targetGridSettings.thisChoicePanel.tableWhereClause[var172] + this.stoken[5]);
                           if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                              this.str.append(this.user.u.strip(this.targetGridSettings.columns.getItem(var172)) + this.stoken[6]);
                           } else {
                              this.str.append(Integer.toString(var142) + this.stoken[6]);
                           }
                        }
                     }
                  }
                  break;
               case 52:
                  for(int var141 = 0; var141 < this.indexes2.length; ++var141) {
                     if (this.indexes2[var141] >= 0) {
                        int var171 = this.indexes2[var141];
                        if (this.targetGridSettings.fieldType[var171].equals("Choice")) {
                           this.str.append(this.stoken[0] + this.user.u.strip(this.targetGridSettings.columns.getItem(var171)) + this.stoken[1]);
                        }
                     }
                  }
                  break;
               case 53:
                  for(int var140 = 0; var140 < this.indexes2.length; ++var140) {
                     String var170 = Integer.toString(var140);
                     if (this.indexes2[var140] >= 0) {
                        int var192 = this.indexes2[var140];
                        if (this.targetGridSettings.fieldType[var192].equals("JDPChoice")) {
                           if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                              String var22 = this.user.u.strip(this.targetGridSettings.columns.getItem(var192));
                              this.str.append(this.stoken[0] + var170 + this.stoken[1] + var22 + this.stoken[2] + var170 + this.stoken[3] + var22 + this.stoken[4]);
                           } else {
                              this.str.append(this.stoken[0] + var170 + this.stoken[1] + var170 + this.stoken[2] + var170 + this.stoken[3] + var170 + this.stoken[4]);
                           }
                        } else if (this.targetGridSettings.fieldType[var192].equals("JDPDate")) {
                           if (!this.layoutName.equals("JDPLayout4") && !this.layoutName.equals("JDPLayout14") && !this.layoutName.equals("JDPLayout24")) {
                              this.str.append("\t\t\t\t\tif (iy == " + var170 + ") tableContents.currentText[iy][ix] = JDPDate.format(Long.valueOf(tempText).longValue());\r\n");
                           } else {
                              this.str.append(this.stoken[0] + "if (iy == " + var170 + ") tableContents.currentText[iy][ix+xOffset] = JDPDate.format(Long.valueOf(tempText).longValue());\r\n");
                           }
                        }
                     }
                  }
                  break;
               case 55:
                  this.str.append(this.stoken[0]);
                  if (this.targetList != null) {
                     this.str.append(Integer.toString(this.targetList.mainBranchIcon.getSelectedIndex()));
                     this.str.append("," + Integer.toString(this.targetList.mainIcon.getSelectedIndex()));

                     for(int var139 = 0; var139 < this.targetList.includeTree.countItems(); ++var139) {
                        this.str.append(",");
                        this.str.append(Integer.toString(this.targetList.iconList[var139]));
                     }
                  }

                  this.str.append(this.stoken[1]);
                  break;
               case 56:
                  this.str.append(this.stoken[0]);
                  if (this.targetList != null && this.user.u.isnumeric(this.targetList.treeMinWidth, this.user.mainmsg)) {
                     this.str.append(this.targetList.treeMinWidth.getText());
                  } else {
                     this.str.append("150");
                  }

                  this.str.append(this.stoken[1]);
                  break;
               case 57:
                  this.str.append(this.stoken[0]);
                  if (this.targetList != null) {
                     this.str.append("\"" + this.targetList.mainBranchText.getText() + "\"");
                  }

                  this.str.append(this.stoken[1]);
                  break;
               case 58:
                  this.str.append(this.stoken[0] + Integer.toString(this.targetScreen.centerTopPanel.length) + this.stoken[1]);
                  break;
               case 59:
                  for(int var70 = 0; var70 < this.targetScreen.centerTopPanel.length; ++var70) {
                     this.str.append(this.stoken[0] + Integer.toString(var70) + this.stoken[1]);
                  }
                  break;
               case 60:
                  this.str.append(this.stoken[0]);
                  if (this.targetScreen.titles != null && this.targetScreen.titles[0] != null) {
                     for(int var12 = 0; var12 < this.targetScreen.centerTopPanel.length; ++var12) {
                        if (var12 > 0) {
                           this.str.append(",");
                        }

                        this.str.append("\"" + this.targetScreen.titles[var12] + "\"");
                     }
                  }

                  this.str.append(this.stoken[1]);
                  break;
               case 61:
                  for(int var138 = 0; var138 < this.fields.length; ++var138) {
                     if (this.indexes[var138] < this.targetSettings.fieldType.length && (this.targetSettings.fieldType[this.indexes[var138]].equals("JDPChoice") || this.targetSettings.fieldType[this.indexes[var138]].equals("JDPComboBox")) && this.targetSettings.thisChoicePanel.valuesFrom[this.indexes[var138]].equals("Fields entered here")) {
                        int var169 = 0;

                        for(int var191 = 0; var191 < JDPChoiceLayout.maxChoices; ++var191) {
                           if (this.targetSettings.thisChoicePanel.textChoiceValue[this.indexes[var138]][var191].trim().length() > 0 || var191 == 0) {
                              this.str.append("\t\t" + this.user.u.strip(this.fields[var138]) + ".addItem(\"");
                              this.str.append(this.targetSettings.thisChoicePanel.textChoiceValue[this.indexes[var138]][var191]);
                              if (this.targetSettings.fieldType[this.indexes[var138]].equals("JDPChoice")) {
                                 this.str.append("\",\"" + this.targetSettings.thisChoicePanel.actualChoiceValue[this.indexes[var138]][var191]);
                              }

                              this.str.append("\"); \r\n");
                              ++var169;
                           }
                        }
                     }
                  }
                  break;
               case 62:
                  if (!this.layoutName.equals("JDPLayout16") && !this.layoutName.equals("JDPLayout17") && !this.layoutName.equals("JDPLayout18")) {
                     for(int var137 = 0; var137 < this.fields.length; ++var137) {
                        if (this.indexes[var137] < this.targetSettings.fieldType.length) {
                           if (this.targetSettings.fieldType[this.indexes[var137]].equals("JDPChoice") && this.targetSettings.thisChoicePanel.valuesFrom[this.indexes[var137]].equals("Database table/columns")) {
                              this.str.append(this.stoken[0] + this.user.u.strip(this.fields[var137]) + this.stoken[1]);
                              this.str.append(this.targetSettings.thisChoicePanel.textChoiceSql[this.indexes[var137]] + this.stoken[2]);
                              this.str.append(this.targetSettings.thisChoicePanel.columnActualList[this.indexes[var137]] + this.stoken[3]);
                              this.str.append(this.targetSettings.thisChoicePanel.tableList[this.indexes[var137]] + this.stoken[4]);
                              this.str.append(this.targetSettings.thisChoicePanel.tableWhereClause[this.indexes[var137]] + this.stoken[5]);
                           }

                           if (this.targetSettings.fieldType[this.indexes[var137]].equals("JDPComboBox") && this.targetSettings.thisChoicePanel.valuesFrom[this.indexes[var137]].equals("Database table/columns")) {
                              this.str.append(this.stoken[0] + this.user.u.strip(this.fields[var137]) + this.stoken[1]);
                              this.str.append(this.targetSettings.thisChoicePanel.textChoiceSql[this.indexes[var137]] + this.stoken[2]);
                              this.str.append(this.targetSettings.thisChoicePanel.textChoiceSql[this.indexes[var137]] + this.stoken[3]);
                              this.str.append(this.targetSettings.thisChoicePanel.tableList[this.indexes[var137]] + this.stoken[4]);
                              this.str.append(this.targetSettings.thisChoicePanel.tableWhereClause[this.indexes[var137]] + this.stoken[5]);
                           }
                        }
                     }
                  } else if (this.targetChoice.valuesfrom.getSelectedItem().equals("Database table/columns")) {
                     if (!this.layoutName.equals("JDPLayout18")) {
                        this.str.append(this.stoken[0] + this.targetChoice.textchoicesql.getText() + this.stoken[1]);
                        this.str.append(this.targetChoice.columnactuallist.getSelectedItem() + this.stoken[2]);
                        this.str.append(this.targetChoice.tablelist.getSelectedItem() + this.stoken[3]);
                        this.str.append(this.targetChoice.tablewhereclause.getText() + this.stoken[4]);
                     } else {
                        this.str.append(this.stoken[0] + this.targetChoice.textchoicesql.getText() + this.stoken[1]);
                        this.str.append(this.targetChoice.tablelist.getSelectedItem() + this.stoken[2]);
                        this.str.append(this.targetChoice.tablewhereclause.getText() + this.stoken[3]);
                     }
                  }
                  break;
               case 63:
                  for(int var136 = 0; var136 < this.targetSettings.columns.countItems(); ++var136) {
                     int var168 = this.targetColumns.columnDatatype[this.targetSettings.columnIndexes[var136]];
                     boolean var190 = this.targetColumns.columnIsIdentity[this.targetSettings.columnIndexes[var136]];
                     if ((this.targetSettings.fieldType[var136].equals("TextField") || this.targetSettings.fieldType[var136].equals("TextArea") || this.targetSettings.fieldType[var136].equals("JDPSpinner")) && !var190 && this.targetSettings.actualCompName[var136] != null && !this.targetSettings.actualCompName[var136].equals("")) {
                        if (JDPUtils.isOdbcChar(var168) && this.targetSettings.fieldRequired[var136].equals("Yes")) {
                           this.str.append(this.stoken[0] + "ischaracter" + this.stoken[1] + this.targetSettings.actualCompName[var136] + this.stoken[2] + this.targetSettings.fieldErrorMsg[var136] + this.stoken[3]);
                        }

                        if (JDPUtils.isOdbcInt(var168) && this.targetSettings.fieldRequired[var136].equals("Yes")) {
                           this.str.append(this.stoken[0] + "isnumeric" + this.stoken[1] + this.targetSettings.actualCompName[var136] + this.stoken[2] + this.targetSettings.fieldErrorMsg[var136] + this.stoken[3]);
                        }

                        if (JDPUtils.isOdbcFloat(var168) && this.targetSettings.fieldRequired[var136].equals("Yes")) {
                           this.str.append(this.stoken[0] + "isfloat" + this.stoken[1] + this.targetSettings.actualCompName[var136] + this.stoken[2] + this.targetSettings.fieldErrorMsg[var136] + this.stoken[3]);
                        }

                        if (JDPUtils.isOdbcDate(var168) && this.targetSettings.fieldRequired[var136].equals("Yes")) {
                           this.str.append(this.stoken[0] + "isvalidDate" + this.stoken[1] + this.targetSettings.actualCompName[var136] + this.stoken[2] + this.targetSettings.fieldErrorMsg[var136] + this.stoken[3]);
                        }
                     }
                  }
                  break;
               case 64:
                  if (this.targetChoice.valuesfrom.getSelectedItem().equals("Fields entered here")) {
                     this.str.append(this.stoken[0]);

                     for(int var135 = 0; var135 < JDPChoiceLayout.maxChoices; ++var135) {
                        if (var135 > 0) {
                           this.str.append(",");
                        }

                        this.str.append("\"" + this.targetChoice.textchoicevalue[var135].getText() + "\"");
                     }

                     this.str.append(this.stoken[1]);
                  }
                  break;
               case 65:
                  if (this.targetChoice.valuesfrom.getSelectedItem().equals("Fields entered here")) {
                     this.str.append(this.stoken[0]);

                     for(int var134 = 0; var134 < JDPChoiceLayout.maxChoices; ++var134) {
                        if (var134 > 0) {
                           this.str.append(",");
                        }

                        this.str.append("\"" + this.targetChoice.actualchoicevalue[var134].getText() + "\"");
                     }

                     this.str.append(this.stoken[1]);
                  }
                  break;
               case 66:
                  if (this.targetChoice.valuesfrom.getSelectedItem().equals("Fields entered here")) {
                     this.str.append(this.stoken[0]);
                  }
                  break;
               case 67:
               case 68:
                  for(int var133 = 0; var133 < this.fields.length; ++var133) {
                     if (this.indexes[var133] < this.targetSettings.fieldType.length) {
                        int var167 = this.targetColumns.columnDatatype[this.targetSettings.columnIndexes[this.indexes[var133]]];
                        if ((this.targetSettings.fieldType[this.indexes[var133]].equals("TextField") || this.targetSettings.fieldType[this.indexes[var133]].equals("TextArea") || this.targetSettings.fieldType[this.indexes[var133]].equals("JDPComboBox") || this.targetSettings.fieldType[this.indexes[var133]].equals("JDPSpinner") || this.targetSettings.fieldType[this.indexes[var133]].equals("JDPDate")) && !this.targetSettings.fieldEditMask[this.indexes[var133]].equals("")) {
                           if (this.lineIndex == 67) {
                              if (JDPUtils.isOdbcNum(var167)) {
                                 this.str.append(this.stoken[0] + "Float" + this.stoken[1]);
                              } else {
                                 this.str.append(this.stoken[0] + "String" + this.stoken[1]);
                              }

                              this.str.append(this.fields[var133] + this.stoken[2] + this.targetSettings.fieldEditMask[this.indexes[var133]] + this.stoken[3]);
                           } else if (this.lineIndex == 68) {
                              if (JDPUtils.isOdbcNum(var167)) {
                                 this.str.append(this.stoken[0] + this.fields[var133] + this.stoken[1] + "Float" + this.stoken[2]);
                              } else {
                                 this.str.append(this.stoken[0] + this.fields[var133] + this.stoken[1] + "String" + this.stoken[2]);
                              }

                              this.str.append(this.fields[var133] + this.stoken[3] + this.targetSettings.fieldEditMask[this.indexes[var133]] + this.stoken[4]);
                           }
                        }
                     }
                  }
                  break;
               case 69:
                  for(int var132 = 0; var132 < this.updatefields.length; ++var132) {
                     int var166 = this.gridDataType[this.updateindexes[var132]];
                     if (this.indexes2[var132] < this.targetGridSettings.fieldType.length && this.targetGridSettings.fieldType[this.indexes2[var132]].equals("TextField") && !this.targetGridSettings.fieldEditMask[this.indexes2[var132]].equals("") && this.lineIndex == 69) {
                        this.str.append(this.stoken[0] + Integer.toString(var132) + this.stoken[1]);
                        if (JDPUtils.isOdbcNum(var166)) {
                           this.str.append("Float" + this.stoken[2]);
                        } else {
                           this.str.append("String" + this.stoken[2]);
                        }

                        this.str.append(this.targetGridSettings.fieldEditMask[this.indexes2[var132]] + this.stoken[3]);
                     }
                  }
                  break;
               case 70:
                  for(int var131 = 0; var131 < this.indexes2.length; ++var131) {
                     if (this.indexes2[var131] >= 0) {
                        int var165 = this.indexes2[var131];
                        if (this.targetGridSettings.fieldType[var165].equals("JDPDate")) {
                           this.str.append(this.stoken[0] + Integer.toString(var131) + this.stoken[1]);
                        }
                     }
                  }
                  break;
               case 71:
                  for(int var19 = 0; var19 < this.indexes2.length; ++var19) {
                     String var20 = Integer.toString(var19);
                     if (this.indexes2[var19] >= 0) {
                        int var21 = this.indexes2[var19];
                        if (this.targetGridSettings.fieldType[var21].equals("Checkbox")) {
                           this.str.append(this.stoken[0] + var20 + this.stoken[1] + this.targetGridSettings.checkedValue[var21] + this.stoken[2]);
                        }
                     }
                  }
                  break;
               default:
                  this.str.append(var1);
            }

            return this.str.toString();
         }
      }
   }

   void retrieveVectors() {
      for(int var1 = 0; var1 < this.user.gParm.size(); ++var1) {
         if (this.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)this.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).equals("SelectDSN")) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
               this.dataSource = this.targetDSN.datasource.getText();
               this.connectString = this.targetDSN.connectstring.getText();
            }

            if (((String)var2.elementAt(0)).equals("SelectTable")) {
               this.targetTable = (JDPSelectTable)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("SelectColumns")) {
               this.targetColumns = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("SearchLayout")) {
               this.targetSearch = (JDPSearchLayout)var2.elementAt(1);
               if (this.targetSearch.columns.getSelectedItems().length == 0) {
                  this.targetSearch = null;
               }
            }

            if (((String)var2.elementAt(0)).equals("ListLayout")) {
               this.targetList = (JDPListLayout)var2.elementAt(1);
               if (this.targetList.columns.getSelectedItems().length == 0) {
                  this.targetList = null;
               }
            }

            if (((String)var2.elementAt(0)).equals("ScreenLayout")) {
               this.targetScreen = (JDPScreenLayout)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("ScreenSettings")) {
               this.targetSettings = (JDPScreenSettings)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("GridSettings")) {
               this.targetGridSettings = (JDPGridSettings)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("SelectReportDef")) {
               this.targetReportDef = (JDPSelectReportDef)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("SelectChartDef")) {
               this.targetChartDef = (JDPSelectChartDef)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("ChartLayout")) {
               this.targetChart = (JDPChartLayout)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("GridLayout")) {
               this.targetGrid = (JDPGridLayout)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).equals("ChoiceLayout")) {
               this.targetChoice = (JDPChoiceLayout)var2.elementAt(1);
            }
         }
      }

      if (this.targetDSN != null && this.targetDSN.usernameChoice != null && this.targetDSN.usernameChoice.getSelectedIndex() == 1) {
         this.connectString = this.user.u.replace(this.connectString, "UID=" + this.targetDSN.userid.getText(), "UID=\" + user.cust.username + \"");
         this.connectString = this.user.u.replace(this.connectString, "PWD=" + this.targetDSN.password.getText(), "PWD=\" + user.cust.password + \"");
      }

   }

   String parseLine100(String var1, String[] var2, int var3) {
      boolean var4 = false;
      switch (var3) {
         case 100:
            this.str.append(var2[0] + "\"SELECT ");
            String var41 = this.targetGridSettings.lockingColumn.getSelectedItem();
            if (var41 != null && !var41.equals("")) {
               this.str.append(var41);
               if (this.user.u.sqlRequiresChange(this.targetDSN.jaggSQL, 0)) {
                  this.str.append(" l" + var41);
               }

               this.str.append(",\" +\r\n\t\t\t\t\t\"");
            }

            var4 = true;
            if (!this.layoutName.equals("JDPLayout4") && !this.layoutName.equals("JDPLayout14") && !this.layoutName.equals("JDPLayout24")) {
               for(int var9 = 0; var9 < this.keysSQLUpdate.length; ++var9) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  this.str.append(this.keysSQLUpdate[var9]);
                  var4 = false;
               }
            }

            for(int var42 = 0; var42 < this.fieldSql.length; ++var42) {
               if (!var4) {
                  this.str.append(", \" +\r\n\t\t\t\t\t\"");
               }

               this.str.append(this.fieldSql[var42]);
               var4 = false;
            }

            this.str.append(" FROM ");
            String var43 = null;
            String var10 = "";

            for(int var11 = 0; var11 < this.targetTable.joinConditions.countItems(); ++var11) {
               if (this.targetTable.joinConditions.getItem(var11).indexOf("*=") > 0) {
                  var43 = "left";
                  var10 = this.targetTable.joinConditions.getItem(var11);
               }

               if (this.targetTable.joinConditions.getItem(var11).indexOf("=*") > 0) {
                  var43 = "right";
                  var10 = this.targetTable.joinConditions.getItem(var11);
               }
            }

            String var44 = "";
            String var12 = "";
            var4 = true;
            int[] var5 = this.targetTable.stables.getSelectedIndexes();
            var44 = this.targetTable.tables.getSelectedItem();
            if (var5.length > 0) {
               var44 = var44 + " a";
            }

            if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
               var44 = var44 + " (NOLOCK)";
            }

            for(int var72 = 0; var72 < var5.length; ++var72) {
               if (var43 == null) {
                  var12 = var12 + ",";
               }

               var12 = var12 + this.targetTable.stables.getItem(var5[var72]);
               var12 = var12 + " " + this.targetTable.stableAlias[var5[var72]];
               if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                  var12 = var12 + " (NOLOCK)";
               }
            }

            if (var43 == null) {
               this.str.append(var44);
               this.str.append(var12);
            } else if (var43.equals("left")) {
               this.str.append("{oj ");
               this.str.append(var44);
               this.str.append(" LEFT OUTER JOIN ");
               this.str.append(var12);
               this.str.append(" ON ");
               this.str.append(this.user.u.replace(var10, "*", ""));
               this.str.append("}");
            } else if (var43.equals("right")) {
               this.str.append("{oj ");
               this.str.append(var12);
               this.str.append(" LEFT OUTER JOIN ");
               this.str.append(var44);
               this.str.append(" ON ");
               this.str.append(this.user.u.replace(var10, "*", ""));
               this.str.append("}");
            }

            this.str.append(" WHERE ");
            if (this.targetGridSettings != null && this.targetGridSettings.pfromwhereclause.getText().length() != 0) {
               this.str.append(this.targetGridSettings.pfromwhereclause.getText() + " ");
            } else {
               this.str.append("(1=1) ");
            }

            if (this.targetTable.joinConditions.countItems() > 0) {
               for(int var73 = 0; var73 < this.targetTable.joinConditions.countItems(); ++var73) {
                  if (!this.targetTable.joinConditions.getItem(var73).equals(var10)) {
                     this.str.append(" AND " + this.targetTable.joinConditions.getItem(var73));
                  }
               }
            }

            if (this.targetSearch != null) {
               if (this.layoutName.equals("JDPLayout2")) {
                  this.str.append(" AND \" + jdpWhereClause.whereClause");
               } else if (this.layoutName.equals("JDPLayout4")) {
                  this.str.append(" AND \" + jdpWhereClause.whereClause");
               } else {
                  this.str.append(" \"");
               }
            } else {
               this.str.append(" \"");
            }

            if (this.layoutName.equals("JDPLayout3")) {
               var4 = true;
               if (this.targetList != null) {
                  for(int var74 = 0; var74 < this.keys.length; ++var74) {
                     if (this.targetList.uniqueTree.isSelected(var74)) {
                        this.str.append(" +\r\n\t\t\t\t\t\t\t\" AND ");
                        var4 = false;
                        this.str.append(this.cvtKey(this.keysSQL[var74], this.keyDataType[var74]) + "=");
                        String var95 = this.getQuote(this.keyDataType[var74]);
                        this.str.append(var95);
                        if (JDPUtils.isOdbcBinary(this.keyDataType[var74])) {
                           this.str.append("0x");
                        }

                        this.str.append("\" + searchResults.recordKey" + Integer.toString(var74) + "[itemIndex]");
                        this.str.append("+ \"");
                        this.str.append(var95);
                        this.str.append("\" ");
                     }
                  }
               }
            }

            if (this.layoutName.equals("JDPLayout12") || this.layoutName.equals("JDPLayout14") || this.layoutName.equals("JDPLayout22") || this.layoutName.equals("JDPLayout23") || this.layoutName.equals("JDPLayout24")) {
               for(int var75 = 0; var75 < this.keys.length; ++var75) {
                  this.str.append(";\r\n\t\tif (keys.length > " + Integer.toString(var75) + " && keys[" + Integer.toString(var75) + "] != null) SQL += \" AND " + this.cvtKey(this.keysSQL[var75], this.keyDataType[var75]) + "=");
                  String var96 = this.getQuote(this.keyDataType[var75]);
                  this.str.append(var96);
                  if (JDPUtils.isOdbcBinary(this.keyDataType[var75])) {
                     this.str.append("0x");
                  }

                  this.str.append("\" + keys[" + Integer.toString(var75) + "]");
                  this.str.append("+ \"");
                  this.str.append(var96);
                  this.str.append("\" ");
               }
            }

            if (this.layoutName.equals("JDPLayout4") || this.layoutName.equals("JDPLayout14") || this.layoutName.equals("JDPLayout24")) {
               if (this.layoutName.equals("JDPLayout14") || this.layoutName.equals("JDPLayout24")) {
                  this.str.append("; \r\n\t\tif (whereClause != null) {\n\t\t\tSQL += whereClause;\n\t\t}");
               }

               int var76 = this.targetReportDef.groupBy.countItems();

               for(int var97 = 0; var97 < var76; ++var97) {
                  if (var97 == 0) {
                     String var104 = this.str.toString().toUpperCase();
                     if (var104.indexOf("SUM(") <= 0 && var104.indexOf("AVG(") <= 0 && var104.indexOf("MIN(") <= 0 && var104.indexOf("MAX(") <= 0) {
                        this.str.append("; \r\n\t\tSQL+=\" ORDER BY ");
                     } else {
                        this.str.append("; \r\n\t\tSQL+=\" GROUP BY ");
                     }
                  }

                  if (var97 > 0) {
                     this.str.append(",");
                  }

                  this.str.append(this.targetReportDef.groupBy.getItem(var97));
               }

               this.str.append("\"");
            }

            this.str.append(var2[1]);
            break;
         case 101:
            for(int var71 = 0; var71 < this.indexes2.length; ++var71) {
               if (this.indexes2[var71] >= 0) {
                  this.str.append(var2[0] + Integer.toString(var71) + var2[1] + this.targetGridSettings.fieldLText[this.indexes2[var71]] + var2[2]);
               }
            }
            break;
         case 102:
            for(int var70 = 0; var70 < this.indexes2.length; ++var70) {
               if (this.indexes2[var70] >= 0 && this.targetGridSettings.fieldLStyle[this.indexes2[var70]] == 0) {
                  this.str.append(var2[0] + Integer.toString(var70) + var2[1] + "Font.PLAIN" + var2[2]);
               }
            }
            break;
         case 103:
            for(int var69 = 0; var69 < this.indexes2.length; ++var69) {
               if (this.indexes2[var69] >= 0 && this.targetGridSettings.fieldStyle[this.indexes2[var69]] == 1) {
                  this.str.append(var2[0] + Integer.toString(var69) + var2[1] + "Font.BOLD" + var2[2]);
               }
            }
            break;
         case 104:
            for(int var68 = 0; var68 < this.indexes2.length; ++var68) {
               if (this.indexes2[var68] >= 0 && this.targetGridSettings.fieldLabelColor[this.indexes2[var68]] != Color.black) {
                  this.str.append(var2[0] + Integer.toString(var68) + var2[1] + JDPUtils._cvtbcolor(this.targetGridSettings.fieldLabelColor[this.indexes2[var68]]) + var2[2]);
               }
            }
            break;
         case 105:
            for(int var67 = 0; var67 < this.indexes2.length; ++var67) {
               if (this.indexes2[var67] >= 0 && this.targetGridSettings.fieldTextColor[this.indexes2[var67]] != Color.black) {
                  this.str.append(var2[0] + Integer.toString(var67) + var2[1] + JDPUtils._cvtbcolor(this.targetGridSettings.fieldTextColor[this.indexes2[var67]]) + var2[2]);
               }
            }
            break;
         case 106:
            for(int var66 = 0; var66 < this.indexes2.length; ++var66) {
               if (this.indexes2[var66] >= 0 && this.targetGridSettings.fieldBackColor[this.indexes2[var66]] != Color.white) {
                  this.str.append(var2[0] + Integer.toString(var66) + var2[1] + JDPUtils._cvtbcolor(this.targetGridSettings.fieldBackColor[this.indexes2[var66]]) + var2[2]);
               }
            }
            break;
         case 107:
            for(int var65 = 0; var65 < this.indexes2.length; ++var65) {
               if (this.indexes2[var65] >= 0 && !this.targetGridSettings.fieldEditable[this.indexes2[var65]] && (var2[0].indexOf("Disabled") < 0 || this.targetGridSettings.fieldType[this.indexes2[var65]].equals("JDPDate"))) {
                  this.str.append(var2[0] + Integer.toString(var65) + var2[1] + "true" + var2[2]);
               }
            }
            break;
         case 108:
            for(int var64 = 0; var64 < this.indexes2.length; ++var64) {
               if (this.indexes2[var64] >= 0) {
                  this.str.append(var2[0] + Integer.toString(var64) + var2[1] + Integer.toString(this.targetGrid.tableContents.columnWidth[this.targetGrid.tableContents.columnOrder[var64]]) + var2[2]);
               }
            }
            break;
         case 109:
            for(int var63 = 0; var63 < this.indexes2.length; ++var63) {
               if (this.indexes2[var63] >= 0 && this.targetGridSettings.fieldAlignment[this.indexes2[var63]].equals("Right")) {
                  this.str.append(var2[0] + Integer.toString(var63) + var2[1] + "true" + var2[2]);
               }
            }
            break;
         case 110:
            for(int var62 = 0; var62 < this.indexes2.length; ++var62) {
               if (this.indexes2[var62] >= 0) {
                  if (this.targetGridSettings.fieldType[this.indexes2[var62]].equals("Checkbox")) {
                     this.str.append(var2[0] + Integer.toString(var62) + var2[1] + "CHECKBOX" + var2[2]);
                  }

                  if (this.targetGridSettings.fieldType[this.indexes2[var62]].equals("JDPSpinner")) {
                     this.str.append(var2[0] + Integer.toString(var62) + var2[1] + "SPINNER" + var2[2]);
                  }
               }
            }
            break;
         case 119:
            this.str.append(var2[0] + Integer.toString(this.fieldSql.length) + var2[1]);
            break;
         case 120:
            this.str.append(var2[0] + Integer.toString(this.keysUpdate.length) + var2[1]);
            break;
         case 121:
            var4 = true;
            this.str.append(var2[0] + "\"INSERT INTO " + this.targetColumns.tableName[0] + " (");

            for(int var56 = 0; var56 < this.keys.length; ++var56) {
               boolean var90 = false;

               for(int var33 = 0; var33 < this.updatefields.length; ++var33) {
                  if (this.keys[var56].equals(this.updatefields[var33]) || this.keyIsIdentity[var56]) {
                     var90 = true;
                     break;
                  }
               }

               if (!var90) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  this.str.append(this.keys[var56]);
                  var4 = false;
               }
            }

            for(int var57 = 0; var57 < this.updatefields.length; ++var57) {
               if (!this.gridIsIdentity[this.updateindexes[var57]] && this.targetGridSettings.includeInUpdateSql[this.indexes2[var57]].equals("Yes")) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  this.str.append(this.updatefields[var57]);
                  var4 = false;
               }
            }

            for(int var58 = 0; var58 < this.insertfields.length; ++var58) {
               boolean var91 = false;

               for(int var34 = 0; var34 < this.updatefields.length; ++var34) {
                  if (this.insertfields[var58].equals(this.updatefields[var34])) {
                     var91 = true;
                     break;
                  }
               }

               for(int var35 = 0; var35 < this.keys.length; ++var35) {
                  if (this.insertfields[var58].equals(this.keys[var35])) {
                     var91 = true;
                     break;
                  }
               }

               if (!var91 && !this.targetColumns.columnIsIdentity[this.iindexes[var58]] && this.targetGridSettings.includeInUpdateSql[var58].equals("Yes")) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  this.str.append(this.insertfields[var58]);
                  var4 = false;
               }
            }

            var4 = true;
            this.str.append(") VALUES(");

            for(int var59 = 0; var59 < this.keys.length; ++var59) {
               boolean var92 = false;

               for(int var36 = 0; var36 < this.updatefields.length; ++var36) {
                  if (this.keys[var59].equals(this.updatefields[var36]) || this.keyIsIdentity[var59]) {
                     var92 = true;
                     break;
                  }
               }

               if (!var92) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  var4 = false;
                  boolean var30 = false;
                  if (JDPUtils.isOdbcChar(this.keyDataType[var59])) {
                     var30 = true;
                  }

                  String var101 = "";
                  if (JDPUtils.isOdbcDate(this.keyDataType[var59])) {
                     String[] var106 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                     this.str.append(var106[0]);
                     var101 = var106[1];
                  } else if (JDPUtils.isOdbcBinary(this.keyDataType[var59])) {
                     this.str.append("0x0");
                  } else if (var30) {
                     this.str.append("'");
                  }

                  if (this.layoutName.equals("JDPLayout2")) {
                     this.str.append("\" + rowKey[tableRow][" + Integer.toString(var59) + "] + ");
                  }

                  if (this.layoutName.equals("JDPLayout12") || this.layoutName.equals("JDPLayout22") || this.layoutName.equals("JDPLayout23")) {
                     this.str.append("\" + tableContents.rowKey[tableRow][" + Integer.toString(var59) + "] + ");
                  }

                  if (this.layoutName.equals("JDPLayout3")) {
                     if (this.keyType != null && this.keyType.length > var59 && this.keyType[var59] != null && this.keyType[var59].equals("JDPChoice")) {
                        this.str.append("\" + " + this.user.u.strip(this.switchField(this.keysSQL[var59])) + ".getSelectedItem() + ");
                     } else {
                        this.str.append("\" + " + this.user.u.strip(this.switchField(this.keysSQL[var59])) + ".getText() + ");
                     }
                  }

                  if (!JDPUtils.isOdbcDate(this.keyDataType[var59])) {
                     this.str.append("\"");
                     if (!JDPUtils.isOdbcDate(this.keyDataType[var59]) && var30) {
                        this.str.append("'");
                     }
                  }

                  this.str.append(var101);
               }
            }

            for(int var60 = 0; var60 < this.updatefields.length; ++var60) {
               if (!this.gridIsIdentity[this.updateindexes[var60]] && this.targetGridSettings.includeInUpdateSql[this.indexes2[var60]].equals("Yes")) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  var4 = false;
                  boolean var31 = false;
                  if (JDPUtils.isOdbcChar(this.gridDataType[this.updateindexes[var60]])) {
                     var31 = true;
                  }

                  String var93 = "";
                  if (JDPUtils.isOdbcDate(this.gridDataType[this.updateindexes[var60]])) {
                     String[] var102 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                     this.str.append(var102[0]);
                     var93 = var102[1];
                  } else if (JDPUtils.isOdbcBinary(this.gridDataType[this.updateindexes[var60]])) {
                     this.str.append("0x0");
                  } else if (var31) {
                     this.str.append("'");
                  }

                  if (this.targetGridSettings.fieldType[this.indexes2[var60]].equals("JDPChoice")) {
                     if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                        this.str.append("\" + (String)value" + this.user.u.strip(this.targetGridSettings.columns.getItem(this.indexes2[var60])) + ".elementAt(user.u.listIndexOf(tableContents.pullDownList[" + Integer.toString(this.updateindexes[var60]) + "][0],tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow])) + ");
                     } else {
                        this.str.append("\" + (String)tableContents.pullDownValue[" + Integer.toString(this.updateindexes[var60]) + "][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[" + Integer.toString(this.updateindexes[var60]) + "][0],tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow])) + ");
                     }
                  } else if (this.targetGridSettings.fieldType[this.indexes2[var60]].equals("Checkbox")) {
                     this.str.append("\" + ((tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow].equals(\"Y\"))?\"" + this.targetGridSettings.checkedValue[this.indexes2[var60]] + "\":\"" + this.targetGridSettings.uncheckedValue[this.indexes2[var60]] + "\") + ");
                  } else if (JDPUtils.isOdbcNum(this.gridDataType[this.updateindexes[var60]]) && !this.targetGridSettings.fieldEditMask[this.indexes2[var60]].equals("")) {
                     this.str.append("\" + JDPMaskEditMain.stripFloat(tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow]) + ");
                  } else if (JDPUtils.isOdbcDate(this.gridDataType[this.updateindexes[var60]])) {
                     this.str.append("tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow]");
                  } else if (JDPUtils.isOdbcBinary(this.gridDataType[this.updateindexes[var60]])) {
                     this.str.append("\" + tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow] + ");
                  } else if (var31) {
                     this.str.append("\" + user.u.replace(tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow],\"'\",\"''\") + ");
                  } else {
                     this.str.append("\" + JDPUtils.tonum(tableContents.currentText[" + Integer.toString(this.updateindexes[var60]) + "][tableRow]) + ");
                  }

                  if (!JDPUtils.isOdbcDate(this.gridDataType[this.updateindexes[var60]])) {
                     this.str.append("\"");
                     if (var31) {
                        this.str.append("'");
                     }
                  }

                  this.str.append(var93);
               }
            }

            for(int var61 = 0; var61 < this.insertfields.length; ++var61) {
               boolean var94 = false;

               for(int var37 = 0; var37 < this.updatefields.length; ++var37) {
                  if (this.insertfields[var61].equals(this.updatefields[var37])) {
                     var94 = true;
                     break;
                  }
               }

               for(int var38 = 0; var38 < this.keys.length; ++var38) {
                  if (this.insertfields[var61].equals(this.keys[var38])) {
                     var94 = true;
                     break;
                  }
               }

               if (!var94 && !this.targetColumns.columnIsIdentity[this.iindexes[var61]] && this.targetGridSettings.includeInUpdateSql[var61].equals("Yes")) {
                  if (!var4) {
                     this.str.append(", \" +\r\n\t\t\t\t\t\"");
                  }

                  var4 = false;
                  boolean var32 = false;
                  int var103 = this.targetColumns.columnDatatype[this.iindexes[var61]];
                  if (JDPUtils.isOdbcChar(var103)) {
                     var32 = true;
                  }

                  String var107 = "";
                  if (JDPUtils.isOdbcDate(var103)) {
                     String[] var108 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                     this.str.append(var108[0]);
                     var107 = var108[1];
                     this.str.append("\"" + this.targetGridSettings.fieldDefault[var61] + "\"");
                  } else if (JDPUtils.isOdbcBinary(var103)) {
                     this.str.append("0x0" + this.targetGridSettings.fieldDefault[var61]);
                  } else if (var32) {
                     this.str.append("'" + this.user.u.replace(this.targetGridSettings.fieldDefault[var61], "'", "''") + "'");
                  } else if (this.targetGridSettings.fieldDefault[var61].equals("")) {
                     this.str.append("0");
                  } else {
                     this.str.append(this.targetGridSettings.fieldDefault[var61]);
                  }

                  this.str.append(var107);
               }
            }

            this.str.append(")\"");
            this.str.append(var2[1]);
            break;
         case 122:
            this.str.append(var2[0] + "\"DELETE FROM " + this.targetColumns.tableName[0]);
            this.str.append("\" +\r\n\t\t\t\t\t\" WHERE ");

            for(int var55 = 0; var55 < this.keysUpdate.length; ++var55) {
               if (var55 > 0) {
                  this.str.append(" +\r\n\t\t\t\t\t\" AND ");
               }

               if (this.keysSQLUpdate[var55].indexOf(".") > 0) {
                  this.str.append(this.cvtKey(this.keysSQLUpdate[var55].substring(2), this.keyDataTypeUpdate[var55]) + "=");
               } else {
                  this.str.append(this.cvtKey(this.keysSQLUpdate[var55], this.keyDataTypeUpdate[var55]) + "=");
               }

               String var89 = this.getQuote(this.keyDataTypeUpdate[var55]);
               this.str.append(var89);
               if (JDPUtils.isOdbcBinary(this.keyDataTypeUpdate[var55])) {
                  this.str.append("0x");
               }

               if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                  this.str.append("\" + rowKey[tableRow][" + Integer.toString(var55) + "]");
               } else {
                  this.str.append("\" + tableContents.rowKey[tableRow][" + Integer.toString(var55) + "]");
               }

               this.str.append("+ \"");
               this.str.append(var89);
               this.str.append("\" ");
            }

            this.str.append(var2[1]);
            break;
         case 123:
            this.str.append(var2[0] + "\"UPDATE " + this.targetColumns.tableName[0] + " SET ");
            var4 = true;

            for(int var53 = 0; var53 < this.updatefields.length; ++var53) {
               if (!this.gridIsIdentity[this.updateindexes[var53]] && this.targetGridSettings.includeInUpdateSql[this.indexes2[var53]].equals("Yes")) {
                  boolean var87 = true;

                  for(int var7 = 0; var7 < this.keysUpdate.length; ++var7) {
                     if (this.keysUpdate[var7].equals(this.updatefields[var53])) {
                        var87 = false;
                        break;
                     }
                  }

                  if (var87) {
                     if (!var4) {
                        this.str.append(", \" +\r\n\t\t\t\t\t\"");
                     }

                     var4 = false;
                     this.str.append(this.updatefields[var53] + " = ");
                     boolean var6 = false;
                     if (JDPUtils.isOdbcChar(this.gridDataType[this.updateindexes[var53]])) {
                        var6 = true;
                     }

                     String var100 = "";
                     if (JDPUtils.isOdbcDate(this.gridDataType[this.updateindexes[var53]])) {
                        String[] var105 = new String[]{"\" + JDPDate.formatForSql(", ", user.u.getDataSourceType(jaggSQL)) + \""};
                        this.str.append(var105[0]);
                        var100 = var105[1];
                     } else if (JDPUtils.isOdbcBinary(this.gridDataType[this.updateindexes[var53]])) {
                        this.str.append("0x0");
                     } else if (var6) {
                        this.str.append("'");
                     }

                     if (this.targetGridSettings.fieldType[this.indexes2[var53]].equals("JDPChoice")) {
                        if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                           this.str.append("\" + (String)value" + this.user.u.strip(this.targetGridSettings.columns.getItem(this.indexes2[var53])) + ".elementAt(user.u.listIndexOf(tableContents.pullDownList[" + Integer.toString(this.updateindexes[var53]) + "][0],tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow])) + ");
                        } else {
                           this.str.append("\" + (String)tableContents.pullDownValue[" + Integer.toString(this.updateindexes[var53]) + "][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[" + Integer.toString(this.updateindexes[var53]) + "][0],tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow])) + ");
                        }
                     } else if (this.targetGridSettings.fieldType[this.indexes2[var53]].equals("Checkbox")) {
                        this.str.append("\" + ((tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow].equals(\"Y\"))?\"" + this.targetGridSettings.checkedValue[this.indexes2[var53]] + "\":\"" + this.targetGridSettings.uncheckedValue[this.indexes2[var53]] + "\") + ");
                     } else if (JDPUtils.isOdbcNum(this.gridDataType[this.updateindexes[var53]]) && !this.targetGridSettings.fieldEditMask[this.indexes2[var53]].equals("")) {
                        this.str.append("\" + JDPMaskEditMain.stripFloat(tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow]) + ");
                     } else if (JDPUtils.isOdbcDate(this.gridDataType[this.updateindexes[var53]])) {
                        this.str.append("tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow]");
                     } else if (JDPUtils.isOdbcBinary(this.gridDataType[this.updateindexes[var53]])) {
                        this.str.append("\" + tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow] + ");
                     } else if (var6) {
                        this.str.append("\" + user.u.replace(tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow],\"'\",\"''\") + ");
                     } else {
                        this.str.append("\" + JDPUtils.tonum(tableContents.currentText[" + Integer.toString(this.updateindexes[var53]) + "][tableRow]) + ");
                     }

                     if (!JDPUtils.isOdbcDate(this.gridDataType[this.updateindexes[var53]])) {
                        this.str.append("\"");
                        if (var6) {
                           this.str.append("'");
                        }
                     }

                     this.str.append(var100);
                  }
               }
            }

            String var40 = this.targetGridSettings.lockingColumn.getSelectedItem();
            if (var40 != null && !var40.equals("")) {
               if (var40.indexOf(".") > 0) {
                  var40 = var40.substring(2);
               }

               this.str.append("\" +\r\n\t\t\t\t\t\"," + var40 + " = " + var40 + " + 1");
            }

            this.str.append("\" +\r\n\t\t\t\t\t\" WHERE ");

            for(int var54 = 0; var54 < this.keysUpdate.length; ++var54) {
               if (var54 > 0) {
                  this.str.append(" +\r\n\t\t\t\t\t\" AND ");
               }

               if (this.keysSQLUpdate[var54].indexOf(".") > 0) {
                  this.str.append(this.cvtKey(this.keysSQLUpdate[var54].substring(2), this.keyDataTypeUpdate[var54]) + "=");
               } else {
                  this.str.append(this.cvtKey(this.keysSQLUpdate[var54], this.keyDataTypeUpdate[var54]) + "=");
               }

               String var88 = this.getQuote(this.keyDataTypeUpdate[var54]);
               this.str.append(var88);
               if (JDPUtils.isOdbcBinary(this.keyDataTypeUpdate[var54])) {
                  this.str.append("0x");
               }

               if (!this.layoutName.equals("JDPLayout12") && !this.layoutName.equals("JDPLayout22") && !this.layoutName.equals("JDPLayout23")) {
                  this.str.append("\" + rowKey[tableRow][" + Integer.toString(var54) + "]");
               } else {
                  this.str.append("\" + tableContents.rowKey[tableRow][" + Integer.toString(var54) + "]");
               }

               this.str.append("+ \"");
               this.str.append(var88);
               this.str.append("\" ");
            }

            this.str.append(var2[1]);
            break;
         case 124:
            this.str.append(var2[0] + this.targetReportDef.reportTitle.getText() + var2[1]);
            break;
         case 125:
            this.str.append(var2[0] + Integer.toString(this.targetGrid.tableContents.columnOrder.length) + var2[1]);
            break;
         case 126:
            this.str.append(var2[0] + Integer.toString(this.targetReportDef.groupBy.countItems()) + var2[1]);
            break;
         case 127:
            for(int var52 = 0; var52 < this.targetReportDef.groupBy.countItems(); ++var52) {
               if (this.targetReportDef.subTotal[var52]) {
                  int var85 = 0;

                  for(var85 = 0; var85 < this.targetGrid.tableContents.columnOrder.length && this.targetGrid.tableContents.columnOrder[var85] != var52; ++var85) {
                  }

                  this.str.append(var2[0] + Integer.toString(var85) + var2[1] + "true" + var2[2]);
               }
            }
            break;
         case 128:
            for(int var51 = 0; var51 < this.targetReportDef.groupBy.countItems(); ++var51) {
               if (this.targetReportDef.grandTotal[var51]) {
                  int var83 = 0;

                  for(var83 = 0; var83 < this.targetGrid.tableContents.columnOrder.length && this.targetGrid.tableContents.columnOrder[var83] != var51; ++var83) {
                  }

                  this.str.append(var2[0] + Integer.toString(var83) + var2[1] + "true" + var2[2]);
               }
            }
            break;
         case 129:
            for(int var50 = 0; var50 < this.targetGridSettings.fieldTotal.length; ++var50) {
               if (this.targetGridSettings.fieldActive[var50] && this.targetGridSettings.fieldTotal[var50]) {
                  int var82 = this.targetGrid.indexes.indexOf(Integer.toString(var50));
                  int var98 = 0;

                  for(var98 = 0; var98 < this.targetGrid.tableContents.columnOrder.length && this.targetGrid.tableContents.columnOrder[var98] != var82; ++var98) {
                  }

                  this.str.append(var2[0] + Integer.toString(var98) + var2[1] + "true" + var2[2]);
               }
            }
            break;
         case 130:
            this.str.append(var2[0] + Integer.toString(this.targetChartDef.groupBy.getSelectedItems().length) + var2[1]);
            break;
         case 131:
            this.str.append(var2[0] + Integer.toString(this.targetChartDef.multipleSeries.getSelectedItems().length) + var2[1]);
            break;
         case 132:
            String var48 = this.targetChart.prevSQL;
            String var14 = "";
            int var15 = var48.indexOf("ORDER BY");
            int var16 = var48.indexOf("GROUP BY");
            int var17 = var48.indexOf("WHERE ");
            if (var17 < 0) {
               var14 = " WHERE \" + whereClause";
            } else {
               var14 = " AND \" + whereClause";
            }

            var4 = true;
            if (this.layoutName.equals("JDPLayout5") && this.targetList != null) {
               for(int var113 = 0; var113 < this.keys.length; ++var113) {
                  if (this.targetList.uniqueTree.isSelected(var113) || this.targetList.useTree.getSelectedItem().equals("List")) {
                     var14 = var14 + " +\r\n\t\t\t\t\t\" AND ";
                     var14 = var14 + this.cvtKey(this.keysSQL[var113], this.keyDataType[var113]) + "=";
                     String var121 = this.getQuote(this.keyDataType[var113]);
                     var14 = var14 + var121;
                     var14 = var14 + "\" + searchResults.recordKey" + Integer.toString(var113) + "[itemIndex]";
                     var14 = var14 + "+ \"" + var121 + "\" ";
                  }
               }
            }

            if (var15 < 0 && var16 < 0) {
               var48 = var48 + var14;
            } else if (var15 < var16 && var15 >= 0) {
               String var115 = var48.substring(0, var15) + var14 + " + \" " + var48.substring(var15) + "\"";
               var48 = var115;
            } else if (var16 >= 0) {
               String var114 = var48.substring(0, var16) + var14 + " + \" " + var48.substring(var16) + "\"";
               var48 = var114;
            } else {
               var48 = var48 + var14;
            }

            this.str.append(var2[0] + "\"" + var48 + var2[1]);
            break;
         case 133:
            for(int var112 = 0; var112 < this.keys.length; ++var112) {
               this.str.append(var2[0] + "if (keys != null && keys.length > " + Integer.toString(var112) + " && keys[" + Integer.toString(var112) + "] != null) whereClause += \" AND " + this.cvtKey(this.keysSQL[var112], this.keyDataType[var112]) + "=");
               String var120 = this.getQuote(this.keyDataType[var112]);
               this.str.append(var120);
               this.str.append("\" + keys[" + Integer.toString(var112) + "]");
               this.str.append("+ \"" + var120 + "\" ");
               this.str.append(var2[1]);
            }
            break;
         case 140:
            this.str.append(var2[0] + Integer.toString(this.targetChartDef.chartType.getSelectedIndex() + 1) + var2[1]);
            break;
         case 141:
            this.str.append(var2[0] + this.targetChartDef.chartTitle.getText() + var2[1]);
            break;
         case 142:
            this.str.append(var2[0] + this.targetChartDef.chartTitleColor.getSelectedItem() + var2[1]);
            break;
         case 143:
            this.str.append(var2[0] + this.targetChartDef.xaxisTitle.getText() + var2[1]);
            break;
         case 144:
            this.str.append(var2[0] + this.targetChartDef.xaxisTitleColor.getSelectedItem() + var2[1]);
            break;
         case 145:
            this.str.append(var2[0] + this.targetChartDef.xaxisLabelColor.getSelectedItem() + var2[1]);
            break;
         case 146:
            this.str.append(var2[0] + this.targetChartDef.yaxisLabelColor.getSelectedItem() + var2[1]);
            break;
         case 147:
            this.str.append(var2[0] + this.targetChartDef.chartFrameColor.getSelectedItem() + var2[1]);
            break;
         case 148:
            int var111 = 0;

            for(int var119 = 0; var119 < this.targetChartDef.fieldActive.length; ++var119) {
               if (this.targetChartDef.fieldActive[var119]) {
                  ++var111;
               }
            }

            if (var111 < 1) {
               var111 = 1;
            }

            this.str.append(var2[0] + Integer.toString(var111) + var2[1]);
            break;
         case 149:
            int var110 = 0;
            if (this.targetChartDef.fieldActive.length == 0) {
               this.str.append(var2[0] + "0" + var2[1] + "" + var2[2]);
            }

            for(int var118 = 0; var118 < this.targetChartDef.fieldActive.length; ++var118) {
               if (this.targetChartDef.fieldActive[var118]) {
                  this.str.append(var2[0] + Integer.toString(var110) + var2[1] + this.targetChartDef.elementLegend[var118] + var2[2]);
                  ++var110;
               }
            }
            break;
         case 150:
            int var109 = 0;
            if (this.targetChartDef.fieldActive.length == 0) {
               this.str.append(var2[0] + "0" + var2[1] + "Color.red" + var2[2]);
            }

            for(int var117 = 0; var117 < this.targetChartDef.fieldActive.length; ++var117) {
               if (this.targetChartDef.fieldActive[var117]) {
                  this.str.append(var2[0] + Integer.toString(var109) + var2[1] + JDPUtils._cvtbcolor(this.targetChartDef.elementColor[var117]) + var2[2]);
                  ++var109;
               }
            }
            break;
         case 151:
            int var18 = 0;
            if (this.targetChartDef.fieldActive.length == 0) {
               this.str.append(var2[0] + "0" + var2[1] + "Color.black" + var2[2]);
            }

            for(int var116 = 0; var116 < this.targetChartDef.fieldActive.length; ++var116) {
               if (this.targetChartDef.fieldActive[var116]) {
                  this.str.append(var2[0] + Integer.toString(var18) + var2[1] + JDPUtils._cvtbcolor(this.targetChartDef.elementBorderColor[var116]) + var2[2]);
                  ++var18;
               }
            }
            break;
         case 152:
            String var19 = "";
            var4 = true;
            if (this.targetChartDef.gridLineSettingH.getSelectedItem().equals("Yes")) {
               var19 = var19 + "JDPChart.HORIZONTAL";
               var4 = false;
            }

            if (this.targetChartDef.gridLineSettingV.getSelectedItem().equals("Yes")) {
               if (!var4) {
                  var19 = var19 + " + ";
               }

               var4 = false;
               var19 = var19 + "JDPChart.VERTICAL";
            }

            if (this.targetChartDef.gridLineSettingF.getSelectedItem().equals("Yes")) {
               if (!var4) {
                  var19 = var19 + " + ";
               }

               var4 = false;
               var19 = var19 + "JDPChart.FOREGROUND";
            }

            if (this.targetChartDef.gridLineSettingB.getSelectedItem().equals("Yes")) {
               if (!var4) {
                  var19 = var19 + " + ";
               }

               var4 = false;
               var19 = var19 + "JDPChart.BACKGROUND";
            }

            if (var19.length() == 0) {
               var19 = "0";
            }

            this.str.append(var2[0] + var19 + var2[1]);
            break;
         case 153:
            this.str.append(var2[0] + this.targetChartDef.gridColor.getSelectedItem() + var2[1]);
            break;
         case 154:
            if (this.targetChartDef.autoscale.getSelectedItem().equals("Yes")) {
               this.str.append(var2[0] + "true" + var2[1]);
            } else {
               this.str.append(var2[0] + "false" + var2[1]);
            }
            break;
         case 155:
            if (this.targetChartDef.autozoom.getSelectedItem().equals("Yes")) {
               this.str.append(var2[0] + "true" + var2[1]);
            } else {
               this.str.append(var2[0] + "false" + var2[1]);
            }
            break;
         case 156:
            this.str.append(var2[0] + this.targetChartDef.maxPlotValue.getText() + var2[1]);
            break;
         case 157:
            this.str.append(var2[0] + this.targetChartDef.minPlotValue.getText() + var2[1]);
            break;
         case 158:
            this.str.append(var2[0] + Integer.toString(this.targetChartDef.chartType.getSelectedIndex() + 1) + var2[1]);
            break;
         case 159:
            this.str.append(var2[0]);
            if (this.targetChartDef.autoscale.getSelectedIndex() == 0) {
               this.str.append("true");
            } else {
               this.str.append("false");
            }

            this.str.append(var2[1]);
            break;
         case 160:
            this.str.append(var2[0]);
            if (this.targetChartDef.autozoom.getSelectedIndex() == 0) {
               this.str.append("true");
            } else {
               this.str.append("false");
            }

            this.str.append(var2[1]);
            break;
         case 161:
            this.str.append(var2[0] + this.targetChartDef.pfromwhereclause.getText() + var2[1]);
            break;
         case 162:
            String var39 = this.targetGridSettings.lockingColumn.getSelectedItem();
            if (var39 != null && !var39.equals("")) {
               this.str.append(var1);
            }
            break;
         case 163:
            String var8 = this.targetGridSettings.lockingColumn.getSelectedItem();
            if (var8 != null && !var8.equals("")) {
               if (var8.indexOf(".") > 0) {
                  var8 = var8.substring(2);
               }

               this.str.append(var2[0] + var8 + var2[1]);
            }
            break;
         case 170:
            for(int var47 = 0; var47 < this.indexes2.length; ++var47) {
               if (this.indexes2[var47] >= 0 && this.targetGrid.maskEdit != null && this.targetGrid.maskEdit[this.targetGrid.tableContents.columnOrder[var47]] != null) {
                  this.str.append(var2[0] + Integer.toString(var47) + var2[1] + this.targetGrid.maskEdit[this.targetGrid.tableContents.columnOrder[var47]] + var2[2]);
               }
            }
            break;
         case 171:
            for(int var13 = 0; var13 < this.indexes2.length; ++var13) {
               if (this.indexes2[var13] >= 0 && this.targetGrid.maskType[this.targetGrid.tableContents.columnOrder[var13]] != null) {
                  this.str.append(var2[0] + Integer.toString(var13) + var2[1] + this.targetGrid.maskType[this.targetGrid.tableContents.columnOrder[var13]] + var2[2]);
               }
            }
            break;
         case 979:
            if (this.targetDSN.jdbcdirect.getSelectedIndex() == 1) {
               this.str.append(var1);
            }
            break;
         case 980:
            this.str.append(var2[0] + this.user.u.replace(this.targetDSN.jdbcdriver.getText(), "\\", "\\\\") + var2[1]);
            break;
         case 981:
            this.str.append(var2[0] + this.user.u.replace(this.targetDSN.jdbcprefix.getText(), "\\", "\\\\") + var2[1]);
            break;
         case 982:
            this.str.append(var2[0] + this.user.u.replace(this.targetDSN.jdbcsuffix.getText(), "\\", "\\\\") + var2[1]);
            break;
         case 984:
            this.str.append(var2[0] + this.user.u.replace(this.targetDSN.userid.getText(), "\\", "\\\\") + var2[1]);
            break;
         case 985:
            this.str.append(var2[0] + this.user.u.replace(this.targetDSN.password.getText(), "\\", "\\\\") + var2[1]);
            break;
         case 994:
            if (this.targetChartDef != null && this.targetChartDef.maxRows != null && this.user.u.isnumeric(this.targetChartDef.maxRows, this.user.mainmsg)) {
               this.str.append(var2[0] + this.targetChartDef.maxRows.getText() + var2[1]);
            } else {
               this.str.append(var2[0] + "100" + var2[1]);
            }
            break;
         case 995:
            if (this.targetReportDef != null && this.targetReportDef.maxRows != null && this.user.u.isnumeric(this.targetReportDef.maxRows, this.user.mainmsg)) {
               this.str.append(var2[0] + this.targetReportDef.maxRows.getText() + var2[1]);
            } else {
               this.str.append(var2[0] + "100" + var2[1]);
            }
            break;
         case 996:
            if (this.targetGridSettings != null && this.targetGridSettings.maxRows != null && this.user.u.isnumeric(this.targetGridSettings.maxRows, this.user.mainmsg)) {
               this.str.append(var2[0] + this.targetGridSettings.maxRows.getText() + var2[1]);
            } else {
               this.str.append(var2[0] + "100" + var2[1]);
            }
            break;
         case 997:
            if (this.targetList != null && this.targetList.maxRows != null && this.user.u.isnumeric(this.targetList.maxRows, this.user.mainmsg)) {
               this.str.append(var2[0] + this.targetList.maxRows.getText() + var2[1]);
            } else {
               this.str.append(var2[0] + "100" + var2[1]);
            }
            break;
         case 998:
            this.str.append(var2[0] + this.user.u.replace(this.dataSource, "\\", "\\\\") + var2[1]);
            break;
         case 999:
            this.str.append(var2[0] + this.user.u.replace(this.connectString, "\\", "\\\\") + var2[1]);
            break;
         default:
            this.str.append(var1);
      }

      return this.str.toString();
   }

   boolean readyToBuild5() {
      if (this.targetChartDef != null && !this.targetChartDef.chartTitle.getText().equals("")) {
         if (this.targetChart != null && !this.targetChart.prevSQL.equals("")) {
            this.setKeyFields();
            return true;
         } else {
            this.user.mainmsg.setStatusMsg("You must first preview the chart settings before building.", 8);
            return false;
         }
      } else {
         this.user.mainmsg.setStatusMsg("You must first define the chart settings before building.", 8);
         return false;
      }
   }
}
