import java.awt.Choice;
import java.awt.Component;
import java.awt.List;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPLoadChoice {
   JDPUser user;
   JDPJagg jaggSQL;

   public JDPLoadChoice(JDPUser var1, JDPJagg var2, Object var3, String var4, String var5, String var6, String var7, Vector var8) {
      this.user = var1;
      this.jaggSQL = var2;
      this.loadChoice(var3, var4, var5, var6, var7, var8, -1000);
   }

   public JDPLoadChoice(JDPUser var1, JDPJagg var2, Component var3, String var4, String var5, String var6, String var7, Vector var8) {
      this.user = var1;
      this.jaggSQL = var2;
      this.loadChoice(var3, var4, var5, var6, var7, var8, -1000);
   }

   public JDPLoadChoice(JDPUser var1, JDPJagg var2, Object var3, String var4, String var5, String var6, String var7, int var8) {
      this.user = var1;
      this.jaggSQL = var2;
      this.loadChoice(var3, var4, var5, var6, var7, (Vector)null, var8);
   }

   void loadChoice(Object var1, String var2, String var3, String var4, String var5, Vector var6) {
      this.loadChoice(var1, var2, var3, var4, var5, var6, -1000);
   }

   void loadChoice(Object var1, String var2, String var3, String var4, String var5, Vector var6, int var7) {
      int var9 = 0;
      Vector var10 = new Vector();
      String var11 = this.jaggSQL.getSEP();
      if (var1 != null) {
         String var13 = var2;
         int var14 = var2.toUpperCase().indexOf("DISTINCT");
         if (var14 >= 0) {
            var13 = var2.substring(var14 + 9);
         }

         if (this.user.u.sqlRequiresChange(this.jaggSQL, 0)) {
            var3 = var3 + " a";
         }

         var14 = var2.toUpperCase().indexOf(" DESC");
         if (var14 >= 0) {
            var2 = var2.substring(0, var14);
         }

         if (var3 != null) {
            if (var3.indexOf(" ") >= 0 && !var3.endsWith(" a") || var3.indexOf("#") >= 0) {
               var3 = "`" + var3 + "`";
            }
         } else {
            var3 = var2;
         }

         if (var2.indexOf("`") < 0 && !var2.startsWith("DISTINCT") && var2.indexOf("(") < 0 && var2.indexOf("_") < 0 && var2.indexOf("'") < 0 && var2.indexOf("+") < 0 && var14 < 0 && (var2.indexOf(" ") >= 0 && !var2.endsWith(" a") || var2.indexOf("#") >= 0)) {
            var2 = "`" + var2 + "`";
         }

         if (this.jaggSQL.getFCTN().equals("") && var4.indexOf("`") < 0 && var4.indexOf("(") < 0 && var4.indexOf(",") < 0 && (var4.indexOf(" ") >= 0 && !var4.endsWith(" a") || var4.indexOf("#") >= 0)) {
            var4 = "`" + var4 + "`";
         }

         if (var13.indexOf("`") < 0 && var13.indexOf("(") < 0 && var13.indexOf("_") < 0 && var13.indexOf("'") < 0 && var13.indexOf("+") < 0 && (var13.indexOf(" ") >= 0 && !var13.endsWith(" a") || var13.indexOf("#") >= 0)) {
            var13 = "`" + var13 + "`";
         }

         String var15 = "SELECT " + var2 + "," + var3 + " FROM " + var4 + " WHERE " + var5 + " ORDER BY " + var13;
         if (this.user.DEBUG) {
            System.out.println("loadData SQL: " + var15);
         }

         var9 = this.jaggSQL.execSQL(var15, var10);
         if (this.user.DEBUG) {
            System.out.println("JDPLoadChoice CNT: " + Integer.toString(var9));
         }

         if (var9 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var15);
         } else {
            Choice var16 = null;
            JDPChoice var17 = null;
            JDPComboBox var18 = null;
            List var19 = null;
            JDPList var20 = null;
            if (var1 instanceof Choice) {
               var16 = (Choice)var1;
            } else if (var1 instanceof JDPChoice) {
               var17 = (JDPChoice)var1;
            } else if (var1 instanceof JDPComboBox) {
               var18 = (JDPComboBox)var1;
            } else if (var1 instanceof List) {
               var19 = (List)var1;
            } else if (var1 instanceof JDPList) {
               var20 = (JDPList)var1;
            }

            if (var1 instanceof Vector) {
            }

            if (var9 >= 1) {
               for(int var23 = 0; var23 < var9; ++var23) {
                  String var12 = (String)var10.elementAt(var23);
                  if (var12 != null && var12.trim().compareTo("") != 0) {
                     StringTokenizer var8 = new StringTokenizer(var12);
                     String var21 = var8.nextToken(var11).trim();
                     String var22 = var8.nextToken(var11).trim();
                     if (var1 instanceof Choice) {
                        var16.addItem(var21);
                     } else if (var1 instanceof JDPChoice) {
                        var17.addItem(var21, var22);
                     } else if (var1 instanceof JDPComboBox) {
                        var18.addItem(var21, var22);
                     } else if (var1 instanceof List) {
                        var19.addItem(var21);
                     } else if (var1 instanceof JDPList) {
                        var20.addItem(var21, var22);
                     } else if (var1 instanceof Vector) {
                        ((Vector)var1).addElement(var21);
                     }

                     if (var6 != null && var7 == -1000) {
                        var6.addElement(var22);
                     } else if (var1 instanceof Vector && var6 != null) {
                        if (JDPUtils.isOdbcChar(var7)) {
                           var6.addElement("='" + this.user.u.replace(var22, "'", "''") + "'");
                        } else if (JDPUtils.isOdbcDate(var7)) {
                           var6.addElement("='" + var22 + "'");
                        } else {
                           var6.addElement("=" + var22);
                        }
                     }
                  }
               }
            }

            this.user.mainmsg.clearStatusMsg();
         }
      }
   }

   public JDPLoadChoice(JDPUser var1, JDPJagg var2, Object var3, String var4, String var5, String var6) {
      this.user = var1;
      this.jaggSQL = var2;
      this.loadChoice(var3, var4, var4, var5, var6, (Vector)null, -1000);
   }
}
