import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Window;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPLogin extends Frame implements Runnable {
   int msgindex;
   TextField username;
   TextField password;
   JDesignerPro target;
   JDPUser user;
   JDPCustomer cust;
   JDPStatusMessage mainmsg;
   Font plainFont;
   Font boldFont;
   boolean licenseValid = true;
   Vector eventVector;
   JDPButton okButton;
   String systemOU;

   void loadMenus(JDPUser var1, String var2) {
      String[] var3 = new String[5];
      int[] var4 = new int[5];
      String[] var5 = new String[5];
      int[] var6 = new int[5];
      String var13 = "";
      float var14 = Float.valueOf(JDesignerPro.actualversion.trim().replace('b', '0'));
      if (this.target.versionnum != var14) {
         this.performVersionUpdate(var14);
      }

      this.mainmsg.setStatusMsg(JDPLang.get("JDPMain1"), 0);
      var1.menu = new JDPMenuStruct();
      if (var1.JDesignerPro.NDSPath != null) {
         this.loadNDSMenus(var1, var2);
      } else {
         Vector var10 = new Vector();
         String var11 = "SELECT initmenu, menuauth1, menuauth2, menuauth3, menuauth4, menuauth5, " + "menulvl1, menulvl2, menulvl3, menulvl4, menulvl5 " + " FROM JDPMenuAuth WHERE JDPSystem = '" + var2 + "' " + " AND userid = " + var1.cust.suserid;
         if (var1.DEBUG) {
            System.out.println("JDPLogin/loadMenus SQL: " + var11);
         }

         int var12 = this.target.jaggSQL.execSQL(var11, var10);
         if (var1.DEBUG) {
            System.out.println("JDPLogin/loadMenus CNT: " + Integer.toString(var12));
         }

         String var7;
         if (var12 == 1) {
            String var9 = new String(this.target.jaggSQL.getSEP());
            StringTokenizer var8 = new StringTokenizer((String)var10.elementAt(0));
            var1.menu.initmenu = var8.nextToken(var9).trim();
            var3[0] = var8.nextToken(var9).trim();
            var3[1] = var8.nextToken(var9).trim();
            var3[2] = var8.nextToken(var9).trim();
            var3[3] = var8.nextToken(var9).trim();
            var3[4] = var8.nextToken(var9).trim();
            var4[0] = Integer.parseInt(var8.nextToken(var9).trim());
            var4[1] = Integer.parseInt(var8.nextToken(var9).trim());
            var4[2] = Integer.parseInt(var8.nextToken(var9).trim());
            var4[3] = Integer.parseInt(var8.nextToken(var9).trim());
            var4[4] = Integer.parseInt(var8.nextToken(var9).trim());
            var1.cust.initmenu = var1.menu.initmenu;
            var1.cust.menuauth1 = var3[0];
            var1.cust.menuauth2 = var3[1];
            var1.cust.menuauth3 = var3[2];
            var1.cust.menuauth4 = var3[3];
            var1.cust.menuauth5 = var3[4];
            var1.cust.menulvl1 = var4[0];
            var1.cust.menulvl2 = var4[1];
            var1.cust.menulvl3 = var4[2];
            var1.cust.menulvl4 = var4[3];
            var1.cust.menulvl5 = var4[4];
            int var15 = 0;

            do {
               if (var3[var15].length() > 0) {
                  if (var13.length() > 0) {
                     var13 = var13 + ",";
                  }

                  var13 = var13 + "'" + var3[var15].trim() + "'";
               }

               ++var15;
            } while(var15 < 5);

            if (var13.length() == 0) {
               var7 = " (menuauth1 = '*ALL') ";
            } else {
               var7 = " (";
               var15 = 0;

               do {
                  if (var15 > 0) {
                     var7 = var7 + " OR ";
                  }

                  var7 = var7 + "menuauth" + Integer.toString(var15 + 1).trim() + " in (" + var13 + ")";
                  ++var15;
               } while(var15 < 5);

               var7 = var7 + ") ";
            }
         } else {
            var7 = " (menuauth1 = '*ALL') ";
            var1.menu.initmenu = "Main";
         }

         var10 = new Vector();
         var11 = "SELECT menuname, menunum, menutype, menuobject, menuparm, menudesc, menutxtclr, menutabclr, " + "menuauth1, menuauth2, menuauth3, menuauth4, menuauth5, " + "menulvl1, menulvl2, menulvl3, menulvl4, menulvl5 " + "FROM JDPMenu WHERE JDPSystem = '" + var2 + "'" + " AND menustatus = 'A' AND " + var7 + " ORDER BY menuname, menunum";
         if (var1.DEBUG) {
            System.out.println("JDPLogin/loadMenus SQL: " + var11);
         }

         var12 = this.target.jaggSQL.execSQL(var11, var10);
         if (var1.DEBUG) {
            System.out.println("JDPLogin/loadMenus CNT: " + Integer.toString(var12));
         }

         if (var12 >= 1) {
            int var28 = 0;
            String[] var16 = new String[var12];
            var1.menu.menunum = new int[var12];
            var1.menu.menutype = new String[var12];
            var1.menu.menuobject = new String[var12];
            var1.menu.menuparm = new String[var12];
            var1.menu.menudesc = new String[var12];
            var1.menu.menutextcolor = new String[var12];
            var1.menu.menutabcolor = new String[var12];
            String var23 = new String(this.target.jaggSQL.getSEP());

            for(int var17 = 0; var17 < var12; ++var17) {
               StringTokenizer var22 = new StringTokenizer((String)var10.elementAt(var17));
               var16[var28] = var22.nextToken(var23).trim();
               var1.menu.menunum[var28] = Integer.parseInt(var22.nextToken(var23).trim());
               var1.menu.menutype[var28] = var22.nextToken(var23).trim();
               var1.menu.menuobject[var28] = var22.nextToken(var23).trim();
               var1.menu.menuparm[var28] = var22.nextToken(var23).trim();
               var1.menu.menudesc[var28] = var22.nextToken(var23).trim();
               var1.menu.menutextcolor[var28] = var22.nextToken(var23).trim();
               var1.menu.menutabcolor[var28] = var22.nextToken(var23).trim();
               var5[0] = var22.nextToken(var23).trim();
               var5[1] = var22.nextToken(var23).trim();
               var5[2] = var22.nextToken(var23).trim();
               var5[3] = var22.nextToken(var23).trim();
               var5[4] = var22.nextToken(var23).trim();
               var6[0] = Integer.parseInt(var22.nextToken(var23).trim());
               var6[1] = Integer.parseInt(var22.nextToken(var23).trim());
               var6[2] = Integer.parseInt(var22.nextToken(var23).trim());
               var6[3] = Integer.parseInt(var22.nextToken(var23).trim());
               var6[4] = Integer.parseInt(var22.nextToken(var23).trim());
               if (var5[0].compareTo("*ALL") != 0) {
                  boolean var18 = false;
                  int var19 = 0;

                  do {
                     int var20 = 0;

                     do {
                        if (!var3[var19].equals("") && var3[var19].equals(var5[var20]) && var4[var19] <= var6[var20]) {
                           var18 = true;
                           break;
                        }

                        ++var20;
                     } while(var20 < 5);

                     ++var19;
                  } while(var19 < 5);

                  if (!var18) {
                     var16[var28] = null;
                     var1.menu.menunum[var28] = 0;
                     var1.menu.menutype[var28] = null;
                     var1.menu.menuobject[var28] = null;
                     var1.menu.menuparm[var28] = null;
                     var1.menu.menudesc[var28] = null;
                     --var28;
                  }
               }

               ++var28;
            }

            var1.menu.menuname = new String[var28];
            System.arraycopy(var16, 0, var1.menu.menuname, 0, var28);
            int[] var30 = var1.menu.menunum;
            var1.menu.menunum = new int[var28];
            System.arraycopy(var30, 0, var1.menu.menunum, 0, var28);
            String[] var31 = var1.menu.menutype;
            var1.menu.menutype = new String[var28];
            System.arraycopy(var31, 0, var1.menu.menutype, 0, var28);
            var31 = var1.menu.menuobject;
            var1.menu.menuobject = new String[var28];
            System.arraycopy(var31, 0, var1.menu.menuobject, 0, var28);
            var31 = var1.menu.menuparm;
            var1.menu.menuparm = new String[var28];
            System.arraycopy(var31, 0, var1.menu.menuparm, 0, var28);
            var31 = var1.menu.menudesc;
            var1.menu.menudesc = new String[var28];
            System.arraycopy(var31, 0, var1.menu.menudesc, 0, var28);
         }

         if (var1.DEBUG) {
            System.out.println("JDPLogin/loadMenus INI: " + var1.menu.initmenu);

            for(int var29 = 0; var29 < var1.menu.menuname.length; ++var29) {
               System.out.println("JDPLogin/loadMenus MNU: " + var1.menu.menuname[var29] + " " + Integer.toString(var1.menu.menunum[var29]) + " " + var1.menu.menutype[var29] + " " + var1.menu.menuobject[var29] + " " + var1.menu.menuparm[var29] + " " + var1.menu.menudesc[var29]);
            }
         }

      }
   }

   JDPLogin(JDesignerPro var1, String var2) {
      super(var2);
      this.target = var1;
      if (!System.getProperty("java.version").startsWith("1.0") && System.getProperty("os.name").startsWith("Win")) {
         ((Frame)this).setIconImage(var1.JDPIconImage);
      }

      ((Component)this).setBackground(JDPUtils.getControlColor());
      this.user = new JDPUser();
      this.user.JDesignerPro = var1;
      this.user.jaggSQL = new JDPJagg(var1.JDPJaggPath);
      this.user.u = new JDPUtils(this.user);
      JDPLang.load(this.user, var1.language, var1.country);
      this.plainFont = new Font(var1.plainFontName, 0, var1.plainFontSize);
      this.boldFont = new Font(var1.boldFontName, 1, var1.boldFontSize);
      this.user.plainFont = this.plainFont;
      this.user.boldFont = this.boldFont;
      ((Component)this).setFont(this.plainFont);
      ((Container)this).setLayout(new BorderLayout(1, 1));
      this.mainmsg = new JDPStatusMessage((JDPUser)null);
      this.eventVector = new Vector();
      Panel var3 = new Panel();
      Panel var4 = new Panel();
      Panel var5 = new Panel();
      Panel var6 = new Panel();
      JDPButton.activated = true;
      JDPRowLayout.activated = true;
      ((Container)var3).setLayout(new JDPRowLayout(1, 1));
      ((Container)var4).setLayout(new BorderLayout(1, 1));
      ((Container)var6).setLayout(new BorderLayout(2, 2));
      ((Container)var5).setLayout(new GridLayout(3, 1));
      ((Container)var3).add("Left", new Label(JDPLang.get("JDPLogin1"), 0));
      ((Container)var3).add("Left", new Label(JDPLang.get("JDPLogin2"), 0));
      this.username = new TextField("", 20);
      this.password = new TextField("", 20);
      if (!JDesignerPro.executable && ((Applet)var1).getParameter("JDPDftUsername") != null) {
         this.username.setText(((Applet)var1).getParameter("JDPDftUsername"));
      } else {
         this.username.setText(JDPLang.get("JDPLoginG"));
      }

      if (!JDesignerPro.executable && ((Applet)var1).getParameter("JDPDftPassword") != null) {
         this.password.setText(((Applet)var1).getParameter("JDPDftPassword"));
      }

      this.password.setEchoCharacter('*');
      ((Container)var3).add("Right", this.username);
      ((Container)var3).add("Right", this.password);
      if (var1.expired) {
      }

      this.okButton = new JDPButton(JDPLang.get("OK"));
      this.okButton.setJDPUser(this.user);
      ((Container)var5).add(this.okButton);
      ((Container)var5).add(new JDPButton(JDPLang.get("Cancel")));
      ((Container)var6).add("West", var5);
      ((Container)var6).add("North", new Panel());
      JDPChiselFramePanel var7 = new JDPChiselFramePanel(this.user, JDPLang.get("JDPLogin0"), var3, "North");
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout(1, 1));
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout(1, 1));
      ((Container)var9).add("Center", var8);
      ((Container)var8).add("Center", var7);
      ((Container)var8).add("East", var6);
      if (!var1.expired) {
         this.licenseValid = this.licenseCheck();
      }

      if (var1.autoUsername == null) {
         ((Container)this).add("North", var9);
         ((Container)this).add("South", this.mainmsg);
         ((Container)this).layout();
         ((Component)this).paintAll(((Component)this).getGraphics());
         ((Window)this).pack();
         ((Component)this).move(60, 70);
         this.username.requestFocus();
         this.username.selectAll();
         ((Window)this).show();
         this.password.resize(this.username.bounds().width, this.password.bounds().height);
      } else {
         ((Container)this).add("Center", this.mainmsg);
         ((Container)this).layout();
         ((Component)this).paintAll(((Component)this).getGraphics());
         ((Window)this).pack();
         ((Component)this).move(90, 100);
         ((Window)this).show();
         this.loginNow(var1.autoUsername.toLowerCase().trim(), var1.autoPassword.toLowerCase().trim());
      }
   }

   void performVersionUpdate(float var1) {
      new JDPVersionUpdate(this.user, this.target.versionnum, var1);
      new JDPSetupNDS(this.user, this.target.versionnum, var1);
   }

   void loadNDSMenus(JDPUser var1, String var2) {
      this.target.jaggSQL.setFCTN("NDSexecSQL");
      this.target.jaggSQL.setFCTNP(this.username.getText().trim() + ";" + this.password.getText().trim() + ";");
      this.loadSystemOU(var2);
      String var3 = this.target.jaggSQL.getSEP();
      Vector var4 = new Vector();
      String var5 = "SELECT b.JDP:menuname, c.JDP:menunum, c.JDP:menutype, c.JDP:menuobject, c.JDP:menuparm, c.JDP:menudesc, c.JDP:menutxtclr, c.JDP:menutabclr " + "FROM JDesignerPro Menu b, JDesignerPro Menu Option c WHERE c.JDP:menustat = 'A'" + " ORDER BY b.JDP:menuname, c.JDP:menunum " + "PARENT=" + this.systemOU + " NDSUSER='" + var1.cust.username + "'";
      int var6 = this.target.jaggSQL.execSQL(var5, var4);
      var1.menu.menuname = new String[var6];
      var1.menu.menunum = new int[var6];
      var1.menu.menutype = new String[var6];
      var1.menu.menuobject = new String[var6];
      var1.menu.menuparm = new String[var6];
      var1.menu.menudesc = new String[var6];
      var1.menu.menutextcolor = new String[var6];
      var1.menu.menutabcolor = new String[var6];

      for(int var8 = 0; var8 < var6; ++var8) {
         StringTokenizer var7 = new StringTokenizer((String)var4.elementAt(var8), var3);
         var1.menu.menuname[var8] = var7.nextToken().trim();
         var1.menu.menunum[var8] = Integer.parseInt(var7.nextToken().trim());
         var1.menu.menutype[var8] = var7.nextToken().trim();
         var1.menu.menuobject[var8] = var7.nextToken().trim();
         var1.menu.menuparm[var8] = var7.nextToken().trim();
         var1.menu.menudesc[var8] = var7.nextToken().trim();
         var1.menu.menutextcolor[var8] = var7.nextToken().trim();
         var1.menu.menutabcolor[var8] = var7.nextToken().trim();
      }

      var1.menu.initmenu = var1.cust.initmenu;
      this.target.jaggSQL.setFCTN("");
      this.target.jaggSQL.setFCTNP("");
   }

   void loginNow(String var1, String var2) {
      int var3 = 0;
      String var4 = "";
      Vector var5 = new Vector();
      String var6;
      if (this.user.JDesignerPro.NDSPath != null) {
         this.target.jaggSQL.setFCTN("NDSexecSQL");
         this.target.jaggSQL.setFCTNP(var1 + ";" + var2 + ";");
         if (var1.toLowerCase().compareTo(JDPLang.get("JDPLoginG").toLowerCase()) != 0) {
            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin3"), 0);
            var4 = " AND password = '" + var2 + "'";
         } else {
            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin4"), 0);
            var1 = "Guest";
         }

         if (!this.licenseValid) {
            var4 = var4 + " AND JDP:userid < " + Integer.toString(JDesignerPro.JDPLicenses);
         }

         var6 = "SELECT JDP:status,`Given Name`,JDP:userid,CN,JDP:password,Surname,JDP:address1,JDP:address2,JDP:city,JDP:state,JDP:zipcode," + "JDP:country,JDP:cardnum,JDP:cardexpiry,JDP:cardname,`Telephone Number`,`Email Address`,JDP:alphsvcph,JDP:alphpgrnum," + "JDP:winx1,JDP:winy1,JDP:winx2,JDP:winy2,JDP:totallogin,JDP:initmenu " + "FROM User WHERE (CN = '" + var1 + "' OR CN = '" + var1.toLowerCase() + "') " + var4;
      } else {
         if (var1.toLowerCase().compareTo(JDPLang.get("JDPLoginG").toLowerCase()) != 0) {
            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin3"), 0);
            var4 = " AND password = '" + var2 + "'";
         } else {
            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin4"), 0);
            var1 = "Guest";
         }

         if (!this.licenseValid) {
            var4 = var4 + " AND userid <= 2 ";
         }

         var6 = "SELECT status,firstname,userid,username,password,lastname,address1,address2,city,state,zipcode," + "country,cardnum,cardexpiry,cardname,phonenum,emailaddr,alphsvcph,alphpgrnum," + "winx1,winy1,winx2,winy2,jdpsystem0,jdpsystem1, " + "jdpsystem2,jdpsystem3,jdpsystem4,jdpsystem5,jdpsystem6,jdpsystem7,jdpsystem8,jdpsystem9 " + "FROM JDPUser WHERE (username = '" + var1 + "' OR username = '" + var1.toLowerCase() + "') " + var4 + " " + "AND (jdpsystem0 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem1 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem2 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem3 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem4 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem5 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem6 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem7 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem8 = '" + this.target.JDPSystem + "' " + "OR  jdpsystem9 = '" + this.target.JDPSystem + "') ";
      }

      int var7 = this.target.jaggSQL.execSQL(var6, var5);
      this.target.jaggSQL.setFCTN("");
      if (var7 == 1) {
         String var8 = new String(this.target.jaggSQL.getSEP());
         StringTokenizer var9 = new StringTokenizer((String)var5.elementAt(0), var8);
         String var10 = var9.nextToken().trim();
         String var11 = var9.nextToken().trim();
         if (var10.compareTo("A") != 0 && var10.compareTo("P") != 0 && var10.compareTo("F") != 0 && var10.compareTo("D") != 0 && var10.compareTo("G") != 0) {
            this.okButton.enable();
            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin9"), 0);
         } else {
            if (!this.target.singlemode) {
               if (var10.compareTo("D") != 0 && var10.compareTo("G") != 0 && var11.length() > 0) {
                  this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin5", var11), 0);
               } else {
                  this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin6"), 0);
               }
            }

            this.cust = new JDPCustomer();
            this.user.cust = this.cust;
            this.user.jaggSQL = this.target.jaggSQL;
            this.cust.firstname = var11;
            this.cust.status = var10;
            this.cust.userid = Integer.parseInt(var9.nextToken().trim());
            this.cust.suserid = Integer.toString(this.cust.userid);
            this.target.jaggSQL.setUserid(this.cust.suserid);
            this.cust.username = var9.nextToken().trim();
            this.cust.password = var9.nextToken().trim();
            this.cust.lastname = var9.nextToken().trim();
            this.cust.address1 = var9.nextToken().trim();
            this.cust.address2 = var9.nextToken().trim();
            this.cust.city = var9.nextToken().trim();
            this.cust.state = var9.nextToken().trim();
            this.cust.zipcode = var9.nextToken().trim();
            this.cust.country = var9.nextToken().trim();
            this.cust.cardnum = var9.nextToken().trim();
            this.cust.cardexpiry = var9.nextToken().trim();
            this.cust.cardname = var9.nextToken().trim();
            this.cust.phonenum = var9.nextToken().trim();
            this.cust.emailaddr = var9.nextToken().trim();
            if (this.cust.emailaddr.startsWith("0;SMTP:")) {
               this.cust.emailaddr = this.cust.emailaddr.substring(7);
            }

            this.cust.alphsvcph = var9.nextToken().trim();
            this.cust.alphpgrnum = var9.nextToken().trim();
            this.cust.winx1 = Integer.parseInt(var9.nextToken().trim());
            this.cust.winy1 = Integer.parseInt(var9.nextToken().trim());
            this.cust.winx2 = Integer.parseInt(var9.nextToken().trim());
            this.cust.winy2 = Integer.parseInt(var9.nextToken().trim());
            if (this.cust.winx2 == 0) {
               this.cust.winx1 = -1;
               this.cust.winy1 = -1;
               this.cust.winx2 = 2000;
               this.cust.winy2 = 2000;
            }

            if (this.user.JDesignerPro.NDSPath == null) {
               this.cust.jdpsystem0 = var9.nextToken().trim();
               this.cust.jdpsystem1 = var9.nextToken().trim();
               this.cust.jdpsystem2 = var9.nextToken().trim();
               this.cust.jdpsystem3 = var9.nextToken().trim();
               this.cust.jdpsystem4 = var9.nextToken().trim();
               this.cust.jdpsystem5 = var9.nextToken().trim();
               this.cust.jdpsystem6 = var9.nextToken().trim();
               this.cust.jdpsystem7 = var9.nextToken().trim();
               this.cust.jdpsystem8 = var9.nextToken().trim();
               this.cust.jdpsystem9 = var9.nextToken().trim();
            } else {
               String var12 = var9.nextToken().trim();
               if (var12.equals("")) {
                  var3 = 1;
               } else {
                  var3 = Integer.parseInt(var12) + 1;
               }

               this.cust.initmenu = var9.nextToken().trim();
               if (this.cust.initmenu.equals("")) {
                  this.cust.initmenu = "Main";
               }
            }

            this.user.loginMessage = this.mainmsg;
            this.user.DSNType = this.user.u.getDataSourceType(this.user.jaggSQL);
            Date var17 = new Date();
            String var13 = JDPDate.formatForSql(var17, this.user.DSNType);
            this.mainmsg.setStatusMsg("Loading user preferences...", 0);
            if (this.user.JDesignerPro.NDSPath == null) {
               var6 = "UPDATE JDPUser SET lastaccess = " + var13 + ", totallogin=totallogin+1 WHERE userid = " + this.cust.suserid;
               var7 = this.target.jaggSQL.execSQL(var6, var5);
            } else {
               var13 = JDPDate.format(var17);
               var6 = "UPDATE User SET JDP:lastaccess = '" + var13 + "', JDP:totallogin=" + Integer.toString(var3) + " WHERE JDP:userid = " + this.cust.suserid;
               this.target.jaggSQL.setFCTN("NDSexecSQL");
               var7 = this.target.jaggSQL.execSQL(var6, var5);
               this.target.jaggSQL.setFCTN("");
            }

            if (var7 < 0) {
               this.user.u.setSqlMessage(this.target.jaggSQL, var6);
            }

            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin7"), 0);
            this.target.user = new JDPUser[50];
            this.target.user[0] = this.user;
            this.target.user[0].JDesignerPro = this.target;
            this.target.user[0].cust = this.cust;
            this.target.user[0].cust.username = this.username.getText();
            this.target.user[0].cust.password = this.password.getText();
            this.target.user[0].JDPSystem = this.target.JDPSystem;
            this.target.user[0].JDPSystemDesc = this.target.JDPSystemDesc;
            this.target.user[0].boldFontName = this.target.boldFontName;
            this.target.user[0].boldFontSize = this.target.boldFontSize;
            this.target.user[0].plainFontName = this.target.plainFontName;
            this.target.user[0].plainFontSize = this.target.plainFontSize;
            this.target.user[0].boldFont = this.boldFont;
            this.target.user[0].plainFont = this.plainFont;
            this.target.user[0].gParm = new Vector();
            this.target.user[0].loginMessage = this.mainmsg;
            this.target.user[0].saveProperties = new JDPSaveProps(this.target.user[0]);
            this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin8"), 0);
            String var14 = this.target.JDPSystem;
            if (!JDesignerPro.usingNDSSnapin) {
               this.loadMenus(this.target.user[0], var14);
            }

            this.target.validLogin();
            ((Frame)this).dispose();
         }
      } else if (var7 == 0) {
         this.okButton.enable();
         this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin10"), 0);
         this.username.requestFocus();
         this.username.selectAll();
      } else {
         this.okButton.enable();
         this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin11"), 0);
      }
   }

   boolean licenseCheck() {
      String var2 = this.target.jaggSQL.getSEP();
      this.target.jaggSQL.setFCTN("CheckLicense");
      this.target.jaggSQL.setFCTNP("");
      Vector var3 = new Vector();
      int var4 = this.target.jaggSQL.execSQL("", var3);
      this.target.jaggSQL.setFCTN("");
      if (var4 <= 0) {
         var4 = 100;
         JDesignerPro.JDPLicensed = false;
      } else {
         JDesignerPro.JDPLicensed = true;
      }

      String var5;
      if (this.user.JDesignerPro.NDSPath != null) {
         this.target.jaggSQL.setFCTN("NDSexecSQL");
         var5 = "SELECT count(*) from User WHERE JDP:status = 'A' OR JDP:status = 'P' OR JDP:status = 'G' OR JDP:status = 'F')";
      } else {
         var5 = "SELECT count(*) from JDPUser WHERE status in ('A','P','G','F')";
      }

      var3 = new Vector();
      int var6 = this.target.jaggSQL.execSQL(var5, var3);
      if (var6 > 0) {
         StringTokenizer var1 = new StringTokenizer((String)var3.elementAt(0));
         String var7 = var1.nextToken(var2).trim();
         int var8 = var7.indexOf(".");
         if (var8 >= 0) {
            var7 = var7.substring(0, var8);
         }

         int var9 = Integer.parseInt(var7);
         JDesignerPro.JDPLicenses = var4;
         if (var9 > var4) {
            this.mainmsg.setStatusMsg("Users exceeds license, contact BulletProof", 0);
            return false;
         } else {
            return true;
         }
      } else if (this.user.JDesignerPro.NDSPath != null) {
         JDesignerPro.JDPLicenses = var4;
         return true;
      } else {
         this.mainmsg.setStatusMsg(JDPLang.get("JDPLogin12"), 0);
         System.out.println(JDPLang.get("JDPLogin13"));
         return false;
      }
   }

   public void run() {
      Event var1 = (Event)this.eventVector.elementAt(0);
      this.eventVector.removeElementAt(0);
      if (this.target.expired) {
         this.target.invalidLogin();
         ((Frame)this).dispose();
         if (JDesignerPro.executable) {
            System.exit(0);
         }

      } else {
         String var2 = (String)var1.arg;
         if (var1.target instanceof JDPButton) {
            if (var2.compareTo(JDPLang.get("OK")) == 0) {
               String var5 = this.username.getText().trim();
               String var6 = "";
               if (var5.compareTo(JDPLang.get("JDPLoginG").toLowerCase()) != 0) {
                  var6 = this.password.getText().toLowerCase().trim();
               }

               this.okButton.disable();
               this.loginNow(var5, var6);
            } else {
               this.target.invalidLogin();
               ((Frame)this).dispose();
               JDPJagg.cleanUp();
               if (JDesignerPro.executable) {
                  System.exit(0);
               }

            }
         } else if (var1.target instanceof TextField) {
            String var3 = this.username.getText().trim();
            String var4 = "";
            if (var3.toLowerCase().compareTo(JDPLang.get("JDPLoginG").toLowerCase()) != 0) {
               var4 = this.password.getText().toLowerCase().trim();
            }

            this.okButton.disable();
            this.loginNow(var3, var4);
         }
      }
   }

   public boolean handleEvent(Event var1) {
      if (var1.id == 1001) {
         this.eventVector.addElement(var1);
         Thread var2 = new Thread(this);
         var2.start();
         return true;
      } else if (var1.id == 201) {
         this.target.invalidLogin();
         ((Frame)this).dispose();
         JDPJagg.cleanUp();
         if (JDesignerPro.executable) {
            System.exit(0);
         }

         return true;
      } else if (var1.key == 9 && var1.id == 401) {
         if (var1.target.equals(this.username)) {
            this.password.requestFocus();
            this.password.selectAll();
            return true;
         } else if (var1.target.equals(this.password)) {
            this.username.requestFocus();
            this.username.selectAll();
            return true;
         } else {
            return true;
         }
      } else {
         return false;
      }
   }

   void loadSystemOU(String var1) {
      String var2 = "SELECT OU FROM JDesignerPro System WHERE JDP:JDPSystem = '" + var1 + "'";
      Vector var3 = new Vector();
      this.target.jaggSQL.execSQL(var2, var3);
      StringTokenizer var4 = new StringTokenizer((String)var3.elementAt(0));
      this.systemOU = var4.nextToken(this.target.jaggSQL.getSEP()).trim();
   }
}
