import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPMenuMaint extends JDPClassLayout {
   JDPSearchResults searchResults;
   String[] psortChoice;
   String[] pdisplayChoice;
   String[] menuStack;
   int stackIndex;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   JDPPopupMessage popuppanel;
   JDPJagg jaggSQL;
   Label lbl4;
   JDPCardPanel objectPanel;
   JDPButton JDPButton1;
   TextField menuname;
   TextField menunum;
   TextField menudesc;
   JDPChoice menutextcolor;
   JDPChoice menutabcolor;
   JDPComboBox menuobject;
   JDPComboBox menuobjectsel;
   TextField menuparm;
   JDPChoice menutype;
   JDPChoice menustatus;
   TextField menuauth1;
   TextField menuauth2;
   TextField menuauth3;
   TextField menuauth4;
   TextField menuauth5;
   TextField menuauthlvl1;
   TextField menuauthlvl2;
   TextField menuauthlvl3;
   TextField menuauthlvl4;
   TextField menuauthlvl5;
   JDPTextGrid DetailGrid1;
   long lastEventTime;
   long lastEventTime1;
   String JDPDirectory;
   String systemOU = "";

   void DetailGrid1LoadChoices() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 1;
      this.jaggSQL.setFCTN("NDSexecSQL");
      var1.isPullDownCol = new boolean[var2];
      var1.pullDownColType = new int[var2];
      var1.pullDownList = new List[var2][1];
      var1.isPullDownCol[0] = true;
      var1.pullDownColType[0] = 0;
      var1.pullDownList[0][0] = new List();
      var1.pullDownValue[0][0] = new Vector();
      var1.pullDownValue[0][0].addElement("");
      var1.pullDownList[0][0].addItem("");
      new JDPLoadChoice(super.user, this.jaggSQL, var1.pullDownList[0][0], "CN", "CN", "Group", "(1=1)", var1.pullDownValue[0][0]);
      new JDPLoadChoice(super.user, this.jaggSQL, var1.pullDownList[0][0], "CN", "CN", "User", "(1=1)", var1.pullDownValue[0][0]);
   }

   void loadOption(int var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (this.stackIndex > 0) {
         --var1;
      }

      String var7 = this.searchResults.recordKey0[var1];
      String var8 = this.searchResults.recordKey4[var1];
      this.menuname.setText(var7);
      this.menunum.setText(var8);
      this.menuobject.setText(this.searchResults.recordKey2[var1]);
      this.menuobjectsel.setText(this.searchResults.recordKey2[var1]);
      this.menuparm.setText(this.searchResults.recordKey3[var1]);
      this.menudesc.setText(this.searchResults.recordName[var1]);
      if (this.searchResults.recordKey1[var1].compareTo("M") == 0) {
         this.menutype.select("Menu");
         this.lbl4.setText("Points to Menu:");
         this.lbl4.show();
         this.menuobject.show();
      }

      if (this.searchResults.recordKey1[var1].compareTo("P") == 0) {
         this.menutype.select("Program Module");
         this.lbl4.setText("Module to load:");
         this.lbl4.show();
         this.menuobject.show();
      }

      if (this.searchResults.recordKey1[var1].compareTo("A") == 0) {
         this.menutype.select("AutoLoad Program Module");
         this.lbl4.setText("Module to load:");
         this.lbl4.show();
         this.menuobject.show();
      }

      if (this.searchResults.recordKey1[var1].compareTo("B") == 0) {
         this.menutype.select("Build Test Panel");
         this.lbl4.hide();
         this.menuobject.hide();
      }

      String var9;
      if (super.user.JDesignerPro.NDSPath != null) {
         var9 = "SELECT JDP:menustat,JDP:menutxtclr,JDP:menutabclr,`ACL:[Entry Rights]` " + "FROM JDesignerPro Menu Option WHERE JDP:menunum = " + var8 + " PARENT=" + this.systemOU + "\\" + var7;
      } else {
         var9 = "SELECT menustatus,menutxtclr,menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5," + "menulvl1,menulvl2,menulvl3,menulvl4,menulvl5 " + "FROM JDPMenu WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND menuname = '" + var7 + "' AND menunum = " + var8;
      }

      if (super.user.DEBUG) {
         System.out.println("JDPMenuMaint/loadOption SQL: " + var9);
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var3 = this.jaggSQL.execSQL(var9, var4);
      if (super.user.DEBUG) {
         System.out.println("JDPMenuMaint/loadOption CNT: " + Integer.toString(var3));
      }

      if (var3 == -1) {
         super.user.u.setSqlMessage(this.jaggSQL, var9);
      } else if (var3 != 1) {
         super.user.mainmsg.setStatusMsg("Menu option not found in the database", 10);
      } else {
         String var6 = (String)var4.elementAt(0);
         if (var6 != null && var6.trim().compareTo("") != 0) {
            StringTokenizer var2 = new StringTokenizer(var6, var5);
            String var10 = var2.nextToken().trim();
            if (var10.compareTo("A") == 0) {
               this.menustatus.select("Active");
            }

            if (var10.compareTo("I") == 0) {
               this.menustatus.select("Inactive");
            }

            this.menutextcolor.select(var2.nextToken().trim());
            this.menutabcolor.select(var2.nextToken().trim());
            if (super.user.JDesignerPro.NDSPath == null) {
               this.menuauth1.setText(var2.nextToken().trim());
               this.menuauth2.setText(var2.nextToken().trim());
               this.menuauth3.setText(var2.nextToken().trim());
               this.menuauth4.setText(var2.nextToken().trim());
               this.menuauth5.setText(var2.nextToken().trim());
               this.menuauthlvl1.setText(var2.nextToken().trim());
               this.menuauthlvl2.setText(var2.nextToken().trim());
               this.menuauthlvl3.setText(var2.nextToken().trim());
               this.menuauthlvl4.setText(var2.nextToken().trim());
               this.menuauthlvl5.setText(var2.nextToken().trim());
            } else {
               int var11 = 0;
               StringTokenizer var12 = new StringTokenizer(var2.nextToken(), ";");

               String[] var13;
               for(var13 = new String[var12.countTokens()]; var12.hasMoreTokens(); var13[var11++] = var12.nextToken().trim()) {
               }

               this.DetailGrid1LoadGridMain(var13);
            }
         }

         super.user.mainmsg.clearStatusMsg();
      }
   }

   void clearFields() {
      this.menuname.setText("");
      this.menunum.setText("0");
      this.menutype.select("Program Module");
      this.lbl4.setText("Module to load:");
      this.menuobject.setText("");
      this.menuparm.setText("");
      this.menustatus.select("Active");
      this.menudesc.setText("");
      this.menutextcolor.select("Black");
      this.menutabcolor.select("LightGray");
      this.menuauth1.setText("*ALL");
      this.menuauth2.setText("");
      this.menuauth3.setText("");
      this.menuauth4.setText("");
      this.menuauth5.setText("");
      this.menuauthlvl1.setText("0");
      this.menuauthlvl2.setText("0");
      this.menuauthlvl3.setText("0");
      this.menuauthlvl4.setText("0");
      this.menuauthlvl5.setText("0");
   }

   public void DetailGrid1LoadEmptyGrid() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 1;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
      var1.setSortingEnabled(true);
   }

   void traverseList(boolean var1) {
      if (!var1 && this.searchResults.resultList.getSelectedItem().compareTo("...") != 0) {
         this.itemIndex = this.searchResults.resultList.getSelectedIndex();
         String var9;
         if (this.stackIndex > 0) {
            this.itemIndex += -1;
            String var2 = this.searchResults.recordKey1[this.itemIndex];
            if (var2.compareTo("P") == 0) {
               return;
            }

            if (super.user.JDesignerPro.NDSPath != null) {
               var9 = "FROM JDesignerPro Menu a, JDesignerPro Menu Option b WHERE a.JDP:menuname = '" + this.searchResults.recordKey2[this.itemIndex] + "' " + "PARENT=" + this.systemOU;
            } else {
               var9 = "FROM JDPMenu WHERE JDPSystem = '" + super.user.JDPSystem + "'" + " AND menuname = '" + this.searchResults.recordKey2[this.itemIndex] + "'";
            }

            this.menuStack[this.stackIndex++] = this.searchResults.recordKey2[this.itemIndex];
         } else {
            String var5 = "M";
            if (super.user.JDesignerPro.NDSPath != null) {
               var9 = "FROM JDesignerPro Menu a, JDesignerPro Menu Option b WHERE a.JDP:menuname = '" + this.searchResults.recordKey0[this.itemIndex] + "' " + "PARENT=" + this.systemOU;
            } else {
               var9 = "FROM JDPMenu WHERE JDPSystem = '" + super.user.JDPSystem + "'" + " AND menuname = '" + this.searchResults.recordKey0[this.itemIndex] + "'";
            }

            this.menuStack[this.stackIndex++] = this.searchResults.recordKey0[this.itemIndex];
         }

         String var7;
         if (super.user.JDesignerPro.NDSPath != null) {
            var7 = "a.JDP:menuname,b.JDP:menutype,b.JDP:menuobject,b.JDP:menuparm,b.JDP:menunum";
            this.psortChoice[0] = "b.JDP:menunum";
            this.pdisplayChoice[0] = "b.JDP:menudesc";
         } else {
            var7 = "menuname,menutype,menuobject,menuparm,menunum";
            this.psortChoice[0] = "menunum";
            this.pdisplayChoice[0] = "menudesc";
         }

         this.searchResults.setTableKey(var7);
         this.searchResults.setFromWhereClause(var9);
         this.searchResults.setSortChoice(this.psortChoice);
         this.searchResults.setDisplayChoice(this.pdisplayChoice);
         this.searchResults.clearList();
         this.searchResults.resultList.addItem("...", 11);
         this.searchResults.loadList();
         this.updateIcons();
      } else {
         if (!var1) {
            this.stackIndex += -1;
         }

         if (this.stackIndex == 0) {
            String var6;
            String var8;
            if (super.user.JDesignerPro.NDSPath != null) {
               var6 = "JDP:menuname";
               var8 = "FROM JDesignerPro Menu PARENT=" + this.systemOU;
               this.psortChoice[0] = "JDP:menuname";
               this.pdisplayChoice[0] = "JDP:menuname";
            } else {
               var6 = "DISTINCT menuname";
               var8 = "FROM JDPMenu WHERE JDPSystem = '" + super.user.JDPSystem + "'";
               this.psortChoice[0] = "menuname";
               this.pdisplayChoice[0] = "menuname";
            }

            this.searchResults.setTableKey(var6);
            this.searchResults.setFromWhereClause(var8);
            this.searchResults.setSortChoice(this.psortChoice);
            this.searchResults.setDisplayChoice(this.pdisplayChoice);
            this.searchResults.clearList();
            this.searchResults.loadList();
            this.updateIcons();
         } else {
            String var3;
            String var4;
            if (super.user.JDesignerPro.NDSPath != null) {
               var3 = "a.JDP:menuname,b.JDP:menutype,b.JDP:menuobject,b.JDP:menuparm,b.JDP:menunum";
               var4 = "FROM JDesignerPro Menu a, JDesignerPro Menu Option b WHERE a.JDP:menuname = '" + this.menuStack[this.stackIndex - 1] + "' " + "PARENT=" + this.systemOU;
               this.psortChoice[0] = "b.JDP:menunum";
               this.pdisplayChoice[0] = "b.JDP:menudesc";
            } else {
               var3 = "menuname,menutype,menuobject,menuparm,menunum";
               var4 = "FROM JDPMenu WHERE JDPSystem = '" + super.user.JDPSystem + "'" + " AND menuname = '" + this.menuStack[this.stackIndex - 1] + "'";
               this.psortChoice[0] = "menunum";
               this.pdisplayChoice[0] = "menudesc";
            }

            this.searchResults.setTableKey(var3);
            this.searchResults.setFromWhereClause(var4);
            this.searchResults.setSortChoice(this.psortChoice);
            this.searchResults.setDisplayChoice(this.pdisplayChoice);
            this.searchResults.clearList();
            this.searchResults.resultList.addItem("...");
            this.searchResults.loadList();
            this.updateIcons();
         }
      }
   }

   void toggleTypeDisplay() {
      int var1 = this.menutype.getSelectedIndex();
      String var2 = this.menutype.getSelectedItem();
      if (var2.equals("AutoLoad Program Module")) {
         var2 = "Program Module";
      }

      this.objectPanel.setSelectedComp(var2);
      if (var1 == 0) {
         this.lbl4.setText("Points to Menu:");
         this.lbl4.show();
      }

      if (var1 == 1) {
         this.lbl4.setText("Module to load:");
         this.lbl4.show();
      }

      if (var1 == 2) {
         this.lbl4.hide();
      }

   }

   boolean saveOption() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.jaggSQL.getSEP();
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      if (this.itemIndex < 0 && !this.insertRequested) {
         super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
         return false;
      } else {
         if (this.stackIndex > 0) {
            this.itemIndex += -1;
         }

         String var3 = this.menuname.getText();
         String var4 = this.menunum.getText().trim();
         String var5 = this.menutype.getSelectedItem().substring(0, 1);
         String var6 = this.menustatus.getSelectedItem().substring(0, 1);
         String var7 = this.menuobject.getText();
         if (this.menutype.getSelectedItem().equals("Menu")) {
            var7 = this.menuobjectsel.getText();
         }

         String var8 = "";
         if (this.deleteRequested) {
            if (super.user.JDesignerPro.NDSPath != null) {
               var8 = "DELETE FROM JDesignerPro Menu Option " + "WHERE JDP:menunum = " + var4 + " PARENT=" + this.systemOU + "\\" + var3;
            } else {
               var8 = "DELETE FROM JDPMenu " + "WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND menuname = '" + var3 + "' AND menunum = " + var4;
            }
         } else if (this.insertRequested) {
            if (super.user.JDesignerPro.NDSPath != null) {
               var8 = "SELECT JDP:menunum FROM JDesignerPro Menu Option " + "WHERE JDP:menunum = " + var4 + " PARENT=" + this.systemOU + "\\" + var3;
            } else {
               var8 = "SELECT menuname FROM JDPMenu " + "WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND menuname = '" + var3 + "' AND menunum = " + var4;
            }

            super.user.mainmsg.setStatusMsg("Accessing database...", 0);
            var1 = this.jaggSQL.execSQL(var8, var2);
            if (var1 > 0) {
               super.user.mainmsg.setStatusMsg("A menu option with this number already exists.", 15);
               return false;
            }

            var2 = new Vector();
            if (super.user.JDesignerPro.NDSPath != null) {
               var8 = "SELECT JDP:menuname FROM JDesignerPro Menu " + "WHERE JDP:menuname = '" + var3 + "'" + " PARENT=" + this.systemOU;
               var1 = this.jaggSQL.execSQL(var8, var2);
               if (var1 == 0) {
                  var8 = "INSERT INTO JDesignerPro Menu (OU, JDP:menuname, Description) " + "VALUES ('" + var3 + "','" + var3 + "','" + var3 + "') " + " PARENT=" + this.systemOU;
                  this.jaggSQL.execSQL(var8, var2);
               }

               var8 = "INSERT INTO JDesignerPro Menu Option (OU, JDP:menunum,JDP:menutype,JDP:menuobject,JDP:menuparm,JDP:menudesc,Description,JDP:menustat,JDP:menutxtclr, " + "JDP:menutabclr,`ACL:[Entry Rights]`) " + "VALUES(" + var4 + this.menudesc.getText() + "," + var4 + "," + "'" + var5 + "','" + var7 + "','" + this.menuparm.getText() + "', " + "'" + this.menudesc.getText() + "'," + "'" + this.menudesc.getText() + "'," + "'" + var6 + "'," + "'" + this.menutextcolor.getSelectedItem() + "', " + "'" + this.menutabcolor.getSelectedItem() + "', " + "'" + this.getACLList() + "')" + " PARENT=" + this.systemOU + "\\" + var3;
            } else {
               var8 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + super.user.JDPSystem + "','" + var3 + "'," + var4 + "," + "'" + var5 + "','" + var7 + "','" + this.menuparm.getText() + "', " + "'" + this.menudesc.getText() + "'," + "'" + var6 + "'," + "'" + this.menutextcolor.getSelectedItem() + "', " + "'" + this.menutabcolor.getSelectedItem() + "'," + "'" + this.menuauth1.getText() + "','" + this.menuauth2.getText() + "', " + "'" + this.menuauth3.getText() + "','" + this.menuauth4.getText() + "', " + "'" + this.menuauth5.getText() + "'," + this.menuauthlvl1.getText() + ", " + this.menuauthlvl2.getText() + "," + this.menuauthlvl3.getText() + ", " + this.menuauthlvl4.getText() + "," + this.menuauthlvl5.getText() + ")";
            }
         } else if (super.user.JDesignerPro.NDSPath != null) {
            var8 = "UPDATE JDesignerPro Menu Option SET JDP:menutype = '" + var5 + "',JDP:menuobject = '" + var7 + "',JDP:menuparm = '" + this.menuparm.getText() + "', " + "JDP:menustat = '" + var6 + "', JDP:menudesc = '" + this.menudesc.getText() + "', Description = '" + this.menudesc.getText() + "', JDP:menutxtclr = '" + this.menutextcolor.getSelectedItem() + "', " + "JDP:menutabclr = '" + this.menutabcolor.getSelectedItem() + "', " + "`ACL:[Entry Rights]` = '" + this.getACLList() + "' " + "WHERE JDP:menunum = " + var4 + " PARENT=" + this.systemOU + "\\" + var3;
         } else {
            var8 = "UPDATE JDPMenu SET menutype = '" + var5 + "',menuobject = '" + var7 + "',menuparm = '" + this.menuparm.getText() + "', " + "menustatus = '" + var6 + "', menudesc = '" + this.menudesc.getText() + "', menutxtclr = '" + this.menutextcolor.getSelectedItem() + "', " + "menutabclr = '" + this.menutabcolor.getSelectedItem() + "'," + "menuauth1 = '" + this.menuauth1.getText() + "',menuauth2 = '" + this.menuauth2.getText() + "', " + "menuauth3 = '" + this.menuauth3.getText() + "',menuauth4 = '" + this.menuauth4.getText() + "', " + "menuauth5 = '" + this.menuauth5.getText() + "',menulvl1 = " + this.menuauthlvl1.getText() + ", " + "menulvl2 = " + this.menuauthlvl2.getText() + ",menulvl3 = " + this.menuauthlvl3.getText() + ", " + "menulvl4 = " + this.menuauthlvl4.getText() + ",menulvl5 = " + this.menuauthlvl5.getText() + " " + "WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND menuname = '" + var3 + "' AND menunum = " + var4;
         }

         if (super.user.DEBUG) {
            System.out.println("JDPMenuMaint/saveOption SQL: " + var8);
         }

         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var1 = this.jaggSQL.execSQL(var8, var2);
         if (super.user.DEBUG) {
            System.out.println("JDPMenuMaint/saveOption CNT: " + Integer.toString(var1));
         }

         if (var1 == -1) {
            super.user.u.setSqlMessage(this.jaggSQL, var8);
            return false;
         } else {
            if (var1 == 1) {
               if (this.deleteRequested) {
                  this.loadMenuObjectSel();
                  super.user.mainmsg.setStatusMsg("Menu option successfully removed.", 3);
               } else if (this.insertRequested) {
                  this.loadMenuObjectSel();
                  super.user.mainmsg.setStatusMsg("Menu option successfully added.", 3);
               } else {
                  super.user.mainmsg.setStatusMsg("Menu option successfully updated.", 3);
               }

               this.menuname.setEditable(false);
               this.menunum.setEditable(false);
            } else {
               super.user.mainmsg.setStatusMsg("Menu option update failed", 10);
            }

            this.deleteRequested = false;
            this.insertRequested = false;
            return true;
         }
      }
   }

   public void loadMenuObjectSel() {
      if (this.menuobjectsel == null) {
         this.menuobjectsel = new JDPComboBox(super.user, "", 20);
      } else {
         this.menuobjectsel.clear();
      }

      this.jaggSQL.loadSettings(super.user);
      if (super.user.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         this.menuobjectsel.loadChoice(super.user, this.jaggSQL, "b.JDP:menuname", "b.JDP:menuname", "JDesignerPro System a, JDesignerPro Menu b", "a.JDP:JDPSystem = '" + super.user.JDPSystem + "'");
      } else {
         this.menuobjectsel.loadChoice(super.user, this.jaggSQL, "DISTINCT menuname", "menuname", "JDPMenu", "JDPSystem = '" + super.user.JDPSystem + "'");
      }
   }

   public void loadMenuObject() {
      if (this.menuobject == null) {
         this.menuobject = new JDPComboBox(super.user, "", 20);
      } else {
         this.menuobject.clear();
      }

      this.jaggSQL.loadSettings(super.user);
      this.jaggSQL.setFCTN("ListFiles");
      this.jaggSQL.setFCTNP(this.JDPDirectory + ";");
      Vector var1 = new Vector();
      this.jaggSQL.execSQL("", var1);

      for(int var3 = 0; var3 < var1.size(); ++var3) {
         StringTokenizer var4 = new StringTokenizer((String)var1.elementAt(var3), this.jaggSQL.getSEP());
         String var2 = var4.nextToken();
         String var5 = var4.nextToken();
         if (var5.equals("F") && var2.endsWith(".class")) {
            var2 = var2.substring(0, var2.length() - 6);
            this.menuobject.addItem(var2, var2);
         }
      }

      if (super.user.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
      } else {
         this.jaggSQL.setFCTN("");
      }

      this.jaggSQL.setFCTNP("");
   }

   String getACLList() {
      StringBuffer var1 = new StringBuffer();
      JDPTextGrid var3 = this.DetailGrid1;

      for(int var4 = 0; var4 < var3.getTableRows(); ++var4) {
         String var2 = var3.getText(0, var4);
         if (var2 != null && !var2.equals("")) {
            var1.append(var2 + ";");
         }
      }

      return var1.toString();
   }

   void updateIcons() {
      for(int var1 = 0; var1 < this.searchResults.recordKey1.length; ++var1) {
         if (!this.searchResults.recordKey1[var1].equals("M")) {
            this.searchResults.resultList.setIcon(var1 + 1, 1);
         }
      }

      this.searchResults.resultList.reDraw();
   }

   boolean checkFields() {
      if (!super.user.u.isnumeric(this.menunum, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.ischaracter(this.menudesc, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl1, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl2, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl3, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl4, super.user.mainmsg)) {
         return false;
      } else {
         return super.user.u.isnumeric(this.menuauthlvl5, super.user.mainmsg);
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key != 9) {
               return false;
            } else if (var1.target.equals(this.menuname)) {
               super.user.u.cursor(this.menunum);
               return true;
            } else if (var1.target.equals(this.menunum)) {
               super.user.u.cursor(this.menutype);
               return true;
            } else {
               if (this.menutype.getSelectedItem().equals("Menu")) {
                  if (var1.target.equals(this.menutype)) {
                     super.user.u.cursor(this.menuobject);
                     return true;
                  }
               } else if (!this.menutype.getSelectedItem().equals("Program Module") && !this.menutype.getSelectedItem().equals("AutoLoad Program Module")) {
                  if (var1.target.equals(this.menutype)) {
                     super.user.u.cursor(this.menuparm);
                     return true;
                  }
               } else if (var1.target.equals(this.menutype)) {
                  super.user.u.cursor(this.menuobjectsel);
                  return true;
               }

               if (var1.target.equals(this.menuobject)) {
                  super.user.u.cursor(this.menuparm);
                  return true;
               } else if (var1.target.equals(this.menuobjectsel)) {
                  super.user.u.cursor(this.menuparm);
                  return true;
               } else if (var1.target.equals(this.menuparm)) {
                  super.user.u.cursor(this.menudesc);
                  return true;
               } else if (var1.target.equals(this.menudesc)) {
                  super.user.u.cursor(this.menutextcolor);
                  return true;
               } else if (var1.target.equals(this.menutextcolor)) {
                  super.user.u.cursor(this.menutabcolor);
                  return true;
               } else if (var1.target.equals(this.menutabcolor)) {
                  super.user.u.cursor(this.menustatus);
                  return true;
               } else if (var1.target.equals(this.menustatus)) {
                  super.user.u.cursor(this.menuauth1);
                  return true;
               } else if (var1.target.equals(this.menuauth1)) {
                  super.user.u.cursor(this.menuauthlvl1);
                  return true;
               } else if (var1.target.equals(this.menuauthlvl1)) {
                  super.user.u.cursor(this.menuauth2);
                  return true;
               } else if (var1.target.equals(this.menuauth2)) {
                  super.user.u.cursor(this.menuauthlvl2);
                  return true;
               } else if (var1.target.equals(this.menuauthlvl2)) {
                  super.user.u.cursor(this.menuauth3);
                  return true;
               } else if (var1.target.equals(this.menuauth3)) {
                  super.user.u.cursor(this.menuauthlvl3);
                  return true;
               } else if (var1.target.equals(this.menuauthlvl3)) {
                  super.user.u.cursor(this.menuauth4);
                  return true;
               } else if (var1.target.equals(this.menuauth4)) {
                  super.user.u.cursor(this.menuauthlvl4);
                  return true;
               } else if (var1.target.equals(this.menuauthlvl4)) {
                  super.user.u.cursor(this.menuauth5);
                  return true;
               } else if (var1.target.equals(this.menuauth5)) {
                  super.user.u.cursor(this.menuauthlvl5);
                  return true;
               } else {
                  if (var1.target.equals(this.menuauthlvl5)) {
                     super.user.u.cursor(this.menuname);
                     return true;
                  }

                  return true;
               }
            }
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target.equals(this.searchResults.resultList)) {
               long var8 = (new Date()).getTime();
               if (var8 - this.lastEventTime < 500L) {
                  return true;
               }

               this.lastEventTime = var8;
               int var10 = (Integer)var1.arg;
               String var12 = this.searchResults.resultList.getItem(var10);
               if (this.stackIndex > 0 && var12 != null && !var12.equals("...")) {
                  this.loadOption(var10);
                  ((Container)this).deliverEvent(new Event(this.menutype, 1001, ""));
               }

               if (var12 != null && (this.stackIndex == 0 || var12.equals("..."))) {
                  this.insertRequested = false;
                  this.menuname.setEditable(false);
                  this.menunum.setEditable(false);
                  this.traverseList(false);
               }
            }

            return true;
         case 1001:
            if (var1.target instanceof TextField) {
               this.checkFields();
            }

            if (var1.target instanceof JDPList) {
               long var2 = (new Date()).getTime();
               this.lastEventTime = var2;
               if (var2 - this.lastEventTime1 < 500L) {
                  return true;
               }

               this.lastEventTime1 = var2;
               if (var1.target.equals(this.searchResults.resultList)) {
                  this.insertRequested = false;
                  this.menuname.setEditable(false);
                  this.menunum.setEditable(false);
                  this.traverseList(false);
                  return true;
               }
            }

            if (var1.target instanceof Button) {
               String var6 = (String)var1.arg;
               if (var6.compareTo("Apply") == 0) {
                  if (this.checkFields() && this.saveOption()) {
                     this.traverseList(true);
                  }

                  return true;
               }

               if (var6.compareTo("Reset") == 0) {
                  this.insertRequested = false;
                  this.menuname.setEditable(false);
                  this.menunum.setEditable(false);
                  this.loadOption(this.searchResults.resultList.getSelectedIndex());
                  ((Container)this).deliverEvent(new Event(this.menutype, 1001, ""));
                  return true;
               }

               if (var6.compareTo("Remove") == 0) {
                  String var9 = "Press again to confirm removal of selected menu option.";
                  if (super.user.mainmsg.getStatusMsg().equals(var9)) {
                     this.deleteRequested = true;
                     if (this.saveOption()) {
                        this.clearFields();
                        this.traverseList(true);
                     }
                  } else {
                     super.user.mainmsg.setStatusMsg(var9, 10);
                  }

                  return true;
               }

               if (var6.compareTo("New") == 0) {
                  this.insertRequested = true;
                  this.menuname.setEditable(true);
                  this.menunum.setEditable(true);
                  this.clearFields();
                  return true;
               }

               if (var6.compareTo("Copy") == 0) {
                  this.menunum.setText("");
                  this.insertRequested = true;
                  this.menuname.setEditable(true);
                  this.menunum.setEditable(true);
                  return true;
               }
            }

            if (var1.target instanceof JDPChoice) {
               if (var1.target.equals(this.menutype)) {
                  this.toggleTypeDisplay();
               }

               return true;
            } else {
               if (var1.target.equals(this.JDPButton1)) {
                  JDPFileDialog var7 = new JDPFileDialog(super.user, super.user.jdpMainWindow, "Select the class file");
                  JDPFilePicker var3 = var7.getFilePicker();
                  var3.setMode(0);
                  var3.setMultipleSelections(false);
                  var3.addFilter("Java Class Files", "*.class");
                  var3.loadFiles(this.JDPDirectory, false);
                  var7.display();
                  String var4 = var3.getSelectedFile();
                  int var5 = 0;
                  if ((var5 = var4.indexOf(".")) > 0) {
                     var4 = var4.substring(0, var5);
                  }

                  this.menuobject.setText(var4);
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void DetailGrid1Main() {
      this.DetailGrid1SetGridSettings();
   }

   void loadSystemOU() {
      String var1 = "SELECT OU FROM JDesignerPro System WHERE JDP:JDPSystem = '" + super.user.JDPSystem + "'";
      Vector var2 = new Vector();
      this.jaggSQL.execSQL(var1, var2);
      StringTokenizer var3 = new StringTokenizer((String)var2.elementAt(0));
      this.systemOU = var3.nextToken(this.jaggSQL.getSEP()).trim();
   }

   void DetailGrid1LoadGridMain(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      var2.totalDataRows = var1.length;
      int var3 = var1.length + 20;
      var2.currentText = new String[1][var3];
      var2.cellChanged = null;
      var2.rowChanged = null;
      var2.columnSelected = null;
      byte var4 = 1;
      var2.rowKey = new String[var3][var4];
      var2.recordLockValue = new String[var3];

      for(int var5 = 0; var5 < var3 - 20; ++var5) {
         var2.currentText[0][var5] = var1[var5];
      }

      var2.newTable();
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(var1.jaggPath);
         this.jaggSQL.loadSettings(var1);
      }

      this.JDPDirectory = var1.JDesignerPro.JDPDirectory;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      this.menuStack = new String[50];
      String var8 = "DISTINCT menuname";
      String var9 = "FROM JDPMenu WHERE JDPSystem = '" + var1.JDPSystem + "'";
      this.psortChoice = new String[1];
      this.psortChoice[0] = "menuname";
      this.pdisplayChoice = new String[1];
      this.pdisplayChoice[0] = "menuname";
      String[] var10 = new String[]{""};
      String var11 = var10[0];
      boolean var12 = true;
      String var13 = "Total Entries:";
      this.menuname = new TextField("", 20);
      this.menunum = new TextField("", 3);
      this.menuname.setEditable(false);
      this.menunum.setEditable(false);
      this.loadMenuObject();
      this.menuparm = new TextField("", 35);
      this.menudesc = new TextField("", 30);
      this.menutextcolor = new JDPChoice();
      this.menutextcolor.addItem("Black");
      this.menutextcolor.addItem("Gray");
      this.menutextcolor.addItem("Blue");
      this.menutextcolor.addItem("Cyan");
      this.menutextcolor.addItem("DarkGray");
      this.menutextcolor.addItem("Green");
      this.menutextcolor.addItem("LightGray");
      this.menutextcolor.addItem("Magenta");
      this.menutextcolor.addItem("Orange");
      this.menutextcolor.addItem("Pink");
      this.menutextcolor.addItem("Red");
      this.menutextcolor.addItem("White");
      this.menutextcolor.addItem("Yellow");
      this.menutabcolor = new JDPChoice();
      this.menutabcolor.addItem("Black");
      this.menutabcolor.addItem("Gray");
      this.menutabcolor.addItem("Blue");
      this.menutabcolor.addItem("Cyan");
      this.menutabcolor.addItem("DarkGray");
      this.menutabcolor.addItem("Green");
      this.menutabcolor.addItem("LightGray");
      this.menutabcolor.addItem("Magenta");
      this.menutabcolor.addItem("Orange");
      this.menutabcolor.addItem("Pink");
      this.menutabcolor.addItem("Red");
      this.menutabcolor.addItem("White");
      this.menutabcolor.addItem("Yellow");
      this.menutype = new JDPChoice();
      this.menutype.addItem("Menu");
      this.menutype.addItem("Program Module");
      this.menutype.addItem("AutoLoad Program Module");
      this.menutype.addItem("Build Test Panel");
      this.menustatus = new JDPChoice();
      this.menustatus.addItem("Active");
      this.menustatus.addItem("Inactive");
      this.menuauth1 = new TextField("", 11);
      this.menuauth2 = new TextField("", 11);
      this.menuauth3 = new TextField("", 11);
      this.menuauth4 = new TextField("", 11);
      this.menuauth5 = new TextField("", 11);
      this.menuauthlvl1 = new TextField("", 3);
      this.menuauthlvl2 = new TextField("", 3);
      this.menuauthlvl3 = new TextField("", 3);
      this.menuauthlvl4 = new TextField("", 3);
      this.menuauthlvl5 = new TextField("", 3);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Menu:"));
      ((Container)var7).add("Right", this.menuname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Option Number:"));
      ((Container)var7).add("Right", this.menunum);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Menu Option Type:"));
      ((Container)var7).add("Right", this.menutype);
      this.lbl4 = new JDPWrapLabel(var1, "Points to Menu:");
      ((Container)var7).add("Left", this.lbl4);
      this.loadMenuObjectSel();
      this.JDPButton1 = new JDPButton(JDPButton.getIconValue("Load"), "", JDPButton.getAlignmentValue("Center"));
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout());
      ((Container)var14).add("Left", this.menuobject);
      ((Container)var14).add("Left", this.JDPButton1);
      this.objectPanel = new JDPCardPanel();
      this.objectPanel.setLayout(new CardLayout());
      this.objectPanel.add("Menu", this.menuobjectsel);
      this.objectPanel.add("Program Module", var14);
      this.objectPanel.add("Build Test Panel", new Panel());
      ((Container)var7).add("Right", this.objectPanel);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Module Parameter:"));
      ((Container)var7).add("Right", this.menuparm);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Description on Menu Tab:"));
      ((Container)var7).add("Right", this.menudesc);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Color of Menu Text/Tab:"));
      Panel var15 = new Panel();
      ((Container)var15).setLayout(new JDPLineLayout(1));
      ((Container)var15).add("Left", this.menutextcolor);
      ((Container)var15).add("Left", this.menutabcolor);
      ((Container)var7).add("Right", var15);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Status:"));
      ((Container)var7).add("Right", this.menustatus);
      if (var1.JDesignerPro.NDSPath == null) {
         ((Container)var7).add("Left", new JDPWrapLabel(var1, "Authorization Codes/Levels:"));
         Panel var16 = new Panel();
         ((Container)var16).setLayout(new JDPLineLayout(1));
         ((Container)var16).add("Left", this.menuauth1);
         ((Container)var16).add("Left", this.menuauthlvl1);
         ((Container)var16).add("Left", this.menuauth2);
         ((Container)var16).add("Left", this.menuauthlvl2);
         ((Container)var7).add("Right", var16);
         ((Container)var7).add("Left", new JDPWrapLabel(var1, ""));
         Panel var17 = new Panel();
         ((Container)var17).setLayout(new JDPLineLayout(1));
         ((Container)var17).add("Left", this.menuauth3);
         ((Container)var17).add("Left", this.menuauthlvl3);
         ((Container)var17).add("Left", this.menuauth4);
         ((Container)var17).add("Left", this.menuauthlvl4);
         ((Container)var7).add("Right", var17);
         ((Container)var7).add("Left", new JDPWrapLabel(var1, ""));
         Panel var18 = new Panel();
         ((Container)var18).setLayout(new JDPLineLayout(1));
         ((Container)var18).add("Left", this.menuauth5);
         ((Container)var18).add("Left", this.menuauthlvl5);
         ((Container)var7).add("Right", var18);
      } else {
         ((Container)var7).add("Left", new JDPWrapLabel(var1, "Authorized Users/Groups:"));
         this.jaggSQL.setFCTN("NDSexecSQL");
         this.loadSystemOU();
         var8 = "JDP:menuname";
         var9 = "FROM JDesignerPro Menu PARENT=" + this.systemOU;
         this.psortChoice[0] = "JDP:menuname";
         this.pdisplayChoice[0] = "JDP:menuname";
         this.DetailGrid1Main();
         this.DetailGrid1.setMinimumWidth(200);
         this.DetailGrid1.setMinimumHeight(120);
         this.DetailGrid1.setScrollSouthDisabled(true);
         ((Container)var7).add("Right", this.DetailGrid1);
      }

      ((Container)var6).add("Center", var7);
      String[] var19 = new String[]{"Apply", "Reset", "Remove", "New", "Copy"};
      int[] var20 = new int[]{0, 6, 8, 9, 10};
      JDPButtons var21 = new JDPButtons(var1, var19, var20, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", var21);
      this.popuppanel.addComponent(var21.button[0], "Apply Changes", "Save changes to the database");
      this.popuppanel.addComponent(var21.button[1], "Undo Changes", "Undo changes by reloading the record");
      this.popuppanel.addComponent(var21.button[2], "Remove record", "Remove the current menu option from the database");
      this.popuppanel.addComponent(var21.button[3], "New Option", "Create a new menu option");
      this.popuppanel.addComponent(var21.button[4], "Copy Option", "Copy this menu option");
      ((Container)var4).add("Center", var6);
      this.searchResults = new JDPSearchResults(var1, (Container)var2, false, this.jaggSQL, false, var8, (String[])null, var9, var10, this.psortChoice, this.pdisplayChoice, var11, var12, var13);
      this.searchResults.setListEvents(true);
      this.searchResults.setIcon(25);
      ((Container)var4).add("West", this.searchResults);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Menu Maintenance", var4, "North"));
      this.searchResults.loadList();
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }

   void DetailGrid1SetGridSettings() {
      if (this.DetailGrid1 == null) {
         this.DetailGrid1 = new JDPTextGrid(super.user);
      }

      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 1;
      var1.fieldTypeCol = new int[var2];
      var1.columnHeader = new String[var2];
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnDisabled = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[0] = true;
      var1.columnWidth[0] = 170;
      var1.columnHeader[0] = "Group/User";
      var1.setRowHeaderOn(false);
      this.DetailGrid1LoadEmptyGrid();
      this.DetailGrid1LoadChoices();
   }
}
