import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPObjectSelection extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPScrollPanel ScrollPanel1;
   Label Label1;
   JDPChoice Choice1;
   Vector valueChoice1;
   Label Label2;
   JDPCardPanel CardPanel1;
   Panel Panel1;
   JDPComboBox classFile;
   JDPButton JDPButton1;
   Panel Panel2;
   JDPChoice Choice2;
   Vector valueChoice2;
   Panel Panel3;
   TextField CommandToRun;
   JDPButton JDPButton2;
   Label Label3;
   JDPCardPanel CardPanel2;
   Panel Panel4;
   JDPChoice constructors;
   Vector valueconstructors;
   Panel Panel5;
   TextField commandParameters;
   Label Label4;
   TextField classParameters;
   public String lastClassLoaded = "";

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label1 = new Label("Object type:", 0);
      this.Choice1Main();
      this.Label2 = new Label("Java Class:", 0);
      this.CardPanel1 = new JDPCardPanel();
      this.Panel1 = new Panel();
      this.classFileMain();
      this.JDPButton1 = new JDPButton(JDPButton.getIconValue("Load"), "", JDPButton.getAlignmentValue("Center"));
      this.Panel2 = new Panel();
      this.Choice2Main();
      this.Panel3 = new Panel();
      this.CommandToRun = new TextField("", 50);
      this.JDPButton2 = new JDPButton(JDPButton.getIconValue("Load"), "JDPButton2", JDPButton.getAlignmentValue("Center"));
      this.Label3 = new Label("Constructor:", 0);
      this.CardPanel2 = new JDPCardPanel();
      this.Panel4 = new Panel();
      this.constructorsMain();
      this.Panel5 = new Panel();
      this.commandParameters = new TextField("", 50);
      this.Label4 = new Label("Parameters:", 0);
      this.classParameters = new TextField("", 50);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.Choice1);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.CardPanel1);
      this.CardPanel1.add("Panel1", this.Panel1);
      this.Panel1.setLayout(new JDPLineLayout());
      this.Panel1.add("Left", this.classFile);
      this.Panel1.add("Left", this.JDPButton1);
      this.CardPanel1.add("Panel2", this.Panel2);
      this.Panel2.setLayout(new JDPLineLayout());
      this.Panel2.add("Left", this.Choice2);
      this.CardPanel1.add("Panel3", this.Panel3);
      this.Panel3.setLayout(new JDPLineLayout());
      this.Panel3.add("Left", this.CommandToRun);
      this.Panel3.add("Left", this.JDPButton2);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.CardPanel2);
      this.CardPanel2.add("Panel4", this.Panel4);
      this.Panel4.setLayout(new BorderLayout());
      this.Panel4.add("Center", this.constructors);
      this.CardPanel2.add("Panel5", this.Panel5);
      this.Panel5.setLayout(new JDPLineLayout());
      this.Panel5.add("Left", this.commandParameters);
      this.ScrollPanel1.add("Left", this.Label4);
      this.ScrollPanel1.add("Right", this.classParameters);
      this.Label1.setFont(new Font("Helvetica", 1, 11));
      this.Label2.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.classFile, "Enter or select the class file", "Enter or select the class file to create and instance of.");
      this.popuppanel.addComponent(this.JDPButton1, "", "Browse the file system for the class to instantiate");
      this.popuppanel.addComponent(this.Choice2, "", "Select the Job Stream to execute");
      this.popuppanel.addComponent(this.CommandToRun, "", "Enter the command to run");
      this.popuppanel.addComponent(this.JDPButton2, "Browse", "Browse the file system for the command to run");
      this.Label3.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.constructors, "", "Choose the constructor to use when creating an instance of this class.");
      this.popuppanel.addComponent(this.commandParameters, "", "Enter the parameters required for this command or constructor.");
      this.Label4.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.classParameters, "", "Enter the parameters to pass to this class");
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.Choice1)) {
               this.Label2.setText(this.Choice1.getSelectedItem() + ":");
               if (this.Choice1.getSelectedKey().equals("C")) {
                  this.CardPanel1.setSelectedComp("Panel1");
                  this.Label3.show();
                  this.Label3.setText("Constructor:");
                  this.CardPanel2.show();
                  this.CardPanel2.setSelectedComp("Panel4");
                  this.Label4.show();
                  this.classParameters.show();
               } else if (this.Choice1.getSelectedKey().equals("A")) {
                  this.CardPanel1.setSelectedComp("Panel3");
                  this.Label2.setText("Command:");
                  this.Label3.show();
                  this.Label3.setText("Parameters:");
                  this.CardPanel2.show();
                  this.CardPanel2.setSelectedComp("Panel5");
                  this.Label4.hide();
                  this.classParameters.hide();
               } else if (this.Choice1.getSelectedKey().equals("J")) {
                  this.CardPanel1.setSelectedComp("Panel2");
                  this.CardPanel2.hide();
                  this.Label3.hide();
                  this.Label4.hide();
                  this.classParameters.hide();
               }

               this.ScrollPanel1.reDrawPanel();
               this.ScrollPanel1.layout();
               this.ScrollPanel1.paintAll(this.ScrollPanel1.getGraphics());
               return true;
            } else if (var1.target.equals(this.classFile)) {
               this.loadconstructors(this.classFile.getText());
               return true;
            } else if (var1.target.equals(this.JDPButton1)) {
               JDPFileDialog var4 = new JDPFileDialog(this.user, this.user.jdpMainWindow, "Select the class to Instantiate");
               JDPFilePicker var5 = var4.getFilePicker();
               var5.setMode(0);
               var5.setMultipleSelections(false);
               var5.addFilter("Java Class Files", "*.class");
               var5.loadFiles(this.user.JDesignerPro.JDPDirectory, false);
               ((Dialog)var4).show();
               this.classFile.setText(var5.getSelectedFile());
               this.loadconstructors(this.classFile.getText());
               return true;
            } else if (var1.target.equals(this.JDPButton2)) {
               JDPFileDialog var2 = new JDPFileDialog(this.user, this.user.jdpMainWindow, "Select the application or command to run");
               JDPFilePicker var3 = var2.getFilePicker();
               var3.setMode(0);
               var3.setMultipleSelections(false);
               if (JDesignerPro.serverPlatform.startsWith("Win")) {
                  var3.addFilter("Applications", "*.exe");
                  var3.addFilter("Batch files", "*.bat");
                  var3.addFilter("All files", "");
               }

               var3.loadFiles(this.user.JDesignerPro.JDPDirectory, false);
               ((Dialog)var2).show();
               this.CommandToRun.setText(var3.getSelectedFullPath());
               return true;
            } else {
               if (var1.target.equals(this.constructors)) {
                  this.classParameters.setText(this.constructors.getSelectedItem().substring(1, this.constructors.getSelectedItem().length() - 1));
                  return true;
               }

               return false;
            }
         case 1005:
            if (var1.target.equals(this.classFile)) {
               this.loadconstructors(this.classFile.getText());
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public String getObjectType() {
      return this.Choice1.getSelectedKey();
   }

   public String getObject() {
      if (this.Choice1.getSelectedKey().equals("C")) {
         return this.classFile.getText();
      } else if (this.Choice1.getSelectedKey().equals("A")) {
         return this.CommandToRun.getText();
      } else {
         return this.Choice1.getSelectedKey().equals("J") ? this.Choice2.getSelectedItem() : "";
      }
   }

   public String getParameters() {
      if (this.Choice1.getSelectedKey().equals("C")) {
         return this.classParameters.getText();
      } else if (this.Choice1.getSelectedKey().equals("A")) {
         return this.commandParameters.getText();
      } else {
         return this.Choice1.getSelectedKey().equals("J") ? "" : "";
      }
   }

   public void setObjectType(String var1) {
      this.Choice1.selectKey(var1);
      ((Container)this).deliverEvent(new Event(this.Choice1, 1001, ""));
   }

   public void setObject(String var1) {
      if (this.Choice1.getSelectedKey().equals("C")) {
         this.classFile.setText(var1);
      } else if (this.Choice1.getSelectedKey().equals("A")) {
         this.CommandToRun.setText(var1);
      } else {
         if (this.Choice1.getSelectedKey().equals("J")) {
            this.Choice2.select(var1);
         }

      }
   }

   public void setParameters(String var1) {
      if (this.Choice1.getSelectedKey().equals("C")) {
         this.classParameters.setText(var1);
      } else {
         if (this.Choice1.getSelectedKey().equals("A")) {
            this.commandParameters.setText(var1);
         }

      }
   }

   public String getConstructor() {
      return this.Choice1.getSelectedKey().equals("C") ? this.constructors.getSelectedItem() : "";
   }

   public void setConstructor(String var1) {
      if (this.Choice1.getSelectedKey().equals("C")) {
         this.loadconstructors(this.getObject());
         this.constructors.select(var1);
      }

   }

   public void Choice1Main() {
      if (this.Choice1 == null) {
         this.Choice1 = new JDPChoice();
      }

      String[] var1 = new String[]{"Java Class", "Application or Command", "JobStream", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"C", "A", "J", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.Choice1.loadChoice(var1, var2);
   }

   public void classFileMain() {
      if (this.classFile == null) {
         this.classFile = new JDPComboBox(this.user, "", 20);
      } else {
         this.classFile.clear();
      }

      this.jaggSQL.loadSettings(this.user);
      this.jaggSQL.setFCTN("ListFiles");
      this.jaggSQL.setFCTNP(this.user.JDesignerPro.JDPDirectory + ";");
      Vector var1 = new Vector();
      this.jaggSQL.execSQL("", var1);
      this.classFile.addItem("", "");

      for(int var3 = 0; var3 < var1.size(); ++var3) {
         StringTokenizer var4 = new StringTokenizer((String)var1.elementAt(var3), this.jaggSQL.getSEP());
         String var2 = var4.nextToken();
         String var5 = var4.nextToken();
         if (var5.equals("F") && var2.endsWith(".class")) {
            var2 = var2.substring(0, var2.length() - 6);
            this.classFile.addItem(var2, var2);
         }
      }

      this.jaggSQL.setFCTN("");
      this.jaggSQL.setFCTNP("");
   }

   public void Choice2Main() {
      if (this.Choice2 == null) {
         this.Choice2 = new JDPChoice();
      }

      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.loadSettings(this.user);
      this.Choice2.loadChoice(this.user, var1, "STREAMNAME", "STREAMNAME", "JDPJobs", "JDPSYSTEM = '" + this.user.JDPSystem + "'");
   }

   public void constructorsMain() {
      if (this.constructors == null) {
         this.constructors = new JDPChoice();
      }

   }

   public void loadconstructors(String var1) {
      var1 = this.user.u.replace(var1, ".class", "");
      if (!var1.equals("") && !var1.equals(this.lastClassLoaded)) {
         this.lastClassLoaded = var1;
         Vector var2 = new Vector();
         this.jaggSQL.setFCTN("JavaBeanGetConstructors");
         this.jaggSQL.setFCTNP(var1 + ";");
         this.jaggSQL.execSQL("", var2);
         this.constructors.clear();
         String var3 = "";

         for(int var4 = 0; var4 < var2.size(); ++var4) {
            if (!((String)var2.elementAt(var4)).equals(" ")) {
               StringTokenizer var5 = new StringTokenizer((String)var2.elementAt(var4), this.jaggSQL.getSEP());
               var3 = var3 + "(";
               int var6 = var5.countTokens() - 1;
               var5.nextToken();

               for(int var7 = 0; var7 < var6; ++var7) {
                  if (var7 > 0) {
                     var3 = var3 + ",";
                  }

                  var3 = var3 + this.convertParm(var5.nextToken());
               }

               var3 = var3 + ")";
               this.constructors.addItem(var3);
            }

            var3 = "";
         }

         this.jaggSQL.setFCTN("");
         this.jaggSQL.setFCTNP("");
         if (this.constructors.getSelectedItem() != null) {
            this.classParameters.setText(this.constructors.getSelectedItem().substring(1, this.constructors.getSelectedItem().length() - 1));
         }

      }
   }

   public String convertParm(String var1) {
      try {
         if (var1.indexOf("[[L") >= 0) {
            var1 = var1.substring(3, var1.length() - 1) + "[][]";
         } else if (var1.indexOf("[I") >= 0) {
            var1 = "int[]";
         } else if (var1.indexOf("[Z") >= 0) {
            var1 = "boolean[]";
         } else if (var1.indexOf("[C") >= 0) {
            var1 = "char[]";
         } else if (var1.indexOf("[B") >= 0) {
            var1 = "byte[]";
         } else if (var1.indexOf("[") >= 0) {
            var1 = var1.substring(2, var1.length() - 1) + "[]";
         }

         if (var1.startsWith("java")) {
            int var2 = var1.lastIndexOf(".");
            if (var2 > 0) {
               var1 = var1.substring(var2 + 1);
            }
         }
      } catch (Exception var3) {
         System.out.println("Parm value: " + var1);
         ((Throwable)var3).printStackTrace();
      }

      return var1;
   }
}
