import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.Panel;
import java.awt.Rectangle;

public class JDPPopupComponent extends Panel {
   JDPUser user;
   Container targetPanel;
   Component listener;

   public void paint(Graphics var1) {
      this.update(var1);
   }

   public void setEventListener(Component var1) {
      this.listener = var1;
   }

   public Component getEventListener() {
      return this.listener;
   }

   public JDPPopupComponent(JDPUser var1, Panel var2) {
      this.user = var1;
      this.targetPanel = var2;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(((Component)var2).getFont());
      if (!JDPButton.activated) {
         System.out.println("Software Violation - this class may only be used in conjunction with JDesignerPro.");
      } else {
         ((Component)this).hide();
      }
   }

   public JDPPopupComponent(JDPUser var1, Container var2) {
      this.user = var1;
      this.targetPanel = var2;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(((Component)var2).getFont());
      if (!JDPButton.activated) {
         System.out.println("Software Violation - this class may only be used in conjunction with JDesignerPro.");
      } else {
         ((Component)this).hide();
      }
   }

   public void update(Graphics var1) {
   }

   public void display(int var1, int var2) {
      this.display(var1, var2, -1);
   }

   public void display(int var1, int var2, int var3) {
      ((Component)this).move(var1, var2);
      Container var4 = super.getParent();
      ((Component)this).show();
      if (System.getProperty("java.vendor").startsWith("Netscape") && System.getProperty("os.name").equals("SunOS")) {
         var4.remove(this);
         var4.add(this);
         ((Component)this).show();
      }

      int var5 = ((Container)this).preferredSize().height;
      int var6 = ((Container)this).preferredSize().width;
      Rectangle var7 = ((Component)var4).bounds();

      for(int var8 = var1 + var6; var8 > var7.width; var8 = var1 + var6) {
         var1 -= 5;
      }

      int var9 = var2 + var5;
      if (var3 == -1) {
         while(var9 > var7.height) {
            var2 -= 5;
            var9 = var2 + var5;
         }
      } else if (var9 > var7.height - 30 || var7.height - 10 - var2 < 40) {
         var5 = var7.height - 30 - var2;
         if (var5 < 60) {
            var5 = ((Container)this).preferredSize().height;
            var2 = var3 - var5;
            if (var2 < 10) {
               var2 = 10;
               var5 = var3 - var2;
            }
         }
      }

      if (var1 < 0) {
         var1 = 0;
      }

      if (var2 < 0) {
         var2 = 0;
      }

      ((Component)this).reshape(var1, var2, var6, var5);
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   public boolean handleEvent(Event var1) {
      if (this.listener != null) {
         this.listener.postEvent(var1);
         return true;
      } else {
         return false;
      }
   }
}
