import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPPreviewServerJob extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPTabSelectPanel TabPanel1;
   JDPChiselFramePanel ChiselPanel2;
   Panel Panel2;
   JDPScrollPanel ScrollPanel1;
   Label Label1;
   TextField jobName;
   Label Label2;
   TextField className;
   Label Label3;
   JDPChoice constructors;
   Vector valueconstructors;
   Label Label4;
   TextField classParameters;
   Label Label5;
   JDPChoice jobQueue;
   Vector valuejobQueue;
   Label Label6;
   JDPChoice holdOnQueue;
   Vector valueholdOnQueue;
   JDPButtons JDPButtons2;
   JDPJobQueueMaint JDPJobQueueMaint1;
   JDPSubsystemMaint JDPSubsystemMaint1;
   JDPJobLogInquiry JDPJobLogInquiry1;
   JDPButtons JDPButtons1;
   JDPRMIConnection RMIConnection1;
   int jobNumber;
   String lastClassLoaded = "";

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Server Job Preview");
      this.Panel1 = new Panel();
      String[] var4 = new String[4];
      Panel[] var5 = new Panel[4];
      var5[0] = new Panel();
      var5[0].setLayout(new BorderLayout());
      var4[0] = "1. Start Job...";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "2. Check Job Queue...";
      var5[2] = new Panel();
      var5[2].setLayout(new BorderLayout());
      var4[2] = "3. Check Subsystems..";
      var5[3] = new Panel();
      var5[3].setLayout(new BorderLayout());
      var4[3] = "4. Check Job Log...";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.ChiselPanel2 = new JDPChiselFramePanel(var1, "Start the job in the Enterprise Server");
      this.Panel2 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label1 = new Label("Job Name:", 0);
      this.jobName = new TextField("", 30);
      this.Label2 = new Label("Class to run:", 0);
      this.className = new TextField("", 30);
      this.Label3 = new Label("Constructor:", 0);
      this.constructorsMain();
      this.Label4 = new Label("Parameters:", 0);
      this.classParameters = new TextField("", 40);
      this.Label5 = new Label("Job Queue:", 0);
      this.jobQueueMain();
      this.Label6 = new Label("Hold on queue:", 0);
      this.holdOnQueueMain();
      String[] var6 = new String[]{"Start Job"};
      int[] var7 = new int[]{JDPButton.getIconValue("Go")};
      this.JDPButtons2 = new JDPButtons(var1, var6, var7, JDPButtons.getAlignmentValue("Horizontal"));
      this.JDPJobQueueMaint1 = new JDPJobQueueMaint();
      this.JDPJobQueueMaint1.InitClass(var1, var2, var3);
      this.JDPSubsystemMaint1 = new JDPSubsystemMaint();
      this.JDPSubsystemMaint1.InitClass(var1, var2, var3);
      this.JDPJobLogInquiry1 = new JDPJobLogInquiry();
      this.JDPJobLogInquiry1.InitClass(var1, var2, var3);
      String[] var8 = new String[]{"Locate Job"};
      int[] var9 = new int[]{JDPButton.getIconValue("Arrow")};
      this.JDPButtons1 = new JDPButtons(var1, var8, var9, JDPButtons.getAlignmentValue("Horizontal"));
      this.RMIConnection1 = new JDPRMIConnection(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.TabPanel1);
      var5[0].add("Center", this.ChiselPanel2);
      this.ChiselPanel2.add("Center", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.jobName);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.className);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.constructors);
      this.ScrollPanel1.add("Left", this.Label4);
      this.ScrollPanel1.add("Right", this.classParameters);
      this.ScrollPanel1.add("Left", this.Label5);
      this.ScrollPanel1.add("Right", this.jobQueue);
      this.ScrollPanel1.add("Left", this.Label6);
      this.ScrollPanel1.add("Right", this.holdOnQueue);
      this.Panel2.add("South", this.JDPButtons2);
      var5[1].add("Center", this.JDPJobQueueMaint1);
      var5[2].add("Center", this.JDPSubsystemMaint1);
      var5[3].add("Center", this.JDPJobLogInquiry1);
      this.Panel1.add("South", this.JDPButtons1);
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(1, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(2, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(3, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.className)) {
               this.constructorsMain();
               return true;
            } else if (var1.target.equals(this.constructors)) {
               this.classParameters.setText(this.constructors.getSelectedItem().substring(1, this.constructors.getSelectedItem().length() - 1));
               return true;
            } else if (var1.target.equals(this.JDPButtons2.button[0])) {
               this.submitJob(this.jobName.getText(), this.className.getText(), this.constructors.getSelectedItem(), this.classParameters.getText(), this.jobQueue.getSelectedItem(), this.holdOnQueue.getSelectedItem());
               return true;
            } else {
               if (var1.target.equals(this.JDPButtons1.button[0])) {
                  this.locateJob();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void MainMethod() {
   }

   public void locateJob() {
      String[] var1 = new String[0];
      String[] var2 = new String[0];
      Integer var3 = (Integer)this.RMIConnection1.getJobInfo(this.jobNumber, "getJobStatus", var1, var2);
      if (var3 != null) {
         int var4 = var3;
         if (this.locateJobInJobQueue(var4)) {
            this.TabPanel1.select(1);
            return;
         }

         if (this.locateJobInSubsystem(var4)) {
            this.TabPanel1.select(2);
            return;
         }
      } else if (this.locateJobInJobLog()) {
         this.TabPanel1.select(3);
      }

   }

   public boolean locateJobInJobQueue(int var1) {
      if (var1 != 2 && var1 != 3) {
         return false;
      } else {
         this.user.mainmsg.setStatusMsg("Job is presently queued.", 10);
         this.JDPJobQueueMaint1.LoadGridWithJobQueueData();
         this.JDPJobQueueMaint1.locateAndLoadJob(this.jobNumber);
         return true;
      }
   }

   public boolean locateJobInSubsystem(int var1) {
      if (var1 != 4 && var1 != 5) {
         return false;
      } else {
         this.user.mainmsg.setStatusMsg("Job is presently running.", 10);
         this.JDPSubsystemMaint1.LoadGridWithSubsystemData();
         this.JDPSubsystemMaint1.locateAndLoadJob(this.jobNumber);
         return true;
      }
   }

   public boolean locateJobInJobLog() {
      this.user.mainmsg.setStatusMsg("Job has ended.", 10);
      this.JDPJobLogInquiry1.setSearchOn("Job Name");
      this.JDPJobLogInquiry1.setMatchUsing("Begins with");
      this.JDPJobLogInquiry1.setMatchConstant(this.jobName.getText());
      this.JDPJobLogInquiry1.newSearch();
      this.JDPJobLogInquiry1.locateAndLoadJob(this.jobNumber);
      return true;
   }

   public void submitJob(String var1, String var2, String var3, String var4, String var5, String var6) {
      String var7 = this.RMIConnection1.submitJob(var5, var1, "C", var2, var3, var4, 5, 5, var6.equals("Yes"), -1, "", "", "B");
      this.jobNumber = 0;
      if (var7 == null) {
         this.user.mainmsg.setStatusMsg("Job submission failed.", 10);
      } else if (var7.startsWith("Jobnumber:")) {
         this.jobNumber = Integer.parseInt(var7.substring(10));
         this.user.mainmsg.setStatusMsg("Job number " + var7.substring(10) + " successfully submitted to the server.", 10);
         this.locateJob();
      } else {
         this.user.mainmsg.setStatusMsg(var7, 20);
      }
   }

   public void setJobName(String var1) {
      if (!this.jobName.getText().equals(var1)) {
         this.classParameters.setText("");
      }

      this.jobName.setText(var1);
      this.TabPanel1.select(0);
   }

   public void setClassName(String var1) {
      this.className.setText(var1);
      this.constructorsMain();
   }

   public void constructorsMain() {
      if (this.constructors == null) {
         this.constructors = new JDPChoice();
      }

      String var1 = this.className.getText();
      if (!var1.equals("") && !var1.equals(this.lastClassLoaded)) {
         this.lastClassLoaded = var1;
         Vector var2 = new Vector();
         this.jaggSQL.setFCTN("JavaBeanGetConstructors");
         this.jaggSQL.setFCTNP(var1 + ";");
         this.jaggSQL.execSQL("", var2);
         this.constructors.clear();
         String var3 = "";

         for(int var4 = 0; var4 < var2.size(); ++var4) {
            if (!((String)var2.elementAt(var4)).equals(" ")) {
               StringTokenizer var5 = new StringTokenizer((String)var2.elementAt(var4), this.jaggSQL.getSEP());
               var3 = var3 + "(";
               int var6 = var5.countTokens() - 1;
               var5.nextToken();

               for(int var7 = 0; var7 < var6; ++var7) {
                  if (var7 > 0) {
                     var3 = var3 + ",";
                  }

                  var3 = var3 + this.convertParm(var5.nextToken());
               }

               var3 = var3 + ")";
               this.constructors.addItem(var3);
            }

            var3 = "";
         }

         this.jaggSQL.setFCTN("");
         this.jaggSQL.setFCTNP("");
         if (this.classParameters.getText().equals("") && this.constructors.getSelectedItem() != null) {
            this.classParameters.setText(this.constructors.getSelectedItem().substring(1, this.constructors.getSelectedItem().length() - 1));
         }

         this.constructors.layoutChoice();
      }
   }

   public String convertParm(String var1) {
      try {
         if (var1.indexOf("[[L") >= 0) {
            var1 = var1.substring(3, var1.length() - 1) + "[][]";
         } else if (var1.indexOf("[I") >= 0) {
            var1 = "int[]";
         } else if (var1.indexOf("[Z") >= 0) {
            var1 = "boolean[]";
         } else if (var1.indexOf("[C") >= 0) {
            var1 = "char[]";
         } else if (var1.indexOf("[B") >= 0) {
            var1 = "byte[]";
         } else if (var1.indexOf("[") >= 0) {
            var1 = var1.substring(2, var1.length() - 1) + "[]";
         }

         if (var1.startsWith("java")) {
            int var2 = var1.lastIndexOf(".");
            if (var2 > 0) {
               var1 = var1.substring(var2 + 1);
            }
         }
      } catch (Exception var3) {
         System.out.println("Parm value: " + var1);
         ((Throwable)var3).printStackTrace();
      }

      return var1;
   }

   public void jobQueueMain() {
      if (this.jobQueue == null) {
         this.jobQueue = new JDPChoice();
      }

      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.loadSettings(this.user);
      this.jobQueue.loadChoice(this.user, var1, "QUEUENAME", "QUEUENAME", "JDPQueue", "(1=1)");
      this.jobQueue.select("QIMMED");
   }

   public void holdOnQueueMain() {
      if (this.holdOnQueue == null) {
         this.holdOnQueue = new JDPChoice();
      }

      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.loadJdbcSettings("Test JDP");
      var1.setUID("");
      var1.setPWD("");
      var1.setMRW("1000");
      var1.setTOUT("60");
      String[] var2 = new String[]{"No", "Yes", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var3 = new String[]{"N", "Y", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.holdOnQueue.loadChoice(var2, var3);
   }
}
