import java.util.StringTokenizer;

public class JDPRMIConnection {
   JDPUser user;
   JDPJagg jaggSQL;

   public Object invokeByJobName(String var1, String var2, String[] var3, String[] var4) {
      return this.jaggSQL.invoke((String)null, var2, var3, var4, var1, 0);
   }

   public void setJobHeld(int var1, boolean var2, String var3) {
      String[] var4 = new String[]{"int", "boolean", "String"};
      String[] var5 = new String[]{Integer.toString(var1), var2 ? "true" : "false", var3};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setJobHeld", var4, var5);
   }

   public void setJobQueueHeld(String var1, boolean var2) {
      String[] var3 = new String[]{"String", "boolean"};
      String[] var4 = new String[]{var1, var2 ? "true" : "false"};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setJobQueueHeld", var3, var4);
   }

   public String submitJob(String var1, String var2, String var3, String var4, String var5, String var6, int var7, int var8, boolean var9, int var10, String var11, String var12, String var13) {
      String var14 = "01001";
      String var15 = "Unknown";
      if (this.user != null) {
         if (this.user.cust != null) {
            var15 = this.user.cust.getUsername();
         }

         if (this.user.JDPSystem != null) {
            var14 = this.user.JDPSystem;
         }
      }

      return this.submitJob(var14, var15, var1, var2, var3, var4, var5, var6, var7, var8, var9, var10, var11, var12, var13);
   }

   String submitJob(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, int var9, int var10, boolean var11, int var12, String var13, String var14, String var15) {
      String[] var16 = new String[]{var3, var1, var4, var2, var5, var6, var7, var8, Integer.toString(var9), Integer.toString(var10), var11 ? "true" : "false", Integer.toString(var12), var13, var14, var15};
      String var17 = "java.lang.String";
      String[] var18 = new String[]{var17, var17, var17, var17, var17, var17, var17, var17, "int", "int", "boolean", "int", var17, var17, var17};
      String var19 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "submitJob", var18, var16);
      return var19;
   }

   public Object getActiveJobInfo(int var1, String var2, String[] var3, String[] var4) {
      return this.jaggSQL.invoke("JDPActiveJob", var2, var3, var4, (String)null, var1);
   }

   public int[] getJobsForName(String var1) {
      String[] var2 = new String[]{"String"};
      String[] var3 = new String[]{var1};
      String var4 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "getJobsForName", var2, var3);
      if (var4.length() == 0) {
         return new int[0];
      } else {
         StringTokenizer var5 = new StringTokenizer(var4, ";");
         int[] var6 = new int[var5.countTokens()];

         for(int var7 = 0; var5.hasMoreTokens(); var6[var7++] = Integer.parseInt(var5.nextToken())) {
         }

         return var6;
      }
   }

   public Object invokeByJobNumber(int var1, String var2) {
      String[] var3 = new String[0];
      String[] var4 = new String[0];
      return this.jaggSQL.invoke((String)null, var2, var3, var4, (String)null, var1);
   }

   public Object invokeByJobNumber(int var1, String var2, String[] var3, String[] var4) {
      return this.jaggSQL.invoke((String)null, var2, var3, var4, (String)null, var1);
   }

   public JDPRMIConnection(JDPUser var1) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
   }

   public String killJob(int var1, String var2) {
      String[] var3 = new String[]{"int", "String"};
      String[] var4 = new String[]{Integer.toString(var1), var2};
      return (String)this.jaggSQL.invoke("JDPSubsystemMgr", "killJob", var3, var4);
   }

   public String checkJobSubmissionAllowed(String var1, String var2) {
      String var3 = "Unknown";
      if (this.user != null && this.user.cust != null) {
         var3 = this.user.cust.getUsername();
      }

      String[] var4 = new String[]{var3, var1, var2};
      String var5 = "java.lang.String";
      String[] var6 = new String[]{var5, var5, var5};
      String var7 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "checkJobSubmissionAllowed", var6, var4);
      return var7;
   }

   public int[] getJobsForClass(String var1) {
      String[] var2 = new String[]{"String"};
      String[] var3 = new String[]{var1};
      String var4 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "getJobsForClass", var2, var3);
      if (var4.length() == 0) {
         return new int[0];
      } else {
         StringTokenizer var5 = new StringTokenizer(var4, ";");
         int[] var6 = new int[var5.countTokens()];

         for(int var7 = 0; var5.hasMoreTokens(); var6[var7++] = Integer.parseInt(var5.nextToken())) {
         }

         return var6;
      }
   }

   public void setSubsystemHeld(String var1, boolean var2) {
      String[] var3 = new String[]{"String", "boolean"};
      String[] var4 = new String[]{var1, var2 ? "true" : "false"};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setSubsystemHeld", var3, var4);
   }

   public Object invokeByClassName(String var1, String var2) {
      return this.jaggSQL.invoke(var1, var2);
   }

   public Object invokeByClassName(String var1, String var2, String[] var3, String[] var4) {
      return this.jaggSQL.invoke(var1, var2, var3, var4);
   }

   public void setJobQueuePriority(int var1, int var2, String var3) {
      String[] var4 = new String[]{"int", "int", "String"};
      String[] var5 = new String[]{Integer.toString(var1), Integer.toString(var2), var3};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setJobQueuePriority", var4, var5);
   }

   public String removeJob(int var1, String var2) {
      String[] var3 = new String[]{"int", "String"};
      String[] var4 = new String[]{Integer.toString(var1), var2};
      return (String)this.jaggSQL.invoke("JDPSubsystemMgr", "removeJob", var3, var4);
   }

   public String getJobLog(int var1) {
      String[] var2 = new String[]{"int"};
      String[] var3 = new String[]{Integer.toString(var1)};
      return (String)this.jaggSQL.invoke("JDPSubsystemMgr", "getJobLog", var2, var3);
   }

   public void setMaxJobs(String var1, int var2) {
      String[] var3 = new String[]{"String", "int"};
      String[] var4 = new String[]{var1, Integer.toString(var2)};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setMaxJobs", var3, var4);
   }

   public boolean triggerEvent(String var1, String var2) {
      String[] var3 = new String[]{"String", "String"};
      String[] var4 = new String[]{var1, var2};
      Boolean var5 = (Boolean)this.jaggSQL.invoke("JDPSubsystemMgr", "triggerEvent", var3, var4);
      return var5;
   }

   public void setJobPriority(int var1, int var2, String var3) {
      String[] var4 = new String[]{"int", "int", "String"};
      String[] var5 = new String[]{Integer.toString(var1), Integer.toString(var2), var3};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setJobPriority", var4, var5);
   }

   public void setJobJobQueue(int var1, String var2, String var3) {
      String[] var4 = new String[]{"int", "String", "String"};
      String[] var5 = new String[]{Integer.toString(var1), var2, var3};
      this.jaggSQL.invoke("JDPSubsystemMgr", "setJobJobQueue", var4, var5);
   }

   public Object getJobInfo(int var1, String var2, String[] var3, String[] var4) {
      return this.jaggSQL.invoke("JDPJob", var2, var3, var4, (String)null, var1);
   }

   public Object invokeByJobName(String var1, String var2) {
      String[] var3 = new String[0];
      String[] var4 = new String[0];
      return this.jaggSQL.invoke((String)null, var2, var3, var4, var1, 0);
   }
}
