import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Rectangle;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSearchResults extends Panel {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   Container targetPanel;
   boolean useTreeClass;
   boolean listEvents;
   JDPComboBox sortChoice;
   JDPList resultList;
   JDPTreePicker tree;
   JDPTreeBranch treeRoot;
   JDPTreeBranch lastBranch;
   String prevEntry;
   Label listCountText;
   Label listCount;
   String pselectFields;
   int[] pdisplayFields;
   String[] psdisplayFields;
   String pfromWhereClause;
   String savepfromWhereClause;
   String[] psortChoice;
   String[] pdisplayChoice;
   int icon = -1;
   String[] recordName;
   String[] recordKey0;
   String[] recordKey1;
   String[] recordKey2;
   String[] recordKey3;
   String[] recordKey4;
   String[] recordKey5;
   String[] recordKey6;
   String[] recordKey7;
   String[] recordKey8;
   String[] recordKey9;
   String[][] psdisplayActual;
   String lastKey;
   Font currentFont;
   Color fgColor;
   Color bgColor;

   public JDPSearchResults(JDPUser var1, Container var2, boolean var3, JDPJagg var4, boolean var5, String var6, String[] var7, String var8, String[] var9, String[] var10, String[] var11, String var12, boolean var13, String var14) {
      this.fgColor = Color.black;
      this.useTreeClass = var3;
      this.targetPanel = var2;
      this.createPanel(var1, var4, var5, var6, (int[])null, var7, var8, var9, var10, var11, var12, var13, var14);
   }

   public JDPSearchResults(JDPUser var1, Panel var2, boolean var3, JDPJagg var4, boolean var5, String var6, String[] var7, String var8, String[] var9, String[] var10, String[] var11, String var12, boolean var13, String var14) {
      this.fgColor = Color.black;
      this.useTreeClass = var3;
      this.targetPanel = (Container)var2;
      this.createPanel(var1, var4, var5, var6, (int[])null, var7, var8, var9, var10, var11, var12, var13, var14);
   }

   public JDPSearchResults(JDPUser var1, boolean var2, JDPJagg var3, boolean var4, String var5, String[] var6, String var7, String[] var8, String[] var9, String[] var10, String var11, boolean var12, String var13) {
      this.fgColor = Color.black;
      this.useTreeClass = var2;
      this.createPanel(var1, var3, var4, var5, (int[])null, var6, var7, var8, var9, var10, var11, var12, var13);
   }

   public JDPSearchResults(JDPUser var1, boolean var2, JDPJagg var3, boolean var4, String var5, int[] var6, String var7, String[] var8, String[] var9, String[] var10, String var11, boolean var12, String var13) {
      this.fgColor = Color.black;
      this.useTreeClass = var2;
      this.createPanel(var1, var3, var4, var5, var6, (String[])null, var7, var8, var9, var10, var11, var12, var13);
   }

   public JDPSearchResults(JDPUser var1, JDPJagg var2, boolean var3, String var4, String var5, String[] var6, String[] var7, String[] var8, String var9, boolean var10, String var11) {
      this.fgColor = Color.black;
      this.createPanel(var1, var2, var3, var4, (int[])null, (String[])null, var5, var6, var7, var8, var9, var10, var11);
   }

   public JDPSearchResults(JDPUser var1) {
      this.fgColor = Color.black;
   }

   public void clearList() {
      if (!this.useTreeClass) {
         this.resultList.clear();
      } else {
         if (this.treeRoot != null && this.treeRoot.name != null) {
            this.treeRoot = this.tree.setRoot(this.treeRoot.name, true);
         } else {
            this.treeRoot = this.tree.setRoot("", true);
         }

         this.lastBranch = null;
         this.prevEntry = null;
      }
   }

   public void clearList(String var1) {
      if (!this.useTreeClass) {
         this.resultList.clear();
      } else {
         this.treeRoot = this.tree.setRoot(var1, true);
         this.lastBranch = null;
         this.prevEntry = null;
      }
   }

   public void setListEvents(boolean var1) {
      this.listEvents = var1;
   }

   public void loadList() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      int var5 = 0;
      int var7 = 0;
      if (this.sortChoice != null && this.sortChoice.getSelectedIndex() >= 0) {
         var7 = this.sortChoice.getSelectedIndex();
      }

      if (this.psortChoice.length != 0) {
         String var8 = "";
         if (var7 < this.psortChoice.length && var7 >= 0) {
            var8 = var8 + " ORDER BY " + this.psortChoice[var7];
         }

         String var9 = "SELECT ";
         if (this.useTreeClass && this.pselectFields.toUpperCase().indexOf("DISTINCT") < 0) {
            var9 = var9 + "DISTINCT ";
         }

         if (this.useTreeClass) {
            String var10 = "";
            if (this.psdisplayFields != null) {
               for(int var11 = 0; var11 < this.psdisplayFields.length; ++var11) {
                  if (var11 > 0) {
                     var10 = var10 + ",";
                  }

                  var10 = var10 + this.psdisplayFields[var11];
               }
            } else {
               var10 = this.pselectFields;
            }

            if (this.pselectFields.startsWith("DISTINCT ")) {
               var10 = this.pselectFields.substring(9);
            }

            if (var7 < this.psortChoice.length && var7 >= 0 && this.psortChoice[var7] != null) {
               int var21 = var10.indexOf(this.psortChoice[var7]);
               if (var21 >= 0) {
                  String var12 = "";
                  if (var21 > 0) {
                     var12 = var10.substring(0, var21 - 1);
                  }

                  int var13 = var10.substring(var21).indexOf(",");
                  if (var13 > 0) {
                     String var14 = var10.substring(var21).substring(var13);
                     if (var12.length() > 0) {
                        var10 = var12 + var14;
                     } else {
                        var10 = var14.substring(1);
                     }
                  } else {
                     var10 = var12;
                  }
               }
            }

            if (var10.length() > 0) {
               var8 = var8 + "," + var10;
            }
         }

         var9 = var9 + this.pselectFields;
         String var20 = this.pfromWhereClause;
         if (this.psdisplayFields != null) {
            String[] var22 = new String[this.psdisplayFields.length];

            for(int var25 = 0; var25 < this.psdisplayFields.length; ++var25) {
               var22[var25] = this.psdisplayFields[var25];
               if (var22[var25].endsWith(" DESC")) {
                  var22[var25] = var22[var25].substring(0, var22[var25].indexOf(" DESC"));
               }
            }

            for(int var26 = 0; var26 < var22.length; ++var26) {
               if (this.user.u.sqlRequiresChange(this.jaggSQL, 0)) {
                  if (this.pselectFields.indexOf(var22[var26]) >= 0) {
                     String var28 = this.user.u.getDataSourceType(this.jaggSQL);
                     if (var28.indexOf(JDPJagg.ANYWHERE) < 0 && var28.indexOf(JDPJagg.SOLIDSERVER) < 0) {
                        if (var28.indexOf(JDPJagg.VFOXPRO) < 0 && var28.indexOf(JDPJagg.ORACLE) < 0 && var28.indexOf(JDPJagg.POLITE) < 0 && var28.indexOf(JDPJagg.INFORMIX) < 0 && var28.indexOf(JDPJagg.CLOUDSCAPE) < 0) {
                           var9 = var9 + "," + var22[var26];
                        } else {
                           var9 = var9 + "," + var22[var26] + " as b" + this.user.u.strip(var22[var26]);
                        }
                     } else {
                        var9 = var9 + "," + var22[var26] + " b" + this.user.u.strip(var22[var26]);
                     }
                  } else {
                     var9 = var9 + "," + var22[var26];
                  }
               } else {
                  var9 = var9 + "," + var22[var26];
               }
            }
         }

         if (this.user.u.sqlRequiresChange(this.jaggSQL, 0)) {
            if (this.pselectFields.indexOf(this.pdisplayChoice[var7]) >= 0) {
               String var23 = this.user.u.getDataSourceType(this.jaggSQL);
               if (var23.indexOf(JDPJagg.ANYWHERE) < 0 && var23.indexOf(JDPJagg.SOLIDSERVER) < 0) {
                  if (var23.indexOf(JDPJagg.VFOXPRO) < 0 && var23.indexOf(JDPJagg.ORACLE) < 0 && var23.indexOf(JDPJagg.POLITE) < 0 && var23.indexOf(JDPJagg.CLOUDSCAPE) < 0) {
                     if (var23.indexOf(JDPJagg.INFORMIX) >= 0) {
                        var9 = var9 + "," + this.pdisplayChoice[var7] + " a" + this.user.u.strip(this.pdisplayChoice[var7]) + " " + this.pfromWhereClause + this.user.u.replace(var8, this.user.u.strip(this.pdisplayChoice[var7]), "a" + this.user.u.strip(this.pdisplayChoice[var7]));
                     }
                  } else {
                     var9 = var9 + "," + this.pdisplayChoice[var7] + " as a" + this.user.u.strip(this.pdisplayChoice[var7]) + " " + this.pfromWhereClause + var8;
                  }
               } else {
                  var9 = var9 + "," + this.pdisplayChoice[var7] + " a" + this.user.u.strip(this.pdisplayChoice[var7]) + " " + this.pfromWhereClause + var8;
               }
            } else {
               var9 = var9 + "," + this.pdisplayChoice[var7] + " " + var20 + var8;
            }
         } else {
            var9 = var9 + "," + this.pdisplayChoice[var7] + " " + var20 + var8;
         }

         if (this.user.DEBUG) {
            System.out.println("JDPSearchResults/loadList SQL: " + var9);
         }

         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var2 = this.jaggSQL.execSQL(var9, var3);
         if (this.user.DEBUG) {
            System.out.println("JDPSearchResults/loadList CNT: " + Integer.toString(var2));
         }

         if (var2 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var9);
         } else {
            if (this.user.DEBUG) {
               System.out.println("JDPSearchResults/loadList COL: " + Integer.toString(this.jaggSQL.getColumnCount()));
            }

            var5 = this.jaggSQL.getRowCount();
            this.recordKey0 = new String[var5];
            this.recordKey1 = new String[var5];
            this.recordKey2 = new String[var5];
            this.recordKey3 = new String[var5];
            this.recordKey4 = new String[var5];
            this.recordKey5 = new String[var5];
            this.recordKey6 = new String[var5];
            this.recordKey7 = new String[var5];
            this.recordKey8 = new String[var5];
            this.recordKey9 = new String[var5];
            this.recordName = new String[var5];
            int var24 = 0;
            if (this.psdisplayFields != null) {
               this.psdisplayActual = new String[var5][this.psdisplayFields.length];
               var24 = this.psdisplayFields.length;
            }

            this.listCount.setText(Integer.toString(var5));
            int var27 = this.jaggSQL.getColumnCount();
            int var29 = 0;
            this.lastKey = null;

            for(int var30 = 0; var30 < var5; ++var30) {
               String var6 = (String)var3.elementAt(var30);
               if (var6 != null && var6.trim().compareTo("") != 0) {
                  StringTokenizer var1 = new StringTokenizer(var6);
                  this.recordKey0[var29] = var1.nextToken(var4).trim();
                  if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(0))) {
                     this.recordKey0[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey0[var29]));
                  }

                  if (var27 > 2 + var24) {
                     this.recordKey1[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(1))) {
                        this.recordKey1[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey1[var29]));
                     }
                  }

                  if (var27 > 3 + var24) {
                     this.recordKey2[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(2))) {
                        this.recordKey2[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey2[var29]));
                     }
                  }

                  if (var27 > 4 + var24) {
                     this.recordKey3[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(3))) {
                        this.recordKey3[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey3[var29]));
                     }
                  }

                  if (var27 > 5 + var24) {
                     this.recordKey4[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(4))) {
                        this.recordKey4[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey4[var29]));
                     }
                  }

                  if (var27 > 6 + var24) {
                     this.recordKey5[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(5))) {
                        this.recordKey5[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey5[var29]));
                     }
                  }

                  if (var27 > 7 + var24) {
                     this.recordKey6[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(6))) {
                        this.recordKey6[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey6[var29]));
                     }
                  }

                  if (var27 > 8 + var24) {
                     this.recordKey7[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(7))) {
                        this.recordKey7[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey7[var29]));
                     }
                  }

                  if (var27 > 9 + var24) {
                     this.recordKey8[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(8))) {
                        this.recordKey8[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey8[var29]));
                     }
                  }

                  if (var27 > 10 + var24) {
                     this.recordKey9[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(9))) {
                        this.recordKey9[var29] = JDPDate.formatSystem(Long.valueOf(this.recordKey9[var29]));
                     }
                  }

                  if (this.psdisplayFields != null) {
                     int var15 = var27 - var1.countTokens();

                     for(int var16 = 0; var16 < this.psdisplayFields.length; ++var16) {
                        this.psdisplayActual[var29][var16] = var1.nextToken(var4).trim();
                        if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(var15 + var16))) {
                           this.psdisplayActual[var29][var16] = JDPDate.format(Long.valueOf(this.psdisplayActual[var29][var16]));
                        }
                     }
                  }

                  if (var1 != null) {
                     this.recordName[var29] = var1.nextToken(var4).trim();
                     if (JDPUtils.isOdbcDate(this.jaggSQL.getColumnType(var27 - 1))) {
                        this.recordName[var29] = JDPDate.format(Long.valueOf(this.recordName[var29]));
                     }
                  }

                  if (this.addEntry(var29)) {
                     ++var29;
                  }
               }
            }

            if (this.useTreeClass) {
               this.listCount.setText(Integer.toString(var29));
               this.tree.repaint();
            }

            this.user.mainmsg.clearStatusMsg();
         }
      }
   }

   public JDPList getListHandle() {
      return this.resultList;
   }

   public void setIcons(int[] var1) {
      if (this.useTreeClass && this.tree != null) {
         this.tree.setIcons(var1);
      }

   }

   public void setDisplayChoice(String[] var1) {
      this.pdisplayChoice = var1;
   }

   public String[] getSelectedBranch() {
      return this.useTreeClass ? this.tree.getSelectedBranch() : null;
   }

   public void setMinWidth(int var1) {
      if (this.useTreeClass) {
         if (this.tree != null) {
            this.tree.setMinWidth(var1);
            return;
         }
      } else if (this.resultList != null) {
         this.resultList.setMinWidth(var1);
      }

   }

   public int getMinWidth() {
      return this.useTreeClass ? this.tree.getMinWidth() : this.resultList.getMinWidth();
   }

   void createPanel(JDPUser var1, JDPJagg var2, boolean var3, String var4, int[] var5, String[] var6, String var7, String[] var8, String[] var9, String[] var10, String var11, boolean var12, String var13) {
      this.user = var1;
      this.jaggSQL = var2;
      this.pselectFields = var4;
      this.pdisplayFields = var5;
      this.psdisplayFields = var6;
      this.pfromWhereClause = var7;
      this.psortChoice = var9;
      this.savepfromWhereClause = var7;
      this.pdisplayChoice = new String[var10.length];

      for(int var14 = 0; var14 < var10.length; ++var14) {
         this.pdisplayChoice[var14] = var10[var14];
         if (var10[var14] != null && var10[var14].indexOf(" DESC") > 0) {
            this.pdisplayChoice[var14] = var10[var14].substring(0, var10[var14].length() - 5);
         }
      }

      ((Container)this).setLayout(new BorderLayout());
      Panel var17 = new Panel();
      ((Container)var17).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this.targetPanel);
      if (this.targetPanel != null) {
         this.targetPanel.add(this.popuppanel);
      }

      if (var8 != null && var8.length > 1) {
         this.sortChoice = new JDPComboBox(var1, "", 7);
         this.sortChoice.setEditable(false);

         for(int var15 = 0; var15 < var8.length; ++var15) {
            if (var8[var15] != null) {
               this.sortChoice.addItem(var8[var15]);
            }
         }

         this.sortChoice.select(var11);
         ((Container)var17).add("North", this.sortChoice);
         this.popuppanel.addComponent(this.sortChoice, "Order by", "Order list entries by this item");
      }

      Panel var18 = new Panel();
      ((Container)var18).setLayout(new BorderLayout(4, 1));
      this.listCountText = new Label(var13, 0);
      ((Container)var18).add("West", this.listCountText);
      this.listCount = new Label("0      ", 0);
      Panel var16 = new Panel();
      ((Container)var16).setLayout(new BorderLayout(4, 1));
      ((Container)var16).add("West", this.listCount);
      ((Container)var16).add("Center", new Label(" ", 0));
      ((Container)var18).add("Center", var16);
      if (var12) {
         ((Container)var17).add("South", var18);
      }

      if (var12 || var8 != null && var8.length > 1) {
         ((Container)this).add("North", var17);
      }

      if (this.useTreeClass) {
         this.tree = new JDPTreePicker(var1);
         ((Container)this).add("Center", this.tree);
         this.popuppanel.addComponent(this.tree, "Result List Tree", "Matching entries are displayed in this tree structure");
      } else {
         this.resultList = new JDPList(var1);
         this.resultList.allowMultipleSelections(var3);
         ((Container)this).add("Center", this.resultList);
         this.popuppanel.addComponent(this.resultList, "Result List", "Matching entries are displayed in this list");
      }
   }

   public JDPTreePicker getTreeHandle() {
      return this.tree;
   }

   public void setTableKey(String var1) {
      this.pselectFields = var1;
   }

   public void setBackground(Color var1) {
      this.bgColor = var1;
      if (this.sortChoice != null) {
         this.sortChoice.setBackground(var1);
      }

      if (this.listCountText != null) {
         this.listCountText.setBackground(var1);
      }

      if (this.listCount != null) {
         this.listCount.setBackground(var1);
      }

      if (!this.useTreeClass && this.resultList != null) {
         this.resultList.setBackground(var1);
      }
   }

   public Color getBackground() {
      if (this.bgColor != null) {
         return this.bgColor;
      } else {
         Container var1 = ((Component)this).getParent();
         return var1 != null ? ((Component)var1).getBackground() : null;
      }
   }

   public void setFromWhereClause(String var1) {
      if (this.savepfromWhereClause.toUpperCase().indexOf("FROM ") < 0) {
         this.pfromWhereClause = var1 + " AND " + this.savepfromWhereClause;
      } else {
         this.pfromWhereClause = var1;
      }
   }

   public void setIcon(int var1) {
      if (!this.useTreeClass) {
         this.icon = var1;
      }

   }

   public void setFont(Font var1) {
      this.currentFont = var1;
      if (this.sortChoice != null) {
         this.sortChoice.setFont(var1);
      }

      if (this.listCountText != null) {
         this.listCountText.setFont(var1);
      }

      if (this.listCount != null) {
         this.listCount.setFont(var1);
      }

      if (!this.useTreeClass) {
         if (this.resultList != null) {
            this.resultList.setFont(var1);
            return;
         }
      } else if (this.tree != null) {
         this.tree.setFont(var1);
      }

   }

   public Font getFont() {
      if (this.currentFont != null) {
         return this.currentFont;
      } else {
         Container var1 = ((Component)this).getParent();
         return var1 != null ? ((Component)var1).getFont() : null;
      }
   }

   public int getSelectedIndex() {
      return this.useTreeClass ? this.tree.getSelectedIndex() : this.resultList.getSelectedIndex();
   }

   public int getTotalEntries() {
      try {
         return Integer.parseInt(this.listCount.getText());
      } catch (Exception var1) {
         return 0;
      }
   }

   public void resetSelections() {
      if (this.tree != null) {
         this.tree.resetSelections();
      } else {
         if (this.resultList != null) {
            this.resultList.resetSelections();
         }

      }
   }

   public void setMinHeight(int var1) {
      if (this.useTreeClass) {
         if (this.tree != null) {
            this.tree.setMinHeight(var1);
            return;
         }
      } else if (this.resultList != null) {
         this.resultList.setMinHeight(var1);
      }

   }

   public int getMinHeight() {
      return this.useTreeClass ? this.tree.getMinHeight() : this.resultList.getMinHeight();
   }

   public void setSortChoice(String[] var1) {
      this.psortChoice = var1;
   }

   public boolean setSelectedKey(String[] var1) {
      boolean var2 = true;

      for(int var3 = 0; var3 < this.recordKey0.length; ++var3) {
         var2 = true;

         for(int var4 = 0; var4 < var1.length; ++var4) {
            if (var4 == 0 && !var1[var4].equals(this.recordKey0[var3])) {
               var2 = false;
            }

            if (var4 == 1 && !var1[var4].equals(this.recordKey1[var3])) {
               var2 = false;
            }

            if (var4 == 2 && !var1[var4].equals(this.recordKey2[var3])) {
               var2 = false;
            }

            if (var4 == 3 && !var1[var4].equals(this.recordKey3[var3])) {
               var2 = false;
            }

            if (var4 == 4 && !var1[var4].equals(this.recordKey4[var3])) {
               var2 = false;
            }

            if (var4 == 5 && !var1[var4].equals(this.recordKey5[var3])) {
               var2 = false;
            }

            if (var4 == 6 && !var1[var4].equals(this.recordKey6[var3])) {
               var2 = false;
            }

            if (var4 == 7 && !var1[var4].equals(this.recordKey7[var3])) {
               var2 = false;
            }

            if (var4 == 8 && !var1[var4].equals(this.recordKey8[var3])) {
               var2 = false;
            }

            if (var4 == 9 && !var1[var4].equals(this.recordKey9[var3])) {
               var2 = false;
            }
         }

         if (var2) {
            this.tree.select(var3);
            return true;
         }
      }

      this.tree.resetSelections();
      return false;
   }

   public void setForeground(Color var1) {
      this.fgColor = var1;
      if (this.sortChoice != null) {
         this.sortChoice.setForeground(var1);
      }

      if (this.listCountText != null) {
         this.listCountText.setForeground(var1);
      }

      if (this.listCount != null) {
         this.listCount.setForeground(var1);
      }

      if (!this.useTreeClass) {
         if (this.resultList != null) {
            this.resultList.setForeground(var1);
            return;
         }
      } else if (this.tree != null) {
         this.tree.setForeground(var1);
      }

   }

   public Color getForeground() {
      if (this.fgColor != null) {
         return this.fgColor;
      } else {
         Container var1 = ((Component)this).getParent();
         return var1 != null ? ((Component)var1).getForeground() : null;
      }
   }

   public void setAllowMultSel(boolean var1) {
      if (!this.useTreeClass) {
         this.resultList.setMultipleSelections(var1);
      }

   }

   public boolean getAllowMultSel() {
      return !this.useTreeClass ? this.resultList.getMultipleSelections() : false;
   }

   boolean addEntry(int var1) {
      int var2 = 0;
      int var3 = 0;
      byte var4 = 0;
      String[] var5 = new String[30];
      if (this.useTreeClass) {
         if (this.recordName[var1] != null) {
            var5[var2++] = this.recordName[var1];
            var4 = 1;
         }

         String var6 = "";
         var6 = var6 + this.recordKey0[var1];
         var6 = var6 + this.recordKey1[var1];
         var6 = var6 + this.recordKey2[var1];
         var6 = var6 + this.recordKey3[var1];
         var6 = var6 + this.recordKey4[var1];
         var6 = var6 + this.recordKey5[var1];
         var6 = var6 + this.recordKey6[var1];
         var6 = var6 + this.recordKey7[var1];
         var6 = var6 + this.recordKey8[var1];
         var6 = var6 + this.recordKey9[var1];
         if (this.pdisplayFields != null) {
            var5[var2++] = this.recordKey0[var1];
            var5[var2++] = this.recordKey1[var1];
            var5[var2++] = this.recordKey2[var1];
            var5[var2++] = this.recordKey3[var1];
            var5[var2++] = this.recordKey4[var1];
            var5[var2++] = this.recordKey5[var1];
            var5[var2++] = this.recordKey6[var1];
            var5[var2++] = this.recordKey7[var1];
            var5[var2++] = this.recordKey8[var1];
            var5[var2++] = this.recordKey9[var1];

            for(var3 = 0; var3 < this.pdisplayFields.length; ++var3) {
               var5[var3 + var4] = var5[this.pdisplayFields[var3] + var4];
            }
         } else {
            for(var3 = 0; var3 < this.psdisplayFields.length; ++var3) {
               var5[var3 + var4] = this.psdisplayActual[var1][var3];
            }
         }

         for(int var7 = var3 + var4; var7 < var5.length; ++var7) {
            var5[var7] = null;
         }

         if (this.lastKey != null && var6.equals(this.lastKey)) {
            if (this.tree.addEntry(var5)) {
               return false;
            }
         } else {
            this.lastKey = var6;
            if (var5[var3 + var4 - 1].equals("")) {
               var5[var3 + var4 - 1] = " ";
            }

            this.tree.addEntry(var5, false, true);
         }
      } else if (this.icon >= 0) {
         if (this.recordName[var1] != null) {
            this.resultList.addItem(this.recordName[var1], this.icon);
         } else {
            this.resultList.addItem(this.recordKey0[var1], this.icon);
         }
      } else if (this.recordName[var1] != null) {
         this.resultList.addItem(this.recordName[var1]);
      } else {
         this.resultList.addItem(this.recordKey0[var1]);
      }

      return true;
   }

   public String[] getSelectedKey() {
      int var1 = -1;
      if (this.useTreeClass) {
         var1 = this.tree.getSelectedIndex();
      } else {
         var1 = this.resultList.getSelectedIndex();
      }

      if (var1 >= 0 && this.recordKey0.length > var1) {
         String[] var2 = new String[]{this.recordKey0[var1], this.recordKey1[var1], this.recordKey2[var1], this.recordKey3[var1], this.recordKey4[var1], this.recordKey5[var1], this.recordKey6[var1], this.recordKey7[var1], this.recordKey8[var1], this.recordKey9[var1]};
         int var3 = 0;
         var3 = 0;

         while(var2[var3] != null) {
            ++var3;
            if (var3 >= 9) {
               break;
            }
         }

         String[] var4 = new String[var3];
         System.arraycopy(var2, 0, var4, 0, var3);
         return var4;
      } else {
         return null;
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 501:
         case 502:
         case 503:
         case 504:
         case 505:
         case 506:
            if (this.targetPanel == null) {
               for(this.targetPanel = super.getParent(); this.targetPanel != null && !(this.targetPanel instanceof JDPPanelLoader); this.targetPanel = this.targetPanel.getParent()) {
               }

               if (this.targetPanel != null && this.popuppanel != null) {
                  this.popuppanel.setTarget(this.targetPanel);
                  this.targetPanel.add(this.popuppanel);
               }
            }

            Object var6 = this;
            if (this != null && this.targetPanel != null) {
               Rectangle var3 = ((Component)this).bounds();

               while(var6 != null && !var6.equals(this.targetPanel)) {
                  var1.x += var3.x;
                  var1.y += var3.y;
                  var6 = ((Component)var6).getParent();
                  if (var6 != null) {
                     var3 = ((Component)var6).bounds();
                  }
               }
            }

            if (this.popuppanel != null) {
               this.popuppanel.postEvent(var1);
            }

            return false;
         case 701:
            if (var1.target instanceof JDPList && !this.listEvents) {
               Event var4 = new Event(var1.target, var1.when, 1001, var1.x, var1.y, var1.key, var1.modifiers, var1.arg);
               ((Component)this).getParent().postEvent(var4);
               var4 = new Event(this, var1.when, 1001, var1.x, var1.y, var1.key, var1.modifiers, var1.arg);
               ((Component)this).getParent().postEvent(var4);
               return false;
            } else {
               if (var1.target.equals(this.tree)) {
                  var1.target = this;
                  ((Component)this).getParent().postEvent(var1);
                  return true;
               }

               return false;
            }
         case 1001:
            if (var1.target instanceof JDPList) {
               if (this.listEvents) {
                  return false;
               }

               return true;
            } else if (var1.target instanceof JDPComboBox) {
               this.clearList();
               this.loadList();
               return true;
            } else {
               if (var1.target instanceof JDPTreePicker) {
                  Event var2 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers);
                  super.postEvent(var2);
                  return false;
               }

               return false;
            }
         default:
            return false;
      }
   }
}
