import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSelectColumns extends JDPClassLayout {
   JDPSelectDSN targetDSN;
   JDPSelectTable target;
   JDPPopupMessage popuppanel;
   JDPDragItem dragPanel;
   int tableIndex = -1;
   JDPList columns;
   JDPList keys;
   JDPList keysUpdate;
   TextField table;
   TextField columnname;
   TextField datatype;
   TextField typename;
   TextField precision;
   TextField length;
   TextField scale;
   TextField radix;
   TextField nullable;
   TextField remarks;
   JDPChoice useRemarks;
   String[] tableQualifier;
   String[] tableOwner;
   String[] tableName;
   String[] columnName;
   int[] columnDatatype;
   String[] columnTypename;
   String[] columnPrecision;
   String[] columnLength;
   String[] columnScale;
   String[] columnRadix;
   String[] columnNullable;
   String[] columnRemarks;
   boolean[] columnIsIdentity;
   String[] saveColumns;
   String[] savetableQualifier;
   String[] savetableOwner;
   String[] savetableName;
   String[] savecolumnName;
   int[] savecolumnDatatype;
   String[] savecolumnTypename;
   String[] savecolumnPrecision;
   String[] savecolumnLength;
   String[] savecolumnScale;
   String[] savecolumnRadix;
   String[] savecolumnNullable;
   String[] savecolumnRemarks;
   boolean[] savecolumnIsIdentity;
   Vector gParmObject;
   JDPTabSelectPanel tabPanel;

   boolean setNewColumns() {
      if (this.columns.getSelectedIndexes().length < 1) {
         if (super.componentName.equals("") && ((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("You have not selected any columns.", 10);
         }

         return false;
      } else if (this.keys.getSelectedIndexes().length < 1) {
         if (((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("You must select a key for selecting rows from this table.", 10);
         }

         return false;
      } else if (this.keysUpdate.getSelectedIndexes().length < 1) {
         if (((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("You must select a unique key for performing updates on this table.", 10);
         }

         return false;
      } else {
         for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
            if (super.user.gParm.elementAt(var1) instanceof Vector) {
               Vector var2 = (Vector)super.user.gParm.elementAt(var1);
               if (((String)var2.elementAt(0)).compareTo("SearchLayout" + super.componentName) == 0) {
                  ((JDPClassLayout)var2.elementAt(1)).refresh();
               }

               if (((String)var2.elementAt(0)).compareTo("ListLayout" + super.componentName) == 0) {
                  ((JDPClassLayout)var2.elementAt(1)).refresh();
               }

               if (((String)var2.elementAt(0)).compareTo("ScreenSettings" + super.componentName) == 0) {
                  ((JDPClassLayout)var2.elementAt(1)).refresh();
               }

               if (((String)var2.elementAt(0)).compareTo("GridSettings" + super.componentName) == 0) {
                  ((JDPClassLayout)var2.elementAt(1)).refresh();
               }

               if (((String)var2.elementAt(0)).compareTo("EmailLayout" + super.componentName) == 0) {
                  ((JDPClassLayout)var2.elementAt(1)).refresh();
               }

               if (((String)var2.elementAt(0)).compareTo("AlphaLayout" + super.componentName) == 0) {
                  ((JDPClassLayout)var2.elementAt(1)).refresh();
               }
            }
         }

         for(int var3 = 0; var3 < super.user.gParm.size(); ++var3) {
            if (super.user.gParm.elementAt(var3) instanceof Vector) {
               Vector var4 = (Vector)super.user.gParm.elementAt(var3);
               if (((String)var4.elementAt(0)).compareTo("ScreenLayout" + super.componentName) == 0) {
                  ((JDPClassLayout)var4.elementAt(1)).refresh();
               }

               if (((String)var4.elementAt(0)).compareTo("SelectReportDef" + super.componentName) == 0) {
                  ((JDPClassLayout)var4.elementAt(1)).refresh();
               }

               if (((String)var4.elementAt(0)).compareTo("SelectChartDef" + super.componentName) == 0) {
                  ((JDPClassLayout)var4.elementAt(1)).refresh();
               }
            }
         }

         if (((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("Selections accepted.", 5);
         }

         return true;
      }
   }

   void clearList() {
      this.columns.clear();
      this.keys.clear();
      this.keysUpdate.clear();
   }

   void loadList() {
      new Vector();
      super.user.jaggSQL.getSEP();
      boolean var1 = false;
      this.clearList();
      this.clearFields();
      this.retrieveTable();
      if (this.tableIndex == -1) {
         this.tabPanel = JDPUtils.getTabPanel(this);
         if (this.tabPanel != null) {
            this.tabPanel.select("Select Table");
         }

      } else if (this.target.tables.countItems() > 0) {
         this.table.setText(this.target.tableName[this.tableIndex]);
         int var2 = 0;
         String var3 = this.target.tables.getSelectedItem();

         for(int var4 = 0; var4 < this.target.columnName.length; ++var4) {
            if (this.target.ctableName[var4] != null && this.target.ctableName[var4].equals(var3)) {
               ++var2;
            }
         }

         int[] var10 = this.target.stables.getSelectedIndexes();

         for(int var5 = 0; var5 < var10.length; ++var5) {
            String var6 = this.target.stables.getItem(var10[var5]);

            for(int var7 = 0; var7 < this.target.columnName.length; ++var7) {
               if (this.target.ctableName[var7] != null && this.target.ctableName[var7].equals(var6)) {
                  ++var2;
               }
            }
         }

         this.tableQualifier = new String[var2];
         this.tableOwner = new String[var2];
         this.tableName = new String[var2];
         this.columnName = new String[var2];
         this.columnDatatype = new int[var2];
         this.columnTypename = new String[var2];
         this.columnPrecision = new String[var2];
         this.columnLength = new String[var2];
         this.columnScale = new String[var2];
         this.columnRadix = new String[var2];
         this.columnNullable = new String[var2];
         this.columnRemarks = new String[var2];
         this.columnIsIdentity = new boolean[var2];
         var2 = 0;

         for(int var11 = 0; var11 < this.target.columnName.length; ++var11) {
            if (this.target.ctableName[var11] != null && this.target.ctableName[var11].equals(var3)) {
               this.tableQualifier[var2] = this.target.ctableQualifier[var11];
               this.tableOwner[var2] = this.target.ctableOwner[var11];
               this.tableName[var2] = this.target.ctableName[var11];
               this.columnName[var2] = this.target.columnName[var11];
               this.columnDatatype[var2] = this.target.columnDatatype[var11];
               this.columnTypename[var2] = this.target.columnTypename[var11];
               String var13 = this.columnTypename[var2].toUpperCase();
               if (var13.indexOf("IDENTITY") >= 0 || var13.indexOf("COUNTER") >= 0) {
                  this.columnIsIdentity[var2] = true;
               }

               this.columnPrecision[var2] = this.target.columnPrecision[var11];
               this.columnLength[var2] = this.target.columnPrecision[var11];

               int var15;
               try {
                  var15 = Integer.parseInt(this.columnLength[var2]);
                  if (var15 > 500) {
                     var15 = 40;
                  }

                  if (var15 < 0) {
                     var15 = 40;
                  }
               } catch (Exception var8) {
                  var15 = 40;
               }

               this.columnLength[var2] = Integer.toString(var15);
               this.columnScale[var2] = this.target.columnScale[var11];
               this.columnRadix[var2] = this.target.columnRadix[var11];
               this.columnNullable[var2] = this.target.columnNullable[var11];
               this.columnRemarks[var2] = this.target.columnRemarks[var11];
               if (this.columnName[var2].indexOf(" ") >= 0 || this.columnName[var2].indexOf("#") >= 0) {
                  this.columnName[var2] = "`" + this.columnName[var2] + "`";
               }

               if (var10.length > 0) {
                  this.columns.addItem("a." + this.columnName[var2], 8);
                  this.columns.select(var2);
                  this.keys.addItem("a." + this.columnName[var2], 8);
                  this.keysUpdate.addItem("a." + this.columnName[var2], 8);
               } else {
                  this.columns.addItem(this.columnName[var2], 8);
                  this.columns.select(var2);
                  this.keys.addItem(this.columnName[var2], 8);
                  this.keysUpdate.addItem(this.columnName[var2], 8);
               }

               ++var2;
            }
         }

         for(int var12 = 0; var12 < var10.length; ++var12) {
            String var14 = this.target.stables.getItem(var10[var12]);

            for(int var16 = 0; var16 < this.target.columnName.length; ++var16) {
               if (this.target.ctableName[var16] != null && this.target.ctableName[var16].equals(var14)) {
                  this.tableQualifier[var2] = this.target.ctableQualifier[var16];
                  this.tableOwner[var2] = this.target.ctableOwner[var16];
                  this.tableName[var2] = this.target.ctableName[var16];
                  this.columnName[var2] = this.target.columnName[var16];
                  this.columnDatatype[var2] = this.target.columnDatatype[var16];
                  this.columnTypename[var2] = this.target.columnTypename[var16];
                  this.columnPrecision[var2] = this.target.columnPrecision[var16];
                  this.columnLength[var2] = this.target.columnLength[var16];
                  this.columnScale[var2] = this.target.columnScale[var16];
                  this.columnRadix[var2] = this.target.columnRadix[var16];
                  this.columnNullable[var2] = this.target.columnNullable[var16];
                  this.columnRemarks[var2] = this.target.columnRemarks[var16];
                  if (this.columnName[var2].indexOf(" ") >= 0 || this.columnName[var2].indexOf("#") >= 0) {
                     this.columnName[var2] = "`" + this.columnName[var2] + "`";
                  }

                  this.columns.addItem(this.target.stableAlias[var10[var12]] + "." + this.columnName[var2], 8);
                  this.columns.select(var2);
                  ++var2;
               }
            }
         }

         if (this.columns.countItems() > 0) {
            this.columns.makeVisible(0);
         }

         if (this.keys.countItems() > 0) {
            this.keys.makeVisible(0);
         }

         if (this.keysUpdate.countItems() > 0) {
            this.keysUpdate.makeVisible(0);
         }

         this.loadKeys();
      }
   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPSelectColumns" + super.componentName;
      String[] var3 = new String[0];
      JDPList var4 = new JDPList(super.user);
      var1.restoreObject(var4, var2, "columnsItems", 1);
      if (var4.countItems() > 0) {
         this.saveArrays();
         JDPList var5 = new JDPList(super.user);

         for(int var6 = 0; var6 < this.columns.countItems(); ++var6) {
            var5.addItem(this.columns.getItem(var6));
         }

         this.columns.clear();
         String var10 = "";

         for(int var7 = 0; var7 < var4.countItems(); ++var7) {
            if (var5.getItem(var4.getItem(var7)) != -1) {
               this.columns.addItem(var4.getItem(var7));
               this.columns.select(this.columns.countItems() - 1);
               this.setNewArrayElement(var7, var4.getItem(var7));
               var10 = this.savetableName[var7];
            } else {
               super.user.mainmsg.setStatusMsg("Column " + var4.getItem(var7) + " has been removed from table " + var10 + ". Application load may fail.", 0);
               System.out.println("Column " + var4.getItem(var7) + " has been removed from table " + var10 + ". Application load may fail.");
            }
         }

         for(int var13 = 0; var13 < var5.countItems(); ++var13) {
            if (this.columns.getItem(var5.getItem(var13)) == -1) {
               this.columns.addItem(var5.getItem(var13));
               this.columns.select(this.columns.countItems() - 1);
               this.setNewArrayElement(this.columns.countItems() - 1, var5.getItem(var13));
            }
         }

         var3 = this.columns.getSelectedItems();
      }

      List var9 = new List();
      var1.restoreObject(var9, var2, "keysItems", 1);
      if (var9.countItems() > 0) {
         List var11 = new List();

         for(int var14 = 0; var14 < this.keys.countItems(); ++var14) {
            var11.addItem(this.keys.getItem(var14));
         }

         this.keys.clear();

         for(int var15 = 0; var15 < var9.countItems(); ++var15) {
            this.keys.addItem(var9.getItem(var15));
         }

         for(int var16 = 0; var16 < var11.countItems(); ++var16) {
            if (this.keys.getItem(var11.getItem(var16)) == -1) {
               this.keys.addItem(var11.getItem(var16));
            }
         }
      }

      List var12 = new List();
      var1.restoreObject(var12, var2, "keysUpdateItems", 1);
      if (var12.countItems() > 0) {
         List var17 = new List();

         for(int var8 = 0; var8 < this.keysUpdate.countItems(); ++var8) {
            var17.addItem(this.keysUpdate.getItem(var8));
         }

         this.keysUpdate.clear();

         for(int var21 = 0; var21 < var12.countItems(); ++var21) {
            this.keysUpdate.addItem(var12.getItem(var21));
         }

         for(int var22 = 0; var22 < var17.countItems(); ++var22) {
            if (this.keysUpdate.getItem(var17.getItem(var22)) == -1) {
               this.keysUpdate.addItem(var17.getItem(var22));
            }
         }
      }

      if (this.columns.countItems() > 0) {
         for(int var18 = 0; var18 < this.columns.countItems(); ++var18) {
            this.columns.select(var18);
         }
      }

      for(int var19 = 0; var19 < var3.length; ++var19) {
         this.columns.select(var3[var19]);
      }

      if (this.keys.countItems() > 0) {
         var1.restoreObject(this.keys, var2, "keys");
      }

      if (this.keysUpdate.countItems() > 0) {
         var1.restoreObject(this.keysUpdate, var2, "keysUpdate");
      }

      if (this.keysUpdate.getSelectedItems().length == 0) {
         String[] var20 = this.keys.getSelectedItems();

         for(int var23 = 0; var23 < var20.length; ++var23) {
            this.keysUpdate.select(var20[var23]);
         }
      }

      return true;
   }

   void clearFields() {
      this.table.setText("");
      this.columnname.setText("");
      this.datatype.setText("");
      this.typename.setText("");
      this.precision.setText("");
      this.length.setText("");
      this.scale.setText("");
      this.radix.setText("");
      this.nullable.setText("");
      this.remarks.setText("");
   }

   void loadKeys() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = super.user.jaggSQL.getSEP();
      String var6 = "";
      this.retrieveTable();
      if (this.tableIndex == -1) {
         if (((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("You must first select a table.", 5);
         }

      } else {
         if (((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         }

         JDPJagg var7 = new JDPJagg(super.user.jaggPath);
         var7.loadSettings(this.targetDSN);
         var7.setFCTN("SQLPrimaryKeys");
         String var8 = this.target.tableName[this.tableIndex];
         String var9 = ";;" + var8 + ";;";
         int var10 = var8.indexOf(".");
         if (var10 >= 0) {
            var9 = ";" + var8.substring(0, var10) + ";" + var8.substring(var10 + 1) + ";;";
         }

         var7.setFCTNP(var9);
         var2 = var7.execSQL(var6, var3);
         if (var2 == -1) {
            if (((Component)this).isShowing()) {
               super.user.mainmsg.clearStatusMsg();
            }

         } else {
            if (super.user.DEBUG) {
               System.out.println("JDPSelectColumns/loadList COL: " + Integer.toString(var7.getColumnCount()));
            }

            if (var2 == 0 && ((Component)this).isShowing()) {
               super.user.mainmsg.setStatusMsg("No key defined for this table - Please create a key before proceeding.", 20);
            }

            for(int var12 = 0; var12 < var7.getRowCount(); ++var12) {
               String var5 = (String)var3.elementAt(var12);
               if (var5 != null && var5.trim().compareTo("") != 0) {
                  StringTokenizer var1 = new StringTokenizer(var5);
                  String var11 = var1.nextToken(var4).trim();
                  var11 = var1.nextToken(var4).trim();
                  var11 = var1.nextToken(var4).trim();
                  var11 = var1.nextToken(var4).trim();

                  for(int var13 = 0; var13 < this.keysUpdate.countItems(); ++var13) {
                     String var14 = this.keysUpdate.getItem(var13);
                     if (var14.startsWith("a.")) {
                        var14 = var14.substring(2);
                     }

                     if (var14.equals(var11)) {
                        this.keysUpdate.select(var13);
                     }

                     if (var14.equals(var11)) {
                        this.keys.select(var13);
                     }
                  }
               }
            }

            if (((Component)this).isShowing()) {
               super.user.mainmsg.clearStatusMsg();
            }

         }
      }
   }

   void saveArrays() {
      this.savetableQualifier = this.tableQualifier;
      this.savetableOwner = this.tableOwner;
      this.savetableName = this.tableName;
      this.savecolumnName = this.columnName;
      this.savecolumnDatatype = this.columnDatatype;
      this.savecolumnTypename = this.columnTypename;
      this.savecolumnPrecision = this.columnPrecision;
      this.savecolumnLength = this.columnLength;
      this.savecolumnScale = this.columnScale;
      this.savecolumnRadix = this.columnRadix;
      this.savecolumnNullable = this.columnNullable;
      this.savecolumnRemarks = this.columnRemarks;
      this.savecolumnIsIdentity = this.columnIsIdentity;
      int var1 = this.columns.countItems();
      this.saveColumns = new String[var1];

      for(int var2 = 0; var2 < var1; ++var2) {
         this.saveColumns[var2] = this.columns.getItem(var2);
      }

      this.tableQualifier = new String[var1];
      this.tableOwner = new String[var1];
      this.tableName = new String[var1];
      this.columnName = new String[var1];
      this.columnDatatype = new int[var1];
      this.columnTypename = new String[var1];
      this.columnPrecision = new String[var1];
      this.columnLength = new String[var1];
      this.columnScale = new String[var1];
      this.columnRadix = new String[var1];
      this.columnNullable = new String[var1];
      this.columnRemarks = new String[var1];
      this.columnIsIdentity = new boolean[var1];
   }

   void setNewArrayElement(int var1, String var2) {
      boolean var3 = false;
      int var4 = 0;

      for(var4 = 0; var4 < this.saveColumns.length; ++var4) {
         if (this.saveColumns[var4].equals(var2)) {
            var3 = true;
            break;
         }
      }

      if (var3) {
         this.tableQualifier[var1] = this.savetableQualifier[var4];
         this.tableOwner[var1] = this.savetableOwner[var4];
         this.tableName[var1] = this.savetableName[var4];
         this.columnName[var1] = this.savecolumnName[var4];
         this.columnDatatype[var1] = this.savecolumnDatatype[var4];
         this.columnTypename[var1] = this.savecolumnTypename[var4];
         this.columnPrecision[var1] = this.savecolumnPrecision[var4];
         this.columnLength[var1] = this.savecolumnLength[var4];
         this.columnScale[var1] = this.savecolumnScale[var4];
         this.columnRadix[var1] = this.savecolumnRadix[var4];
         this.columnNullable[var1] = this.savecolumnNullable[var4];
         this.columnRemarks[var1] = this.savecolumnRemarks[var4];
         this.columnIsIdentity[var1] = this.savecolumnIsIdentity[var4];
      }
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPSelectColumns" + super.componentName;
      var1.saveObject(this.columns, var2, "columnsItems", 1);
      var1.saveObject(this.keys, var2, "keysItems", 1);
      var1.saveObject(this.keysUpdate, var2, "keysUpdateItems", 1);
      var1.saveObject(this.columns, var2, "columns");
      var1.saveObject(this.keys, var2, "keys");
      var1.saveObject(this.keysUpdate, var2, "keysUpdate");
      return true;
   }

   void refresh() {
      this.retrieveTable();
      this.loadList();
      this.restoreSelections();
   }

   int[] getKeyIndexes(JDPList var1) {
      String[] var2 = ((JDPTreePicker)var1).getSelectedItems();
      int[] var3 = new int[var2.length];

      for(int var4 = 0; var4 < var2.length; ++var4) {
         var3[var4] = this.columns.getItem(var2[var4]);
      }

      return var3;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPList) {
               int var4 = (Integer)var1.arg;
               this.loadItem(var4);
               return true;
            }

            return false;
         case 1001:
            if (var1.target instanceof TextField) {
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Accept") == 0) {
                     this.keys.clear();

                     for(int var3 = 0; var3 < this.keysUpdate.countItems(); ++var3) {
                        this.keys.addItem(this.keysUpdate.getItem(var3));
                        if (this.keysUpdate.isSelected(var3)) {
                           this.keys.select(var3);
                        }
                     }

                     if (this.setNewColumns()) {
                        this.saveSelections();
                        if (super.componentName.equals("")) {
                           super.user.jdpMenuPanel.loadNextTab();
                        } else {
                           this.tabPanel = JDPUtils.getTabPanel(this);
                           if (this.tabPanel != null) {
                              this.tabPanel.loadNextTab();
                           }
                        }
                     }

                     return true;
                  }
               }

               return false;
            }
         default:
            return false;
      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPSelectColumns" + super.componentName;
      var1.removeObject(this.columns, var2, "columnsItems");
      var1.removeObject(this.keys, var2, "keysItems");
      var1.removeObject(this.keysUpdate, var2, "keysUpdateItems");
      var1.removeObject(this.columns, var2, "columns");
      var1.removeObject(this.keys, var2, "keys");
      var1.removeObject(this.keysUpdate, var2, "keysUpdate");
      var1.removeObject(this.columnLength, var2, "keysUpdate");
      return true;
   }

   void loadItem(int var1) {
      this.table.setText(this.tableName[var1]);
      this.columnname.setText(this.columnName[var1]);
      this.datatype.setText(JDPUtils.getODBCValue(this.columnDatatype[var1]));
      this.typename.setText(this.columnTypename[var1]);
      this.precision.setText(this.columnPrecision[var1]);
      this.length.setText(this.columnLength[var1]);
      this.scale.setText(this.columnScale[var1]);
      this.radix.setText(this.columnRadix[var1]);
      this.nullable.setText(this.columnNullable[var1]);
      this.remarks.setText(this.columnRemarks[var1]);
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      super.moduleName = "SelectColumns";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
         var3 = "";
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      this.dragPanel = new JDPDragItem(var1, var2);
      ((Container)var2).add(this.dragPanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      this.table = new TextField("", 20);
      this.columnname = new TextField("", 20);
      this.datatype = new TextField("", 20);
      this.typename = new TextField("", 20);
      this.precision = new TextField("", 10);
      this.length = new TextField("", 10);
      this.scale = new TextField("", 10);
      this.radix = new TextField("", 10);
      this.nullable = new TextField("", 10);
      this.remarks = new TextField("", 25);
      this.table.setEditable(false);
      this.columnname.setEditable(false);
      this.datatype.setEditable(false);
      this.typename.setEditable(false);
      this.precision.setEditable(false);
      this.length.setEditable(false);
      this.scale.setEditable(false);
      this.radix.setEditable(false);
      this.nullable.setEditable(false);
      this.remarks.setEditable(false);
      this.useRemarks = new JDPChoice(var1);
      this.useRemarks.addItem("Yes");
      this.useRemarks.addItem("No");
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Table:"));
      ((Container)var7).add("Right", this.table);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Column Name:"));
      ((Container)var7).add("Right", this.columnname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Data Type:"));
      ((Container)var7).add("Right", this.datatype);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Type Name:"));
      ((Container)var7).add("Right", this.typename);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Length:"));
      ((Container)var7).add("Right", this.precision);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Decimal:"));
      ((Container)var7).add("Right", this.scale);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Nullable:"));
      ((Container)var7).add("Right", this.nullable);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Remarks:"));
      ((Container)var7).add("Right", this.remarks);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Use remarks for Labels:"));
      ((Container)var7).add("Right", this.useRemarks);
      ((Container)var6).add("Center", var7);
      String[] var8 = new String[]{"Accept"};
      int[] var9 = new int[]{5};
      JDPButtons var10 = new JDPButtons(var1, var8, var9, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", var10);
      this.popuppanel.addComponent(var10.button[0], "Accept Selections", "Accept selections and proceed to next screen");
      ((Container)var4).add("Center", var6);
      this.columns = new JDPList(var1);
      this.columns.allowMultipleSelections(true);
      this.columns.setMinWidth(160);
      this.keys = new JDPList(var1);
      this.keys.allowMultipleSelections(true);
      this.keys.setMinWidth(160);
      this.keys.setSelectionsCheckboxes(true);
      this.keys.setAllowChangeOrder(true);
      this.keysUpdate = new JDPList(var1);
      this.keysUpdate.allowMultipleSelections(true);
      this.keysUpdate.setMinWidth(160);
      this.keysUpdate.setSelectionsCheckboxes(true);
      this.keysUpdate.setAllowChangeOrder(true);
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new BorderLayout());
      ((Container)var11).add("North", new JDPWrapLabel(var1, "Unique Key for Selects:"));
      ((Container)var11).add("Center", this.keys);
      Panel var12 = new Panel();
      ((Container)var12).setLayout(new BorderLayout());
      ((Container)var12).add("North", new JDPWrapLabel(var1, "Unique Key:"));
      ((Container)var12).add("Center", this.keysUpdate);
      this.popuppanel.addComponent(this.keysUpdate, "Primary table unique key", "Choose the columns that make up the unique key of the primary table. Drag columns to change the order.");
      ((Container)var4).add("West", var12);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Define key for selects and updates", var4, "North"));
      this.gParmObject = new Vector();
      this.gParmObject.addElement(super.moduleName + super.componentName);
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }

   void retrieveTable() {
      this.tableIndex = -1;

      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.target = (JDPSelectTable)var2.elementAt(1);
               this.tableIndex = this.target.tables.getSelectedIndex();
            }
         }
      }

   }
}
