import java.io.PrintStream;
import java.io.StringBufferInputStream;

public class JDPServerJob {
   PrintStream serverResponse;
   JDPUser user;
   JDPJagg jaggSQL;
   JDPSaveProps params;

   public void returnParm(String var1, String var2) {
      try {
         String var3 = var1 + "\u0003" + var2 + "\u0002";

         for(int var4 = 0; var4 < var3.length(); ++var4) {
            this.serverResponse.write(var3.charAt(var4));
         }

      } catch (Exception var6) {
         ((Throwable)var6).printStackTrace();
      }
   }

   public void runJob() {
   }

   public void InitClass(String var1, String var2, PrintStream var3) {
      this.serverResponse = var3;
      this.user = new JDPUser();
      this.user.cust = new JDPCustomer();
      this.user.u = new JDPUtils(this.user);
      this.params = new JDPSaveProps(this.user);
      StringBufferInputStream var4 = new StringBufferInputStream(var2);

      try {
         this.params.p.load(var4);
      } catch (Exception var14) {
         ((Throwable)var14).printStackTrace();
      }

      JDPJagg.activated = true;
      JDPJagg.useJaggServer = true;
      JDPJagg.version = JDesignerPro.version.trim();
      this.user.jaggPath = "";
      this.user.jaggDSN = "";
      this.user.jaggCSTR = "";
      this.user.jdbcDriver = "";
      this.user.jdbcPrefix = "";
      this.user.jdbcSuffix = "";
      this.user.jdbcUserid = "";
      this.user.jdbcPassword = "";
      this.user.jaggPath = (String)this.params.restoreObject("userjaggPath", this.user.jaggPath);
      this.user.jaggDSN = (String)this.params.restoreObject("userjaggDSN", this.user.jaggDSN);
      this.user.jaggCSTR = (String)this.params.restoreObject("userjaggCSTR", this.user.jaggCSTR);
      this.user.jdbcDriver = (String)this.params.restoreObject("userjdbcDriver", this.user.jdbcDriver);
      this.user.jdbcPrefix = (String)this.params.restoreObject("userjdbcPrefix", this.user.jdbcPrefix);
      this.user.jdbcSuffix = (String)this.params.restoreObject("userjdbcSuffix", this.user.jdbcSuffix);
      this.user.jdbcUserid = (String)this.params.restoreObject("userjdbcUserid", this.user.jdbcUserid);
      this.user.jdbcPassword = (String)this.params.restoreObject("userjdbcPassword", this.user.jdbcPassword);
      int var5 = this.params.restoreObject("userjaggPort", 0);
      JDPJagg.setDefaultPort(var5);
      this.user.jaggSQL = new JDPJagg(this.user.jaggPath);
      this.user.jaggSQL.loadSettings(this.user);
      String var6 = (String)this.params.restoreObject("jaggDSN", this.user.jaggDSN);
      String var7 = (String)this.params.restoreObject("jaggCSTR", this.user.jaggCSTR);
      String var8 = (String)this.params.restoreObject("jdbcDriver", this.user.jdbcDriver);
      String var9 = (String)this.params.restoreObject("jdbcPrefix", this.user.jdbcPrefix);
      String var10 = (String)this.params.restoreObject("jdbcSuffix", this.user.jdbcSuffix);
      String var11 = (String)this.params.restoreObject("jdbcUserid", this.user.jdbcUserid);
      String var12 = (String)this.params.restoreObject("jdbcPassword", this.user.jdbcPassword);
      if (!var6.equals("") || !var8.equals("")) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
         this.jaggSQL.setDSN(var6);
         this.jaggSQL.setCSTR(var7);
         this.jaggSQL.setJdbcDriver(var8);
         this.jaggSQL.setJdbcPrefix(var9);
         this.jaggSQL.setJdbcSuffix(var10);
         this.jaggSQL.setUID(var11);
         this.jaggSQL.setPWD(var12);
         this.jaggSQL.setMRW("1000000");
      }

      this.user.mainmsg = new JDPStatusMessage(this.user, var3, var1);
      this.runJob();
   }
}
