import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.StringBufferInputStream;
import java.net.Socket;
import java.util.Hashtable;
import java.util.Properties;

public class JDPServerListenerCxn extends Thread {
   JDPUser user;
   JDPServerListener listener;
   Socket thisSocket;
   private BufferedOutputStream serverResponse;
   private BufferedInputStream serverRequest;
   // $FF: renamed from: NL java.lang.String
   static String field_0 = "\u0002";
   static String EOT = "\u0001";

   String parseRequest(String var1) {
      String var2 = "";
      int var3 = var1.indexOf("\u0002SQL=");
      if (var3 >= 0) {
         var2 = var1.substring(var3 + 5, var1.length() - 1);
      }

      return var2;
   }

   void writeLn(String var1) {
      int var2 = var1.length();
      byte[] var3 = new byte[var2];
      var1.getBytes(0, var2, var3, 0);

      try {
         this.serverResponse.write(var3);
      } catch (Exception var4) {
      }
   }

   void processRequest(String var1) throws Exception {
      var1 = this.parseRequest(var1);
      Properties var2 = new Properties();
      StringBufferInputStream var3 = new StringBufferInputStream(var1);
      var2.load(var3);
      String var4 = (String)((Hashtable)var2).get("requestName");
      int var5 = Integer.parseInt((String)((Hashtable)var2).get("requestEventId"));
      String var6 = (String)((Hashtable)var2).get("requestArg");
      this.writeLn("JAGG_RESULT_ROWS:0");
      this.writeLn(field_0);
      this.writeLn(EOT);
      this.listener.registerRequest(var4, var5, var6);
   }

   public JDPServerListenerCxn(JDPUser var1, JDPServerListener var2, Socket var3) {
      this.user = var1;
      this.listener = var2;
      this.thisSocket = var3;
      ((Thread)this).start();
   }

   public void run() {
      try {
         this.serverResponse = new BufferedOutputStream(this.thisSocket.getOutputStream());
         this.serverRequest = new BufferedInputStream(this.thisSocket.getInputStream());
         String var1 = "";
         String var2 = "";
         int var3 = 0;
         char[] var4 = new char[10];
         int var5 = 0;

         do {
            int var6 = this.serverRequest.read();
            var4[var3++] = (char)var6;
            ++var5;
         } while(var5 < 10);

         var1 = String.copyValueOf(var4, 0, var3).trim();
         var5 = 0;

         try {
            var5 = Integer.parseInt(var1);
         } catch (Exception var8) {
         }

         if (var5 > 0) {
            var4 = new char[var5];

            for(var3 = 0; var3 < var5; ++var3) {
               var4[var3] = (char)this.serverRequest.read();
            }

            var2 = String.copyValueOf(var4, 0, var3);
            this.processRequest(var2);
            this.serverResponse.flush();
         }
      } catch (Exception var9) {
         try {
            this.writeLn("JAGG_RESULT_ROWS:0");
            this.writeLn(field_0);
            this.writeLn(EOT);
            this.serverResponse.flush();
         } catch (Exception var7) {
         }
      }

      ((Thread)this).stop();
   }
}
