import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Vector;

public class JDPServerPropMaint extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPButtons JDPButtons1;
   JDPTabSelectPanel TabPanel1;
   JDPChiselFramePanel ChiselPanel2;
   JDPScrollPanel ScrollPanel2;
   Label Label3;
   TextField mailServer;
   Label Label4;
   TextField returnAddress;
   JDPChiselFramePanel ChiselPanel3;
   JDPScrollPanel ScrollPanel1;
   Label Label1;
   JDPChoice commPort;
   Vector valuecommPort;
   Label Label2;
   JDPChoice baudRate;
   Vector valuebaudRate;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Server Properties");
      this.Panel1 = new Panel();
      String[] var4 = new String[]{"Apply"};
      int[] var5 = new int[]{JDPButton.getIconValue("Save")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      String[] var6 = new String[2];
      Panel[] var7 = new Panel[]{new Panel(), null};
      var7[0].setLayout(new BorderLayout());
      var6[0] = "Email";
      var7[1] = new Panel();
      var7[1].setLayout(new BorderLayout());
      var6[1] = "Paging";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var6, var7, "North");
      this.ChiselPanel2 = new JDPChiselFramePanel(var1, "Set the email properties for the server");
      this.ScrollPanel2 = new JDPScrollPanel();
      this.Label3 = new Label("Mail server name:", 0);
      this.mailServer = new TextField("", 30);
      this.Label4 = new Label("Default senders' email address:", 0);
      this.returnAddress = new TextField("", 30);
      this.ChiselPanel3 = new JDPChiselFramePanel(var1, "Set the alphanumeric paging properties for the server");
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label1 = new Label("Comm port for paging:", 0);
      this.commPortMain();
      this.Label2 = new Label("Default baud rate:", 0);
      this.baudRateMain();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("South", this.JDPButtons1);
      this.Panel1.add("Center", this.TabPanel1);
      var7[0].add("Center", this.ChiselPanel2);
      this.ChiselPanel2.add("Center", this.ScrollPanel2);
      this.ScrollPanel2.add("Left", this.Label3);
      this.ScrollPanel2.add("Right", this.mailServer);
      this.ScrollPanel2.add("Left", this.Label4);
      this.ScrollPanel2.add("Right", this.returnAddress);
      var7[1].add("Center", this.ChiselPanel3);
      this.ChiselPanel3.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.commPort);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.baudRate);
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(1, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.popuppanel.addComponent(this.mailServer, "", "Enter the machine name or IP address of the mailserver for sending emails");
      this.popuppanel.addComponent(this.returnAddress, "", "Enter the default email return address for the Server to use for status emails");
      this.popuppanel.addComponent(this.commPort, "", "Select the comm port to use for alphanumeric paging");
      this.popuppanel.addComponent(this.baudRate, "", "Select the default baud rate setting for the alpha paging service provider");
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.saveSettings();
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
      this.loadSettings();
   }

   public void loadSettings() {
      String var1 = this.user.JDesignerPro.JDPDirectory + "System" + JDesignerPro.serverSeparator + "ServerSettings.cfg";
      JDPSaveProps var2 = new JDPSaveProps(this.user);
      boolean var3 = var2.load(var1);
      if (var3) {
         String var4 = "Server";
         var2.restoreObject(this.mailServer, var4, "mailServer");
         var2.restoreObject(this.returnAddress, var4, "returnAddress");
         var2.restoreObject(this.commPort, var4, "commPort");
         var2.restoreObject(this.baudRate, var4, "baudRate");
      }

      if (this.mailServer.getText().equals("")) {
         this.mailServer.setText("mail");
      }

      if (this.returnAddress.getText().equals("")) {
         this.returnAddress.setText(this.user.cust.getEmailaddr());
      }

   }

   public void saveSettings() {
      String var1 = this.user.JDesignerPro.JDPDirectory + "System" + JDesignerPro.serverSeparator + "ServerSettings.cfg";
      JDPSaveProps var2 = new JDPSaveProps(this.user);
      String var3 = "Server";
      var2.saveObject(this.mailServer, var3, "mailServer");
      var2.saveObject(this.returnAddress, var3, "returnAddress");
      var2.saveObject(this.commPort, var3, "commPort");
      var2.saveObject(this.baudRate, var3, "baudRate");
      var2.save(var1);
   }

   public void commPortMain() {
      if (this.commPort == null) {
         this.commPort = new JDPChoice();
      }

      String[] var1 = new String[]{"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "", "", "", "", ""};
      String[] var2 = new String[]{"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "", "", "", "", ""};
      this.commPort.loadChoice(var1, var2);
   }

   public void baudRateMain() {
      if (this.baudRate == null) {
         this.baudRate = new JDPChoice();
      }

      String[] var1 = new String[]{"300", "600", "1200", "2400", "4800", "9600", "14400", "19200", "38400", "56000", "128000", "256000", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"300", "600", "1200", "2400", "4800", "9600", "14400", "19200", "38400", "56000", "128000", "256000", "", "", "", "", "", "", "", ""};
      this.baudRate.loadChoice(var1, var2);
   }
}
