import java.applet.AppletContext;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.Frame;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.Window;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.Date;
import java.util.Vector;

public class JDPSetup extends Frame {
   JDesignerPro target;
   String IniContents;
   JDPUser user;
   AppletContext context;
   Panel statusPanel;
   JDPStatusMessage mainmsg;
   TextField jaggPath;
   TextField adminUsername;
   TextField adminPassword;
   JDPSelectDSN selectDSN;
   JDPPopupMessage popuppanel;
   Panel basePanel;
   Panel mainPanel;
   JDPButton installOptionButton1;
   JDPButton installOptionButton2;
   String connectString;
   String dbtype;
   int counter = 1;
   int totalRecs = 10;

   boolean insertRecords() {
      this.counter = 1;
      this.user.mainmsg.setStatusMsg("Creating Default Records...", 0);
      boolean var2 = false;
      if (JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPSystemDef")) {
         String var1 = "SELECT JDPSystem FROM JDPSystemDef WHERE JDPSystem = '" + this.target.JDPSystem.trim() + "'";
         if (this.runSQL(var1) > 0) {
            var2 = true;
            var1 = "UPDATE JDPUser SET username = '" + this.adminUsername.getText() + "', password = '" + this.adminPassword.getText().toLowerCase() + "' WHERE userid = 2";
            this.runSQL(var1);
            return true;
         }
      }

      this.sts();
      String var5 = "INSERT INTO JDPSystemDef (JDPSystem, JDPSystemD, versionnum, bfontname, bfontsize, pfontname, pfontsize, jlanguage, country, dateformat) VALUES('" + this.target.JDPSystem.trim() + "', 'JDesignerPro System'," + "'0.00','Helvetica',11,'Helvetica',11,'en', ' ', 'mm/dd/yy')";
      if (this.runSQL(var5) < 0) {
         return false;
      } else {
         this.sts();
         var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','Main',0," + "'P','JDPBrowser','Docs/JDesignerPro.htm', " + "'Welcome'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var5) < 0) {
            return false;
         } else {
            this.sts();
            var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','Main',20," + "'M','System','', " + "'System Maintenance'," + "'A'," + "'Black', " + "'LightGray'," + "'ADMIN','', " + "'','', " + "'',0,0,0,0,0)";
            if (this.runSQL(var5) < 0) {
               return false;
            } else {
               this.sts();
               var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',0," + "'P','JDPBrowser','Docs/JDPSystemMain.htm', " + "'Help'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
               if (this.runSQL(var5) < 0) {
                  return false;
               } else {
                  this.sts();
                  var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',1," + "'P','JDPSystemMaint','', " + "'System Maintenance'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                  if (this.runSQL(var5) < 0) {
                     return false;
                  } else {
                     this.sts();
                     var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',2," + "'P','JDPMenuMaint','', " + "'Menu Maintenance'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                     if (this.runSQL(var5) < 0) {
                        return false;
                     } else {
                        this.sts();
                        var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',3," + "'P','JDPUserMaint','', " + "'User Maintenance'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                        if (this.runSQL(var5) < 0) {
                           return false;
                        } else {
                           this.sts();
                           var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',4," + "'P','JDPUserAuth','', " + "'User Menu Authorization'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                           if (this.runSQL(var5) < 0) {
                              return false;
                           } else {
                              this.sts();
                              var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',5," + "'P','JDPUserSystemMaint','', " + "'User System Authorization'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                              if (this.runSQL(var5) < 0) {
                                 return false;
                              } else {
                                 this.sts();
                                 var5 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "','System',65," + "'P','JDPUserBill','', " + "'User Billing Details'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                                 if (this.runSQL(var5) < 0) {
                                    return false;
                                 } else {
                                    this.user.mainmsg.setStatusMsg("Finishing Installation...", 0);
                                    var5 = "SELECT * FROM JDPUser WHERE username = 'guest'";
                                    if (this.runSQL(var5) > 0) {
                                       var2 = true;
                                       var5 = "UPDATE JDPUser SET username = '" + this.adminUsername.getText() + "', password = '" + this.adminPassword.getText().toLowerCase() + "' WHERE userid = 2";
                                       this.runSQL(var5);
                                    }

                                    if (!var2) {
                                       Date var3 = new Date(90, 0, 1);
                                       String var4 = JDPDate.formatForSql(var3, this.selectDSN.dsnType);
                                       var5 = "INSERT INTO JDPUser (userid,username,password,firstname,lastname,address1," + "address2,city,state,zipcode,country,cardnum,cardexpiry,cardname,phonenum," + "emailaddr,alphsvcph,alphpgrnum,lastaccess,totallogin,winx1,winy1,winx2," + "winy2,status,jdpsystem0,jdpsystem1,jdpsystem2,jdpsystem3,jdpsystem4," + "jdpsystem5,jdpsystem6,jdpsystem7,jdpsystem8,jdpsystem9,signupdate,canceldate) " + "VALUES(1,'guest','','Guest','Account','','','','','','','','','','',''," + "'',''," + var4 + ",0,0,0,640,480,'G','" + this.target.JDPSystem.trim() + "','','','','','','','','',''," + var4 + "," + var4 + ")";
                                       if (this.runSQL(var5) < 0) {
                                          return false;
                                       }

                                       var5 = "INSERT INTO JDPUser (userid,username,password,firstname,lastname,address1," + "address2,city,state,zipcode,country,cardnum,cardexpiry,cardname,phonenum," + "emailaddr,alphsvcph,alphpgrnum,lastaccess,totallogin,winx1,winy1,winx2," + "winy2,status,jdpsystem0,jdpsystem1,jdpsystem2,jdpsystem3,jdpsystem4," + "jdpsystem5,jdpsystem6,jdpsystem7,jdpsystem8,jdpsystem9,signupdate,canceldate) " + "VALUES(2,'" + this.adminUsername.getText().toLowerCase() + "','" + this.adminPassword.getText().toLowerCase() + "','Admin','Account','','','','','','','','','','',''," + "'',''," + var4 + ",0,0,0,640,480,'A','" + this.target.JDPSystem.trim() + "','','','','','','','','',''," + var4 + "," + var4 + ")";
                                       if (this.runSQL(var5) < 0) {
                                          return false;
                                       }
                                    } else {
                                       var5 = "UPDATE JDPUser SET jdpsystem1 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem1 = '' OR jdpsystem1 is NULL) AND userid <= 2";
                                       int var32 = this.runSQL(var5);
                                       if (var32 < 0) {
                                          return false;
                                       }

                                       if (var32 == 0) {
                                          var5 = "UPDATE JDPUser SET jdpsystem2 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem2 = '' OR jdpsystem2 is NULL) AND userid <= 2";
                                          if (this.runSQL(var5) == 0) {
                                             var5 = "UPDATE JDPUser SET jdpsystem3 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem3 = '' OR jdpsystem3 is NULL) AND userid <= 2";
                                             if (this.runSQL(var5) == 0) {
                                                var5 = "UPDATE JDPUser SET jdpsystem4 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem4 = '' OR jdpsystem4 is NULL) AND userid <= 2";
                                                if (this.runSQL(var5) == 0) {
                                                   var5 = "UPDATE JDPUser SET jdpsystem5 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem5 = '' OR jdpsystem5 is NULL) AND userid <= 2";
                                                   if (this.runSQL(var5) == 0) {
                                                      var5 = "UPDATE JDPUser SET jdpsystem6 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem6 = '' OR jdpsystem6 is NULL) AND userid <= 2";
                                                      if (this.runSQL(var5) == 0) {
                                                         var5 = "UPDATE JDPUser SET jdpsystem7 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem7 = '' OR jdpsystem7 is NULL) AND userid <= 2";
                                                         if (this.runSQL(var5) == 0) {
                                                            var5 = "UPDATE JDPUser SET jdpsystem8 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem8 = '' OR jdpsystem8 is NULL) AND userid <= 2";
                                                            if (this.runSQL(var5) == 0) {
                                                               var5 = "UPDATE JDPUser SET jdpsystem9 = '" + this.target.JDPSystem.trim() + "' " + "WHERE (jdpsystem9 = '' OR jdpsystem9 is NULL) AND userid <= 2";
                                                            }
                                                         }
                                                      }
                                                   }
                                                }
                                             }
                                          }
                                       }
                                    }

                                    var5 = "INSERT INTO JDPMenuAuth (JDPSystem,userid,initmenu,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "',1,'Main'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
                                    if (this.runSQL(var5) < 0) {
                                       return false;
                                    } else {
                                       var5 = "INSERT INTO JDPMenuAuth (JDPSystem,userid,initmenu,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.target.JDPSystem.trim() + "',2,'Main'," + "'*ALL','ADMIN', " + "'','', " + "'',0,0,0,0,0)";
                                       if (this.runSQL(var5) < 0) {
                                          return false;
                                       } else {
                                          this.user.mainmsg.setStatusMsg("JDesignerPro Database successfully created.", 10);
                                          return true;
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }

   int runSQL(String var1) {
      Vector var2 = new Vector();
      int var3 = this.user.jaggSQL.execSQL(var1, var2);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.user.jaggSQL, var1);
      }

      return var3;
   }

   boolean createDatabase() throws InterruptedException {
      this.user.mainmsg.setStatusMsg("Table creation in progress...", 0);
      this.IniContents = this.IniContents + this.target.JDPSystem + this.jaggPath.getText() + " ";
      if (JDPJagg.useJaggServer) {
         this.connectString = "DSN=" + this.selectDSN.datasource.getText() + ";";
         String var10001 = this.connectString;
         this.connectString = var10001 + "JDBCDRIVER=" + this.selectDSN.jdbcdriver.getText() + ";";
         var10001 = this.connectString;
         this.connectString = var10001 + "JDBCPREFIX=" + this.selectDSN.jdbcprefix.getText() + ";";
         var10001 = this.connectString;
         this.connectString = var10001 + "JDBCSUFFIX=" + this.selectDSN.jdbcsuffix.getText() + ";";
         var10001 = this.connectString;
         this.connectString = var10001 + "UID=" + this.selectDSN.userid.getText() + ";";
         var10001 = this.connectString;
         this.connectString = var10001 + "PWD=" + this.selectDSN.password.getText() + ";";
         if (!this.selectDSN.connectstring.getText().equals("")) {
            var10001 = this.connectString;
            this.connectString = var10001 + "CSTR=" + this.selectDSN.connectstring.getText() + ";";
         }
      } else {
         this.connectString = this.selectDSN.connectstring.getText();
      }

      String var43 = this.IniContents;
      this.IniContents = var43 + this.connectString + "\r\n";
      this.user.jaggSQL.loadSettings(this.selectDSN);
      Vector var2 = new Vector();
      int var3 = 1;
      this.dbtype = this.user.u.getDataSourceType(this.user.jaggSQL);
      System.out.println("DBTYPE=" + this.dbtype);
      if (this.dbtype == null) {
         return false;
      } else {
         String var4 = "text";
         String var5 = "date";
         String var6 = "float";
         String var7 = "int";
         String var8 = " NULL";
         if (this.dbtype.indexOf(JDPJagg.MSSQLSERVER) >= 0) {
            var4 = "text";
            var5 = "datetime";
            var6 = "decimal";
         } else if (this.dbtype.indexOf(JDPJagg.SYBASE) < 0 && this.dbtype.indexOf(JDPJagg.SYBASE10) < 0) {
            if (this.dbtype.indexOf(JDPJagg.ANYWHERE) >= 0) {
               var4 = "text";
               var5 = "datetime";
               var6 = "decimal";
            } else if (this.dbtype.indexOf(JDPJagg.FOXPRO) >= 0) {
               var6 = "int";
               var8 = "";
               var4 = "memo";
            } else if (this.dbtype.indexOf(JDPJagg.ORACLE) >= 0) {
               var4 = "long";
               var6 = "decimal";
            } else if (this.dbtype.indexOf(JDPJagg.POLITE) >= 0) {
               var4 = "long";
               var6 = "decimal";
            } else if (this.dbtype.indexOf(JDPJagg.DB2) >= 0) {
               var4 = "long varchar";
               var6 = "decimal";
            }
         } else {
            var4 = "text";
            var5 = "datetime";
            var6 = "decimal";
         }

         if (this.dbtype.indexOf(JDPJagg.SOLIDSERVER) >= 0) {
            var4 = "long varchar";
            var6 = "decimal";
         }

         if (this.dbtype.indexOf(JDPJagg.LOTUS) >= 0) {
            var4 = "long varchar";
            var6 = "decimal";
            var7 = "integer";
         }

         if (this.dbtype.indexOf(JDPJagg.INFORMIX) >= 0) {
            var4 = "varchar(255)";
            var6 = "decimal";
            var7 = "integer";
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPDataSrc")) {
            String var1 = "CREATE TABLE JDPDataSrc (sourcename char(50), jdbcdriver char(100), jdbcprefix char(100), jdbcsuffix char(100), conparms char(100), sourcetype char(50), jdbcdirect char(3))";
            if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var1);
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPSystemDef")) {
            this.user.mainmsg.setStatusMsg("Creating table " + Integer.toString(var3++) + " of 5...", 0);
            String var9 = "CREATE TABLE JDPSystemDef (" + "JDPSystem char (5) ," + "JDPSystemD char (50) ," + "versionnum char (10) ," + "bfontname char (30) ," + "bfontsize " + var7 + " ," + "pfontname char (30) ," + "pfontsize " + var7 + ", " + "jlanguage char (2) ," + "country char (2), " + "dateformat char (20) )";
            if (this.user.jaggSQL.execSQL(var9, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var9);
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPMenu")) {
            this.user.mainmsg.setStatusMsg("Creating table " + Integer.toString(var3) + " of 5...", 0);
            String var10 = "CREATE TABLE JDPMenu\t(" + "JDPSystem char (5) , " + "menuname char (20) , " + "menunum " + var7 + ",\t\t\t" + "menutype char (1) ,\t" + "menuobject char (20) , " + "menuparm char (150) ,\t" + "menudesc char (30) ,\t" + "menutxtclr char (15) ,\t" + "menutabclr char (15) , " + "menustatus char (1) ,\t" + "menuauth1 char (10) ,\t" + "menulvl1 " + var7 + ",   " + "menuauth2 char (10) ,\t" + "menulvl2 " + var7 + ",   " + "menuauth3 char (10) ,\t" + "menulvl3 " + var7 + "," + "menuauth4 char (10) ,\t" + "menulvl4 " + var7 + ",\t" + "menuauth5 char (10) ,\t" + "menulvl5 " + var7 + ") ";
            if (this.user.jaggSQL.execSQL(var10, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var10);
               return false;
            }
         }

         ++var3;
         if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPMenuAuth")) {
            this.user.mainmsg.setStatusMsg("Creating table " + Integer.toString(var3) + " of 5...", 0);
            String var11 = "CREATE TABLE JDPMenuAuth\t(" + "JDPSystem char (5) , " + "userid " + var7 + ", " + "initmenu char (20) ," + "menuauth1 char (10) ,\t" + "menulvl1 " + var7 + ",   " + "menuauth2 char (10) ,\t" + "menulvl2 " + var7 + ",   " + "menuauth3 char (10) ,\t" + "menulvl3 " + var7 + "," + "menuauth4 char (10) ,\t" + "menulvl4 " + var7 + ",\t" + "menuauth5 char (10) ,\t" + "menulvl5 " + var7 + ") ";
            if (this.user.jaggSQL.execSQL(var11, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var11);
               return false;
            }
         }

         ++var3;
         if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPUser")) {
            this.user.mainmsg.setStatusMsg("Creating table " + Integer.toString(var3) + " of 5...", 0);
            String var12 = "CREATE TABLE JDPUser\t(" + "userid " + var7 + "," + "username char (20) ," + "password char (20) ," + "firstname char (15) ," + "lastname char (20) ," + "address1 char (45) ," + "address2 char (45) ," + "city char (30) ," + "state char (2) ," + "zipcode char (10) ," + "country char (20) ," + "cardnum char (20) ," + "cardexpiry char (4) ," + "cardname char (30) ," + "phonenum char (15) ," + "emailaddr char (50) ," + "alphsvcph char (25) ," + "alphpgrnum char (15) ," + "lastaccess " + var5 + " ," + "totallogin " + var7 + "," + "winx1 " + var7 + "," + "winy1 " + var7 + "," + "winx2 " + var7 + "," + "winy2 " + var7 + "," + "status char (1) ," + "jdpsystem0 char (5) ," + "jdpsystem1 char (5) ," + "jdpsystem2 char (5) ," + "jdpsystem3 char (5) ," + "jdpsystem4 char (5) ," + "jdpsystem5 char (5) ," + "jdpsystem6 char (5) ," + "jdpsystem7 char (5) ," + "jdpsystem8 char (5) ," + "jdpsystem9 char (5) ," + "signupdate " + var5 + " ," + "canceldate " + var5 + " )";
            if (this.user.jaggSQL.execSQL(var12, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var12);
               return false;
            }
         }

         ++var3;
         ++var3;
         return true;
      }
   }

   JDPSetup(JDesignerPro var1, String var2) {
      super("JDesignerPro Setup");
      this.target = var1;
      this.IniContents = var2;
      ((Component)this).setBackground(JDPUtils.getControlColor());
      this.user = new JDPUser();
      this.user.JDesignerPro = var1;
      this.user.u = new JDPUtils(this.user);
      this.user.gParm = new Vector();
      this.user.plainFont = new Font("Helvetica", 0, 11);
      this.user.boldFont = new Font("Helvetica", 1, 11);
      ((Component)this).setFont(this.user.plainFont);
      this.user.popup = new JDPPopupComponent(this.user, this);
      ((Container)this).add(this.user.popup);
      ((Container)this).setLayout(new BorderLayout());
      String var3 = "";
      if (var1.JDPJaggDir != null) {
         int var4 = var1.JDPJaggDir.lastIndexOf("\\", var1.JDPJaggDir.length() - 2);
         if (var4 >= 0) {
            var3 = var1.JDPDomain + var1.JDPJaggDir.substring(var4 + 1, var1.JDPJaggDir.length() - 1) + "/JDPJagg.exe";
         } else {
            var3 = var1.JDPDomain + "JDPJagg.exe";
         }
      } else {
         var3 = var1.JDPDomain;
      }

      this.jaggPath = new TextField(var3, 50);
      this.adminUsername = new TextField("admin", 15);
      this.adminPassword = new TextField("", 15);
      this.mainPanel = new Panel();
      this.mainPanel.setLayout(new BorderLayout());
      this.basePanel = new Panel();
      this.basePanel.setLayout(new BorderLayout());
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new JDPRowLayout(1, 1));
      this.popuppanel = new JDPPopupMessage(this.user, this.basePanel);
      this.basePanel.add(this.popuppanel);
      if (!JDPJagg.useJaggServer) {
         Panel var5 = new Panel();
         ((Container)var5).setLayout(new JDPLineLayout(1));
         ((Container)var13).add("Left", new JDPWrapLabel(this.user, "URL to JDPJagg.exe:"));
         ((Container)var5).add("Left", this.jaggPath);
         this.popuppanel.addComponent(this.jaggPath, "URL path to JDPJagg.exe CGI program", "Enter the corrent URL path to JDPJagg.exe CGI program");
         JDPButton var6 = new JDPButton("Apply", 5, 1);
         ((Container)var5).add("Left", var6);
         this.popuppanel.addComponent(var6, "Load list of datasources", "Press to search for a list of Datasources/Databases on your server");
         ((Container)var13).add("Right", var5);
      }

      Panel var14 = new Panel();
      Panel var15 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout(1));
      ((Container)var15).setLayout(new JDPLineLayout(1));
      if (var1.NDSPath == null) {
         ((Container)var13).add("Left", new JDPWrapLabel(this.user, "Admin Username:"));
      } else {
         ((Container)var13).add("Left", new JDPWrapLabel(this.user, "NDS Admin Username:"));
      }

      ((Container)var14).add("Left", this.adminUsername);
      this.installOptionButton1 = new JDPButton("Standard Installation", 5, 1);
      this.installOptionButton2 = new JDPButton("Custom Installation   ", 32, 1);
      ((Container)var14).add("Right", this.installOptionButton1);
      this.popuppanel.addComponent(this.adminUsername, "JDesignerPro Admin username", "Enter the Admin username you would like to use to administer JDP");
      if (var1.NDSPath == null) {
         ((Container)var13).add("Left", new JDPWrapLabel(this.user, "Admin Password:"));
      } else {
         ((Container)var13).add("Left", new JDPWrapLabel(this.user, "NDS Admin Password:"));
         this.adminPassword.setEchoCharacter('*');
      }

      ((Container)var15).add("Left", this.adminPassword);
      ((Container)var15).add("Right", this.installOptionButton2);
      this.popuppanel.addComponent(this.adminPassword, "JDesignerPro Admin password", "Enter the Admin password you would like to use to administer JDP");
      ((Container)var13).add("Right", var14);
      ((Container)var13).add("Right", var15);
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      ((Container)var7).add("West", var13);
      this.mainPanel.add("North", var7);
      this.user.wwwroot = var1.wwwroot;
      this.user.mainmsg = new JDPStatusMessage(this.user);
      this.user.mainmsg.remove(this.user.mainmsg.eastMessage);
      this.user.mainmsg.remove(this.user.mainmsg.message);
      this.user.mainmsg.message = new TextField("", 40);
      this.user.mainmsg.message.setEditable(false);
      this.user.mainmsg.add("Center", this.user.mainmsg.message);
      this.user.cust = new JDPCustomer();
      this.user.jaggSQL = new JDPJagg(this.jaggPath.getText());
      this.user.jaggSQL.setDropConnectionAfter(300);
      this.selectDSN = new JDPSelectDSN();
      this.selectDSN.InitClass(this.user, this.mainPanel, "JDPSetup");
      this.mainPanel.add("Center", this.selectDSN);
      boolean var8 = false;
      boolean var9 = this.selectDSN.loadList();
      this.statusPanel = new Panel();
      this.statusPanel.setLayout(new BorderLayout());
      this.basePanel.add("Center", new JDPChiselFramePanel(this.user, "JDesignerPro Installation", this.mainPanel, "North"));
      this.statusPanel.add("Center", this.user.mainmsg);
      this.basePanel.add("South", this.statusPanel);
      ((Component)this).hide();
      ((Container)this).removeAll();
      ((Container)this).add(this.user.popup);
      ((Container)this).add("Center", this.basePanel);
      ((Window)this).pack();
      Dimension var10 = Toolkit.getDefaultToolkit().getScreenSize();
      if (var10.width > 800 && var10.height > 600) {
         ((Component)this).reshape(0, 0, 800, 570);
      } else {
         ((Component)this).reshape(0, 0, var10.width, var10.height - 30);
      }

      if (var9) {
         this.selectDefaultDSN(true);
      }

      if (this.selectDSN.isVisible()) {
         this.installOptionButton1.hide();
         this.installOptionButton2.hide();
         if (var9 && !var8) {
            this.user.mainmsg.setStatusMsg("Select or enter a Datasource/Database name and press the Install button.", 0);
         }
      }

      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
      ((Window)this).show();
      if (this.selectDSN.dataSources.countItems() <= 0) {
         if (!JDPJagg.useJaggServer) {
            this.jaggPath.requestFocus();
            this.jaggPath.selectAll();
         } else {
            this.user.u.cursor(this.adminUsername);
         }
      } else {
         this.user.u.cursor(this.adminUsername);
      }

      if (var8) {
         this.user.mainmsg.setStatusMsg("Check that JaggServer is running and DOMAIN= setting is correct in JDesignerPro.ini.", 0);
      }

      Vector var11 = new Vector();
      var11.addElement("Setup");
      var11.addElement(this);
      this.user.gParm.addElement(var11);
   }

   boolean writeIniFile() {
      int var1 = 0;
      String var2 = this.target.JDPDirectory + "JDesignerPro.ini";
      Object var4 = null;
      String var6 = "";

      try {
         String var7 = this.target.wwwroot + "JDesignerPro.ini";
         InputStream var14;
         if (!JDesignerPro.executable) {
            URL var3 = new URL(var7);
            var14 = var3.openStream();
         } else {
            FileInputStream var8 = new FileInputStream(var2);
            var14 = (InputStream)var8;
         }

         new DataInputStream(var14);
         byte[] var17 = new byte[4096];

         try {
            var14.read(var17, 0, var17.length);
            var14.close();
            var6 = new String(var17, 0);
            Object var18 = null;
         } catch (Exception var11) {
            this.user.mainmsg.setStatusMsg("Error occured while reading template file. Please try again.", 10);
            ((Throwable)var11).printStackTrace();
            return false;
         }
      } catch (Exception var12) {
         System.out.println("Could not open JDesignerPro.ini file.");
         System.out.println("Check that http server is running and that JDPJagg.exe is in your cgi directory.");
         return false;
      }

      this.IniContents = var6.trim() + "\r\n" + this.IniContents.trim() + "\r\n";
      this.user.jaggSQL.setFCTN("WriteToFile");
      this.user.jaggSQL.setFCTNP(var2 + ";w+;");
      Vector var16 = new Vector();
      var1 = this.user.jaggSQL.execSQL(this.IniContents, var16);
      if (var1 < 0) {
         this.user.mainmsg.setStatusMsg("JDesignerPro.ini File Write Failed - check JDPDIR setting.", 20);
      }

      this.user.jaggSQL.setFCTN("");
      this.user.jaggSQL.setFCTNP("");
      return var1 == 0;
   }

   void sts() {
      this.user.mainmsg.setStatusMsg("Creating Default Record " + Integer.toString(this.counter++) + " of " + Integer.toString(this.totalRecs) + "...", 0);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 201:
            ((Frame)this).dispose();
            JDPJagg.cleanUp();
            if (JDesignerPro.executable) {
               System.exit(0);
            }

            return true;
         case 503:
         case 504:
         case 505:
            var1.x -= this.basePanel.bounds().x;
            var1.y -= this.basePanel.bounds().y;
            if (this.popuppanel != null) {
               this.popuppanel.postEvent(var1);
            }

            return false;
         case 1001:
            if (var1.target instanceof JDPButton) {
               String var5 = (String)var1.arg;
               this.user.cust.username = this.adminUsername.getText();
               if (var5.equals("Apply")) {
                  this.user.jaggSQL = new JDPJagg(this.jaggPath.getText());
                  this.user.jaggSQL.setDropConnectionAfter(300);
                  this.selectDSN.clearList();
                  this.selectDSN.loadList();
                  this.selectDefaultDSN(false);
               }

               if (var5.trim().equals("Custom Installation")) {
                  this.installOptionButton1.hide();
                  this.installOptionButton2.hide();
                  this.selectDSN.show();
                  Dimension var3 = Toolkit.getDefaultToolkit().getScreenSize();
                  if (var3.width > 800 && var3.height > 600) {
                     ((Component)this).reshape(0, 0, 800, 570);
                  } else {
                     ((Component)this).reshape(0, 0, var3.width, var3.height);
                  }

                  ((Container)this).layout();
                  ((Component)this).paintAll(((Component)this).getGraphics());
                  this.user.mainmsg.setStatusMsg("Select or enter a Datasource/Database name and press the Install button.", 0);
               }

               if (!var5.trim().equals("Install JDP") && !var5.trim().equals("Standard Installation")) {
                  if (var5.trim().equals("Exit Setup")) {
                     ((Frame)this).dispose();
                     JDPJagg.cleanUp();
                     if (JDesignerPro.executable) {
                        System.exit(0);
                     }

                     return true;
                  }

                  return true;
               } else if (this.adminUsername.getText().compareTo("") == 0) {
                  this.user.mainmsg.setStatusMsg("Please enter the desired Administration Username.", 10);
                  return true;
               } else if (this.adminPassword.getText().compareTo("") == 0) {
                  this.user.mainmsg.setStatusMsg("Please enter the desired Administration Password.", 10);
                  return true;
               } else {
                  this.user.mainmsg.clearStatusMsg();
                  this.user.mainmsg.setStatusMsg("Connecting to database...", 0);
                  if (this.selectDSN.connectstring.getText().compareTo("") == 0) {
                     this.selectDSN.buildConnectString();
                  }

                  if (!this.selectDSN.setNewDSN()) {
                     return true;
                  } else {
                     if (this.selectDSN.datasource.getText().length() <= 0) {
                        this.user.mainmsg.setStatusMsg("Please choose a data source where you would like JDesignerPro Installed.", 10);
                        return true;
                     }

                     try {
                        if (this.createDatabase() && this.insertRecords() && this.writeIniFile()) {
                           this.target.user = new JDPUser[1];
                           this.target.user[0] = new JDPUser();
                           this.target.user[0].cust = new JDPCustomer();
                           this.target.user[0].cust.username = this.adminUsername.getText();
                           this.target.user[0].cust.password = this.adminPassword.getText();
                           this.target.user[0].loginMessage = this.user.mainmsg;
                           this.target.getSystem(this.target.JDPSystem, this.jaggPath.getText() + " " + this.connectString);
                           this.target.login.username.setText(this.adminUsername.getText());
                           this.target.login.password.setText(this.adminPassword.getText());
                           Event var6 = new Event(this.target.login.okButton, 1001, "OK");
                           this.target.login.postEvent(var6);
                           this.target.login.mainmsg.setStatusMsg("Starting Enterprise Server...", 0);
                           this.user.jaggSQL.invoke("JDPSubsystemMgr", "start");
                           ((Frame)this).dispose();
                        }
                     } catch (InterruptedException var4) {
                     }

                     return true;
                  }
               }
            } else if (var1.target instanceof MenuItem) {
               String var2 = (String)var1.arg;
               if (var2.equals("About JDP...")) {
                  this.user.process = new JDPProcessThread[2];
                  this.user.processStatus = new int[2];
                  this.user.startProcess(1, this.user.mainmsg);
               }

               if (var2.equals("Quit")) {
                  ((Frame)this).dispose();
                  JDPJagg.cleanUp();
                  if (JDesignerPro.executable) {
                     System.exit(0);
                  }
               }

               return true;
            }
         case 401:
            if (var1.key == 9) {
               if (var1.target.equals(this.jaggPath)) {
                  this.user.u.cursor(this.adminUsername);
                  return true;
               }

               if (var1.target.equals(this.adminUsername)) {
                  this.user.u.cursor(this.adminPassword);
                  return true;
               }

               if (this.selectDSN.isVisible()) {
                  if (var1.target.equals(this.adminPassword)) {
                     this.user.u.cursor(this.selectDSN.userid);
                     return true;
                  }
               } else if (var1.target.equals(this.adminPassword)) {
                  this.user.u.cursor(this.adminUsername);
                  return true;
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   void selectDefaultDSN(boolean var1) {
      boolean var2 = false;

      for(int var3 = 0; var3 < this.selectDSN.dataSources.countItems(); ++var3) {
         if (this.selectDSN.dataSources.getItem(var3).equals("JDesignerPro DB3")) {
            this.selectDSN.datasource.setText("JDesignerPro DB3");
            this.selectDSN.jdbcdriver.select(0);
            this.selectDSN.jdbcprefix.select(0);
            this.selectDSN.jdbcsuffix.setText("JDesignerPro DB3");
            this.selectDSN.jdbcsuffixC.select("JDesignerPro DB3");
            this.selectDSN.dataSources.select(var3);
            this.selectDSN.dataSources.makeVisible(var3);
            if (var1) {
               ((CardLayout)this.selectDSN.jdbcsuffixPanel.getLayout()).show(this.selectDSN.jdbcsuffixPanel, "jdbc:odbc:");
               this.selectDSN.hide();
               ((Window)this).pack();
               ((Component)this).move(60, 70);
               if (this.target.NDSPath == null) {
                  this.user.mainmsg.setStatusMsg("Enter an administrator password and select installation type.", 0);
               } else {
                  this.user.mainmsg.setStatusMsg("Enter your NDS Administrator username and password.", 0);
               }
            } else {
               this.user.mainmsg.setStatusMsg("Select a database in which to install the JDP system tables.", 0);
            }

            var2 = true;
            break;
         }
      }

      if (!var2) {
         for(int var4 = 0; var4 < this.selectDSN.dataSources.countItems(); ++var4) {
            if (this.selectDSN.dataSources.getItem(var4).equals("JDesignerPro DB")) {
               this.selectDSN.datasource.setText("JDesignerPro DB");
               this.selectDSN.jdbcdriver.select(0);
               this.selectDSN.jdbcprefix.select(0);
               this.selectDSN.jdbcsuffix.setText("JDesignerPro DB");
               this.selectDSN.jdbcsuffixC.select("JDesignerPro DB");
               this.selectDSN.dataSources.select(var4);
               this.selectDSN.dataSources.makeVisible(var4);
               if (var1) {
                  ((CardLayout)this.selectDSN.jdbcsuffixPanel.getLayout()).show(this.selectDSN.jdbcsuffixPanel, "jdbc:odbc:");
                  this.selectDSN.hide();
                  ((Window)this).pack();
                  ((Component)this).move(60, 70);
                  if (this.target.NDSPath == null) {
                     this.user.mainmsg.setStatusMsg("Enter an administrator password and select installation type.", 0);
                  } else {
                     this.user.mainmsg.setStatusMsg("Enter your NDS Administrator username and password.", 0);
                  }
               } else {
                  this.user.mainmsg.setStatusMsg("Select a database in which to install the JDP system tables.", 0);
               }
               break;
            }
         }
      }

      if (!var2) {
         for(int var5 = 0; var5 < this.selectDSN.dataSources.countItems(); ++var5) {
            if (this.selectDSN.dataSources.getItem(var5).equals("Cloudscape")) {
               this.selectDSN.datasource.setText("Cloudscape");
               this.selectDSN.jdbcdriver.select(8);
               this.selectDSN.jdbcprefix.select(8);
               this.selectDSN.jdbcsuffix.setText("JDP1");
               this.selectDSN.jdbcsuffixC.select(0);
               this.selectDSN.dataSources.select(var5);
               this.selectDSN.dataSources.makeVisible(var5);
               if (var1) {
                  ((CardLayout)this.selectDSN.jdbcsuffixPanel.getLayout()).show(this.selectDSN.jdbcsuffixPanel, "other");
                  this.selectDSN.hide();
                  ((Window)this).pack();
                  ((Component)this).move(60, 70);
                  if (this.target.NDSPath == null) {
                     this.user.mainmsg.setStatusMsg("Enter an administrator password and select installation type.", 0);
                     return;
                  }

                  this.user.mainmsg.setStatusMsg("Enter your NDS Administrator username and password.", 0);
                  return;
               }

               this.user.mainmsg.setStatusMsg("Select a database in which to install the JDP system tables.", 0);
               return;
            }

            if (this.selectDSN.dataSources.getItem(var5).equals("Oracle")) {
               this.selectDSN.datasource.setText("Oracle");
               this.selectDSN.jdbcdriver.select(2);
               this.selectDSN.jdbcprefix.select(2);
               this.selectDSN.jdbcsuffix.setText("@" + this.user.JDesignerPro.JDPDomain.substring(7, this.user.JDesignerPro.JDPDomain.length() - 1) + ":1521:ORCL");
               this.selectDSN.jdbcsuffixC.select(0);
               this.selectDSN.userid.setText("system");
               this.selectDSN.password.setText("manager");
               this.selectDSN.dataSources.select(var5);
               this.selectDSN.dataSources.makeVisible(var5);
               if (var1) {
                  ((CardLayout)this.selectDSN.jdbcsuffixPanel.getLayout()).show(this.selectDSN.jdbcsuffixPanel, "other");
                  this.selectDSN.hide();
                  ((Window)this).pack();
                  ((Component)this).move(60, 70);
                  if (this.target.NDSPath == null) {
                     this.user.mainmsg.setStatusMsg("Enter an administrator password and select installation type.", 0);
                     return;
                  }

                  this.user.mainmsg.setStatusMsg("Enter your NDS Administrator username and password.", 0);
                  return;
               }

               this.user.mainmsg.setStatusMsg("Select a database in which to install the JDP system tables.", 0);
               return;
            }
         }
      }

   }
}
