import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSingle extends JDesignerPro implements Runnable {
   String panelName = "";
   Label msgLabel;

   public JDPUser initUser(int var1) {
      JDPUser var2 = new JDPUser();
      var2.JDesignerPro = this;
      JDPButton.user = var2;
      var2.jaggSQL = super.jaggSQL;
      var2.u = new JDPUtils(var2);
      JDPLang.load(var2, super.language, super.country);
      var2.boldFontName = super.boldFontName;
      var2.boldFontSize = super.boldFontSize;
      var2.plainFontName = super.plainFontName;
      var2.plainFontSize = super.plainFontSize;
      var2.plainFont = new Font(super.plainFontName, 0, super.plainFontSize);
      var2.boldFont = new Font(super.boldFontName, 1, super.boldFontSize);
      ((Component)this).setFont(var2.plainFont);
      var2.JDesignerPro = this;
      var2.jaggPath = super.JDPJaggPath;
      var2.jaggDSN = super.JDPJaggDSN;
      var2.jaggCSTR = super.JDPJaggCSTR;
      var2.jdbcDriver = super.JDPJaggJdbcDriver;
      var2.jdbcPrefix = super.JDPJaggJdbcPrefix;
      var2.jdbcSuffix = super.JDPJaggJdbcSuffix;
      var2.jdbcUserid = super.JDPJaggJdbcUserid;
      var2.jdbcPassword = super.JDPJaggJdbcPassword;
      var2.wwwroot = super.wwwroot;
      var2.gParm = new Vector();
      var2.serverListener = new JDPServerListener(var2);
      var2.serverListener.registerForRequest("JDPSystemMessage", this);
      return var2;
   }

   public void stop() {
      super.jaggSQL.setFCTN("Logout");
      super.jaggSQL.setFCTNP("");
      Vector var1 = new Vector();
      super.jaggSQL.execSQL("", var1);
   }

   public boolean checkSetup(String var1, String var2, String var3) {
      if (var3.substring(0, 4).compareTo("http") != 0) {
         int var4 = var3.lastIndexOf("/");
         if (var4 > 0) {
            var3 = var3.substring(0, var4 + 1);
            super.wwwroot = var3;
         }
      }

      var2 = ((JDesignerPro)this).loadIniFile(var3, var1);
      ((JDesignerPro)this).getServerPlatform();
      if (var2 == null) {
         return false;
      } else {
         return var2.length() > 0 ? this.getSystem(var1, var2) : false;
      }
   }

   public boolean getSystem(String var1, String var2) {
      int var3 = var2.indexOf(" ");
      super.JDPJaggPath = var2.substring(0, var3);
      super.JDPJaggCSTR = var2.substring(var3 + 1);
      int var4 = super.JDPJaggCSTR.indexOf("DSN=") + 4;
      int var5 = super.JDPJaggCSTR.indexOf(";", var4);
      super.JDPJaggDSN = super.JDPJaggCSTR.substring(var4, var5);
      int var6 = var2.indexOf("JDBCDRIVER=");
      if (var6 >= 0) {
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcDriver = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("JDBCPREFIX=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcPrefix = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("JDBCSUFFIX=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcSuffix = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("UID=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcUserid = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("PWD=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcPassword = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("CSTR=", var6 + 1);
         super.JDPJaggCSTR = "";
         if (var6 > 0) {
            var6 = var2.indexOf("=", var6 + 1);
            super.JDPJaggCSTR = var2.substring(var6 + 1);
         }
      } else {
         var6 = var2.indexOf("UID=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcUserid = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("PWD=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         super.JDPJaggJdbcPassword = var2.substring(var6 + 1, var3);
      }

      super.jaggSQL = new JDPJagg(super.JDPJaggPath);
      super.jaggSQL.setUserid("0");
      super.jaggSQL.setSystem(var1);
      super.jaggSQL.setDSN(super.JDPJaggDSN);
      super.jaggSQL.setCSTR(super.JDPJaggCSTR);
      super.jaggSQL.setJdbcDriver(super.JDPJaggJdbcDriver);
      super.jaggSQL.setJdbcPrefix(super.JDPJaggJdbcPrefix);
      super.jaggSQL.setJdbcSuffix(super.JDPJaggJdbcSuffix);
      super.jaggSQL.setUID(super.JDPJaggJdbcUserid);
      super.jaggSQL.setPWD(super.JDPJaggJdbcPassword);
      super.jaggSQL.loadJdbcDataSources();
      Vector var7 = new Vector();
      int var9;
      if (super.NDSPath != null) {
         super.jaggSQL.setFCTN("NDSexecSQL");
         String var8 = "SELECT Description,JDP:bfontname,JDP:bfontsize,JDP:pfontname, " + "JDP:pfontsize,JDP:jlanguage, JDP:country, JDP:dateformat " + "FROM JDesignerPro System WHERE JDP:JDPSystem = '" + var1 + "'";
         var9 = super.jaggSQL.execSQL(var8, var7);
         super.jaggSQL.setFCTN("");
      } else {
         String var35 = "SELECT JDPSystemD,bfontname,bfontsize,pfontname, " + "pfontsize, jlanguage, country, dateFormat " + "FROM JDPSystemDef WHERE JDPSystem = '" + var1 + "'";
         var9 = super.jaggSQL.execSQL(var35, var7);
         if (var9 < 0) {
            var35 = "SELECT JDPSystemD,bfontname,bfontsize,pfontname, " + "pfontsize, 'en', ' ', 'mm/dd/yy' " + "FROM JDPSystemDef WHERE JDPSystem = '" + var1 + "'";
            var9 = super.jaggSQL.execSQL(var35, var7);
         }
      }

      if (var9 < 0) {
         super.daysRemaining = 1;
      }

      if (JDPJagg.useJaggServer && super.JDPJaggDir == null) {
         ((JDesignerPro)this).getUnixDaysRemaining();
      }

      if (JDPJagg.useJaggServer && var9 > 0 && super.JDPJaggDir != null) {
         String var10 = super.JDPJaggDir + "JDPJagg.exe CheckLicense";
         Vector var11 = new Vector();
         super.jaggSQL.setFCTN("System");
         super.jaggSQL.setFCTNP("");
         int var12 = super.jaggSQL.execSQL(var10, var11);
         super.daysRemaining = var12;
         super.jaggSQL.setFCTN("");
         if (var12 <= 0) {
            System.out.println(super.jaggSQL.getError());
            var9 = -1;
            super.daysRemaining = 0;
         }
      }

      if (!JDPJagg.useJaggServer) {
         ((JDesignerPro)this).getDaysRemaining();
      }

      if (super.daysRemaining > 90) {
         super.daysRemaining = 0;
         var9 = -1;
      }

      if (var9 != 1) {
         if (var9 < 0 && super.daysRemaining == 0) {
            super.boldFontName = "Helvetica";
            super.boldFontSize = 11;
            super.plainFontName = "Helvetica";
            super.plainFontSize = 11;
            super.versionnum = 0.0F;
            super.expired = true;
            ((JDesignerPro)this).loadExpiredMessage();
            return false;
         } else {
            return false;
         }
      } else {
         String var37 = new String(super.jaggSQL.getSEP());
         StringTokenizer var38 = new StringTokenizer((String)var7.elementAt(0));
         super.JDPSystemDesc = var38.nextToken(var37).trim();
         super.boldFontName = var38.nextToken(var37).trim();
         super.boldFontSize = Integer.parseInt(var38.nextToken(var37).trim());
         super.plainFontName = var38.nextToken(var37).trim();
         super.plainFontSize = Integer.parseInt(var38.nextToken(var37).trim());
         super.language = var38.nextToken(var37).trim();
         super.country = var38.nextToken(var37).trim();
         JDesignerPro.dateFormat = var38.nextToken(var37).trim();
         this.validLogin();
         return true;
      }
   }

   public void setParms(String[] var1) {
      JDesignerPro.executable = true;
      if (var1 != null) {
         if (var1.length >= 1) {
            super.wwwroot = var1[0];
         }

         if (var1.length >= 2) {
            super.JDPSystem = var1[1];
         }

         if (var1.length >= 3) {
            this.panelName = var1[2];
         }

      }
   }

   public void validLogin() {
      JDPUser var1 = this.initUser(0);
      super.user = new JDPUser[1];
      super.user[0] = var1;
      super.wintitle = var1.JDPSystemDesc;
      ((JDesignerPro)this).licenseCheck();
      if (!JDesignerPro.JDPLicensed) {
         super.wintitle = super.wintitle + " (Unlicensed)";
      }

      JDPButton.activated = true;
      JDPRowLayout.activated = true;
      Panel var2 = new Panel();
      ((Container)var2).setLayout(new GridLayout(1, 1));
      var1.mainmsg = new JDPStatusMessage(var1);
      if (!JDesignerPro.JDPLicensed) {
         var1.mainmsg.eastMessage.setText("(Unlicensed)");
         var1.mainmsg.eastMessage.setForeground(Color.red);
      }

      ((Container)var2).add(var1.mainmsg);
      ((Container)this).removeAll();
      var1.popup = new JDPPopupComponent(var1, this);
      ((Container)this).add(var1.popup);
      ((Container)this).add("South", var2);
      String var3 = ((Applet)this).getParameter("moduleParameter");
      if (var3 == null) {
         var3 = "";
      }

      ((Container)this).add("Center", new JDPPanelLoader(var1, this.panelName, var3, (boolean[])null, 0));
      ((Component)this).show();
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   public static void main(String[] var0) {
      JDPSingle var1 = new JDPSingle();
      var1.setParms(var0);
      var1.init();
   }

   public void init() {
      (new Thread(this)).start();
      if (super.wwwroot == null || super.wwwroot.equals("")) {
         super.wwwroot = ((Applet)this).getCodeBase().toString();
      }

      if (super.JDPSystem == null || super.JDPSystem.equals("")) {
         super.JDPSystem = ((Applet)this).getParameter("JDPSystem");
      }

      if (this.panelName == null || this.panelName.equals("")) {
         this.panelName = ((Applet)this).getParameter("JDPClassName");
      }

      JDPJagg.activated = true;
      JDPUser.classactivated = true;
      JDPButton.thisJDP = this;
      JDPTreePicker.thisJDP = this;
      if (this.checkSetup(super.JDPSystem, super.JDPJaggSetup, super.wwwroot)) {
         ;
      }
   }

   public void run() {
      ((Container)this).setLayout(new BorderLayout());

      try {
         if ((!System.getProperty("java.vendor").startsWith("Netscape") || System.getProperty("java.version").compareTo("1.1.2") > 0) && !System.getProperty("os.name").startsWith("Mac") && !System.getProperty("java.version").startsWith("1.0")) {
            JDPSystemColor.loadColors();
         }
      } catch (Exception var1) {
      }

      ((Component)this).setBackground(JDPUtils.getControlColor());
      this.msgLabel = new Label("Please wait while applet loads...", 0);
      ((Container)this).add("North", this.msgLabel);
      ((Component)this).show();
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   public boolean handleEvent(Event var1) {
      if (super.exitapplet) {
         return true;
      } else {
         switch (var1.id) {
            case 201:
               System.exit(0);
               return true;
            case 1001:
               if (var1.target.equals(super.user[0].serverListener)) {
                  String var8 = (String)var1.arg;
                  StringTokenizer var9 = new StringTokenizer(var8, "|");
                  var9.nextToken();
                  String var10 = var9.nextToken();
                  String var11 = var9.nextToken();
                  String var6 = var9.nextToken();
                  String var7 = var9.nextToken();
                  ((JDesignerPro)this).displayMessage(super.user[0], "Message from " + var10, var11, var6, var7);
                  return true;
               }

               return false;
            case 1004:
               if (var1.target.equals(this)) {
                  Component[] var2 = ((Container)this).getComponents();

                  for(int var3 = 0; var3 < var2.length; ++var3) {
                     if (var2[var3] instanceof JDPPanelLoader) {
                        Component[] var4 = ((Container)var2[var3]).getComponents();

                        for(int var5 = 0; var5 < var4.length; ++var5) {
                           if (var4[var5] instanceof JDPClassLayout) {
                              var4[var5].requestFocus();
                              return true;
                           }
                        }
                     }
                  }
               }

               return false;
            default:
               return false;
         }
      }
   }

   public void loadAppletContext() {
      super.saveAppletContext = ((Applet)this).getAppletContext();
   }
}
