import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSourceLayout extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   Panel Panel1;
   JDPTabSelectPanel TabPanel1;
   JDPMethodExplorer JDPMethodExplorer1;
   Panel source;
   Panel Panel3;
   Panel Panel4;
   Label Label2;
   TextField searchField;
   JDPButtons JDPButtons1;
   Label Label3;
   Label Label1;
   JDPSpinner currentLine;
   Panel Panel5;
   JDPButton JDPButton1;
   JDPSplitPanel Panel2;
   TextArea sourcePanel;
   JDPList methodList;
   JDPDefineAll JDPDefineAll1;
   boolean searchForward = true;
   JDPSourceItem currentItem;
   // $FF: renamed from: mt JDPMethodTree
   JDPMethodTree field_0;
   public String definePos = "North";
   public String explorePos = "Center";
   public String sourcePos = "South";
   public String tabPos = "Hidden";
   boolean appChanged = false;
   Thread thisThread;
   boolean threadRunning = false;
   String sepChars = " \t\n\r;()/*[]\\!|&%$#@";
   StringBuffer textSoFar;
   String beforeSelection;
   String afterSelection;
   int saveSelectionStartPos;
   JDPInteractionMgr interactionMgr;
   StringBuffer thisEntry;
   Vector listItems;
   int lastSearchLine;
   String lastSearchText = "";
   int lastCursorStartPos;
   int lastCursorEndPos;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.Panel1 = new Panel();
      String[] var4 = new String[1];
      Panel[] var5 = new Panel[]{new Panel()};
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Tab 1";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.JDPMethodExplorer1 = new JDPMethodExplorer(var1.getJDPUser());
      this.source = new Panel();
      this.Panel3 = new Panel();
      this.Panel4 = new Panel();
      this.Label2 = new Label("Search:", 0);
      this.searchField = new TextField("", 20);
      String[] var6 = new String[]{"Fwd", "Back"};
      int[] var7 = new int[]{JDPButton.getIconValue("SearchFwd"), JDPButton.getIconValue("SearchBack")};
      this.JDPButtons1 = new JDPButtons(var1, var7, var6, JDPButtons.getAlignmentValue("Horizontal"));
      this.Label3 = new Label("", 0);
      this.Label1 = new Label("Line:", 0);
      this.currentLine = new JDPSpinner(var1, "", 5);
      this.Panel5 = new Panel();
      this.JDPButton1 = new JDPButton(JDPButton.getIconValue("Documents"), "", JDPButton.getAlignmentValue("Center"));
      this.Panel2 = new JDPSplitPanel(var1);
      this.sourcePanel = new TextArea("", 15, 20);
      this.methodListMain();
      this.JDPDefineAll1 = new JDPDefineAll();
      this.JDPDefineAll1.InitClass(var1, var2, var3);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("East", this.TabPanel1);
      this.Panel1.add("Center", this.JDPMethodExplorer1);
      this.Panel1.add("South", this.source);
      this.source.setLayout(new BorderLayout());
      this.source.add("South", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("West", this.Panel4);
      this.Panel4.setLayout(new JDPLineLayout());
      this.Panel4.add("Left", this.Label2);
      this.Panel4.add("Left", this.searchField);
      this.Panel4.add("Left", this.JDPButtons1);
      this.Panel4.add("Left", this.Label3);
      this.Panel4.add("Left", this.Label1);
      this.Panel4.add("Left", this.currentLine);
      this.Panel3.add("East", this.Panel5);
      this.Panel5.setLayout(new BorderLayout());
      this.Panel5.add("Center", this.JDPButton1);
      this.source.add("Center", this.Panel2);
      this.Panel2.add("Center", this.sourcePanel);
      this.Panel2.add("Right", this.methodList);
      this.Panel1.add("North", this.JDPDefineAll1);
      this.TabPanel1.hide();
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.popuppanel.addComponent(this.JDPButtons1.button[0], "Search forward", "Search forward");
      this.popuppanel.addComponent(this.JDPButtons1.button[1], "Search backward", "Search backward");
      this.currentLine.setMinValue(0);
      this.currentLine.setMaxValue(999999);
      this.popuppanel.addComponent(this.JDPButton1, "Display/hide source helper", "Display/hide the source helper");
      this.JDPButton1.setStayOn(true);
      this.JDPButton1.setPressed(true);
      this.Panel2.setLeftPercentage(80.0F);
      this.Panel2.setTopPercentage(50.0F);
      this.sourcePanel.setFont(new Font("Courier", 0, 12));
      this.sourcePanel.setBackground(var1.u._cvtcolor("White"));
      this.methodList.setBackground(var1.u._cvtcolor("White"));
      this.methodList.setMinWidth(200);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.target.equals(this.methodList)) {
               if (var1.key == 9) {
                  this.sourcePanel.requestFocus();
               }

               return false;
            }

            return false;
         case 402:
            if (var1.target.equals(this.sourcePanel)) {
               if (var1.key == 10) {
                  JDPUtils.insertTabs(this.sourcePanel);
                  return false;
               }

               if (var1.key == 9) {
                  return false;
               }

               this.startThread();
               return false;
            }

            return false;
         case 404:
            if (var1.target.equals(this.sourcePanel) && var1.key == 1006) {
               if (this.threadRunning) {
                  if (this.thisThread != null) {
                     this.thisThread.interrupt();
                  }
               } else {
                  this.threadRunning = true;
                  this.thisThread = new Thread(this);
                  this.thisThread.start();
               }

               return false;
            } else {
               if (var1.target.equals(this.sourcePanel) && var1.key == 1007) {
                  if (this.threadRunning) {
                     if (this.thisThread != null) {
                        this.thisThread.interrupt();
                     }
                  } else {
                     this.threadRunning = true;
                     this.thisThread = new Thread(this);
                     this.thisThread.start();
                  }

                  return false;
               }

               return false;
            }
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target.equals(this.JDPMethodExplorer1)) {
               JDPSourceItem var6 = this.JDPMethodExplorer1.getSelectedItem();
               if (var6 == null && this.field_0 != null) {
                  var6 = this.field_0.getSelectedSourceItem();
               }

               this.currentItem = var6;
               this.JDPDefineAll1.setSourceItem(var6);
               if (var6 != null) {
                  this.sourcePanel.setText(var6.actualSource);
                  if (this.field_0 != null) {
                     this.field_0.select(var6);
                  }

                  if (var6.node != null) {
                     if (var6.node.nodeColumn == 1001) {
                        this.searchField.setText(var6.name);
                     }

                     if (var6.node.nodeColumn == 999) {
                        this.searchField.setText(this.JDPMethodExplorer1.nodeRoot.name);
                     }
                  }
               } else {
                  this.sourcePanel.setText("");
               }

               return true;
            } else {
               if (var1.target.equals(this.methodList)) {
                  this.replaceSelectedText(this.methodList.getSelectedItem());
                  this.startThread();
                  return true;
               }

               return false;
            }
         case 1001:
            if (var1.target.equals(this.JDPMethodExplorer1)) {
               JDPSourceItem var5 = this.JDPMethodExplorer1.getSelectedItem();
               if (var5 == null && this.field_0 != null) {
                  var5 = this.field_0.getSelectedSourceItem();
               }

               this.currentItem = var5;
               this.JDPDefineAll1.setSourceItem(var5);
               if (var5 != null) {
                  this.sourcePanel.setText(var5.actualSource);
                  if (this.field_0 != null) {
                     this.field_0.select(var5);
                  }
               } else {
                  this.sourcePanel.setText("");
               }

               return true;
            } else if (var1.target.equals(this.searchField)) {
               this.searchForText(this.searchField.getText(), this.searchForward);
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.searchForText(this.searchField.getText(), true);
               this.searchForward = true;
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               this.searchForText(this.searchField.getText(), false);
               this.searchForward = false;
               return true;
            } else if (var1.target.equals(this.JDPButton1)) {
               if (this.methodList.isVisible()) {
                  this.methodList.hide();
                  this.JDPButton1.setPressed(false);
               } else {
                  this.methodList.show();
               }

               this.source.layout();
               this.source.paintAll(this.source.getGraphics());
               return true;
            } else {
               if (var1.target.equals(this.methodList)) {
                  this.replaceSelectedText(this.methodList.getSelectedItem());
                  this.startThread();
                  return true;
               }

               return false;
            }
         case 1004:
            if (var1.target.equals(this.sourcePanel)) {
               this.saveLastCursorPos();
               return false;
            }

            return false;
         case 1005:
            if (var1.target.equals(this.sourcePanel)) {
               this.saveLastCursorPos();
               this.handleLostFocus();
               return false;
            } else if (!var1.target.equals(this.JDPDefineAll1)) {
               return false;
            } else {
               if (this.currentItem != null) {
                  String var2 = this.currentItem.name;
                  this.JDPMethodExplorer1.sp.removeCalledMethod(this.currentItem);
                  int var3 = 0;
                  if (this.currentItem.type == 2 && this.currentItem.parmNames != null) {
                     var3 = this.currentItem.parmNames.size();
                  }

                  if (this.JDPDefineAll1.updateSourceItem(this.currentItem) != null) {
                     JDPSourceParser.reCreateHeader(this.currentItem);
                     this.JDPMethodExplorer1.sp.reParseSource(this.currentItem);
                     this.sourcePanel.setText(this.currentItem.actualSource);
                     if (this.field_0 != null) {
                        this.field_0.refreshBranchFromItem(this.currentItem);
                     }

                     this.JDPMethodExplorer1.refreshNodeFromItem(this.currentItem);
                     if (!var2.equals(this.currentItem.name)) {
                        JDPSourceParser.changeMethodName(this.currentItem, var2);
                     }

                     int var4 = 0;
                     if (this.currentItem.parmNames != null) {
                        var4 = this.currentItem.parmNames.size();
                     }

                     if ((this.currentItem.type != 2 || var3 == var4) && var2.equals(this.currentItem.name)) {
                        this.JDPMethodExplorer1.refreshRelations(this.currentItem);
                     } else {
                        this.JDPMethodExplorer1.refreshAllRelations(this.JDPMethodExplorer1.sp.classHeader);
                     }

                     this.setAppChanged(true);
                  }
               }

               return true;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
      this.TabPanel1.removeAllTabs();
   }

   public void setSourceItem(JDPSourceItem var1) {
      this.currentItem = var1;
      if (var1 == null) {
         this.sourcePanel.setText("");
         this.JDPMethodExplorer1.clear();
         this.JDPMethodExplorer1.reDraw();
         var1 = new JDPSourceItem();
         var1.type = 0;
         var1.name = "";
         this.JDPDefineAll1.setSourceItem(var1);
         this.setAppChanged(false);
      } else {
         this.JDPDefineAll1.setSourceItem(var1);
         this.sourcePanel.setText(var1.actualSource);
         this.JDPMethodExplorer1.setRootNode(var1);
         this.JDPMethodExplorer1.makeVisible(var1);
      }
   }

   public JDPSourceItem getSourceItem() {
      JDPSourceItem var1 = this.JDPDefineAll1.getSourceItem();
      var1.actualSource = this.sourcePanel.getText();
      return var1;
   }

   public void setSourceFile(String var1, JDPMethodTree var2) {
      this.field_0 = var2;
      this.JDPMethodExplorer1.loadSource(var1, var2);
      this.setSourceItem(this.JDPMethodExplorer1.getSelectedItem());
   }

   public void setPanelPosition(String var1, String var2) {
      Object var3 = null;
      String var4 = "";
      String var5 = "";
      if (var1.equals("Definition Panel")) {
         var3 = this.JDPDefineAll1;
         var4 = "Definition";
         var5 = this.definePos;
         this.definePos = var2;
      } else if (var1.equals("Explorer Panel")) {
         var3 = this.JDPMethodExplorer1;
         var4 = "Explorer";
         var5 = this.explorePos;
         this.explorePos = var2;
      } else if (var1.equals("Source Panel")) {
         var3 = this.source;
         var4 = "Source";
         var5 = this.sourcePos;
         this.sourcePos = var2;
      } else if (var1.equals("Tab Panel")) {
         var3 = this.TabPanel1;
         this.tabPos = var2;
      }

      if (var3 != null) {
         Container var6 = ((Component)var3).getParent();
         if (var6 != null) {
            if (var5.equals("TabPanel")) {
               this.TabPanel1.removeTab((Component)var3);
            } else {
               var6.remove((Component)var3);
            }
         }

         if (var2.equals("Hidden")) {
            ((Component)var3).hide();
         } else if (var2.equals("TabPanel")) {
            ((Component)var3).show();
            this.TabPanel1.add((Component)var3, var4);
         } else {
            ((Component)var3).show();
            this.Panel1.add(var2, (Component)var3);
         }

         if (this.TabPanel1.getTabnames()[0].equals("Tab 1")) {
            this.TabPanel1.hide();
            this.TabPanel1.removeAllTabs();
         }

         if (var2.equals("TabPanel") && !this.tabPos.equals("Hidden")) {
            this.TabPanel1.show();
         }

         ((Container)this).layout();
         ((Component)this).paintAll(((Component)this).getGraphics());
      }
   }

   public Vector getPanelPositions(String var1) {
      Vector var2 = new Vector();
      String[] var3 = new String[]{"Center", "North", "South"};

      for(int var4 = 0; var4 < var3.length; ++var4) {
         if (!this.definePos.equals(var3[var4]) && !this.explorePos.equals(var3[var4]) && !this.sourcePos.equals(var3[var4]) && !this.tabPos.equals(var3[var4])) {
            var2.addElement(var3[var4]);
         }
      }

      if (var1.equals("definePanel") && !this.definePos.equals("TabPanel") || var1.equals("explorePanel") && !this.explorePos.equals("TabPanel") || var1.equals("sourcePanel") && !this.sourcePos.equals("TabPanel")) {
         var2.addElement("TabPanel");
      }

      if (var1.equals("definePanel") && !this.definePos.equals("Hidden") || var1.equals("explorePanel") && !this.explorePos.equals("Hidden") || var1.equals("sourcePanel") && !this.sourcePos.equals("Hidden") || var1.equals("TabPanel") && !this.tabPos.equals("Hidden")) {
         var2.addElement("Hidden");
      }

      return var2;
   }

   public void loadPopupMenu(JDPPopupMenu var1) {
      String[] var2 = new String[]{"definePanel", "explorePanel", "sourcePanel", "TabPanel"};
      String[] var3 = new String[]{"Definition Panel", "Explorer Panel", "Source Panel", "Tab Panel"};
      String[] var4 = new String[]{"Layout", "", ""};

      for(int var5 = 0; var5 < var2.length; ++var5) {
         var4[1] = var3[var5];
         Vector var6 = this.getPanelPositions(var2[var5]);

         for(int var7 = 0; var7 < var6.size(); ++var7) {
            var4[2] = (String)var6.elementAt(var7);
            var1.addEntry(var4);
         }
      }

   }

   public void setAppChanged(boolean var1) {
      this.appChanged = var1;
   }

   public boolean getAppChanged() {
      return this.appChanged;
   }

   public void loadNewItem(JDPSourceItem var1) {
      this.currentItem = var1;
      this.JDPMethodExplorer1.addNode(this.currentItem);
      String var2 = var1.name;
      int var3 = 1;
      if (this.currentItem.actualSource != null && !this.currentItem.actualSource.equals("")) {
         this.JDPMethodExplorer1.sp.reParseSource(this.currentItem);

         while(!this.field_0.addItem(var1) && var1.type != 1) {
            var1.name = var2 + Integer.toString(var3++);
         }

         if (!var1.name.equals(var2)) {
            JDPSourceParser.replaceSource(var1, var2, var1.name);
         }

         this.JDPDefineAll1.setSourceItem(this.currentItem);
         if (this.field_0 != null) {
            this.field_0.refreshBranchFromItem(this.currentItem);
         }

         this.JDPMethodExplorer1.sp.addCalledMethod(this.currentItem);
         this.JDPMethodExplorer1.refreshNodeFromItem(this.currentItem);
         this.JDPMethodExplorer1.refreshRelations(this.currentItem);
         this.setAppChanged(true);
      } else {
         while(!this.field_0.addItem(var1) && var1.type != 1) {
            var1.name = var2 + Integer.toString(var3++);
         }

         this.JDPDefineAll1.setSourceItem(this.currentItem);
         JDPSourceParser.reCreateHeader(this.currentItem);
         if (this.field_0 != null) {
            this.field_0.refreshBranchFromItem(this.currentItem);
         }

         this.JDPMethodExplorer1.sp.addCalledMethod(this.currentItem);
         this.JDPMethodExplorer1.refreshNodeFromItem(this.currentItem);
         this.JDPMethodExplorer1.refreshRelations(this.currentItem);
         this.sourcePanel.setText(this.currentItem.actualSource);
         this.setAppChanged(true);
      }
   }

   public void removeSourceItem(JDPSourceItem var1) {
      this.currentItem = null;
      this.JDPMethodExplorer1.removeNode(var1.node);
      this.JDPDefineAll1.setSourceItem((JDPSourceItem)null);
      this.sourcePanel.setText("");
      this.JDPMethodExplorer1.setRootNode("");
   }

   public String getPanelPosition(String var1) {
      if (var1.equals("Definition Panel")) {
         return this.definePos;
      } else if (var1.equals("Explorer Panel")) {
         return this.explorePos;
      } else if (var1.equals("Source Panel")) {
         return this.sourcePos;
      } else {
         return var1.equals("Tab Panel") ? this.tabPos : null;
      }
   }

   public void refreshAllNodes() {
      this.JDPMethodExplorer1.refreshAllNodes();
   }

   public void run() {
      this.threadRunning = true;

      while(this.threadRunning) {
         try {
            Thread.sleep(2000L);
            if (this.methodList.isVisible()) {
               this.loadMethodList();
               this.handleLostFocus();
            }

            this.threadRunning = false;
         } catch (InterruptedException var1) {
         }
      }

   }

   public void refreshAllRelations() {
      this.JDPMethodExplorer1.refreshAllRelations(this.JDPMethodExplorer1.sp.classHeader);
   }

   public void reParseSource(JDPSourceItem var1) {
      this.JDPMethodExplorer1.sp.reParseSource(var1);
   }

   public void loadMethodList() {
      int var1 = this.sourcePanel.getSelectionStart();
      int var2 = this.sourcePanel.getSelectionEnd();
      if (var1 >= 1 && var2 >= 1) {
         Object var3 = null;
         this.beforeSelection = null;
         this.afterSelection = null;
         this.interactionMgr.listItems = new Vector();
         String var4 = this.sourcePanel.getText();
         String var5 = this.sourcePanel.getText();
         int var6 = 0;
         if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
            var4 = this.user.u.replace(var4, "\n", "\n ");

            for(int var7 = var1; (var7 = var4.lastIndexOf("\n", var7 - 1)) >= 0; --var1) {
               ++var6;
            }

            for(int var15 = var2; (var15 = var4.lastIndexOf("\n", var15 - 1)) >= 0; --var2) {
            }
         }

         this.beforeSelection = var5.substring(0, var1);
         this.afterSelection = var5.substring(var2);
         this.saveSelectionStartPos = var1;
         if (var1 == var2) {
            if (this.textSoFar == null) {
               this.textSoFar = new StringBuffer();
            }

            String var16 = var5.substring(var1 - 1, var1);
            if (this.sepChars.indexOf(var16) >= 0) {
               return;
            }

            Object var8 = null;
            String var9 = null;
            int var10 = var1;
            this.textSoFar.setLength(0);
            boolean var11 = false;

            while(!var16.equals("") && this.sepChars.indexOf(var16) < 0) {
               if (var16.equals(".") && var9 == null) {
                  var11 = true;
                  var9 = this.textSoFar.toString();
                  this.textSoFar.setLength(0);
                  this.beforeSelection = var5.substring(0, var10);
                  this.saveSelectionStartPos = var10;
               } else {
                  this.textSoFar.insert(0, var16);
               }

               --var10;
               if (var10 == 0) {
                  var16 = "";
               } else {
                  var16 = var5.substring(var10 - 1, var10);
               }
            }

            String var17 = this.textSoFar.toString();
            if (var17.equals("this")) {
               var17 = var9;
               var9 = null;
               var10 += 5;
            }

            if (var9 == null) {
               this.beforeSelection = var5.substring(0, var10);
               this.saveSelectionStartPos = var10;
            }

            if (var17 != null && var9 == null) {
               this.methodList.clear();
               this.loadMethodAndVariableNames(this.methodList, var17, (String)null);
               if ((this.methodList.countItems() != 1 || !this.methodList.getItem(0).equals(var17)) && this.methodList.countItems() > 0) {
                  this.setMethodListVisible(true);
                  this.methodList.requestFocus();
               }
            } else {
               String var12 = this.getGlobalVariableType(var17);
               if (var12 != null) {
                  this.interactionMgr.loadVariableMethods(this.methodList, var12, var17, var9, 0);
                  if (this.methodList.countItems() > 0) {
                     this.setMethodListVisible(true);
                     this.methodList.requestFocus();
                  }
               } else {
                  this.interactionMgr.loadVariableMethods(this.methodList, var17, var17, var9, 8);
                  if (this.methodList.countItems() > 0) {
                     this.setMethodListVisible(true);
                     this.methodList.requestFocus();
                  }
               }
            }
         } else if (var2 - var1 < 40) {
            String var13 = var5.substring(var1, var2);
            if (var13.indexOf(" ") < 0 && var13.indexOf("\t") < 0 && var13.indexOf("\n") < 0) {
               this.interactionMgr.loadMethodsForReturnValue(this.methodList, var13);
               this.loadMethodAndVariableNames(this.methodList, (String)null, var13);
               if (this.methodList.countItems() > 0) {
                  this.setMethodListVisible(true);
                  this.methodList.requestFocus();
               }
            }
         }

         this.saveSelectionStartPos += var6;
      }
   }

   public void setInteractionMgr(JDPInteractionMgr var1) {
      this.interactionMgr = var1;
   }

   public String getGlobalVariableType(String var1) {
      if (var1.startsWith("this.")) {
         var1 = var1.substring(5);
      } else {
         String var3 = this.interactionMgr.findLocalVar(var1, this.beforeSelection);
         if (var3 != null) {
            return var3;
         }
      }

      for(int var4 = 0; var4 < this.JDPMethodExplorer1.sp.classHeader.components.size(); ++var4) {
         JDPSourceItem var2 = (JDPSourceItem)this.JDPMethodExplorer1.sp.classHeader.components.elementAt(var4);
         if (var2.type == 3 && var2.name.equals(var1)) {
            return var2.varType;
         }
      }

      return null;
   }

   public void setMethodListVisible(boolean var1) {
      if (var1) {
         this.methodList.show();
         this.JDPButton1.setPressed(true);
      } else {
         this.methodList.hide();
         this.JDPButton1.setPressed(false);
      }

      this.source.layout();
      this.source.paintAll(this.source.getGraphics());
   }

   public void loadMethodAndVariableNames(JDPList var1, String var2, String var3) {
      Vector var4 = this.JDPMethodExplorer1.sp.classHeader.components;
      Object var6 = null;
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      this.thisEntry.setLength(0);
      this.listItems = new Vector();
      if (var2 != null && var2.startsWith("this.")) {
         var2 = var2.substring(5);
      } else {
         this.getVarsFromSource(var2, var3, this.beforeSelection, var1);
      }

      for(int var7 = 0; var7 < var4.size(); ++var7) {
         JDPSourceItem var5 = (JDPSourceItem)var4.elementAt(var7);
         if (var5.type == 3) {
            if (var2 != null && var5.name.startsWith(var2) && this.listItems.indexOf(var5.name) < 0) {
               var1.addItem(var5.name);
            }

            if (var3 != null && var5.varType.equals(var3) && this.listItems.indexOf(var5.name) < 0) {
               var1.addItem(var5.name);
            }
         } else if (var5.type == 2) {
            this.thisEntry.setLength(0);
            this.thisEntry.append(var5.name + "(");
            if (var5.parmTypes != null) {
               for(int var8 = 0; var8 < var5.parmTypes.size(); ++var8) {
                  if (var8 > 0) {
                     this.thisEntry.append(",");
                  }

                  this.thisEntry.append((String)var5.parmTypes.elementAt(var8));
               }
            }

            this.thisEntry.append(")");
            if (var2 != null && var5.name.startsWith(var2)) {
               String var9 = this.thisEntry.toString();
               if (this.listItems.indexOf(var9) < 0) {
                  var1.addItem(var9);
               }
            }

            if (var3 != null && var5.returnType.equals(var3)) {
               String var10 = this.thisEntry.toString();
               if (this.listItems.indexOf(var10) < 0) {
                  var1.addItem(var10);
               }
            }
         }
      }

      if (var1.countItems() > 0) {
         var1.sortList();
         ((JDPTreePicker)var1).select(0);
      }

   }

   public void replaceSelectedText(String var1) {
      if (var1.endsWith(")") && (this.afterSelection.startsWith("\n") || this.afterSelection.startsWith("\r") || this.afterSelection.equals(""))) {
         var1 = var1 + ";";
      }

      int var2 = this.saveSelectionStartPos + var1.length();
      this.sourcePanel.setText(this.beforeSelection + var1 + this.afterSelection);
      int var3 = var1.indexOf("(");
      int var4 = var1.indexOf(")");
      if (var3 >= 0 && var4 > var3 + 1) {
         int var5 = var1.indexOf(",");
         if (var5 >= 0) {
            var4 = var5;
         }

         int var6 = 0;
         if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
            for(int var7 = this.beforeSelection.indexOf("\n"); var7 >= 0; var7 = this.beforeSelection.indexOf("\n", var7 + 1)) {
               ++var6;
            }
         }

         var3 += this.saveSelectionStartPos + 1 - var6;
         var4 += this.saveSelectionStartPos - var6;
         this.sourcePanel.select(var3, var4);
         this.startThread();
      } else {
         this.sourcePanel.setSelectionStart(var2);
         this.sourcePanel.setSelectionEnd(var2);
      }

      this.sourcePanel.requestFocus();
   }

   public void reDraw() {
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   public void startThread() {
      if (this.threadRunning) {
         if (this.thisThread != null) {
            this.thisThread.interrupt();
            return;
         }
      } else {
         this.threadRunning = true;
         this.thisThread = new Thread(this);
         this.thisThread.start();
      }

   }

   void getVarsFromSource(String var1, String var2, String var3, JDPList var4) {
      int var9 = var3.indexOf("(");
      int var10 = var3.indexOf(")", var9 + 2);
      if (var9 > 0 && var9 < var10) {
         StringTokenizer var11 = new StringTokenizer(var3.substring(var9 + 1, var10), " \n\r\t,");

         while(var11.hasMoreTokens()) {
            String var7 = var11.nextToken();
            if (var11.hasMoreTokens()) {
               String var8 = var11.nextToken();
               if (var1 != null && var8.startsWith(var1) && this.listItems.indexOf(var8) < 0) {
                  var4.addItem(var8);
                  this.listItems.addElement(var8);
               }

               if (var2 != null && var7.equals(var2) && this.listItems.indexOf(var8) < 0) {
                  var4.addItem(var8);
                  this.listItems.addElement(var8);
               }
            }
         }
      }

      var9 = var3.indexOf("{");
      if (var9 >= 0 && var9 < var3.length() - 1) {
         StringTokenizer var15 = new StringTokenizer(var3.substring(var9 + 1), "{};");

         while(var15.hasMoreTokens()) {
            String var6 = var15.nextToken();
            StringTokenizer var5 = new StringTokenizer(var6, "\n\r \t;");
            if (var5.countTokens() >= 2) {
               String var12 = var5.nextToken();
               if (var5.hasMoreTokens()) {
                  String var13 = var5.nextToken();
                  if (var1 != null && var13.startsWith(var1) && this.listItems.indexOf(var13) < 0) {
                     var4.addItem(var13);
                     this.listItems.addElement(var13);
                  }

                  if (var2 != null && var12.equals(var2) && this.listItems.indexOf(var13) < 0) {
                     var4.addItem(var13);
                     this.listItems.addElement(var13);
                  }
               }
            }
         }

      }
   }

   void searchForText(String var1, boolean var2) {
      this.user.mainmsg.clearStatusMsg();
      if (var2) {
         if (this.lastSearchLine == 999999 || !var1.equals(this.lastSearchText)) {
            this.lastSearchLine = 0;
         }
      } else if (this.lastSearchLine == 0 || !var1.equals(this.lastSearchText)) {
         this.lastSearchLine = 999999;
      }

      this.lastSearchText = var1;
      int var4 = this.sourcePanel.getText().length();
      int var3;
      if (var2) {
         var3 = this.sourcePanel.getText().toUpperCase().indexOf(var1.toUpperCase(), this.lastSearchLine);
      } else {
         if (this.lastSearchLine > var4) {
            this.lastSearchLine = var4;
         }

         this.lastSearchLine -= 2;
         if (this.lastSearchLine < 0) {
            this.lastSearchLine = 0;
         }

         var3 = this.sourcePanel.getText().toUpperCase().lastIndexOf(var1.toUpperCase(), this.lastSearchLine);
      }

      if (var3 >= 0) {
         this.sourcePanel.select(var3, var3 + var1.length());
         this.lastSearchLine = var3 + 1;
      } else {
         this.user.mainmsg.setStatusMsg("Search string not found", 5);
         if (var2) {
            this.lastSearchLine = 0;
         } else {
            this.lastSearchLine = 999999;
         }

         this.sourcePanel.requestFocus();
      }
   }

   public void positionToLine(int var1) {
      String var2 = this.sourcePanel.getText();
      int var3 = -1;

      for(int var4 = 0; var4 < var1; ++var4) {
         var3 = var2.indexOf("\n", var3 + 1);
      }

      int var5 = var2.indexOf("\n", var3 + 1);
      int var6 = var2.indexOf("\r", var3 + 1);
      if (var6 >= 0 && var6 < var5) {
         var5 = var6;
      }

      if (var5 < 0) {
         var5 = var2.length();
      }

      this.sourcePanel.select(var3, var5);
      this.sourcePanel.requestFocus();
   }

   public void handleLostFocus() {
      if (this.currentItem != null) {
         this.currentItem.actualSource = this.sourcePanel.getText();
         String var1 = this.currentItem.name;
         int var2 = 0;
         if (this.currentItem.type == 2 && this.currentItem.parmNames != null) {
            var2 = this.currentItem.parmNames.size();
         }

         this.JDPMethodExplorer1.sp.reParseSource(this.currentItem);
         this.JDPDefineAll1.setSourceItem(this.currentItem);
         if (this.field_0 != null) {
            this.field_0.refreshBranchFromItem(this.currentItem);
         }

         this.JDPMethodExplorer1.refreshNodeFromItem(this.currentItem);
         int var3 = 0;
         if (this.currentItem.parmNames != null) {
            var3 = this.currentItem.parmNames.size();
         }

         if (!var1.equals(this.currentItem.name)) {
            JDPSourceParser.changeMethodName(this.currentItem, var1);
         }

         if ((this.currentItem.type != 2 || var2 == var3) && var1.equals(this.currentItem.name)) {
            this.JDPMethodExplorer1.refreshRelations(this.currentItem);
         } else {
            this.JDPMethodExplorer1.refreshAllRelations(this.JDPMethodExplorer1.sp.classHeader);
         }

         this.setAppChanged(true);
      }

   }

   public void saveLastCursorPos() {
      this.lastCursorStartPos = this.sourcePanel.getSelectionStart();
      this.lastCursorEndPos = this.sourcePanel.getSelectionEnd();
   }

   public int getSelectionStart() {
      return this.lastCursorStartPos;
   }

   public int getSelectionEnd() {
      return this.lastCursorEndPos;
   }

   public void methodListMain() {
      if (this.methodList == null) {
         this.methodList = new JDPList(this.user);
      }

   }
}
