import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPTemplTypeMaint extends JDPClassLayout {
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   JDPJagg jaggSQL;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   String pfromWhereClause;
   TextField templtype;
   TextField typedesc;

   void loadChoices() {
   }

   void newSearch() {
      String var1 = this.pfromWhereClause;
      if (this.jdpWhereClause != null) {
         var1 = var1 + " AND " + this.jdpWhereClause.whereClause;
      }

      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
   }

   void clearFields() {
      this.templtype.setText("");
      this.typedesc.setText("");
   }

   void retrieveHandle() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
      }

   }

   void loadData() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      if ((this.itemIndex = this.searchResults.getSelectedIndex()) < 0) {
         this.clearFields();
      } else {
         String var6 = "SELECT templtype," + "typedesc" + " FROM JDPTmpType" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'" + " AND templtype='" + this.searchResults.recordKey1[this.itemIndex] + "'";
         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var2 = this.jaggSQL.execSQL(var6, var3);
         if (var2 == -1) {
            super.user.u.setSqlMessage(this.jaggSQL, var6);
         } else if (var2 >= 1) {
            String var5 = (String)var3.elementAt(0);
            if (var5 != null && var5.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var5);
               this.templtype.setText(var1.nextToken(var4).trim());
               this.typedesc.setText(var1.nextToken(var4).trim());
            }

            if (var2 > 1) {
               super.user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
            } else {
               super.user.mainmsg.clearStatusMsg();
            }
         } else {
            super.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
            this.clearFields();
         }
      }
   }

   boolean saveData() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.jaggSQL.getSEP();
      String var3 = "";
      if (this.insertRequested) {
         var3 = "INSERT INTO JDPTmpType (JDPSystem, templtype, " + "typedesc) VALUES('" + super.user.JDPSystem + "','" + this.templtype.getText() + "', " + "'" + this.typedesc.getText() + "')";
      } else {
         this.itemIndex = this.searchResults.getSelectedIndex();
         if (this.itemIndex < 0) {
            super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         if (this.deleteRequested) {
            var3 = "DELETE FROM JDPTmpType" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'" + " AND templtype='" + this.searchResults.recordKey1[this.itemIndex] + "'";
         } else {
            var3 = "UPDATE JDPTmpType SET typedesc = '" + this.typedesc.getText() + "'" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'" + " AND templtype='" + this.searchResults.recordKey1[this.itemIndex] + "'";
         }
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var1 = this.jaggSQL.execSQL(var3, var2);
      if (var1 == -1) {
         super.user.u.setSqlMessage(this.jaggSQL, var3);
         return false;
      } else {
         if (var1 == 1) {
            if (this.insertRequested) {
               super.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (this.deleteRequested) {
               super.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               super.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            super.user.u.setSqlMessage(this.jaggSQL, var3);
         }

         this.insertRequested = false;
         this.deleteRequested = false;
         return true;
      }
   }

   boolean checkFields() {
      return true;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectTopPanel) {
               return true;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.templtype)) {
                     super.user.u.cursor(this.typedesc);
                     return true;
                  }

                  if (var1.target.equals(this.typedesc)) {
                     super.user.u.cursor(this.templtype);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.typedesc)) {
                     super.user.u.cursor(this.templtype);
                     return true;
                  }

                  if (var1.target.equals(this.templtype)) {
                     super.user.u.cursor(this.typedesc);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target.equals(this.searchResults.resultList)) {
               this.loadData();
               return true;
            } else if (var1.target instanceof JDPTreePicker && var1.target.equals(this.searchResults.tree)) {
               this.loadData();
               return true;
            } else if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2.trim().compareTo("Apply") == 0) {
                  if (this.checkFields()) {
                     if (this.insertRequested) {
                        this.saveData();
                        this.newSearch();
                     } else {
                        this.saveData();
                     }
                  }

                  return true;
               } else if (var2.trim().compareTo("Reset") == 0) {
                  this.loadData();
                  return true;
               } else if (var2.trim().compareTo("New") == 0) {
                  this.insertRequested = true;
                  this.clearFields();
                  return true;
               } else if (var2.trim().compareTo("Submit") == 0) {
                  this.insertRequested = true;
                  if (this.checkFields()) {
                     this.saveData();
                  }

                  return true;
               } else if (var2.trim().compareTo("Copy") == 0) {
                  this.insertRequested = true;
                  return true;
               } else if (var2.trim().compareTo("Remove") == 0) {
                  this.insertRequested = false;
                  this.deleteRequested = true;
                  this.saveData();
                  this.newSearch();
                  return true;
               } else {
                  if (var2.trim().compareTo("Search") == 0) {
                     this.insertRequested = false;
                     this.deleteRequested = false;
                     this.newSearch();
                     return true;
                  }

                  return true;
               }
            } else if (var1.target instanceof Choice) {
               return true;
            } else {
               if (var1.target instanceof TextField) {
                  if (this.jdpWhereClause != null && var1.target.equals(this.jdpWhereClause.matchConstant)) {
                     this.insertRequested = false;
                     this.deleteRequested = false;
                     this.newSearch();
                     return true;
                  }

                  this.checkFields();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      String var9 = "JDPSystem,templtype";
      String[] var10 = new String[0];
      this.pfromWhereClause = "FROM JDPTmpType WHERE JDPSystem = '" + var1.JDPSystem + "'";
      this.psortChoice = new String[2];
      this.psortChoice[0] = "templtype";
      this.psortChoice[1] = "typedesc";
      String[] var11 = new String[]{"Template type", "Description"};
      this.pdisplayChoice = this.psortChoice;
      boolean var12 = true;
      String var13 = "Total Types:";
      this.templtype = new TextField("", 3);
      this.typedesc = new TextField("", 52);
      this.loadChoices();
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Type:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Description:", Color.black));
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout());
      ((Container)var14).add("Left", this.templtype);
      ((Container)var7).add("Right", var14);
      Panel var15 = new Panel();
      ((Container)var15).setLayout(new JDPLineLayout());
      ((Container)var15).add("Left", this.typedesc);
      ((Container)var7).add("Right", var15);
      ((Container)var6).add("Center", var7);
      this.templtype.setForeground(Color.black);
      this.typedesc.setForeground(Color.black);
      this.templtype.setBackground(Color.white);
      this.typedesc.setBackground(Color.white);
      if (var3.compareTo("Inquiry") == 0) {
         this.templtype.setEditable(false);
         this.typedesc.setEditable(false);
         String[] var16 = new String[]{""};
         ((Container)var6).add("South", new JDPButtons(var1, var16, JDPButtons.HORIZONTAL));
      } else {
         String[] var22 = new String[]{"   Apply   ", "   Reset   ", "   New   ", "   Copy  ", " Remove "};
         ((Container)var6).add("South", new JDPButtons(var1, var22, JDPButtons.HORIZONTAL));
      }

      ((Container)var4).add("Center", var6);
      String[] var23 = new String[0];
      String[] var17 = new String[0];
      String[][] var18 = new String[0][0];
      String[][] var19 = new String[0][0];
      boolean[] var20 = new boolean[0];
      int[] var21 = new int[0];
      if (var23.length > 0) {
         this.jdpWhereClause = new JDPWhereClause(var1, var2, "JDPTemplTypeMait", true, " ", var23, var17, var18, var19, (String[][])null, (String[][])null, var21, var20);
         ((Container)var8).add("North", this.jdpWhereClause);
      }

      if (this.psortChoice.length > 0) {
         this.searchResults = new JDPSearchResults(var1, var2, false, this.jaggSQL, false, var9, var10, this.pfromWhereClause, var11, this.psortChoice, this.pdisplayChoice, "", var12, var13);
         ((Container)var8).add("Center", this.searchResults);
         ((Container)var4).add("West", var8);
      }

      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Template Type Maintenance", var4, "North"));
      if (this.psortChoice.length > 0) {
         this.newSearch();
      }

      ((Component)var2).paintAll(((Component)var2).getGraphics());
      var1.gParm.addElement(this);
   }
}
