import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPTemplateMaint extends Panel {
   JDPUser user;
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   JDPSelectDSN selectDSN;
   JDPSelectTable selectTable;
   Panel targetPanel;
   JDPTabSelectPanel tabPanel;
   JDPDatabaseMaint target;
   Panel tabMainPanel;
   JDPTemplDtlMaint templateDetail;
   JDPTabSelectPanel tabPanelMain;
   JDPJagg jaggSQL;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   boolean typeChanged;
   String pfromWhereClause;
   TextField a_templname;
   TextField a_templdesc;
   JDPChoice a_templtype;
   Vector valuea_templtype;
   JDPChoice a_groupname;
   Vector valuea_groupname;

   void loadChoices() {
      this.valuea_templtype = new Vector();
      new JDPLoadChoice(this.user, this.jaggSQL, this.a_templtype, "typedesc", "templtype", "JDPTmpType", "(1=1)", this.valuea_templtype);
      this.valuea_groupname = new Vector();
      new JDPLoadChoice(this.user, this.jaggSQL, this.a_groupname, "groupdesc", "groupname", "JDPTmpGrp", "(1=1)", this.valuea_groupname);
   }

   void clearFields() {
      this.a_templname.setText("");
      this.a_templdesc.setText("");
      this.a_templtype.select(0);
      this.a_groupname.select(0);
   }

   public JDPTemplateMaint(JDPUser var1, Panel var2, String var3, JDPDatabaseMaint var4) {
      this.user = var1;
      this.targetPanel = var2;
      this.target = var4;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      JDPScrollPanel var9 = new JDPScrollPanel();
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new BorderLayout());
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new BorderLayout());
      Panel var12 = new Panel();
      ((Container)var12).setLayout(new BorderLayout());
      this.psortChoice = new String[1];
      this.psortChoice[0] = "c.typedesc";
      this.pdisplayChoice = this.psortChoice;
      this.a_templname = new TextField("", 22);
      this.a_templdesc = new TextField("", 42);
      this.a_templtype = new JDPChoice();
      this.a_groupname = new JDPChoice();
      this.loadChoices();
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Name:", Color.black));
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Description:", Color.black));
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new JDPLineLayout());
      ((Container)var13).add("Left", this.a_templname);
      ((Container)var9).add("Right", var13);
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout());
      ((Container)var14).add("Left", this.a_templdesc);
      ((Container)var9).add("Right", var14);
      ((Container)var8).add("North", var9);
      this.selectDSN = new JDPSelectDSN();
      ((Container)var11).add("Center", this.selectDSN);
      this.selectDSN.InitClass(var1, var11, "JDPTemplateMaint");
      this.selectTable = new JDPSelectTable();
      ((Container)var12).add("Center", this.selectTable);
      this.selectTable.InitClass(var1, var12, "JDPTemplateMaint");
      String[] var15 = new String[]{"Select a Data Source", "Select Tables"};
      Panel[] var16 = new Panel[]{var11, var12};
      this.tabPanel = new JDPTabSelectPanel(var1, var15, var16, "North");
      this.tabMainPanel = new Panel();
      this.tabMainPanel.setLayout(new CardLayout());
      this.tabMainPanel.add("blank", new Panel());
      this.tabMainPanel.add("E", this.tabPanel);
      ((Container)var8).add("Center", this.tabMainPanel);
      this.a_templname.setForeground(Color.black);
      this.a_templdesc.setForeground(Color.black);
      this.a_templtype.setForeground(Color.black);
      this.a_groupname.setForeground(Color.black);
      this.a_templname.setBackground(Color.white);
      this.a_templdesc.setBackground(Color.white);
      this.a_templtype.setBackground(Color.white);
      this.a_groupname.setBackground(Color.white);
      if (var3.compareTo("Inquiry") == 0) {
         this.a_templname.setEditable(false);
         this.a_templdesc.setEditable(false);
         String[] var17 = new String[]{""};
         ((Container)this).add("South", new JDPButtons(var1, var17, JDPButtons.HORIZONTAL));
      } else {
         String[] var20 = new String[]{"Apply", "Reset"};
         int[] var18 = new int[]{0, 6};
         ((Container)this).add("South", new JDPButtons(var1, var20, var18, JDPButtons.HORIZONTAL));
      }

      ((Container)var5).add("Center", var8);
      this.templateDetail = new JDPTemplDtlMaint(var1, var3, this);
      ((Container)var6).add("Center", this.templateDetail);
      ((Component)var6).paintAll(((Component)var6).getGraphics());
      String[] var21 = new String[]{"Template Definition", "Template Details"};
      Panel[] var22 = new Panel[]{var5, var6};
      this.tabPanelMain = new JDPTabSelectPanel(var1, var21, var22, "North");
      ((Container)this).add("Center", this.tabPanelMain);
      if (this.psortChoice.length > 0) {
      }

      ((Component)var2).paintAll(((Component)var2).getGraphics());
      var1.gParm.addElement(this);
      int[] var19 = new int[]{4, 0, 2, 1};
      var4.tree.setIcons(var19);
      var4.tree.setRoot(var1.JDesignerPro.wwwroot, true);
      this.loadTypes();
      this.loadGroups();
      this.loadTemplates();
   }

   void retrieveHandle() {
      for(int var1 = 0; var1 < this.user.gParm.size(); ++var1) {
      }

   }

   void loadTypes() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      int var5 = 0;
      String var7 = "SELECT typedesc FROM JDPTmpType WHERE JDPSystem = '" + this.user.JDPSystem + "' ORDER BY typedesc";
      this.user.mainmsg.setStatusMsg("Loading Type definitions, please wait...", 0);
      int[] var8 = new int[]{4, 0, 2, 1};
      this.target.tree.setIcons(var8);
      var2 = this.jaggSQL.execSQL(var7, var3);
      if (var2 != -1) {
         var5 = this.jaggSQL.getRowCount();
         this.jaggSQL.getColumnCount();
         String[] var9 = new String[2];

         for(int var10 = 0; var10 < var5; ++var10) {
            String var6 = (String)var3.elementAt(var10);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var6, var4);
               var9[0] = var1.nextToken().trim();
               var9[1] = "";
               this.target.tree.addEntry(var9);
            }
         }

         this.user.mainmsg.clearStatusMsg();
      }
   }

   void loadData(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      String var7 = "";
      String var8 = this.selectDSN.connectstring.getText();
      String[] var9;
      if (var1 != null) {
         var9 = var1;
      } else {
         if ((this.itemIndex = this.target.tree.getSelectedIndex()) < 0) {
            this.clearFields();
            return;
         }

         var9 = this.target.tree.getSelectedBranch();
      }

      String var10 = "SELECT a.templname," + "a.templdesc," + "a.templtype," + "a.templdsn," + "a.templcstr," + "a.templtbls," + "a.templjoin," + "a.groupname" + " FROM JDPTmpTable a,JDPTmpGrp b,JDPTmpType c" + " WHERE a.templtype = c.templtype AND a.groupname = b.groupname AND a.JDPSystem = b.JDPSystem AND a.JDPSystem = c.JDPSystem AND a.JDPSystem='" + this.user.JDPSystem + "'" + " AND b.groupdesc='" + var9[2] + "' AND a.templname='" + var9[3] + "'";
      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var3 = this.jaggSQL.execSQL(var10, var4);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var10);
      } else {
         if (var3 >= 1) {
            String var6 = (String)var4.elementAt(0);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var6);
               this.a_templname.setText(var2.nextToken(var5).trim());
               this.a_templdesc.setText(var2.nextToken(var5).trim());
               var7 = var2.nextToken(var5).trim();
               if (this.valuea_templtype.indexOf(var7) >= 0) {
                  this.a_templtype.select(this.valuea_templtype.indexOf(var7));
               }

               if (var7.equals("E")) {
                  ((CardLayout)this.tabMainPanel.getLayout()).show(this.tabMainPanel, "E");
               } else {
                  ((CardLayout)this.tabMainPanel.getLayout()).show(this.tabMainPanel, "blank");
               }

               this.selectDSN.datasourceC.select(var2.nextToken(var5).trim());
               this.selectDSN.datasource.setText(this.selectDSN.datasourceC.getSelectedItem());
               this.selectDSN.sourcetype.setText(this.selectDSN.recordName[this.selectDSN.datasourceC.getSelectedIndex()]);
               this.selectDSN.connectstring.setText(var2.nextToken(var5).trim());
               String var11 = var2.nextToken(var5).trim();
               String var12 = var2.nextToken(var5).trim();
               String var13 = var2.nextToken(var5).trim();
               if (this.valuea_groupname.indexOf(var13) >= 0) {
                  this.a_groupname.select(this.valuea_groupname.indexOf(var13));
               }

               String var14 = this.selectDSN.connectstring.getText();
               int var15 = var14.indexOf("UID=");
               int var16 = 0;
               if (var15 > 0) {
                  var16 = var14.substring(var15).indexOf(";");
                  this.selectDSN.userid.setText(var14.substring(var15 + 4, var15 + var16));
               }

               var15 = var14.indexOf("PWD=");
               if (var15 > 0) {
                  var16 = var14.substring(var15).indexOf(";");
                  this.selectDSN.password.setText(var14.substring(var15 + 4, var15 + var16));
               }

               var15 = var14.indexOf("DATABASE=");
               if (var15 > 0) {
                  var16 = var14.substring(var15).indexOf(";");
                  this.selectDSN.database.setText(var14.substring(var15 + 9, var15 + var16));
               }

               if (var7.equals("E") && !var8.equals(this.selectDSN.connectstring.getText())) {
                  this.selectDSN.setNewDSN();
                  this.selectTable.refresh();
               }

               int var17 = -1;

               for(int var18 = 0; var18 < this.selectTable.stables.countItems(); ++var18) {
                  if (var11.indexOf(this.selectTable.stables.getItem(var18) + ";") >= 0) {
                     this.selectTable.stables.select(var18);
                     if (var17 < 0) {
                        var17 = var18;
                     }
                  } else {
                     this.selectTable.stables.deselect(var18);
                  }
               }

               if (var17 >= 0) {
                  this.selectTable.stables.makeVisible(var17);
               }

               this.selectTable.resetAlias();
               StringTokenizer var26 = new StringTokenizer(var12, ";");
               this.selectTable.joinConditions.clear();

               while(var26.hasMoreElements()) {
                  this.selectTable.joinConditions.addItem(var26.nextToken().trim());
               }
            }

            if (var3 > 1) {
               this.user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
            } else {
               this.user.mainmsg.clearStatusMsg();
            }
         } else {
            this.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
            this.clearFields();
         }

         this.templateDetail.loadData(var1);
      }
   }

   boolean saveData() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.jaggSQL.getSEP();
      String var3 = "";
      String[] var4 = this.target.tree.getSelectedBranch();
      String var5 = this.formatTables();
      String var6 = "";

      for(int var7 = 0; var7 < this.selectTable.joinConditions.countItems(); ++var7) {
         var6 = var6 + this.selectTable.joinConditions.getItem(var7);
         var6 = var6 + ";";
      }

      if (this.insertRequested) {
         var3 = "INSERT INTO JDPTmpTable (JDPSystem, templname, " + "templdesc, " + "templtype, " + "templdsn, " + "templcstr, " + "templtbls, " + "templjoin, " + "groupname) VALUES('" + this.user.JDPSystem + "','" + this.a_templname.getText() + "', " + "'" + this.a_templdesc.getText() + "', " + "'" + var4[1].substring(0, 1) + "', " + "'" + this.selectDSN.datasourceC.getSelectedItem() + "', " + "'" + this.selectDSN.connectstring.getText() + "', " + "'" + var5 + "', " + "'" + var6 + "', " + "'" + (String)this.valuea_groupname.elementAt(this.a_groupname.getSelectedIndex()) + "')";
      } else if (this.deleteRequested) {
         var3 = "DELETE FROM JDPTmpTable" + " WHERE JDPSystem='" + this.user.JDPSystem + "'" + " AND templtype='" + var4[1].substring(0, 1) + "' AND groupname='" + (String)this.valuea_groupname.elementAt(this.a_groupname.getSelectedIndex()) + "' AND templname='" + this.a_templname.getText() + "'";
      } else {
         var3 = "UPDATE JDPTmpTable SET templdesc = '" + this.a_templdesc.getText() + "', " + "templtype = '" + (String)this.valuea_templtype.elementAt(this.a_templtype.getSelectedIndex()) + "', " + "templdsn = '" + this.selectDSN.datasourceC.getSelectedItem() + "', " + "templcstr = '" + this.selectDSN.connectstring.getText() + "', " + "templtbls = '" + var5 + "', " + "templjoin = '" + var6 + "' " + " WHERE JDPSystem='" + this.user.JDPSystem + "'" + " AND templtype='" + var4[1].substring(0, 1) + "' AND groupname='" + (String)this.valuea_groupname.elementAt(this.a_groupname.getSelectedIndex()) + "' AND templname='" + this.a_templname.getText() + "'";
      }

      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var1 = this.jaggSQL.execSQL(var3, var2);
      if (var1 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var3);
         return false;
      } else {
         if (var1 == 1) {
            if (this.insertRequested) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (this.deleteRequested) {
               var3 = "DELETE FROM JDPTmpDetail" + " WHERE JDPSystem='" + this.user.JDPSystem + "'" + " AND templtype='" + var4[1].substring(0, 1) + "' AND groupname='" + (String)this.valuea_groupname.elementAt(this.a_groupname.getSelectedIndex()) + "' AND templname='" + this.a_templname.getText() + "'";
               this.jaggSQL.execSQL(var3, var2);
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
               this.target.tree.removeBranch(this.target.tree.getSelectedBranch());
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var3);
         }

         this.templateDetail.checkRows();
         this.loadTemplates();
         if (this.insertRequested) {
            String[] var12 = this.target.tree.getSelectedBranch();
            var12[3] = this.a_templname.getText();
            this.target.tree.nothingChanged = false;
            this.target.tree.select(var12, 3);
            this.target.tree.repaint();
            this.templateDetail.loadGrid(var12);
         }

         this.insertRequested = false;
         this.deleteRequested = false;
         return true;
      }
   }

   void loadTemplates() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      int var5 = 0;
      String var7 = "SELECT c.templtype, c.typedesc, b.groupdesc, a.templname FROM JDPTmpTable a,JDPTmpGrp b,JDPTmpType c WHERE a.templtype = c.templtype AND a.groupname = b.groupname AND a.JDPSystem = b.JDPSystem AND a.JDPSystem = c.JDPSystem AND a.JDPSystem = '" + this.user.JDPSystem + "' ORDER BY c.typedesc, b.groupdesc, a.templname";
      this.user.mainmsg.setStatusMsg("Loading Template definitions, please wait...", 0);
      int[] var8 = new int[]{4, 0, 2, 1};
      this.target.tree.setIcons(var8);
      var2 = this.jaggSQL.execSQL(var7, var3);
      if (var2 != -1) {
         var5 = this.jaggSQL.getRowCount();
         this.jaggSQL.getColumnCount();
         Object[] var9 = new Object[]{null, null, "Tables", "Templates"};
         this.target.tree.setDropKeys(var9);
         String[] var10 = new String[3];

         for(int var11 = 0; var11 < var5; ++var11) {
            String var6 = (String)var3.elementAt(var11);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var6, var4);
               var1.nextToken().trim();
               var10[0] = var1.nextToken().trim();
               var10[1] = var1.nextToken().trim();
               var10[2] = var1.nextToken().trim();
               this.target.tree.addEntry(var10);
            }
         }

         this.target.tree.setDropKeys((Object[])null);
         this.user.mainmsg.clearStatusMsg();
      }
   }

   String formatTables() {
      String var1 = "";

      for(int var2 = 0; var2 < this.selectTable.stables.countItems(); ++var2) {
         if (this.selectTable.stables.isSelected(var2)) {
            var1 = var1 + this.selectTable.stables.getItem(var2);
            var1 = var1 + ";";
         }
      }

      return var1;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               if (var1.target.equals(this.tabPanel) && this.tabPanel.isSelected(1)) {
                  String var3 = this.selectDSN.connectstring.getText();
                  if (var3.equals("")) {
                     this.selectDSN.buildConnectString();
                  }

                  if (!var3.equals(this.selectDSN.connectstring.getText())) {
                     this.selectDSN.setNewDSN();
                     this.selectTable.refresh();
                  }
               }

               if (var1.target.equals(this.tabPanelMain) && this.tabPanelMain.isSelected(1)) {
                  this.templateDetail.templdsn = this.selectDSN.datasource.getText();
                  this.templateDetail.templcstr = this.selectDSN.connectstring.getText();
                  this.templateDetail.templtbls = this.formatTables();
                  if (this.templateDetail.currentType.equals("E")) {
                     this.templateDetail.loadColumns();
                  }
               }

               return true;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.a_templname)) {
                     this.user.u.cursor(this.a_templdesc);
                     return true;
                  }

                  if (var1.target.equals(this.a_templdesc)) {
                     this.user.u.cursor(this.a_templtype);
                     return true;
                  }

                  if (var1.target.equals(this.a_templtype)) {
                     this.user.u.cursor(this.a_groupname);
                     return true;
                  }

                  if (!this.valuea_templtype.elementAt(this.a_templtype.getSelectedIndex()).equals("E")) {
                     if (var1.target.equals(this.a_groupname)) {
                        this.user.u.cursor(this.a_templname);
                        return true;
                     }
                  } else if (this.tabPanel.isSelected(0)) {
                     if (!JDPJagg.useJaggServer) {
                        if (var1.target.equals(this.a_groupname)) {
                           this.user.u.cursor(this.selectDSN.datasourceC);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.datasourceC)) {
                           this.user.u.cursor(this.selectDSN.userid);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.userid)) {
                           this.user.u.cursor(this.selectDSN.password);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.password)) {
                           this.user.u.cursor(this.selectDSN.database);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.database)) {
                           this.user.u.cursor(this.selectDSN.connectstring);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.connectstring)) {
                           this.user.u.cursor(this.a_templname);
                           return true;
                        }
                     } else {
                        if (var1.target.equals(this.a_groupname)) {
                           this.user.u.cursor(this.selectDSN.datasource);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.datasource)) {
                           this.user.u.cursor(this.selectDSN.sourcechoice);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.sourcechoice)) {
                           this.user.u.cursor(this.selectDSN.userid);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.userid)) {
                           this.user.u.cursor(this.selectDSN.password);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.password)) {
                           this.user.u.cursor(this.selectDSN.database);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.database)) {
                           this.user.u.cursor(this.selectDSN.connectstring);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.connectstring)) {
                           this.user.u.cursor(this.a_templname);
                           return true;
                        }
                     }
                  }
               } else {
                  if (var1.target.equals(this.a_templdesc)) {
                     this.user.u.cursor(this.a_templname);
                     return true;
                  }

                  if (var1.target.equals(this.a_templtype)) {
                     this.user.u.cursor(this.a_templdesc);
                     return true;
                  }

                  if (var1.target.equals(this.a_groupname)) {
                     this.user.u.cursor(this.a_templtype);
                     return true;
                  }

                  if (!this.valuea_templtype.elementAt(this.a_templtype.getSelectedIndex()).equals("E")) {
                     if (var1.target.equals(this.a_templname)) {
                        this.user.u.cursor(this.a_groupname);
                        return true;
                     }
                  } else if (this.tabPanel.isSelected(0)) {
                     if (var1.target.equals(this.a_templname)) {
                        this.user.u.cursor(this.selectDSN.connectstring);
                        return true;
                     }

                     if (!JDPJagg.useJaggServer) {
                        if (var1.target.equals(this.selectDSN.datasourceC)) {
                           this.user.u.cursor(this.a_groupname);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.userid)) {
                           this.user.u.cursor(this.selectDSN.datasourceC);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.password)) {
                           this.user.u.cursor(this.selectDSN.userid);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.database)) {
                           this.user.u.cursor(this.selectDSN.password);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.connectstring)) {
                           this.user.u.cursor(this.selectDSN.database);
                           return true;
                        }
                     } else {
                        if (var1.target.equals(this.selectDSN.datasource)) {
                           this.user.u.cursor(this.a_groupname);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.sourcechoice)) {
                           this.user.u.cursor(this.selectDSN.datasource);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.userid)) {
                           this.user.u.cursor(this.selectDSN.sourcechoice);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.password)) {
                           this.user.u.cursor(this.selectDSN.userid);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.database)) {
                           this.user.u.cursor(this.selectDSN.password);
                           return true;
                        }

                        if (var1.target.equals(this.selectDSN.connectstring)) {
                           this.user.u.cursor(this.selectDSN.database);
                           return true;
                        }
                     }
                  }
               }

               return false;
            }

            return false;
         case 701:
            if (!var1.target.equals(this.selectTable.stables) || var1.id != 701 && var1.id != 702) {
               return false;
            } else {
               this.selectTable.resetAlias();
               return true;
            }
         case 1001:
            if (var1.target instanceof JDPTreePicker) {
               this.loadData((String[])null);
               return true;
            } else if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2.trim().compareTo("Apply") == 0) {
                  if (this.valuea_templtype.elementAt(this.a_templtype.getSelectedIndex()).equals("E")) {
                     this.selectDSN.buildConnectString();
                     this.selectDSN.setNewDSN();
                  }

                  if (this.checkFields()) {
                     if (this.insertRequested) {
                        this.saveData();
                     } else {
                        this.saveData();
                     }

                     this.typeChanged = false;
                  } else {
                     this.tabPanelMain.select(0);
                  }

                  return true;
               } else {
                  if (var2.trim().compareTo("Reset") == 0) {
                     this.loadData((String[])null);
                     return true;
                  }

                  return true;
               }
            } else if (var1.target instanceof JDPChoice) {
               if (var1.target.equals(this.a_templtype)) {
                  if (this.valuea_templtype.elementAt(this.a_templtype.getSelectedIndex()).equals("E")) {
                     ((CardLayout)this.tabMainPanel.getLayout()).show(this.tabMainPanel, "E");
                  } else {
                     ((CardLayout)this.tabMainPanel.getLayout()).show(this.tabMainPanel, "blank");
                  }

                  this.typeChanged = true;
               }

               if (var1.target.equals(this.selectDSN.datasourceC)) {
                  this.selectDSN.buildConnectString();
                  this.selectDSN.setNewDSN();
                  this.selectDSN.sourcetype.setText(this.selectDSN.recordName[this.selectDSN.datasourceC.getSelectedIndex()]);
               }

               return true;
            } else {
               if (var1.target instanceof TextField) {
                  if (this.jdpWhereClause != null && var1.target.equals(this.jdpWhereClause.matchConstant)) {
                     this.insertRequested = false;
                     this.deleteRequested = false;
                     return true;
                  }

                  this.checkFields();
                  return true;
               }

               return false;
            }
         default:
            if (var1.target instanceof TextField) {
               if (!var1.target.equals(this.selectDSN.userid) && !var1.target.equals(this.selectDSN.password) && !var1.target.equals(this.selectDSN.database)) {
                  return false;
               } else {
                  this.selectDSN.connectstring.setText("");
                  return false;
               }
            } else {
               return false;
            }
      }
   }

   boolean checkFields() {
      String var1 = this.a_templname.getText();
      var1 = this.user.u.replace(var1, " ", "");
      this.a_templname.setText(var1);
      if (!this.user.u.ischaracter(this.a_templname, this.user.mainmsg, "Please enter a template name")) {
         return false;
      } else {
         return this.user.u.ischaracter(this.a_templdesc, this.user.mainmsg, "Please enter a template description");
      }
   }

   void loadGroups() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      int var5 = 0;
      String var7 = "SELECT c.typedesc, b.groupdesc FROM JDPTmpGrp b,JDPTmpType c WHERE b.templtype = c.templtype AND b.JDPSystem = c.JDPSystem AND b.JDPSystem = '" + this.user.JDPSystem + "' ORDER BY c.typedesc, b.groupdesc";
      this.user.mainmsg.setStatusMsg("Loading Group definitions, please wait...", 0);
      int[] var8 = new int[]{4, 0, 2, 1};
      this.target.tree.setIcons(var8);
      var2 = this.jaggSQL.execSQL(var7, var3);
      if (var2 != -1) {
         Object[] var9 = new Object[]{null, null, "Tables", null};
         String[] var10 = new String[]{null, null, "Drop here to create a new template from this table", null};
         this.target.tree.setDropKeys(var9);
         this.target.tree.setDropMessages(var10);
         var5 = this.jaggSQL.getRowCount();
         this.jaggSQL.getColumnCount();
         String[] var11 = new String[3];

         for(int var12 = 0; var12 < var5; ++var12) {
            String var6 = (String)var3.elementAt(var12);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var6, var4);
               var11[0] = var1.nextToken().trim();
               var11[1] = var1.nextToken().trim();
               var11[2] = "";
               this.target.tree.addEntry(var11);
            }
         }

         this.target.tree.setDropKeys((Object[])null);
         this.target.tree.setDropMessages((String[])null);
         this.loadChoices();
         this.user.mainmsg.clearStatusMsg();
      }
   }
}
