import java.awt.Font;
import java.awt.Panel;
import java.util.Vector;

public class JDPUser {
   public JDesignerPro JDesignerPro;
   public JDPMainWindow jdpMainWindow;
   public JDPPopupComponent popup;
   public JDPTabSelectPanel jdpMenuPanel;
   public JDPServerListener serverListener;
   JDPAboutBox aboutBox;
   public String jaggPath;
   public String jaggDSN;
   public String DSNType;
   public String jaggCSTR;
   public String jdbcDriver;
   public String jdbcPrefix;
   public String jdbcSuffix;
   public String jdbcDirect;
   String jdbcUserid;
   String jdbcPassword;
   public JDPJagg jaggSQL;
   public JDPStatusMessage mainmsg;
   // $FF: renamed from: u JDPUtils
   public JDPUtils field_0;
   JDPStatusMessage loginMessage;
   public String wwwroot;
   public Vector gParm;
   public boolean DEBUG;
   static boolean classactivated;
   public String JDPSystem;
   public String JDPSystemDesc;
   public String boldFontName;
   public int boldFontSize;
   public String plainFontName;
   public int plainFontSize;
   public Font boldFont;
   public Font plainFont;
   public JDPCustomer cust;
   JDPMenuStruct menu;
   JDPSaveProps saveProperties;
   JDPSaveProps prevProperties;
   int JDPBuildTestPanelIndex;
   int JDPBuildTestPanelDisplay;
   Panel[] JDPBuildTestPanel = new Panel[10];
   JDPProcessThread[] process;
   int[] processStatus;

   public Vector getGlobalParm() {
      return this.gParm;
   }

   public String getJDPDir() {
      return this.JDesignerPro.JDPDirectory;
   }

   public String getJDPClassParameter() {
      return this.JDesignerPro.JDPClassParameter;
   }

   public String getJDPCompiler() {
      return this.JDesignerPro.JDPCompiler;
   }

   public String getJDPDomain() {
      return this.JDesignerPro.JDPDomain;
   }

   public String getJDPSystem() {
      return this.JDPSystem;
   }

   public JDPUser getJDPUser() {
      return this;
   }

   public String getJDPJaggDir() {
      return this.JDesignerPro.JDPJaggDir;
   }

   public String getJDPClasses() {
      return this.JDesignerPro.JDPClasses;
   }

   public String getJDPInWebPage() {
      return this.JDesignerPro.JDPInWebPage;
   }

   void copyUser(JDPUser var1) {
      var1.cust = this.cust;
      var1.menu = this.menu;
      var1.jaggPath = this.jaggPath;
      var1.JDPSystem = this.JDPSystem;
      var1.JDPSystemDesc = this.JDPSystemDesc;
      var1.boldFontName = this.boldFontName;
      var1.boldFontSize = this.boldFontSize;
      var1.plainFontName = this.plainFontName;
      var1.plainFontSize = this.plainFontSize;
      var1.plainFont = this.plainFont;
      var1.boldFont = this.boldFont;
      var1.wwwroot = this.wwwroot;
      var1.DSNType = this.DSNType;
      var1.jaggDSN = this.jaggDSN;
      var1.jaggCSTR = this.jaggCSTR;
      var1.jdbcDriver = this.jdbcDriver;
      var1.jdbcPrefix = this.jdbcPrefix;
      var1.jdbcSuffix = this.jdbcSuffix;
      var1.jdbcUserid = this.jdbcUserid;
      var1.jdbcPassword = this.jdbcPassword;
      if (var1.field_0 == null) {
         var1.field_0 = new JDPUtils(var1);
      }

      var1.serverListener = this.serverListener;
   }

   public String getJDPSystemDesc() {
      return this.JDPSystemDesc;
   }

   public String getWWWroot() {
      return this.wwwroot;
   }

   public JDPJagg getJaggSQL() {
      return this.jaggSQL;
   }

   public JDPTabSelectPanel getMenuPanel() {
      return this.jdpMenuPanel;
   }

   public String getJaggPath() {
      return this.jaggPath;
   }

   void startProcess(int var1, JDPStatusMessage var2) {
      if (this.processStatus[var1] != 0 && this.processStatus[var1] != 2) {
         if (this.processStatus[var1] == 1) {
            var2.setStatusMsg("The requested process is presently starting.", 10);
         }

      } else {
         if (this.processStatus[var1] != 0) {
         }

         this.process[var1] = new JDPProcessThread(this, var1);
         (new Thread(this.process[var1])).start();
      }
   }

   void killProcess(int var1) {
      this.processStatus[var1] = 0;
   }

   public String getJDPClassName() {
      return this.JDesignerPro.JDPClassName;
   }
}
