import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Label;
import java.awt.Panel;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.URL;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDesignerPro extends Applet implements Runnable {
   static boolean JDPLicensed;
   static int JDPLicenses;
   String JDPSystem;
   String JDPClassName;
   String JDPClassParameter;
   String JDPInWebPage;
   String JDPDomain;
   String JDPDirectory = "";
   String JDPJaggDir;
   String JDPCompiler;
   String JDPClasses;
   String NDSPath;
   String JDPJaggSetup;
   String JDPJaggServer;
   String JDPSystemDesc;
   String boldFontName;
   int boldFontSize;
   String plainFontName;
   int plainFontSize;
   float versionnum;
   String language;
   String country;
   String JDPJaggPath;
   String JDPJaggDSN;
   String JDPJaggCSTR;
   String JDPJaggJdbcDriver;
   String JDPJaggJdbcPrefix;
   String JDPJaggJdbcSuffix;
   String JDPJaggJdbcUserid;
   String JDPJaggJdbcPassword;
   String autoUsername;
   String autoPassword;
   Image iconImage;
   Image JDPIconImage;
   static ByteArrayOutputStream SystemOutStream;
   JDPConsoleDialog consoleDialog;
   static String version = "3.0";
   static String actualversion = "3.00";
   boolean installing;
   JDPJagg jaggSQL;
   JDPLogin login;
   JDPUser[] user;
   int userCount;
   boolean exitapplet;
   static boolean executable;
   static boolean usingNDSSnapin;
   AppletContext saveAppletContext;
   Label updateLabel;
   int maxprocess = 20;
   String username;
   boolean singlemode;
   boolean expired;
   String wintitle;
   String thisDocument;
   String wwwroot;
   String IniContents = "";
   static String pathDelimiter = ";";
   static String serverPlatform = "";
   static String serverSeparator = "\\";
   static String dateFormat = "mm/dd/yy";
   int daysRemaining;
   // $FF: renamed from: r java.lang.Runtime
   Runtime field_0;
   int counter;

   public void stop() {
      if (this.JDPInWebPage != null) {
         this.jaggSQL.setFCTN("Logout");
         this.jaggSQL.setFCTNP("");
         Vector var1 = new Vector();
         this.jaggSQL.execSQL("", var1);
      }

   }

   JDPUser initUser(int var1) {
      JDPUser var2;
      if (this.JDPClassName == null) {
         var2 = this.user[var1];
      } else {
         var2 = this.user[var1];
         var2.u = new JDPUtils(var2);
         var2.boldFontName = this.boldFontName;
         var2.boldFontSize = this.boldFontSize;
         var2.plainFontName = this.plainFontName;
         var2.plainFontSize = this.plainFontSize;
         var2.plainFont = new Font(this.plainFontName, 0, this.plainFontSize);
         var2.boldFont = new Font(this.boldFontName, 1, this.boldFontSize);
         ((Component)this).setFont(var2.plainFont);
      }

      var2.JDesignerPro = this;
      var2.process = new JDPProcessThread[this.maxprocess];
      var2.processStatus = new int[this.maxprocess];
      var2.jaggPath = this.JDPJaggPath;
      var2.jaggDSN = this.JDPJaggDSN;
      var2.jaggCSTR = this.JDPJaggCSTR;
      var2.jdbcDriver = this.JDPJaggJdbcDriver;
      var2.jdbcPrefix = this.JDPJaggJdbcPrefix;
      var2.jdbcSuffix = this.JDPJaggJdbcSuffix;
      var2.jdbcUserid = this.JDPJaggJdbcUserid;
      var2.jdbcPassword = this.JDPJaggJdbcPassword;
      var2.wwwroot = this.wwwroot;
      var2.gParm = new Vector();
      var2.JDPBuildTestPanel[0] = new Panel();
      var2.JDPBuildTestPanel[1] = new Panel();
      var2.JDPBuildTestPanel[2] = new Panel();
      var2.JDPBuildTestPanel[3] = new Panel();
      var2.JDPBuildTestPanel[4] = new Panel();
      var2.saveProperties = new JDPSaveProps(var2);
      var2.serverListener = new JDPServerListener(var2);
      return var2;
   }

   String addDelimiter(String var1) {
      String var2 = var1.substring(var1.length() - 1);
      if (!var2.equals("/") && !var2.equals("\\")) {
         if (var1.indexOf("/") >= 0) {
            var1 = var1 + "/";
         } else {
            var1 = var1 + "\\";
         }
      }

      if (var1.indexOf("/") >= 0) {
         pathDelimiter = ":";
      } else {
         pathDelimiter = ";";
      }

      return var1;
   }

   void displayMessage(JDPUser var1, String var2, String var3, String var4, String var5) {
      new JDPSvrMsgDialog(var1, var2, this, false, var3, var4, var5);
   }

   boolean checkSetup(String var1, String var2, String var3) {
      if (var3.substring(0, 4).compareTo("http") != 0) {
         int var4 = var3.lastIndexOf("/");
         if (var4 > 0) {
            var3 = var3.substring(0, var4 + 1);
            this.wwwroot = var3;
         }
      }

      var2 = this.loadIniFile(var3, var1);
      this.getServerPlatform();
      if (var2 == null) {
         if (executable) {
            this.JDPSystemDesc = "Could not open JDesignerPro.ini.";
         } else {
            this.JDPSystemDesc = "Could not connect to WebServer.";
         }

         this.boldFontName = "Helvetica";
         this.boldFontSize = 11;
         this.plainFontName = "Helvetica";
         this.plainFontSize = 11;
         this.versionnum = 0.0F;
         this.expired = true;
         this.login = new JDPLogin(this, this.JDPSystemDesc);
         if (executable) {
            this.login.mainmsg.setStatusMsg("Check JDesignerPro dir permissions.", 0);
         } else {
            this.login.mainmsg.setStatusMsg("Check that WebServer is running.", 0);
         }

         JDPJagg.cleanUp();
         return false;
      } else if (var2.length() > 0) {
         return this.getSystem(var1, var2);
      } else {
         this.installing = true;
         this.loadLicenseWindow();
         this.versionnum = Float.valueOf(actualversion.trim().replace('b', '0'));
         return true;
      }
   }

   void invalidLogin() {
      this.exitapplet = true;
   }

   public JDesignerPro() {
   }

   public JDesignerPro(String var1, String var2) {
      if (var1 == null) {
         var1 = ((Applet)this).getCodeBase().toString();
      } else {
         executable = true;
         SystemOutStream = new ByteArrayOutputStream();
      }

      this.wwwroot = var1;
      this.JDPSystem = var2;
      this.init();
   }

   public JDesignerPro(String var1, String var2, String var3, String var4) {
      if (var1 == null) {
         var1 = ((Applet)this).getCodeBase().toString();
      } else {
         executable = true;
         SystemOutStream = new ByteArrayOutputStream();
      }

      this.wwwroot = var1;
      this.JDPSystem = var2;
      this.autoUsername = var3;
      this.autoPassword = var4;
      this.init();
   }

   public JDesignerPro(String var1, String var2, String var3, String var4, String var5) {
      if (var1 == null) {
         var1 = ((Applet)this).getCodeBase().toString();
      } else {
         executable = true;
         SystemOutStream = new ByteArrayOutputStream();
      }

      this.wwwroot = var1;
      this.JDPSystem = var2;
      this.autoUsername = var3;
      this.autoPassword = var4;
      this.JDPClassName = var5;
      this.init();
   }

   boolean getSystem(String var1, String var2) {
      int var3 = var2.indexOf(" ");
      this.JDPJaggPath = var2.substring(0, var3);
      this.JDPJaggCSTR = var2.substring(var3 + 1);
      int var4 = this.JDPJaggCSTR.indexOf("DSN=") + 4;
      int var5 = this.JDPJaggCSTR.indexOf(";", var4);
      this.JDPJaggDSN = this.JDPJaggCSTR.substring(var4, var5);
      int var6 = var2.indexOf("JDBCDRIVER=");
      if (var6 >= 0) {
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcDriver = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("JDBCPREFIX=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcPrefix = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("JDBCSUFFIX=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcSuffix = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("UID=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcUserid = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("PWD=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcPassword = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("CSTR=", var6 + 1);
         this.JDPJaggCSTR = "";
         if (var6 > 0) {
            var6 = var2.indexOf("=", var6 + 1);
            this.JDPJaggCSTR = var2.substring(var6 + 1);
         }
      } else {
         var6 = var2.indexOf("UID=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcUserid = var2.substring(var6 + 1, var3);
         var6 = var2.indexOf("PWD=", var6 + 1);
         var6 = var2.indexOf("=", var6 + 1);
         var3 = var2.indexOf(";", var6 + 1);
         this.JDPJaggJdbcPassword = var2.substring(var6 + 1, var3);
      }

      this.jaggSQL = new JDPJagg(this.JDPJaggPath);
      this.jaggSQL.setSystem(var1);
      this.jaggSQL.setDSN(this.JDPJaggDSN);
      this.jaggSQL.setCSTR(this.JDPJaggCSTR);
      this.jaggSQL.setJdbcDriver(this.JDPJaggJdbcDriver);
      this.jaggSQL.setJdbcPrefix(this.JDPJaggJdbcPrefix);
      this.jaggSQL.setJdbcSuffix(this.JDPJaggJdbcSuffix);
      this.jaggSQL.setUID(this.JDPJaggJdbcUserid);
      this.jaggSQL.setPWD(this.JDPJaggJdbcPassword);
      this.jaggSQL.loadJdbcDataSources();
      Vector var7 = new Vector();
      int var9;
      if (this.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         String var8 = "SELECT Description,JDP:bfontname,JDP:bfontsize,JDP:pfontname, " + "JDP:pfontsize,JDP:versionnum, JDP:jlanguage, JDP:country, JDP:dateformat " + "FROM JDesignerPro System WHERE JDP:JDPSystem = '" + var1 + "'";
         var9 = this.jaggSQL.execSQL(var8, var7);
         this.jaggSQL.setFCTN("");
      } else {
         String var36 = "SELECT JDPSystemD,bfontname,bfontsize,pfontname, " + "pfontsize,versionnum, jlanguage, country, dateformat " + "FROM JDPSystemDef WHERE JDPSystem = '" + var1 + "'";
         var9 = this.jaggSQL.execSQL(var36, var7);
      }

      if (var9 < 0 || this.NDSPath != null && var9 == 0) {
         if (this.user == null) {
            this.user = new JDPUser[1];
            this.user[0] = new JDPUser();
         }

         this.user[0] = this.initUser(0);
         this.user[0].jaggSQL = this.jaggSQL;
         this.user[0].u = new JDPUtils(this.user[0]);
         this.user[0].mainmsg = new JDPStatusMessage(this.user[0]);
         this.performVersionUpdate();
         this.performNDSUpdate();
         var7 = new Vector();
         if (this.NDSPath != null) {
            this.jaggSQL.setFCTN("NDSexecSQL");
            String var37 = "SELECT Description,JDP:bfontname,JDP:bfontsize,JDP:pfontname, " + "JDP:pfontsize,JDP:versionnum, JDP:jlanguage, JDP:country, JDP:dateformat " + "FROM JDesignerPro System WHERE JDP:JDPSystem = '" + var1 + "'";
            var9 = this.jaggSQL.execSQL(var37, var7);
            this.jaggSQL.setFCTN("");
         } else {
            String var38 = "SELECT JDPSystemD,bfontname,bfontsize,pfontname, " + "pfontsize,versionnum, 'en', ' ', 'mm/dd/yy' " + "FROM JDPSystemDef WHERE JDPSystem = '" + var1 + "'";
            var9 = this.jaggSQL.execSQL(var38, var7);
         }
      }

      if (var9 < 0) {
         this.daysRemaining = 1;
      }

      String var10 = "\\";
      if (this.JDPCompiler.indexOf("/") >= 0) {
         var10 = "/";
      }

      if (JDPJagg.useJaggServer && this.JDPJaggDir == null) {
         this.getUnixDaysRemaining();
      }

      if (JDPJagg.useJaggServer && var9 > 0 && this.JDPJaggDir != null) {
         String var11 = this.JDPJaggDir + "JDPJagg.exe CheckLicense";
         Vector var12 = new Vector();
         this.jaggSQL.setFCTN("System");
         this.jaggSQL.setFCTNP("");
         int var13 = this.jaggSQL.execSQL(var11, var12);
         this.daysRemaining = var13;
         this.jaggSQL.setFCTN("");
         if (var13 <= 0) {
            System.out.println(this.jaggSQL.getError());
            var9 = -1;
            this.daysRemaining = 0;
         }
      }

      if (!JDPJagg.useJaggServer) {
         this.getDaysRemaining();
      }

      if (this.daysRemaining > 90) {
         this.daysRemaining = 0;
         var9 = -1;
      }

      if (var9 != 1) {
         if (var9 < 0 && this.daysRemaining == 0) {
            this.boldFontName = "Helvetica";
            this.boldFontSize = 11;
            this.plainFontName = "Helvetica";
            this.plainFontSize = 11;
            this.versionnum = 0.0F;
            this.expired = true;
            this.loadExpiredMessage();
            this.JDPSystemDesc = "Trial period expired.";
            this.boldFontName = "Helvetica";
            this.boldFontSize = 11;
            this.plainFontName = "Helvetica";
            this.plainFontSize = 11;
            this.versionnum = 0.0F;
            this.expired = true;
            this.login = new JDPLogin(this, "Trial period expired.");
            this.login.mainmsg.setStatusMsg("Please purchase a license from BulletProof.", 0);
            return false;
         } else {
            this.jaggSQL.getError();
            if (JDPJagg.useJaggServer) {
               this.JDPSystemDesc = "Could not connect to JaggServer.";
            } else {
               this.JDPSystemDesc = "Could not connect to WebServer.";
            }

            this.boldFontName = "Helvetica";
            this.boldFontSize = 11;
            this.plainFontName = "Helvetica";
            this.plainFontSize = 11;
            this.versionnum = 0.0F;
            this.expired = true;
            this.login = new JDPLogin(this, this.JDPSystemDesc);
            if (JDPJagg.useJaggServer) {
               this.login.mainmsg.setStatusMsg("Check that JaggServer is running.", 0);
            } else {
               this.login.mainmsg.setStatusMsg("Check that WebServer is running.", 0);
            }

            return false;
         }
      } else {
         String var40 = new String(this.jaggSQL.getSEP());
         StringTokenizer var41 = new StringTokenizer((String)var7.elementAt(0));
         this.JDPSystemDesc = var41.nextToken(var40).trim();
         this.boldFontName = var41.nextToken(var40).trim();
         this.boldFontSize = Integer.parseInt(var41.nextToken(var40).trim());
         this.plainFontName = var41.nextToken(var40).trim();
         this.plainFontSize = Integer.parseInt(var41.nextToken(var40).trim());
         String var42 = var41.nextToken(var40).trim().replace('b', '0');
         this.versionnum = Float.valueOf(var42);
         this.language = var41.nextToken(var40).trim();
         this.country = var41.nextToken(var40).trim();
         dateFormat = var41.nextToken(var40).trim();
         this.login = new JDPLogin(this, this.JDPSystemDesc);
         return true;
      }
   }

   void setParms(String[] var1) {
      executable = true;

      try {
         if (Class.forName("JDPSplash") != null) {
            new JDPSplash();
         }
      } catch (Exception var2) {
      }

      SystemOutStream = new ByteArrayOutputStream();
      if (var1 != null) {
         if (var1.length >= 1) {
            this.wwwroot = var1[0];
         }

         if (var1.length >= 2) {
            this.JDPSystem = var1[1];
         }

         if (var1.length >= 3) {
            this.autoUsername = var1[2];
            this.autoPassword = "";
            if (var1.length >= 4) {
               this.autoPassword = var1[3];
               if (var1.length >= 5) {
                  this.JDPClassName = var1[4];
               }
            }
         }

      }
   }

   void performVersionUpdate() {
      new JDPVersionUpdate(this.user[0], 0.0F, 0.0F);
   }

   void getDaysRemaining() {
      this.jaggSQL.getSEP();
      this.jaggSQL.setFCTN("DaysRemaining");
      this.jaggSQL.setFCTNP("");
      Vector var1 = new Vector();
      this.daysRemaining = this.jaggSQL.execSQL("", var1);
      if (this.daysRemaining < 0) {
         this.daysRemaining = 0;
      }

      this.jaggSQL.setFCTN("");
   }

   void getUnixDaysRemaining() {
      this.jaggSQL.getSEP();
      this.jaggSQL.setFCTN("UnixDaysRemaining");
      this.jaggSQL.setFCTNP("");
      Vector var1 = new Vector();
      this.daysRemaining = this.jaggSQL.execSQL("", var1);
      if (this.daysRemaining < 0) {
         this.daysRemaining = 0;
      }

      this.jaggSQL.setFCTN("");
   }

   String getServerPlatform() {
      if (!JDPJagg.useJaggServer) {
         serverSeparator = "\\";
         serverPlatform = "Windows";
         return serverPlatform;
      } else {
         if (this.jaggSQL == null) {
            this.jaggSQL = new JDPJagg(this.JDPDomain);
         }

         this.jaggSQL.setSystem(this.JDPSystem);
         this.jaggSQL.setFCTN("GetPlatform");
         this.jaggSQL.setFCTNP("");
         Vector var1 = new Vector();
         int var2 = this.jaggSQL.execSQL("", var1);
         if (var2 < 0 && executable) {
            (new Thread(this)).start();

            try {
               Thread.sleep(1000L);
            } catch (Exception var3) {
            }

            var2 = this.jaggSQL.execSQL("", var1);
         }

         if (var2 >= 1) {
            serverSeparator = (String)var1.elementAt(0);
            serverPlatform = (String)var1.elementAt(1);
         }

         this.jaggSQL.setFCTN("");
         return serverPlatform;
      }
   }

   void loadLicenseWindow() {
      new JDPSetup(this, this.IniContents);
   }

   // $FF: renamed from: gc () void
   void method_0() {
      if (this.counter++ > 50) {
         if (this.field_0 == null) {
            this.field_0 = Runtime.getRuntime();
         }

         this.field_0.gc();
         System.runFinalization();
         System.gc();
         this.counter = 0;
      }

   }

   void validLogin() {
      if (executable && !System.getProperty("java.version").startsWith("1.0")) {
         PrintStream var1 = new PrintStream((OutputStream)SystemOutStream);
         System.setOut(var1);
         System.setErr(var1);
      }

      JDPUser var3 = this.initUser(0);
      this.wintitle = var3.JDPSystemDesc;
      var3.jaggSQL = this.jaggSQL;
      this.versionnum = Float.valueOf(actualversion.trim().replace('b', '0'));
      if (var3.loginMessage != null) {
         var3.loginMessage.setStatusMsg("Loading window...", 0);
      }

      if (this.JDPInWebPage != null) {
         this.user[0] = var3;
         ((Container)this).setLayout(new BorderLayout());
         ((Component)this).setBackground(JDPUtils.getControlColor());
         var3.popup = new JDPPopupComponent(var3, this);
         ((Container)this).add(var3.popup);
         var3.mainmsg = new JDPStatusMessage(var3);
         if (this.JDPClassName != null) {
            ((Container)this).add("Center", new JDPPanelLoader(var3, this.JDPClassName, this.JDPClassParameter, (boolean[])null, 0));
         } else {
            var3.jdpMenuPanel = new JDPTabSelectPanel(var3, var3.menu, "North");
            ((Container)this).add("Center", var3.jdpMenuPanel);
         }

         Panel var2 = new Panel();
         ((Container)var2).setLayout(new GridLayout(1, 1));
         ((Container)var2).add(var3.mainmsg);
         ((Container)this).add("South", var2);
         if (!JDPLicensed) {
            var3.mainmsg.eastMessage.setText("(Unlicensed)");
            var3.mainmsg.eastMessage.setForeground(Color.red);
         }

         ((Component)this).show();
         var3.serverListener.registerForRequest("JDPSystemMessage", this);
         ((Component)this).paintAll(((Component)this).getGraphics());
         this.remlogin();
      } else {
         var3.jdpMainWindow = new JDPMainWindow(var3, this.wintitle);
         this.remlogin();
         var3.jdpMainWindow.requestFocus();
      }

      ++this.userCount;
   }

   public static void main(String[] var0) {
      JDesignerPro var1 = new JDesignerPro();
      var1.setParms(var0);
      var1.init();
   }

   void performNDSUpdate() {
      new JDPSetupNDS(this.user[0], 0.0F, 0.0F);
   }

   void loadImages() {
      JDPImageLoader var1 = new JDPImageLoader((JDPUser)null, this, "Images/JDPICON.gif");
      (new Thread(var1)).start();
   }

   void licenseCheck() {
      this.jaggSQL.getSEP();
      this.jaggSQL.setFCTN("CheckLicense");
      this.jaggSQL.setFCTNP("");
      Vector var1 = new Vector();
      int var2 = this.jaggSQL.execSQL("", var1);
      this.jaggSQL.setFCTN("");
      if (var2 <= 0) {
         var2 = 100;
         String var3 = "\\";
         if (this.JDPCompiler.indexOf("/") >= 0) {
            var3 = "/";
         }

         if (JDPJagg.useJaggServer && this.JDPJaggDir == null) {
            var2 = 2;
         }

         JDPLicensed = false;
      } else {
         JDPLicensed = true;
      }
   }

   boolean loadExpiredMessage() {
      String var1 = "expired.html";
      String var2 = this.JDPDirectory + "Docs" + serverSeparator + var1;
      if (executable) {
         this.user = new JDPUser[1];
         this.user[0] = new JDPUser();
         this.user[0] = this.initUser(0);
         this.user[0].jaggSQL = new JDPJagg(this.JDPJaggPath);
         this.user[0].u = new JDPUtils(this.user[0]);
         this.user[0].mainmsg = new JDPStatusMessage(this.user[0]);
         String var9 = this.user[0].u.getRelatedAppPath(".html", "Please locate your browser application", true);
         if (var9 != null) {
            String var4 = var9 + " " + var2;

            try {
               Runtime var5 = Runtime.getRuntime();
               var5.exec(var4);
            } catch (Exception var7) {
               ((Throwable)var7).printStackTrace();
            }

            System.exit(0);
            return false;
         } else {
            return false;
         }
      } else {
         try {
            String var3 = this.wwwroot + "Docs/" + var1;
            ((Applet)this).getAppletContext().showDocument(new URL(var3));
         } catch (Exception var8) {
            ((Throwable)var8).printStackTrace();
         }

         return false;
      }
   }

   public void run() {
      System.out.println("Starting Enterprise Server in background...");
      JaggServer.jdesignerpro = this;
      new JaggServer(JDPJagg.getDefaultPort(), "sun.jdbc.odbc.JdbcOdbcDriver", "jdbc:odbc:");
   }

   public void init() {
      if (this.wwwroot == null) {
         this.wwwroot = ((Applet)this).getCodeBase().toString();
         this.JDPSystem = ((Applet)this).getParameter("JDPSystem");
         this.JDPInWebPage = ((Applet)this).getParameter("JDPInWebPage");
         this.autoUsername = ((Applet)this).getParameter("JDPUsername");
         this.autoPassword = ((Applet)this).getParameter("JDPPassword");
         this.JDPClassName = ((Applet)this).getParameter("JDPClassName");
         this.JDPClassParameter = ((Applet)this).getParameter("JDPClassParameter");
      }

      if (this.JDPClassParameter == null) {
         this.JDPClassParameter = "";
      }

      JDPUser.classactivated = true;
      JDPButton.thisJDP = this;
      JDPTreePicker.thisJDP = this;
      JDPBrowser.activated = true;
      this.field_0 = Runtime.getRuntime();

      try {
         if ((!System.getProperty("java.vendor").startsWith("Netscape") || System.getProperty("java.version").compareTo("1.1.2") > 0) && !System.getProperty("os.name").startsWith("Mac") && !System.getProperty("java.version").startsWith("1.0")) {
            JDPSystemColor.loadColors();
         }
      } catch (Exception var1) {
      }

      this.loadImages();
      if (this.checkSetup(this.JDPSystem, this.JDPJaggSetup, this.wwwroot)) {
         if (this.JDPClassName != null) {
         }

      }
   }

   public boolean handleEvent(Event var1) {
      if (this.exitapplet) {
         return true;
      } else {
         switch (var1.id) {
            case 201:
               JDPJagg.cleanUp();
               if (executable) {
                  System.exit(0);
               }

               return true;
            case 1001:
               if (var1.target.equals(this.user[0].serverListener)) {
                  String var2 = (String)var1.arg;
                  StringTokenizer var3 = new StringTokenizer(var2, "|");
                  var3.nextToken();
                  String var4 = var3.nextToken();
                  String var5 = var3.nextToken();
                  String var6 = var3.nextToken();
                  String var7 = var3.nextToken();
                  this.displayMessage(this.user[0], "Message from " + var4, var5, var6, var7);
                  return true;
               }

               return false;
            default:
               return false;
         }
      }
   }

   void remlogin() {
      if (this.login != null) {
         this.login.dispose();
      }

      this.login = null;
   }

   void loadAppletContext() {
      this.saveAppletContext = ((Applet)this).getAppletContext();
   }

   String loadIniFile(String var1, String var2) {
      Object var4 = null;
      String var6 = "";

      try {
         String var7 = var1 + "JDesignerPro.ini";
         InputStream var12;
         if (!executable) {
            URL var3 = new URL(var7);
            var12 = var3.openStream();
         } else {
            FileInputStream var8 = new FileInputStream("JDesignerPro.ini");
            var12 = (InputStream)var8;
         }

         DataInputStream var5 = new DataInputStream(var12);

         for(String var13 = var5.readLine(); var13 != null; var13 = var5.readLine()) {
            if (var13.length() > 10) {
               if (var13.length() > 5 && var13.substring(0, 5).compareTo(var2) == 0) {
                  int var9 = var13.indexOf("JAGGSERVER=Server");
                  if (var9 > 0) {
                     JDPJagg.useJaggServer = true;
                     var13 = var13.substring(0, var9) + var13.substring(var9 + 17);
                  } else {
                     var9 = var13.indexOf("JAGGSERVER=CGI");
                     if (var9 > 0) {
                        JDPJagg.useJaggServer = false;
                        var13 = var13.substring(0, var9) + var13.substring(var9 + 14);
                     }
                  }

                  var6 = var13.substring(5);
               }

               if (var13.substring(0, 7).compareTo("DOMAIN=") == 0) {
                  this.JDPDomain = this.addDelimiter(var13.substring(7));
                  if (executable && var1.equals("")) {
                     this.wwwroot = this.JDPDomain + "JDesignerPro/";
                  }
               }

               if (var13.substring(0, 7).compareTo("JDPDIR=") == 0) {
                  this.JDPDirectory = this.addDelimiter(var13.substring(7));
               }

               if (var13.substring(0, 8).compareTo("JAGGDIR=") == 0) {
                  this.JDPJaggDir = this.addDelimiter(var13.substring(8));
               }

               if (var13.substring(0, 9).compareTo("COMPILER=") == 0) {
                  this.JDPCompiler = var13.substring(9);
               }

               if (var13.substring(0, 8).compareTo("CLASSES=") == 0) {
                  this.JDPClasses = var13.substring(8);
               }

               if (var13.substring(0, 8).compareTo("NDSPATH=") == 0 && var13.length() > 8) {
                  this.NDSPath = var13.substring(8);
               }

               if (var13.substring(0, 11).compareTo("JAGGSERVER=") == 0) {
                  this.JDPJaggServer = var13.substring(11);
                  if (this.JDPJaggServer.indexOf("CGI") >= 0) {
                     JDPJagg.useJaggServer = false;
                  }

                  if (this.JDPJaggServer.indexOf("Server") >= 0) {
                     JDPJagg.useJaggServer = true;
                  }

                  if (this.JDPJaggServer.indexOf("Local") >= 0) {
                     JDPJagg.useJaggServer = true;
                  }
               }

               if (var13.length() > 15 && var13.substring(0, 15).compareTo("JAGGSERVERPORT=") == 0) {
                  JDPJagg.setDefaultPort(Integer.parseInt(var13.substring(15)));
               }
            }
         }

         var12.close();
         JDPJagg.activated = true;
         JDPJagg.version = version;
         return var6;
      } catch (Exception var11) {
         ((Throwable)var11).printStackTrace();
         System.out.println("Could not open JDesignerPro.ini file.");
         System.out.println("Check that ini file is in the JDesignerPro directory.");
         return null;
      }
   }
}
