import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

public class NextAvailableNum extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPScrollPanel ScrollPanel1;
   Button Button1;
   TextField TextField1;
   Label Label1;
   JDPRMIConnection RMIConnection1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Button1 = new Button("Press to get the next available number");
      this.TextField1 = new TextField("", 20);
      this.Label1 = new Label("This demo uses JDesignerPro's lightweight RMI to get a number from the NextAvailableNumber Entity on the server", 0);
      this.RMIConnection1 = new JDPRMIConnection(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Button1);
      this.ScrollPanel1.add("Left", this.TextField1);
      this.Main.add("North", this.Label1);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.Button1)) {
               int[] var2 = this.RMIConnection1.getJobsForName("NextAvailableNumber");
               if (var2.length == 0) {
                  this.startJob();
               }

               var2 = this.RMIConnection1.getJobsForName("NextAvailableNumber");
               if (var2.length > 0) {
                  Integer var3 = (Integer)this.RMIConnection1.invokeByJobNumber(var2[0], "getNextAvailableNumber");
                  if (var3 != null) {
                     this.TextField1.setText(var3.toString());
                  } else {
                     this.user.mainmsg.setStatusMsg("Could not get next available number. Check that NextAvailableNumber job is running on server", 15);
                  }
               } else {
                  this.user.mainmsg.setStatusMsg("Could not get next available number. Check that NextAvailableNumber job is running on server", 15);
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void startJob() {
      String var1 = this.RMIConnection1.submitJob("QIMMED", "NextAvailableNumber", "C", "NextAvailableNumberEntity", "(JDPSubsystemMgr,JDPJob)", "JDPSubsystemMgr,JDPJob", 5, 5, false, -1, "", "", "B");
      if (var1 == null) {
         this.user.mainmsg.setStatusMsg("Job submission failed.", 10);
      } else if (var1.startsWith("Jobnumber:")) {
         this.user.mainmsg.setStatusMsg("NextAvailableNumber job submitted to QIMMED.", 10);
      } else {
         this.user.mainmsg.setStatusMsg(var1, 20);
      }

      try {
         Thread.sleep(3000L);
      } catch (Exception var2) {
      }
   }
}
