import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

public class ReceiveServerPush extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   Label Label1;
   Panel Panel1;
   Panel Panel3;
   JDPScrollPanel ScrollPanel1;
   JDPButton JDPButton2;
   JDPScrollPanel ScrollPanel2;
   Label Label3;
   TextField dataReceived;
   JDPServerListener MessageReceiver1;
   JDPRMIConnection RMIConnection1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.Label1 = new Label("This example demostrates using server push to send a message to a JDP client", 0);
      this.Panel1 = new Panel();
      this.Panel3 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.JDPButton2 = new JDPButton("Press to register to receive requests of type 'ServerPushTest'", JDPButton.getAlignmentValue("Center"));
      this.ScrollPanel2 = new JDPScrollPanel();
      this.Label3 = new Label("Data received from ServerPushEntity:", 0);
      this.dataReceived = new TextField("", 26);
      this.MessageReceiver1 = var1.serverListener;
      this.RMIConnection1 = new JDPRMIConnection(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("North", this.Label1);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("North", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.JDPButton2);
      this.Panel3.add("Center", this.ScrollPanel2);
      this.ScrollPanel2.add("Left", this.Label3);
      this.ScrollPanel2.add("Right", this.dataReceived);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButton2)) {
               this.startJob();
               this.MessageReceiver1.registerForRequest("ServerPushTest", this);
               this.user.mainmsg.setStatusMsg("Registration complete", 10);
               return true;
            } else {
               if (var1.target.equals(this.MessageReceiver1)) {
                  if (var1.arg instanceof String) {
                     String var2 = (String)var1.arg;
                     if (var2.startsWith("ServerPushTest")) {
                        var2 = var2.substring(var2.indexOf("|") + 1);
                        this.dataReceived.setText(var2);
                     }
                  }

                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void startJob() {
      int[] var1 = this.RMIConnection1.getJobsForName("ServerPushEntity");
      if (var1.length <= 0) {
         String var2 = this.RMIConnection1.submitJob("QIMMED", "ServerPushEntity", "C", "ServerPushEntity", "(JDPSubsystemMgr,JDPJob)", "JDPSubsystemMgr,JDPJob", 5, 5, false, -1, "", "", "B");
         if (var2 == null) {
            this.user.mainmsg.setStatusMsg("Job submission failed.", 10);
         } else if (var2.startsWith("Jobnumber:")) {
            this.user.mainmsg.setStatusMsg("ServerPushEntity job submitted to QIMMED.", 10);
         } else {
            this.user.mainmsg.setStatusMsg(var2, 20);
         }

         try {
            Thread.sleep(3000L);
         } catch (Exception var3) {
         }
      }
   }
}
