import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class SalesMasterDetail extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel MasterDetail1;
   Panel Panel1;
   Panel Panel2;
   JDPScrollPanel ScrollPanel1;
   Label stor_idLabel1;
   TextField b_stor_id1;
   Label stor_nameLabel1;
   TextField b_stor_name1;
   Label stor_addressLabel1;
   TextField b_stor_address1;
   Label cityLabel1;
   Panel cityLine1;
   TextField b_city1;
   TextField b_state1;
   TextField b_zip1;
   Label ord_numLabel1;
   TextField a_ord_num1;
   Label ord_dateLabel1;
   JDPDate a_ord_date1;
   JDPTextGrid MasterDetail1GL1;
   JDPButtons JDPButtons1;
   Panel Panel3;
   JDPWhereClause MasterDetail1SP1;
   JDPSearchResults MasterDetail1RL1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Sales Detail Inquiry");
      this.MasterDetail1 = new Panel();
      this.Panel1 = new Panel();
      this.Panel2 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.stor_idLabel1 = new Label("Store Id:", 0);
      this.b_stor_id1 = new TextField("b.stor_id", 6);
      this.stor_nameLabel1 = new Label("Name:", 0);
      this.b_stor_name1 = new TextField("b.stor_name", 42);
      this.stor_addressLabel1 = new Label("Address:", 0);
      this.b_stor_address1 = new TextField("b.stor_address", 42);
      this.cityLabel1 = new Label("", 0);
      this.cityLine1 = new Panel();
      this.b_city1 = new TextField("b.city", 22);
      this.b_state1 = new TextField("b.state", 4);
      this.b_zip1 = new TextField("b.zip", 7);
      this.ord_numLabel1 = new Label("Order Number:", 0);
      this.a_ord_num1 = new TextField("a.ord_num", 20);
      this.ord_dateLabel1 = new Label("Order Date:", 0);
      this.a_ord_date1 = new JDPDate(var1, "", 19);
      this.MasterDetail1GL1 = new JDPTextGrid(var1);
      String[] var4 = new String[]{"Apply", "Refresh", "Remove"};
      int[] var5 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("Undo"), JDPButton.getIconValue("Delete")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Panel3 = new Panel();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.MasterDetail1);
      this.MasterDetail1.setLayout(new BorderLayout());
      this.MasterDetail1Main();
      this.MasterDetail1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("North", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.stor_idLabel1);
      this.ScrollPanel1.add("Right", this.b_stor_id1);
      this.ScrollPanel1.add("Left", this.stor_nameLabel1);
      this.ScrollPanel1.add("Right", this.b_stor_name1);
      this.ScrollPanel1.add("Left", this.stor_addressLabel1);
      this.ScrollPanel1.add("Right", this.b_stor_address1);
      this.ScrollPanel1.add("Left", this.cityLabel1);
      this.ScrollPanel1.add("Right", this.cityLine1);
      this.cityLine1.setLayout(new JDPLineLayout());
      this.cityLine1.add("Left", this.b_city1);
      this.cityLine1.add("Left", this.b_state1);
      this.cityLine1.add("Left", this.b_zip1);
      this.ScrollPanel1.add("Left", this.ord_numLabel1);
      this.ScrollPanel1.add("Right", this.a_ord_num1);
      this.ScrollPanel1.add("Left", this.ord_dateLabel1);
      this.ScrollPanel1.add("Right", this.a_ord_date1);
      this.Panel1.add("Center", this.MasterDetail1GL1);
      this.Panel1.add("South", this.JDPButtons1);
      this.MasterDetail1.add("West", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("North", this.MasterDetail1SP1);
      this.Panel3.add("Center", this.MasterDetail1RL1);
      this.stor_idLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_stor_id1.setEditable(false);
      this.popuppanel.addComponent(this.b_stor_id1, "Stor Id", "");
      this.b_stor_id1.setEditable(false);
      this.stor_nameLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_stor_name1.setEditable(false);
      this.popuppanel.addComponent(this.b_stor_name1, "Stor name", "");
      this.b_stor_name1.setEditable(false);
      this.stor_addressLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_stor_address1.setEditable(false);
      this.popuppanel.addComponent(this.b_stor_address1, "Stor Address", "");
      this.b_stor_address1.setEditable(false);
      this.cityLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_city1.setEditable(false);
      this.popuppanel.addComponent(this.b_city1, "City", "");
      this.b_city1.setEditable(false);
      this.b_state1.setEditable(false);
      this.popuppanel.addComponent(this.b_state1, "State", "");
      this.b_state1.setEditable(false);
      this.b_zip1.setEditable(false);
      this.popuppanel.addComponent(this.b_zip1, "Zip", "");
      this.b_zip1.setEditable(false);
      this.ord_numLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.a_ord_num1, "Ord Num", "");
      this.ord_dateLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.a_ord_date1, "Ord Date", "");
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.b_stor_id1)) {
                  this.user.u.cursor(this.b_stor_name1);
                  return true;
               }

               if (var1.target.equals(this.b_stor_name1)) {
                  this.user.u.cursor(this.b_stor_address1);
                  return true;
               }

               if (var1.target.equals(this.b_stor_address1)) {
                  this.user.u.cursor(this.b_city1);
                  return true;
               }

               if (var1.target.equals(this.b_city1)) {
                  this.user.u.cursor(this.b_state1);
                  return true;
               }

               if (var1.target.equals(this.b_state1)) {
                  this.user.u.cursor(this.b_zip1);
                  return true;
               }

               if (var1.target.equals(this.b_zip1)) {
                  this.user.u.cursor(this.a_ord_num1);
                  return true;
               }

               if (var1.target.equals(this.a_ord_num1)) {
                  this.user.u.cursor(this.a_ord_date1);
                  return true;
               }

               if (var1.target.equals(this.a_ord_date1)) {
                  this.user.u.cursor(this.b_stor_id1);
                  return true;
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.b_stor_id1)) {
                  this.user.u.cursor(this.a_ord_date1);
                  return true;
               }

               if (var1.target.equals(this.b_stor_name1)) {
                  this.user.u.cursor(this.b_stor_id1);
                  return true;
               }

               if (var1.target.equals(this.b_stor_address1)) {
                  this.user.u.cursor(this.b_stor_name1);
                  return true;
               }

               if (var1.target.equals(this.b_city1)) {
                  this.user.u.cursor(this.b_stor_address1);
                  return true;
               }

               if (var1.target.equals(this.b_state1)) {
                  this.user.u.cursor(this.b_city1);
                  return true;
               }

               if (var1.target.equals(this.b_zip1)) {
                  this.user.u.cursor(this.b_state1);
                  return true;
               }

               if (var1.target.equals(this.a_ord_num1)) {
                  this.user.u.cursor(this.b_zip1);
                  return true;
               }

               if (var1.target.equals(this.a_ord_date1)) {
                  this.user.u.cursor(this.a_ord_num1);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.MasterDetail1UpdateRows(this.MasterDetail1RL1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               this.MasterDetail1LoadGrid(this.MasterDetail1RL1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[2])) {
               this.MasterDetail1DeleteRows(this.MasterDetail1RL1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.MasterDetail1SP1)) {
               this.MasterDetail1RL1.clearList();
               this.MasterDetail1RL1.setFromWhereClause(this.MasterDetail1SP1.getFromWhereClause());
               this.MasterDetail1RL1.loadList();
               return true;
            } else {
               if (var1.target.equals(this.MasterDetail1RL1)) {
                  this.MasterDetail1Load(this.MasterDetail1RL1.getSelectedKey());
                  this.MasterDetail1LoadGrid(this.MasterDetail1RL1.getSelectedKey());
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void MasterDetail1Main() {
      this.MasterDetail1ClearFields();
      this.MasterDetail1SetGridSettings();
      this.MasterDetail1LoadChoices();
      this.MasterDetail1WhereClauseMain();
      this.MasterDetail1SearchResultsMain();
   }

   public void MasterDetail1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var7 = "SELECT a.ord_num,a.ord_date,b.stor_id,b.stor_name,b.stor_address,b.city,b.state,b.zip FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)";
         if (var1.length > 0 && var1[0] != null) {
            var7 = var7 + " AND a.stor_id='" + var1[0] + "'";
         }

         if (var1.length > 1 && var1[1] != null) {
            var7 = var7 + " AND a.ord_num='" + var1[1] + "'";
         }

         if (var1.length > 2 && var1[2] != null) {
            var7 = var7 + " AND a.title_id='" + var1[2] + "'";
         }

         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
         var3 = this.jaggSQL.execSQL(var7, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var7);
         } else if (var3 >= 1) {
            String var6 = (String)var4.elementAt(0);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var6, var5);
               this.a_ord_num1.setText(var2.nextToken().trim());
               this.a_ord_date1.setText(JDPDate.format(Long.valueOf(var2.nextToken())));
               this.b_stor_id1.setText(var2.nextToken().trim());
               this.b_stor_name1.setText(var2.nextToken().trim());
               this.b_stor_address1.setText(var2.nextToken().trim());
               this.b_city1.setText(var2.nextToken().trim());
               this.b_state1.setText(var2.nextToken().trim());
               this.b_zip1.setText(var2.nextToken().trim());
            }

            if (var3 > 1) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message1"), 10);
            } else {
               this.user.mainmsg.clearStatusMsg();
            }
         } else {
            this.user.mainmsg.setStatusMsg(JDPLang.get("Message2"), 10);
            this.MasterDetail1ClearFields();
         }
      } else {
         this.MasterDetail1ClearFields();
      }
   }

   public void MasterDetail1ClearFields() {
      this.a_ord_num1.setText("");
      this.a_ord_date1.setText("");
      this.b_stor_id1.setText("");
      this.b_stor_name1.setText("");
      this.b_stor_address1.setText("");
      this.b_city1.setText("");
      this.b_state1.setText("");
      this.b_zip1.setText("");
   }

   public boolean MasterDetail1CheckFields() {
      return true;
   }

   public void MasterDetail1LoadGridFromWhereClause(String var1) {
      int var2 = var1.indexOf("WHERE ");
      var1 = " AND" + var1.substring(var2 + 5);
      String[] var3 = new String[0];
      this.MasterDetail1LoadGridMain(var3, var1);
   }

   public void MasterDetail1LoadGrid(String[] var1) {
      this.MasterDetail1LoadGridMain(var1, (String)null);
   }

   void MasterDetail1LoadGridMain(String[] var1, String var2) {
      JDPTextGrid var3 = this.MasterDetail1GL1;
      int var5 = 0;
      Vector var6 = new Vector();
      String var7 = this.jaggSQL.getSEP();
      int var8 = 0;
      byte var10 = 3;
      new Vector();
      new Vector();
      String var11 = "SELECT a.stor_id, a.ord_num, a.title_id, a.title_id, a.qty, a.payterms FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)  ";
      if (var1.length > 0 && var1[0] != null) {
         var11 = var11 + " AND a.stor_id='" + var1[0] + "'";
      }

      if (var1.length > 1 && var1[1] != null) {
         var11 = var11 + " AND a.ord_num='" + var1[1] + "'";
      }

      if (var1.length > 2 && var1[2] != null) {
         var11 = var11 + " AND a.title_id='" + var1[2] + "'";
      }

      if (var2 != null) {
         var11 = var11 + var2;
      }

      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      var5 = this.jaggSQL.execSQL(var11, var6);
      if (var5 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var11);
      } else {
         var3.totalDataRows = this.jaggSQL.getRowCount();
         var8 = this.jaggSQL.getRowCount() + 20;
         var3.currentText = new String[var10][var8];
         var3.cellChanged = null;
         var3.rowChanged = null;
         var3.columnSelected = null;
         byte var12 = 3;
         var3.rowKey = new String[var8][var12];
         var3.recordLockValue = new String[var8];

         for(int var14 = 0; var14 < var8 - 20; ++var14) {
            String var9 = (String)var6.elementAt(var14);
            if (var9 != null && var9.trim().compareTo("") != 0) {
               StringTokenizer var4 = new StringTokenizer(var9, var7);

               for(int var15 = 0; var15 < var12; ++var15) {
                  var3.rowKey[var14][var15] = var4.nextToken().trim();
               }

               for(int var16 = 0; var16 < var10; ++var16) {
                  String var13 = var4.nextToken().trim();
                  var3.currentText[var16][var14] = var13;
                  if (var16 == 0 && var3.pullDownValue[0][0].indexOf(var13) >= 0) {
                     var3.currentText[var16][var14] = var3.pullDownList[0][0].getItem(var3.pullDownValue[0][0].indexOf(var13));
                  }

                  if (var16 == 2 && var3.pullDownValue[2][0].indexOf(var13) >= 0) {
                     var3.currentText[var16][var14] = var3.pullDownList[2][0].getItem(var3.pullDownValue[2][0].indexOf(var13));
                  }
               }
            }
         }

         for(int var19 = var8 - 20; var19 < var8; ++var19) {
            for(int var20 = 0; var20 < var1.length; ++var20) {
               var3.rowKey[var19][var20] = var1[var20];
            }
         }

         var3.newTable();
         this.user.mainmsg.clearStatusMsg();
      }
   }

   public void MasterDetail1UpdateRowsFromWhereClause(String var1) {
      int var2 = var1.indexOf("WHERE ");
      var1 = " AND" + var1.substring(var2 + 5);
      String[] var3 = new String[0];
      this.MasterDetail1UpdateRowsMain(var3, var1);
   }

   public void MasterDetail1UpdateRows(String[] var1) {
      this.MasterDetail1UpdateRowsMain(var1, (String)null);
   }

   void MasterDetail1UpdateRowsMain(String[] var1, String var2) {
      JDPTextGrid var3 = this.MasterDetail1GL1;
      int var4 = 0;
      int var5 = 0;
      int var6 = 1;
      int var7 = 1;
      boolean var8 = false;

      for(int var9 = 0; var9 < var3.rowChanged.length; ++var9) {
         if (var3.rowChanged[var9]) {
            if (var9 >= var3.totalDataRows) {
               ++var5;
            } else {
               ++var4;
            }
         }
      }

      for(int var10 = 0; var10 < var3.rowChanged.length; ++var10) {
         if (var3.rowChanged[var10]) {
            if (var10 >= var3.totalDataRows) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message7", var7++, var5), 0);
               this.MasterDetail1SaveData(var10, "I");
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message8", var6++, var4), 0);
               if (this.MasterDetail1SaveData(var10, "U")) {
                  var8 = true;
               }
            }

            var3.rowChanged[var10] = false;
         }
      }

      if (var5 > 0 || var8) {
         this.MasterDetail1LoadGridMain(var1, var2);
      }

   }

   public void MasterDetail1DeleteRowsFromWhereClause(String var1) {
      int var2 = var1.indexOf("WHERE ");
      var1 = " AND" + var1.substring(var2 + 5);
      String[] var3 = new String[0];
      this.MasterDetail1DeleteRowsMain(var3, var1);
   }

   public void MasterDetail1DeleteRows(String[] var1) {
      this.MasterDetail1DeleteRowsMain(var1, (String)null);
   }

   void MasterDetail1DeleteRowsMain(String[] var1, String var2) {
      JDPTextGrid var3 = this.MasterDetail1GL1;
      int var4 = 0;
      int var5 = 1;

      for(int var6 = 0; var6 < var3.rowChanged.length; ++var6) {
         if (var3.rowSelected[var6]) {
            ++var4;
         }
      }

      for(int var7 = 0; var7 < var3.rowChanged.length; ++var7) {
         if (var3.rowSelected[var7]) {
            this.user.mainmsg.setStatusMsg(JDPLang.get("Message9", var5++, var4), 0);
            this.MasterDetail1SaveData(var7, "D");
         }
      }

      if (var4 > 0) {
         this.MasterDetail1LoadGridMain(var1, var2);
      }

   }

   boolean MasterDetail1SaveData(int var1, String var2) {
      JDPTextGrid var3 = this.MasterDetail1GL1;
      int var4 = 0;
      Vector var5 = new Vector();
      this.jaggSQL.getSEP();
      String var6 = "";
      String var7 = null;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      if (var2.equals("I")) {
         var6 = "INSERT INTO dbo_sales (stor_id, ord_num, title_id, qty, payterms, ord_date) VALUES('" + var3.rowKey[var1][0] + "', " + "'" + var3.rowKey[var1][1] + "', " + "'" + (String)var3.pullDownValue[0][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[0][0], var3.currentText[0][var1])) + "', " + "" + JDPUtils.tonum(var3.currentText[1][var1]) + ", " + "'" + (String)var3.pullDownValue[2][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[2][0], var3.currentText[2][var1])) + "', " + "'" + JDPDate.format("") + "')";
      } else if (var2.equals("D")) {
         var6 = "DELETE FROM dbo_sales WHERE stor_id='" + var3.rowKey[var1][0] + "'" + " AND ord_num='" + var3.rowKey[var1][1] + "'" + " AND title_id='" + var3.rowKey[var1][2] + "'";
         if (var3.recordLockValue[var1] != null) {
            var7 = var6;
         }
      } else {
         var6 = "UPDATE dbo_sales SET qty = " + JDPUtils.tonum(var3.currentText[1][var1]) + ", " + "payterms = '" + (String)var3.pullDownValue[2][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[2][0], var3.currentText[2][var1])) + "'" + " WHERE stor_id='" + var3.rowKey[var1][0] + "'" + " AND ord_num='" + var3.rowKey[var1][1] + "'" + " AND title_id='" + var3.rowKey[var1][2] + "'";
         if (var3.recordLockValue[var1] != null) {
            var7 = var6;
         }
      }

      var4 = this.jaggSQL.execSQL(var6, var5);
      if (this.user.DEBUG) {
         System.out.println("saveData CNT: " + Integer.toString(var4));
      }

      if (var4 == 0 && var7 != null) {
         String[] var8 = new String[]{"Reload", "Update"};
         int[] var9 = new int[]{6, 0};
         JDPMessageDialog var10 = new JDPMessageDialog(this.user, this.user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), var8, var9);
         ((JDPDialog)var10).display();
         if (var10.getPressedButton() != 1) {
            return true;
         }

         var5 = new Vector();
         var4 = this.jaggSQL.execSQL(var7, var5);
      }

      if (var4 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var6);
         return false;
      } else {
         if (var4 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message4"), 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message5"), 3);
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message6"), 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var6);
         }

         return var7 != null;
      }
   }

   public void MasterDetail1LoadEmptyGrid() {
      JDPTextGrid var1 = this.MasterDetail1GL1;
      byte var2 = 3;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void MasterDetail1SetGridSettings() {
      if (this.MasterDetail1 == null) {
         this.MasterDetail1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.MasterDetail1GL1;
      byte var2 = 3;
      var1.columnHeader = new String[var2];
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[0] = true;
      var1.columnProtected[2] = true;
      var1.columnWidth[0] = 307;
      var1.columnWidth[1] = 52;
      var1.columnWidth[2] = 100;
      var1.rightJustify[1] = true;
      var1.columnHeader[0] = "Title";
      var1.columnHeader[1] = "Quantity";
      var1.columnHeader[2] = "Terms";
      this.MasterDetail1LoadEmptyGrid();
   }

   void MasterDetail1LoadChoices() {
      JDPTextGrid var1 = this.MasterDetail1GL1;
      byte var2 = 3;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      var1.isPullDownCol = new boolean[var2];
      var1.pullDownColType = new int[var2];
      var1.pullDownList = new List[var2][1];
      var1.isPullDownCol[0] = true;
      var1.isPullDownCol[2] = true;
      var1.pullDownColType[0] = 0;
      var1.pullDownColType[2] = 0;
      var1.pullDownList[0][0] = new List();
      var1.pullDownList[2][0] = new List();
      var1.pullDownValue[2][0] = new Vector();
      var1.pullDownList[2][0].addItem("Net 30");
      var1.pullDownValue[2][0].addElement("Net 30");
      var1.pullDownList[2][0].addItem("Net 60");
      var1.pullDownValue[2][0].addElement("Net 60");
      var1.pullDownList[2][0].addItem("ON invoice");
      var1.pullDownValue[2][0].addElement("ON invoice");
      var1.pullDownValue[0][0] = new Vector();
      new JDPLoadChoice(this.user, this.jaggSQL, var1.pullDownList[0][0], "title", "title_id", "dbo_titles", "(1=1)", var1.pullDownValue[0][0]);
   }

   public void MasterDetail1WhereClauseMain() {
      String[] var1 = new String[3];
      String[] var2 = new String[3];
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      var1[0] = "Order Num";
      var2[0] = "a.ord_num";
      var1[1] = "Store name";
      var2[1] = "b.stor_name";
      var1[2] = "Store Address";
      var2[2] = "b.stor_address";
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      ((Vector)var3.elementAt(0)).addElement("Begins with");
      ((Vector)var4.elementAt(0)).addElement("like");
      ((Vector)var3.elementAt(0)).addElement("Contains");
      ((Vector)var4.elementAt(0)).addElement("like");
      ((Vector)var3.elementAt(1)).addElement("Begins with");
      ((Vector)var4.elementAt(1)).addElement("like");
      ((Vector)var3.elementAt(1)).addElement("Contains");
      ((Vector)var4.elementAt(1)).addElement("like");
      ((Vector)var3.elementAt(2)).addElement("Begins with");
      ((Vector)var4.elementAt(2)).addElement("like");
      ((Vector)var3.elementAt(2)).addElement("Contains");
      ((Vector)var4.elementAt(2)).addElement("like");
      int[] var5 = new int[3];
      boolean[] var6 = new boolean[3];
      var5[0] = 22;
      var6[0] = true;
      var5[1] = 44;
      var6[1] = true;
      var5[2] = 44;
      var6[2] = true;
      this.MasterDetail1SP1 = new JDPWhereClause(this.user, super.targetPanel, "", true, "", var1, var2, var3, var4, (String[][])null, (String[][])null, var5, var6, "FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)");
      this.MasterDetail1SP1.setDSNType("ACCESS");
      this.MasterDetail1SP1.setDataType(0, 12);
      this.MasterDetail1SP1.setDataType(1, 12);
      this.MasterDetail1SP1.setDataType(2, 12);
   }

   public void MasterDetail1SearchResultsMain() {
      String var1 = "a.stor_id,a.ord_num";
      String[] var2 = new String[]{"a.ord_num"};
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Stor name", "Stor Address"};
      String[] var5 = new String[]{"b.stor_name", "b.stor_address"};
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.setDSN("JDP Tutorial");
      var6.setUID("");
      var6.setPWD("");
      var6.setMRW("1000");
      var6.setTOUT("60");
      this.MasterDetail1RL1 = new JDPSearchResults(this.user, super.targetPanel, true, var6, false, var1, var2, var3, var4, var5, var5, "", true, "Total Entries:");
      int[] var7 = new int[14];
      var7[0] = 3;
      var7[1] = 5;
      var7[2] = 8;
      this.MasterDetail1RL1.setMinWidth(130);
      this.MasterDetail1RL1.setIcons(var7);
      this.MasterDetail1RL1.setFromWhereClause(" FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)");
      this.MasterDetail1RL1.clearList("");
      this.MasterDetail1RL1.loadList();
   }
}
