import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

public class SalesReportClient extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPScrollPanel ScrollPanel1;
   Label Label2;
   TextField mailServer;
   Label Label3;
   TextField toAddress;
   Label Label4;
   TextField returnAddress;
   Label Label1;
   JDPButtons JDPButtons1;
   JDPRMIConnection RMIConnection1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label2 = new Label("Mail Server Name:", 0);
      this.mailServer = new TextField("mail", 20);
      this.Label3 = new Label("Recipient Email Address:", 0);
      this.toAddress = new TextField("", 20);
      this.Label4 = new Label("Sender's Email Address:", 0);
      this.returnAddress = new TextField("", 20);
      this.Label1 = new Label("This example demonstrates the use of a Server Session Bean that sends a email sales report to an end user", 0);
      String[] var4 = new String[]{"Send"};
      int[] var5 = new int[]{JDPButton.getIconValue("Email")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.RMIConnection1 = new JDPRMIConnection(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.mailServer);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.toAddress);
      this.ScrollPanel1.add("Left", this.Label4);
      this.ScrollPanel1.add("Right", this.returnAddress);
      this.Main.add("North", this.Label1);
      this.Main.add("South", this.JDPButtons1);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.submitReportJob();
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void submitReportJob() {
      String var1 = "JDPSubsystemMgr,JDPJob,";
      var1 = var1 + this.mailServer.getText() + ",";
      var1 = var1 + this.toAddress.getText() + ",";
      var1 = var1 + this.returnAddress.getText();
      String var2 = this.RMIConnection1.submitJob("QIMMED", "Sales Report", "C", "SalesReportSessionBean", "(JDPSubsystemMgr,JDPJob,String,String,String)", var1, 5, 5, false, -1, "", "", "B");
      if (var2 == null) {
         this.user.mainmsg.setStatusMsg("Job submission failed.", 10);
      } else if (var2.startsWith("Jobnumber:")) {
         this.user.mainmsg.setStatusMsg("Sales Report job submitted to QIMMED.", 10);
      } else {
         this.user.mainmsg.setStatusMsg(var2, 20);
      }
   }
}
