import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

public class SecurityCheck extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPScrollPanel ScrollPanel1;
   Label Label2;
   TextField username;
   Label Label3;
   TextField password;
   JDPButtons JDPButtons1;
   Label Label1;
   JDPRMIConnection RMIConnection1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label2 = new Label("Username:", 0);
      this.username = new TextField("Michael", 20);
      this.Label3 = new Label("Password:", 0);
      this.password = new TextField("Michael", 20);
      String[] var4 = new String[]{"Validate"};
      int[] var5 = new int[]{JDPButton.getIconValue("Check")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Label1 = new Label("This demo uses JDesignerPro's lightweight RMI to validate a user by calling a method in a job on the server", 0);
      this.RMIConnection1 = new JDPRMIConnection(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.username);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.password);
      this.ScrollPanel1.add("Right", this.JDPButtons1);
      this.Main.add("North", this.Label1);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               int[] var2 = this.RMIConnection1.getJobsForName("UserSecurityCheck");
               if (var2.length == 0) {
                  this.startJob();
               }

               var2 = this.RMIConnection1.getJobsForName("UserSecurityCheck");
               if (var2.length > 0) {
                  String[] var3 = new String[]{"String", "String"};
                  String[] var4 = new String[]{this.username.getText(), this.password.getText()};
                  Boolean var5 = (Boolean)this.RMIConnection1.invokeByJobNumber(var2[0], "validateUser", var3, var4);
                  if (var5) {
                     this.user.mainmsg.setStatusMsg("User Authorization Successful", 10);
                  } else {
                     this.user.mainmsg.setStatusMsg("User Authorization Failed.", 10);
                  }
               } else {
                  this.user.mainmsg.setStatusMsg("Could not find UserSecurityCheck job. Check that job is running on server", 15);
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void startJob() {
      Object var1 = null;
      String var3 = this.RMIConnection1.submitJob("QIMMED", "UserSecurityCheck", "C", "UserSecurityCheck", "(JDPSubsystemMgr,JDPJob)", "JDPSubsystemMgr,JDPJob", 5, 5, false, -1, "", "", "B");
      if (var3 == null) {
         this.user.mainmsg.setStatusMsg("Job submission failed.", 10);
      } else if (var3.startsWith("Jobnumber:")) {
         this.user.mainmsg.setStatusMsg("UserSecurityCheck job submitted to QIMMED.", 10);
      } else {
         this.user.mainmsg.setStatusMsg(var3, 20);
      }

      try {
         Thread.sleep(3000L);
      } catch (Exception var2) {
      }
   }
}
