import java.awt.Event;
import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.Date;

public class ServerPushEntity {
   JDPServerSender MessageSender1;
   JDPJagg jaggSQL;
   JDPSubsystemMgr manager;
   JDPJob thisJob;

   public ServerPushEntity(JDPSubsystemMgr var1, JDPJob var2) {
      this.manager = var1;
      this.thisJob = var2;
      var2.setInstance(this);
      var2.appendJobLog("Job started on " + (new Date()).toString());
      this.jaggSQL = new JDPJagg(var1.JDPJaggPath);
      this.MessageSender1 = new JDPServerSender(this.jaggSQL);

      while(!var1.shutdownRequested) {
         try {
            this.sendMessages();
            Thread.sleep(10000L);
         } catch (Exception var6) {
            ByteArrayOutputStream var4 = new ByteArrayOutputStream();
            PrintStream var5 = new PrintStream(var4);
            ((Throwable)var6).printStackTrace(var5);
            var2.appendJobLog(var4.toString());
         }
      }

      var2.appendJobLog("Job completed on " + (new Date()).toString());
   }

   void sendMessages() {
      String var1 = (new Date()).toString();
      this.MessageSender1.getConnectedClients();
      String[] var2 = this.MessageSender1.getIPAddresses();
      if (var2 != null) {
         Event var3 = new Event(this, 1001, var1);

         for(int var4 = 0; var4 < var2.length; ++var4) {
            this.MessageSender1.sendEventToClient(var2[var4], "ServerPushTest", var3);
         }
      }

   }
}
