import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;

public class SimpleServerPush extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   Label Label1;
   Panel Panel1;
   Panel Panel2;
   List connectedClients;
   JDPButton JDPButton1;
   Panel Panel3;
   JDPScrollPanel ScrollPanel1;
   JDPButton JDPButton2;
   JDPButton JDPButton3;
   JDPScrollPanel ScrollPanel2;
   Label Label2;
   TextField requestData;
   Label Label3;
   TextField dataReceived;
   JDPServerSender MessageSender1;
   JDPServerListener MessageReceiver1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.Label1 = new Label("This example demostrates using server push to send a message to a JDP client", 0);
      this.Panel1 = new Panel();
      this.Panel2 = new Panel();
      this.connectedClients = new List();
      this.JDPButton1 = new JDPButton("Get Connected Clients", JDPButton.getIconValue("Custom"), JDPButton.getAlignmentValue("Center"));
      this.Panel3 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.JDPButton2 = new JDPButton("Press to register to receive requests of type 'TestRequest'", JDPButton.getAlignmentValue("Center"));
      this.JDPButton3 = new JDPButton("Press so send a request of type 'TestRequest' to the selected IP address", JDPButton.getAlignmentValue("Center"));
      this.ScrollPanel2 = new JDPScrollPanel();
      this.Label2 = new Label("Data to send:", 0);
      this.requestData = new TextField("sample data", 20);
      this.Label3 = new Label("Data received:", 0);
      this.dataReceived = new TextField("", 20);
      this.MessageSender1 = new JDPServerSender(var1);
      this.MessageReceiver1 = var1.serverListener;
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("North", this.Label1);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("West", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.connectedClients);
      this.Panel2.add("North", this.JDPButton1);
      this.Panel1.add("Center", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("North", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.JDPButton2);
      this.ScrollPanel1.add("Left", this.JDPButton3);
      this.Panel3.add("Center", this.ScrollPanel2);
      this.ScrollPanel2.add("Left", this.Label2);
      this.ScrollPanel2.add("Right", this.requestData);
      this.ScrollPanel2.add("Left", this.Label3);
      this.ScrollPanel2.add("Right", this.dataReceived);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (!var1.target.equals(this.JDPButton1)) {
               if (var1.target.equals(this.JDPButton2)) {
                  this.MessageReceiver1.registerForRequest("TestRequest", this);
                  this.user.mainmsg.setStatusMsg("Registration complete", 10);
                  return true;
               }

               if (var1.target.equals(this.JDPButton3)) {
                  if (this.connectedClients.getSelectedIndex() >= 0) {
                     Event var6 = new Event(this, 1001, this.requestData.getText());
                     if (this.MessageSender1.sendEventToClient(this.connectedClients.getSelectedItem(), "TestRequest", var6)) {
                        this.user.mainmsg.setStatusMsg("Request sent", 10);
                     } else {
                        this.user.mainmsg.setStatusMsg("Could not send requested to selected IP address", 15);
                     }
                  }

                  return true;
               }

               if (var1.target.equals(this.MessageReceiver1)) {
                  if (var1.arg instanceof String) {
                     String var4 = (String)var1.arg;
                     if (var4.startsWith("TestRequest")) {
                        var4 = var4.substring(var4.indexOf("|") + 1);
                        this.dataReceived.setText(var4);
                     }
                  }

                  return true;
               }

               return false;
            }

            this.connectedClients.clear();
            this.MessageSender1.getConnectedClients();
            String[] var2 = this.MessageSender1.getIPAddresses();
            if (var2 != null) {
               for(int var3 = 0; var3 < var2.length; ++var3) {
                  this.connectedClients.addItem(var2[var3]);
               }
            }

            return true;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }
}
