import java.awt.BorderLayout;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;

public class SpreadSheet extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPTextGrid GridPanel1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      new CheckboxGroup();
      this.Main = new Panel();
      this.GridPanel1 = new JDPTextGrid(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.GridPanel1);
      this.GridPanel1.setRowHeaderWidth(60);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 402:
            if (var1.target.equals(this.GridPanel1)) {
               this.GridPanel1Recalc();
               return true;
            }

            return false;
         case 404:
            if (var1.target.equals(this.GridPanel1) && var1.key == 404) {
               this.GridPanel1Recalc();
               return true;
            } else if (var1.target.equals(this.GridPanel1) && var1.key == 1004) {
               this.GridPanel1Recalc();
               return true;
            } else {
               if (var1.target.equals(this.GridPanel1) && var1.key == 1005) {
                  this.GridPanel1Recalc();
                  return true;
               }

               return false;
            }
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1004:
            if (var1.target.equals(this.GridPanel1)) {
               this.GridPanel1Recalc();
               return true;
            }

            return false;
         case 1005:
            if (var1.target.equals(this.GridPanel1)) {
               this.GridPanel1Recalc();
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.GridPanel1.setTableDimensions(5, 8);
      this.GridPanel1.setRowHeader(7, "Total:");

      for(int var1 = 0; var1 < this.GridPanel1.getTableColumns(); ++var1) {
         this.GridPanel1.setCellProtected(var1, this.GridPanel1.getTableRows() - 1, true);
         this.GridPanel1.setCellColor(var1, this.GridPanel1.getTableRows() - 1, Color.red);
      }

      this.GridPanel1.reDraw();
   }

   public void GridPanel1Recalc() {
      for(int var1 = 0; var1 < this.GridPanel1.getTableColumns(); ++var1) {
         int var2 = 0;

         for(int var3 = 0; var3 < this.GridPanel1.getTableRows() - 1; ++var3) {
            try {
               var2 += Integer.parseInt(this.GridPanel1.getText(var1, var3));
            } catch (Exception var4) {
            }
         }

         this.GridPanel1.setText(Integer.toString(var2), var1, this.GridPanel1.getTableRows() - 1);
      }

   }
}
