import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;

public class SubmitServerJob extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPScrollPanel ScrollPanel1;
   Button Button1;
   Label Label1;
   JDPRMIConnection RMIConnection1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Button1 = new Button("Press to submit test job on Server");
      this.Label1 = new Label("This demo uses JDesignerPro's lightweight RMI to submit a job on the server", 0);
      this.RMIConnection1 = new JDPRMIConnection(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Button1);
      this.Main.add("North", this.Label1);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.Button1)) {
               String var2 = this.RMIConnection1.submitJob("QBATCH", "Test Job", "C", "JDPChoice", "()", "", 5, 5, true, -1, "", "", "B");
               if (var2 == null) {
                  this.user.mainmsg.setStatusMsg("Job submission failed.", 10);
               } else if (var2.startsWith("Jobnumber:")) {
                  this.user.mainmsg.setStatusMsg("Job submitted and held on QBATCH. Go to Job Queues in Server Manager to release job.", 30);
               } else {
                  this.user.mainmsg.setStatusMsg(var2, 15);
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }
}
