import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;

public class TreeCardDemo extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   JDPTreePicker TreeStructure1;
   JDPCardPanel CardPanel1;
   SalesOrder SalesOrder1;
   SimpleEmail SimpleEmail1;
   TreePopupMenu TreePopupMenu1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Select the Application");
      this.TreeStructure1 = new JDPTreePicker(var1);
      this.TreeStructure1.setRoot("My Tree Structure", true);
      this.CardPanel1 = new JDPCardPanel();
      this.SalesOrder1 = new SalesOrder();
      this.SalesOrder1.InitClass(var1, var2, var3);
      this.SimpleEmail1 = new SimpleEmail();
      this.SimpleEmail1.InitClass(var1, var2, var3);
      this.TreePopupMenu1 = new TreePopupMenu();
      this.TreePopupMenu1.InitClass(var1, var2, var3);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.TreeStructure1);
      this.Main.add("Center", this.CardPanel1);
      this.CardPanel1.add("SalesOrder1", this.SalesOrder1);
      this.CardPanel1.add("SimpleEmail1", this.SimpleEmail1);
      this.CardPanel1.add("TreePopupMenu1", this.TreePopupMenu1);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.TreeStructure1)) {
               this.CardPanel1.setSelectedComp(this.TreeStructure1.getSelectedItem() + "1");
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      int[] var1 = new int[]{4, 1};
      boolean[] var2 = new boolean[]{true, true};
      this.TreeStructure1.setIcons(var1);
      this.TreeStructure1.setExpanded(var2);
      this.TreeStructure1.setRoot("Example Applications", true);
      String[] var3 = new String[]{"SalesOrder"};
      this.TreeStructure1.addEntry(var3);
      var3[0] = "SimpleEmail";
      this.TreeStructure1.addEntry(var3);
      var3[0] = "TreePopupMenu";
      this.TreeStructure1.addEntry(var3);
      this.TreeStructure1.reDraw();
   }
}
