import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.GridLayout;
import java.awt.Panel;

public class TreeDragAndDrop extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPDragItem DragAndDrop1;
   Panel Panel1;
   JDPChiselFramePanel ChiselPanel1;
   JDPTreePicker TreeStructure1;
   JDPChiselFramePanel ChiselPanel2;
   JDPTreePicker TreeStructure2;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.DragAndDrop1 = new JDPDragItem(var1.getJDPUser(), this.Main);
      this.Panel1 = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Drag a branch from this tree to the lower one");
      this.TreeStructure1 = new JDPTreePicker(var1);
      this.TreeStructure1.setRoot("My Tree Structure", true);
      this.ChiselPanel2 = new JDPChiselFramePanel(var1, "Drop the branch on this tree");
      this.TreeStructure2 = new JDPTreePicker(var1);
      this.TreeStructure2.setRoot("My Other Tree Structure", true);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.DragAndDrop1);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new GridLayout(2, 2));
      this.Panel1.add(this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.TreeStructure1);
      this.Panel1.add(this.ChiselPanel2);
      this.ChiselPanel2.add("Center", this.TreeStructure2);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 506:
            if (var1.target.equals(this.Panel1)) {
               this.DragAndDrop1.postEvent(var1);
               return true;
            }

            return false;
         case 1001:
            if (var1.target.equals(this.DragAndDrop1)) {
               JDPTreeBranch[] var2 = this.DragAndDrop1.getDraggedBranch(this.TreeStructure1);
               JDPTreeBranch[] var3 = this.DragAndDrop1.getDroppedBranch(this.TreeStructure2);
               if (var2 != null && var3 != null) {
                  JDPTreeBranch var4 = var3[var3.length - 1];
                  String var5 = var2[var2.length - 1].name;
                  int var6 = var2[var2.length - 1].icon;
                  this.TreeStructure2.addBranch(var4, var5, var6, false, (Object)null, (String)null, false);
                  var4.expanded = true;
                  this.TreeStructure1.reDraw();
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      int[] var1 = new int[]{4, 5};
      boolean[] var2 = new boolean[]{true, true, true};
      this.TreeStructure1.setIcons(var1);
      this.TreeStructure1.setExpanded(var2);
      this.TreeStructure1.setDragPanel(this.DragAndDrop1);
      Object[] var3 = new Object[]{"TreeItem", "TreeItem"};
      String[] var4 = new String[]{null, "Drop here"};
      this.TreeStructure1.setDropKeys(var3);
      this.TreeStructure1.setDragAndDrop((boolean[])null);
      this.TreeStructure1.setRoot("Employees", true);
      String[] var5 = new String[]{"John"};
      this.TreeStructure1.addEntry(var5);
      var5[0] = "Mary";
      this.TreeStructure1.addEntry(var5);
      var5[0] = "Steven";
      this.TreeStructure1.addEntry(var5);
      var5[0] = "Joe";
      this.TreeStructure1.addEntry(var5);
      var5[0] = "Andrew";
      this.TreeStructure1.addEntry(var5);
      this.TreeStructure1.reDraw();
      int[] var6 = new int[]{0, 8};
      boolean[] var7 = new boolean[]{true, true, true};
      this.TreeStructure2.setIcons(var6);
      this.TreeStructure2.setExpanded(var7);
      this.TreeStructure2.setDragPanel(this.DragAndDrop1);
      Object[] var8 = new Object[]{null, "TreeItem"};
      String[] var9 = new String[]{null, "Drop here"};
      this.TreeStructure2.setDropKeys(var8);
      this.TreeStructure2.setDragAndDrop((boolean[])null);
      this.TreeStructure2.setDropMessages(var9);
      this.TreeStructure2.setRoot("Positions", true);
      var5 = new String[]{"Marketing"};
      this.TreeStructure2.addEntry(var5);
      var5[0] = "Sales";
      this.TreeStructure2.addEntry(var5);
      var5[0] = "Managerment";
      this.TreeStructure2.addEntry(var5);
      var5[0] = "Technical";
      this.TreeStructure2.addEntry(var5);
      var5[0] = "Human Resources";
      this.TreeStructure2.addEntry(var5);
      this.TreeStructure2.reDraw();
   }
}
