import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;

public class TreePopupMenu extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPPopupMenu PopupMenu1;
   JDPChiselFramePanel ChiselPanel1;
   JDPTreePicker TreeStructure1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.PopupMenu1 = new JDPPopupMenu(var1.getJDPUser(), this.Main);
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Tree Structure with Popup Menu Demo");
      this.TreeStructure1 = new JDPTreePicker(var1);
      this.TreeStructure1.setRoot("My Tree Structure", true);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.PopupMenu1);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.TreeStructure1);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target.equals(this.TreeStructure1)) {
               this.PopupMenu1.clear();
               this.PopupMenu1.addEntry("Send Email...");
               this.PopupMenu1.addEntry("");
               this.PopupMenu1.addEntry("Remove");
               this.PopupMenu1.display(var1.x, var1.y);
               return true;
            }

            return false;
         case 1001:
            if (var1.target.equals(this.PopupMenu1)) {
               String var2 = this.TreeStructure1.getCurrentBranch().name;
               this.user.mainmsg.setStatusMsg(this.PopupMenu1.getSelectedMenu(0) + " on " + var2 + " selected.", 5);
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      int[] var1 = new int[]{4, 5};
      boolean[] var2 = new boolean[]{true, true};
      this.TreeStructure1.setIcons(var1);
      this.TreeStructure1.setExpanded(var2);
      this.TreeStructure1.setRoot("Employees", true);
      String[] var3 = new String[]{"John"};
      this.TreeStructure1.addEntry(var3);
      var3[0] = "Mary";
      this.TreeStructure1.addEntry(var3);
      var3[0] = "Steven";
      this.TreeStructure1.addEntry(var3);
      var3[0] = "Joe";
      this.TreeStructure1.addEntry(var3);
      var3[0] = "Andrew";
      this.TreeStructure1.addEntry(var3);
      this.TreeStructure1.reDraw();
   }
}
