package javax.ejb;

import java.rmi.Remote;
import java.rmi.RemoteException;

public interface EJBObject extends Remote {
   EJBHome getEJBHome() throws RemoteException;

   Object getPrimaryKey() throws RemoteException;

   void remove() throws RemoteException, RemoveException;

   Handle getHandle() throws RemoteException;

   boolean isIdentical(EJBObject var1) throws RemoteException;
}
