package oracle.jdbc.oracore;

public class CoreException extends Exception {
   public static final byte UNDERFLOW = 0;
   public static final byte OVERFLOW = 1;
   private byte errno;

   public CoreException() {
   }

   public CoreException(String s) {
      super(s);
   }

   public CoreException(byte errno) {
      this.errno = errno;
   }

   public byte getErrorCode() {
      return this.errno;
   }
}
