package oracle.jdbc.ttc7;

import oracle.jdbc.dbaccess.DBStatement;

public class TTCStatement extends DBStatement {
   private boolean firstStreamPiece;
   public int cursor;

   public TTCStatement(int cursor) {
      this.cursor = cursor;
      this.firstStreamPiece = true;
   }

   public int getCursor() {
      return this.cursor;
   }

   public void firstPieceRead() {
      this.firstStreamPiece = false;
   }

   public void firstPieceReset() {
      this.firstStreamPiece = true;
   }

   public boolean isFirstStreamPiece() {
      return this.firstStreamPiece;
   }
}
