package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class TTIoac extends TTIMsg {
   short oacdty;
   short oacflg;
   short oacpre;
   short oacscl;
   int oacmxl;
   int oacmal;
   int oacfl2;
   private static final boolean DEBUG = false;
   private static final int ORACLE_NUMBER = 2;

   public TTIoac(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) {
      super(types, sqlnet, conv);
      ((TTIMsg)this).initInBuffers();
   }

   public void unmarshal() throws IOException, SQLException {
      this.oacdty = ((TTIMsg)this).unmarshalUB1();
      this.oacflg = ((TTIMsg)this).unmarshalUB1();
      this.oacpre = ((TTIMsg)this).unmarshalUB1();
      if (this.oacdty == 2) {
         this.oacscl = (short)((TTIMsg)this).unmarshalUB2();
      } else {
         this.oacscl = ((TTIMsg)this).unmarshalUB1();
      }

      this.oacmxl = ((TTIMsg)this).unmarshalSB4();
      this.oacmal = ((TTIMsg)this).unmarshalSB4();
      this.oacfl2 = ((TTIMsg)this).unmarshalSB4();
   }
}
