package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class TTIrid extends TTIMsg {
   private TTIti5 ti5;
   private long blockNumber;
   private int slotNumber;

   public TTIrid(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) {
      super(types, sqlnet, conv);
      this.ti5 = new TTIti5(types, sqlnet, conv);
      ((TTIMsg)this).initInBuffers();
   }

   public void unmarshal() throws SQLException, IOException {
      this.ti5.unmarshal();
      this.blockNumber = ((TTIMsg)this).unmarshalUB4();
      this.slotNumber = ((TTIMsg)this).unmarshalUB2();
   }

   public void print() {
      System.out.println("      ti5 structure     :");
      this.ti5.print();
      System.out.println("      blockNumber :" + this.blockNumber);
      System.out.println("      slotNumber  :" + this.slotNumber);
   }
}
