package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class TTIti5 extends TTIMsg {
   private long rba;
   private int partionID;
   private short tableID;

   public TTIti5(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) {
      super(types, sqlnet, conv);
      ((TTIMsg)this).initInBuffers();
   }

   public void unmarshal() throws SQLException, IOException {
      this.rba = ((TTIMsg)this).unmarshalUB4();
      this.partionID = ((TTIMsg)this).unmarshalUB2();
      this.tableID = ((TTIMsg)this).unmarshalUB1();
   }

   public void print() {
      System.out.println("          rba         :" + this.rba);
      System.out.println("          partition ID:" + this.rba);
      System.out.println("          table ID    :" + this.rba);
   }
}
