package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class TTIuds extends TTIMsg {
   protected TTIoac udsoac;
   protected boolean udsnull;
   protected short udscnl;

   public TTIuds(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) {
      super(types, sqlnet, conv);
      this.udsoac = new TTIoac(types, sqlnet, conv);
      ((TTIMsg)this).initInBuffers();
   }

   public void unmarshal() throws IOException, SQLException {
      this.udsoac.unmarshal();
      short null_allowed = ((TTIMsg)this).unmarshalUB1();
      this.udsnull = null_allowed > 0;
      this.udscnl = ((TTIMsg)this).unmarshalUB1();
   }
}
