import java.awt.BorderLayout;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.List;
import java.awt.Panel;
import java.util.StringTokenizer;
import java.util.Vector;

public class CopyGridRows extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPSearchResults ResultList1;
   Panel Panel1;
   JDPTextGrid DetailGrid1;
   JDPButtons JDPButtons1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      new CheckboxGroup();
      this.Main = new Panel();
      this.ResultList1Main();
      this.Panel1 = new Panel();
      this.DetailGrid1Main();
      String[] var4 = new String[]{"Copy Selected Rows"};
      int[] var5 = new int[]{JDPButton.getIconValue("Copy")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.ResultList1);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.DetailGrid1);
      this.Panel1.add("South", this.JDPButtons1);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.ResultList1)) {
               this.DetailGrid1LoadGrid(this.ResultList1.getSelectedKey());
               return true;
            } else {
               if (var1.target.equals(this.JDPButtons1.button[0])) {
                  this.DetailGrid1Copy();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
   }

   public void ResultList1Main() {
      String var1 = "stor_id";
      String[] var2 = new String[0];
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Stor name"};
      String[] var5 = new String[]{"stor_name"};
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, this.jaggSQL, false, var1, var2, var3, var4, var5, var5, "", true, "Total Entries:");
      int[] var6 = new int[8];
      var6[0] = 3;
      var6[1] = 5;
      this.ResultList1.setMinWidth(130);
      this.ResultList1.setIcons(var6);
      this.ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
      this.ResultList1.clearList("");
      this.ResultList1.loadList();
   }

   public void DetailGrid1Main() {
      this.DetailGrid1SetGridSettings();
   }

   public void DetailGrid1LoadGrid(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var4 = 0;
         Vector var5 = new Vector();
         String var6 = this.jaggSQL.getSEP();
         int var7 = 0;
         byte var9 = 6;
         new Vector();
         new Vector();
         String var10 = "SELECT stor_id, ord_num, title_id, stor_id, ord_num, format(ord_date, 'mm/dd/yy'), qty, payterms, title_id FROM dbo_sales WHERE (1=1)  ";
         if (var1.length > 0 && var1[0] != null) {
            var10 = var10 + " AND stor_id='" + var1[0] + "'";
         }

         if (var1.length > 1 && var1[1] != null) {
            var10 = var10 + " AND ord_num='" + var1[1] + "'";
         }

         if (var1.length > 2 && var1[2] != null) {
            var10 = var10 + " AND title_id='" + var1[2] + "'";
         }

         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
         this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
         this.jaggSQL.setJdbcSuffix("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setCSTR(" ");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         var4 = this.jaggSQL.execSQL(var10, var5);
         if (var4 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var10);
         } else {
            var2.totalDataRows = this.jaggSQL.getRowCount();
            var7 = this.jaggSQL.getRowCount() + 20;
            var2.currentText = new String[var9][var7];
            var2.cellChanged = null;
            var2.rowChanged = null;
            var2.columnSelected = null;
            byte var11 = 3;
            var2.rowKey = new String[var7][var11];

            for(int var13 = 0; var13 < var7 - 20; ++var13) {
               String var8 = (String)var5.elementAt(var13);
               if (var8 != null && var8.trim().compareTo("") != 0) {
                  StringTokenizer var3 = new StringTokenizer(var8);

                  for(int var14 = 0; var14 < var11; ++var14) {
                     var2.rowKey[var13][var14] = var3.nextToken(var6).trim();
                  }

                  for(int var15 = 0; var15 < var9; ++var15) {
                     String var12 = var3.nextToken(var6).trim();
                     var2.currentText[var15][var13] = var12;
                  }
               }
            }

            for(int var18 = var7 - 20; var18 < var7; ++var18) {
               for(int var19 = 0; var19 < var1.length; ++var19) {
                  var2.rowKey[var18][var19] = var1[var19];
               }
            }

            var2.newTable();
            this.user.mainmsg.clearStatusMsg();
         }
      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   public void DetailGrid1UpdateRows(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var3 = 0;
         int var4 = 0;
         int var5 = 1;
         int var6 = 1;

         for(int var7 = 0; var7 < var2.rowChanged.length; ++var7) {
            if (var2.rowChanged[var7]) {
               if (var7 >= var2.totalDataRows) {
                  ++var4;
               } else {
                  ++var3;
               }
            }
         }

         for(int var8 = 0; var8 < var2.rowChanged.length; ++var8) {
            if (var2.rowChanged[var8]) {
               if (var8 >= var2.totalDataRows) {
                  this.user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(var6++) + " of " + Integer.toString(var4) + "...", 0);
                  this.DetailGrid1SaveData(var8, "I");
               } else {
                  this.user.mainmsg.setStatusMsg("Updating row " + Integer.toString(var5++) + " of " + Integer.toString(var3) + "...", 0);
                  this.DetailGrid1SaveData(var8, "U");
               }

               var2.rowChanged[var8] = false;
            }
         }

         if (var4 > 0) {
            this.DetailGrid1LoadGrid(var1);
         }

      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   boolean DetailGrid1SaveData(int var1, String var2) {
      JDPTextGrid var3 = this.DetailGrid1;
      int var4 = 0;
      Vector var5 = new Vector();
      this.jaggSQL.getSEP();
      String var6 = "";
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      if (var2.equals("I")) {
         var6 = "INSERT INTO dbo_sales (stor_id, ord_num, ord_date, qty, payterms, title_id) VALUES('" + this.user.u.replace(var3.currentText[0][var1], "'", "''") + "', " + "'" + this.user.u.replace(var3.currentText[1][var1], "'", "''") + "', " + "'" + this.user.u.replace(var3.currentText[2][var1], "'", "''") + "', " + "" + var3.currentText[3][var1] + ", " + "'" + this.user.u.replace(var3.currentText[4][var1], "'", "''") + "', " + "'" + this.user.u.replace(var3.currentText[5][var1], "'", "''") + "')";
      } else if (var2.equals("D")) {
         var6 = "DELETE FROM dbo_sales WHERE stor_id='" + var3.rowKey[var1][0] + "'" + " AND ord_num='" + var3.rowKey[var1][1] + "'" + " AND title_id='" + var3.rowKey[var1][2] + "'";
      } else {
         var6 = "UPDATE dbo_sales SET ord_date = '" + this.user.u.replace(var3.currentText[2][var1], "'", "''") + "', " + "qty = " + var3.currentText[3][var1] + ", " + "payterms = '" + this.user.u.replace(var3.currentText[4][var1], "'", "''") + "'" + " WHERE stor_id='" + var3.rowKey[var1][0] + "'" + " AND ord_num='" + var3.rowKey[var1][1] + "'" + " AND title_id='" + var3.rowKey[var1][2] + "'";
      }

      var4 = this.jaggSQL.execSQL(var6, var5);
      if (this.user.DEBUG) {
         System.out.println("saveData CNT: " + Integer.toString(var4));
      }

      if (var4 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var6);
         return false;
      } else {
         if (var4 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var6);
         }

         return true;
      }
   }

   public void DetailGrid1LoadEmptyGrid() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 6;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void DetailGrid1SetGridSettings() {
      if (this.DetailGrid1 == null) {
         this.DetailGrid1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 6;
      var1.columnHeader = new String[var2];
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnWidth[0] = 46;
      var1.columnWidth[1] = 150;
      var1.columnWidth[2] = 126;
      var1.columnWidth[3] = 32;
      var1.columnWidth[4] = 98;
      var1.columnWidth[5] = 56;
      var1.rightJustify[3] = true;
      var1.columnHeader[0] = "Stor Id";
      var1.columnHeader[1] = "Ord Num";
      var1.columnHeader[2] = "Ord Date";
      var1.columnHeader[3] = "Qty";
      var1.columnHeader[4] = "Payterms";
      var1.columnHeader[5] = "Title Id";
      this.DetailGrid1LoadEmptyGrid();
      this.DetailGrid1LoadChoices();
   }

   void DetailGrid1LoadChoices() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 6;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      var1.isPullDownCol = new boolean[var2];
      var1.pullDownList = new List[var2][1];
   }

   public void DetailGrid1Copy() {
      JDPTextGrid var1 = this.DetailGrid1;
      int var2 = var1.getTableRows() - 19;

      for(int var3 = 0; var3 < var1.rowChanged.length; ++var3) {
         if (var1.rowSelected[var3]) {
            for(int var4 = 0; var4 < var1.getTableColumns(); ++var4) {
               var1.currentText[var4][var2] = var1.currentText[var4][var3];
            }

            ++var2;
         }
      }

      var1.reDraw();
   }
}
