import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;

public class FileDragAndDrop extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPDragItem DragAndDrop1;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   Panel Panel2;
   JDPFilePicker FilePicker1;
   Label Label1;
   Panel Panel3;
   JDPFilePicker FilePicker2;
   Label Label2;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.DragAndDrop1 = new JDPDragItem(var1.getJDPUser(), this.Main);
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Drag and Drop demo (no files actually get copied or moved)");
      this.Panel1 = new Panel();
      this.Panel2 = new Panel();
      this.FilePicker1 = new JDPFilePicker();
      this.FilePicker1.InitClass(var1, var2, var3);
      this.Label1 = new Label("Drag from here", 0);
      this.Panel3 = new Panel();
      this.FilePicker2 = new JDPFilePicker();
      this.FilePicker2.InitClass(var1, var2, var3);
      this.Label2 = new Label("To here", 0);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.DragAndDrop1);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new GridLayout(1, 2));
      this.Panel1.add(this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.FilePicker1);
      this.Panel2.add("North", this.Label1);
      this.Panel1.add(this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("Center", this.FilePicker2);
      this.Panel3.add("North", this.Label2);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.DragAndDrop1)) {
               String var2 = null;
               String var3 = "";
               String var4 = null;
               JDPTreeBranch[] var5 = this.DragAndDrop1.getDraggedBranch(this.FilePicker1.List1);
               if (var5 != null) {
                  var2 = this.FilePicker1.getFilePath(var5[var5.length - 1]);
                  var3 = var5[var5.length - 1].name;
               } else {
                  var5 = this.DragAndDrop1.getDraggedBranch(this.FilePicker2.List1);
                  if (var5 != null) {
                     var2 = this.FilePicker2.getFilePath(var5[var5.length - 1]);
                     var3 = var5[var5.length - 1].name;
                  }
               }

               JDPTreeBranch[] var6 = this.DragAndDrop1.getDroppedBranch(this.FilePicker1.TreeStructure1);
               if (var6 != null) {
                  var4 = this.FilePicker1.getDirectoryPath(var6[var6.length - 1]) + this.FilePicker1.getSeparator() + var3;
               } else {
                  var6 = this.DragAndDrop1.getDroppedBranch(this.FilePicker2.TreeStructure1);
                  if (var6 != null) {
                     var4 = this.FilePicker2.getDirectoryPath(var6[var6.length - 1]) + this.FilePicker2.getSeparator() + var3;
                  }
               }

               if (var4 == null) {
                  var6 = this.DragAndDrop1.getDroppedBranch(this.FilePicker1.List1);
                  if (var6 != null) {
                     var4 = this.FilePicker1.getDirectoryPath(var6[var6.length - 1]) + this.FilePicker1.getSeparator() + var3;
                  } else {
                     var6 = this.DragAndDrop1.getDroppedBranch(this.FilePicker2.List1);
                     if (var6 != null) {
                        var4 = this.FilePicker2.getDirectoryPath(var6[var6.length - 1]) + this.FilePicker2.getSeparator() + var3;
                     }
                  }
               }

               if (var2 != null && var4 != null) {
                  this.user.mainmsg.setStatusMsg("Copy " + var2 + " to " + var4 + ".", 10);
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.FilePicker1.setDragKey("Files");
      this.FilePicker1.setDragPanel(this.DragAndDrop1);
      this.FilePicker1.setDropMessage("Drop here to copy the selected class to this folder");
      this.FilePicker2.clearFilter();
      this.FilePicker1.addFilter("Java Class Files", ".class");
      this.FilePicker1.addFilter("Java Source Files", ".java");
      this.FilePicker1.addFilter("JDP Applications", ".jdp");
      this.FilePicker1.loadFiles(this.user.getJDPDir(), false);
      this.FilePicker2.setDragPanel(this.DragAndDrop1);
      this.FilePicker2.clear();
      this.FilePicker2.setDragKey("Files");
      this.FilePicker2.setDropMessage("Drop here to copy the selected class to this folder");
      this.FilePicker2.clearFilter();
      this.FilePicker2.addFilter("Java Class Files", ".class");
      this.FilePicker2.addFilter("Java Source Files", ".java");
      this.FilePicker2.addFilter("JDP Applications", ".jdp");
      this.FilePicker2.loadFiles(this.user.getJDPDir(), false);
      this.FilePicker2.loadAllDrives();
   }
}
