import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Panel;
import java.net.URL;

public class JDPBrowserCtl extends JDPClassLayout {
   JDPBrowser HTMLPanel1;
   Panel Main;
   JDPButtons btns;
   JDPPopupMessage popuppanel;
   JDPPopupMenu popup;

   public void setKeywords(String[] var1) {
      this.HTMLPanel1.setKeywords(var1);
   }

   public String getDocname() {
      return this.HTMLPanel1.getDocname();
   }

   public boolean setDocname(String var1) {
      return this.HTMLPanel1.setDocname(var1);
   }

   public boolean setDocname(String var1, boolean var2) {
      return this.HTMLPanel1.setDocname(var1, var2);
   }

   public void setMatchCompleteWords(boolean var1) {
      this.HTMLPanel1.setMatchCompleteWords(var1);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               return true;
            }

            return false;
         case 502:
            this.popup.display(var1.x, var1.y);
            return true;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2.equals("Back")) {
                  this.HTMLPanel1.back();
                  return true;
               }

               if (var2.equals("Forward")) {
                  this.HTMLPanel1.forward();
                  return true;
               }
            }

            if (var1.target.equals(this.popup)) {
               String var5 = this.popup.getSelectedMenu(0);
               if (var5.equals("Send to browser")) {
                  Object var6 = null;

                  try {
                     URL var7 = new URL(this.HTMLPanel1.getFullDocname());
                     super.user.JDesignerPro.getAppletContext().showDocument(var7);
                  } catch (Exception var4) {
                     super.user.mainmsg.setStatusMsg("Could not load URL: " + ((URL)var6).toString(), 10);
                  }

                  return true;
               }

               if (var5.equals("Back")) {
                  this.HTMLPanel1.back();
                  return true;
               }

               if (var5.equals("Forward")) {
                  this.HTMLPanel1.forward();
                  return true;
               }

               if (var5.equals("Table of Contents")) {
                  this.HTMLPanel1.setDocname("jdpmanual.htm", false);
                  return true;
               }

               if (var5.equals("Set font")) {
                  String var3 = this.popup.getSelectedMenu(1);
                  if (var3.equals("infinitesimal")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize - 4);
                  } else if (var3.equals("tiny")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize - 1);
                  } else if (var3.equals("small")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize + 1);
                  } else if (var3.equals("regular")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize + 3);
                  } else if (var3.equals("large")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize + 7);
                  } else if (var3.equals("huge")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize + 15);
                  } else if (var3.equals("enormous")) {
                     this.HTMLPanel1.setFontSize(super.user.plainFontSize + 24);
                  }

                  return true;
               }

               if (var5.equals("Print")) {
                  this.HTMLPanel1.printPages();
                  return true;
               }
            }

            return true;
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      ((Container)this).setLayout(new BorderLayout());
      this.popup = new JDPPopupMenu(var1, this);
      this.popup.addEntry("Back");
      this.popup.addEntry("Forward");
      String[] var4 = new String[]{"Set font", "infinitesimal"};
      this.popup.addEntry(var4);
      var4[1] = "tiny";
      this.popup.addEntry(var4);
      var4[1] = "small";
      this.popup.addEntry(var4);
      var4[1] = "regular";
      this.popup.addEntry(var4);
      var4[1] = "large";
      this.popup.addEntry(var4);
      var4[1] = "huge";
      this.popup.addEntry(var4);
      var4[1] = "enormous";
      this.popup.addEntry(var4);
      if (!JDesignerPro.executable) {
         this.popup.addEntry("Send to browser");
      } else if (!System.getProperty("java.version").startsWith("1.0")) {
         this.popup.addEntry("Print");
      }

      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      this.Main = new Panel();
      this.HTMLPanel1 = new JDPBrowser();
      this.HTMLPanel1.InitClass(var1, var2, var3);
      String[] var5 = new String[]{"Back", "Forward"};
      int[] var6 = new int[]{6, 5};
      this.btns = new JDPButtons(var1, var5, var6, JDPButtons.HORIZONTAL);
      this.Main.setLayout(new BorderLayout());
      this.Main.setFont(new Font("Helvetica", 0, 11));
      this.Main.setForeground(var1.u._cvtcolor("Black"));
      ((Container)this).add("Center", this.Main);
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      ((Container)var7).add(this.popup);
      ((Container)var7).add("Center", this.HTMLPanel1);
      this.Main.add("Center", var7);
      this.Main.add("South", this.btns);
      this.HTMLPanel1.setFont(new Font("TimesRoman", 0, 12));
      this.popuppanel.addComponent(this.btns.button[0], "Back", "Load the previous document");
      this.popuppanel.addComponent(this.btns.button[1], "Forward", "Load the previous forward document");
      var1.gParm.addElement(this);
   }
}
