import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPChoiceLayout extends JDPClassLayout {
   JDPSelectDSN targetDSN;
   JDPSelectColumns target;
   JDPJagg jaggSQL;
   String moduleParameter;
   JDPSelectTable tableTarget;
   JDPScreenLayout targetScreen;
   JDPLayoutMgr targetLayoutMgr;
   Panel targetPanel;
   JDPPopupMessage popuppanel;
   Panel cardChoicePanel;
   Panel vlPanel;
   JDPComboBox valuesfrom;
   TextField[] textchoicevalue;
   TextField[] actualchoicevalue;
   JDPList tablelist;
   JDPList columntextlist;
   JDPList columnactuallist;
   JDPList columndatatype;
   TextField textchoicesql;
   TextField tablewhereclause;
   Label listCount;
   JDPWrapLabel actualLabel;
   String[] valuesFrom;
   String[][] textChoiceValue;
   String[][] actualChoiceValue;
   String[] tableList;
   String[] columnTextList;
   String[] columnActualList;
   String[] columnDataType;
   String[] textChoiceSql;
   String[] tableWhereClause;
   String tableQualifier;
   String tableOwner;
   String tableName;
   String prevDSNString;
   String prevTableString;
   Vector gParmObject;
   int currentSelection = -1;
   static int maxChoices = 20;
   String extraName = "";

   void updateArrays(int var1) {
      if (var1 >= 0) {
         for(int var2 = 0; var2 < maxChoices; ++var2) {
            this.textChoiceValue[var1][var2] = this.textchoicevalue[var2].getText();
            this.actualChoiceValue[var1][var2] = this.actualchoicevalue[var2].getText();
         }

         this.valuesFrom[var1] = this.valuesfrom.getSelectedItem();
         this.tableList[var1] = this.tablelist.getSelectedItem();
         this.columnTextList[var1] = this.columntextlist.getSelectedItem();
         this.columnActualList[var1] = this.columnactuallist.getSelectedItem();
         this.columndatatype.select(this.columnactuallist.getSelectedIndex());
         this.columnDataType[var1] = this.columndatatype.getSelectedItem();
         this.textChoiceSql[var1] = this.textchoicesql.getText();
         this.tableWhereClause[var1] = this.tablewhereclause.getText();
         ((CardLayout)this.cardChoicePanel.getLayout()).show(this.cardChoicePanel, this.valuesfrom.getSelectedItem());
         this.saveSelections();
      }
   }

   void initList(int var1) {
      this.textChoiceValue = new String[var1][maxChoices];
      this.actualChoiceValue = new String[var1][maxChoices];
      this.valuesFrom = new String[var1];
      this.tableList = new String[var1];
      this.columnTextList = new String[var1];
      this.columnActualList = new String[var1];
      this.columnDataType = new String[var1];
      this.textChoiceSql = new String[var1];
      this.tableWhereClause = new String[var1];
   }

   void loadList(int var1) {
      for(int var2 = 0; var2 < maxChoices; ++var2) {
         this.textChoiceValue[var1][var2] = "";
         this.actualChoiceValue[var1][var2] = "";
      }

      this.valuesFrom[var1] = "Fields entered here";
      this.tableList[var1] = " ";
      this.columnTextList[var1] = "";
      this.columnActualList[var1] = "";
      this.columnDataType[var1] = "";
      this.textChoiceSql[var1] = "";
      this.tableWhereClause[var1] = "(1=1)";
   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = this.moduleParameter;
      if (super.componentName.equals("")) {
         var2 = "";
      }

      String var3 = "JDPChoiceLayout" + var2 + super.componentName;
      if (!super.componentName.equals("")) {
         var3 = var3 + this.extraName;
      }

      if (this.tableList == null) {
         this.initList(1);
      }

      String[] var4 = (String[])var1.restoreObject(this.valuesFrom, var3, "valuesFrom");
      String[][] var5 = (String[][])var1.restoreObject(this.textChoiceValue, var3, "textChoiceValue");
      String[][] var6 = (String[][])var1.restoreObject(this.actualChoiceValue, var3, "actualChoiceValue");
      String[] var7 = (String[])var1.restoreObject(this.tableList, var3, "tableList");
      String[] var8 = (String[])var1.restoreObject(this.columnTextList, var3, "columnTextList");
      String[] var9 = (String[])var1.restoreObject(this.columnActualList, var3, "columnActualList");
      String[] var10 = (String[])var1.restoreObject(this.columnDataType, var3, "columnDataType");
      String[] var11 = (String[])var1.restoreObject(this.textChoiceSql, var3, "textChoiceSql");
      String[] var12 = (String[])var1.restoreObject(this.tableWhereClause, var3, "tableWhereClause");
      if (this.tableList.length == 1 || this.valuesFrom.length < var4.length) {
         this.initList(var4.length);
      }

      for(int var13 = 0; var13 < var4.length; ++var13) {
         this.valuesFrom[var13] = var4[var13];

         for(int var14 = 0; var14 < var5[0].length; ++var14) {
            this.textChoiceValue[var13][var14] = var5[var13][var14];
            this.actualChoiceValue[var13][var14] = var6[var13][var14];
         }

         this.tableList[var13] = var7[var13];
         this.columnTextList[var13] = var8[var13];
         this.columnActualList[var13] = var9[var13];
         if (var10 != null && var10.length > var13) {
            this.columnDataType[var13] = var10[var13];
         }

         this.textChoiceSql[var13] = var11[var13];
         this.tableWhereClause[var13] = var12[var13];
      }

      for(int var15 = 0; var15 < this.textChoiceValue.length; ++var15) {
         for(int var16 = 0; var16 < this.textChoiceValue[0].length; ++var16) {
            if (this.textChoiceValue[var15][var16] == null) {
               this.textChoiceValue[var15][var16] = "";
            }

            if (this.actualChoiceValue[var15][var16] == null) {
               this.actualChoiceValue[var15][var16] = "";
            }
         }
      }

      return true;
   }

   void clearFields() {
      for(int var1 = 0; var1 < maxChoices; ++var1) {
         this.textchoicevalue[var1].setText("");
         this.actualchoicevalue[var1].setText("");
      }

      this.valuesfrom.select("Fields entered here");
      int var2 = this.tablelist.getSelectedIndex();
      if (var2 >= 0) {
         this.tablelist.deselect(var2);
      }

      var2 = this.columntextlist.getSelectedIndex();
      if (var2 >= 0) {
         this.columntextlist.deselect(var2);
      }

      var2 = this.columnactuallist.getSelectedIndex();
      if (var2 >= 0) {
         this.columnactuallist.deselect(var2);
      }

      if (var2 >= 0) {
         this.columndatatype.deselect(var2);
      }

      this.textchoicesql.setText("(1=1)");
      this.tablewhereclause.setText("(1=1)");
      this.columntextlist.clear();
      this.columnactuallist.clear();
      this.columndatatype.clear();
      ((CardLayout)this.cardChoicePanel.getLayout()).show(this.cardChoicePanel, this.valuesfrom.getSelectedItem());
   }

   void loadLayoutComponent() {
      if (this.targetDSN != null) {
         if (!this.targetDSN.datasource.getText().equals("") && this.tablelist.getSelectedIndex() >= 0 && !this.valuesfrom.getSelectedItem().equals("Fields entered here")) {
            this.jaggSQL.loadSettings(this.targetDSN);
            if (super.thisBranch.thisObject instanceof JDPChoice) {
               ((JDPChoice)super.thisBranch.thisObject).loadChoice(super.user, this.jaggSQL, this.textchoicesql.getText(), this.columnactuallist.getSelectedItem(), this.tablelist.getSelectedItem(), this.tablewhereclause.getText());
            } else if (super.thisBranch.thisObject instanceof JDPComboBox) {
               ((JDPComboBox)super.thisBranch.thisObject).loadChoice(super.user, this.jaggSQL, this.textchoicesql.getText(), this.tablelist.getSelectedItem(), this.tablewhereclause.getText());
            } else if (super.thisBranch.thisObject instanceof JDPList) {
               ((JDPList)super.thisBranch.thisObject).loadList(super.user, this.jaggSQL, this.textchoicesql.getText(), this.columnactuallist.getSelectedItem(), this.tablelist.getSelectedItem(), this.tablewhereclause.getText());
            }
         } else {
            String[] var1 = new String[maxChoices];
            String[] var2 = new String[maxChoices];
            boolean var3 = false;

            for(int var4 = 0; var4 < maxChoices; ++var4) {
               var1[var4] = this.textchoicevalue[var4].getText();
               var2[var4] = this.actualchoicevalue[var4].getText();
               if (!var1[var4].equals("") || !var2[var4].equals("")) {
                  var3 = true;
               }
            }

            if (var3) {
               if (super.thisBranch.thisObject instanceof JDPChoice) {
                  ((JDPChoice)super.thisBranch.thisObject).loadChoice(var1, var2);
               } else if (super.thisBranch.thisObject instanceof JDPComboBox) {
                  ((JDPComboBox)super.thisBranch.thisObject).loadChoice(var1);
               } else if (super.thisBranch.thisObject instanceof JDPList) {
                  ((JDPList)super.thisBranch.thisObject).loadList(var1, var2);
               }
            }
         }

         if (this.targetLayoutMgr != null && !this.targetLayoutMgr.projectLoading) {
            this.targetLayoutMgr.gSource.constructMethod(super.thisBranch, "Main");
            this.targetLayoutMgr.setButton("Layout");
            this.targetLayoutMgr.reDraw();
         }

      }
   }

   void loadTableList() {
      if (this.tableTarget != null) {
         this.tablelist.clear();

         for(int var1 = 0; var1 < this.tableTarget.tables.countItems(); ++var1) {
            this.tablelist.addItem(this.tableTarget.tables.getItem(var1), 1);
         }

         this.restoreSelections();
      }
   }

   void loadTables() {
      String var1 = this.targetDSN.datasource.getText().trim() + this.targetDSN.userid.getText() + this.targetDSN.password.getText();
      if (this.prevDSNString == null || !var1.equals(this.prevDSNString)) {
         this.prevDSNString = var1;
         int var3 = 0;
         String var5 = this.jaggSQL.getSEP();
         int var6 = 0;
         String var8 = "";
         this.tablelist.clear();
         String var9 = this.targetDSN.datasource.getText();
         if (var9.compareTo("") == 0) {
            JDPTabSelectPanel var18 = JDPUtils.getTabPanel(this);
            if (var18 != null) {
               var18.loadPrevTab();
            }

         } else {
            if (((Component)this).isShowing()) {
               super.user.mainmsg.setStatusMsg("Loading Table definitions, please wait...", 0);
            }

            this.jaggSQL.loadSettings(this.targetDSN);
            this.jaggSQL.setFCTN("SQLTables");
            this.jaggSQL.setMRW("100000");
            String[] var10 = new String[]{"TABLE", "VIEW"};
            int var11 = 0;

            for(int var12 = 0; var12 < var10.length; ++var12) {
               this.jaggSQL.setFCTNP(";;;" + var10[var12] + ";");
               Vector var4 = new Vector();
               var3 = this.jaggSQL.execSQL(var8, var4);
               if (var3 == -1) {
                  super.user.mainmsg.setStatusMsg("Could not connect to datasource. Please check the Connect String.", 20);
                  JDPTabSelectPanel var19 = JDPUtils.getTabPanel(this);
                  if (var19 != null) {
                     var19.loadPrevTab();
                  }

                  return;
               }

               if (super.user.DEBUG) {
                  System.out.println("JDPSelectTable/loadList COL: " + Integer.toString(this.jaggSQL.getColumnCount()));
               }

               this.jaggSQL.getColumnCount();
               var6 = this.jaggSQL.getRowCount();

               for(int var13 = 0; var13 < var6; ++var13) {
                  String var7 = (String)var4.elementAt(var13);
                  if (var7 != null && var7.trim().compareTo("") != 0) {
                     StringTokenizer var2 = new StringTokenizer(var7, var5);
                     this.tableQualifier = var2.nextToken().trim();
                     this.tableOwner = var2.nextToken().trim();
                     this.tableName = var2.nextToken().trim();
                     String var14 = "";
                     if (this.tableOwner.length() > 0) {
                        var14 = this.tableOwner + "." + this.tableName;
                     } else {
                        var14 = this.tableName;
                     }

                     String var15 = var2.nextToken().trim();
                     if (var15.equals("TABLE") || var15.equals("VIEW")) {
                        this.tablelist.addItem(var14, 1);
                        ++var11;
                     }
                  }
               }
            }

            super.user.mainmsg.clearStatusMsg();
         }
      }
   }

   void setDisplayType(String var1) {
      if (var1.equals("JDPComboBox")) {
         this.columnactuallist.hide();
         this.actualLabel.hide();

         for(int var4 = 0; var4 < this.actualchoicevalue.length; ++var4) {
            this.actualchoicevalue[var4].hide();
         }

         this.vlPanel.show();
      } else if (var1.equals("RadioButtons")) {
         this.columnactuallist.show();
         this.actualLabel.show();

         for(int var3 = 0; var3 < this.actualchoicevalue.length; ++var3) {
            this.actualchoicevalue[var3].show();
         }

         this.vlPanel.hide();
      } else {
         this.columnactuallist.show();
         this.actualLabel.show();

         for(int var2 = 0; var2 < this.actualchoicevalue.length; ++var2) {
            this.actualchoicevalue[var2].show();
         }

         this.vlPanel.show();
      }
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = this.moduleParameter;
      if (super.componentName.equals("")) {
         var2 = "";
      }

      String var3 = "JDPChoiceLayout" + var2 + super.componentName;
      if (!super.componentName.equals("")) {
         var3 = var3 + this.extraName;
      }

      var1.saveObject(this.valuesFrom, var3, "valuesFrom");
      var1.saveObject(this.textChoiceValue, var3, "textChoiceValue");
      var1.saveObject(this.actualChoiceValue, var3, "actualChoiceValue");
      var1.saveObject(this.tableList, var3, "tableList");
      var1.saveObject(this.columnTextList, var3, "columnTextList");
      var1.saveObject(this.columnActualList, var3, "columnActualList");
      var1.saveObject(this.columnDataType, var3, "columnDataType");
      var1.saveObject(this.textChoiceSql, var3, "textChoiceSql");
      var1.saveObject(this.tableWhereClause, var3, "tableWhereClause");
      return true;
   }

   void refresh() {
      this.clearFields();
      this.currentSelection = 0;
      this.retrieveColumns();
      this.loadList(this.currentSelection);
      this.loadTables();
      this.restoreSelections();
      this.loadItem(this.currentSelection);
      if (super.thisBranch != null) {
         this.setDisplayType(super.thisBranch.compType);
      }

   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.tableTarget = (JDPSelectTable)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("ScreenLayout" + super.componentName) == 0) {
               this.targetScreen = (JDPScreenLayout)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key != 9) {
               return false;
            } else {
               if (this.valuesfrom.getSelectedItem().compareTo("Fields entered here") == 0) {
                  if (var1.target.equals(this.valuesfrom)) {
                     super.user.u.cursor(this.textchoicevalue[0]);
                     return true;
                  }

                  for(int var2 = 0; var2 < maxChoices; ++var2) {
                     if (var1.target.equals(this.textchoicevalue[var2])) {
                        super.user.u.cursor(this.actualchoicevalue[var2]);
                        return true;
                     }

                     if (var1.target.equals(this.actualchoicevalue[var2])) {
                        super.user.u.cursor(this.textchoicevalue[var2 + 1]);
                        return true;
                     }
                  }

                  if (var1.target.equals(this.textchoicevalue[maxChoices])) {
                     super.user.u.cursor(this.actualchoicevalue[maxChoices]);
                     return true;
                  }

                  if (var1.target.equals(this.actualchoicevalue[maxChoices])) {
                     super.user.u.cursor(this.valuesfrom);
                     return true;
                  }
               }

               return true;
            }
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPList) {
               if (var1.target.equals(this.tablelist)) {
                  this.setColumnLists();
               }

               if (var1.target.equals(this.columntextlist)) {
                  this.textchoicesql.setText(this.columntextlist.getSelectedItem());
                  this.textChoiceSql[this.currentSelection] = this.columntextlist.getSelectedItem();
               }

               this.updateArrays(this.currentSelection);
               return true;
            }
         default:
            return false;
         case 1001:
            if (var1.target instanceof Button) {
               if (var1.arg.equals("Accept")) {
                  this.updateArrays(0);
                  this.saveSelections();
                  if (!super.componentName.equals("")) {
                     this.loadLayoutComponent();
                  }
               }

               return false;
            } else if (var1.target instanceof JDPComboBox) {
               this.updateArrays(this.currentSelection);
               return false;
            } else {
               return true;
            }
      }
   }

   void setColumnLists() {
      if (this.target == null || this.target.tableIndex >= 0) {
         String var1 = "";
         String var2 = this.tablelist.getSelectedItem();
         int var3 = var2.indexOf(".");
         if (var3 >= 0) {
            var2 = var2.substring(var3 + 1);
         }

         var1 = ";;" + var2 + ";;";
         int var4 = var2.indexOf(".");
         if (var4 >= 0) {
            var1 = ";" + var2.substring(0, var4) + ";" + var2.substring(var4 + 1) + ";;";
         }

         if (this.tableTarget != null) {
            this.jaggSQL.loadSettings(this.tableTarget.targetDSN);
         } else {
            this.jaggSQL.loadSettings(this.targetDSN);
         }

         if (this.prevTableString == null || !var1.equals(this.prevTableString) || this.columntextlist.countItems() <= 0) {
            this.prevTableString = var1;
            int var6 = 0;
            Vector var7 = new Vector();
            String var8 = this.jaggSQL.getSEP();
            int var9 = 0;
            String var11 = "";
            if (this.tablelist.getSelectedItem().compareTo("") == 0) {
               if (super.componentName.equals("")) {
                  super.user.mainmsg.setStatusMsg("You must first select a table.", 5);
               }

            } else {
               this.columntextlist.clear();
               this.columnactuallist.clear();
               this.columndatatype.clear();
               super.user.mainmsg.setStatusMsg("Accessing database...", 0);
               this.jaggSQL.setFCTN("SQLColumns");
               this.jaggSQL.setFCTNP(var1);
               var6 = this.jaggSQL.execSQL(var11, var7);
               this.jaggSQL.setFCTN("");
               this.jaggSQL.setFCTNP("");
               if (var6 == -1) {
                  super.user.u.setSqlMessage(this.jaggSQL, var11);
               } else {
                  if (super.user.DEBUG) {
                     System.out.println("JDPSelectColumns/loadList COL: " + Integer.toString(this.jaggSQL.getColumnCount()));
                  }

                  var9 = this.jaggSQL.getRowCount();

                  for(int var12 = 0; var12 < var9; ++var12) {
                     String var10 = (String)var7.elementAt(var12);
                     if (var10 != null && var10.trim().compareTo("") != 0) {
                        StringTokenizer var5 = new StringTokenizer(var10);
                        String var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        this.columntextlist.addItem(var13, 8);
                        this.columnactuallist.addItem(var13, 8);
                        var13 = var5.nextToken(var8).trim();
                        this.columndatatype.addItem(var13);
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                        var13 = var5.nextToken(var8).trim();
                     }
                  }

                  super.user.mainmsg.clearStatusMsg();
               }
            }
         }
      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = this.moduleParameter;
      if (super.componentName.equals("")) {
         var2 = "";
      }

      String var3 = "JDPChoiceLayout" + var2 + super.componentName;
      if (!super.componentName.equals("")) {
         var3 = var3 + this.extraName;
      }

      var1.removeObject(this.valuesFrom, var3, "valuesFrom");
      var1.removeObject(this.textChoiceValue, var3, "textChoiceValue");
      var1.removeObject(this.actualChoiceValue, var3, "actualChoiceValue");
      var1.removeObject(this.tableList, var3, "tableList");
      var1.removeObject(this.columnTextList, var3, "columnTextList");
      var1.removeObject(this.columnActualList, var3, "columnActualList");
      var1.removeObject(this.columnDataType, var3, "columnDataType");
      var1.removeObject(this.textChoiceSql, var3, "textChoiceSql");
      var1.removeObject(this.tableWhereClause, var3, "tableWhereClause");
      return true;
   }

   void loadItem(int var1) {
      for(int var2 = 0; var2 < maxChoices; ++var2) {
         this.textchoicevalue[var2].setText(this.textChoiceValue[var1][var2]);
         this.actualchoicevalue[var2].setText(this.actualChoiceValue[var1][var2]);
      }

      this.valuesfrom.select(this.valuesFrom[var1]);

      for(int var3 = 0; var3 < this.tablelist.countItems(); ++var3) {
         if (this.tableList[var1] != null && this.tablelist.getItem(var3).compareTo(this.tableList[var1]) == 0) {
            this.tablelist.select(var3);
            this.tablelist.makeVisible(var3);
            this.setColumnLists();
         }
      }

      for(int var4 = 0; var4 < this.columntextlist.countItems(); ++var4) {
         if (this.columnTextList[var1] != null && this.columntextlist.getItem(var4).compareTo(this.columnTextList[var1]) == 0) {
            this.columntextlist.select(var4);
            this.columntextlist.makeVisible(var4);
         }

         if (this.columnActualList[var1] != null && this.columnactuallist.getItem(var4).compareTo(this.columnActualList[var1]) == 0) {
            this.columnactuallist.select(var4);
            this.columnactuallist.makeVisible(var4);
            this.columndatatype.select(var4);
         }
      }

      this.textchoicesql.setText(this.textChoiceSql[var1]);
      this.tablewhereclause.setText(this.tableWhereClause[var1]);
      ((CardLayout)this.cardChoicePanel.getLayout()).show(this.cardChoicePanel, this.valuesfrom.getSelectedItem());
      this.currentSelection = var1;
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.targetPanel = var2;
      this.moduleParameter = var3;
      super.moduleName = "ChoiceLayout";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
         int var4 = super.componentName.indexOf(":");
         if (var4 >= 0) {
            this.extraName = super.componentName.substring(var4 + 1);
            super.componentName = super.componentName.substring(0, var4);
         }

         this.moduleParameter = "";
         this.initList(1);
      }

      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.loadSettings(var1);
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      JDPScrollPanel var17 = new JDPScrollPanel();
      this.cardChoicePanel = new Panel();
      this.cardChoicePanel.setLayout(new CardLayout());
      JDPScrollPanel var5 = new JDPScrollPanel();
      this.valuesfrom = new JDPComboBox(var1, "", 20);
      this.valuesfrom.setEditable(false);
      this.valuesfrom.addItem("Fields entered here");
      this.valuesfrom.addItem("Database table/columns");
      this.vlPanel = new Panel();
      this.vlPanel.setLayout(new JDPLineLayout(1));
      this.vlPanel.add("Left", new JDPWrapLabel(var1, "Values come from:"));
      this.vlPanel.add("Left", this.valuesfrom);
      ((Container)var17).add("Left", this.vlPanel);
      ((Container)var5).add("Left", new JDPWrapLabel(var1, "Text/Actual:"));
      this.textchoicevalue = new TextField[maxChoices];
      this.actualchoicevalue = new TextField[maxChoices];
      Panel[] var6 = new Panel[maxChoices];

      for(int var7 = 0; var7 < maxChoices; ++var7) {
         if (var7 > 0) {
            ((Container)var5).add("Left", new Panel());
         }

         this.textchoicevalue[var7] = new TextField("", 15);
         this.actualchoicevalue[var7] = new TextField("", 10);
         var6[var7] = new Panel();
         var6[var7].setLayout(new JDPLineLayout(1));
         var6[var7].add("Left", this.textchoicevalue[var7]);
         var6[var7].add("Left", this.actualchoicevalue[var7]);
         ((Container)var5).add("Right", var6[var7]);
      }

      this.tablelist = new JDPList(var1);
      this.tablelist.setMinHeight(84);
      this.tablelist.setMinWidth(110);
      this.columntextlist = new JDPList(var1);
      this.columntextlist.setMinHeight(84);
      this.columntextlist.setMinWidth(110);
      this.columnactuallist = new JDPList(var1);
      this.columnactuallist.setMinHeight(84);
      this.columnactuallist.setMinWidth(110);
      this.columndatatype = new JDPList(var1);
      Panel var18 = new Panel();
      ((Container)var18).setLayout(new BorderLayout());
      ((Container)var18).add("Center", this.tablelist);
      ((Container)var18).add("North", new JDPWrapLabel(var1, "Table:"));
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      ((Container)var8).add("Center", this.columntextlist);
      ((Container)var8).add("North", new JDPWrapLabel(var1, "Pulldown:"));
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      ((Container)var9).add("Center", this.columnactuallist);
      this.actualLabel = new JDPWrapLabel(var1, "Actual:");
      ((Container)var9).add("North", this.actualLabel);
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new JDPLineLayout(1));
      ((Container)var10).add("Left", var18);
      ((Container)var10).add("Left", var8);
      ((Container)var10).add("Left", var9);
      JDPScrollPanel var11 = new JDPScrollPanel();
      this.tablewhereclause = new TextField("(1=1)", 25);
      ((Container)var11).add("Left", var10);
      JDPScrollPanel var12 = new JDPScrollPanel();
      this.textchoicesql = new TextField("", 25);
      ((Container)var12).add("Left", new JDPWrapLabel(var1, "Pulldown SQL Clause:"));
      ((Container)var12).add("Right", this.textchoicesql);
      ((Container)var12).add("Left", new JDPWrapLabel(var1, "Special Where Clause:"));
      ((Container)var12).add("Right", this.tablewhereclause);
      ((Container)var11).add("Left", var12);
      this.cardChoicePanel.add("Fields entered here", var5);
      this.cardChoicePanel.add("Database table/columns", var11);
      ((Container)var17).add("Left", this.cardChoicePanel);
      this.retrieveColumns();
      if (this.tableTarget == null) {
         this.gParmObject = new Vector();
         this.gParmObject.addElement(super.moduleName + super.componentName);
         this.gParmObject.addElement(this);
         var1.gParm.addElement(this.gParmObject);
         String[] var13 = new String[]{"Accept", "Reset"};
         int[] var14 = new int[]{5, 6};
         JDPButtons var15 = new JDPButtons(var1, var13, var14, JDPButtons.HORIZONTAL);
         Panel var16 = new Panel();
         ((Container)var16).setLayout(new BorderLayout());
         ((Container)var16).add("Center", var17);
         ((Container)var16).add("South", var15);
         this.popuppanel.addComponent(var15.button[0], "Accept Selections", "Accept selections and proceed to next screen");
         this.popuppanel.addComponent(var15.button[1], "Reset Selections", "Reset selections back to default settings");
         this.currentSelection = 0;
         ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Define the choice entries", var16, "North"));
      } else {
         ((Container)this).add("Center", var17);
      }

      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
