import java.util.Vector;

public class JDPCommandExecuter {
   JDPUser user;
   JDPJagg jaggSQL;
   public boolean success;
   public Vector results;
   String errorMessage = "";

   public boolean execCommand(String var1, String var2, String var3, String var4) {
      this.success = false;
      if (this.user != null) {
         this.user.mainmsg.setStatusMsg(var2, 0);
      }

      this.results = new Vector();
      this.jaggSQL.setFCTN("System");
      this.jaggSQL.setFCTNP("");
      this.errorMessage = "";
      int var5 = this.jaggSQL.execSQL(var1, this.results);
      this.errorMessage = this.jaggSQL.getError();
      this.jaggSQL.setFCTN("");
      if (!var3.equals("")) {
         if (var5 == 0) {
            if (this.user != null) {
               this.user.mainmsg.setStatusMsg(var3, 5);
            }

            this.success = true;
         } else if (var5 < 0) {
            if (this.user != null) {
               this.user.mainmsg.setStatusMsg(var4, 5);
            }
         } else if (this.user != null) {
            this.user.mainmsg.setStatusMsg(var4, 5);
         }
      } else if (var5 == 0) {
         this.success = true;
      }

      return this.success;
   }

   public boolean getCommandResult() {
      return this.success;
   }

   public String getCommandError() {
      return this.errorMessage;
   }

   public JDPCommandExecuter(JDPUser var1) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.setDSN(var1.jaggDSN);
   }

   public JDPCommandExecuter(JDPJagg var1) {
      this.user = null;
      this.jaggSQL = var1;
   }

   public JDPCommandExecuter(JDPUser var1, String var2, String var3, String var4, String var5) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      this.execCommand(var2, var3, var4, var5);
   }

   public Vector getCommandResultVector() {
      return this.results;
   }
}
