import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.LayoutManager;
import java.awt.List;
import java.awt.Panel;
import java.awt.Rectangle;
import java.awt.Scrollbar;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.TextField;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPComponentMgr extends JDPClassLayout {
   JDPLayoutMgr target;
   Panel targetPanel;
   JDPTreePicker tree;
   JDPTreeBranch currentBranch;
   JDPPopupMessage popuppanel;
   JDPDragItem dragPanel;
   JDPTabSelectPanel tabPanel;
   Panel[] tabpanels;
   List columns;
   TextField compName;
   JDPTextGrid compProps;
   JDPButton propsButton;
   JDPComboBox propsChoice;
   JDPButton choiceButton;
   JDPButton removePropButton;
   Panel compPropsPanel;
   Panel compPropsPanel1;
   String saveButton = "Layout";
   JDPTreeBranch lastChoiceBranch;
   String testProps = "Pos:Layout:Popup:Status:Tab to:Back to:Font:Style:Size:FColor:BColor:Editable:Dft:";

   Font getFontProperties() {
      if (this.currentBranch.properties == null) {
         return ((Component)this).getFont();
      } else {
         try {
            for(int var1 = 0; var1 < this.currentBranch.properties[0].length; ++var1) {
               if (this.currentBranch.properties[0][var1] != null && this.currentBranch.properties[0][var1].equals("Font:")) {
                  String var2 = this.currentBranch.properties[1][var1 + 1];
                  byte var3 = 0;
                  if (var2.equals("Bold")) {
                     var3 = 1;
                  }

                  if (var2.equals("Italic")) {
                     var3 = 2;
                  }

                  if (var2.equals("Bold Italic")) {
                     var3 = 3;
                  }

                  return new Font(this.currentBranch.properties[1][var1], var3, Integer.parseInt(this.currentBranch.properties[1][var1 + 2]));
               }
            }
         } catch (Exception var4) {
         }

         return ((Component)this).getFont();
      }
   }

   void updateProperties(int var1) {
      JDPTreePicker var2 = this.target.lView.tree;
      JDPTreeBranch var3 = this.currentBranch;
      Component var4 = null;
      if (var3.thisObject instanceof Component) {
         var4 = (Component)var3.thisObject;
      }

      this.checkPropertiesArray(var3);
      this.target.setAppChanged(true);
      String var5 = var3.compType;
      String var6 = var3.compPosition;
      String var7 = this.getProperty("Pos:");
      Container var8 = null;
      JDPTreeBranch var9 = this.target.compTree;
      if (var4 != null) {
         var8 = var4.getParent();
         var9 = this.target.layoutTree.getBranch((Component)var8);
      }

      if (var1 < 0) {
         if (!var3.name.equals(this.compName.getText())) {
            JDPTreeBranch var33 = this.target.layoutTree.getBranch(this.compName.getText());
            if (var33 != null) {
               super.user.mainmsg.setStatusMsg("A component with this name already exists. Please choose another name.", 8);
            } else {
               super.user.mainmsg.clearStatusMsg();
               String var43 = var3.name;
               this.target.interactionMgr.replaceName(this.target.compTree, var43, this.compName.getText());
               this.target.interactionMgr.replaceName(var43, this.compName.getText());
               var3.name = this.compName.getText();
               this.target.interactionMgr.extractMethodNames(this.target.interactionMgr.methodTree, var3, false);
               if (var3.relatedComps != null) {
                  for(int var48 = 0; var48 < var3.relatedComps.length; ++var48) {
                     ((JDPClassLayout)var3.relatedComps[var48]).removeSelections();
                     ((JDPClassLayout)var3.relatedComps[var48]).setComponentName(this.compName.getText());
                     ((JDPClassLayout)var3.relatedComps[var48]).saveSelections();
                  }
               }

               if (this.target.buttonPanel == null || this.target.buttonPanel.getPressed() == null || this.target.buttonPanel.getPressed().equals("Source")) {
                  this.target.loadList(var3);
                  this.target.loadSource(var3, 0);
               }

               var2.nothingChanged = false;
               ((Component)var2).repaint();
            }
         }
      } else {
         if (var5.equals("TextField") || var5.equals("JDPTextField")) {
            int var10 = Integer.parseInt(this.getProperty("Cols:"));
            if (var10 != ((TextField)var4).getColumns()) {
               String var11 = ((TextField)var4).getText();
               var8.remove(var4);
               var3.thisObject = new TextField(var11, var10);
               var4 = (Component)var3.thisObject;
               var8.add(var3.compPosition, var4);
               if (var8 instanceof JDPScrollPanel) {
                  this.target.reLoadComponents(var9);
               }
            }
         }

         if (var5.equals("JDPSpinner")) {
            int var23 = Integer.parseInt(this.getProperty("Cols:"));
            if (var23 != ((JDPSpinner)var4).getColumns()) {
               var8.remove(var4);
               var3.thisObject = new JDPSpinner(super.user, "", var23);
               var4 = (Component)var3.thisObject;
               var8.add(var3.compPosition, var4);
               if (var8 instanceof JDPScrollPanel) {
                  this.target.reLoadComponents(var9);
               }
            }
         }

         if (var5.equals("JDPDate")) {
            int var24 = Integer.parseInt(this.getProperty("Cols:"));
            if (var24 != ((JDPDate)var4).getColumns()) {
               String var34 = ((JDPDate)var4).getText();
               var8.remove(var4);
               var3.thisObject = new JDPDate(super.user, var34, var24);
               var4 = (Component)var3.thisObject;
               var8.add(var3.compPosition, var4);
               if (var8 instanceof JDPScrollPanel) {
                  this.target.reLoadComponents(var9);
               }
            }
         }

         if (var5.equals("TextArea")) {
            int var25 = Integer.parseInt(this.getProperty("Cols:"));
            int var35 = Integer.parseInt(this.getProperty("Rows:"));
            if (var25 != ((TextArea)var4).getColumns() || var35 != ((TextArea)var4).getRows()) {
               String var12 = ((TextArea)var4).getText();
               var8.remove(var4);
               var3.thisObject = new TextArea(var12, var35, var25);
               var4 = (Component)var3.thisObject;
               var8.add(var3.compPosition, var4);
               if (var8 instanceof JDPScrollPanel) {
                  this.target.reLoadComponents(var9);
               }
            }
         }

         if (var4 instanceof TextComponent) {
            ((TextComponent)var3.thisObject).setText(this.getProperty("Dft:"));
            if (this.getProperty("Editable:").equals("false")) {
               ((TextComponent)var3.thisObject).setEditable(false);
            } else {
               ((TextComponent)var3.thisObject).setEditable(true);
            }
         }

         if (var5.equals("Panel") || var5.equals("JDPColumns") || var5.startsWith("JDPWiz") || var4 instanceof Container && ((Container)var4).getLayout() != null) {
            String var26 = ((Container)var4).getLayout().toString();
            String var36 = this.getProperty("Layout:");
            if (var36 != null && (var26.indexOf(var36) < 0 || var36.equals("GridLayout"))) {
               try {
                  if (var36.equals("BorderLayout")) {
                     ((Container)var3.thisObject).setLayout(new BorderLayout(1, 1));
                  }

                  if (var36.equals("CardLayout")) {
                     ((Container)var3.thisObject).setLayout(new CardLayout());
                  }

                  if (var36.equals("FlowLayout")) {
                     ((Container)var3.thisObject).setLayout(new FlowLayout());
                  }

                  if (var36.equals("GridBagLayout")) {
                     ((Container)var3.thisObject).setLayout(new GridBagLayout());
                  }

                  if (var36.equals("GridLayout")) {
                     int var44 = 0;

                     try {
                        var44 = Integer.parseInt(this.getProperty("Rows:"));
                     } catch (Exception var20) {
                        var44 = 2;
                     }

                     int var13 = 0;

                     try {
                        var13 = Integer.parseInt(this.getProperty("Cols:"));
                     } catch (Exception var19) {
                        var13 = 2;
                     }

                     int var14 = var26.indexOf("rows=");
                     int var15 = -1;
                     int var16 = -1;
                     if (var26.indexOf("GridLayout") >= 0) {
                        String var17 = var26.substring(var14 + 5, var26.indexOf(",", var14));
                        var14 = var26.indexOf("cols=");
                        String var18 = var26.substring(var14 + 5, var26.indexOf("]", var14));
                        var15 = Integer.parseInt(var17);
                        var16 = Integer.parseInt(var18);
                     }

                     if (var15 != var44 || var16 != var13) {
                        ((Container)var3.thisObject).setLayout(new GridLayout(var44, var13));
                        if (!this.target.projectLoading) {
                           this.target.reLoadComponents(var9);
                           if (var15 < 0) {
                              this.setProperties(var3);
                           }
                        }
                     }
                  } else {
                     if (var36.equals("JDPLineLayout")) {
                        ((Container)var3.thisObject).setLayout(new JDPLineLayout(3));
                     }

                     if (var36.equals("JDPRowLayout")) {
                        ((Container)var3.thisObject).setLayout(new JDPRowLayout(3, 1));
                     }

                     if (!this.target.projectLoading) {
                        this.target.reLoadComponents(var9);
                        this.setProperties(var3);
                     }
                  }
               } catch (Exception var22) {
               }
            }
         }

         if (var5.equals("JDPSplitPanel")) {
            ((JDPSplitPanel)var3.thisObject).setLeftPercentage(Float.valueOf(this.getProperty("LeftPercentage:")));
            ((JDPSplitPanel)var3.thisObject).setTopPercentage(Float.valueOf(this.getProperty("TopPercentage:")));
         }

         if (var5.equals("Label")) {
            ((Label)var3.thisObject).setText(this.getProperty("Label:"));
         }

         if (var5.equals("Checkbox") || var5.equals("CheckboxGroup")) {
            ((Checkbox)var3.thisObject).setLabel(this.getProperty("Label:"));
         }

         if (var5.equals("CheckboxGroup")) {
            ((Checkbox)var3.thisObject).setCheckboxGroup(this.target.cbgroup[this.getPropertyIndex("Group:")]);
         }

         if (var5.equals("Button")) {
            ((Button)var3.thisObject).setLabel(this.getProperty("Label:"));
         }

         if (var5.equals("Scrollbar")) {
            int var27 = Integer.parseInt(this.getProperty("Min:"));
            int var37 = Integer.parseInt(this.getProperty("Max:"));
            int var46 = Integer.parseInt(this.getProperty("Value:"));
            int var50 = Integer.parseInt(this.getProperty("Vis:"));
            String var53 = this.getProperty("Align:");
            byte var54 = 1;
            if (var53.equals("Horizontal")) {
               var54 = 0;
            }

            int var55 = ((Scrollbar)var4).getOrientation();
            if (var55 != var54) {
               var8.remove(var4);
               this.currentBranch.thisObject = new Scrollbar(var54, var46, var50, var27, var37);
               var4 = (Component)var3.thisObject;
               var8.add(var6, (Component)this.currentBranch.thisObject);
            } else {
               ((Scrollbar)var3.thisObject).setValues(var46, var50, var27, var37);
            }
         }

         if (var5.equals("JDPButton")) {
            if (this.getProperty("Labels:").equals("No")) {
               ((JDPButton)var3.thisObject).setIconOnly(true);
            } else {
               ((JDPButton)var3.thisObject).setIconOnly(false);
            }

            ((JDPButton)var3.thisObject).setLabel(this.getProperty("Label:"));
            ((JDPButton)var3.thisObject).setIcon(this.getProperty("Icon:"));
            int var28 = JDPButton.getAlignmentValue(this.getProperty("Align:"));
            ((JDPButton)var3.thisObject).setAlignment(var28);
         }

         if (var5.equals("JDPButtons")) {
            if (this.getProperty("Labels:").equals("No")) {
               ((JDPButtons)var3.thisObject).setIconsOnly(true);
            } else {
               ((JDPButtons)var3.thisObject).setIconsOnly(false);
            }

            int var29 = JDPButtons.getAlignmentValue(this.getProperty("Align:"));
            ((JDPButtons)var3.thisObject).setAlignment(var29);
            int var38 = ((JDPButtons)var3.thisObject).getButtonCount();
            int var47 = Integer.parseInt(this.getProperty("# Btns:"));
            ((JDPButtons)var3.thisObject).setButtonCount(var47);

            for(int var51 = 0; var51 < var47; ++var51) {
               ((JDPButtons)var3.thisObject).setLabel(var51, this.getProperty("Btn#" + Integer.toString(var51) + ":"));
               ((JDPButtons)var3.thisObject).setIcon(var51, this.getProperty("Icon#" + Integer.toString(var51) + ":"));
            }

            if (var38 != var47) {
               this.setProperties(var3);
               this.target.interactionMgr.setProperties(var3);
            }
         }

         if (var5.equals("JDPChiselFramePanel")) {
            ((JDPChiselFramePanel)var3.thisObject).setTitle(this.getProperty("Title:"));
         }

         if (var5.equals("JDPTabSelectPanel")) {
            try {
               int var30 = Integer.parseInt(this.getProperty("# Tabs:"));

               for(int var39 = 0; var39 < var30; ++var39) {
                  ((JDPTabSelectPanel)var3.thisObject).setTabname(var39, this.getProperty("Tab#" + Integer.toString(var39) + ":"));
                  ((JDPTabSelectPanel)var3.thisObject).setTabcolor(var39, super.user.u._cvtcolor(this.getProperty("FCol#" + Integer.toString(var39) + ":")), super.user.u._cvtcolor(this.getProperty("BCol#" + Integer.toString(var39) + ":")));
                  ((JDPTabSelectPanel)var3.thisObject).setTabIcon(var39, this.getProperty("Icon#" + Integer.toString(var39) + ":"));
               }
            } catch (Exception var21) {
            }
         }

         if (var5.equals("JDPTreePicker")) {
            ((JDPTreePicker)var3.thisObject).setRoot(this.getProperty("Title:"), true);
         }

         if (var5.equals("JDPBrowser")) {
            ((JDPBrowser)var3.thisObject).setDocname(this.getProperty("Doc path:"));
         }

         if (var5.equals("JDPBrowserCtl")) {
            ((JDPBrowserCtl)var3.thisObject).setDocname(this.getProperty("Doc path:"));
         }

         if (var5.equals("JDPImage")) {
            ((JDPImage)var3.thisObject).setImagePath(this.getProperty("Path:"));
            if (this.getProperty("Width:").equals("0")) {
               if (((JDPImage)var3.thisObject).getDimension().width > 0) {
                  this.setProperty("Width:", Integer.toString(((JDPImage)var3.thisObject).getDimension().width));
                  this.setProperty("Height:", Integer.toString(((JDPImage)var3.thisObject).getDimension().height));
                  this.repaintGrid();
               }
            } else {
               Dimension var31 = new Dimension(Integer.parseInt(this.getProperty("Width:")), Integer.parseInt(this.getProperty("Height:")));
               ((JDPImage)var3.thisObject).setDimension(var31);
            }
         }

         if (var4 != null && var4 instanceof Component) {
            Font var32 = this.getFontProperties();
            if (var32 != null) {
               var4.setFont(var32);
            }

            if (!this.getProperty("FColor:").equals("")) {
               Color var40 = super.user.u._cvtcolor(this.getProperty("FColor:"));
               if ((var4.getForeground() == null || !var4.getForeground().equals(var40)) && var40 != null) {
                  var4.setForeground(var40);
               }
            }

            if (!this.getProperty("BColor:").equals("")) {
               Color var41 = super.user.u._cvtcolor(this.getProperty("BColor:"));
               if ((var4.getBackground() == null || !var4.getBackground().equals(var41)) && var41 != null) {
                  var4.setBackground(var41);
               }
            }

            if ((this.getProperty("Enabled:").equals("Yes") || this.getProperty("Enabled:").equals("true")) && !var4.isEnabled()) {
               var4.enable();
            } else if ((this.getProperty("Enabled:").equals("No") || this.getProperty("Enabled:").equals("false")) && var4.isEnabled()) {
               var4.disable();
            }

            if (!this.getProperty("Visible:").equals("No") && !this.getProperty("Visible:").equals("false")) {
               if (!var4.isVisible() && (this.getProperty("Visible:").equals("Yes") || this.getProperty("Visible:").equals("true"))) {
                  var4.show();
               }
            } else {
               var4.hide();
            }

            if (var3.properties != null && var1 < var3.properties[0].length && (var3.properties[0][var1].startsWith("Popup") || var3.properties[0][var1].startsWith("Status"))) {
               if (var4 instanceof JDPButtons) {
                  for(int var42 = 0; var42 < Integer.parseInt(this.getProperty("# Btns:")); ++var42) {
                     this.target.popuppanel.removeComponent(((JDPButtons)var3.thisObject).button[var42]);
                     this.target.popuppanel.addComponent(((JDPButtons)var3.thisObject).button[var42], this.getProperty("Popup" + Integer.toString(var42) + ":"), this.getProperty("Status" + Integer.toString(var42) + ":"));
                  }
               } else {
                  this.target.popuppanel.removeComponent(var4);
                  this.target.popuppanel.addComponent(var4, this.getProperty("Popup:"), this.getProperty("Status:"));
               }
            }
         }

         this.updateOtherProperties(var3, var1);
         var2.nothingChanged = false;
         ((Component)var2).repaint();
         if (!this.target.projectLoading) {
            if (var6 == null || var7 == null || !var6.equals(var7)) {
               var3.compPosition = var7;
               this.target.reLoadComponents(var9);
               return;
            }

            this.target.reDraw();
         }

      }
   }

   String getProperty(String var1) {
      if (var1 == null) {
         return "";
      } else if (this.currentBranch.properties == null) {
         return "";
      } else if (this.currentBranch.properties.length == 0) {
         return "";
      } else if (this.currentBranch.properties[0].length == 0) {
         return "";
      } else if (this.currentBranch.properties[0][0] == null) {
         return "";
      } else {
         for(int var2 = 0; var2 < this.currentBranch.properties[0].length; ++var2) {
            if (this.currentBranch.properties[0][var2].equals(var1)) {
               return this.currentBranch.properties[1][var2];
            }
         }

         return "";
      }
   }

   void setProperty(String var1, String var2) {
      if (this.currentBranch.properties != null) {
         if (this.currentBranch.properties[0][0] != null) {
            for(int var3 = 0; var3 < this.currentBranch.properties[0].length; ++var3) {
               if (this.currentBranch.properties[0][var3].equals(var1)) {
                  this.currentBranch.properties[1][var3] = var2;
                  this.compProps.currentText[0][var3] = var2;
                  return;
               }
            }

         }
      }
   }

   String getProperty(JDPTreeBranch var1, String var2) {
      if (var1.properties == null) {
         return "";
      } else if (var1.properties[0][0] == null) {
         return "";
      } else {
         for(int var3 = 0; var3 < var1.properties[0].length; ++var3) {
            if (var1.properties[0][var3].equals(var2)) {
               return var1.properties[1][var3];
            }
         }

         return "";
      }
   }

   void loadOtherProperties(JDPTreeBranch var1) {
      if (var1.properties != null) {
         int var2 = var1.properties[0].length;

         for(int var3 = 0; var3 < var2; ++var3) {
            if (var1.properties[2][var3] != null && (!var1.properties[2][var3].endsWith("||") && var1.properties[2][var3].indexOf("|") >= 0 || !this.propAlreadyDrawn(var1.properties[0][var3]))) {
               String var5 = var1.properties[0][var3];
               if (var1.properties[2][var3] != null && !var1.properties[2][var3].endsWith("||")) {
                  var5 = null;
               }

               int var4;
               if ((var4 = this.getPropPos(var1, var5)) >= 0) {
                  this.addProperty(var1, var3, var4);
               }
            }
         }

      }
   }

   void setGridWidth(int var1) {
      if (this.compPropsPanel.countComponents() == 0) {
         this.compProps.rowHeaderWidth = (int)((double)this.compPropsPanel1.bounds().width * (double)0.25F);
         this.compProps.columnWidth[0] = (int)((double)this.compPropsPanel1.bounds().width * 0.65);
      } else {
         this.compProps.rowHeaderWidth = (int)((double)var1 * (double)0.25F);
         this.compProps.columnWidth[0] = (int)((double)var1 * 0.65);
      }
   }

   void loadEmptyGrid() {
      short var1 = 200;
      this.compProps.currentText = new String[1][var1];
      this.compProps.rowKey = new String[1][var1];
      this.compProps.cellChanged = null;
      this.compProps.rowChanged = null;
      this.compProps.columnSelected = null;
      this.compProps.columnHeader = new String[1];
      this.compProps.columnHeaderStyle = new int[1];
      this.compProps.columnStyle = new int[1];
      this.compProps.columnHeaderColor = new Color[1];
      this.compProps.columnColor = new Color[1];
      this.compProps.columnBGColor = new Color[1];
      this.compProps.columnProtected = new boolean[1];
      this.compProps.columnWidth = new int[1];
      this.compProps.rightJustify = new boolean[1];
      this.compProps.rowHeader = null;
      this.compProps.columnHeight = null;
      this.compProps.isPullDownCol = null;
      this.compProps.pullDownList = null;
      this.compProps.rowHeader = new String[var1];
      this.compProps.rowHeaderWidth = 50;
      this.compProps.scrollSouthDisabled = true;
      this.compProps.rowHeadJustify = "Left";
      if (this.compProps.scrollSouth != null) {
         this.compProps.remove(this.compProps.scrollSouth);
      }

      this.compProps.columnHeaderStyle[0] = 1;
      this.compProps.columnStyle[0] = 0;
      this.compProps.columnHeaderColor[0] = Color.black;
      this.compProps.columnColor[0] = Color.black;
      this.compProps.columnBGColor[0] = Color.white;
      this.compProps.columnStyle[0] = 0;
      this.compProps.columnHeader[0] = "Value";
      this.repaintGrid();
   }

   void repaintGrid() {
      this.compProps.newTable();
      this.setGridWidth(this.tree.bounds().width);
      this.compProps.layout();
      this.compProps.reDraw();
   }

   void emptyGrid() {
      for(int var1 = 0; var1 < this.compProps.rowHeader.length; ++var1) {
         this.compProps.rowHeader[var1] = "";
         this.compProps.currentText[0][var1] = "";
         this.compProps.fieldProtected[0][var1] = true;
         this.compProps.isPullDown[0][var1] = false;
         this.compProps.rowKey[0][var1] = null;
      }

      this.repaintGrid();
   }

   Vector getComponentList(JDPTreeBranch var1, Vector var2) {
      if (var2 == null) {
         var2 = new Vector();
      }

      var2.addElement(var1.name);

      for(int var3 = 0; var3 < var1.leaves.size(); ++var3) {
         JDPTreeBranch var4 = (JDPTreeBranch)var1.leaves.elementAt(var3);
         this.getComponentList(var4, var2);
      }

      return var2;
   }

   void addProperty(JDPTreeBranch var1, String var2, String var3) {
      var2 = var2 + ":";
      if (this.propSelected(var1, var2) >= 0 && var3.endsWith("||")) {
         super.user.mainmsg.setStatusMsg("Property is already selected", 10);
      } else {
         int var4 = var1.properties[0].length + 1;
         String[][] var5 = new String[3][var4];

         for(int var6 = 0; var6 < var1.properties[0].length; ++var6) {
            var5[0][var6] = var1.properties[0][var6];
            var5[1][var6] = var1.properties[1][var6];
            var5[2][var6] = var1.properties[2][var6];
         }

         int var8 = var1.properties[0].length;
         var5[0][var8] = var2;
         var5[1][var8] = "";
         var5[2][var8++] = var3;
         var1.properties = var5;
         this.setProperties(var1);
      }
   }

   void addProperty(JDPTreeBranch var1, int var2, int var3) {
      this.compProps.rowHeader[var3] = var1.properties[0][var2];
      this.compProps.rowKey[0][var3] = var1.properties[2][var2];
      var1.properties[0][var2].substring(0, var1.properties[0][var2].length() - 1);
      if (var1.properties[2][var2] == null) {
         var1.properties[2][var2] = "";
      }

      StringTokenizer var4 = new StringTokenizer(var1.properties[2][var2], "|");
      String[] var5 = new String[var4.countTokens()];

      for(int var6 = 0; var4.hasMoreTokens(); var5[var6++] = var4.nextToken()) {
      }

      for(int var7 = 0; var7 < var5.length; ++var7) {
         if (var5[var7] == null) {
            return;
         }

         if (var5.length == 1 && var5[var7].equals("boolean")) {
            this.compProps.fieldProtected[0][var3] = true;
            this.compProps.isPullDown[0][var3] = true;
            this.compProps.pullDownList[0][var3] = new List();
            this.compProps.pullDownList[0][var3].addItem("true");
            this.compProps.pullDownList[0][var3].addItem("false");
         } else if (var5.length == 1 && var5[var7].equals("java.awt.LayoutManager")) {
            this.compProps.fieldProtected[0][var3] = true;
            this.compProps.isPullDown[0][var3] = true;
            this.compProps.pullDownList[0][var3] = new List();
            this.compProps.pullDownList[0][var3].addItem("BorderLayout");
            this.compProps.pullDownList[0][var3].addItem("FlowLayout");
            this.compProps.pullDownList[0][var3].addItem("GridLayout");
            this.compProps.pullDownList[0][var3].addItem("JDPLineLayout");
            this.compProps.pullDownList[0][var3].addItem("JDPRowLayout");
         } else {
            this.compProps.fieldProtected[0][var3] = false;
            this.compProps.isPullDown[0][var3] = false;
            this.compProps.pullDownList[0][var3] = null;
         }

         String var8 = null;
         if (!this.target.projectLoading) {
            var8 = this.getOtherProperties(var1, var2);
         }

         if (var8 != null) {
            this.compProps.currentText[0][var3] = var8;
         } else {
            this.compProps.currentText[0][var3] = this.getProperty(var1.properties[0][var2]);
         }
      }

   }

   int addColorProperties(int var1, Component var2) {
      this.compProps.rowHeader[var1] = "FColor:";
      this.compProps.fieldProtected[0][var1] = true;
      this.compProps.isPullDown[0][var1] = true;
      this.compProps.pullDownList[0][var1] = new List();
      JDPUtils.loadColors(this.compProps.pullDownList[0][var1]);
      super.user.u.listSelect(this.compProps.pullDownList[0][var1], JDPUtils._cvtbcolor(var2.getForeground()));
      this.compProps.currentText[0][var1] = this.compProps.pullDownList[0][var1].getSelectedItem();
      ++var1;
      Color var3 = var2.getBackground();
      if (var3 == null) {
         return var1;
      } else {
         this.compProps.rowHeader[var1] = "BColor:";
         this.compProps.fieldProtected[0][var1] = true;
         this.compProps.isPullDown[0][var1] = true;
         this.compProps.pullDownList[0][var1] = new List();
         JDPUtils.loadColors(this.compProps.pullDownList[0][var1]);
         super.user.u.listSelect(this.compProps.pullDownList[0][var1], JDPUtils._cvtbcolor(var2.getBackground()));
         this.compProps.currentText[0][var1] = this.compProps.pullDownList[0][var1].getSelectedItem();
         ++var1;
         return var1;
      }
   }

   int addTabBack(int var1, Component var2) {
      this.compProps.rowHeader[var1] = "Back to:";
      this.compProps.fieldProtected[0][var1] = true;
      this.compProps.isPullDown[0][var1] = true;
      this.compProps.pullDownList[0][var1] = new List();
      Vector var3 = this.getComponentList(this.target.compTree, (Vector)null);
      this.compProps.pullDownList[0][var1].addItem("");

      for(int var4 = 0; var4 < var3.size(); ++var4) {
         this.compProps.pullDownList[0][var1].addItem((String)var3.elementAt(var4));
      }

      this.compProps.currentText[0][var1] = this.getProperty("Back to:");
      ++var1;
      return var1;
   }

   void updateOtherProperties(JDPTreeBranch var1, int var2) {
      if (!System.getProperty("java.version").startsWith("1.0")) {
         int var4 = var2;
         int var5 = var2 + 1;
         if (this.target.projectLoading) {
            var4 = 0;
            var5 = var1.properties[0].length;
         }

         for(int var6 = var4; var6 < var5; ++var6) {
            if (var1.properties == null || var6 >= var1.properties[0].length) {
               return;
            }

            String var7 = "";
            if (var1.properties[0][var6].length() > 0) {
               var7 = var1.properties[0][var6].substring(0, var1.properties[0][var6].length() - 1);
            }

            String[] var8 = new String[0];
            if (var1.properties[2][var6] != null) {
               StringTokenizer var3 = new StringTokenizer(var1.properties[2][var6], "|");
               var8 = new String[var3.countTokens()];

               for(int var9 = 0; var3.hasMoreTokens(); var8[var9++] = var3.nextToken()) {
               }
            }

            if (var8.length > 0 && !var8[0].equals("") && !var7.equals("") && !var7.equals("Dft") && !var7.equals("Pos") && !var7.equals("Layout") && !var7.equals("Popup") && !var7.equals("Status") && !var7.equals("Tab to") && !var7.equals("Back to") && !var7.equals("Font") && !var7.equals("FColor") && !var7.equals("BColor") && !var7.equals("Size") && !var7.equals("Style") && !var7.equals("Color")) {
               String[] var18 = new String[var8.length];
               StringTokenizer var17;
               if (!this.target.projectLoading) {
                  var17 = new StringTokenizer(this.compProps.currentText[0][var6], ",");
               } else {
                  var17 = new StringTokenizer(var1.properties[1][var6], ",");
               }

               for(int var10 = 0; var10 < var18.length; ++var10) {
                  if (var17.hasMoreTokens()) {
                     var18[var10] = var17.nextToken();
                  } else if (var10 < var18.length - 1) {
                     var18[var10] = "0";
                  } else {
                     var18[var10] = "";
                  }
               }

               Object var19 = null;

               try {
                  Class var20 = this.target.instanceMgr.getClass(var1);
                  Object var21 = var1.thisObject;
                  if (var21 instanceof JDPGridLayout) {
                     var21 = ((JDPGridLayout)var21).tableContents;
                     var20 = Class.forName("JDPTextGrid");
                  }

                  if (var21 instanceof JDPChartLayout) {
                     var21 = ((JDPChartLayout)var21).chartPanel;
                     var20 = Class.forName("JDPChart");
                  }

                  Object[] var22 = new Object[var8.length];
                  Class[] var13 = new Class[var8.length];

                  for(int var15 = 0; var15 < var8.length; ++var15) {
                     var13[var15] = this.target.instanceMgr.getClass(var8[var15]);
                     var22[var15] = this.createObject(var13[var15], var18[var15]);
                  }

                  Method var14;
                  if (var7.equals("Enabled")) {
                     Object var23 = null;
                     if (var1.properties[1][var6].equals("true")) {
                        var14 = var20.getMethod("enable", (Class[])var23);
                     } else {
                        var14 = var20.getMethod("disable", (Class[])var23);
                     }
                  } else {
                     var14 = var20.getMethod("set" + var7, var13);
                  }

                  if (var22 != null && var22[0] != null) {
                     var14.invoke(var21, var22);
                  } else {
                     super.user.mainmsg.setStatusMsg("A value is required for this property", 10);
                  }
               } catch (Exception var16) {
                  String var11 = "";

                  for(int var12 = 0; var12 < var8.length; ++var12) {
                     if (var12 > 0) {
                        var11 = var11 + ",";
                     }

                     var11 = var11 + var8[var12];
                  }
               }
            }
         }

      }
   }

   void checkPropertiesArray(JDPTreeBranch var1) {
      if (var1.properties != null && var1.properties.length > 0 && var1.properties.length < 3) {
         String[][] var2 = new String[3][var1.properties[0].length];

         for(int var3 = 0; var3 < var1.properties[0].length; ++var3) {
            var2[0][var3] = var1.properties[0][var3];
            var2[1][var3] = var1.properties[1][var3];
            var2[2][var3] = var1.properties[2][var3];
         }

         var1.properties = var2;
      } else {
         if (var1.properties != null && var1.properties.length <= 0) {
            var1.properties = new String[3][0];
         }

      }
   }

   int getPropPos(JDPTreeBranch var1, String var2) {
      byte var3 = 0;
      if (var2 != null) {
         for(int var4 = 0; var4 < this.compProps.rowHeader.length; ++var4) {
            if (this.compProps.rowHeader[var4] != null && this.compProps.rowHeader[var4].equals(var2)) {
               return -1;
            }
         }
      }

      for(int var5 = 0; var5 < this.compProps.rowHeader.length; ++var5) {
         if (this.compProps.rowHeader[var5] == null || this.compProps.rowHeader[var5].equals("")) {
            return var5;
         }
      }

      return var3;
   }

   void loadPropertyChoice(JDPTreeBranch var1) {
      if (!this.target.projectLoading && this.propsChoice.isShowing()) {
         if (this.lastChoiceBranch == null || !var1.equals(this.lastChoiceBranch)) {
            this.lastChoiceBranch = var1;
            Vector var2 = this.target.interactionMgr.returnMethods;
            Vector var3 = this.target.interactionMgr.classMethods;
            this.propsChoice.clear();
            Vector var4 = new Vector();
            if (var2 != null) {
               String var7 = super.user.jaggSQL.getSEP();
               String var12 = "java.lang.String int boolean byte char short long float double java.awt.LayoutManager";
               if (var1.thisObject instanceof Component) {
                  this.propsChoice.addItem("Popup(String)");
                  this.propsChoice.addItem("Tab to(Component)");
                  this.propsChoice.addItem("Back to(Component)");
                  this.propsChoice.addItem("Font(Font)");
                  this.propsChoice.addItem("FColor(Color)");
                  this.propsChoice.addItem("BColor(Color)");
               }

               for(int var17 = 0; var17 < var2.size(); ++var17) {
                  String var5 = (String)var2.elementAt(var17);
                  if (!var5.equals(" ") && var5.startsWith(var1.name + var7)) {
                     StringTokenizer var6 = new StringTokenizer(var5, var7);
                     if (var6.countTokens() > 2) {
                        var6.nextToken();
                        var6.nextToken();
                        int var18 = Integer.parseInt(var6.nextToken());
                        Vector var13 = (Vector)var3.elementAt(var18);
                        Vector var14 = (Vector)var13.elementAt(1);

                        for(int var19 = 0; var19 < var14.size(); ++var19) {
                           var5 = (String)var14.elementAt(var19);
                           if (!var5.equals(" ")) {
                              var6 = new StringTokenizer(var5, var7);
                              if (var6.countTokens() > 4) {
                                 var6.nextToken();
                                 var6.nextToken();
                                 String var15 = var6.nextToken();
                                 String var16 = var6.nextToken();
                                 if (var15.startsWith("set") && var6.countTokens() > 1) {
                                    var6.nextToken();
                                    String var9 = var6.nextToken();
                                    String var10 = "";
                                    String var11 = "";
                                    if (var6.hasMoreTokens()) {
                                       var10 = var6.nextToken();
                                    }

                                    if (var6.hasMoreTokens()) {
                                       var11 = var6.nextToken();
                                    }

                                    if (!var6.hasMoreTokens() && var12.indexOf(var9) >= 0 && var12.indexOf(var10) >= 0 && var12.indexOf(var11) >= 0 && (!var10.equals("") && var11.equals("") && var9.equals("int") || !var11.equals("") && var9.equals("int") && var10.equals("int") || var10.equals("") && var11.equals(""))) {
                                       String var8 = var15.substring(3);
                                       if (this.propsChoice.getItem(var8) < 0) {
                                          String var20 = var8 + "(";
                                          if (!var9.equals("")) {
                                             var20 = var20 + var9;
                                          }

                                          if (!var10.equals("")) {
                                             var20 = var20 + "," + var10;
                                          }

                                          if (!var11.equals("")) {
                                             var20 = var20 + "," + var11;
                                          }

                                          var20 = var20 + ")";
                                          if (var4.indexOf(var20) < 0) {
                                             this.propsChoice.addItem(var20, var9 + "|" + var10 + "|" + var11);
                                             var4.addElement(var20);
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
               }

               this.propsChoice.sortItems();
               this.propsChoice.select(0);
            }
         }
      }
   }

   Object createObject(Class var1, String var2) {
      if (System.getProperty("java.version").startsWith("1.0")) {
         return null;
      } else if (var2 != null && !var2.equals("")) {
         try {
            String var3 = var1.getName();
            if (var3.equals("java.awt.LayoutManager")) {
               if (var2.equals("BorderLayout")) {
                  return new BorderLayout();
               }

               if (var2.equals("FlowLayout")) {
                  return new FlowLayout();
               }

               if (var2.equals("GridLayout")) {
                  return new GridLayout(2, 2);
               }

               if (var2.equals("JDPRowLayout")) {
                  return new JDPRowLayout();
               }

               if (var2.equals("JDPLineLayout")) {
                  return new JDPLineLayout();
               }

               return new BorderLayout();
            }

            if (var3.equals("java.lang.String")) {
               return var2;
            }

            if (var3.equals("int")) {
               return new Integer(var2);
            }

            if (var3.equals("boolean")) {
               if (var2.equals("true")) {
                  return new Boolean(true);
               }

               return new Boolean(false);
            }

            if (var3.equals("char")) {
               return new Character(var2.charAt(0));
            }

            if (var3.equals("byte")) {
               return new Byte(var2);
            }

            if (var3.equals("short")) {
               return new Short(var2);
            }

            if (var3.equals("long")) {
               return new Long(var2);
            }

            if (var3.equals("float")) {
               return new Float(var2);
            }

            if (var3.equals("double")) {
               return new Double(var2);
            }

            Constructor[] var4 = var1.getConstructors();
            Object var5 = null;
            Object[] var6 = new Object[]{var2};

            for(int var7 = 0; var7 < var4.length; ++var7) {
               Class[] var12 = var4[var7].getParameterTypes();
               if (var12.length == 1) {
                  try {
                     Object var8 = var4[var7].newInstance(var6);
                     return var8;
                  } catch (Exception var10) {
                     ((Throwable)var10).printStackTrace();
                  }
               }
            }
         } catch (Exception var11) {
         }

         return null;
      } else {
         return null;
      }
   }

   int propSelected(JDPTreeBranch var1, String var2) {
      if (var1.properties == null) {
         return -1;
      } else {
         for(int var3 = 0; var3 < var1.properties[0].length; ++var3) {
            if (var1.properties[0][var3] != null && var1.properties[0][var3].equals(var2)) {
               return var3;
            }
         }

         return -1;
      }
   }

   int addButtonIconProperties(int var1, Component var2) {
      this.compProps.rowHeader[var1] = "Icon:";
      this.compProps.fieldProtected[0][var1] = true;
      this.compProps.isPullDown[0][var1] = true;
      this.compProps.pullDownList[0][var1] = new List();
      String[] var3 = JDPButton.getButtonIconList();

      for(int var4 = 0; var4 < var3.length; ++var4) {
         this.compProps.pullDownList[0][var1].addItem(var3[var4]);
      }

      ++var1;
      return var1;
   }

   int addPopupProperties(int var1, Component var2, int var3) {
      int var4 = 1;
      if (var3 > 0) {
         var4 = var3;
      }

      for(int var5 = 0; var5 < var1; ++var5) {
         if (this.compProps.rowHeader[var5].startsWith("Popup")) {
            return var1;
         }
      }

      for(int var9 = 0; var9 < var4; ++var9) {
         this.compProps.fieldProtected[0][var1] = false;
         this.compProps.isPullDown[0][var1] = false;
         String var6 = "Popup:";
         if (var3 > 0) {
            var6 = "Popup" + Integer.toString(var9) + ":";
         }

         this.compProps.rowHeader[var1] = var6;
         this.compProps.currentText[0][var1++] = this.getProperty(var6);
         this.compProps.fieldProtected[0][var1] = false;
         this.compProps.isPullDown[0][var1] = false;
         String var7 = "Status:";
         if (var3 > 0) {
            var7 = "Status" + Integer.toString(var9) + ":";
         }

         this.compProps.rowHeader[var1] = var7;
         this.compProps.currentText[0][var1++] = this.getProperty(var7);
      }

      return var1;
   }

   void removeProperty(JDPTreeBranch var1, String var2) {
      if (this.testProps.indexOf(var2) >= 0) {
         super.user.mainmsg.setStatusMsg("This property may not be removed.", 5);
      } else {
         for(int var3 = 0; var3 < var1.properties[0].length; ++var3) {
            if (var1.properties[0][var3].equals(var2)) {
               if (var1.properties[2][var3] == null) {
                  super.user.mainmsg.setStatusMsg("This property may not be removed.", 5);
                  return;
               }

               String[][] var4 = new String[3][var1.properties[0].length - 1];

               for(int var5 = 0; var5 < var3; ++var5) {
                  var4[0][var5] = var1.properties[0][var5];
                  var4[1][var5] = var1.properties[1][var5];
                  var4[2][var5] = var1.properties[2][var5];
               }

               for(int var6 = var3 + 1; var6 < var1.properties[0].length; ++var6) {
                  var4[0][var6 - 1] = var1.properties[0][var6];
                  var4[1][var6 - 1] = var1.properties[1][var6];
                  var4[2][var6 - 1] = var1.properties[2][var6];
               }

               var1.properties = var4;
               this.setProperties(var1);
               return;
            }
         }

      }
   }

   String getOtherProperties(JDPTreeBranch var1, int var2) {
      if (System.getProperty("java.version").startsWith("1.0")) {
         return "";
      } else {
         Object var3 = "";
         String var4 = "";
         if (var2 >= var1.properties[0].length) {
            return "";
         } else {
            if (var1.properties[2][var2] == null) {
               var1.properties[2][var2] = "";
            }

            String var6 = var1.properties[0][var2].substring(0, var1.properties[0][var2].length() - 1);
            StringTokenizer var7 = new StringTokenizer(var1.properties[2][var2], "|");
            String[] var8 = new String[var7.countTokens()];

            for(int var9 = 0; var7.hasMoreTokens(); var8[var9++] = var7.nextToken()) {
            }

            if (var8.length > 0 && !var6.equals("Layout") && !var6.equals("Popup") && !var6.equals("Tab to") && !var6.equals("Back to") && !var6.equals("Font") && !var6.equals("FColor") && !var6.equals("BColor") && !var6.equals("Size") && !var6.equals("Color")) {
               String var10 = var8[var8.length - 1];
               String[] var11 = new String[var8.length];
               var7 = new StringTokenizer(var1.properties[1][var2], ",");

               for(int var24 = 0; var24 < var11.length; ++var24) {
                  if (var7.hasMoreTokens()) {
                     var11[var24] = var7.nextToken();
                  } else if (var24 < var11.length - 1) {
                     var11[var24] = "0";
                  } else {
                     var11[var24] = "";
                  }
               }

               try {
                  Class var12 = this.target.instanceMgr.getClass(var1);
                  Object var13 = var1.thisObject;
                  if (var13 instanceof JDPGridLayout) {
                     var13 = ((JDPGridLayout)var13).tableContents;
                     var12 = Class.forName("JDPTextGrid");
                  }

                  if (var13 instanceof JDPChartLayout) {
                     var13 = ((JDPChartLayout)var13).chartPanel;
                     var12 = Class.forName("JDPChart");
                  }

                  Class[] var14 = new Class[var8.length - 1];
                  Object[] var15 = new Object[var8.length - 1];
                  JDPTreeBranch var16 = new JDPTreeBranch();
                  var16.compType = var10;
                  String[] var17 = new String[]{"get"};
                  if (var10.equals("boolean")) {
                     var17 = new String[]{"get", "is"};
                  }

                  int var18 = 0;

                  while(var18 < var17.length) {
                     try {
                        for(int var28 = 0; var28 < var14.length; ++var28) {
                           var14[var28] = this.target.instanceMgr.getClass(var8[var28]);
                           var15[var28] = this.createObject(var14[var28], var11[var28]);
                        }

                        Method var29 = var12.getMethod(var17[var18] + var6, var14);
                        var3 = var29.invoke(var13, var15);
                        if (var3.toString().equals("")) {
                           var3 = var11[var11.length - 1];
                        }

                        var18 = var17.length;
                     } catch (Exception var21) {
                        String var19 = "";

                        for(int var20 = 0; var20 < var14.length; ++var20) {
                           if (var20 > 0) {
                              var19 = var19 + ",";
                           }

                           var19 = var19 + var8[var20];
                        }

                        if (var18 == var17.length - 1 && var14.length > 0) {
                           var14 = new Class[var14.length - 1];
                           var15 = new Object[var14.length];
                           var18 = -1;
                        }

                        ++var18;
                     }
                  }
               } catch (Exception var22) {
               }

               for(int var25 = 0; var25 < var8.length - 1; ++var25) {
                  var4 = var4 + var11[var25] + ",";
               }

               if (var3 == null) {
                  var1.properties[1][var2] = "";
                  var1.properties[1][var2] = var4 + var1.properties[1][var2];
                  return var1.properties[1][var2];
               }

               if (var3 instanceof Dimension) {
                  Dimension var27 = (Dimension)var3;
                  var1.properties[1][var2] = Integer.toString(var27.width) + "," + Integer.toString(var27.height);
                  return var1.properties[1][var2];
               }

               if (var3 instanceof Rectangle) {
                  Rectangle var26 = (Rectangle)var3;
                  var1.properties[1][var2] = Integer.toString(var26.x) + "," + Integer.toString(var26.y) + "," + Integer.toString(var26.width) + "," + Integer.toString(var26.height);
                  return var1.properties[1][var2];
               }

               if (var3.equals("")) {
                  var1.properties[1][var2] = "";
                  if (var1.properties[1][var2] == null || var1.properties[1][var2].equals("") || var1.properties[1][var2].equals("?")) {
                     if (var10.equals("boolean")) {
                        var1.properties[1][var2] = "true";
                     } else if (var10.equals("java.lang.String")) {
                        var1.properties[1][var2] = "String";
                     } else if (var10.equals("java.awt.LayoutManager")) {
                        var1.properties[1][var2] = "BorderLayout";
                     } else if (var10.equals("char")) {
                        var1.properties[1][var2] = "c";
                     } else {
                        var1.properties[1][var2] = "0";
                     }
                  }

                  var1.properties[1][var2] = var4 + var1.properties[1][var2];
                  return var1.properties[1][var2];
               }
            }

            var1.properties[1][var2] = var4 + var3.toString();
            return var1.properties[1][var2];
         }
      }
   }

   boolean propAlreadyDrawn(String var1) {
      if (this.compProps.rowHeader == null) {
         return false;
      } else if (var1 == null) {
         return false;
      } else {
         for(int var2 = 0; var2 < this.compProps.rowHeader.length; ++var2) {
            if (this.compProps.rowHeader[var2].equals(var1)) {
               return true;
            }
         }

         return false;
      }
   }

   int getPropertyIndex(String var1) {
      String var2 = this.getProperty(var1);
      if (var2.startsWith("Group")) {
         var2 = var2.substring(5);
         return Integer.parseInt(var2);
      } else {
         int var3 = 0;

         while(var2.indexOf(Integer.toString(var3)) < 0) {
            ++var3;
            if (var3 >= 500) {
               return -1;
            }
         }

         return var3;
      }
   }

   void setProperties(JDPTreeBranch var1) {
      this.emptyGrid();
      if (var1 != null && var1.compType != null) {
         this.checkPropertiesArray(var1);
         this.currentBranch = var1;
         Component var2 = null;
         Object var3 = null;
         String var4 = null;
         if (var1.thisObject instanceof Component) {
            var2 = (Component)var1.thisObject;
            Container var14 = var2.getParent();
            if (var14 != null) {
               var4 = var14.getLayout().toString();
            }
         }

         if (var1.equals(this.target.compTree)) {
            var4 = "BorderLayout";
         }

         this.compName.setText(var1.name);
         if (var1.name.equals("Main")) {
            this.compName.setEditable(false);
         } else {
            this.compName.setEditable(true);
         }

         String var5 = var1.compType;
         this.compProps.pullDownList = new List[1][this.compProps.isPullDown[0].length];
         this.compProps.columnWidth[0] = this.tree.bounds().width - 70;
         int var31 = 0;
         if (var1.thisObject instanceof Component) {
            this.compProps.rowHeader[var31] = "Pos:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[var31][0] = var1.compPosition;
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("");
            if (var4 == null || var4.indexOf("JDPRowLayout") < 0 && var4.indexOf("JDPLineLayout") < 0) {
               if (var4 != null && var4.indexOf("BorderLayout") >= 0) {
                  this.compProps.pullDownList[0][var31].addItem("Center");
                  this.compProps.pullDownList[0][var31].addItem("North");
                  this.compProps.pullDownList[0][var31].addItem("South");
                  this.compProps.pullDownList[0][var31].addItem("East");
                  this.compProps.pullDownList[0][var31].addItem("West");
               } else if (var4 != null && var4.indexOf("JDPSplitLayout") >= 0) {
                  this.compProps.pullDownList[0][var31].addItem("Left");
                  this.compProps.pullDownList[0][var31].addItem("Right");
                  this.compProps.pullDownList[0][var31].addItem("Center");
                  this.compProps.pullDownList[0][var31].addItem("North");
                  this.compProps.pullDownList[0][var31].addItem("South");
                  this.compProps.pullDownList[0][var31].addItem("East");
                  this.compProps.pullDownList[0][var31].addItem("West");
               } else {
                  this.compProps.fieldProtected[0][var31] = false;
               }
            } else {
               this.compProps.pullDownList[0][var31].addItem("Left");
               this.compProps.pullDownList[0][var31].addItem("Right");
            }

            super.user.u.listSelect(this.compProps.pullDownList[0][var31], var1.compPosition);
            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
         }

         if (var5.equals("TextField") || var5.equals("JDPTextField")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Cols:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((TextField)var1.thisObject).getColumns());
         }

         if (var5.equals("JDPSpinner")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Cols:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((JDPSpinner)var1.thisObject).getColumns());
         }

         if (var5.equals("JDPDate")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Cols:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((JDPDate)var1.thisObject).getColumns());
         }

         if (var5.equals("TextArea")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Rows:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((TextArea)var1.thisObject).getRows());
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Cols:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((TextArea)var1.thisObject).getColumns());
         }

         if (var1.thisObject instanceof TextComponent) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Dft:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = ((TextComponent)var1.thisObject).getText();
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Editable:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("true");
            this.compProps.pullDownList[0][var31].addItem("false");
            if (((TextComponent)var1.thisObject).isEditable()) {
               this.compProps.pullDownList[0][var31].select(0);
            } else {
               this.compProps.pullDownList[0][var31].select(1);
            }

            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
         }

         if (var5.equals("Panel") || var5.equals("JDPColumns") || var5.startsWith("JDPWiz")) {
            LayoutManager var7 = ((Container)var1.thisObject).getLayout();
            if (var7 != null) {
               this.compProps.fieldProtected[0][var31] = true;
               this.compProps.isPullDown[0][var31] = true;
               this.compProps.rowHeader[var31] = "Layout:";
               this.compProps.rowKey[0][var31] = null;
               this.compProps.pullDownList[0][var31] = new List();
               this.compProps.pullDownList[0][var31].addItem("BorderLayout");
               this.compProps.pullDownList[0][var31].addItem("FlowLayout");
               this.compProps.pullDownList[0][var31].addItem("GridLayout");
               this.compProps.pullDownList[0][var31].addItem("JDPLineLayout");
               this.compProps.pullDownList[0][var31].addItem("JDPRowLayout");
               String var8 = var7.toString();
               String var9 = var8;
               int var10 = var8.indexOf("[");
               if (var10 > 0) {
                  var8 = var8.substring(0, var10);
               }

               var10 = var8.lastIndexOf(".");
               if (var10 > 0) {
                  var8 = var8.substring(var10 + 1);
               }

               super.user.u.listSelect(this.compProps.pullDownList[0][var31], var8);
               this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
               ++var31;
               if (this.compProps.currentText[0][var31 - 1] != null && this.compProps.currentText[0][var31 - 1].equals("GridLayout")) {
                  int var11 = var9.indexOf("rows=");
                  String var12 = var9.substring(var11 + 5, var9.indexOf(",", var11));
                  var11 = var9.indexOf("cols=");
                  String var13 = var9.substring(var11 + 5, var9.indexOf("]", var11));
                  this.compProps.fieldProtected[0][var31] = false;
                  this.compProps.isPullDown[0][var31] = false;
                  this.compProps.rowHeader[var31] = "Cols:";
                  this.compProps.rowKey[0][var31] = null;
                  this.compProps.currentText[0][var31++] = var13;
                  this.compProps.fieldProtected[0][var31] = false;
                  this.compProps.isPullDown[0][var31] = false;
                  this.compProps.rowHeader[var31] = "Rows:";
                  this.compProps.rowKey[0][var31] = null;
                  this.compProps.currentText[0][var31++] = var12;
               }
            }
         }

         if (var5.equals("Label") || var5.equals("Button") || var5.equals("Checkbox") || var5.equals("CheckboxGroup") || var5.equals("JDPButton")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Label:";
            this.compProps.rowKey[0][var31] = null;
         }

         if (var5.equals("Label")) {
            this.compProps.currentText[0][var31++] = ((Label)var1.thisObject).getText();
         }

         if (var5.equals("Button")) {
            this.compProps.currentText[0][var31++] = ((Button)var1.thisObject).getLabel();
         }

         if (var5.equals("Checkbox")) {
            this.compProps.currentText[0][var31++] = ((Checkbox)var1.thisObject).getLabel();
         }

         if (var5.equals("CheckboxGroup")) {
            this.compProps.currentText[0][var31++] = ((Checkbox)var1.thisObject).getLabel();
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Group:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            CheckboxGroup var44 = ((Checkbox)var1.thisObject).getCheckboxGroup();

            for(int var50 = 0; var50 < this.target.cbgroup.length; ++var50) {
               this.compProps.pullDownList[0][var31].addItem("Group" + Integer.toString(var50));
               if (this.target.cbgroup[var50].equals(var44)) {
                  this.compProps.pullDownList[0][var31].select(var50);
               }
            }

            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
         }

         if (var5.equals("Scrollbar")) {
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Align:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("Vertical");
            this.compProps.pullDownList[0][var31].addItem("Horizontal");
            int var45 = ((Scrollbar)var1.thisObject).getOrientation();
            if (var45 == 0) {
               this.compProps.pullDownList[0][var31].select(1);
            } else {
               this.compProps.pullDownList[0][var31].select(0);
            }

            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Value:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((Scrollbar)var1.thisObject).getValue());
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Vis:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((Scrollbar)var1.thisObject).getVisible());
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Min:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((Scrollbar)var1.thisObject).getMinimum());
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Max:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((Scrollbar)var1.thisObject).getMaximum());
         }

         if (var5.equals("JDPButton")) {
            this.compProps.currentText[0][var31++] = ((JDPButton)var1.thisObject).getLabel();
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Labels:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("Yes");
            this.compProps.pullDownList[0][var31].addItem("No");
            if (((JDPButton)var1.thisObject).isIconOnly()) {
               this.compProps.pullDownList[0][var31].select(1);
            } else {
               this.compProps.pullDownList[0][var31].select(0);
            }

            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Align:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("Center");
            this.compProps.pullDownList[0][var31].addItem("Left");
            this.compProps.pullDownList[0][var31].addItem("Right");
            int var46 = ((JDPButton)var1.thisObject).getAlignment();
            this.compProps.pullDownList[0][var31].select(var46);
            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
            var31 = this.addButtonIconProperties(var31, var2);
            this.compProps.pullDownList[0][var31 - 1].select(((JDPButton)var1.thisObject).getIcon() + 1);
            this.compProps.currentText[0][var31 - 1] = this.compProps.pullDownList[0][var31 - 1].getSelectedItem();
         }

         if (var5.equals("JDPButtons")) {
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Labels:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("Yes");
            this.compProps.pullDownList[0][var31].addItem("No");
            if (((JDPButtons)var1.thisObject).isIconsOnly()) {
               this.compProps.pullDownList[0][var31].select(1);
            } else {
               this.compProps.pullDownList[0][var31].select(0);
            }

            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = true;
            this.compProps.rowHeader[var31] = "Align:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.pullDownList[0][var31] = new List();
            this.compProps.pullDownList[0][var31].addItem("Vertical");
            this.compProps.pullDownList[0][var31].addItem("Horizontal");
            int var47 = ((JDPButtons)var1.thisObject).getAlignment();
            this.compProps.pullDownList[0][var31].select(var47);
            this.compProps.currentText[0][var31] = this.compProps.pullDownList[0][var31].getSelectedItem();
            ++var31;
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "# Btns:";
            this.compProps.rowKey[0][var31] = null;
            int var51 = ((JDPButtons)var1.thisObject).getButtonCount();
            this.compProps.currentText[0][var31++] = Integer.toString(var51);
            String[] var53 = ((JDPButtons)var1.thisObject).getLabels();

            for(int var58 = 0; var58 < var53.length; ++var58) {
               int var29 = this.getPropPos(var1, "Btn#" + Integer.toString(var58) + ":");
               this.compProps.fieldProtected[0][var29] = false;
               this.compProps.isPullDown[0][var29] = false;
               this.compProps.rowHeader[var29] = "Btn#" + Integer.toString(var58) + ":";
               this.compProps.rowKey[0][var29] = null;
               this.compProps.currentText[0][var29] = var53[var58];
               int var30 = this.getPropPos(var1, "Icon#" + Integer.toString(var58) + ":");
               var31 = this.addButtonIconProperties(var30, var2);
               this.compProps.rowHeader[var31 - 1] = "Icon#" + Integer.toString(var58) + ":";
               this.compProps.rowKey[0][var31 - 1] = null;
               this.compProps.pullDownList[0][var31 - 1].select(((JDPButtons)var1.thisObject).getIcon(var58) + 1);
               this.compProps.currentText[0][var31 - 1] = this.compProps.pullDownList[0][var31 - 1].getSelectedItem();
            }

            var31 = this.addPopupProperties(var31, var2, var53.length);
         }

         if (var5.equals("JDPChiselFramePanel")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Title:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = ((JDPChiselFramePanel)var1.thisObject).getTitle();
         }

         if (var5.equals("JDPTabSelectPanel")) {
            this.compProps.fieldProtected[0][var31] = true;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "# Tabs:";
            this.compProps.rowKey[0][var31] = null;
            int var48 = ((JDPTabSelectPanel)var1.thisObject).getTabcount();
            this.compProps.currentText[0][var31++] = Integer.toString(var48);
            String[] var52 = ((JDPTabSelectPanel)var1.thisObject).getTabnames();
            ((JDPTabSelectPanel)var1.thisObject).getTabIcons();

            for(int var54 = 0; var54 < var48; ++var54) {
               var31 = this.getPropPos(var1, "Tab#" + Integer.toString(var54) + ":");
               this.compProps.fieldProtected[0][var31] = false;
               this.compProps.isPullDown[0][var31] = false;
               this.compProps.rowHeader[var31] = "Tab#" + Integer.toString(var54) + ":";
               this.compProps.rowKey[0][var31] = null;
               this.compProps.currentText[0][var31++] = var52[var54];
            }

            for(int var55 = 0; var55 < var48; ++var55) {
               int var32 = this.getPropPos(var1, "FCol#" + Integer.toString(var55) + ":");
               var31 = this.addColorProperties(var32, var2);
               this.compProps.rowHeader[var31 - 2] = "FCol#" + Integer.toString(var55) + ":";
               this.compProps.rowKey[0][var31 - 2] = null;
               this.compProps.rowHeader[var31 - 1] = "BCol#" + Integer.toString(var55) + ":";
               this.compProps.rowKey[0][var31 - 1] = null;
               super.user.u.listSelect(this.compProps.pullDownList[0][var31 - 2], this.getProperty("FCol#" + Integer.toString(var55) + ":"));
               this.compProps.currentText[0][var31 - 2] = this.compProps.pullDownList[0][var31 - 2].getSelectedItem();
               super.user.u.listSelect(this.compProps.pullDownList[0][var31 - 1], this.getProperty("BCol#" + Integer.toString(var55) + ":"));
               this.compProps.currentText[0][var31 - 1] = this.compProps.pullDownList[0][var31 - 1].getSelectedItem();
            }

            for(int var56 = 0; var56 < var48; ++var56) {
               int var33 = this.getPropPos(var1, "Icon#" + Integer.toString(var56) + ":");
               var31 = this.addButtonIconProperties(var33, var2);
               this.compProps.rowHeader[var31 - 1] = "Icon#" + Integer.toString(var56) + ":";
               this.compProps.rowKey[0][var31 - 1] = null;
               this.compProps.pullDownList[0][var31 - 1].select(((JDPTabSelectPanel)var1.thisObject).getTabIcon(var56) + 1);
               this.compProps.currentText[0][var31 - 1] = this.compProps.pullDownList[0][var31 - 1].getSelectedItem();
            }
         }

         if (var5.equals("JDPBrowser")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Doc path:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = ((JDPBrowser)var1.thisObject).getDocname();
         }

         if (var5.equals("JDPBrowserCtl")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Doc path:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = ((JDPBrowserCtl)var1.thisObject).getDocname();
         }

         if (var5.equals("JDPTreePicker")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Title:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = ((JDPTreePicker)var1.thisObject).getTitle();
         }

         if (var5.equals("JDPImage")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Path:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = ((JDPImage)var1.thisObject).getImagePath();
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Width:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((JDPImage)var1.thisObject).getDimension().width);
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "Height:";
            this.compProps.rowKey[0][var31] = null;
            this.compProps.currentText[0][var31++] = Integer.toString(((JDPImage)var1.thisObject).getDimension().height);
         }

         if (var1.thisObject instanceof Component) {
            if ((var31 = this.getPropPos(var1, "Popup:")) >= 0) {
               this.addPopupProperties(var31, var2, 0);
            }

            if ((var31 = this.getPropPos(var1, "Tab to:")) >= 0) {
               this.addTabTo(var31, var2);
            }

            if ((var31 = this.getPropPos(var1, "Back to:")) >= 0) {
               this.addTabBack(var31, var2);
            }

            if ((var31 = this.getPropPos(var1, "Font:")) >= 0) {
               this.addFontProperties(var31, var2);
            }

            if ((var31 = this.getPropPos(var1, "FColor:")) >= 0) {
               this.addFColorProperties(var31, var2);
            }

            if ((var31 = this.getPropPos(var1, "BColor:")) >= 0) {
               this.addBColorProperties(var31, var2);
            }
         }

         if (var5.equals("JDPSplitPanel")) {
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "LeftPercentage:";
            this.compProps.rowKey[0][var31] = "int";
            this.compProps.currentText[0][var31++] = Integer.toString((int)((JDPSplitPanel)var1.thisObject).getLeftPercentage());
            this.compProps.fieldProtected[0][var31] = false;
            this.compProps.isPullDown[0][var31] = false;
            this.compProps.rowHeader[var31] = "TopPercentage:";
            this.compProps.rowKey[0][var31] = "int";
            this.compProps.currentText[0][var31++] = Integer.toString((int)((JDPSplitPanel)var1.thisObject).getTopPercentage());
         }

         this.loadPropertyChoice(var1);
         this.loadOtherProperties(var1);

         for(var31 = 0; var31 < this.compProps.rowHeader.length && !this.compProps.rowHeader[var31].equals(""); ++var31) {
         }

         if (var1.properties == null) {
            var1.properties = new String[3][var31];

            for(int var49 = 0; var49 < var31; ++var49) {
               var1.properties[0][var49] = this.compProps.rowHeader[var49];
               var1.properties[1][var49] = this.compProps.currentText[0][var49];
               var1.properties[2][var49] = this.compProps.rowKey[0][var49];
            }
         }

         this.repaintGrid();
      }
   }

   void setPropPosition(String var1) {
      if (var1.equals("Max")) {
         if (this.compPropsPanel.countComponents() != 0) {
            this.compPropsPanel.remove(this.compProps);
            this.compPropsPanel1.add("Center", this.compProps);
            this.saveButton = this.target.buttonPanel.getPressed();
            this.target.setButton("Properties");
            this.compPropsPanel1.layout();
            this.compPropsPanel1.paintAll(this.compPropsPanel.getGraphics());
            this.repaintGrid();
         }
      } else if (this.compPropsPanel.countComponents() <= 0) {
         this.compPropsPanel1.remove(this.compProps);
         this.compPropsPanel.add("Center", this.compProps);
         this.target.setButton(this.saveButton);
         this.compPropsPanel.layout();
         this.compPropsPanel.paintAll(this.compPropsPanel.getGraphics());
         this.repaintGrid();
         this.propsButton.setPressed(false);
      }
   }

   int addFontProperties(int var1, Component var2) {
      if (var2 == null) {
         return var1;
      } else {
         this.compProps.rowHeader[var1] = "Font:";
         this.compProps.fieldProtected[0][var1] = true;
         this.compProps.isPullDown[0][var1] = true;
         this.compProps.pullDownList[0][var1] = new List();
         this.compProps.pullDownList[0][var1].addItem("Courier");
         this.compProps.pullDownList[0][var1].addItem("Helvetica");
         this.compProps.pullDownList[0][var1].addItem("SansSerif");
         this.compProps.pullDownList[0][var1].addItem("TimesRoman");
         if (super.user.u.listIndexOf(this.compProps.pullDownList[0][var1], super.user.plainFont.getName()) < 0) {
            this.compProps.pullDownList[0][var1].addItem(super.user.plainFont.getName());
         }

         Font var3 = var2.getFont();
         if (var3 == null) {
            var3 = ((Component)this.target.layoutTree.treeRoot.thisObject).getFont();
         }

         super.user.u.listSelect(this.compProps.pullDownList[0][var1], var2.getFont().getName());
         this.compProps.currentText[0][var1] = this.compProps.pullDownList[0][var1].getSelectedItem();
         ++var1;
         this.compProps.rowHeader[var1] = "Style:";
         this.compProps.fieldProtected[0][var1] = true;
         this.compProps.isPullDown[0][var1] = true;
         this.compProps.pullDownList[0][var1] = new List();
         this.compProps.pullDownList[0][var1].addItem("Plain");
         this.compProps.pullDownList[0][var1].addItem("Bold");
         this.compProps.pullDownList[0][var1].addItem("Italic");
         this.compProps.pullDownList[0][var1].addItem("Bold Italic");
         this.compProps.pullDownList[0][var1].select(var2.getFont().getStyle());
         this.compProps.currentText[0][var1] = this.compProps.pullDownList[0][var1].getSelectedItem();
         ++var1;
         this.compProps.rowHeader[var1] = "Size:";
         this.compProps.fieldProtected[0][var1] = false;
         this.compProps.isPullDown[0][var1] = false;
         this.compProps.currentText[0][var1++] = Integer.toString(var2.getFont().getSize());
         return var1;
      }
   }

   int addFColorProperties(int var1, Component var2) {
      this.compProps.rowHeader[var1] = "FColor:";
      this.compProps.fieldProtected[0][var1] = true;
      this.compProps.isPullDown[0][var1] = true;
      this.compProps.pullDownList[0][var1] = new List();
      JDPUtils.loadColors(this.compProps.pullDownList[0][var1]);
      super.user.u.listSelect(this.compProps.pullDownList[0][var1], JDPUtils._cvtbcolor(var2.getForeground()));
      this.compProps.currentText[0][var1] = this.compProps.pullDownList[0][var1].getSelectedItem();
      ++var1;
      return var1;
   }

   int addBColorProperties(int var1, Component var2) {
      Color var3 = var2.getBackground();
      if (var3 == null) {
         return var1;
      } else {
         this.compProps.rowHeader[var1] = "BColor:";
         this.compProps.fieldProtected[0][var1] = true;
         this.compProps.isPullDown[0][var1] = true;
         this.compProps.pullDownList[0][var1] = new List();
         JDPUtils.loadColors(this.compProps.pullDownList[0][var1]);
         super.user.u.listSelect(this.compProps.pullDownList[0][var1], JDPUtils._cvtbcolor(var2.getBackground()));
         this.compProps.currentText[0][var1] = this.compProps.pullDownList[0][var1].getSelectedItem();
         ++var1;
         return var1;
      }
   }

   int addTabTo(int var1, Component var2) {
      this.compProps.rowHeader[var1] = "Tab to:";
      this.compProps.fieldProtected[0][var1] = true;
      this.compProps.isPullDown[0][var1] = true;
      this.compProps.pullDownList[0][var1] = new List();
      Vector var3 = this.getComponentList(this.target.compTree, (Vector)null);
      this.compProps.pullDownList[0][var1].addItem("");

      for(int var4 = 0; var4 < var3.size(); ++var4) {
         this.compProps.pullDownList[0][var1].addItem((String)var3.elementAt(var4));
      }

      this.compProps.currentText[0][var1] = this.getProperty("Tab to:");
      ++var1;
      return var1;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               if (var1.target.equals(this.tabPanel)) {
                  if (this.tabPanel.isSelected(0)) {
                     if (this.propsButton.isPressed()) {
                        this.target.setButton(this.saveButton);
                     }
                  } else {
                     this.loadPropertyChoice(this.currentBranch);
                     if (this.propsButton.isPressed()) {
                        this.saveButton = this.target.buttonPanel.getPressed();
                        this.target.setButton("Properties");
                     }
                  }
               }

               return true;
            }

            return false;
         case 501:
            this.dragPanel.postEvent(var1);
            return false;
         case 502:
            if (this.dragPanel.isVisible()) {
               this.dragPanel.postEvent(var1);
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 506:
            this.dragPanel.postEvent(var1);
            return true;
         case 1001:
            if (var1.target instanceof JDPButton) {
               String var5 = (String)var1.arg;
               if (var5.equals("Properties")) {
                  if (this.compPropsPanel.countComponents() > 0) {
                     this.setPropPosition("Max");
                  } else {
                     this.setPropPosition("Min");
                  }
               }

               if (var1.target.equals(this.choiceButton)) {
                  String var8 = this.propsChoice.getSelectedItem();
                  int var4 = var8.indexOf("(");
                  if (var4 >= 0) {
                     var8 = var8.substring(0, var4);
                  }

                  this.addProperty(this.currentBranch, var8, this.propsChoice.getSelectedKey());
                  return true;
               } else {
                  if (var1.target.equals(this.removePropButton) && this.compProps.getCurrentRow() >= 0) {
                     String var7 = this.compProps.getRowHeader(this.compProps.getCurrentRow());
                     this.removeProperty(this.currentBranch, var7);
                     return true;
                  }

                  return true;
               }
            } else {
               if (var1.target instanceof TextField) {
                  if (var1.target.equals(this.compName)) {
                     this.updateProperties(-1);
                  }

                  return true;
               }

               return false;
            }
         case 1005:
            if (var1.target instanceof JDPTextGrid && var1.target.equals(this.compProps)) {
               int var2 = this.compProps.getPrevRow();
               if (this.compProps.currentText[0][var2] == null) {
                  return true;
               } else {
                  int var3;
                  for(var3 = 0; !this.compProps.rowHeader[var3].equals(""); ++var3) {
                  }

                  if (this.currentBranch.properties == null || this.currentBranch.properties[0].length < var3) {
                     this.currentBranch.properties = new String[3][var3];
                  }

                  for(int var6 = 0; !this.compProps.rowHeader[var6].equals(""); ++var6) {
                     this.currentBranch.properties[0][var6] = this.compProps.rowHeader[var6];
                     this.currentBranch.properties[1][var6] = this.compProps.currentText[0][var6];
                     this.currentBranch.properties[2][var6] = this.compProps.rowKey[0][var6];
                  }

                  this.updateProperties(var2);
                  return true;
               }
            } else {
               return false;
            }
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, JDPLayoutMgr var2, String var3) {
      super.user = var1;
      this.target = var2;
      this.targetPanel = var2.targetPanel;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.dragPanel = var2.dragPanel;
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      String[] var5 = new String[]{"Objects", "Properties"};
      this.tabpanels = new Panel[2];
      this.tabpanels[0] = new Panel();
      this.tabpanels[1] = new Panel();
      this.tabpanels[0].setLayout(new BorderLayout());
      this.tabpanels[1].setLayout(new BorderLayout());
      this.tabPanel = new JDPTabSelectPanel(var1, var5, this.tabpanels, "North");
      if (this.tree != null) {
         var2.leftMarginWidth = this.tree.getMinWidth();
      }

      this.tree = new JDPTreePicker(var1, this.targetPanel, this.dragPanel);
      this.tree.setResizingAllowed(false);
      int[] var6 = new int[]{4, 3, 2, 1};
      this.tree.setIcons(var6);
      this.tree.setRoot("", true);
      this.tabpanels[0].add("Center", this.tree);
      this.tree.setMinWidth(var2.leftMarginWidth);
      this.compName = new TextField("", 5);
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      ((Container)var7).add("West", new JDPWrapLabel(var1, "Name:", Color.black));
      ((Container)var7).add("Center", this.compName);
      this.tabpanels[1].add("North", var7);
      this.compProps = new JDPTextGrid(var1);
      this.compPropsPanel = new Panel();
      this.compPropsPanel.setLayout(new BorderLayout());
      this.compPropsPanel.add("Center", this.compProps);
      this.tabpanels[1].add("Center", this.compPropsPanel);
      this.propsButton = new JDPButton(5, "Properties", 0);
      ((Container)var7).add("East", this.propsButton);
      this.propsButton.setStayOn(true);
      this.propsChoice = new JDPComboBox(var1);
      this.propsChoice.setEditable(false);
      this.choiceButton = new JDPButton(7, "Add");
      this.removePropButton = new JDPButton(8, "Remove");
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new GridLayout(1, 2));
      ((Container)var8).add(this.choiceButton);
      ((Container)var8).add(this.removePropButton);
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      ((Container)var9).add("Center", this.propsChoice);
      ((Container)var9).add("East", var8);
      this.tabpanels[1].add("South", var9);
      this.compPropsPanel1 = new Panel();
      this.compPropsPanel1.setLayout(new BorderLayout());
      var2.cardPanel.add("Properties", this.compPropsPanel1);
      this.popuppanel.addComponent(this.compName, "Component Name", "Enter the desired name of this component");
      this.popuppanel.addComponent(this.propsButton, "Partial/Full Screen", "Press to toggle between full and partial view of the property sheet");
      this.popuppanel.addComponent(this.compProps, "", "Adjust the initialization properties by entering values or making pulldown choices");
      this.popuppanel.addComponent(this.propsChoice, "", "Select the property to add to the property sheet to allow adjustment");
      this.popuppanel.addComponent(this.choiceButton, "", "Add the selected property to the property sheet to allow adjustment");
      this.popuppanel.addComponent(this.removePropButton, "", "Remove the selected property from the property sheet");
      if (!(var1.JDesignerPro.versionnum >= 2.1F) || JDesignerPro.JDPLicensed && JDesignerPro.JDPLicenses <= 5) {
         this.popuppanel.addComponent(this.tree, "", "Drag an object to the panel at right or the Layout View below.");
      } else {
         this.popuppanel.addComponent(this.tree, "", "Drag an object to the panel at right or the Layout View below. Click on an Objects, Folders or the Computer icon for importing and other options.");
      }

      this.loadEmptyGrid();
      ((Container)this).add("Center", this.tabPanel);
      this.targetPanel.paintAll(this.targetPanel.getGraphics());
      var1.gParm.addElement(this);
      var1.JDesignerPro.gc();
   }
}
