import sun.tools.debug.DebuggerCallback;
import sun.tools.debug.RemoteThread;

public class JDPDebuggerCallback implements DebuggerCallback {
   JDPDebugMgr target;

   public JDPDebuggerCallback(JDPDebugMgr var1) {
      this.target = var1;
   }

   public void printToConsole(String var1) {
      this.target.printToConsole(var1);
   }

   public void breakpointEvent(RemoteThread var1) {
      this.target.breakpointEvent(var1);
   }

   public void exceptionEvent(RemoteThread var1, String var2) {
      this.target.exceptionEvent(var1, var2);
   }

   public void threadDeathEvent(RemoteThread var1) {
      this.target.threadDeathEvent(var1);
   }

   public void quitEvent() {
      this.target.quitEvent();
   }
}
