import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Panel;

public class JDPDeployment extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   JDPTabSelectPanel TabPanel1;
   JDPTabSelectPanel TabPanel2;
   JDPMenuAddOption JDPMenuAddOption1;
   JDPAddToHtml JDPAddToHtml1;
   JDPMenuMaint JDPMenuMaint1;
   JDPDeploymentMgr JDPDeploymentMgr1;
   JDPEventMaintenance JDPEventMaintenance1;
   JDPTabSelectPanel mainPanel;
   boolean dialogNotShown = true;

   public void select(String var1) {
      if (var1.equals("Client")) {
         this.mainPanel.select(0);
      } else {
         this.mainPanel.select(1);
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               if (var1.target.equals(this.TabPanel2) && this.TabPanel2.getSelectedItem().equals("Create Html") && this.user.JDesignerPro.JDPDirectory.indexOf("BulletProof") > 0 && this.dialogNotShown) {
                  JDPMessageDialog var2 = new JDPMessageDialog(this.user, this);
                  ((Component)var2).setFont(this.user.plainFont);
                  ((Component)var2).setForeground(this.user.u._cvtcolor("Black"));
                  ((Component)var2).setBackground(this.user.u._cvtcolor("LightGray"));
                  ((Dialog)var2).setTitle("Local Installation Only");
                  var2.setMessage("JDP has not been installed into a Web Server.|The html page you are about to create may not load|in your browser.|Please install a Web Server and then reinstall JDP and|select the Web Server when prompted.");
                  var2.setButtonCount(1);
                  var2.setButtonText(0, "Close");
                  var2.setButtonIcon(0, 8);
                  this.dialogNotShown = false;
                  ((JDPDialog)var2).display();
               }

               this.JDPMenuAddOption1.retrieveHandle();
               this.JDPAddToHtml1.retrieveHandle();
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      String[] var4 = new String[2];
      Panel[] var5 = new Panel[]{new Panel(), null};
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Client Deployment";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "Server Deployment";
      this.mainPanel = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Client Deployment Manager");
      String[] var6 = new String[2];
      Panel[] var7 = new Panel[]{new Panel(), null};
      var7[0].setLayout(new BorderLayout());
      var6[0] = "Local Deployment";
      var7[1] = new Panel();
      var7[1].setLayout(new BorderLayout());
      var6[1] = "Remote Deployment";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var6, var7, "North");
      String[] var8 = new String[3];
      Panel[] var9 = new Panel[]{new Panel(), null, null};
      var9[0].setLayout(new BorderLayout());
      var8[0] = "Add to Menu";
      var9[1] = new Panel();
      var9[1].setLayout(new BorderLayout());
      var8[1] = "Create Html";
      var9[2] = new Panel();
      var9[2].setLayout(new BorderLayout());
      var8[2] = "Menu Maintenance";
      this.TabPanel2 = new JDPTabSelectPanel(var1, var8, var9, "North");
      this.JDPMenuAddOption1 = new JDPMenuAddOption();
      this.JDPMenuAddOption1.InitClass(var1, var2, var3);
      this.JDPAddToHtml1 = new JDPAddToHtml();
      this.JDPAddToHtml1.InitClass(var1, var2, var3);
      this.JDPMenuMaint1 = new JDPMenuMaint();
      this.JDPMenuMaint1.InitClass(var1, var2, var3);
      if (JDesignerPro.executable) {
         this.JDPDeploymentMgr1 = new JDPDeploymentMgr();
         this.JDPDeploymentMgr1.InitClass(var1, var2, var3);
      }

      this.JDPEventMaintenance1 = new JDPEventMaintenance();
      this.JDPEventMaintenance1.InitClass(var1, var2, var3);
      var9[0].add("Center", this.JDPMenuAddOption1);
      var9[1].add("Center", this.JDPAddToHtml1);
      var9[2].add("Center", this.JDPMenuMaint1);
      ((Container)this).add("Center", this.mainPanel);
      var5[0].add("Center", this.ChiselPanel1);
      var5[1].add("Center", this.JDPEventMaintenance1);
      if (JDesignerPro.executable) {
         this.ChiselPanel1.add("Center", this.TabPanel1);
         var7[0].add("Center", this.TabPanel2);
         var7[1].add("Center", this.JDPDeploymentMgr1);
      } else {
         this.ChiselPanel1.add("Center", this.TabPanel2);
      }

      var1.gParm.addElement(this);
   }
}
