import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPDeploymentMgr extends JDPClassLayout implements Runnable {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPUser newUser;
   Panel Main;
   JDPDragItem DragAndDrop1;
   JDPTabSelectPanel TabPanel1;
   JDPChiselFramePanel ChiselPanel2;
   Panel Panel1;
   JDPScrollPanel ScrollPanel1;
   Label Label1;
   TextField serverName;
   Label Label2;
   TextField serverPort;
   Label Label3;
   TextField jdpUsername;
   Label Label4;
   TextField jdpPassword;
   Label Label7;
   TextField JDPSystem;
   JDPButtons JDPButtons1;
   JDPChiselFramePanel ChiselPanel3;
   JDPSplitPanel Panel2;
   Panel Panel3;
   JDPFilePicker FilePicker1;
   Label Label5;
   Panel Panel4;
   JDPFilePicker FilePicker2;
   Label Label6;
   JDPMenuAddOption JDPMenuAddOption1;
   JDPMenuMaint JDPMenuMaint1;
   JDPAddToHtml JDPAddToHtml1;
   Panel Panel5;
   String JDPDirectory;
   String JDPJaggDir;
   String JDPCompiler;
   String JDPClasses;
   String JDPJaggDSN;
   String JDPJaggJdbcDriver;
   String JDPJaggJdbcPrefix;
   String JDPJaggJdbcSuffix;
   String JDPJaggJdbcUserid;
   String JDPJaggJdbcPassword;
   String JDPJaggCSTR;
   String JDPDomain;
   String remotePathDelimiter;
   Vector eventVector;
   long lastEventTime;

   public boolean ConnectToRemoteServer() {
      this.user.mainmsg.setStatusMsg("Checking permissions...", 0);
      String var1 = "SELECT a.userid FROM JDPUser a, JDPMenuAuth b " + "WHERE a.userid = b.userid " + "AND (a.Username = '" + this.jdpUsername.getText() + "' OR a.Username = '" + this.jdpUsername.getText().toLowerCase() + "') " + "AND (a.Password = '" + this.jdpPassword.getText() + "' OR a.Password = '" + this.jdpPassword.getText().toLowerCase() + "') " + "AND (b.menuauth1 = 'ADMIN' OR b.menuauth2 = 'ADMIN' OR " + "b.menuauth3 = 'ADMIN' OR b.menuauth4 = 'ADMIN' OR " + "b.menuauth5 = 'ADMIN')";
      Vector var2 = new Vector();
      this.jaggSQL.setDSN(this.JDPJaggDSN);
      this.jaggSQL.setJdbcDriver(this.JDPJaggJdbcDriver);
      this.jaggSQL.setJdbcPrefix(this.JDPJaggJdbcPrefix);
      this.jaggSQL.setJdbcSuffix(this.JDPJaggJdbcSuffix);
      this.jaggSQL.setUID(this.JDPJaggJdbcUserid);
      this.jaggSQL.setPWD(this.JDPJaggJdbcPassword);
      this.jaggSQL.setCSTR(this.JDPJaggCSTR);
      this.newUser.JDPSystem = this.JDPSystem.getText();
      this.newUser.jaggDSN = this.JDPJaggDSN;
      this.newUser.jdbcDriver = this.JDPJaggJdbcDriver;
      this.newUser.jdbcPrefix = this.JDPJaggJdbcPrefix;
      this.newUser.jdbcSuffix = this.JDPJaggJdbcSuffix;
      this.newUser.jdbcUserid = this.JDPJaggJdbcUserid;
      this.newUser.jdbcPassword = this.JDPJaggJdbcPassword;
      this.newUser.jaggCSTR = this.JDPJaggCSTR;
      int var3 = this.jaggSQL.execSQL(var1, var2);
      if (var3 < 0) {
         this.user.mainmsg.setStatusMsg("Could not establish connection to remote server.", 15);
         return false;
      } else if (var3 == 0) {
         this.user.mainmsg.setStatusMsg("Username/Password invalid or user not authorized to remote server.", 15);
         return false;
      } else {
         this.JDPMenuMaint1.searchResults.clearList();
         this.JDPMenuMaint1.searchResults.setFromWhereClause("FROM JDPMenu WHERE JDPSystem = '" + this.newUser.JDPSystem + "'");
         this.JDPMenuMaint1.searchResults.loadList();
         this.JDPMenuMaint1.JDPDirectory = this.JDPDirectory;
         this.JDPMenuMaint1.loadMenuObject();
         this.JDPMenuMaint1.loadMenuObjectSel();
         this.JDPAddToHtml1.JDPSystem = this.JDPSystem.getText();
         this.JDPAddToHtml1.wwwroot = this.JDPDomain;
         if (!this.JDPDomain.endsWith("/")) {
            JDPAddToHtml var10000 = this.JDPAddToHtml1;
            String var10001 = var10000.wwwroot;
            var10000.wwwroot = var10001 + "/";
         }

         JDPAddToHtml var4 = this.JDPAddToHtml1;
         String var5 = var4.wwwroot;
         var4.wwwroot = var5 + "JDesignerPro";
         this.JDPAddToHtml1.JDPDirectory = this.JDPDirectory;
         this.JDPMenuAddOption1.loadChoices();
         return true;
      }
   }

   String addDelimiter(String var1) {
      String var2 = var1.substring(var1.length() - 1);
      if (!var2.equals("/") && !var2.equals("\\")) {
         if (var1.indexOf("/") >= 0) {
            var1 = var1 + "/";
         } else {
            var1 = var1 + "\\";
         }
      }

      if (var1.indexOf("/") >= 0) {
         this.remotePathDelimiter = ":";
      } else {
         this.remotePathDelimiter = ";";
      }

      return var1;
   }

   void retrieveHandle() {
      String var1 = "";

      for(int var2 = 0; var2 < this.user.gParm.size(); ++var2) {
         if (this.user.gParm.elementAt(var2) instanceof JDPLayoutMgr) {
            JDPLayoutMgr var3 = (JDPLayoutMgr)this.user.gParm.elementAt(var2);
            if (var1.equals("") || !var1.equals(var3.lastBuiltAppName)) {
               var1 = var3.lastBuiltAppName;
               this.JDPMenuAddOption1.appName = var1;
               this.JDPMenuAddOption1.menudesc.setText(var1);
               if (!var1.equals("")) {
                  this.FilePicker1.setSelectedFile(var1 + ".class");
               }
            }

            return;
         }
      }

   }

   public boolean CopyFile(String var1, JDPJagg var2, String var3, JDPJagg var4) {
      int var5 = 0;
      boolean var6 = false;
      this.user.mainmsg.setStatusMsg("Copying file...", 0);
      StringBuffer var7 = new StringBuffer();
      var2.setFCTN("ReadFromFile");
      var2.setFCTNP(var1 + ";r;");
      Vector var8 = new Vector();
      var2.execSQL("", var8);

      for(int var9 = 0; var9 < var8.size(); ++var9) {
         var7.append((String)var8.elementAt(var9));
      }

      var2.setFCTN("");
      var2.setFCTNP("");
      if (var7 != null && var7.length() != 0) {
         String var16 = var7.toString();
         var4.setFCTN("checkVersion");
         if (var4.getFCTN().equals("OK")) {
            var6 = true;
            var4.setMainMsg(this.user.mainmsg);
         }

         var4.setFCTN("WriteToFile");
         var4.setFCTNP(var3 + ";w+;");
         var8 = new Vector();
         int var10 = 1500;
         if (JDPJagg.useJaggServer) {
            var10 = 10000000;
         }

         this.user.mainmsg.setStatusMsg("Copying file...", 0);

         while(var16.length() > 0) {
            String var11 = "";
            if (var16.length() > var10) {
               var11 = var16.substring(var10);
               var5 = var4.execSQL(var16.substring(0, var10), var8);
            } else {
               var5 = var4.execSQL(var16, var8);
            }

            if (var5 < 0) {
               this.user.mainmsg.setStatusMsg("Write failed - trying again", 0);
               var5 = var4.execSQL(var16, var8);
               if (var5 < 0) {
                  this.user.mainmsg.setStatusMsg("Write failed - trying again", 0);
                  var5 = var4.execSQL(var16, var8);
                  if (var5 < 0) {
                     System.out.println(var4.getError());
                     this.user.mainmsg.setStatusMsg("File already exists. Please use another name.", 15);
                  } else {
                     this.user.mainmsg.setStatusMsg("Write successful - continuing...", 0);
                  }
               } else {
                  this.user.mainmsg.setStatusMsg("Write successful - continuing...", 0);
               }
            } else {
               for(int var12 = 0; var12 < var5; ++var12) {
                  System.out.println((String)var8.elementAt(var12));
               }
            }

            var4.setFCTNP(var3 + ";a;");
            var16 = var11;
         }

         Object var15 = null;
         var4.setFCTN("");
         var4.setFCTNP("");
         if (var5 == 0) {
            this.user.mainmsg.setStatusMsg("File successfully copied.", 10);
            if (var4.equals(this.jaggSQL)) {
               this.FilePicker2.reloadSelectedDirectory();
            } else {
               this.FilePicker1.reloadSelectedDirectory();
            }

            return true;
         } else {
            return false;
         }
      } else {
         return false;
      }
   }

   public void InitComponents() {
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               this.retrieveHandle();
               return true;
            }

            return false;
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.serverName)) {
                  this.user.u.cursor(this.serverPort);
                  return true;
               }

               if (var1.target.equals(this.serverPort)) {
                  this.user.u.cursor(this.jdpUsername);
                  return true;
               }

               if (var1.target.equals(this.jdpUsername)) {
                  this.user.u.cursor(this.jdpPassword);
                  return true;
               }

               if (var1.target.equals(this.jdpPassword)) {
                  this.user.u.cursor(this.JDPSystem);
                  return true;
               }

               if (var1.target.equals(this.JDPSystem)) {
                  this.user.u.cursor(this.serverName);
                  return true;
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.serverName)) {
                  this.user.u.cursor(this.JDPSystem);
                  return true;
               }

               if (var1.target.equals(this.serverPort)) {
                  this.user.u.cursor(this.serverName);
                  return true;
               }

               if (var1.target.equals(this.jdpUsername)) {
                  this.user.u.cursor(this.serverPort);
                  return true;
               }

               if (var1.target.equals(this.jdpPassword)) {
                  this.user.u.cursor(this.jdpUsername);
                  return true;
               }

               if (var1.target.equals(this.JDPSystem)) {
                  this.user.u.cursor(this.jdpPassword);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            this.eventVector.addElement(var1);
            Thread var2 = new Thread(this);
            var2.start();
            return true;
         case 1004:
            if (var1.target.equals(this.Main)) {
               this.retrieveHandle();
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void run() {
      Event var1 = (Event)this.eventVector.elementAt(0);
      this.lastEventTime = var1.when;
      this.eventVector.removeElementAt(0);
      if (var1.target.equals(this.DragAndDrop1)) {
         String var2 = null;
         String var3 = "";
         String var4 = null;
         JDPJagg var5 = null;
         JDPJagg var6 = null;
         JDPTreeBranch[] var7 = this.DragAndDrop1.getDraggedBranch(this.FilePicker1.List1);
         if (var7 != null) {
            var2 = this.FilePicker1.getFilePath(var7[var7.length - 1]);
            var3 = this.FilePicker1.getFileName(var7[var7.length - 1]);
            var5 = this.user.jaggSQL;
         } else {
            var7 = this.DragAndDrop1.getDraggedBranch(this.FilePicker2.List1);
            if (var7 != null) {
               var2 = this.FilePicker2.getFilePath(var7[var7.length - 1]);
               var3 = this.FilePicker1.getFileName(var7[var7.length - 1]);
               var5 = this.jaggSQL;
            }
         }

         JDPTreeBranch[] var8 = this.DragAndDrop1.getDroppedBranch(this.FilePicker2.TreeStructure1);
         if (var8 != null) {
            var4 = this.FilePicker2.getDirectoryPath(var8[var8.length - 1]) + this.FilePicker2.getSeparator() + var3;
            var6 = this.jaggSQL;
            this.FilePicker2.loadSelectedDirectory(this.FilePicker2.TreeStructure1.getCurrentBranch(), false);
         } else {
            var8 = this.DragAndDrop1.getDroppedBranch(this.FilePicker1.TreeStructure1);
            if (var8 != null) {
               var4 = this.FilePicker1.getDirectoryPath(var8[var8.length - 1]) + this.FilePicker1.getSeparator() + var3;
               var6 = this.user.jaggSQL;
               this.FilePicker1.loadSelectedDirectory(this.FilePicker1.TreeStructure1.getCurrentBranch(), false);
            }
         }

         if (var4 == null) {
            var8 = this.DragAndDrop1.getDroppedBranch(this.FilePicker2.List1);
            if (var8 != null) {
               var4 = this.FilePicker2.getDirectoryPath(var8[var8.length - 1]) + this.FilePicker2.getSeparator() + var3;
               var6 = this.jaggSQL;
            } else {
               var8 = this.DragAndDrop1.getDroppedBranch(this.FilePicker1.List1);
               if (var8 != null) {
                  var4 = this.FilePicker1.getDirectoryPath(var8[var8.length - 1]) + this.FilePicker1.getSeparator() + var3;
                  var6 = this.user.jaggSQL;
               }
            }
         }

         if (var2 != null && var4 != null) {
            this.CopyFile(var2, var5, var4, var6);
         }

      } else if (var1.target.equals(this.JDPButtons1.button[0].Button) || var1.target.equals(this.jdpPassword)) {
         if (this.GetRemoteConnectionParms()) {
            if (this.ConnectToRemoteServer()) {
               this.user.mainmsg.setStatusMsg("Successfully connected to remote server.", 10);
               this.TabPanel1.select(1);
               this.FilePicker1.setDragKey("Files");
               this.FilePicker1.setDragPanel(this.DragAndDrop1);
               this.FilePicker1.setDropMessage("Drop here to copy the selected class to this folder");
               this.FilePicker2.clearFilter();
               this.FilePicker1.addFilter("Java Class Files", ".class");
               this.FilePicker1.addFilter("Java Source Files", ".java");
               this.FilePicker1.addFilter("JDP Applications", ".jdp");
               this.FilePicker1.addFilter("All Files", "");
               this.FilePicker1.loadFiles(this.user.getJDPDir(), false);
               this.retrieveHandle();
               this.FilePicker2.setDragPanel(this.DragAndDrop1);
               this.FilePicker2.clear();
               this.FilePicker2.setDragKey("Files");
               this.FilePicker2.setDropMessage("Drop here to copy the selected class to this folder");
               this.FilePicker2.clearFilter();
               this.FilePicker2.addFilter("Java Class Files", ".class");
               this.FilePicker2.addFilter("Java Source Files", ".java");
               this.FilePicker2.addFilter("JDP Applications", ".jdp");
               this.FilePicker2.addFilter("All Files", "");
               this.FilePicker2.loadAllDrives();
               this.FilePicker2.loadFiles(this.JDPDirectory.toString(), false);
            }
         } else {
            this.user.mainmsg.setStatusMsg("Connection to remote server failed. Check server name and verify that JaggServer is running on remote server.", 10);
         }
      }
   }

   public boolean GetRemoteConnectionParms() {
      this.user.mainmsg.setStatusMsg("Attempting connection to " + this.serverName.getText() + "...", 0);
      this.jaggSQL.setServer(this.serverName.getText());
      this.jaggSQL.setPort(Integer.parseInt(this.serverPort.getText()));
      StringBuffer var1 = new StringBuffer();
      this.jaggSQL.setFCTN("ReadFromFile");
      this.jaggSQL.setFCTNP("JDesignerPro.ini" + ";r;");
      Vector var2 = new Vector();
      this.jaggSQL.execSQL("", var2);

      for(int var3 = 0; var3 < var2.size(); ++var3) {
         var1.append((String)var2.elementAt(var3));
      }

      this.jaggSQL.setFCTN("");
      this.jaggSQL.setFCTNP("");
      if (var1 != null && var1.length() != 0) {
         String var11 = var1.toString();
         StringTokenizer var4 = new StringTokenizer(var11, "\n\r");

         while(var4.hasMoreTokens()) {
            String var5 = var4.nextToken();
            if (var5.length() > 10) {
               if (var5.length() > 5 && var5.substring(0, 5).compareTo(this.JDPSystem.getText()) == 0) {
                  int var6 = var5.indexOf("JAGGSERVER=Server");
                  if (var6 > 0) {
                     JDPUtils var7 = new JDPUtils((JDPUser)null);
                     var5 = var7.replace(var5, "JAGGSERVER=Server", "");
                  } else {
                     var6 = var5.indexOf("JAGGSERVER=CGI");
                     if (var6 > 0) {
                        JDPUtils var25 = new JDPUtils((JDPUser)null);
                        var5 = var25.replace(var5, "JAGGSERVER=CGI", "");
                     }
                  }

                  String var26 = var5.substring(5);
                  int var8 = var26.indexOf("DSN=") + 4;
                  int var9 = var26.indexOf(";", var8);
                  this.JDPJaggDSN = var26.substring(var8, var9);
                  var6 = var26.indexOf("JDBCDRIVER=");
                  if (var6 >= 0) {
                     var6 = var26.indexOf("=", var6 + 1);
                     int var10 = var26.indexOf(";", var6 + 1);
                     this.JDPJaggJdbcDriver = var26.substring(var6 + 1, var10);
                     var6 = var26.indexOf("JDBCPREFIX=", var6 + 1);
                     var6 = var26.indexOf("=", var6 + 1);
                     var10 = var26.indexOf(";", var6 + 1);
                     this.JDPJaggJdbcPrefix = var26.substring(var6 + 1, var10);
                     var6 = var26.indexOf("JDBCSUFFIX=", var6 + 1);
                     var6 = var26.indexOf("=", var6 + 1);
                     var10 = var26.indexOf(";", var6 + 1);
                     this.JDPJaggJdbcSuffix = var26.substring(var6 + 1, var10);
                     var6 = var26.indexOf("UID=", var6 + 1);
                     var6 = var26.indexOf("=", var6 + 1);
                     var10 = var26.indexOf(";", var6 + 1);
                     this.JDPJaggJdbcUserid = var26.substring(var6 + 1, var10);
                     var6 = var26.indexOf("PWD=", var6 + 1);
                     var6 = var26.indexOf("=", var6 + 1);
                     var10 = var26.indexOf(";", var6 + 1);
                     this.JDPJaggJdbcPassword = var26.substring(var6 + 1, var10);
                     var6 = var26.indexOf("CSTR=", var6 + 1);
                     var6 = var26.indexOf("=", var6 + 1);
                     var10 = var26.indexOf(";", var6 + 1);
                     this.JDPJaggCSTR = var26.substring(var6 + 1, var10);
                  } else {
                     int var32 = var26.indexOf(" ");
                     this.JDPJaggCSTR = var26.substring(var32 + 1);
                  }
               }

               if (var5.substring(0, 7).compareTo("DOMAIN=") == 0) {
                  this.JDPDomain = this.addDelimiter(var5.substring(7));
               }

               if (var5.substring(0, 7).compareTo("JDPDIR=") == 0) {
                  this.JDPDirectory = this.addDelimiter(var5.substring(7));
               }

               if (var5.substring(0, 8).compareTo("JAGGDIR=") == 0) {
                  this.JDPJaggDir = this.addDelimiter(var5.substring(8));
               }

               if (var5.substring(0, 9).compareTo("COMPILER=") == 0) {
                  this.JDPCompiler = var5.substring(9);
               }

               if (var5.substring(0, 8).compareTo("CLASSES=") == 0) {
                  this.JDPClasses = var5.substring(8);
               }
            }
         }

         this.newUser.jaggPath = this.serverName.getText();
         this.FilePicker2.jaggSQL.setServer(this.serverName.getText());
         this.FilePicker2.serverSeparator = null;
         this.user.mainmsg.setStatusMsg("Successful connection to server...", 0);
         return true;
      } else {
         this.user.mainmsg.setStatusMsg("Connection failed or could not read server settings file.", 0);
         return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      this.newUser = new JDPUser();
      this.newUser.jaggPath = var1.jaggPath;
      this.newUser.jaggDSN = var1.jaggDSN;
      this.newUser.jdbcDriver = var1.jdbcDriver;
      this.newUser.jdbcPrefix = var1.jdbcPrefix;
      this.newUser.jdbcSuffix = var1.jdbcSuffix;
      this.newUser.jaggCSTR = var1.jaggCSTR;
      this.newUser.u = new JDPUtils(this.newUser);
      this.newUser.jaggSQL = this.jaggSQL;
      this.newUser.mainmsg = var1.mainmsg;
      this.newUser.gParm = var1.gParm;
      this.newUser.JDesignerPro = var1.JDesignerPro;
      this.eventVector = new Vector();
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      this.Main = new Panel();
      this.DragAndDrop1 = new JDPDragItem(var1.getJDPUser(), this.Main);
      String[] var4 = new String[5];
      Panel[] var5 = new Panel[5];
      var5[0] = new Panel();
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Select Server";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "Migrate Classes";
      var5[2] = new Panel();
      var5[2].setLayout(new BorderLayout());
      var4[2] = "Remote Add to Menu";
      var5[3] = new Panel();
      var5[3].setLayout(new BorderLayout());
      var4[3] = "Remote Html Creation";
      var5[4] = new Panel();
      var5[4].setLayout(new BorderLayout());
      var4[4] = "Remote Menu Maintenance";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.ChiselPanel2 = new JDPChiselFramePanel(var1, "Select the server you wish to deploy to");
      this.Panel1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label1 = new Label("Server Name or IP:", 0);
      this.serverName = new TextField("", 30);
      this.Label2 = new Label("Server Port:", 0);
      this.serverPort = new TextField("", 8);
      this.Label3 = new Label("User Name:", 0);
      this.jdpUsername = new TextField("", 20);
      this.Label4 = new Label("Password:", 0);
      this.jdpPassword = new TextField("", 20);
      this.Label7 = new Label("JDP System:", 0);
      this.JDPSystem = new TextField("", 10);
      String[] var6 = new String[]{"Connect"};
      int[] var7 = new int[]{JDPButton.getIconValue("Go")};
      this.JDPButtons1 = new JDPButtons(var1, var6, var7, JDPButtons.getAlignmentValue("Horizontal"));
      this.ChiselPanel3 = new JDPChiselFramePanel(var1, "Copy the classes to the server");
      this.Panel2 = new JDPSplitPanel(var1);
      this.Panel3 = new Panel();
      this.FilePicker1 = new JDPFilePicker();
      this.FilePicker1.InitClass(var1, this.Main, var3);
      this.FilePicker1.JDPButtons1.hide();
      this.FilePicker1.setAutoScroll(false);
      this.Label5 = new Label("Drag the class from this machine to the remote server", 0);
      this.Panel4 = new Panel();
      this.FilePicker2 = new JDPFilePicker();
      this.FilePicker2.InitClass(var1, this.Main, var3);
      this.FilePicker2.JDPButtons1.hide();
      this.FilePicker2.setAutoScroll(false);
      this.Label6 = new Label("Drop the class in the JDesignerPro folder", 0);
      this.JDPMenuAddOption1 = new JDPMenuAddOption();
      this.JDPMenuAddOption1.InitClass(this.newUser, var2, var3);
      this.JDPMenuAddOption1.jaggSQL = this.jaggSQL;
      this.JDPMenuMaint1 = new JDPMenuMaint();
      this.JDPMenuMaint1.jaggSQL = this.jaggSQL;
      this.JDPMenuMaint1.InitClass(this.newUser, var2, var3);
      this.JDPAddToHtml1 = new JDPAddToHtml();
      this.JDPAddToHtml1.utils = this.newUser.u;
      this.JDPAddToHtml1.InitClass(this.newUser, var2, var3);
      this.Panel5 = new Panel();
      this.JDPDirectory = new String();
      this.JDPJaggDir = new String();
      this.JDPCompiler = new String();
      this.JDPClasses = new String();
      this.JDPJaggDSN = new String();
      this.JDPJaggJdbcDriver = new String();
      this.JDPJaggJdbcPrefix = new String();
      this.JDPJaggJdbcSuffix = new String();
      this.JDPJaggJdbcUserid = new String();
      this.JDPJaggJdbcPassword = new String();
      this.JDPJaggCSTR = new String();
      this.JDPDomain = new String();
      this.remotePathDelimiter = new String();
      this.Main.setLayout(new BorderLayout());
      if (JDesignerPro.executable) {
         ((Container)this).add("Center", this.Main);
      }

      this.Main.add("West", this.DragAndDrop1);
      this.Main.add("Center", this.TabPanel1);
      var5[0].add("Center", this.ChiselPanel2);
      this.ChiselPanel2.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.serverName);
      this.ScrollPanel1.add("Left", this.Label2);
      this.ScrollPanel1.add("Right", this.serverPort);
      this.ScrollPanel1.add("Left", this.Label3);
      this.ScrollPanel1.add("Right", this.jdpUsername);
      this.ScrollPanel1.add("Left", this.Label4);
      this.ScrollPanel1.add("Right", this.jdpPassword);
      this.ScrollPanel1.add("Left", this.Label7);
      this.ScrollPanel1.add("Right", this.JDPSystem);
      this.Panel1.add("South", this.JDPButtons1);
      var5[1].add("Center", this.ChiselPanel3);
      this.ChiselPanel3.add("Center", this.Panel2);
      this.Panel2.add("Left", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("Center", this.FilePicker1);
      this.Panel3.add("North", this.Label5);
      this.Panel2.add("Right", this.Panel4);
      this.Panel4.setLayout(new BorderLayout());
      this.Panel4.add("Center", this.FilePicker2);
      this.Panel4.add("North", this.Label6);
      var5[2].add("Center", this.JDPMenuAddOption1);
      var5[3].add("Center", this.JDPAddToHtml1);
      var5[4].add("Center", this.JDPMenuMaint1);
      this.Main.add("South", this.Panel5);
      this.Panel5.setLayout(new BorderLayout());
      this.Label1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.serverName, "Remote Server Domain or IP", "Enter the Domain name or IP address of the remote server that has JaggServer running");
      this.Label2.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.serverPort, "Remote Server Port Number", "Enter the port number that JaggServer is listening on");
      this.serverPort.setText("4899");
      this.Label3.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.jdpUsername, "Remote Server Username", "Enter the username on the remote server that has administator priviledges");
      this.Label4.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.jdpPassword, "Remote Server Password", "Enter the password that matches the username you have entered");
      this.jdpPassword.setEchoCharacter('*');
      this.Label7.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.JDPSystem, "JDesignerPro System Number", "Enter the JDesignerPro System number to connect to on the remote server");
      this.JDPSystem.setText("01001");
      this.popuppanel.addComponent(this.JDPButtons1.button[0], "Connect to Remote Server", "Establish a connection with the remote server");
      this.InitComponents();
      var1.gParm.addElement(this);
      if (!JDesignerPro.executable) {
         var1.mainmsg.setStatusMsg("Remote Deployment will not function when run through a browser. Load JDP locally to perform Remote Deployment.", 30);
      }

   }
}
