import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPEventMaintenance extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   Panel Panel2;
   JDPScrollPanel ScrollPanel1;
   Label EVENTNAMELabel1;
   Label EVENTDESCLabel1;
   Panel Panel3;
   TextField EVENTNAME1;
   Checkbox STATUS1;
   TextField EVENTDESC1;
   JDPTabSelectPanel TabPanel1;
   JDPChiselFramePanel ChiselPanel2;
   Panel Panel5;
   Panel Panel6;
   JDPCardPanel CardPanel1;
   Panel Panel9;
   JDPChiselFramePanel ChiselPanel6;
   JDPScrollPanel ScrollPanel3;
   Label Label1;
   Panel Panel8;
   JDPDate oneTimeStartDate;
   TextField oneTimeStartTime;
   JDPChoice Choice1;
   Vector valueChoice1;
   JDPMaskEdit MaskEdit1;
   JDPRecurSelection recur;
   Panel Panel7;
   Label EVENTTYPELabel1;
   JDPChoice EVENTTYPE1;
   Vector valueEVENTTYPE1;
   JDPChiselFramePanel ChiselPanel3;
   Panel Panel4;
   JDPObjectSelection JDPObjectSelection1;
   JDPChiselFramePanel ChiselPanel7;
   JDPScrollPanel ScrollPanel2;
   Label Label3;
   Label Label4;
   JDPChoice JOBQUEUE;
   Vector valueJOBQUEUE;
   Label Label6;
   Label Label5;
   JDPSpinner QUEPRIORTY;
   JDPSpinner JOBPRIORTY;
   JDPChoice JOBHELD;
   Vector valueJOBHELD;
   JDPChiselFramePanel ChiselPanel4;
   Panel Panel10;
   JDPScrollPanel ScrollPanel4;
   Label NOTIFYUSERLabel1;
   JDPChoice NOTIFYUSER1;
   Vector valueNOTIFYUSER1;
   Label NOTIFYVIALabel1;
   JDPChoice NOTIFYVIA1;
   Vector valueNOTIFYVIA1;
   Label NOTIFYONLabel1;
   JDPChoice NOTIFYON1;
   Vector valueNOTIFYON1;
   Checkbox Checkbox1;
   JDPChiselFramePanel ChiselPanel5;
   JDPScrollPanel ScrollPanel5;
   Label Label2;
   JDPChoice LOGEVENT1;
   Vector valueLOGEVENT1;
   JDPButtons JDPButtons1;
   JDPSearchResults ResultList1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Event Maintenance");
      this.Panel1 = new Panel();
      this.Panel2 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.EVENTNAMELabel1 = new Label("Event Name:", 0);
      this.EVENTDESCLabel1 = new Label("Description:", 0);
      this.Panel3 = new Panel();
      this.EVENTNAME1 = new TextField("EVENTNAME", 20);
      this.STATUS1 = new Checkbox("Enabled");
      this.EVENTDESC1 = new TextField("EVENTDESC", 50);
      String[] var4 = new String[5];
      Panel[] var5 = new Panel[5];
      var5[0] = new Panel();
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Event Type";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "Action Performed";
      var5[2] = new Panel();
      var5[2].setLayout(new BorderLayout());
      var4[2] = "Queuing";
      var5[3] = new Panel();
      var5[3].setLayout(new BorderLayout());
      var4[3] = "Notification";
      var5[4] = new Panel();
      var5[4].setLayout(new BorderLayout());
      var4[4] = "Logging";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.ChiselPanel2 = new JDPChiselFramePanel(var1, "Select the Event Type ");
      this.Panel5 = new Panel();
      this.Panel6 = new Panel();
      this.CardPanel1 = new JDPCardPanel();
      this.Panel9 = new Panel();
      this.ChiselPanel6 = new JDPChiselFramePanel(var1, "Occurs");
      this.ScrollPanel3 = new JDPScrollPanel();
      this.Label1 = new Label("When:", 0);
      this.Panel8 = new Panel();
      this.oneTimeStartDate = new JDPDate(var1, "", 8);
      this.oneTimeStartTime = new TextField("12:00", 6);
      this.Choice1Main();
      this.MaskEdit1 = new JDPMaskEdit();
      this.recur = new JDPRecurSelection();
      this.recur.InitClass(var1, var2, var3);
      this.Panel7 = new Panel();
      this.EVENTTYPELabel1 = new Label("Type:", 0);
      this.EVENTTYPE1Main();
      this.ChiselPanel3 = new JDPChiselFramePanel(var1, "Select the type of action to be performed");
      this.Panel4 = new Panel();
      this.JDPObjectSelection1 = new JDPObjectSelection();
      this.JDPObjectSelection1.InitClass(var1, var2, var3);
      this.ChiselPanel7 = new JDPChiselFramePanel(var1, "Select the Job Queue and Priority");
      this.ScrollPanel2 = new JDPScrollPanel();
      this.Label3 = new Label("Job Queue:", 0);
      this.Label4 = new Label("Queue Priority:", 0);
      this.JOBQUEUEMain();
      this.Label6 = new Label("Execution Priority:", 0);
      this.Label5 = new Label("Held on Queue:", 0);
      this.QUEPRIORTY = new JDPSpinner(var1, "", 4);
      this.JOBPRIORTY = new JDPSpinner(var1, "", 4);
      this.JOBHELDMain();
      this.ChiselPanel4 = new JDPChiselFramePanel(var1, "Set the notification parameters");
      this.Panel10 = new Panel();
      this.ScrollPanel4 = new JDPScrollPanel();
      this.NOTIFYUSERLabel1 = new Label("Notify User:", 0);
      this.NOTIFYUSER1Main();
      this.NOTIFYVIALabel1 = new Label("Notify Via:", 0);
      this.NOTIFYVIA1Main();
      this.NOTIFYONLabel1 = new Label("Notify On:", 0);
      this.NOTIFYON1Main();
      this.Checkbox1 = new Checkbox("Activate Notification");
      this.ChiselPanel5 = new JDPChiselFramePanel(var1, "Set the logging level");
      this.ScrollPanel5 = new JDPScrollPanel();
      this.Label2 = new Label("Log Event on:", 0);
      this.LOGEVENT1Main();
      String[] var6 = new String[]{"Apply", "Add", "Delete", "Refresh", "Submit"};
      int[] var7 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("New"), JDPButton.getIconValue("Delete"), JDPButton.getIconValue("Circular"), JDPButton.getIconValue("Go")};
      this.JDPButtons1 = new JDPButtons(var1, var6, var7, JDPButtons.getAlignmentValue("Horizontal"));
      this.ResultList1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("North", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.EVENTNAMELabel1);
      this.ScrollPanel1.add("Left", this.EVENTDESCLabel1);
      this.ScrollPanel1.add("Right", this.Panel3);
      this.Panel3.setLayout(new JDPLineLayout());
      this.Panel3.add("Left", this.EVENTNAME1);
      this.Panel3.add("Left", this.STATUS1);
      this.ScrollPanel1.add("Right", this.EVENTDESC1);
      this.Panel2.add("Center", this.TabPanel1);
      var5[0].add("Center", this.ChiselPanel2);
      this.ChiselPanel2.add("Center", this.Panel5);
      this.Panel5.setLayout(new BorderLayout());
      this.Panel5.add("Center", this.Panel6);
      this.Panel6.setLayout(new BorderLayout());
      this.Panel6.add("Center", this.CardPanel1);
      this.CardPanel1.add("Panel9", this.Panel9);
      this.Panel9.setLayout(new BorderLayout());
      this.CardPanel1.add("ChiselPanel6", this.ChiselPanel6);
      this.ChiselPanel6.add("Center", this.ScrollPanel3);
      this.ScrollPanel3.add("Left", this.Label1);
      this.ScrollPanel3.add("Right", this.Panel8);
      this.Panel8.setLayout(new JDPLineLayout());
      this.Panel8.add("Left", this.oneTimeStartDate);
      this.Panel8.add("Left", this.oneTimeStartTime);
      this.Panel8.add("Left", this.Choice1);
      this.CardPanel1.add("recur", this.recur);
      this.Panel5.add("North", this.Panel7);
      this.Panel7.setLayout(new JDPLineLayout());
      this.Panel7.add("Left", this.EVENTTYPELabel1);
      this.Panel7.add("Left", this.EVENTTYPE1);
      var5[1].add("Center", this.ChiselPanel3);
      this.ChiselPanel3.add("Center", this.Panel4);
      this.Panel4.setLayout(new BorderLayout());
      this.Panel4.add("Center", this.JDPObjectSelection1);
      var5[2].add("Center", this.ChiselPanel7);
      this.ChiselPanel7.add("Center", this.ScrollPanel2);
      this.ScrollPanel2.add("Left", this.Label3);
      this.ScrollPanel2.add("Left", this.Label4);
      this.ScrollPanel2.add("Right", this.JOBQUEUE);
      this.ScrollPanel2.add("Left", this.Label6);
      this.ScrollPanel2.add("Left", this.Label5);
      this.ScrollPanel2.add("Right", this.QUEPRIORTY);
      this.ScrollPanel2.add("Right", this.JOBPRIORTY);
      this.ScrollPanel2.add("Right", this.JOBHELD);
      var5[3].add("Center", this.ChiselPanel4);
      this.ChiselPanel4.add("Center", this.Panel10);
      this.Panel10.setLayout(new BorderLayout());
      this.Panel10.add("Center", this.ScrollPanel4);
      this.ScrollPanel4.add("Left", this.NOTIFYUSERLabel1);
      this.ScrollPanel4.add("Right", this.NOTIFYUSER1);
      this.ScrollPanel4.add("Left", this.NOTIFYVIALabel1);
      this.ScrollPanel4.add("Right", this.NOTIFYVIA1);
      this.ScrollPanel4.add("Left", this.NOTIFYONLabel1);
      this.ScrollPanel4.add("Right", this.NOTIFYON1);
      this.Panel10.add("North", this.Checkbox1);
      var5[4].add("Center", this.ChiselPanel5);
      this.ChiselPanel5.add("Center", this.ScrollPanel5);
      this.ScrollPanel5.add("Left", this.Label2);
      this.ScrollPanel5.add("Right", this.LOGEVENT1);
      this.Panel2.add("South", this.JDPButtons1);
      this.Panel1.add("West", this.ResultList1);
      this.EVENTNAMELabel1.setFont(new Font("Helvetica", 1, 11));
      this.EVENTDESCLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.EVENTNAME1, "Event Name", "Enter the name of the event");
      this.STATUS1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.STATUS1, "Status", "Choose whether or not the event is activated");
      this.popuppanel.addComponent(this.EVENTDESC1, "Eventdesc", "Enter the description of the event");
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(1, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(2, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(3, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(4, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.EVENTTYPELabel1.setFont(new Font("Helvetica", 1, 11));
      this.Label3.setFont(new Font("Helvetica", 1, 11));
      this.Label4.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.JOBQUEUE, "", "Select the Job Queue to which this event is submitted");
      this.Label6.setFont(new Font("Helvetica", 1, 11));
      this.Label5.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.JOBHELD, "", "Select whether this job should enter the Job queue in a Held state");
      this.NOTIFYUSERLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.NOTIFYUSER1, "Notifyuser", "Select the user to receive notification of the job");
      this.NOTIFYVIALabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.NOTIFYVIA1, "Notifyvia", "Select the media that the user will be notified with");
      this.NOTIFYONLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.NOTIFYON1, "Notifyon", "Select the completion status that will cause notification");
      this.Checkbox1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.Checkbox1, "", "Select where notification is enabled");
      this.Label2.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.LOGEVENT1, "", "Select whether logging information is retained after this event completes");
      this.popuppanel.addComponent(this.JDPButtons1.button[0], "Apply changes", "Saves changes made to this event");
      this.popuppanel.addComponent(this.JDPButtons1.button[1], "Create a new event", "Select the settings for a new event and then press here to create the event");
      this.popuppanel.addComponent(this.JDPButtons1.button[2], "Delete", "Remove the currently selected event");
      this.popuppanel.addComponent(this.JDPButtons1.button[3], "Reload the Event list", "Reload the list of events");
      this.popuppanel.addComponent(this.JDPButtons1.button[4], "Submit to Job Queue", "Submit the selected job to the Job Queue");
      this.popuppanel.addComponent(this.ResultList1, "", "Displays a list of all the events that have been defined");
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.EVENTNAME1)) {
                  this.user.u.cursor(this.EVENTDESC1);
               }

               if (var1.target.equals(this.STATUS1)) {
                  this.user.u.cursor(this.NOTIFYUSER1);
               }

               if (var1.target.equals(this.EVENTDESC1)) {
                  this.user.u.cursor(this.STATUS1);
               }

               if (var1.target.equals(this.JOBQUEUE)) {
                  this.user.u.cursor(this.JOBPRIORTY);
               }

               if (var1.target.equals(this.JOBHELD)) {
                  this.user.u.cursor(this.JOBQUEUE);
               }

               if (var1.target.equals(this.NOTIFYUSER1)) {
                  this.user.u.cursor(this.NOTIFYVIA1);
               }

               if (var1.target.equals(this.NOTIFYVIA1)) {
                  this.user.u.cursor(this.NOTIFYON1);
               }

               if (var1.target.equals(this.NOTIFYON1)) {
                  this.user.u.cursor(this.NOTIFYUSER1);
               }

               if (var1.target.equals(this.Checkbox1)) {
                  this.user.u.cursor(this.NOTIFYUSER1);
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.STATUS1)) {
                  this.user.u.cursor(this.EVENTDESC1);
                  return true;
               }

               if (var1.target.equals(this.EVENTDESC1)) {
                  this.user.u.cursor(this.EVENTNAME1);
                  return true;
               }

               if (var1.target.equals(this.JOBQUEUE)) {
                  this.user.u.cursor(this.JOBHELD);
                  return true;
               }

               if (var1.target.equals(this.JOBHELD)) {
                  this.user.u.cursor(this.JOBPRIORTY);
                  return true;
               }

               if (var1.target.equals(this.NOTIFYUSER1)) {
                  this.user.u.cursor(this.Checkbox1);
                  return true;
               }

               if (var1.target.equals(this.NOTIFYVIA1)) {
                  this.user.u.cursor(this.NOTIFYUSER1);
                  return true;
               }

               if (var1.target.equals(this.NOTIFYON1)) {
                  this.user.u.cursor(this.NOTIFYVIA1);
                  return true;
               }

               if (var1.target.equals(this.Checkbox1)) {
                  this.user.u.cursor(this.NOTIFYON1);
                  return true;
               }
            }

            return false;
         case 402:
            if (var1.target.equals(this.oneTimeStartTime)) {
               this.MaskEdit1.formatFloat(this.oneTimeStartTime, "99:99");
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.EVENTTYPE1)) {
               if (this.EVENTTYPE1.getSelectedKey().equals("O")) {
                  this.CardPanel1.setSelectedComp("ChiselPanel6");
               } else if (this.EVENTTYPE1.getSelectedKey().equals("R")) {
                  this.CardPanel1.setSelectedComp("recur");
               } else {
                  this.CardPanel1.setSelectedComp("Panel9");
               }

               return true;
            } else if (var1.target.equals(this.Checkbox1)) {
               if (this.Checkbox1.getState()) {
                  this.NOTIFYUSER1.enable();
                  this.NOTIFYVIA1.enable();
                  this.NOTIFYON1.enable();
               } else {
                  this.NOTIFYUSER1.disable();
                  this.NOTIFYVIA1.disable();
                  this.NOTIFYON1.disable();
                  this.NOTIFYUSER1.select(0);
               }

               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[0])) {
               if (!this.Columns1updateRow(this.ResultList1.getSelectedKey())) {
                  return true;
               }

               this.InterruptScheduler();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               if (!this.Columns1insertRow(this.ResultList1.getSelectedKey())) {
                  return true;
               }

               this.ResultList1.clearList();
               this.ResultList1.loadList();
               this.convertIcons();
               this.InterruptScheduler();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[2])) {
               this.Columns1removeRow(this.ResultList1.getSelectedKey());
               this.InterruptScheduler();
               this.ResultList1.clearList();
               this.ResultList1.loadList();
               this.convertIcons();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[3])) {
               this.ResultList1.clearList();
               this.ResultList1.loadList();
               this.convertIcons();
               this.Columns1LoadChoices();
               this.JOBQUEUEMain();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[4])) {
               this.SubmitJob();
               return true;
            } else {
               if (var1.target.equals(this.ResultList1)) {
                  this.Columns1Load(this.ResultList1.getSelectedKey());
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.Columns1Main();
      this.jaggSQL.setKeepConnectionOpen(false);
      this.QUEPRIORTY.setMinValue(1);
      this.QUEPRIORTY.setMaxValue(10);
      this.QUEPRIORTY.setValue(5);
      this.JOBPRIORTY.setMinValue(1);
      this.JOBPRIORTY.setMaxValue(10);
      this.JOBPRIORTY.setValue(5);
   }

   public void Columns1Main() {
      this.Columns1LoadChoices();
      this.Columns1ClearFields();
   }

   public void Columns1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var8 = "SELECT EVENTNAME,EVENTDESC,EVENTTYPE,FREQUENCY,FREQINT,FREQDAYS,FREQSTDAY,FREQWEEK,FREQWEEKDY,STARTDATE,STARTTIME,ENDDATE,ENDTIME,REPFREQ,REPFREQUOM,STATUS,OBJECTTYPE,OBJECT,OBJECTCONS,OBJECTPARM,JOBQUEUE,JOBPRIORTY,QUEPRIORTY,JOBHELD,NOTIFYUSER,NOTIFYVIA,NOTIFYON,LOGEVENT FROM JDPEvent WHERE (1=1)";
         if (var1.length > 0 && var1[0] != null) {
            var8 = var8 + " AND JDPSYSTEM='" + var1[0] + "'";
         }

         if (var1.length > 1 && var1[1] != null) {
            var8 = var8 + " AND EVENTNAME='" + var1[1] + "'";
         }

         this.jaggSQL.loadSettings(this.user);
         this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
         var3 = this.jaggSQL.execSQL(var8, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var8);
         } else {
            if (var3 >= 1) {
               String var6 = (String)var4.elementAt(0);
               if (var6 != null && var6.trim().compareTo("") != 0) {
                  StringTokenizer var2 = new StringTokenizer(var6, var5);
                  this.EVENTNAME1.setText(var2.nextToken().trim());
                  this.EVENTDESC1.setText(var2.nextToken().trim());
                  this.EVENTTYPE1.selectKey(var2.nextToken(var5).trim());
                  this.recur.setFrequency(var2.nextToken(var5).trim());
                  this.recur.setFreqInt(Integer.parseInt(var2.nextToken().trim()));
                  this.recur.setFreqDays(var2.nextToken().trim());
                  this.recur.setFreqStDay(Integer.parseInt(var2.nextToken().trim()));
                  this.recur.setFreqWeek(Integer.parseInt(var2.nextToken().trim()));
                  this.recur.setFreqWeekDy(Integer.parseInt(var2.nextToken(var5).trim()));
                  Date var9 = new Date(Long.valueOf(var2.nextToken().trim()));
                  this.oneTimeStartDate.setDate(var9);
                  this.recur.setStartDate(var9);
                  long var10 = Long.valueOf(var2.nextToken().trim());
                  this.setStartTime(var10);
                  this.recur.setStartTime(var10);
                  this.recur.setEndDate(new Date(Long.valueOf(var2.nextToken().trim())));
                  this.recur.setEndTime(Long.valueOf(var2.nextToken().trim()));
                  this.recur.setRepFreq(Integer.parseInt(var2.nextToken().trim()));
                  this.recur.setRepFreqUOM(var2.nextToken(var5).trim());
                  String var7 = var2.nextToken(var5).trim();
                  this.STATUS1.setState(var7.equals("Y"));
                  this.JDPObjectSelection1.setObjectType(var2.nextToken().trim());
                  this.JDPObjectSelection1.setObject(var2.nextToken().trim());
                  this.JDPObjectSelection1.setConstructor(var2.nextToken().trim());
                  this.JDPObjectSelection1.setParameters(var2.nextToken().trim());
                  this.JOBQUEUE.select(var2.nextToken(var5).trim());
                  this.JOBPRIORTY.setText(var2.nextToken(var5).trim());
                  this.QUEPRIORTY.setText(var2.nextToken(var5).trim());
                  this.JOBHELD.selectKey(var2.nextToken(var5).trim());
                  var7 = var2.nextToken(var5).trim();
                  this.NOTIFYUSER1.selectKey(var7);
                  var7 = var2.nextToken(var5).trim();
                  this.NOTIFYVIA1.selectKey(var7);
                  var7 = var2.nextToken(var5).trim();
                  this.NOTIFYON1.selectKey(var7);
                  this.LOGEVENT1.selectKey(var2.nextToken(var5).trim());
               }

               if (var3 > 1) {
                  this.user.mainmsg.setStatusMsg(JDPLang.get("Message1"), 10);
               } else {
                  this.user.mainmsg.clearStatusMsg();
               }
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message2"), 10);
               this.Columns1ClearFields();
            }

            ((Container)this).deliverEvent(new Event(this.EVENTTYPE1, 1001, ""));
            this.Checkbox1.setState(!this.NOTIFYUSER1.getSelectedItem().equals(""));
         }
      } else {
         this.Columns1ClearFields();
      }
   }

   public boolean Columns1updateRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "U") : false;
   }

   public boolean Columns1insertRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "I") : false;
   }

   public boolean Columns1removeRow(String[] var1) {
      return this.Columns1Save(var1, "D");
   }

   boolean Columns1Save(String[] var1, String var2) {
      int var3 = 0;
      Vector var4 = new Vector();
      this.jaggSQL.getSEP();
      String var5 = "";
      Object var6 = null;
      Date var7 = this.recur.getStartDate();
      long var8 = this.recur.getStartTime();
      if (this.EVENTTYPE1.getSelectedKey().equals("O")) {
         var7 = this.oneTimeStartDate.getDate();
         var8 = this.getStartTime();
      }

      if (var2.equals("I")) {
         var5 = "INSERT INTO JDPEvent (JDPSYSTEM, EVENTNAME, EVENTDESC, EVENTTYPE, FREQUENCY, FREQINT, FREQDAYS, FREQSTDAY, FREQWEEK, FREQWEEKDY, STARTDATE, STARTTIME, ENDDATE, ENDTIME, REPFREQ, REPFREQUOM, NEXTRUNTIM, STATUS, OBJECTTYPE, OBJECT, OBJECTPARM, OBJECTCONS, JOBQUEUE, JOBPRIORTY, QUEPRIORTY, JOBHELD, NOTIFYUSER, NOTIFYVIA, NOTIFYON, LOGEVENT, ACTUALSTRT, ACTUALEND, LASTSTATUS) VALUES('" + this.user.JDPSystem + "', " + "'" + this.user.u.replace(this.EVENTNAME1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.EVENTDESC1.getText(), "'", "''") + "', " + "'" + this.EVENTTYPE1.getSelectedKey() + "', " + "'" + this.recur.getFrequency() + "', " + "" + Integer.toString(this.recur.getFreqInt()) + ", " + "'" + this.recur.getFreqDays() + "', " + "" + Integer.toString(this.recur.getFreqStDay()) + ", " + "" + Integer.toString(this.recur.getFreqWeek()) + ", " + "" + Integer.toString(this.recur.getFreqWeekDy()) + ", " + "" + JDPDate.formatForSql(var7, this.user.DSNType) + ", " + "" + Long.toString(var8) + ", " + "" + JDPDate.formatForSql(this.recur.getEndDate(), this.user.DSNType) + ", " + "" + Long.toString(this.recur.getEndTime()) + ", " + "" + Integer.toString(this.recur.getRepFreq()) + ", " + "'" + this.recur.getRepFreqUOM() + "', " + "0, " + "'" + (this.STATUS1.getState() ? "Y" : "N") + "', " + "'" + this.JDPObjectSelection1.getObjectType() + "', " + "'" + this.JDPObjectSelection1.getObject() + "', " + "'" + this.JDPObjectSelection1.getParameters() + "', " + "'" + this.JDPObjectSelection1.getConstructor() + "', " + "'" + this.JOBQUEUE.getSelectedItem() + "', " + "" + this.JOBPRIORTY.getText() + ", " + "" + this.QUEPRIORTY.getText() + ", " + "'" + this.JOBHELD.getSelectedKey() + "', " + "" + this.NOTIFYUSER1.getSelectedKey() + ", " + "'" + this.NOTIFYVIA1.getSelectedKey() + "', " + "'" + this.NOTIFYON1.getSelectedKey() + "', " + "'" + this.LOGEVENT1.getSelectedKey() + "', " + "0, " + "0, " + "'')";
      } else {
         if (var1 == null || var1.length == 0) {
            this.user.mainmsg.setStatusMsg(JDPLang.get("Message3"), 5);
            return false;
         }

         if (var2.equals("D")) {
            var5 = "DELETE FROM JDPEvent WHERE JDPSYSTEM='" + var1[0] + "'" + " AND EVENTNAME='" + var1[1] + "'";
         } else {
            var5 = "UPDATE JDPEvent SET EVENTDESC = '" + this.user.u.replace(this.EVENTDESC1.getText(), "'", "''") + "', " + "EVENTTYPE = '" + this.EVENTTYPE1.getSelectedKey() + "', " + "FREQUENCY = '" + this.recur.getFrequency() + "', " + "FREQINT = " + Integer.toString(this.recur.getFreqInt()) + ", " + "FREQDAYS = '" + this.recur.getFreqDays() + "', " + "FREQSTDAY = " + Integer.toString(this.recur.getFreqStDay()) + ", " + "FREQWEEK = " + Integer.toString(this.recur.getFreqWeek()) + ", " + "FREQWEEKDY = " + Integer.toString(this.recur.getFreqWeekDy()) + ", " + "STARTDATE = " + JDPDate.formatForSql(var7, this.user.DSNType) + ", " + "STARTTIME = " + Long.toString(var8) + ", " + "ENDDATE = " + JDPDate.formatForSql(this.recur.getEndDate(), this.user.DSNType) + ", " + "ENDTIME = " + Long.toString(this.recur.getEndTime()) + ", " + "REPFREQ = " + Integer.toString(this.recur.getRepFreq()) + ", " + "REPFREQUOM = '" + this.recur.getRepFreqUOM() + "', " + "STATUS = '" + (this.STATUS1.getState() ? "Y" : "N") + "', " + "OBJECTTYPE = '" + this.JDPObjectSelection1.getObjectType() + "', " + "OBJECT = '" + this.JDPObjectSelection1.getObject() + "', " + "OBJECTPARM = '" + this.JDPObjectSelection1.getParameters() + "', " + "OBJECTCONS = '" + this.JDPObjectSelection1.getConstructor() + "', " + "JOBQUEUE = '" + this.JOBQUEUE.getSelectedItem() + "', " + "JOBPRIORTY = " + this.JOBPRIORTY.getText() + ", " + "QUEPRIORTY = " + this.QUEPRIORTY.getText() + ", " + "JOBHELD = '" + this.JOBHELD.getSelectedKey() + "', " + "NOTIFYUSER = " + this.NOTIFYUSER1.getSelectedKey() + ", " + "NOTIFYVIA = '" + this.NOTIFYVIA1.getSelectedKey() + "', " + "NOTIFYON = '" + this.NOTIFYON1.getSelectedKey() + "', " + "LOGEVENT = '" + this.LOGEVENT1.getSelectedKey() + "'" + " WHERE JDPSYSTEM='" + var1[0] + "'" + " AND EVENTNAME='" + var1[1] + "'";
         }
      }

      this.jaggSQL.loadSettings(this.user);
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      var3 = this.jaggSQL.execSQL(var5, var4);
      if (var3 == 0 && var6 != null) {
         String[] var10 = new String[]{JDPLang.get("Reload"), JDPLang.get("Update")};
         int[] var11 = new int[]{6, 0};
         JDPMessageDialog var12 = new JDPMessageDialog(this.user, this.user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), var10, var11);
         ((JDPDialog)var12).display();
         if (var12.getPressedButton() != 1) {
            this.Columns1Load(var1);
            return true;
         }

         var4 = new Vector();
         var3 = this.jaggSQL.execSQL((String)var6, var4);
      }

      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var5);
         return false;
      } else {
         if (var3 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message4"), 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message5"), 3);
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message6"), 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var5);
         }

         if (var6 != null) {
            this.Columns1Load(var1);
         }

         return true;
      }
   }

   public void Columns1ClearFields() {
      this.EVENTNAME1.setText("");
      this.EVENTDESC1.setText("");
      this.EVENTTYPE1.select(0);
      this.STATUS1.setState(false);
      this.NOTIFYUSER1.select(0);
      this.NOTIFYVIA1.select(0);
      this.NOTIFYON1.select(0);
      this.LOGEVENT1.select(0);
   }

   void Columns1LoadChoices() {
      this.NOTIFYVIA1.clear();
      this.NOTIFYVIA1.addItem("Pager", "P");
      this.NOTIFYVIA1.addItem("Email", "E");
      this.NOTIFYVIA1.addItem("Both", "B");
      this.NOTIFYON1.clear();
      this.NOTIFYON1.addItem("Failure", "F");
      this.NOTIFYON1.addItem("Success", "S");
      this.NOTIFYON1.addItem("Both", "B");
      this.jaggSQL.loadSettings(this.user);
      this.NOTIFYUSER1.clear();
      this.NOTIFYUSER1.addItem("", "-1");
      new JDPLoadChoice(this.user, this.jaggSQL, this.NOTIFYUSER1, "USERNAME", "USERID", "JDPUSER", "(1=1)", (Vector)null);
   }

   public boolean Columns1CheckFields() {
      if (!this.user.u.ischaracter(this.EVENTNAME1, this.user.mainmsg)) {
         return false;
      } else {
         return this.user.u.ischaracter(this.EVENTDESC1, this.user.mainmsg);
      }
   }

   public void convertIcons() {
      JDPTreeBranch var1 = this.ResultList1.tree.treeRoot;

      for(int var2 = 0; var2 < var1.leaves.size(); ++var2) {
         JDPTreeBranch var3 = (JDPTreeBranch)var1.leaves.elementAt(var2);
         if (var3.name.equals("One Time")) {
            var3.icon = 37;
         }

         if (var3.name.equals("Recurring")) {
            var3.icon = 37;
         }

         if (var3.name.equals("On Demand")) {
            var3.icon = 5;
         }

         if (var3.name.equals("Triggered")) {
            var3.icon = 12;
         }

         if (var3.name.equals("Auto Start")) {
            var3.icon = 28;
         }
      }

      this.ResultList1.tree.reDraw();
   }

   public void setEventName(String var1) {
      this.EVENTNAME1.setText(var1);
   }

   public void setEventDescription(String var1) {
      this.EVENTDESC1.setText(var1);
   }

   public void resetSelections() {
      this.ResultList1.resetSelections();
   }

   public void setClassName(String var1) {
      this.JDPObjectSelection1.setObjectType("C");
      this.JDPObjectSelection1.setObject(var1);
      this.JDPObjectSelection1.loadconstructors(var1);
   }

   public void setEnabled(boolean var1) {
      this.STATUS1.setState(var1);
   }

   public long getStartTime() {
      String var1 = this.oneTimeStartTime.getText();
      int var2 = var1.indexOf(":");
      String var3 = var1.substring(0, var2);
      if (var3.equals("12")) {
         var3 = "0";
      }

      String var4 = var1.substring(var2 + 1);
      long var5 = (long)(Integer.parseInt(var3) * 3600000 + Integer.parseInt(var4) * '\uea60');
      if (this.Choice1.getSelectedKey().equals("P")) {
         var5 += 43200000L;
      }

      return var5;
   }

   public void setStartTime(long var1) {
      int var3 = (int)(var1 / 3600000L);
      int var4 = (int)((var1 - (long)(var3 * 3600000)) / 60000L);
      if (var3 > 11) {
         this.Choice1.select("PM");
      } else {
         this.Choice1.select("AM");
      }

      if (var3 > 12) {
         var3 -= 12;
      }

      if (var3 == 0) {
         var3 = 12;
      }

      String var5 = Integer.toString(var4);
      if (var5.length() < 2) {
         var5 = "0" + var5;
      }

      this.oneTimeStartTime.setText(Integer.toString(var3) + ":" + var5);
   }

   public void Choice1Main() {
      if (this.Choice1 == null) {
         this.Choice1 = new JDPChoice();
      }

      String[] var1 = new String[]{"AM", "PM", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"A", "P", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.Choice1.loadChoice(var1, var2);
   }

   public void EVENTTYPE1Main() {
      if (this.EVENTTYPE1 == null) {
         this.EVENTTYPE1 = new JDPChoice();
      }

      this.jaggSQL.loadSettings(this.user);
      this.EVENTTYPE1.loadChoice(this.user, this.jaggSQL, "TYPEDESC", "EVENTTYPE", "JDPEvtTy", "(1=1)");
   }

   public void JOBQUEUEMain() {
      if (this.JOBQUEUE == null) {
         this.JOBQUEUE = new JDPChoice();
      }

      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.loadSettings(this.user);
      this.JOBQUEUE.loadChoice(this.user, var1, "QUEUENAME", "QUEUENAME", "JDPQueue", "(1=1)");
   }

   public void JOBHELDMain() {
      if (this.JOBHELD == null) {
         this.JOBHELD = new JDPChoice();
      }

      String[] var1 = new String[]{"No", "Yes", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"N", "Y", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.JOBHELD.loadChoice(var1, var2);
   }

   public void NOTIFYUSER1Main() {
      if (this.NOTIFYUSER1 == null) {
         this.NOTIFYUSER1 = new JDPChoice();
      }

   }

   public void NOTIFYVIA1Main() {
      if (this.NOTIFYVIA1 == null) {
         this.NOTIFYVIA1 = new JDPChoice();
      }

      String[] var1 = new String[]{"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.NOTIFYVIA1.loadChoice(var1, var2);
   }

   public void NOTIFYON1Main() {
      if (this.NOTIFYON1 == null) {
         this.NOTIFYON1 = new JDPChoice();
      }

      String[] var1 = new String[]{"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.NOTIFYON1.loadChoice(var1, var2);
   }

   public void LOGEVENT1Main() {
      if (this.LOGEVENT1 == null) {
         this.LOGEVENT1 = new JDPChoice();
      }

      String[] var1 = new String[]{"None", "Failure", "Success", "Success or Failure", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"N", "F", "S", "B", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.LOGEVENT1.loadChoice(var1, var2);
   }

   public void InterruptScheduler() {
      this.jaggSQL.invoke("JDPSubsystemMgr", "interruptScheduler");
   }

   public void SubmitJob() {
      if (this.ResultList1.getSelectedKey() == null) {
         this.user.mainmsg.setStatusMsg("You must first make a selection.", 10);
      } else {
         String[] var1 = new String[]{this.JOBQUEUE.getSelectedItem(), this.user.JDPSystem, this.EVENTNAME1.getText(), this.user.cust.getUsername(), this.JDPObjectSelection1.getObjectType(), this.JDPObjectSelection1.getObject(), this.JDPObjectSelection1.getConstructor(), this.JDPObjectSelection1.getParameters(), this.JOBPRIORTY.getText(), this.QUEPRIORTY.getText(), this.JOBHELD.getSelectedKey().equals("Y") ? "true" : "false", this.NOTIFYUSER1.getSelectedKey(), this.NOTIFYVIA1.getSelectedKey(), this.NOTIFYON1.getSelectedKey(), this.LOGEVENT1.getSelectedKey()};
         String var2 = "java.lang.String";
         String[] var3 = new String[]{var2, var2, var2, var2, var2, var2, var2, var2, "int", "int", "boolean", "int", var2, var2, var2};
         String var4 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "submitJob", var3, var1);
         if (var4 == null) {
            this.user.mainmsg.setStatusMsg("Job submission failed.", 15);
         } else if (var4.startsWith("Jobnumber:")) {
            this.user.mainmsg.setStatusMsg("Job number " + var4.substring(10) + " submitted. See Server console to monitor status and Job log for details.", 15);
         } else {
            this.user.mainmsg.setStatusMsg(var4, 15);
         }
      }
   }

   public void ResultList1Main() {
      String var1 = "a.JDPSYSTEM,a.EVENTNAME";
      String[] var2 = new String[]{"a.EVENTNAME"};
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Typedesc"};
      String[] var5 = new String[]{"b.TYPEDESC"};
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.loadSettings(this.user);
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, var6, false, var1, var2, var3, var4, var5, var5, "", false, "Total Entries:");
      int[] var7 = new int[37];
      var7[0] = 4;
      var7[1] = 28;
      var7[2] = 1;
      this.ResultList1.setMinWidth(180);
      this.ResultList1.setIcons(var7);
      this.ResultList1.setFromWhereClause(" FROM JDPEVENT a,JDPEvtTy b WHERE a.EVENTTYPE = b.EVENTTYPE AND a.JDPSYSTEM = '" + this.user.getJDPSystem() + "'");
      this.ResultList1.clearList("Event Type / Event Name");
      this.ResultList1.loadList();
      this.convertIcons();
   }
}
