import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.TextField;
import java.awt.Toolkit;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPInteractionMgr extends JDPClassLayout {
   JDPLayoutMgr target;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   Panel targetPanel;
   JDPDragItem dragPanel;
   JDPSplitPanel Main;
   JDPTabSelectPanel TabPanel1;
   Panel Panel1;
   JDPTreePicker methodTree;
   JDPSplitPanel Panel2;
   JDPTreePicker parameterTree;
   JDPTreePicker methodPropertyTree;
   TextArea eventSource;
   JDPTreePicker eventTree;
   JDPTreeBranch lastSelectedEvent;
   JDPTreeBranch lastSelectedParameter;
   String prevCompTypes;
   JDPList methodList;
   JDPList sourceEditorList;
   String sourceSelected;
   JDPSpinner currentLine;
   Vector components;
   Vector classMethods;
   Vector returnMethods;
   Vector returnTypeVector;
   StringBuffer thisEntry;
   StringTokenizer stok;
   int lastCursorStartPos;
   int lastCursorEndPos;
   String sepChars = " \t\n\r;()/*[]\\!|&%$#@";
   StringBuffer textSoFar;
   String beforeSelection;
   String afterSelection;
   int saveSelectionStartPos;
   Vector listItems;
   TextField searchFor;
   int lastSearchLine;
   JDPButtons searchButtons;
   JDPButton methodsButton;
   Panel eventSourcePanel;
   JDPSplitPanel eventSourcePanelFrame;
   String globalSource;
   Thread thisThread;
   boolean threadRunning;

   void removeSelectedMethod() {
      JDPTreeBranch[] var1 = this.eventTree.getTreeBranch(this.eventTree.getCurrentBranch());
      this.eventTree.removeTreeBranch(this.eventTree.getCurrentBranch());
      if (var1[2].leaves.size() == 0) {
         this.eventTree.removeTreeBranch(var1[2]);
         this.TabPanel1.select(0);
      }

      this.clearParameterTree();
      this.clearMethodPropertyTree();
   }

   void dragAndDrop(String var1, JDPTreeBranch[] var2, JDPTreeBranch[] var3) {
      if (var2 != null && var3 != null && var1 != null) {
         if (var1.equals("Methods")) {
            this.eventTree.setDropKeys((Object[])null);
            this.eventTree.setDragAndDrop((boolean[])null);
            int[] var4 = new int[]{4, 1, 2, 1};
            String[] var5 = new String[]{"", null, null, null};
            boolean[] var6 = new boolean[]{true, true, true, false};
            this.eventTree.setIcons(var4);
            this.eventTree.setExpanded(var6);
            var5[0] = var3[1].name;
            var5[1] = var2[var2.length - 3].name;
            var5[2] = var2[var2.length - 1].name;
            var4[2] = var2[var2.length - 3].icon;
            var4[3] = 1;
            var3[1].expanded = true;
            this.eventTree.addEntry(var5, var4, var2[var2.length - 2].name);
            this.eventTree.select(var5);
            this.eventTree.reDraw();
            this.lastSelectedEvent = this.eventTree.getLastAddedBranch();
            this.TabPanel1.select(1);
            JDPTreeBranch var7 = this.eventTree.getCurrentBranch();
            JDPTreeBranch var8 = this.loadParameterTree(this.parameterTree, var7, this.eventTree.getTreeBranch(var7));
            if (var2[2].name.equals("Local Methods")) {
               var7.compPosition = "Local Methods";
            }

            var7.treeVector.setElementAt(var8, 0);
            this.eventSource.setText(this.target.gSource.constructEventSource(this.eventTree.getTreeBranch(this.eventTree.getCurrentBranch())));
            this.clearMethodPropertyTree();
            this.target.setAppChanged(true);
         }

         if (var1.equals("MethodProperty")) {
            if (!var3[var3.length - 1].equals(this.parameterTree.getCurrentBranch())) {
               return;
            }

            this.parameterTree.setDropKeys((Object[])null);
            this.parameterTree.setDragAndDrop((boolean[])null);
            int[] var9 = new int[]{4, 1, 2, 1};
            String[] var11 = new String[]{"", null, null, null};
            boolean[] var13 = new boolean[]{true, true, true, false};
            this.parameterTree.setIcons(var9);
            this.parameterTree.setExpanded(var13);
            var11[0] = var3[1].name;
            var11[1] = var2[var2.length - 3].name;
            var11[2] = var2[var2.length - 1].name;
            var9[2] = var2[var2.length - 3].icon;
            var9[3] = 1;
            var3[1].expanded = true;
            var3[1].leaves = null;
            var3[1].leaves = new Vector();
            this.parameterTree.addEntry(var11, var9, var2[var2.length - 2].name);
            this.parameterTree.reDraw();
            JDPTreeBranch var15 = this.parameterTree.getLastAddedBranch();
            var15.compType = var2[var2.length - 2].name;
            var15.compPosition = var2[var2.length - 1].compPosition;
            this.parameterTree.getTreeBranch(var15)[2].iconImage = var2[var2.length - 3].iconImage;
            this.eventSource.setText(this.target.gSource.constructEventSource(this.eventTree.getTreeBranch(this.eventTree.getCurrentBranch())));
            this.target.setAppChanged(true);
         }

         if (var1.equals("MethodPropertyVar")) {
            if (!var3[var3.length - 1].equals(this.parameterTree.getCurrentBranch())) {
               return;
            }

            this.parameterTree.setDropKeys((Object[])null);
            this.parameterTree.setDragAndDrop((boolean[])null);
            int[] var10 = new int[]{4, 1, 2, 1};
            String[] var12 = new String[]{"", null, null};
            boolean[] var14 = new boolean[]{true, true, false};
            this.parameterTree.setIcons(var10);
            this.parameterTree.setExpanded(var14);
            var12[0] = var3[1].name;
            var12[1] = var2[var2.length - 1].name;
            var10[2] = var2[var2.length - 1].icon;
            var3[1].expanded = true;
            var3[1].leaves = null;
            var3[1].leaves = new Vector();
            this.parameterTree.addEntry(var12, var10, var2[var2.length - 1].name);
            this.parameterTree.reDraw();
            JDPTreeBranch var16 = this.parameterTree.getLastAddedBranch();
            var16.compType = var2[var2.length - 1].name;
            var16.compPosition = var2[var2.length - 1].compPosition;
            this.parameterTree.getTreeBranch(var16)[2].iconImage = var2[var2.length - 1].iconImage;
            this.eventSource.setText(this.target.gSource.constructEventSource(this.eventTree.getTreeBranch(this.eventTree.getCurrentBranch())));
            this.target.setAppChanged(true);
         }

      }
   }

   void removeLocalMethodNames(JDPTreeBranch var1) {
      String[] var2 = new String[]{this.methodTree.treeRoot.name, var1.name, "Local Methods"};
      this.methodTree.removeBranch(var2);
   }

   void extractMethodNames(JDPTreePicker var1, JDPTreeBranch var2, boolean var3) {
      if (var1 != null) {
         String[] var6 = new String[]{var1.treeRoot.name, var2.name, "Local Methods"};
         var1.removeBranch(var6);
         if (var2.text != null && var2.text.length > 0) {
            String[] var7 = new String[3];
            int[] var8 = new int[4];
            boolean[] var9 = new boolean[]{true, false, true, false};
            var1.setExpanded(var9);

            for(int var10 = 0; var10 < var2.text.length; ++var10) {
               String var4 = var2.text[var10];
               if (var4 != null) {
                  int var5 = var4.indexOf("|");
                  if (var5 > 0) {
                     var7[0] = var2.name;
                     var7[1] = var2.compType;
                     var7[1] = "Local Methods";
                     var7[2] = var4.substring(0, var5);
                     var8[1] = var2.icon;
                     var8[2] = 2;
                     var8[3] = 1;
                     String var11 = var2.compType;
                     if (var2.thisObject != null) {
                        var11 = var2.thisObject.toString();
                        if (var11.indexOf("[") > 0) {
                           var11 = var11.substring(0, var11.indexOf("["));
                        }
                     }

                     if (var11.equals("JDPGridLayout")) {
                        var11 = "JDPTextGrid";
                     }

                     if (var11.equals("JDPChartLayout")) {
                        var11 = "JDPChart";
                     }

                     int var12 = var4.indexOf("(");
                     if (var12 > var5 && var4.substring(var5, var12).indexOf("public") >= 0) {
                        var1.addEntry(var7, var8, var11);
                     }
                  }
               }
            }
         }

         if (var3 && var2.leaves != null) {
            for(int var13 = 0; var13 < var2.leaves.size(); ++var13) {
               JDPTreeBranch var14 = (JDPTreeBranch)var2.leaves.elementAt(var13);
               this.extractMethodNames(var1, var14, var3);
            }
         }

      }
   }

   public void loadMethodAndVariableNames(JDPList var1, String var2, String var3) {
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      String var11 = this.jaggSQL.getSEP();
      boolean var12 = true;
      if (var2 != null) {
         if (var2.startsWith("this.")) {
            var2 = var2.substring(5);
         } else {
            this.loadMethodsFromName(var1, this.target.compTree, var2);
         }
      }

      this.getVarsFromSource(var2, var3, this.beforeSelection, var1);
      if (this.globalSource == null) {
         this.globalSource = this.target.gSource.templateSource[0].substring(0, this.target.gSource.templateSource[0].indexOf("<Components>"));
      }

      this.getVarsFromSource(var2, var3, this.globalSource, var1);

      for(int var13 = 0; var13 < this.returnMethods.size(); ++var13) {
         String var10 = (String)this.returnMethods.elementAt(var13);
         if (!var10.equals(" ")) {
            this.stok = new StringTokenizer(var10, var11);
            if (this.stok.countTokens() > 2) {
               String var7 = this.stok.nextToken();
               if (var2 != null) {
                  if (var7.startsWith(var2) && this.listItems.indexOf(var7) < 0) {
                     var1.addItem(var7);
                     this.listItems.addElement(var7);
                  }
               } else {
                  this.loadVariablesFromType(var1, this.target.compTree, var3);
                  this.stok.nextToken();
                  int var14 = Integer.parseInt(this.stok.nextToken());
                  Vector var15 = (Vector)this.classMethods.elementAt(var14);
                  Vector var16 = (Vector)var15.elementAt(1);

                  for(int var17 = 0; var17 < var16.size(); ++var17) {
                     var10 = (String)var16.elementAt(var17);
                     if (!var10.equals(" ")) {
                        this.stok = new StringTokenizer(var10, var11);
                        if (this.stok.countTokens() > 4) {
                           String var9 = this.stok.nextToken();
                           this.stok.nextToken();
                           String var6 = this.stok.nextToken();
                           String var8 = this.stok.nextToken();
                           String var5 = convertParm(this.stok.nextToken());
                           this.thisEntry.setLength(0);
                           if (var5.equals(var3)) {
                              this.thisEntry.append(var7 + "." + var6 + "(");
                              var12 = true;

                              while(this.stok.hasMoreTokens()) {
                                 if (!var12) {
                                    this.thisEntry.append(",");
                                 }

                                 var12 = false;
                                 this.thisEntry.append(convertParm(this.stok.nextToken()));
                              }

                              this.thisEntry.append(")");
                              String var4 = this.thisEntry.toString();
                              if (this.listItems.indexOf(var4) < 0) {
                                 var1.addItem(var4);
                                 this.listItems.addElement(var4);
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }

      if (var1.countItems() > 0) {
         var1.sortList();
         ((JDPTreePicker)var1).select(0);
      }

   }

   void loadSourceBuilderTree(JDPTreePicker var1, String var2) {
      this.loadSourceBuilderTree(var1, var2, (JDPTreeBranch)null);
   }

   public void startThread() {
      if (this.threadRunning) {
         if (this.thisThread != null) {
            this.thisThread.interrupt();
            return;
         }
      } else {
         this.threadRunning = true;
         this.thisThread = new Thread(this);
         this.thisThread.start();
      }

   }

   void loadSourceBuilderTree(JDPTreePicker var1, String var2, JDPTreeBranch var3) {
      var2 = super.user.u.replace(var2, "<", "");
      var2 = super.user.u.replace(var2, ">", "");
      var1.setDropKeys((Object[])null);
      var1.setDragAndDrop((boolean[])null);
      this.loadSourceBuilderParameterTree(var1, var2, var3);
   }

   public void loadObjectsIntoMethodTree(JDPTreePicker var1, JDPTreeBranch var2, String var3) {
      int[] var4 = new int[]{4, 8, 1};
      String[] var5 = new String[]{"", null, null, null};
      boolean[] var6 = new boolean[]{true, false, true, false};
      var1.setIcons(var4);
      var1.setExpanded(var6);
      if (!var2.compType.equals(var3) && (!var2.compType.startsWith("java") || !var2.compType.endsWith(var3) || var3.equals("Create from other object"))) {
         if (var2.thisObject != null) {
            try {
               Class var11 = var2.thisObject.getClass();
               if (var11 == null) {
                  var11 = Class.forName(var2.compType);
               }

               for(; var11 != null; var11 = var11.getSuperclass()) {
                  if (var11.getName().equals(var3) || var11.getName().startsWith("java") && var11.getName().endsWith(var3)) {
                     var5[0] = var2.name + " ";
                     var4[1] = var2.icon;
                     var1.addEntry(var5, var4, var5[0]);
                  }
               }
            } catch (Exception var10) {
               ((Throwable)var10).printStackTrace();
            }
         }
      } else {
         var5[0] = var2.name + " ";
         var4[1] = var2.icon;
         var1.addEntry(var5, var4, var5[0]);
         JDPTreeBranch var7 = var1.getLastAddedBranch();
         var7.thisObject = var2.thisObject;
      }

      if (var2.leaves != null) {
         for(int var12 = 0; var12 < var2.leaves.size(); ++var12) {
            JDPTreeBranch var8 = (JDPTreeBranch)var2.leaves.elementAt(var12);
            this.loadObjectsIntoMethodTree(var1, var8, var3);
         }
      }

   }

   public void loadMethodsFromName(JDPList var1, JDPTreeBranch var2, String var3) {
      String var6 = "|";
      if (var2.text != null) {
         for(int var10 = 0; var10 < var2.text.length; ++var10) {
            String var8 = var2.text[var10];
            if (var8 != null && var8.startsWith(var3)) {
               int var4 = var8.indexOf(var6);
               if (var4 > 0) {
                  String var7 = var8.substring(0, var4) + "(";
                  var4 = var8.indexOf("(");
                  int var5 = var8.indexOf(")");
                  if (var4 > 0 && var5 > 0) {
                     boolean var9 = true;
                     StringTokenizer var11 = new StringTokenizer(var8.substring(var4 + 1, var5), " ,\n\t\r");

                     while(var11.hasMoreTokens()) {
                        if (!var9) {
                           var7 = var7 + ",";
                        }

                        var9 = false;
                        var7 = var7 + var11.nextToken();
                        var11.nextToken();
                     }

                     var7 = var7 + ")";
                     if (this.listItems.indexOf(var7) < 0) {
                        var1.addItem(var7);
                        this.listItems.addElement(var7);
                     }
                  }
               }
            }
         }
      }

      if (var2.leaves != null) {
         for(int var14 = 0; var14 < var2.leaves.size(); ++var14) {
            JDPTreeBranch var15 = (JDPTreeBranch)var2.leaves.elementAt(var14);
            this.loadMethodsFromName(var1, var15, var3);
         }
      }

   }

   boolean loadEventSource() {
      if (this.TabPanel1.getSelectedIndex() == 0) {
         this.TabPanel1.select(1);
         this.clearMethodPropertyTree();
      }

      this.clearParameterTree();
      JDPTreeBranch var1 = this.eventTree.getCurrentBranch();
      if (var1 == null) {
         return false;
      } else {
         JDPTreeBranch var2 = this.loadParameterTree(this.parameterTree, var1, this.eventTree.getTreeBranch(var1));
         var1.treeVector.setElementAt(var2, 0);
         if (var1.text == null || var1.text[0] == null) {
            var1.text = new String[1];
            var1.text[0] = this.target.gSource.constructEventSource(this.eventTree.getTreeBranch(this.eventTree.getCurrentBranch()));
         }

         this.TabPanel1.select(2);
         this.eventSource.setText(var1.text[0]);
         if (this.lastSelectedEvent != null && this.lastSelectedEvent.equals(var1)) {
            return false;
         } else {
            this.lastSelectedEvent = var1;
            return true;
         }
      }
   }

   public void loadMethodList(TextArea var1, JDPList var2) {
      int var3 = ((TextComponent)var1).getSelectionStart();
      int var4 = ((TextComponent)var1).getSelectionEnd();
      if (var3 >= 1 && var4 >= 1) {
         Object var5 = null;
         this.beforeSelection = null;
         this.afterSelection = null;
         this.listItems = new Vector();
         String var6 = ((TextComponent)var1).getText();
         String var7 = ((TextComponent)var1).getText();
         int var8 = 0;
         if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
            var6 = super.user.u.replace(var6, "\n", "\n ");

            for(int var9 = var3; (var9 = var6.lastIndexOf("\n", var9 - 1)) >= 0; --var3) {
               ++var8;
            }

            for(int var19 = var4; (var19 = var6.lastIndexOf("\n", var19 - 1)) >= 0; --var4) {
            }
         }

         this.beforeSelection = var7.substring(0, var3);
         this.afterSelection = var7.substring(var4);
         this.saveSelectionStartPos = var3;
         if (var3 == var4) {
            if (this.textSoFar == null) {
               this.textSoFar = new StringBuffer();
            }

            String var20 = var7.substring(var3 - 1, var3);
            if (this.sepChars.indexOf(var20) >= 0) {
               return;
            }

            Object var10 = null;
            String var11 = null;
            int var12 = var3;
            this.textSoFar.setLength(0);
            boolean var13 = false;

            while(!var20.equals("") && this.sepChars.indexOf(var20) < 0) {
               if (var20.equals(".") && var11 == null) {
                  var13 = true;
                  var11 = this.textSoFar.toString();
                  this.textSoFar.setLength(0);
                  this.beforeSelection = var7.substring(0, var12);
                  this.saveSelectionStartPos = var12;
               } else {
                  this.textSoFar.insert(0, var20);
               }

               --var12;
               if (var12 == 0) {
                  var20 = "";
               } else {
                  var20 = var7.substring(var12 - 1, var12);
               }
            }

            String var21 = this.textSoFar.toString();
            if (var21.equals("this")) {
               var21 = var11;
               var11 = null;
               var12 += 5;
            }

            if (var11 == null) {
               this.beforeSelection = var7.substring(0, var12);
               this.saveSelectionStartPos = var12;
            }

            if (var21 != null && var11 == null) {
               var2.clear();
               this.loadMethodAndVariableNames(var2, var21, (String)null);
               if ((var2.countItems() != 1 || !var2.getItem(0).equals(var21)) && var2.countItems() > 0) {
                  this.setMethodListVisible(true);
                  ((Component)var2).requestFocus();
               }
            } else {
               String var14 = this.getGlobalVariableType(var21);
               if (var14 != null) {
                  this.loadVariableMethods(var2, var14, var21, var11, 0);
                  if (var2.countItems() > 0) {
                     this.setMethodListVisible(true);
                     ((Component)var2).requestFocus();
                  }
               } else {
                  this.loadVariableMethods(var2, var21, var21, var11, 8);
                  if (var2.countItems() > 0) {
                     this.setMethodListVisible(true);
                     ((Component)var2).requestFocus();
                  }
               }
            }
         } else if (var4 - var3 < 40) {
            String var15 = var7.substring(var3, var4);
            if (var15.indexOf(" ") < 0 && var15.indexOf("\t") < 0 && var15.indexOf("\n") < 0) {
               var15 = super.user.u.replace(var15, "<", "");
               var15 = super.user.u.replace(var15, ">", "");
               this.loadMethodsForReturnValue(var2, var15);
               this.loadMethodAndVariableNames(var2, (String)null, var15);
               if (var2.countItems() > 0) {
                  this.setMethodListVisible(true);
                  ((Component)var2).requestFocus();
               }
            }
         }

         this.saveSelectionStartPos += var8;
      }
   }

   public void loadMethodsFromReturnType(JDPList var1, JDPTreeBranch var2, String var3) {
      String var6 = "|";
      if (var2.text != null) {
         for(int var11 = 0; var11 < var2.text.length; ++var11) {
            String var9 = var2.text[var11];
            if (var9 != null) {
               int var4 = var9.indexOf("public");
               if (var4 > 0) {
                  String var8 = var9.substring(var4 + 7);
                  var8 = var8.substring(0, var8.indexOf(" "));
                  if (var8.equals(var3)) {
                     var4 = var9.indexOf(var6);
                     String var7 = var9.substring(0, var4) + "(";
                     var4 = var9.indexOf("(");
                     int var5 = var9.indexOf(")");
                     if (var4 > 0 && var5 > 0) {
                        boolean var10 = true;
                        StringTokenizer var12 = new StringTokenizer(var9.substring(var4 + 1, var5), " ,\n\t\r");

                        while(var12.hasMoreTokens()) {
                           if (!var10) {
                              var7 = var7 + ",";
                           }

                           var10 = false;
                           var7 = var7 + var12.nextToken();
                           var12.nextToken();
                        }

                        var7 = var7 + ")";
                        if (this.listItems.indexOf(var7) < 0) {
                           var1.addItem(var7);
                           this.listItems.addElement(var7);
                        }
                     }
                  }
               }
            }
         }
      }

      if (var2.leaves != null) {
         for(int var17 = 0; var17 < var2.leaves.size(); ++var17) {
            JDPTreeBranch var18 = (JDPTreeBranch)var2.leaves.elementAt(var17);
            this.loadMethodsFromReturnType(var1, var18, var3);
         }
      }

   }

   public void loadMethodsForReturnValue(JDPList var1, String var2) {
      var1.clear();
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      String var10 = this.jaggSQL.getSEP();
      var2 = super.user.u.replace(var2, "<", "");
      var2 = super.user.u.replace(var2, ">", "");
      boolean var11 = true;
      this.loadMethodsFromReturnType(var1, this.target.compTree, var2);

      for(int var12 = 0; var12 < this.returnMethods.size(); ++var12) {
         String var9 = (String)this.returnMethods.elementAt(var12);
         if (!var9.equals(" ")) {
            this.stok = new StringTokenizer(var9, var10);
            if (this.stok.countTokens() > 2) {
               String var6 = this.stok.nextToken();
               if (!var6.startsWith("user")) {
                  this.stok.nextToken();
                  int var13 = Integer.parseInt(this.stok.nextToken());
                  Vector var14 = (Vector)this.classMethods.elementAt(var13);
                  Vector var15 = (Vector)var14.elementAt(1);

                  for(int var16 = 0; var16 < var15.size(); ++var16) {
                     var9 = (String)var15.elementAt(var16);
                     if (!var9.equals(" ")) {
                        this.stok = new StringTokenizer(var9, var10);
                        if (this.stok.countTokens() > 4) {
                           String var8 = this.stok.nextToken();
                           this.stok.nextToken();
                           String var5 = this.stok.nextToken();
                           String var7 = this.stok.nextToken();
                           String var4 = convertParm(this.stok.nextToken());
                           if (var4.equals(var2)) {
                              this.thisEntry.setLength(0);
                              this.thisEntry.append(var6 + ".");
                              this.thisEntry.append(var5 + "(");
                              var11 = true;

                              while(this.stok.hasMoreTokens()) {
                                 if (!var11) {
                                    this.thisEntry.append(",");
                                 }

                                 var11 = false;
                                 this.thisEntry.append(convertParm(this.stok.nextToken()));
                              }

                              this.thisEntry.append(")");
                              String var3 = this.thisEntry.toString();
                              if (this.listItems.indexOf(var3) < 0) {
                                 var1.addItem(var3);
                                 this.listItems.addElement(var3);
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }

   }

   void clearMethodTree() {
      int[] var1 = new int[]{4, 0, 2, 1};
      this.methodTree.setIcons(var1);
      this.methodTree.setRoot("Select or drag a method to the Event tree", true);
      this.sourceSelected = "";
      this.target.sourceSelected = "";
   }

   void loadMethodTree(JDPTreeBranch var1, boolean var2) {
      if (!this.target.appType.equals("NonVisualApp")) {
         this.components = this.loadComponents(var1, (Vector)null);
         Object[] var3 = new Object[]{null, null, null, "Methods"};
         this.methodTree.setDropKeys(var3);
         this.methodTree.setDragAndDrop((boolean[])null);
         int[] var4 = new int[]{4, 0, 2, 1};
         String[] var5 = new String[]{"", null, null, null};
         this.methodTree.setIcons(var4);
         boolean[] var6 = new boolean[]{true, var2, true, false};
         this.methodTree.setExpanded(var6);
         if (!var2) {
            this.removeLocalMethodNames(var1);
            this.extractMethodNames(this.methodTree, var1, var1.equals(this.target.compTree));
         }

         for(int var7 = 0; var7 < this.components.size(); ++var7) {
            var5[0] = ((String[])this.components.elementAt(var7))[1];
            var5[1] = "";
            var4[1] = Integer.parseInt(((String[])this.components.elementAt(var7))[2]);
            var4[2] = 2;
            var4[3] = 1;
            this.methodTree.addEntry(var5, var4, ((String[])this.components.elementAt(var7))[0]);
         }

         if (var2) {
            boolean var20 = true;
            String var9 = "";
            String var10 = this.jaggSQL.getSEP();

            for(int var11 = 0; var11 < this.components.size(); ++var11) {
               Vector var12 = this.getClassMethods((String[])this.components.elementAt(var11));

               for(int var13 = 0; var13 < var12.size(); ++var13) {
                  Vector var14 = (Vector)var12.elementAt(var13);
                  Vector var15 = (Vector)var14.elementAt(1);
                  String var16 = "";
                  String var17 = "";

                  for(int var18 = 0; var18 < var15.size(); ++var18) {
                     var17 = (String)var15.elementAt(var18);
                     if (!var17.equals(" ")) {
                        StringTokenizer var8 = new StringTokenizer(var17, var10);
                        var5[0] = ((String[])this.components.elementAt(var11))[1];
                        var4[1] = Integer.parseInt(((String[])this.components.elementAt(var11))[2]);
                        var16 = var8.nextToken();
                        var5[1] = var8.nextToken();
                        var5[2] = var8.nextToken();
                        var4[2] = 2;
                        var4[3] = 1;
                        var8.nextToken();
                        var8.nextToken();
                        if (!var5[1].startsWith("java") && !var5[1].equals("JDPClassLayout") && var5[1].indexOf(".") <= 0) {
                           boolean[] var27 = new boolean[]{true, false, true, false};
                           this.methodTree.setExpanded(var27);
                        } else {
                           boolean[] var19 = new boolean[]{true, false, false, false};
                           this.methodTree.setExpanded(var19);
                        }

                        var5[2] = var5[2] + "(";

                        for(boolean var21 = true; var8.hasMoreTokens(); var5[2] = var5[2] + convertParm(var9)) {
                           if (!var21) {
                              var5[2] = var5[2] + ",";
                           }

                           var21 = false;
                           var9 = var8.nextToken();
                        }

                        var5[2] = var5[2] + ")";
                        this.methodTree.addEntry(var5, var4, var16);
                     }
                  }
               }

               super.user.mainmsg.clearStatusMsg();
            }
         } else {
            for(int var22 = 0; var22 < this.components.size(); ++var22) {
               this.getClassMethods((String[])this.components.elementAt(var22));
            }
         }

         boolean[] var23 = new boolean[4];
         var23[1] = true;
         this.methodTree.sortTree(this.methodTree.treeRoot, var23);
         this.methodTree.reDraw();
      }
   }

   void clearMethodPropertyTree() {
      JDPTreeBranch var1 = new JDPTreeBranch();
      this.methodPropertyTree.treeRoot = var1;
      int[] var2 = new int[]{4, 2, 0, 1};
      this.methodPropertyTree.setIcons(var2);
      this.methodPropertyTree.setRoot("Select a method", true);
   }

   void loadMethodPropertyTree(JDPTreeBranch var1) {
      this.loadMethodPropertyTree(var1, (JDPTreeBranch)null);
   }

   void loadMethodPropertyTree(JDPTreeBranch var1, JDPTreeBranch var2) {
      Object[] var3 = new Object[]{null, null, null, "MethodProperty"};
      this.methodPropertyTree.setDropKeys(var3);
      this.methodPropertyTree.setDragAndDrop((boolean[])null);
      String var4 = var1.name.trim();
      this.loadSourceBuilderParameterTree(this.methodPropertyTree, var4, var2);
   }

   Vector getClassMethodVector(String var1, String[] var2) {
      for(int var3 = 0; var3 < this.classMethods.size(); ++var3) {
         Vector var4 = (Vector)this.classMethods.elementAt(var3);
         String var5 = (String)var4.elementAt(0);
         if (var1.equals(var5)) {
            this.addReturnMethods(var1, var2);
            return var4;
         }
      }

      return this.loadClassMethodVector(var1, var2);
   }

   public void setMethodListVisible(boolean var1) {
      if (var1) {
         this.methodList.show();
      } else {
         this.methodList.hide();
      }

      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   String findLocalVar(String var1, String var2) {
      int var5 = var2.indexOf("(");
      int var6 = var2.indexOf(")", var5 + 2);
      if (var5 > 0 && var5 < var6) {
         StringTokenizer var7 = new StringTokenizer(var2.substring(var5 + 1, var6), " \n\r\t,");

         String var3;
         for(String var4 = null; var7.hasMoreTokens(); var4 = var3) {
            var3 = var7.nextToken();
            if (var3.equals(var1)) {
               return var4;
            }
         }
      }

      var5 = var2.indexOf("{");
      if (var5 >= 0 && var5 < var2.length() - 1) {
         this.stok = new StringTokenizer(var2.substring(var5 + 1), "{};");

         while(this.stok.hasMoreTokens()) {
            String var8 = this.stok.nextToken();
            StringTokenizer var12 = new StringTokenizer(var8, "\n\r \t;");

            String var9;
            for(String var10 = null; var12.hasMoreTokens(); var10 = var9) {
               var9 = var12.nextToken();
               if (var9.equals(var1)) {
                  return var10;
               }
            }
         }

         return null;
      } else {
         return null;
      }
   }

   public void loadPlaceIntoForVisualApp(JDPComboBox var1, int var2) {
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      this.listItems = new Vector();
      String var11 = this.jaggSQL.getSEP();

      for(int var12 = 0; var12 < this.returnMethods.size(); ++var12) {
         String var10 = (String)this.returnMethods.elementAt(var12);
         if (!var10.equals(" ")) {
            this.stok = new StringTokenizer(var10, var11);
            if (this.stok.countTokens() > 2) {
               String var6 = this.stok.nextToken();
               this.stok.nextToken();
               int var13 = Integer.parseInt(this.stok.nextToken());
               Vector var14 = (Vector)this.classMethods.elementAt(var13);
               Vector var15 = (Vector)var14.elementAt(1);

               for(int var16 = 0; var16 < var15.size(); ++var16) {
                  var10 = (String)var15.elementAt(var16);
                  if (!var10.equals(" ")) {
                     this.stok = new StringTokenizer(var10, var11);
                     if (this.stok.countTokens() > 4) {
                        String var7 = this.stok.nextToken();
                        this.stok.nextToken();
                        String var5 = this.stok.nextToken();
                        String var8 = this.stok.nextToken();
                        String var4 = convertParm(this.stok.nextToken());
                        if (this.stok.hasMoreTokens()) {
                           String var9 = this.stok.nextToken();
                           if (var5.startsWith("set") && !this.stok.hasMoreTokens()) {
                              this.thisEntry.setLength(0);
                              if (var9.equals("int") && JDPUtils.isOdbcNum(var2)) {
                                 this.thisEntry.setLength(0);
                                 this.thisEntry.append(var6 + "." + var5 + "(");
                                 this.thisEntry.append("Integer.parseInt(stok.nextToken())");
                                 this.thisEntry.append(")");
                                 String var19 = this.thisEntry.toString();
                                 if (this.listItems.indexOf(var19) < 0) {
                                    var1.addItem(var19);
                                    this.listItems.addElement(var19);
                                 }
                              } else if (var9.equals("long") && JDPUtils.isOdbcNum(var2)) {
                                 this.thisEntry.setLength(0);
                                 this.thisEntry.append(var6 + "." + var5 + "(");
                                 this.thisEntry.append("Long.valueOf(stok.nextToken()).longValue()");
                                 this.thisEntry.append(")");
                                 String var18 = this.thisEntry.toString();
                                 if (this.listItems.indexOf(var18) < 0) {
                                    var1.addItem(var18);
                                    this.listItems.addElement(var18);
                                 }
                              } else if (var9.equals("float") && JDPUtils.isOdbcNum(var2)) {
                                 this.thisEntry.setLength(0);
                                 this.thisEntry.append(var6 + "." + var5 + "(");
                                 this.thisEntry.append("Float.valueOf(stok.nextToken()).floatValue()");
                                 this.thisEntry.append(")");
                                 String var17 = this.thisEntry.toString();
                                 if (this.listItems.indexOf(var17) < 0) {
                                    var1.addItem(var17);
                                    this.listItems.addElement(var17);
                                 }
                              } else if (var9.equals("java.lang.String") && JDPUtils.isOdbcChar(var2)) {
                                 this.thisEntry.setLength(0);
                                 this.thisEntry.append(var6 + "." + var5 + "(");
                                 this.thisEntry.append("stok.nextToken()");
                                 this.thisEntry.append(")");
                                 String var3 = this.thisEntry.toString();
                                 if (this.listItems.indexOf(var3) < 0) {
                                    var1.addItem(var3);
                                    this.listItems.addElement(var3);
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }

   }

   void replaceName(String var1, String var2) {
      if (var1 != null && var2 != null) {
         this.eventTree.reDraw();
         this.replaceName(this.methodTree.treeRoot, var1, var2);
         this.methodTree.reDraw();
         this.parameterTree.reDraw();
         this.methodPropertyTree.reDraw();
         String var3 = "";
         String var4 = this.jaggSQL.getSEP();
         if (this.returnMethods != null) {
            for(int var5 = 0; var5 < this.returnMethods.size(); ++var5) {
               var3 = (String)this.returnMethods.elementAt(var5);
               if (var3.startsWith(var1 + var4)) {
                  var3 = super.user.u.replace(var3, var1 + var4, var2 + var4);
                  this.returnMethods.setElementAt(var3, var5);
               }
            }
         }

         if (this.returnTypeVector != null) {
            for(int var9 = 0; var9 < this.returnTypeVector.size(); ++var9) {
               String[] var6 = (String[])this.returnTypeVector.elementAt(var9);
               if (var6[0].equals(var1)) {
                  var6[0] = var2;
                  this.returnTypeVector.setElementAt(var6, var9);
               }
            }
         }

         this.replaceName(this.methodPropertyTree.treeRoot, var1, var2);
         this.eventSource.setText(super.user.u.replace(this.eventSource.getText(), var1, var2));
      }
   }

   void removeMethod(JDPTreeBranch var1) {
      JDPTreeBranch[] var2 = this.methodTree.getTreeBranch(var1.name);
      if (var2 != null) {
         this.methodTree.removeTreeBranch(var2[var2.length - 1]);
         if (var1.leaves != null) {
            for(int var3 = 0; var3 < var1.leaves.size(); ++var3) {
               JDPTreeBranch var4 = (JDPTreeBranch)var1.leaves.elementAt(var3);
               this.removeMethod(var4);
            }
         }

         String var8 = "";
         String var10 = this.jaggSQL.getSEP();
         if (this.returnMethods != null) {
            int var5 = this.returnMethods.size();

            for(int var6 = 0; var6 < var5; ++var6) {
               var8 = (String)this.returnMethods.elementAt(var6);
               if (var8.startsWith(var1.name + var10)) {
                  while(!var8.equals(" ") && var6 < var5) {
                     this.returnMethods.removeElementAt(var6);
                     --var5;
                     if (var6 < var5) {
                        var8 = (String)this.returnMethods.elementAt(var6);
                     }
                  }
               }
            }
         }

         if (this.returnTypeVector != null) {
            int var11 = this.returnTypeVector.size();

            for(int var12 = 0; var12 < var11; ++var12) {
               String[] var7 = (String[])this.returnTypeVector.elementAt(var12);
               if (var7[0].equals(var1.name)) {
                  this.returnTypeVector.removeElementAt(var12);
                  --var12;
                  --var11;
               }
            }
         }

      }
   }

   void replaceName(JDPTreeBranch var1, String var2, String var3) {
      if (var1.name != null) {
         if (var1.name.equals(var2)) {
            var1.name = var3;
         }

         if (var1.name.equals(var2 + "Method")) {
            var1.name = var3 + "Method";
         }
      }

      if (var1.text != null) {
         for(int var4 = 0; var4 < var1.text.length; ++var4) {
            if (var1.text[var4] != null) {
               var1.text[var4] = super.user.u.replace(var1.text[var4], var2, var3);
            }
         }
      }

      if (var1.treeVector != null) {
         for(int var6 = 0; var6 < var1.treeVector.size(); ++var6) {
            if (var1.treeVector.elementAt(var6) instanceof JDPTreeBranch) {
               JDPTreeBranch var5 = (JDPTreeBranch)var1.treeVector.elementAt(var6);
               this.replaceName(var5, var2, var3);
            }
         }
      }

      if (var1.leaves != null) {
         for(int var7 = 0; var7 < var1.leaves.size(); ++var7) {
            JDPTreeBranch var8 = (JDPTreeBranch)var1.leaves.elementAt(var7);
            this.replaceName(var8, var2, var3);
         }
      }

   }

   void extractReturnValues(JDPTreeBranch var1, String var2, JDPTreePicker var3) {
      if (var1 != null) {
         if (var1.text != null && var1.text.length > 0) {
            String[] var8 = new String[3];
            int[] var9 = new int[4];

            for(int var10 = 0; var10 < var1.text.length; ++var10) {
               String var6 = var1.text[var10];
               if (var6 != null) {
                  int var4 = var6.indexOf("(");
                  if (var4 > 0) {
                     StringTokenizer var11 = new StringTokenizer(var6.substring(0, var4), " \n\r\t");
                     int var12 = var11.countTokens() - 2;

                     while(var12-- > 0) {
                        var11.nextToken();
                     }

                     String var13 = var11.nextToken();
                     int var5 = var6.indexOf("|");
                     if (var4 > var5 && var6.substring(var5, var4).indexOf("public") >= 0 && (var13.equals(var2) || var2.endsWith(var13))) {
                        var8[0] = var1.name;
                        var9[1] = var1.icon;
                        String var7 = var1.compType;
                        var8[1] = "Methods";
                        var9[2] = 2;
                        var8[2] = var6.substring(0, var6.indexOf("|"));
                        var9[3] = 1;
                        var3.addEntry(var8, var9, var7);
                        var3.getLastAddedBranch().compPosition = "Local Methods";
                     }
                  }
               }
            }
         }

         if (var1.leaves != null) {
            for(int var14 = 0; var14 < var1.leaves.size(); ++var14) {
               JDPTreeBranch var15 = (JDPTreeBranch)var1.leaves.elementAt(var14);
               this.extractReturnValues(var15, var2, var3);
            }
         }

      }
   }

   Vector getClassNames(String var1) {
      Vector var2 = new Vector();
      int var3 = var1.indexOf("[");
      if (var3 >= 0) {
         var1 = var1.substring(0, var3);
      }

      if (var1.equals("JDPGridLayout")) {
         var1 = "JDPTextGrid";
      }

      if (var1.equals("JDPChartLayout")) {
         var1 = "JDPChart";
      }

      if (var1.length() == 0) {
         return var2;
      } else {
         try {
            Class var4 = null;
            if (var1.equals("int")) {
               var4 = Integer.TYPE;
            }

            if (var1.equals("boolean")) {
               var4 = Boolean.TYPE;
            }

            if (var1.equals("char")) {
               var4 = Character.TYPE;
            }

            if (var1.equals("byte")) {
               var4 = Byte.TYPE;
            }

            if (var1.equals("short")) {
               var4 = Short.TYPE;
            }

            if (var1.equals("long")) {
               var4 = Long.TYPE;
            }

            if (var1.equals("float")) {
               var4 = Float.TYPE;
            }

            if (var1.equals("double")) {
               var4 = Double.TYPE;
            }

            if (var1.equals("void")) {
               var4 = Void.TYPE;
            }

            if (var4 == null) {
               if (var1.indexOf(".") < 0) {
                  try {
                     var4 = Class.forName(var1);
                  } catch (Exception var12) {
                     try {
                        var4 = Class.forName("java.lang." + var1);
                     } catch (Exception var11) {
                        try {
                           var4 = Class.forName("java.awt." + var1);
                        } catch (Exception var10) {
                           try {
                              var4 = Class.forName("java.net." + var1);
                           } catch (Exception var9) {
                              try {
                                 var4 = Class.forName("java.io." + var1);
                              } catch (Exception var8) {
                                 try {
                                    var4 = Class.forName("java.util." + var1);
                                 } catch (Exception var7) {
                                    try {
                                       var4 = Class.forName("java.math." + var1);
                                    } catch (Exception var6) {
                                       try {
                                          var4 = Class.forName("java.sql." + var1);
                                       } catch (Exception var5) {
                                          var4 = Class.forName(var1);
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
               } else {
                  var4 = Class.forName(var1);
               }
            }

            var2.addElement(var4.getName());

            while(var4 != null) {
               var4 = var4.getSuperclass();
               if (var4 != null) {
                  var2.addElement(var4.getName());
               }
            }
         } catch (Exception var13) {
         }

         return var2;
      }
   }

   JDPTreeBranch getMethodParameters(JDPTreeBranch var1, JDPTreePicker var2) {
      JDPTreePicker var3 = new JDPTreePicker(super.user, this.targetPanel, this.dragPanel);
      var3.setResizingAllowed(false);
      return this.loadParameterTree(var3, var1, var2.getTreeBranch(var1));
   }

   public void replaceSelectedText(TextArea var1, String var2) {
      if (var2.endsWith(")") && (this.afterSelection.startsWith("\n") || this.afterSelection.startsWith("\r") || this.afterSelection.equals(""))) {
         var2 = var2 + ";";
      }

      int var3 = this.saveSelectionStartPos + var2.length();
      ((TextComponent)var1).setText(this.beforeSelection + var2 + this.afterSelection);
      int var4 = var2.indexOf("(");
      int var5 = var2.indexOf(")");
      if (var4 >= 0 && var5 > var4 + 1) {
         int var6 = var2.indexOf(",");
         if (var6 >= 0) {
            var5 = var6;
         }

         int var7 = 0;
         if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
            for(int var8 = this.beforeSelection.indexOf("\n"); var8 >= 0; var8 = this.beforeSelection.indexOf("\n", var8 + 1)) {
               ++var7;
            }
         }

         var4 += this.saveSelectionStartPos + 1 - var7;
         var5 += this.saveSelectionStartPos - var7;
         ((TextComponent)var1).select(var4, var5);
      } else {
         ((TextComponent)var1).setSelectionStart(var3);
         ((TextComponent)var1).setSelectionEnd(var3);
      }

      ((Component)var1).requestFocus();
   }

   void getVarsFromSource(String var1, String var2, String var3, JDPList var4) {
      int var9 = var3.indexOf("(");
      int var10 = var3.indexOf(")", var9 + 2);
      if (var9 > 0 && var9 < var10) {
         this.stok = new StringTokenizer(var3.substring(var9 + 1, var10), " \n\r\t,");

         while(this.stok.hasMoreTokens()) {
            String var7 = this.stok.nextToken();
            if (this.stok.hasMoreTokens()) {
               String var8 = this.stok.nextToken();
               if (var1 != null && var8.startsWith(var1) && this.listItems.indexOf(var8) < 0) {
                  var4.addItem(var8);
                  this.listItems.addElement(var8);
               }

               if (var2 != null && var7.equals(var2) && this.listItems.indexOf(var8) < 0) {
                  var4.addItem(var8);
                  this.listItems.addElement(var8);
               }
            }
         }
      }

      var9 = var3.indexOf("{");
      if (var9 >= 0 && var9 < var3.length() - 1) {
         this.stok = new StringTokenizer(var3.substring(var9 + 1), "{};");

         while(this.stok.hasMoreTokens()) {
            String var6 = this.stok.nextToken();
            StringTokenizer var5 = new StringTokenizer(var6, "\n\r \t;");
            if (var5.countTokens() >= 2) {
               String var11 = var5.nextToken();
               if (var5.hasMoreTokens()) {
                  String var12 = var5.nextToken();
                  if (var1 != null && var12.startsWith(var1) && this.listItems.indexOf(var12) < 0) {
                     var4.addItem(var12);
                     this.listItems.addElement(var12);
                  }

                  if (var2 != null && var11.equals(var2) && this.listItems.indexOf(var12) < 0) {
                     var4.addItem(var12);
                     this.listItems.addElement(var12);
                  }
               }
            }
         }

      }
   }

   void addReturnMethods(String var1, String[] var2) {
      if (this.returnMethods == null) {
         this.returnMethods = new Vector();
      }

      if (this.returnTypeVector == null) {
         this.returnTypeVector = new Vector();
      }

      String var4 = this.jaggSQL.getSEP();
      String var5 = "";

      for(int var6 = 0; var6 < this.classMethods.size(); ++var6) {
         Vector var7 = (Vector)this.classMethods.elementAt(var6);
         String var8 = (String)var7.elementAt(0);
         if (var1.equals(var8)) {
            Vector var9 = (Vector)var7.elementAt(1);

            for(int var12 = 0; var12 < var9.size(); ++var12) {
               String var11 = (String)var9.elementAt(var12);
               if (!var11.equals(" ")) {
                  StringTokenizer var3 = new StringTokenizer(var11, var4);
                  if (var3.countTokens() > 4) {
                     var3.nextToken();
                     var3.nextToken();
                     var3.nextToken();
                     var3.nextToken();
                     String var10 = convertParm(var3.nextToken()) + " ";
                     if (var5.indexOf(var10) < 0) {
                        var5 = var5 + var10;
                     }
                  }
               }
            }

            this.returnMethods.addElement(var2[1] + var4 + var2[2] + var4 + Integer.toString(var6));
         }
      }

      String[] var13 = new String[]{var2[1], var2[2], var5, var1};
      this.returnTypeVector.addElement(var13);
   }

   void clearEventTree() {
      JDPTreeBranch var1 = new JDPTreeBranch();
      this.eventTree.treeRoot = var1;
      int[] var2 = new int[]{4, 1, 2, 1};
      this.eventTree.setIcons(var2);
      this.eventTree.setRoot("Component Events", true);
      this.methodTree.resetSelections(this.methodTree.treeRoot);
      this.clearParameterTree();
      this.clearMethodPropertyTree();
      this.lastSelectedEvent = null;
      this.eventSource.setText("");
   }

   JDPTreeBranch loadEventTree(JDPTreeBranch var1, JDPTreeBranch var2) {
      this.clearEventTree();
      this.eventTree.treeRoot = var1;
      this.eventTree.resetSelections(this.eventTree.treeRoot);
      Object[] var3 = new Object[]{null, "Methods"};
      String[] var4 = new String[]{null, "Drop here to attach this component/method to this Event"};
      this.eventTree.setDropKeys(var3);
      this.eventTree.setDragAndDrop((boolean[])null);
      this.eventTree.setDropMessages(var4);
      int[] var5 = new int[]{4, 1, 2, 1};
      this.eventTree.setIcons(var5);
      boolean[] var6 = new boolean[]{true, true, true, false};
      this.eventTree.setExpanded(var6);
      if (this.eventTree.treeRoot == null || this.eventTree.treeRoot.leaves == null || this.eventTree.treeRoot.leaves.size() == 0) {
         this.eventTree.setRoot("Component Events", true);
      }

      if (var2.compType != null && var2.compType.equals("JDPButtons")) {
         int var7 = ((JDPButtons)var2.thisObject).getButtonCount();

         for(int var8 = 0; var8 < var7; ++var8) {
            String[] var9 = new String[]{"ACTION_BTN_" + Integer.toString(var8), null, null, null};
            this.eventTree.addEntry(var9, var5, "ACTION_BTN_" + Integer.toString(var8));
         }
      }

      String[] var11 = new String[]{null, null, null, null};
      if (var2.compType.equals("JDPRichText") || var2.thisObject instanceof Component || var2.compType.equals("JDPServerListener")) {
         if (!var2.compType.equals("JDPButtons")) {
            var11[0] = "ACTION_EVENT";
            this.eventTree.addEntry(var11, var5, var11[0]);
         }

         var11[0] = "KEY_PRESS";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "KEY_RELEASE";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "KEY_ACTION";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "KEY_ACTION_RELEASE";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "HOME";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "END";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "PGUP";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "PGDN";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "UP";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "DOWN";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "LEFT";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "RIGHT";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F1";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F2";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F3";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F4";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F5";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F6";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F7";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F8";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F9";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F10";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F11";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "F12";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "ESC";
         this.eventTree.addEntry(var11, var5, var11[0]);
      }

      if (var2.compType.equals("List") || var2.compType.equals("JDPGridDetail") || var2.thisObject instanceof JDPList || var2.thisObject instanceof JDPTreePicker || var2.thisObject instanceof JDPTextGrid || var2.thisObject instanceof JDPMethodExplorer || var2.thisObject instanceof JDPSearchResults || var2.thisObject instanceof JDPClassLayout || var2.compType.equals("JDPServerListener")) {
         var11[0] = "LIST_SELECT";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "LIST_DESELECT";
         this.eventTree.addEntry(var11, var5, var11[0]);
      }

      if (var2.compType.equals("Scrollbar") || var2.compType.equals("JDPScrollPanel")) {
         var11[0] = "SCROLL_ABSOLUTE";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "SCROLL_LINE_DOWN";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "SCROLL_LINE_UP";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "SCROLL_PAGE_DOWN";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "SCROLL_PAGE_UP";
         this.eventTree.addEntry(var11, var5, var11[0]);
      }

      if (var2.thisObject instanceof Component || var2.compType.equals("JDPServerListener")) {
         var11[0] = "MOUSE_DOWN";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "MOUSE_UP";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "MOUSE_DRAG";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "WINDOW_EXPOSE";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "WINDOW_DESTROY";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "LOST_FOCUS";
         this.eventTree.addEntry(var11, var5, var11[0]);
         var11[0] = "GOT_FOCUS";
         this.eventTree.addEntry(var11, var5, var11[0]);
      }

      this.loadListenerEvents(var1, var2);
      var1 = this.eventTree.treeRoot;
      this.eventTree.reDraw();
      return var1;
   }

   void clearParameterTree() {
      JDPTreeBranch var1 = new JDPTreeBranch();
      this.parameterTree.treeRoot = var1;
      int[] var2 = new int[]{4, 1, 2, 1};
      this.parameterTree.setIcons(var2);
      this.parameterTree.setRoot("Method Parameters", true);
      this.clearMethodPropertyTree();
      this.eventSource.setText("");
   }

   synchronized JDPTreeBranch loadParameterTree(JDPTreePicker var1, JDPTreeBranch var2, JDPTreeBranch[] var3) {
      if (var2 == null) {
         return null;
      } else {
         if (var2.treeVector == null) {
            var2.treeVector = new Vector();
            JDPTreeBranch var4 = new JDPTreeBranch();
            var2.treeVector.addElement(var4);
         }

         var1.treeRoot = (JDPTreeBranch)var2.treeVector.elementAt(0);
         var1.resetSelections(var1.treeRoot);
         if (var1.treeRoot == null || var1.treeRoot.leaves == null || var1.treeRoot.leaves.size() == 0) {
            var1.setRoot("Method Parameters", true);
            Object[] var20 = new Object[]{null, "MethodProperty"};
            String[] var5 = new String[]{null, "Drop here to assign this method to this Parameter"};
            var1.setDropKeys(var20);
            var1.setDragAndDrop((boolean[])null);
            var1.setDropMessages(var5);
            int[] var6 = new int[]{4, 1, 2, 1};
            String[] var7 = new String[]{"", null, null, null};
            boolean[] var8 = new boolean[]{true, false, true, false};
            var1.setIcons(var6);
            var1.setExpanded(var8);
            if (this.extractParameterNames(var2, var3) == 0) {
               int var9 = 0;
               int var10 = var2.name.indexOf("(");
               String var11 = var2.name;
               if (var10 > 0) {
                  var11 = var11.substring(var10);
                  StringTokenizer var23 = new StringTokenizer(var11, ",()");

                  while(var23.hasMoreTokens()) {
                     ++var9;
                     var7[0] = var23.nextToken();

                     for(var6[1] = 1; var1.addEntry(var7, var6, var7[0]); var7[0] = var7[0] + " ") {
                     }
                  }
               } else {
                  String var12 = "*ALL;" + var2.name + ";";
                  var12 = var12 + var3[var3.length - 1].compType + ";";
                  Vector var13 = new Vector();
                  this.jaggSQL.setFCTN("JavaBeanGetParameterTypes");
                  this.jaggSQL.setFCTNP(var12);
                  if (JDPJagg.useJaggServer) {
                     this.jaggSQL.execSQL("", var13);
                  }

                  String var14 = this.jaggSQL.getSEP();
                  String var15 = "";
                  int var16 = 0;

                  for(int var17 = 0; var17 < var13.size(); ++var17) {
                     var15 = (String)var13.elementAt(var17);
                     if (var15.equals(" ")) {
                        ++var16;
                     } else {
                        StringTokenizer var18 = new StringTokenizer(var15, var14);
                        var18.nextToken();
                        var18.nextToken();

                        while(var18.hasMoreTokens()) {
                           ++var9;
                           var7[0] = convertParm(var18.nextToken());

                           for(var6[1] = 1; var1.addEntry(var7, var6, var7[0]); var7[0] = var7[0] + " ") {
                           }
                        }
                     }
                  }
               }

               if (var9 == 0 && var1.equals(this.parameterTree)) {
                  super.user.mainmsg.setStatusMsg("No parameters exist for this method.", 6);
                  this.TabPanel1.select(0);
               } else {
                  super.user.mainmsg.clearStatusMsg();
               }
            }
         }

         var2 = var1.treeRoot;
         var1.reDraw();
         return var2;
      }
   }

   void loadSourceBuilderParameterTree(JDPTreePicker var1, String var2, JDPTreeBranch var3) {
      int[] var4 = new int[]{4, 0, 2, 1};
      String[] var5 = new String[]{"", null, null, null};
      var1.setIcons(var4);
      boolean[] var6 = new boolean[]{true, false, true, false};
      var1.setExpanded(var6);
      if (var3 == null) {
         if (var2.equals("")) {
            var1.setRoot("Click on a method to add to source", true);
            if (((Component)var1).isShowing()) {
               super.user.mainmsg.setStatusMsg("Please select a Return type by selecting the text with the mouse", 7);
            }

            return;
         }

         var1.setRoot("Click on a method to add to source", true);
         this.extractReturnValues(this.target.compTree, var2, var1);
      }

      this.loadObjectsIntoMethodTree(var1, this.target.compTree, var2);
      String var7 = "";
      boolean var8 = true;
      String var10 = this.jaggSQL.getSEP();
      String var11 = "";
      String var12 = "";
      String var13 = "";
      int var14 = 0;
      if (var3 == null) {
         for(int var16 = 0; var16 < this.returnTypeVector.size(); ++var16) {
            String[] var15 = (String[])this.returnTypeVector.elementAt(var16);
            if (var2.equals("") || var15[2].indexOf(var2 + " ") >= 0) {
               var5[0] = var15[0];
               var4[1] = Integer.parseInt(var15[1]);
               var5[1] = "";
               var4[2] = 2;
               var1.addEntry(var5, var4, var15[3]);
            }
         }
      } else {
         for(int var28 = 0; var28 < this.returnMethods.size(); ++var28) {
            var13 = (String)this.returnMethods.elementAt(var28);
            if (!var13.equals(" ") && var13.startsWith(var3.name + var10)) {
               StringTokenizer var9 = new StringTokenizer(var13, var10);
               if (var9.countTokens() > 2) {
                  var5[0] = var9.nextToken();
                  var4[1] = Integer.parseInt(var9.nextToken());
                  int var17 = Integer.parseInt(var9.nextToken());
                  Vector var18 = (Vector)this.classMethods.elementAt(var17);
                  Vector var19 = (Vector)var18.elementAt(1);

                  for(int var20 = 0; var20 < var19.size(); ++var20) {
                     var13 = (String)var19.elementAt(var20);
                     if (!var13.equals(" ")) {
                        var9 = new StringTokenizer(var13, var10);
                        if (var9.countTokens() > 4) {
                           var11 = var9.nextToken();
                           var9.nextToken();
                           var5[1] = "Methods";
                           var4[2] = 2;
                           var5[2] = var9.nextToken();
                           var4[3] = 1;
                           var12 = var9.nextToken();
                           if (convertParm(var9.nextToken()).endsWith(var2) || var2.equals("")) {
                              var5[2] = var5[2] + "(";

                              for(boolean var22 = true; var9.hasMoreTokens(); var5[2] = var5[2] + convertParm(var7)) {
                                 if (!var22) {
                                    var5[2] = var5[2] + ",";
                                 }

                                 var22 = false;
                                 var7 = var9.nextToken();
                              }

                              var5[2] = var5[2] + ")";
                              var1.addEntry(var5, var4, var11);
                              ++var14;
                           }
                        }
                     }
                  }
               }
            }
         }
      }

      var1.sortTree(var1.treeRoot);
      var1.reDraw();
      if (var1.treeRoot.leaves.size() == 0) {
         super.user.mainmsg.setStatusMsg("No methods were found that match the selected return type", 7);
      } else {
         super.user.mainmsg.clearStatusMsg();
      }
   }

   JDPTreePicker addEvent(JDPTreeBranch var1, String var2) {
      if (var1.treeVector == null) {
         var1.treeVector = new Vector();
      }

      JDPTreePicker var3 = new JDPTreePicker(super.user, this.target, this.target.dragPanel);
      var3.setResizingAllowed(false);
      int[] var4 = new int[]{4, 1, 2, 1};
      var3.setIcons(var4);
      var3.setRoot("Component Events", true);
      JDPTreeBranch var5 = var3.treeRoot;
      Object[] var6 = new Object[]{null, "Methods"};
      String[] var7 = new String[]{null, "Drop here to attach this component/method to this Event"};
      var3.setDropKeys(var6);
      var3.setDragAndDrop((boolean[])null);
      var3.setDropMessages(var7);
      String[] var8 = new String[]{var2, null, null, null};
      boolean[] var9 = new boolean[]{true, true, true, false};
      var3.setIcons(var4);
      var3.setExpanded(var9);
      var3.addEntry(var8, var4, var2);
      var1.treeVector.addElement(var5);
      return var3;
   }

   void loadParameterTree(JDPTreeBranch var1, String[] var2) {
      var1.treeVector = new Vector();
      JDPTreePicker var3 = new JDPTreePicker(super.user, this.target, this.target.dragPanel);
      var3.setResizingAllowed(false);
      int[] var4 = new int[]{4, 1, 2, 1};
      var3.setIcons(var4);
      var3.setRoot("Method Parameters", true);
      JDPTreeBranch var5 = var3.treeRoot;
      Object[] var6 = new Object[]{null, "MethodProperty"};
      String[] var7 = new String[]{null, "Drop here to assign this method/property to this Parameter"};
      var3.setDropKeys(var6);
      var3.setDragAndDrop((boolean[])null);
      var3.setDropMessages(var7);
      boolean[] var8 = new boolean[]{true, false, true, false};
      var3.setExpanded(var8);
      String[] var9 = new String[]{null, null, null, null};

      for(int var10 = 0; var10 < var2.length; ++var10) {
         for(var9[0] = var2[var10]; var3.addEntry(var9, var4, var9[0]); var9[0] = var9[0] + " ") {
         }
      }

      var1.treeVector.addElement(var5);
   }

   public void loadVariableMethods(JDPList var1, String var2, String var3, String var4, int var5) {
      var1.clear();
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      String var10 = this.jaggSQL.getSEP();
      if (var3 != null && var3.startsWith("this.")) {
         var3 = var3.substring(5);
      }

      String[] var11 = new String[]{var2, var3, Integer.toString(5)};
      Vector var12 = this.getClassMethods(var11);
      boolean var13 = true;

      for(int var14 = 0; var14 < var12.size(); ++var14) {
         Vector var15 = (Vector)var12.elementAt(var14);
         Vector var16 = (Vector)var15.elementAt(1);
         String var17 = "";

         for(int var18 = 0; var18 < var16.size(); ++var18) {
            var17 = (String)var16.elementAt(var18);
            if (!var17.equals(" ")) {
               this.stok = new StringTokenizer(var17, var10);
               this.stok.nextToken();
               this.stok.nextToken();
               String var6 = this.stok.nextToken();
               int var7 = Integer.parseInt(this.stok.nextToken());
               if (var5 == 0 || (var7 & var5) != 0) {
                  String var8 = this.stok.nextToken();
                  if (var6.startsWith(var4)) {
                     this.thisEntry.setLength(0);
                     this.thisEntry.append(var6 + "(");
                     var13 = true;

                     while(this.stok.hasMoreTokens()) {
                        if (!var13) {
                           this.thisEntry.append(",");
                        }

                        var13 = false;
                        this.thisEntry.append(convertParm(this.stok.nextToken()));
                     }

                     this.thisEntry.append(")");
                     String var9 = this.thisEntry.toString();
                     if (this.listItems.indexOf(var9) < 0) {
                        var1.addItem(var9);
                        this.listItems.addElement(var9);
                     }
                  }
               }
            }
         }
      }

      var1.sortList();
      ((JDPTreePicker)var1).select(0);
   }

   static String convertParm(String var0) {
      try {
         if (var0.indexOf("[[L") >= 0) {
            var0 = var0.substring(3, var0.length() - 1) + "[][]";
         } else if (var0.indexOf("[I") >= 0) {
            var0 = "int[]";
         } else if (var0.indexOf("[Z") >= 0) {
            var0 = "boolean[]";
         } else if (var0.indexOf("[C") >= 0) {
            var0 = "char[]";
         } else if (var0.indexOf("[B") >= 0) {
            var0 = "byte[]";
         } else if (var0.indexOf("[") >= 0) {
            var0 = var0.substring(2, var0.length() - 1) + "[]";
         }

         if (var0.startsWith("java")) {
            int var1 = var0.lastIndexOf(".");
            if (var1 > 0) {
               var0 = var0.substring(var1 + 1);
            }
         }
      } catch (Exception var3) {
         System.out.println("Parm value: " + var0);
         ((Throwable)var3).printStackTrace();
      }

      return var0;
   }

   public String getGlobalVariableType(String var1) {
      if (var1.equals("user.u")) {
         return "JDPUtils";
      } else if (var1.equals("user.mainmsg")) {
         return "JDPStatusMessage";
      } else if (var1.equals("user.cust")) {
         return "JDPCustomer";
      } else {
         if (this.globalSource == null) {
            this.globalSource = this.target.gSource.templateSource[0].substring(0, this.target.gSource.templateSource[0].indexOf("<Components>"));
         }

         String var2 = this.findLocalVar(var1, this.beforeSelection);
         if (var2 != null) {
            return var2;
         } else {
            if (var1 != null && var1.startsWith("this.")) {
               var1 = var1.substring(5);
            }

            String var3 = this.findLocalVar(var1, this.globalSource);
            if (var3 != null) {
               return var3;
            } else {
               JDPTreeBranch var4 = this.target.layoutTree.getBranch(var1);
               return var4 != null ? var4.compType : null;
            }
         }
      }
   }

   void removeSelectedParameter() {
      JDPTreeBranch[] var1 = this.parameterTree.getTreeBranch(this.parameterTree.getCurrentBranch());
      this.parameterTree.removeTreeBranch(this.parameterTree.getCurrentBranch());
      if (var1[2].leaves.size() == 0) {
         this.parameterTree.removeTreeBranch(var1[2]);
      }

      this.eventSource.setText(this.target.gSource.constructEventSource(this.eventTree.getTreeBranch(this.eventTree.getCurrentBranch())));
   }

   void loadListenerEvents(JDPTreeBranch var1, JDPTreeBranch var2) {
      String[] var3 = new String[]{null, null, null, null};
      int[] var4 = new int[]{4, 1, 2, 1};
      String var5;
      if (var2.thisObject != null && !(var2.thisObject instanceof String)) {
         var5 = var2.thisObject.toString();
      } else {
         var5 = var2.compType;
      }

      if (var5.equals("JDPGridLayout")) {
         var5 = "JDPTextGrid";
      }

      if (var5.equals("JDPChartLayout")) {
         var5 = "JDPChart";
      }

      if (var5.indexOf(" ") > 0) {
         var5 = var5.substring(0, var5.indexOf(" "));
      }

      if (var5.indexOf("@") > 0) {
         var5 = var5.substring(0, var5.indexOf("@"));
      }

      String[] var6 = new String[]{var5, var2.name, Integer.toString(var2.icon)};
      Vector var7 = this.getClassMethods(var6);
      String var9 = super.user.jaggSQL.getSEP();

      for(int var12 = 0; var12 < var7.size(); ++var12) {
         Vector var13 = (Vector)var7.elementAt(var12);
         Vector var14 = (Vector)var13.elementAt(2);

         for(int var15 = 0; var15 < var14.size(); ++var15) {
            String var11 = (String)var14.elementAt(var15);
            if (!var11.equals(" ")) {
               StringTokenizer var8 = new StringTokenizer(var11, var9);
               var8.nextToken();
               var8.nextToken();
               String var10 = var8.nextToken();
               String[] var16 = new String[var8.countTokens()];

               for(int var17 = 0; var17 < var16.length; ++var17) {
                  var16[var17] = var8.nextToken();
               }

               for(int var19 = 0; var19 < var16.length; ++var19) {
                  var3[0] = var16[var19];
                  this.eventTree.addEntry(var3, var4, var10);
                  JDPTreeBranch var18 = this.eventTree.getLastAddedBranch();
                  if (var18 != null) {
                     var18.text = var16;
                  }
               }
            }
         }
      }

   }

   synchronized void clearReturnValues() {
      this.returnMethods = null;
      this.returnTypeVector = null;
   }

   synchronized Vector loadClassMethodVector(String var1, String[] var2) {
      this.jaggSQL.getSEP();
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      super.user.mainmsg.setStatusMsg("Retrieving class information...", 0);
      this.jaggSQL.setFCTN("JavaBeanGetMethods");
      this.jaggSQL.setFCTNP("*SUPER;" + var1 + ";");
      if (JDPJagg.useJaggServer) {
         this.jaggSQL.execSQL("", var3);
      }

      this.jaggSQL.setFCTN("JavaBeanGetEvents");
      if (JDPJagg.useJaggServer) {
         this.jaggSQL.execSQL("", var4);
      }

      Vector var5 = new Vector(3);
      var5.addElement(var1);
      var5.addElement(var3);
      var5.addElement(var4);
      this.classMethods.addElement(var5);
      this.addReturnMethods(var1, var2);
      super.user.mainmsg.clearStatusMsg();
      return var5;
   }

   void addEventEntry(JDPTreePicker var1, String var2, String var3, int var4, String var5, String[] var6, String var7) {
      String[] var8 = new String[]{var2, var3, var5, null};
      int[] var9 = new int[]{4, 1, var4, 1};
      var1.addEntry(var8, var9, var8[2]);
      JDPTreeBranch var10 = var1.getLastAddedBranch();
      var10.text = new String[1];
      var10.text[0] = var7;
      this.loadParameterTree(var10, var6);
   }

   public void loadMethodsForVisualApp(JDPComboBox var1, int var2) {
      this.loadMethodsForVisualApp(var1, var2, true);
   }

   public void loadMethodsForVisualApp(JDPComboBox var1, int var2, boolean var3) {
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      this.listItems = new Vector();
      String var8 = "";
      String var11 = this.jaggSQL.getSEP();

      for(int var12 = 0; var12 < this.returnMethods.size(); ++var12) {
         String var10 = (String)this.returnMethods.elementAt(var12);
         if (!var10.equals(" ")) {
            this.stok = new StringTokenizer(var10, var11);
            if (this.stok.countTokens() > 2) {
               String var7 = this.stok.nextToken();
               this.stok.nextToken();
               int var13 = Integer.parseInt(this.stok.nextToken());
               Vector var14 = (Vector)this.classMethods.elementAt(var13);
               Vector var15 = (Vector)var14.elementAt(1);

               for(int var16 = 0; var16 < var15.size(); ++var16) {
                  var10 = (String)var15.elementAt(var16);
                  if (!var10.equals(" ")) {
                     this.stok = new StringTokenizer(var10, var11);
                     if (this.stok.countTokens() > 4) {
                        String var9 = this.stok.nextToken();
                        this.stok.nextToken();
                        String var6 = this.stok.nextToken();
                        var8 = this.stok.nextToken();
                        String var5 = convertParm(this.stok.nextToken());
                        if (var6.startsWith("get") && !this.stok.hasMoreTokens()) {
                           this.thisEntry.setLength(0);
                           if (var5.equals("int") && JDPUtils.isOdbcNum(var2)) {
                              this.thisEntry.append("\" + Integer.toString(" + var7 + "." + var6 + "(");
                              this.thisEntry.append(")) + \"");
                              String var19 = this.thisEntry.toString();
                              if (this.listItems.indexOf(var19) < 0) {
                                 var1.addItem(var19);
                                 this.listItems.addElement(var19);
                              }
                           } else if (var5.equals("long") && JDPUtils.isOdbcNum(var2)) {
                              this.thisEntry.append("\" + Long.toString(" + var7 + "." + var6 + "(");
                              this.thisEntry.append(")) + \"");
                              String var18 = this.thisEntry.toString();
                              if (this.listItems.indexOf(var18) < 0) {
                                 var1.addItem(var18);
                                 this.listItems.addElement(var18);
                              }
                           } else if (var5.equals("float") && JDPUtils.isOdbcNum(var2)) {
                              this.thisEntry.append("\" + Float.toString(" + var7 + "." + var6 + "(");
                              this.thisEntry.append(")) + \"");
                              String var17 = this.thisEntry.toString();
                              if (this.listItems.indexOf(var17) < 0) {
                                 var1.addItem(var17);
                                 this.listItems.addElement(var17);
                              }
                           } else if (var5.equals("String") && JDPUtils.isOdbcChar(var2)) {
                              if (var3) {
                                 this.thisEntry.append("'\" + " + var7 + "." + var6 + "(");
                                 this.thisEntry.append(") + \"'");
                              } else {
                                 this.thisEntry.append("\" + " + var7 + "." + var6 + "(");
                                 this.thisEntry.append(") + \"");
                              }

                              String var4 = this.thisEntry.toString();
                              if (this.listItems.indexOf(var4) < 0) {
                                 var1.addItem(var4);
                                 this.listItems.addElement(var4);
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }

   }

   void searchForText(String var1, boolean var2) {
      if (var2) {
         if (this.lastSearchLine == 999999) {
            this.lastSearchLine = 0;
         }
      } else if (this.lastSearchLine == 0) {
         this.lastSearchLine = 999999;
      }

      int var4 = this.eventSource.getText().length();
      int var3;
      if (var2) {
         var3 = this.eventSource.getText().toUpperCase().indexOf(var1.toUpperCase(), this.lastSearchLine);
      } else {
         if (this.lastSearchLine > var4) {
            this.lastSearchLine = var4;
         }

         this.lastSearchLine -= 2;
         if (this.lastSearchLine < 0) {
            this.lastSearchLine = 0;
         }

         var3 = this.eventSource.getText().toUpperCase().lastIndexOf(var1.toUpperCase(), this.lastSearchLine);
      }

      if (var3 >= 0) {
         this.eventSource.select(var3, var3 + var1.length());
         this.lastSearchLine = var3 + 1;
         this.eventSource.requestFocus();
      } else {
         super.user.mainmsg.setStatusMsg("Search string not found", 5);
         if (var2) {
            this.lastSearchLine = 0;
         } else {
            this.lastSearchLine = 999999;
         }
      }
   }

   void setProperties(JDPTreeBranch var1) {
      if (this.target.buttonPanel != null && this.target.buttonPanel.getPressed() != null && this.target.buttonPanel.getPressed().equals("Events") && var1 != null) {
         if (var1.treeVector == null) {
            var1.treeVector = new Vector();
            JDPTreeBranch var2 = new JDPTreeBranch();
            var1.treeVector.addElement(var2);
         }

         JDPTreeBranch var3 = this.loadEventTree((JDPTreeBranch)var1.treeVector.elementAt(0), var1);
         var1.treeVector.setElementAt(var3, 0);
         if (var3 != null && var3.leaves != null && var3.leaves.size() != 0 && var3.leaves.elementAt(0) != null && ((JDPTreeBranch)var3.leaves.elementAt(0)).leaves != null && ((JDPTreeBranch)var3.leaves.elementAt(0)).leaves.size() != 0) {
            if (this.TabPanel1.getSelectedIndex() == 0) {
               this.TabPanel1.select(1);
               this.clearMethodPropertyTree();
            }

         } else {
            this.TabPanel1.select(0);
         }
      }
   }

   Vector loadComponents(JDPTreeBranch var1, Vector var2) {
      if (var2 == null) {
         var2 = new Vector();
         boolean var3 = false;

         for(int var4 = 0; var4 < this.methodTree.treeRoot.leaves.size(); ++var4) {
            if (((JDPTreeBranch)this.methodTree.treeRoot.leaves.elementAt(var4)).name.equals("user")) {
               var3 = true;
               break;
            }
         }

         if (!var3 || this.returnTypeVector == null) {
            String[] var9 = new String[]{"JDPUser", "user", Integer.toString(5)};
            this.getClassMethods(var9);
            var2.addElement(var9);
            String[] var5 = new String[]{"JDPCustomer", "user.cust", Integer.toString(5)};
            this.getClassMethods(var5);
            var2.addElement(var5);
            String[] var6 = new String[]{"JDPStatusMessage", "user.mainmsg", Integer.toString(34)};
            this.getClassMethods(var6);
            var2.addElement(var6);
            String[] var7 = new String[]{"JDPUtils", "user.u", Integer.toString(2)};
            this.getClassMethods(var7);
            var2.addElement(var7);
            if (var3) {
               var2 = new Vector();
            }
         }
      }

      if (var1 != null && var1.name != null && !var1.name.equals("")) {
         String var8;
         if (var1.thisObject != null && !(var1.thisObject instanceof String)) {
            var8 = var1.thisObject.toString();
         } else {
            var8 = var1.compType;
         }

         if (var8.equals("JDPGridLayout")) {
            var8 = "JDPTextGrid";
         }

         if (var8.equals("JDPChartLayout")) {
            var8 = "JDPChart";
         }

         if (var8.indexOf(" ") > 0) {
            var8 = var8.substring(0, var8.indexOf(" "));
         }

         if (var8.indexOf("@") > 0) {
            var8 = var8.substring(0, var8.indexOf("@"));
         }

         String[] var10 = new String[]{var8, var1.name, Integer.toString(var1.icon)};
         var2.addElement(var10);
         if (var1.thisObject != null) {
            for(int var11 = 0; var11 < var1.leaves.size(); ++var11) {
               JDPTreeBranch var12 = (JDPTreeBranch)var1.leaves.elementAt(var11);
               this.loadComponents(var12, var2);
            }
         }
      }

      return var2;
   }

   int extractParameterNames(JDPTreeBranch var1, JDPTreeBranch[] var2) {
      int var6 = 0;
      int[] var7 = new int[]{4, 1, 2, 1};
      String[] var8 = new String[]{"", null, null, null};
      String var9 = var2[2].name;
      JDPTreeBranch[] var10 = this.target.lView.tree.getTreeBranch(var9);
      if (var10 != null && var10[var10.length - 1].text != null && var10[var10.length - 1].text.length > 0) {
         for(int var11 = 0; var11 < var10[var10.length - 1].text.length; ++var11) {
            String var3 = var10[var10.length - 1].text[var11];
            if (var3 != null) {
               int var4 = var3.indexOf("|");
               if (var4 > 0 && var3.substring(0, var4).equals(var1.name)) {
                  var4 = var3.indexOf("(");
                  int var5 = var3.indexOf(")");
                  if (var4 > 0 && var5 > 0) {
                     StringTokenizer var12 = new StringTokenizer(var3.substring(var4 + 1, var5), " \n\t\r");

                     while(var12.hasMoreTokens()) {
                        ++var6;
                        var8[0] = var12.nextToken();
                        var12.nextToken();
                        var7[1] = 1;
                        this.parameterTree.addEntry(var8, var7, var8[0]);
                     }
                  }
               }
            }
         }
      }

      return var6;
   }

   Vector getClassMethods(String[] var1) {
      Vector var2 = this.getClassNames(var1[0]);
      Vector var3 = new Vector();

      for(int var4 = 0; var4 < var2.size(); ++var4) {
         String var5 = (String)var2.elementAt(var4);
         var3.addElement(this.getClassMethodVector(var5, var1));
      }

      return var3;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            return false;
         case 401:
            if (this.eventTree.getCurrentBranch() != null) {
               if (this.eventTree.getCurrentBranch().text == null) {
                  this.eventTree.getCurrentBranch().text = new String[1];
               }

               this.target.setAppChanged(true);
               this.eventTree.getCurrentBranch().text[0] = this.eventSource.getText();
            }

            if (var1.key == 9 && var1.target.equals(this.methodList)) {
               this.eventSource.requestFocus();
               return true;
            }

            return false;
         case 402:
            if (var1.target.equals(this.eventSource)) {
               if (var1.key == 10) {
                  JDPUtils.insertTabs((TextArea)var1.target);
                  return false;
               }

               if (var1.key == 9) {
                  return false;
               }

               this.startThread();
            }

            return false;
         case 404:
            if (var1.target.equals(this.eventSource) && (var1.key == 1006 || var1.key == 1007)) {
               this.startThread();
            }

            return false;
         case 501:
            this.dragPanel.postEvent(var1);
            return false;
         case 502:
            if (this.dragPanel.isVisible()) {
               this.dragPanel.postEvent(var1);
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            if (var1.target.equals(this.methodList)) {
               String var9 = "";
               if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
                  String var4 = super.user.u.replace(this.eventSource.getText(), "\n", "  ");
                  var9 = var4.substring(this.eventSource.getSelectionStart(), this.eventSource.getSelectionEnd());
               } else {
                  var9 = this.eventSource.getSelectedText();
               }

               if (this.sourceSelected == null || !var9.equals(this.sourceSelected)) {
                  this.loadMethodList(this.eventSource, this.methodList);
                  this.sourceSelected = var9;
               }
            }

            this.popuppanel.postEvent(var1);
            return false;
         case 506:
            this.dragPanel.postEvent(var1);
            return true;
         case 701:
            if (var1.target.equals(this.methodList)) {
               this.replaceSelectedText(this.eventSource, this.methodList.getSelectedItem());
               this.startThread();
               return true;
            } else if (var1.target.equals(this.eventTree) && this.eventTree.getSelectedLvl() < 3) {
               if (this.lastSelectedEvent != null) {
                  this.eventTree.select(this.lastSelectedEvent);
               }

               return true;
            } else if (var1.target.equals(this.parameterTree) && this.parameterTree.getSelectedLvl() == 1) {
               this.clearMethodPropertyTree();
               JDPTreeBranch var5 = this.parameterTree.getCurrentBranch();
               this.loadMethodPropertyTree(var5);
               return true;
            } else {
               String var2 = (String)var1.arg;
               if (var1.target.equals(this.methodTree) && this.methodTree.getSelectedLvl() == 1 && var2.equals("BranchOpen")) {
                  JDPTreeBranch var8 = this.methodTree.getCurrentBranch();
                  if (var8.leaves.size() <= 2) {
                     this.loadMethodTree(var8, true);
                  }

                  return true;
               } else {
                  if (var1.target.equals(this.methodPropertyTree) && this.methodPropertyTree.getSelectedLvl() == 1 && var2.equals("BranchOpen")) {
                     JDPTreeBranch var7 = this.methodPropertyTree.getCurrentBranch();
                     if (var7.leaves.size() <= 2) {
                        this.loadMethodPropertyTree(this.parameterTree.getCurrentBranch(), var7);
                     }

                     return true;
                  }

                  if (var1.target.equals(this.eventTree) && this.eventTree.getSelectedLvl() == 3) {
                     this.lastSelectedEvent = this.eventTree.getCurrentBranch();
                  }

                  this.lastSelectedParameter = this.parameterTree.getCurrentBranch();
                  return false;
               }
            }
         case 1001:
            if (this.lastSelectedEvent != null) {
               if (this.lastSelectedEvent.text == null || this.lastSelectedEvent.text.length == 0) {
                  this.lastSelectedEvent.text = new String[1];
               }

               this.lastSelectedEvent.text[0] = this.eventSource.getText();
               this.target.setAppChanged(true);
            }

            if (var1.target.equals(this.eventTree) && this.eventTree.getSelectedLvl() == 3) {
               return this.loadEventSource();
            } else if (var1.target.equals(this.methodTree) && this.methodTree.getSelectedLvl() == 3) {
               this.lastSelectedEvent = null;
               JDPTreeBranch[] var6 = this.eventTree.getTreeBranch("ACTION_EVENT");
               if (var6 == null) {
                  var6 = this.eventTree.getTreeBranch("LIST_SELECT");
               }

               if (var6 == null) {
                  var6 = this.eventTree.getTreeBranch("ACTION_BTN_0");
               }

               this.dragAndDrop("Methods", this.methodTree.getTreeBranch(this.methodTree.getCurrentBranch()), var6);
               return true;
            } else if (var1.target.equals(this.parameterTree) && this.parameterTree.getSelectedLvl() == 1) {
               this.clearMethodPropertyTree();
               JDPTreeBranch var3 = this.parameterTree.getCurrentBranch();
               this.loadMethodPropertyTree(var3);
               if (this.lastSelectedParameter != null && this.lastSelectedParameter.equals(var3)) {
                  return false;
               }

               this.lastSelectedParameter = var3;
               return true;
            } else if (var1.target.equals(this.methodPropertyTree) && this.methodPropertyTree.getSelectedLvl() == 3 && this.parameterTree.getSelectedLvl() == 1) {
               this.dragAndDrop("MethodProperty", this.methodPropertyTree.getTreeBranch(this.methodPropertyTree.getCurrentBranch()), this.parameterTree.getTreeBranch(this.parameterTree.getCurrentBranch()));
               return true;
            } else if (var1.target.equals(this.methodPropertyTree) && this.methodPropertyTree.getSelectedLvl() == 1 && this.parameterTree.getSelectedLvl() == 1) {
               this.dragAndDrop("MethodPropertyVar", this.methodPropertyTree.getTreeBranch(this.methodPropertyTree.getCurrentBranch()), this.parameterTree.getTreeBranch(this.parameterTree.getCurrentBranch()));
               return true;
            } else if (var1.target.equals(this.methodList)) {
               this.replaceSelectedText(this.eventSource, this.methodList.getSelectedItem());
               this.startThread();
               return true;
            } else {
               if (var1.target.equals(this.methodsButton)) {
                  if (this.methodList.isVisible()) {
                     this.methodList.hide();
                     this.methodsButton.setPressed(false);
                  } else {
                     this.methodList.show();
                  }

                  this.eventSourcePanelFrame.layout();
                  this.eventSourcePanelFrame.paintAll(this.eventSourcePanelFrame.getGraphics());
               }

               if (var1.target.equals(this.searchButtons.button[0])) {
                  this.searchForText(this.searchFor.getText(), true);
                  return true;
               } else {
                  if (var1.target.equals(this.searchButtons.button[1])) {
                     this.searchForText(this.searchFor.getText(), false);
                     return true;
                  }

                  return false;
               }
            }
         case 1005:
            if (this.lastSelectedEvent != null) {
               if (this.lastSelectedEvent.text == null || this.lastSelectedEvent.text.length == 0) {
                  this.lastSelectedEvent.text = new String[1];
               }

               this.target.setAppChanged(true);
               this.lastSelectedEvent.text[0] = this.eventSource.getText();
            }

            if (var1.target.equals(this.eventSource)) {
               this.lastCursorStartPos = this.eventSource.getSelectionStart();
               this.lastCursorEndPos = this.eventSource.getSelectionEnd();
            }

            return false;
         default:
            return false;
      }
   }

   public void run() {
      this.threadRunning = true;

      while(this.threadRunning) {
         try {
            Thread.sleep(2000L);
            if (this.eventSource.isShowing()) {
               if (this.methodList.isVisible()) {
                  this.loadMethodList(this.eventSource, this.methodList);
               }
            } else if (this.sourceEditorList.isVisible()) {
               this.loadMethodList(this.target.sourcePanel, this.sourceEditorList);
            }

            this.threadRunning = false;
         } catch (InterruptedException var1) {
         }
      }

   }

   public void InitClass(JDPUser var1, JDPLayoutMgr var2, String var3) {
      super.user = var1;
      this.target = var2;
      this.targetPanel = var2.targetPanel;
      this.dragPanel = var2.dragPanel;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.setDSN(var1.jaggSQL.getDSN());
      this.classMethods = new Vector();
      this.returnMethods = new Vector();
      this.returnTypeVector = new Vector();
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.Main = new JDPSplitPanel(var1, 1, 1);
      this.Main.setLeftPercentage(25.0F);
      String[] var4 = new String[3];
      Panel[] var5 = new Panel[]{new Panel(), null, null};
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Add New Event";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "Parameters";
      var5[2] = new Panel();
      var5[2].setLayout(new BorderLayout());
      var4[2] = "Source";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.Panel1 = new Panel();
      this.methodTree = new JDPTreePicker(var1, var2, this.dragPanel);
      this.methodTree.autoScrollOn = false;
      this.methodTree.setResizingAllowed(false);
      int var6 = (int)((double)this.targetPanel.bounds().width / (double)4.5F);
      if (var6 == 0) {
         Dimension var7 = Toolkit.getDefaultToolkit().getScreenSize();
         var6 = (int)((double)var7.width / (double)6.0F);
      }

      this.methodTree.setMinWidth(var6);
      this.Panel2 = new JDPSplitPanel(var1, 1, 1);
      this.parameterTree = new JDPTreePicker(var1, var2, this.dragPanel);
      this.parameterTree.setResizingAllowed(false);
      this.parameterTree.setRoot("parameterTree", true);
      this.parameterTree.setMinWidth(var6);
      this.methodPropertyTree = new JDPTreePicker(var1, var2, this.dragPanel);
      this.methodPropertyTree.setResizingAllowed(false);
      this.methodPropertyTree.autoScrollOn = false;
      this.clearMethodPropertyTree();
      this.eventSource = new TextArea("", 3, 20);
      this.eventSource.setFont(new Font("Courier", 0, 12));
      this.eventTree = new JDPTreePicker(var1, this.targetPanel, this.dragPanel);
      this.eventTree.setResizingAllowed(false);
      this.eventTree.setMinWidth(var6);
      this.methodList = new JDPList(var1);
      this.sourceEditorList = new JDPList(var1);
      this.methodList.setMinWidth(140);
      this.sourceEditorList.setMinWidth(140);
      this.currentLine = new JDPSpinner(var1, "0", 5);
      this.currentLine.setMinValue(0);
      this.currentLine.setMaxValue(999999);
      var2.sourcePanelFrame.add("Right", this.sourceEditorList);
      this.clearMethodTree();
      ((Container)this).add("Center", this.Main);
      this.Main.add("Right", this.TabPanel1);
      var5[0].add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.methodTree);
      var5[1].add("Center", this.Panel2);
      this.Panel2.add("Left", this.parameterTree);
      this.Panel2.add("Right", this.methodPropertyTree);
      this.eventSourcePanelFrame = new JDPSplitPanel(var1, 1, 1);
      this.eventSourcePanelFrame.add("Left", this.eventSource);
      this.eventSourcePanelFrame.add("Right", this.methodList);
      this.eventSourcePanelFrame.setLeftPercentage(80.0F);
      this.eventSourcePanel = new Panel();
      this.eventSourcePanel.setLayout(new BorderLayout());
      this.eventSourcePanel.add("Center", this.eventSourcePanelFrame);
      var5[2].add("Center", this.eventSourcePanel);
      this.Main.add("Left", this.eventTree);
      this.methodsButton = new JDPButton(43, "Display Methods", 0);
      this.popuppanel.addComponent(this.methodsButton, "Display/Hide Source Helper", "Display/Hide the source helper");
      this.methodsButton.setStayOn(true);
      this.methodsButton.setPressed(true);
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new BorderLayout());
      ((Container)var11).add("East", this.methodsButton);
      this.eventSourcePanel.add("South", var11);
      this.searchFor = new TextField("", 20);
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new JDPLineLayout());
      ((Container)var8).add("Left", new Label("Search:", 2));
      ((Container)var8).add("Left", this.searchFor);
      ((Container)var11).add("West", var8);
      this.popuppanel.addComponent(this.searchFor, "Search", "Search for the text in the currently displayed source");
      String[] var9 = new String[]{"SearchFwd", "SearchBack"};
      int[] var10 = new int[]{48, 49};
      this.searchButtons = new JDPButtons(var1, var10, var9, JDPButtons.getAlignmentValue("Horizontal"));
      this.popuppanel.addComponent(this.searchButtons.button[0], "Search Forward", "Search for the text in the currently displayed source");
      this.popuppanel.addComponent(this.searchButtons.button[1], "Search Backward", "Search backwards for the text in the currently displayed source");
      ((Container)var8).add("Left", this.searchButtons);
      ((Container)var8).add("Left", new Panel());
      ((Container)var8).add("Left", new Label("Line:", 0));
      ((Container)var8).add("Left", this.currentLine);
      this.methodTree.setBackground(var1.u._cvtcolor("White"));
      this.parameterTree.setBackground(var1.u._cvtcolor("White"));
      this.methodPropertyTree.setBackground(var1.u._cvtcolor("White"));
      this.eventTree.setBackground(var1.u._cvtcolor("White"));
      var1.gParm.addElement(this);
      var1.JDesignerPro.gc();
   }

   public void loadVariablesFromType(JDPList var1, JDPTreeBranch var2, String var3) {
      if (!var2.compType.equals(var3) && (!var2.compType.startsWith("java") || !var2.compType.endsWith(var3))) {
         if (var2.thisObject != null) {
            try {
               Class var4 = var2.thisObject.getClass();
               if (var4 == null) {
                  var4 = Class.forName(var2.compType);
               }

               for(; var4 != null; var4 = var4.getSuperclass()) {
                  if ((var4.getName().equals(var3) || var4.getName().startsWith("java") && var4.getName().endsWith(var3)) && this.listItems.indexOf(var2.name) < 0) {
                     var1.addItem(var2.name);
                     this.listItems.addElement(var2.name);
                  }
               }
            } catch (Exception var7) {
               ((Throwable)var7).printStackTrace();
            }
         }
      } else if (this.listItems.indexOf(var2.name) < 0) {
         var1.addItem(var2.name);
         this.listItems.addElement(var2.name);
      }

      if (var2.leaves != null) {
         for(int var8 = 0; var8 < var2.leaves.size(); ++var8) {
            JDPTreeBranch var5 = (JDPTreeBranch)var2.leaves.elementAt(var8);
            this.loadVariablesFromType(var1, var5, var3);
         }
      }

   }
}
