import java.sql.Connection;
import java.util.Date;
import java.util.Vector;

public class JDPJaggCxnMgr extends Thread {
   JDPSubsystemMgr manager;
   JaggServer server;
   JDPJagg jaggSQL;
   Vector requests;

   public String getJdbcConnections() {
      String var1 = " " + this.manager.jaggSQL.getSEP();
      String var2 = Long.toString((new Date()).getTime());
      StringBuffer var3 = new StringBuffer();

      try {
         for(int var4 = 0; var4 < this.manager.server.dbConnection.size(); ++var4) {
            Vector var5 = (Vector)this.manager.server.dbConnection.elementAt(var4);
            var3.append((String)var5.elementAt(0));
            var3.append(var1);
            var3.append((String)var5.elementAt(1));
            var3.append(var1);
            var3.append((String)var5.elementAt(3));
            var3.append(var1);
            var3.append((String)var5.elementAt(4));
            var3.append(var1);
            var3.append(((Long)var5.elementAt(5)).toString());
            var3.append(var1);
            var3.append(((Long)var5.elementAt(6)).toString());
            var3.append(var1);
            var3.append(var2);
            var3.append(var1);
         }
      } catch (Exception var7) {
         ((Throwable)var7).printStackTrace();
      }

      return var3.toString();
   }

   public synchronized void registerRequest(JaggServerCxn var1) {
      this.requests.addElement(var1);
   }

   public synchronized Vector getJdbcConnectioCxn(long var1) {
      for(int var3 = 0; var3 < this.server.dbConnection.size(); ++var3) {
         Vector var4 = (Vector)this.server.dbConnection.elementAt(var3);
         long var5 = (Long)var4.elementAt(6);
         if (var5 == var1) {
            return var4;
         }
      }

      return null;
   }

   public String killRequest(long var1) {
      JaggServerCxn var3 = this.getJaggServerCxn(var1);
      if (var3 != null) {
         try {
            ((Thread)var3).stop(new Exception("ThreadKilled"));
            return "Request successfully killed.";
         } catch (Exception var6) {
            ((Throwable)var6).printStackTrace();
         }
      }

      return "Request is no longer active.";
   }

   public String setRequestPriority(long var1, int var3) {
      JaggServerCxn var4 = this.getJaggServerCxn(var1);
      if (var4 != null) {
         try {
            ((Thread)var4).setPriority(var3);
            return "Priority successfully changed.";
         } catch (Exception var7) {
            ((Throwable)var7).printStackTrace();
         }
      }

      return "Request is no longer active.";
   }

   public String closeConnection(long var1) {
      Vector var3 = this.getJdbcConnectioCxn(var1);
      if (var3 != null) {
         try {
            String var4 = (String)var3.elementAt(1);
            if (var4.equals("Inactive")) {
               Connection var5 = (Connection)var3.elementAt(2);

               try {
                  var5.close();
                  this.server.dbConnection.removeElement(var3);
                  Object var9 = null;
                  Object var10 = null;
               } catch (Exception var7) {
               }

               return "Connection closed.";
            }

            return "Cannot close an Active connection.";
         } catch (Exception var8) {
            ((Throwable)var8).printStackTrace();
         }
      }

      return "Connection is already closed.";
   }

   public synchronized void deRegisterRequest(JaggServerCxn var1) {
      this.requests.removeElement(var1);
   }

   public JDPJaggCxnMgr(JDPSubsystemMgr var1, JaggServer var2) {
      super(var1.mainThreadGroup, "JDPJaggUserMgr");
      this.manager = var1;
      this.server = var2;
      this.requests = new Vector();
   }

   public synchronized JaggServerCxn getJaggServerCxn(long var1) {
      for(int var3 = 0; var3 < this.requests.size(); ++var3) {
         JaggServerCxn var4 = (JaggServerCxn)this.requests.elementAt(var3);
         if (var4.requestNum == var1) {
            return var4;
         }
      }

      return null;
   }

   public String setRequestHeld(long var1, boolean var3) {
      JaggServerCxn var4 = this.getJaggServerCxn(var1);
      if (var4 != null) {
         try {
            if (var3) {
               var4.suspended = true;
               ((Thread)var4).suspend();
               return "Request successfully held.";
            }

            var4.suspended = false;
            ((Thread)var4).resume();
            return "Request successfully resumed.";
         } catch (Exception var7) {
            ((Throwable)var7).printStackTrace();
         }
      }

      return "Request is no longer active.";
   }

   public String getConnections() {
      String var1 = " " + this.manager.jaggSQL.getSEP();
      String var2 = Long.toString((new Date()).getTime());
      StringBuffer var3 = new StringBuffer();

      try {
         if (this.requests != null) {
            for(int var4 = 0; var4 < this.requests.size(); ++var4) {
               JaggServerCxn var5 = (JaggServerCxn)this.requests.elementAt(var4);
               if (var5.FCTN.equals("")) {
                  var3.append("SQL");
               } else {
                  var3.append(var5.FCTN);
               }

               var3.append(var1);
               if (var5.FCTN.equals("Invoke")) {
                  if (var5.jobName != null) {
                     var3.append(var5.jobName + ":");
                  }

                  if (var5.jobNumber != null) {
                     var3.append(var5.jobNumber + ":");
                  }

                  if (var5.objectName != null) {
                     var3.append(var5.objectName + "." + var5.methodName);
                  }
               } else if (!var5.FCTN.equals("") && !var5.FCTN.equals("System")) {
                  var3.append(var5.FCTNP);
               } else {
                  var3.append(var5.SQL);
               }

               var3.append(var1);
               var3.append(var5.jdbcDriver);
               var3.append(var1);
               var3.append(var5.jdbcPrefix);
               var3.append(var1);
               var3.append(var5.jdbcSuffix);
               var3.append(var1);
               var3.append(var5.UID);
               var3.append(var1);
               var3.append(var5.PWD);
               var3.append(var1);
               var3.append(var5.USER);
               var3.append(var1);
               var3.append(var5.SYS);
               var3.append(var1);
               var3.append(var5.TOUT);
               var3.append(var1);
               var3.append(var5.MRW);
               var3.append(var1);
               var3.append(var5.CSTR);
               var3.append(var1);
               if (var5.startDate != null) {
                  var3.append(Long.toString(var5.startDate.getTime()));
               } else {
                  var3.append("0");
               }

               var3.append(var1);

               try {
                  if (var5.thisSocket != null && var5.thisSocket.getInetAddress() != null && var5.thisSocket.getInetAddress().getHostAddress() != null) {
                     var3.append(var5.thisSocket.getInetAddress().getHostAddress());
                     var3.append(var1);
                     var3.append(var5.thisSocket.getInetAddress().getHostName());
                  } else {
                     var3.append("Unknown");
                     var3.append(var1);
                     var3.append("Unknown");
                  }
               } catch (Exception var7) {
                  var3.append("Unknown");
                  var3.append(var1);
                  var3.append("Unknown");
               }

               var3.append(var1);
               var3.append(Long.toString(var5.requestNum));
               var3.append(var1);
               var3.append(Integer.toString(((Thread)var5).getPriority()));
               var3.append(var1);
               var3.append(var5.suspended ? "Y" : "N");
               var3.append(var1);
               var3.append(Long.toString(var5.thisJdbcConnectionNum));
               var3.append(var1);
               var3.append(var2);
               var3.append(var1);
            }
         }
      } catch (Exception var8) {
         ((Throwable)var8).printStackTrace();
      }

      return var3.toString();
   }

   public void run() {
      while(!this.manager.shutdownRequested) {
         try {
            Thread.sleep(10000L);
         } catch (Exception var1) {
         }
      }

   }
}
