import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPJobStreamMaint extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   Panel Panel2;
   Panel Columns1;
   JDPScrollPanel ScrollPanel1;
   Label STREAMNAMELabel1;
   TextField a_STREAMNAME1;
   Label STREAMDESCLabel1;
   TextField b_STREAMDESC1;
   Label LASTSTATUSLabel1;
   TextField b_LASTSTATUS1;
   Label LASTENTRYLabel1;
   TextField b_LASTENTRY1;
   Label ACTUALSTRTLabel1;
   TextField b_ACTUALSTRT1;
   Label ACTUALENDLabel1;
   TextField b_ACTUALEND1;
   Label ENTRYLabel1;
   Panel ENTRYLine1;
   JDPSpinner a_ENTRY1;
   Checkbox a_STOPIFFAIL1;
   Label LASTSTATUSLabel2;
   Panel Panel5;
   TextField a_LASTSTATUS1;
   Label DURATIONLabel1;
   TextField a_DURATION1;
   Label Label1;
   JDPChoice restartSetting;
   Vector valuerestartSetting;
   JDPButtons JDPButtons1;
   JDPTabSelectPanel TabPanel1;
   JDPChiselFramePanel ChiselPanel3;
   Panel Panel3;
   JDPObjectSelection JDPObjectSelection1;
   JDPChiselFramePanel ChiselPanel2;
   Panel Panel4;
   TextArea JobLog;
   JDPSearchResults ResultList1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Job Stream Maintenance");
      this.Panel1 = new Panel();
      this.Panel2 = new Panel();
      this.Columns1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.STREAMNAMELabel1 = new Label("Stream Name:", 0);
      this.a_STREAMNAME1 = new TextField("a.STREAMNAME", 20);
      this.STREAMDESCLabel1 = new Label("Description:", 0);
      this.b_STREAMDESC1 = new TextField("b.STREAMDESC", 50);
      this.LASTSTATUSLabel1 = new Label("Last run status:", 0);
      this.b_LASTSTATUS1 = new TextField("b.LASTSTATUS", 20);
      this.LASTENTRYLabel1 = new Label("Last entry run:", 0);
      this.b_LASTENTRY1 = new TextField("b.LASTENTRY", 20);
      this.ACTUALSTRTLabel1 = new Label("Actual start:", 0);
      this.b_ACTUALSTRT1 = new TextField("b.ACTUALSTRT", 25);
      this.ACTUALENDLabel1 = new Label("Actual end:", 0);
      this.b_ACTUALEND1 = new TextField("b.ACTUALEND", 25);
      this.ENTRYLabel1 = new Label("Entry:", 0);
      this.ENTRYLine1 = new Panel();
      this.a_ENTRY1 = new JDPSpinner(var1, "", 5);
      this.a_STOPIFFAIL1 = new Checkbox("Stop if Entry fails");
      this.LASTSTATUSLabel2 = new Label("Last status:", 0);
      this.Panel5 = new Panel();
      this.a_LASTSTATUS1 = new TextField("a.LASTSTATUS", 8);
      this.DURATIONLabel1 = new Label("Duration:", 0);
      this.a_DURATION1 = new TextField("a.DURATION", 20);
      this.Label1 = new Label("When restarting:", 0);
      this.restartSettingMain();
      String[] var4 = new String[]{"Apply", "Add", "Remove", "Refresh"};
      int[] var5 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("New"), JDPButton.getIconValue("Delete"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      String[] var6 = new String[2];
      Panel[] var7 = new Panel[]{new Panel(), null};
      var7[0].setLayout(new BorderLayout());
      var6[0] = "Define Task";
      var7[1] = new Panel();
      var7[1].setLayout(new BorderLayout());
      var6[1] = "Last Job Log";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var6, var7, "North");
      this.ChiselPanel3 = new JDPChiselFramePanel(var1, "Define the Java class, platform command or Job Stream that is to be run");
      this.Panel3 = new Panel();
      this.JDPObjectSelection1 = new JDPObjectSelection();
      this.JDPObjectSelection1.InitClass(var1, var2, var3);
      this.ChiselPanel2 = new JDPChiselFramePanel(var1, "Last Job Log output");
      this.Panel4 = new Panel();
      this.JobLog = new TextArea("", 3, 20);
      this.ResultList1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("North", this.Columns1);
      this.Columns1.setLayout(new BorderLayout());
      this.Columns1Main();
      this.Columns1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.STREAMNAMELabel1);
      this.ScrollPanel1.add("Right", this.a_STREAMNAME1);
      this.ScrollPanel1.add("Left", this.STREAMDESCLabel1);
      this.ScrollPanel1.add("Right", this.b_STREAMDESC1);
      this.ScrollPanel1.add("Left", this.LASTSTATUSLabel1);
      this.ScrollPanel1.add("Right", this.b_LASTSTATUS1);
      this.ScrollPanel1.add("Left", this.LASTENTRYLabel1);
      this.ScrollPanel1.add("Right", this.b_LASTENTRY1);
      this.ScrollPanel1.add("Left", this.ACTUALSTRTLabel1);
      this.ScrollPanel1.add("Right", this.b_ACTUALSTRT1);
      this.ScrollPanel1.add("Left", this.ACTUALENDLabel1);
      this.ScrollPanel1.add("Right", this.b_ACTUALEND1);
      this.ScrollPanel1.add("Left", this.ENTRYLabel1);
      this.ScrollPanel1.add("Right", this.ENTRYLine1);
      this.ENTRYLine1.setLayout(new JDPLineLayout());
      this.ENTRYLine1.add("Left", this.a_ENTRY1);
      this.ENTRYLine1.add("Left", this.a_STOPIFFAIL1);
      this.ScrollPanel1.add("Left", this.LASTSTATUSLabel2);
      this.ScrollPanel1.add("Right", this.Panel5);
      this.Panel5.setLayout(new JDPLineLayout());
      this.Panel5.add("Left", this.a_LASTSTATUS1);
      this.Panel5.add("Left", this.DURATIONLabel1);
      this.Panel5.add("Left", this.a_DURATION1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.restartSetting);
      this.Panel2.add("South", this.JDPButtons1);
      this.Panel2.add("Center", this.TabPanel1);
      var7[0].add("Center", this.ChiselPanel3);
      this.ChiselPanel3.add("Center", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("Center", this.JDPObjectSelection1);
      var7[1].add("Center", this.ChiselPanel2);
      this.ChiselPanel2.add("Center", this.Panel4);
      this.Panel4.setLayout(new BorderLayout());
      this.Panel4.add("Center", this.JobLog);
      this.Panel1.add("West", this.ResultList1);
      this.STREAMNAMELabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.a_STREAMNAME1, "Stream Name", "Enter the name of this Job Stream");
      this.STREAMDESCLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.b_STREAMDESC1, "Description", "Entry the Description of this Job Stream");
      this.b_STREAMDESC1.setEditable(true);
      this.LASTSTATUSLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_LASTSTATUS1.setEditable(false);
      this.popuppanel.addComponent(this.b_LASTSTATUS1, "Last run status", "The status returned the last time this Job Stream was run.");
      this.b_LASTSTATUS1.setEditable(false);
      this.LASTENTRYLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_LASTENTRY1.setEditable(false);
      this.popuppanel.addComponent(this.b_LASTENTRY1, "Last entry run", "The last entry of this Stream that was run.");
      this.b_LASTENTRY1.setEditable(false);
      this.ACTUALSTRTLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_ACTUALSTRT1.setEditable(false);
      this.popuppanel.addComponent(this.b_ACTUALSTRT1, "Actual start", "The actual start date/time of the last run.");
      this.b_ACTUALSTRT1.setEditable(false);
      this.ACTUALENDLabel1.setFont(new Font("Helvetica", 1, 11));
      this.b_ACTUALEND1.setEditable(false);
      this.popuppanel.addComponent(this.b_ACTUALEND1, "Actual end", "The actual end date/time of the last run.");
      this.b_ACTUALEND1.setEditable(false);
      this.ENTRYLabel1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.a_ENTRY1, "Entry Number", "Select the Entry Number. This number defines the execution order of entries in the Job Stream.");
      this.popuppanel.addComponent(this.a_STOPIFFAIL1, "Stop if entry fails", "Check to cause execution of the Job Stream to halt if this entry results in failure.");
      this.LASTSTATUSLabel2.setFont(new Font("Helvetica", 1, 11));
      this.a_LASTSTATUS1.setEditable(false);
      this.popuppanel.addComponent(this.a_LASTSTATUS1, "Laststatus", "The status that was returned the last time this entry was run.");
      this.a_LASTSTATUS1.setEditable(false);
      this.DURATIONLabel1.setFont(new Font("Helvetica", 1, 11));
      this.a_DURATION1.setEditable(false);
      this.popuppanel.addComponent(this.a_DURATION1, "Duration", "The duration of this entry the last time it was run.");
      this.a_DURATION1.setEditable(false);
      this.Label1.setFont(new Font("Helvetica", 1, 11));
      this.popuppanel.addComponent(this.JDPButtons1.button[0], "Apply Changes", "");
      this.popuppanel.addComponent(this.JDPButtons1.button[1], "Create a new Entry", "");
      this.popuppanel.addComponent(this.JDPButtons1.button[2], "Remove an Entry", "");
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(1, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.JobLog.setEditable(false);
      this.popuppanel.addComponent(this.JobLog, "", "Output from the last time this task was run");
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9 && var1.modifiers != 1) {
               if (var1.target.equals(this.a_STREAMNAME1)) {
                  this.user.u.cursor(this.b_STREAMDESC1);
               }

               if (var1.target.equals(this.b_STREAMDESC1)) {
                  this.user.u.cursor(this.b_LASTSTATUS1);
               }

               if (var1.target.equals(this.b_LASTSTATUS1)) {
                  this.user.u.cursor(this.b_LASTENTRY1);
               }

               if (var1.target.equals(this.b_LASTENTRY1)) {
                  this.user.u.cursor(this.b_ACTUALSTRT1);
               }

               if (var1.target.equals(this.b_ACTUALSTRT1)) {
                  this.user.u.cursor(this.b_ACTUALEND1);
               }

               if (var1.target.equals(this.b_ACTUALEND1)) {
                  this.user.u.cursor(this.a_ENTRY1);
               }

               if (var1.target.equals(this.a_ENTRY1)) {
                  this.user.u.cursor(this.a_STOPIFFAIL1);
               }

               if (var1.target.equals(this.a_STOPIFFAIL1)) {
                  this.user.u.cursor(this.a_LASTSTATUS1);
               }

               if (var1.target.equals(this.a_LASTSTATUS1)) {
                  this.user.u.cursor(this.a_DURATION1);
               }

               if (var1.target.equals(this.a_DURATION1)) {
                  this.user.u.cursor(this.a_STREAMNAME1);
               }
            }

            if (var1.key == 9 && var1.modifiers == 1) {
               if (var1.target.equals(this.a_STREAMNAME1)) {
                  this.user.u.cursor(this.a_DURATION1);
                  return true;
               }

               if (var1.target.equals(this.b_STREAMDESC1)) {
                  this.user.u.cursor(this.a_STREAMNAME1);
                  return true;
               }

               if (var1.target.equals(this.b_LASTSTATUS1)) {
                  this.user.u.cursor(this.b_STREAMDESC1);
                  return true;
               }

               if (var1.target.equals(this.b_LASTENTRY1)) {
                  this.user.u.cursor(this.b_LASTSTATUS1);
                  return true;
               }

               if (var1.target.equals(this.b_ACTUALSTRT1)) {
                  this.user.u.cursor(this.b_LASTENTRY1);
                  return true;
               }

               if (var1.target.equals(this.b_ACTUALEND1)) {
                  this.user.u.cursor(this.b_ACTUALSTRT1);
                  return true;
               }

               if (var1.target.equals(this.a_ENTRY1)) {
                  this.user.u.cursor(this.b_ACTUALEND1);
                  return true;
               }

               if (var1.target.equals(this.a_STOPIFFAIL1)) {
                  this.user.u.cursor(this.a_ENTRY1);
                  return true;
               }

               if (var1.target.equals(this.a_LASTSTATUS1)) {
                  this.user.u.cursor(this.a_STOPIFFAIL1);
                  return true;
               }

               if (var1.target.equals(this.a_DURATION1)) {
                  this.user.u.cursor(this.a_LASTSTATUS1);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.Columns1updateRow(this.ResultList1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               if (!this.Columns1insertRow(this.ResultList1.getSelectedKey())) {
                  return true;
               }

               this.ResultList1.clearList();
               this.ResultList1.loadList();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[2])) {
               this.Columns1removeRow(this.ResultList1.getSelectedKey());
               this.ResultList1.clearList();
               this.ResultList1.loadList();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[3])) {
               this.ResultList1.clearList();
               this.ResultList1.loadList();
               return true;
            } else {
               if (var1.target.equals(this.ResultList1)) {
                  this.Columns1Load(this.ResultList1.getSelectedKey());
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void Columns1Main() {
      this.Columns1LoadChoices();
      this.Columns1ClearFields();
   }

   public void Columns1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var8 = "SELECT a.STREAMNAME,a.ENTRY,a.DURATION,a.LASTSTATUS,a.STOPIFFAIL,a.OBJECTTYPE,a.OBJECT,a.OBJECTPARM,a.OBJECTCONS,a.LASTJOBLOG,b.STREAMDESC,b.LASTSTATUS,b.LASTENTRY,b.ACTUALSTRT,b.STARTTIME,b.ACTUALEND,b.ENDTIME,b.RESTART FROM JDPJOBEN a,JDPJOBS b WHERE a.JDPSYSTEM = b.JDPSYSTEM AND a.STREAMNAME = b.STREAMNAME";
         if (var1.length > 0 && var1[0] != null) {
            var8 = var8 + " AND a.JDPSYSTEM='" + var1[0] + "'";
         }

         if (var1.length > 1 && var1[1] != null) {
            var8 = var8 + " AND a.STREAMNAME='" + var1[1] + "'";
         }

         if (var1.length > 2 && var1[2] != null) {
            var8 = var8 + " AND a.ENTRY=" + var1[2] + "";
         }

         this.jaggSQL.loadSettings(this.user);
         this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
         var3 = this.jaggSQL.execSQL(var8, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var8);
         } else {
            String var9 = "";
            String var10 = "";
            String var11 = "";
            String var12 = "";
            String var13 = "";
            if (var3 >= 1) {
               String var6 = (String)var4.elementAt(0);
               if (var6 != null && var6.trim().compareTo("") != 0) {
                  StringTokenizer var2 = new StringTokenizer(var6, var5);
                  this.a_STREAMNAME1.setText(var2.nextToken().trim());
                  this.a_ENTRY1.setText(var2.nextToken().trim());
                  var9 = var2.nextToken().trim();
                  this.a_LASTSTATUS1.setText(var2.nextToken().trim());
                  String var7 = var2.nextToken(var5).trim();
                  this.a_STOPIFFAIL1.setState(var7.equals("Y"));
                  this.JDPObjectSelection1.setObjectType(var2.nextToken(var5).trim());
                  this.JDPObjectSelection1.setObject(var2.nextToken(var5).trim());
                  this.JDPObjectSelection1.setParameters(var2.nextToken(var5).trim());
                  this.JDPObjectSelection1.setConstructor(var2.nextToken(var5).trim());
                  this.JobLog.setText(var2.nextToken().trim());
                  this.b_STREAMDESC1.setText(var2.nextToken().trim());
                  this.b_LASTSTATUS1.setText(var2.nextToken().trim());
                  this.b_LASTENTRY1.setText(var2.nextToken().trim());
                  var10 = var2.nextToken().trim();
                  var11 = var2.nextToken().trim();
                  var12 = var2.nextToken().trim();
                  var13 = var2.nextToken().trim();
                  this.restartSetting.selectKey(var2.nextToken().trim());
               }

               if (var3 > 1) {
                  this.user.mainmsg.setStatusMsg(JDPLang.get("Message1"), 10);
               } else {
                  this.user.mainmsg.clearStatusMsg();
               }

               long var14 = Long.valueOf(var9);
               long var16 = var14 / 86400000L;
               long var18 = (var14 - var16 * 24L * 3600000L) / 3600000L;
               long var20 = (var14 - var16 * 24L * 3600000L - var18 * 3600000L) / 60000L;
               long var22 = (var14 - var16 * 24L * 3600000L - var18 * 3600000L - var20 * 60000L) / 1000L;
               String var24 = "";
               if (var16 > 0L) {
                  var24 = var24 + Long.toString(var16) + " dys ";
               }

               var24 = var24 + Long.toString(var18) + " hr " + Long.toString(var20) + " min " + Long.toString(var22) + " secs";
               if (this.a_LASTSTATUS1.getText().equals("")) {
                  this.a_DURATION1.setText("");
               } else {
                  this.a_DURATION1.setText(var24);
               }

               if (this.a_LASTSTATUS1.getText().equals("S")) {
                  this.a_LASTSTATUS1.setText("Success");
               } else if (this.a_LASTSTATUS1.getText().equals("F")) {
                  this.a_LASTSTATUS1.setText("Fail");
               }

               if (this.b_LASTSTATUS1.getText().equals("S")) {
                  this.b_LASTSTATUS1.setText("Success");
               } else if (this.b_LASTSTATUS1.getText().equals("F")) {
                  this.b_LASTSTATUS1.setText("Fail");
               }

               if (var10.equals("0")) {
                  this.b_ACTUALSTRT1.setText("");
               } else {
                  this.b_ACTUALSTRT1.setText((new Date(Long.valueOf(var10) + Long.valueOf(var11))).toString());
               }

               if (var12.equals("0")) {
                  this.b_ACTUALEND1.setText("");
               } else {
                  this.b_ACTUALEND1.setText((new Date(Long.valueOf(var12) + Long.valueOf(var13))).toString());
               }
            } else {
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message2"), 10);
               this.Columns1ClearFields();
            }
         }
      } else {
         this.Columns1ClearFields();
      }
   }

   public boolean Columns1updateRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "U") : false;
   }

   public boolean Columns1insertRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "I") : false;
   }

   public boolean Columns1removeRow(String[] var1) {
      return this.Columns1Save(var1, "D");
   }

   boolean Columns1Save(String[] var1, String var2) {
      int var3 = 0;
      Vector var4 = new Vector();
      this.jaggSQL.getSEP();
      String var5 = "";
      Object var6 = null;
      if (var2.equals("I")) {
         var5 = "INSERT INTO JDPJOBEN (JDPSYSTEM, STREAMNAME, ENTRY, OBJECTTYPE, OBJECT, OBJECTPARM, OBJECTCONS, DURATION, LASTSTATUS, STOPIFFAIL, LASTJOBLOG) VALUES('" + this.user.JDPSystem + "', " + "'" + this.user.u.replace(this.a_STREAMNAME1.getText(), "'", "''") + "', " + "" + JDPUtils.tonum(this.a_ENTRY1.getText()) + ", " + "'" + this.JDPObjectSelection1.getObjectType() + "', " + "'" + this.JDPObjectSelection1.getObject() + "', " + "'" + this.JDPObjectSelection1.getParameters() + "', " + "'" + this.JDPObjectSelection1.getConstructor() + "', " + "0, " + "'', " + "'" + (this.a_STOPIFFAIL1.getState() ? "Y" : "N") + "', " + "'')";
      } else {
         if (var1 == null || var1.length == 0) {
            this.user.mainmsg.setStatusMsg(JDPLang.get("Message3"), 5);
            return false;
         }

         if (var2.equals("D")) {
            var5 = "DELETE FROM JDPJOBEN WHERE JDPSYSTEM='" + var1[0] + "'" + " AND STREAMNAME='" + var1[1] + "'" + " AND ENTRY=" + var1[2];
         } else {
            var5 = "UPDATE JDPJOBEN SET STOPIFFAIL = '" + (this.a_STOPIFFAIL1.getState() ? "Y" : "N") + "' ," + " OBJECTTYPE = '" + this.JDPObjectSelection1.getObjectType() + "', " + " OBJECT = '" + this.JDPObjectSelection1.getObject() + "', " + " OBJECTPARM = '" + this.JDPObjectSelection1.getParameters() + "', " + " OBJECTCONS = '" + this.JDPObjectSelection1.getConstructor() + "' " + " WHERE JDPSYSTEM='" + var1[0] + "'" + " AND STREAMNAME='" + var1[1] + "'" + " AND ENTRY=" + var1[2];
         }
      }

      this.jaggSQL.loadSettings(this.user);
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      var3 = this.jaggSQL.execSQL(var5, var4);
      if (var3 == 0 && var6 != null) {
         String[] var7 = new String[]{JDPLang.get("Reload"), JDPLang.get("Update")};
         int[] var8 = new int[]{6, 0};
         JDPMessageDialog var9 = new JDPMessageDialog(this.user, this.user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), var7, var8);
         ((JDPDialog)var9).display();
         if (var9.getPressedButton() != 1) {
            this.Columns1Load(var1);
            return true;
         }

         var4 = new Vector();
         var3 = this.jaggSQL.execSQL((String)var6, var4);
      }

      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var5);
         return false;
      } else {
         if (var3 == 1) {
            if (var2.equals("I")) {
               var5 = "SELECT * FROM JDPJOBS  WHERE JDPSYSTEM='" + this.user.JDPSystem + "'" + " AND STREAMNAME='" + this.user.u.replace(this.a_STREAMNAME1.getText(), "'", "''") + "'";
               var3 = this.jaggSQL.execSQL(var5, var4);
               if (var3 <= 0) {
                  var5 = "INSERT INTO JDPJobs (JDPSYSTEM, STREAMNAME, STREAMDESC, LASTSTATUS, LASTENTRY, RESTART, ACTUALSTRT, STARTTIME, ACTUALEND, ENDTIME) VALUES('" + this.user.JDPSystem + "', " + "'" + this.user.u.replace(this.a_STREAMNAME1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.b_STREAMDESC1.getText(), "'", "''") + "', " + "'', " + "0, " + "'" + this.restartSetting.getSelectedKey() + "', " + "null , " + "0, " + "null, " + "0)";
                  this.jaggSQL.execSQL(var5, var4);
               }

               this.user.mainmsg.setStatusMsg(JDPLang.get("Message4"), 3);
            } else if (var2.equals("D")) {
               var5 = "SELECT * FROM JDPJOBEN  WHERE JDPSYSTEM='" + var1[0] + "'" + " AND STREAMNAME='" + var1[1] + "'";
               var3 = this.jaggSQL.execSQL(var5, var4);
               if (var3 == 0) {
                  var5 = "DELETE FROM JDPJOBS  WHERE JDPSYSTEM='" + var1[0] + "'" + " AND STREAMNAME='" + var1[1] + "'";
                  this.jaggSQL.execSQL(var5, var4);
               }

               this.user.mainmsg.setStatusMsg(JDPLang.get("Message5"), 3);
            } else {
               var5 = "UPDATE JDPJOBS SET STREAMDESC = '" + this.user.u.replace(this.b_STREAMDESC1.getText(), "'", "''") + "', " + " RESTART = '" + this.restartSetting.getSelectedKey() + "' " + " WHERE JDPSYSTEM='" + var1[0] + "'" + " AND STREAMNAME='" + var1[1] + "'";
               this.jaggSQL.execSQL(var5, var4);
               this.user.mainmsg.setStatusMsg(JDPLang.get("Message6"), 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var5);
         }

         if (var6 != null) {
            this.Columns1Load(var1);
         }

         return true;
      }
   }

   public void Columns1ClearFields() {
      this.a_STREAMNAME1.setText("");
      this.a_ENTRY1.setText("");
      this.a_DURATION1.setText("");
      this.a_LASTSTATUS1.setText("");
      this.a_STOPIFFAIL1.setState(false);
      this.b_STREAMDESC1.setText("");
      this.b_LASTSTATUS1.setText("");
      this.b_LASTENTRY1.setText("");
      this.b_ACTUALSTRT1.setText("");
      this.b_ACTUALEND1.setText("");
   }

   void Columns1LoadChoices() {
   }

   public boolean Columns1CheckFields() {
      if (!this.user.u.ischaracter(this.a_STREAMNAME1, this.user.mainmsg)) {
         return false;
      } else {
         return this.user.u.ischaracter(this.b_STREAMDESC1, this.user.mainmsg);
      }
   }

   public void restartSettingMain() {
      if (this.restartSetting == null) {
         this.restartSetting = new JDPChoice();
      }

      String[] var1 = new String[]{"Restart at first entry", "Restart at last failed entry", "Restart at entry after last failed", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"F", "L", "A", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.restartSetting.loadChoice(var1, var2);
   }

   public void ResultList1Main() {
      String var1 = "a.JDPSYSTEM,a.STREAMNAME,a.ENTRY";
      String[] var2 = new String[]{"a.ENTRY"};
      String var3 = "a.JDPSystem = '" + this.user.JDPSystem + "'";
      String[] var4 = new String[]{"Stream Name"};
      String[] var5 = new String[]{"a.STREAMNAME"};
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.loadSettings(this.user);
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, var6, false, var1, var2, var3, var4, var5, var5, "", false, "Total Entries:");
      int[] var7 = new int[19];
      var7[0] = 4;
      var7[1] = 26;
      var7[2] = 1;
      this.ResultList1.setMinWidth(180);
      this.ResultList1.setIcons(var7);
      this.ResultList1.setFromWhereClause(" FROM JDPJOBEN a,JDPJOBS b WHERE a.JDPSYSTEM = b.JDPSYSTEM AND a.STREAMNAME = b.STREAMNAME AND a.JDPSystem = '" + this.user.JDPSystem + "'");
      this.ResultList1.clearList("Job Stream / Entry Number");
      this.ResultList1.loadList();
   }
}
