import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.StringBufferInputStream;
import java.util.Properties;

public class JDPLang {
   static JDPUser user;
   // $FF: renamed from: p java.util.Properties
   static Properties field_0;
   static String language;
   static String country;

   public static String get(String var0) {
      String var1 = (String)field_0.get(var0);
      if (var1 == null) {
         if (var0.equals("JDPLogin0")) {
            return "Please log in";
         } else if (var0.equals("JDPLogin1")) {
            return "Username:";
         } else if (var0.equals("JDPLogin2")) {
            return "Password:";
         } else {
            return var0.equals("JDPLoginG") ? "Guest" : var0;
         }
      } else {
         return var1;
      }
   }

   public static String get(String var0, String var1) {
      String var2 = user.u.replace((String)field_0.get(var0), "%s", var1);
      return var2;
   }

   public static String get(String var0, String[] var1) {
      String var2 = (String)field_0.get(var0);

      for(int var3 = 0; var3 < var1.length; ++var3) {
         var2 = JDPUtils.replace(var2, "%s" + Integer.toString(var3), var1[var3], 1);
      }

      return var2;
   }

   public static String get(String var0, int var1) {
      String var2 = user.u.replace((String)field_0.get(var0), "%d", Integer.toString(var1));
      return var2;
   }

   public static String get(String var0, int var1, int var2) {
      String var3 = user.u.replace((String)field_0.get(var0), "%d1", Integer.toString(var1));
      var3 = user.u.replace(var3, "%d2", Integer.toString(var2));
      return var3;
   }

   public static String get(String var0, int[] var1) {
      String var2 = (String)field_0.get(var0);

      for(int var3 = 0; var3 < var1.length; ++var3) {
         var2 = JDPUtils.replace(var2, "%d" + Integer.toString(var3), Integer.toString(var1[var3]), 1);
      }

      return var2;
   }

   public static boolean load(JDPUser var0, String var1, String var2) {
      user = var0;
      if (var1 == null) {
         var1 = "en";
         var2 = "";
      }

      language = var1.toLowerCase();
      country = var2.toUpperCase();
      if (!load()) {
         country = "";
         if (!load()) {
            language = "en";
            if (load()) {
               if (user.mainmsg != null) {
                  user.mainmsg.setStatusMsg(get("lang1"), 10);
               }

               return true;
            } else {
               if (user.mainmsg != null) {
                  user.mainmsg.setStatusMsg("Language load failed. See Java console for details.", 20);
               }

               System.out.println("Failed reading file: en.lang");
               return false;
            }
         } else {
            if (user.mainmsg != null) {
               user.mainmsg.setStatusMsg(get("lang1"), 10);
            }

            return true;
         }
      } else {
         if (user.mainmsg != null) {
            user.mainmsg.setStatusMsg(get("lang1"), 10);
         }

         return true;
      }
   }

   static boolean load() {
      field_0 = new Properties();
      if ((language + country).trim().equals("")) {
         return false;
      } else {
         String var0 = "System" + JDesignerPro.serverSeparator + "Language" + JDesignerPro.serverSeparator;
         String var1 = user.JDesignerPro.JDPDirectory + var0 + language + country + ".lang";
         String var2 = user.u.readFromFile(var1);
         if (var2 == null) {
            return false;
         } else {
            try {
               StringBufferInputStream var3 = new StringBufferInputStream(var2);
               field_0.load(var3);
               return true;
            } catch (Exception var5) {
               ((Throwable)var5).printStackTrace();
               return false;
            }
         }
      }
   }

   static boolean save() {
      String var0 = "System" + JDesignerPro.serverSeparator + "Language" + JDesignerPro.serverSeparator;
      String var1 = user.JDesignerPro.JDPDirectory + var0 + language + country + ".lang";
      if (field_0 == null) {
         return false;
      } else {
         if (user.mainmsg != null) {
            user.mainmsg.setStatusMsg("Saving settings...", 0);
         }

         ByteArrayOutputStream var2 = new ByteArrayOutputStream();
         field_0.save((OutputStream)var2, var1);
         String var3 = var2.toString();
         if (user.mainmsg != null) {
            user.mainmsg.setStatusMsg("Writing...", 0);
         }

         if (user.u.writeToFile(var1, var3, "w+")) {
            if (user.mainmsg != null) {
               user.mainmsg.setStatusMsg("File successfully saved.", 10);
            }

            return true;
         } else {
            if (user.mainmsg != null) {
               user.mainmsg.setStatusMsg("File write failed. See Java console for details.", 20);
            }

            return false;
         }
      }
   }
}
