import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Vector;

public class JDPListLayout extends JDPClassLayout {
   JDPSelectDSN targetDSN;
   JDPSelectTable targetTable;
   JDPSelectColumns target;
   JDPLayoutMgr targetLayoutMgr;
   String moduleParameter;
   JDPPopupMessage popuppanel;
   JDPList columns;
   JDPComboBox useTree;
   Label includeLabel;
   JDPList columns1;
   JDPList includeTree;
   TextField mainBranchText;
   JDPComboBox mainBranchIcon;
   JDPComboBox mainIcon;
   JDPComboBox iconlist;
   JDPList uniqueTree;
   TextField treeMinWidth;
   TextField maxRows;
   JDPComboBox displayCount;
   TextField pcounttext;
   TextField psortchoicetext;
   TextField psortchoicesql;
   JDPComboBox psortorder;
   JDPComboBox pinitchoice;
   TextField pfromwhereclause;
   Label listCount;
   String[] psortChoiceText;
   String[] psortChoiceSql;
   String[] psortOrder;
   int[] iconList;
   String pinitChoice = "";
   String pselectFields;
   String[] psdisplayFields;
   String[] psortCh;
   String[] psortChSql;
   Vector gParmObject;
   int currentSelection = -1;
   int currentSelection1 = -1;
   JDPTabSelectPanel tabPanel;
   long lastEventTime;

   void updateArrays() {
      if (this.currentSelection >= 0) {
         this.psortChoiceText[this.currentSelection] = this.psortchoicetext.getText();
         this.psortChoiceSql[this.currentSelection] = this.psortchoicesql.getText();
         this.psortOrder[this.currentSelection] = this.psortorder.getSelectedItem();
      }
   }

   void clearList() {
      this.columns.clear();

      for(int var1 = 0; var1 < this.columns1.countItems(); ++var1) {
         this.columns1.deselect(var1);
      }

      for(int var2 = 0; var2 < this.includeTree.countItems(); ++var2) {
         this.includeTree.deselect(var2);
      }

      for(int var3 = 0; var3 < this.uniqueTree.countItems(); ++var3) {
         this.uniqueTree.deselect(var3);
      }

      this.columns1.clear();
      this.includeTree.clear();
      this.uniqueTree.clear();
   }

   void loadList() {
      this.clearList();
      this.psortChoiceText = new String[1];
      this.psortChoiceSql = new String[1];
      this.psortOrder = new String[1];
      this.iconList = new int[1];
      if (this.target != null && this.target.columnName != null && this.target.columns.getSelectedIndexes().length != 0) {
         String[] var1 = this.target.columns.getSelectedItems();
         this.target.columns.getSelectedIndexes();
         int var2 = var1.length;
         this.listCount.setText(Integer.toString(var2));
         this.psortChoiceText = new String[var2];
         this.psortChoiceSql = new String[var2];
         this.psortOrder = new String[var2];
         this.iconList = new int[var2];

         for(int var3 = 0; var3 < var1.length; ++var3) {
            this.psortChoiceText[var3] = super.user.u.makeLabel(var1[var3]);
            this.psortChoiceSql[var3] = var1[var3];
            this.psortOrder[var3] = "Ascending";
            this.columns.addItem(var1[var3], 8);
            this.columns1.addItem(var1[var3]);
         }

         String[] var5 = this.target.keys.getSelectedItems();

         for(int var4 = 0; var4 < var5.length; ++var4) {
            this.uniqueTree.addItem(var5[var4]);
            this.uniqueTree.select(var4);
            this.uniqueTree.makeVisible(0);
         }

      } else {
         if (super.componentName.equals("") && ((Component)this).isShowing()) {
            super.user.mainmsg.setStatusMsg("You must first select a Table.", 5);
         }

      }
   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPListLayout" + super.componentName;
      this.mainBranchText.setText("");
      this.mainBranchIcon.select(0);
      this.mainIcon.select(0);
      var1.restoreObject(this.columns, var2, "columns");
      var1.restoreObject(this.useTree, var2, "useTree");
      var1.restoreObject(this.columns1, var2, "columns1");
      var1.restoreObject(this.includeTree, var2, "includeTree", 1);
      var1.restoreObject(this.mainBranchText, var2, "mainBranchText");
      var1.restoreObject(this.mainBranchIcon, var2, "mainBranchIcon");
      var1.restoreObject(this.mainIcon, var2, "mainIcon");
      int[] var3 = (int[])var1.restoreObject(this.iconList, var2, "iconList");
      var1.restoreObject(this.uniqueTree, var2, "uniqueTree");
      var1.restoreObject(this.treeMinWidth, var2, "treeMinWidth");
      var1.restoreObject(this.maxRows, var2, "maxRows");
      var1.restoreObject(this.displayCount, var2, "displayCount");
      var1.restoreObject(this.pcounttext, var2, "pcounttext");
      String[] var4 = (String[])var1.restoreObject(this.psortChoiceText, var2, "psortChoiceText");
      String[] var5 = (String[])var1.restoreObject(this.psortChoiceSql, var2, "psortChoiceSql");
      String[] var6 = (String[])var1.restoreObject(this.psortOrder, var2, "psortOrder");
      this.pinitChoice = (String)var1.restoreObject(this.pinitChoice, var2, "pinitChoice");
      var1.restoreObject(this.pfromwhereclause, var2, "pfromwhereclause");
      if (var3 != null) {
         if (this.iconList.length < var3.length) {
            this.iconList = new int[var3.length];
         }

         if (this.psortChoiceText.length < var4.length) {
            this.psortChoiceText = new String[var4.length];
         }

         if (this.psortChoiceSql.length < var5.length) {
            this.psortChoiceSql = new String[var5.length];
         }

         if (this.psortOrder.length < var6.length) {
            this.psortOrder = new String[var6.length];
         }

         for(int var7 = 0; var7 < var3.length; ++var7) {
            this.iconList[var7] = var3[var7];
            this.psortChoiceText[var7] = var4[var7];
            this.psortChoiceSql[var7] = var5[var7];
            this.psortOrder[var7] = var6[var7];
         }
      }

      return true;
   }

   void clearFields() {
      this.psortchoicetext.setText("");
      this.psortchoicesql.setText("");
      this.psortorder.select("Ascending");
      this.pinitchoice.select("Yes");
      this.pinitChoice = "";
   }

   void loadLayoutComponent() {
      if (this.targetLayoutMgr != null && this.psortChoiceSql != null && this.columns.countItems() > 0 && this.columns.getSelectedIndexes().length > 0) {
         JDPJagg var1 = new JDPJagg(super.user.jaggPath);
         var1.loadSettings(this.targetDSN);
         var1.setMRW("100");
         this.pselectFields = "";
         String[] var2 = this.uniqueTree.getSelectedItems();

         for(int var3 = 0; var3 < var2.length; ++var3) {
            if (var3 > 0) {
               String var10001 = this.pselectFields;
               this.pselectFields = var10001 + ",";
            }

            String var12 = this.pselectFields;
            this.pselectFields = var12 + var2[var3];
         }

         this.psdisplayFields = new String[this.includeTree.countItems()];

         for(int var7 = 0; var7 < this.includeTree.countItems(); ++var7) {
            this.psdisplayFields[var7] = this.includeTree.getItem(var7);
         }

         int[] var8 = this.columns.getSelectedIndexes();
         this.psortCh = new String[var8.length];

         for(int var4 = 0; var4 < this.psortCh.length; ++var4) {
            if (var8[var4] < this.psortChoiceText.length) {
               this.psortCh[var4] = this.psortChoiceText[var8[var4]];
            }
         }

         this.psortChSql = new String[var8.length];

         for(int var9 = 0; var9 < this.psortChSql.length; ++var9) {
            if (var8[var9] < this.psortChoiceSql.length) {
               this.psortChSql[var9] = this.psortChoiceSql[var8[var9]];
               if (this.psortOrder[var8[var9]].equals("Descending")) {
                  String[] var10000 = this.psortChSql;
                  var10000[var9] = var10000[var9] + " DESC";
               }
            }
         }

         Container var10 = null;
         if (super.thisBranch.thisObject instanceof Component) {
            var10 = ((Component)super.thisBranch.thisObject).getParent();
            if (var10 != null) {
               var10.remove((Component)super.thisBranch.thisObject);
            }
         }

         super.thisBranch.thisObject = new JDPSearchResults(super.user, super.targetPanel, this.useTree.getSelectedIndex() == 0, var1, false, this.pselectFields, this.psdisplayFields, this.pfromwhereclause.getText(), this.psortCh, this.psortChSql, this.psortChSql, this.pinitChoice, this.displayCount.getSelectedIndex() == 0, this.pcounttext.getText());
         int[] var5 = new int[this.iconList.length + 2];
         var5[0] = this.mainBranchIcon.getSelectedIndex();
         var5[1] = this.mainIcon.getSelectedIndex();

         for(int var6 = 0; var6 < this.iconList.length; ++var6) {
            var5[var6 + 2] = this.iconList[var6];
         }

         JDPSearchResults var11 = (JDPSearchResults)super.thisBranch.thisObject;
         var11.setMinWidth(Integer.parseInt(this.treeMinWidth.getText()));
         var11.setIcons(var5);
         var11.setFromWhereClause(this.targetLayoutMgr.gSource.createFromWhereClause(this.targetDSN, this.targetTable, this));
         var11.clearList(this.mainBranchText.getText());
         var11.loadList();
         if (var10 != null) {
            var10.add(super.thisBranch.compPosition, (Component)super.thisBranch.thisObject);
         }

         if (!this.targetLayoutMgr.projectLoading) {
            this.targetLayoutMgr.gSource.constructMethod(super.thisBranch, "Main");
            this.targetLayoutMgr.setButton("Layout");
            this.targetLayoutMgr.reDraw();
         }

         this.targetLayoutMgr.cMgr.updateProperties(0);
      }

   }

   void updateArrays1() {
      if (this.currentSelection1 >= 0) {
         this.iconList[this.currentSelection1] = this.iconlist.getSelectedIndex();
      }
   }

   void loadItem1(int var1) {
      this.iconlist.select(this.iconList[var1]);
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPListLayout" + super.componentName;
      var1.saveObject(this.columns, var2, "columns");
      var1.saveObject(this.useTree, var2, "useTree");
      var1.saveObject(this.columns1, var2, "columns1");
      var1.saveObject(this.includeTree, var2, "includeTree", 1);
      var1.saveObject(this.mainBranchText, var2, "mainBranchText");
      var1.saveObject(this.mainBranchIcon, var2, "mainBranchIcon");
      var1.saveObject(this.mainIcon, var2, "mainIcon");
      var1.saveObject(this.iconList, var2, "iconList");
      var1.saveObject(this.uniqueTree, var2, "uniqueTree");
      var1.saveObject(this.treeMinWidth, var2, "treeMinWidth");
      var1.saveObject(this.maxRows, var2, "maxRows");
      var1.saveObject(this.pcounttext, var2, "pcounttext");
      var1.saveObject(this.displayCount, var2, "displayCount");
      var1.saveObject(this.psortChoiceText, var2, "psortChoiceText");
      var1.saveObject(this.psortChoiceSql, var2, "psortChoiceSql");
      var1.saveObject(this.psortOrder, var2, "psortOrder");
      var1.saveObject(this.pinitChoice, var2, "pinitChoice");
      var1.saveObject(this.pfromwhereclause, var2, "pfromwhereclause");
      return true;
   }

   void refresh() {
      this.clearFields();
      this.currentSelection = -1;
      this.currentSelection1 = -1;
      this.retrieveColumns();
      this.loadList();
      this.restoreSelections();
   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.targetTable = (JDPSelectTable)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (var1.target.equals(this.uniqueTree)) {
                  super.user.u.cursor(this.psortchoicesql);
                  return true;
               }

               if (var1.target.equals(this.psortchoicesql)) {
                  super.user.u.cursor(this.useTree);
                  return true;
               }

               if (var1.target.equals(this.mainBranchText)) {
                  super.user.u.cursor(this.mainBranchIcon);
                  return true;
               }

               if (var1.target.equals(this.mainBranchIcon)) {
                  super.user.u.cursor(this.mainIcon);
                  return true;
               }

               if (var1.target.equals(this.mainIcon)) {
                  super.user.u.cursor(this.treeMinWidth);
                  return true;
               }

               if (var1.target.equals(this.treeMinWidth)) {
                  super.user.u.cursor(this.columns1);
                  return true;
               }

               if (var1.target.equals(this.columns1)) {
                  super.user.u.cursor(this.includeTree);
                  return true;
               }

               if (var1.target.equals(this.includeTree)) {
                  super.user.u.cursor(this.iconlist);
                  return true;
               }

               if (var1.target.equals(this.iconlist)) {
                  super.user.u.cursor(this.uniqueTree);
                  return true;
               }

               if (var1.target.equals(this.uniqueTree)) {
                  super.user.u.cursor(this.mainBranchText);
                  return true;
               }

               if (var1.target.equals(this.psortchoicetext)) {
                  super.user.u.cursor(this.psortorder);
                  return true;
               }

               if (var1.target.equals(this.psortorder)) {
                  super.user.u.cursor(this.pinitchoice);
                  return true;
               }

               if (var1.target.equals(this.pinitchoice)) {
                  super.user.u.cursor(this.psortchoicetext);
                  return true;
               }

               if (var1.target.equals(this.maxRows)) {
                  super.user.u.cursor(this.displayCount);
                  return true;
               }

               if (var1.target.equals(this.displayCount)) {
                  super.user.u.cursor(this.pcounttext);
                  return true;
               }

               if (var1.target.equals(this.pcounttext)) {
                  super.user.u.cursor(this.pfromwhereclause);
                  return true;
               }

               if (super.componentName.equals("")) {
                  if (var1.target.equals(this.pfromwhereclause)) {
                     super.user.u.cursor(this.maxRows);
                     return true;
                  }
               } else if (var1.target.equals(this.pfromwhereclause)) {
                  super.user.u.cursor(this.displayCount);
                  return true;
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
         case 702:
            if (var1.target instanceof JDPList) {
               if (var1.target.equals(this.columns)) {
                  this.updateArrays();
                  int var4 = (Integer)var1.arg;
                  this.loadItem(var4);
                  this.currentSelection = var4;
               }

               if (var1.target.equals(this.columns1)) {
                  this.updateArrays1();
                  if (this.columns1.getSelectedIndex() >= 0) {
                     this.includeTree.addItem(this.columns1.getSelectedItem());
                     this.columns1.delItem(this.columns1.getSelectedIndex());
                  }
               }

               if (var1.target.equals(this.includeTree)) {
                  this.updateArrays1();
                  int var5 = this.includeTree.getSelectedIndex();
                  this.loadItem1(var5);
                  this.currentSelection1 = var5;
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target instanceof TextField) {
               super.user.u.isnumeric(this.maxRows, super.user.mainmsg);
               super.user.u.isnumeric(this.treeMinWidth, super.user.mainmsg);
               return true;
            } else if (var1.target instanceof JDPComboBox) {
               if (var1.target.equals(this.pinitchoice)) {
                  if (this.pinitchoice.getSelectedItem().compareTo("Yes") == 0) {
                     this.pinitChoice = this.psortchoicetext.getText();
                  } else {
                     this.pinitChoice = "";
                  }
               }

               if (var1.target.equals(this.useTree)) {
               }

               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Accept") == 0) {
                     if (super.user.u.isnumeric(this.maxRows, super.user.mainmsg) && super.user.u.isnumeric(this.treeMinWidth, super.user.mainmsg)) {
                        if (this.useTree.getSelectedItem().equals("Tree Structure") && this.uniqueTree.getSelectedIndexes().length <= 0) {
                           super.user.mainmsg.setStatusMsg("You must select a unique key for branches in the tree", 10);
                           return true;
                        }

                        this.updateArrays();
                        this.updateArrays1();
                        this.saveSelections();
                        super.user.mainmsg.setStatusMsg("Selections accepted.", 5);
                        if (super.componentName.equals("")) {
                           super.user.jdpMenuPanel.loadNextTab();
                        } else {
                           this.tabPanel = JDPUtils.getTabPanel(this);
                           if (this.tabPanel != null) {
                              int var6 = this.tabPanel.getSelectedIndex();
                              this.tabPanel.loadNextTab();
                              if (var6 == this.tabPanel.getSelectedIndex()) {
                                 this.loadLayoutComponent();
                              }
                           }
                        }
                     }

                     return true;
                  }

                  if (var2.trim().compareTo("Reset") == 0) {
                     for(int var3 = 0; var3 < this.columns.countItems(); ++var3) {
                        this.columns.deselect(var3);
                     }

                     return true;
                  }

                  if (var2.trim().compareTo(">") == 0 && this.columns1.getSelectedIndex() >= 0) {
                     this.includeTree.addItem(this.columns1.getSelectedItem());
                     this.columns1.delItem(this.columns1.getSelectedIndex());
                  }

                  if (var2.trim().compareTo("<") == 0 && this.includeTree.getSelectedIndex() >= 0) {
                     this.columns1.addItem(this.includeTree.getSelectedItem());
                     this.includeTree.delItem(this.includeTree.getSelectedIndex());
                  }
               }

               return true;
            }
         default:
            return false;
      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPListLayout" + super.componentName;
      var1.removeObject(this.columns, var2, "columns");
      var1.removeObject(this.useTree, var2, "useTree");
      var1.removeObject(this.columns1, var2, "columns1");
      var1.removeObject(this.includeTree, var2, "includeTree");
      var1.removeObject(this.mainBranchText, var2, "mainBranchText");
      var1.removeObject(this.mainBranchIcon, var2, "mainBranchIcon");
      var1.removeObject(this.mainIcon, var2, "mainIcon");
      var1.removeObject(this.iconList, var2, "iconList");
      var1.removeObject(this.uniqueTree, var2, "uniqueTree");
      var1.removeObject(this.treeMinWidth, var2, "treeMinWidth");
      var1.removeObject(this.maxRows, var2, "maxRows");
      var1.removeObject(this.pcounttext, var2, "pcounttext");
      var1.removeObject(this.displayCount, var2, "displayCount");
      var1.removeObject(this.psortChoiceText, var2, "psortChoiceText");
      var1.removeObject(this.psortChoiceSql, var2, "psortChoiceSql");
      var1.removeObject(this.psortOrder, var2, "psortOrder");
      var1.removeObject(this.pinitChoice, var2, "pinitChoice");
      var1.removeObject(this.pfromwhereclause, var2, "pfromwhereclause");
      return true;
   }

   void loadItem(int var1) {
      this.psortchoicetext.setText(this.psortChoiceText[var1]);
      this.psortchoicesql.setText(this.psortChoiceSql[var1]);
      this.psortorder.select(this.psortOrder[var1]);
      if (this.pinitChoice.compareTo(this.psortChoiceText[var1]) == 0) {
         this.pinitchoice.select("Yes");
      } else {
         this.pinitchoice.select("No");
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.moduleParameter = var3;
      super.moduleName = "ListLayout";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
         this.moduleParameter = "";
         var3 = "";
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new BorderLayout());
      JDPScrollPanel var11 = new JDPScrollPanel();
      JDPScrollPanel var12 = new JDPScrollPanel();
      JDPScrollPanel var13 = new JDPScrollPanel();
      JDPScrollPanel var14 = new JDPScrollPanel();
      ((Container)var7).add("Center", new JDPChiselFramePanel(var1, "Result list style", var11, "North"));
      ((Container)var8).add("Center", new JDPChiselFramePanel(var1, "Define the format of the tree", var12, "North"));
      ((Container)var9).add("Center", new JDPChiselFramePanel(var1, "Define the order by pulldown", var13, "North"));
      ((Container)var10).add("Center", new JDPChiselFramePanel(var1, "General settings", var14, "North"));
      String[] var15 = new String[]{"Style", "Tree Definition", "Ordering", "General"};
      Panel[] var16 = new Panel[]{var7, var8, var9, var10};
      JDPTabSelectPanel var17 = new JDPTabSelectPanel(var1, var15, var16, "North");
      this.useTree = new JDPComboBox(var1, "", 15);
      this.useTree.setEditable(false);
      this.useTree.addItem("Tree Structure");
      this.useTree.addItem("List");
      this.columns1 = new JDPList(var1);
      this.columns1.setMinWidth(90);
      this.columns1.setMinHeight(80);
      this.includeTree = new JDPList(var1);
      this.includeTree.setMinWidth(90);
      this.includeTree.setMinHeight(80);
      this.mainBranchText = new TextField("", 30);
      this.mainBranchIcon = new JDPComboBox(var1, "", 15);
      this.mainBranchIcon.setEditable(false);
      this.mainIcon = new JDPComboBox(var1, "", 15);
      this.mainIcon.setEditable(false);
      this.iconlist = new JDPComboBox(var1, "", 10);
      this.iconlist.setEditable(false);
      String[] var18 = JDPTreePicker.getTreeIconList();

      for(int var19 = 0; var19 < var18.length; ++var19) {
         this.mainBranchIcon.addItem(var18[var19]);
         this.mainIcon.addItem(var18[var19]);
         this.iconlist.addItem(var18[var19]);
      }

      this.uniqueTree = new JDPList(var1);
      this.uniqueTree.allowMultipleSelections(true);
      this.uniqueTree.setMinWidth(90);
      this.uniqueTree.setMinHeight(80);
      this.treeMinWidth = new TextField("130", 7);
      this.maxRows = new TextField("100", 10);
      this.displayCount = new JDPComboBox(var1, "", 5);
      this.displayCount.setEditable(false);
      this.displayCount.addItem("Yes");
      this.displayCount.addItem("No");
      this.pcounttext = new TextField("Total Entries:", 15);
      this.psortchoicetext = new TextField("", 20);
      this.psortchoicesql = new TextField("", 20);
      this.psortorder = new JDPComboBox(var1, "", 15);
      this.psortorder.setEditable(false);
      this.psortorder.addItem("Ascending");
      this.psortorder.addItem("Descending");
      this.pinitchoice = new JDPComboBox(var1, "", 5);
      this.pinitchoice.setEditable(false);
      this.pinitchoice.addItem("Yes");
      this.pinitchoice.addItem("No");
      this.pfromwhereclause = new TextField("(1=1)", 30);
      ((Container)var11).add("Left", new JDPWrapLabel(var1, "Type of structure for results:"));
      ((Container)var11).add("Right", this.useTree);
      Panel var33 = new Panel();
      ((Container)var33).setLayout(new BorderLayout());
      ((Container)var33).add("Center", this.columns1);
      Panel var20 = new Panel();
      ((Container)var20).setLayout(new GridLayout(2, 1));
      ((Container)var20).add(new JDPButton("  >  "));
      ((Container)var20).add(new JDPButton("  <  "));
      Panel var21 = new Panel();
      ((Container)var21).setLayout(new BorderLayout());
      ((Container)var21).add("Center", this.includeTree);
      Panel var22 = new Panel();
      ((Container)var22).setLayout(new BorderLayout());
      ((Container)var22).add("North", this.iconlist);
      Panel var23 = new Panel();
      ((Container)var23).setLayout(new JDPLineLayout(1));
      ((Container)var23).add("Left", var33);
      ((Container)var23).add("Left", var20);
      ((Container)var23).add("Left", var21);
      ((Container)var23).add("Left", var22);
      JDPScrollPanel var24 = new JDPScrollPanel();
      ((Container)var24).add("Left", new JDPWrapLabel(var1, "Initial branch text:"));
      ((Container)var24).add("Right", this.mainBranchText);
      ((Container)var24).add("Left", new JDPWrapLabel(var1, "Initial branch icon:"));
      ((Container)var24).add("Right", this.mainBranchIcon);
      ((Container)var24).add("Left", new JDPWrapLabel(var1, "First branch icon:"));
      ((Container)var24).add("Right", this.mainIcon);
      ((Container)var24).add("Left", new JDPWrapLabel(var1, "Initial width of tree panel:"));
      ((Container)var24).add("Right", this.treeMinWidth);
      ((Container)var12).add("Left", var24);
      ((Container)var12).add("Left", new JDPWrapLabel(var1, "Select the branch structure of the tree and the icons:"));
      ((Container)var12).add("Left", var23);
      Panel var25 = new Panel();
      ((Container)var25).setLayout(new JDPLineLayout(3));
      ((Container)var25).add("Left", new JDPWrapLabel(var1, "Unique key for branch in tree:"));
      ((Container)var25).add("Right", this.uniqueTree);
      ((Container)var12).add("Left", var25);
      if (super.componentName.equals("")) {
         ((Container)var14).add("Left", new JDPWrapLabel(var1, "Maximum result rows:"));
         ((Container)var14).add("Right", this.maxRows);
      }

      ((Container)var14).add("Left", new JDPWrapLabel(var1, "Display a list count:"));
      ((Container)var14).add("Right", this.displayCount);
      ((Container)var14).add("Left", new JDPWrapLabel(var1, "List count text:"));
      ((Container)var14).add("Right", this.pcounttext);
      ((Container)var13).add("Left", new JDPWrapLabel(var1, "Sort pulldown text:"));
      ((Container)var13).add("Right", this.psortchoicetext);
      ((Container)var11).add("Left", new JDPWrapLabel(var1, "SQL Select:"));
      ((Container)var11).add("Right", this.psortchoicesql);
      ((Container)var13).add("Left", new JDPWrapLabel(var1, "Sort Order:"));
      ((Container)var13).add("Right", this.psortorder);
      ((Container)var13).add("Left", new JDPWrapLabel(var1, "Make this the initial choice:"));
      ((Container)var13).add("Right", this.pinitchoice);
      ((Container)var14).add("Left", new JDPWrapLabel(var1, "Special Where Clause:"));
      ((Container)var14).add("Right", this.pfromwhereclause);
      ((Container)var6).add("Center", var17);
      String[] var26 = new String[]{"Accept", "Reset"};
      int[] var27 = new int[]{5, 6};
      JDPButtons var28 = new JDPButtons(var1, var26, var27, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", var28);
      this.popuppanel.addComponent(var28.button[0], "Accept Selections", "Accept selections and proceed to next screen");
      this.popuppanel.addComponent(var28.button[1], "Reset Selections", "Reset selections back to default settings");
      ((Container)var4).add("Center", var6);
      this.columns = new JDPList(var1);
      this.columns.setSelectionsCheckboxes(true);
      this.columns.allowMultipleSelections(true);
      this.columns.setMinWidth(160);
      Panel var29 = new Panel();
      ((Container)var29).setLayout(new BorderLayout());
      ((Container)var29).add("Center", this.columns);
      ((Container)var4).add("West", var29);
      Panel var30 = new Panel();
      ((Container)var30).setLayout(new BorderLayout(4, 1));
      ((Container)var30).add("West", new Label("Columns:", 0));
      this.listCount = new Label("0      ", 0);
      Panel var31 = new Panel();
      ((Container)var31).setLayout(new BorderLayout(4, 1));
      ((Container)var31).add("West", this.listCount);
      ((Container)var31).add("Center", new Label(" ", 0));
      ((Container)var30).add("Center", var31);
      ((Container)var29).add("North", var30);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Select the columns by which to order your search results", var4, "North"));
      this.gParmObject = new Vector();
      this.gParmObject.addElement(super.moduleName + super.componentName);
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
