import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPMenuAddOption extends JDPClassLayout {
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPLayoutMgr targetLayoutMgr;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   String pfromWhereClause;
   JDPChoice menuname;
   Vector valuemenuname;
   TextField menunum;
   TextField menudesc;
   String appName;
   String systemOU = "";

   void loadChoices() {
      this.valuemenuname = new Vector();
      this.menuname.clear();
      if (super.user.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         new JDPLoadChoice(super.user, this.jaggSQL, this.menuname, "b.JDP:menuname", "b.JDP:menuname", "JDesignerPro System a, JDesignerPro Menu b", "a.JDP:JDPSystem = '" + super.user.JDPSystem + "'", this.valuemenuname);
      } else {
         new JDPLoadChoice(super.user, this.jaggSQL, this.menuname, "DISTINCT menuname", "menuname", "JDPMenu", "JDPSystem = '" + super.user.JDPSystem + "'", this.valuemenuname);
      }
   }

   void clearFields() {
      this.menuname.select("Main");
      this.menunum.setText("1");
      this.menudesc.setText(this.appName);
      this.menunum.selectAll();
      this.menunum.requestFocus();
   }

   void retrieveHandle() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
            this.appName = this.targetLayoutMgr.appName;
            this.menudesc.setText(this.targetLayoutMgr.appName);
            return;
         }
      }

   }

   boolean saveData() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.jaggSQL.getSEP();
      String var3 = "";
      if (super.user.JDesignerPro.NDSPath != null) {
         var3 = "INSERT INTO JDesignerPro Menu Option (OU, JDP:menunum,JDP:menutype,JDP:menuobject,JDP:menuparm,JDP:menudesc,Description,JDP:menustat,JDP:menutxtclr, " + "JDP:menutabclr,`ACL:[Entry Rights]`) " + "VALUES(" + this.menunum.getText() + this.menudesc.getText() + "," + this.menunum.getText() + "," + "'P','" + this.appName + "','', " + "'" + this.menudesc.getText() + "'," + "'" + this.menudesc.getText() + "'," + "'A'," + "'Black', " + "'LightGray', " + "'')" + " PARENT=" + this.systemOU + "\\" + (String)this.valuemenuname.elementAt(this.menuname.getSelectedIndex());
      } else {
         var3 = "INSERT INTO JDPMenu (JDPSystem,menuname, " + "menunum, " + "menudesc, " + "menutype, " + "menuobject, " + "menuparm, " + "menutxtclr, " + "menutabclr, " + "menustatus, " + "menuauth1, " + "menulvl1, " + "menuauth2, " + "menulvl2, " + "menuauth3, " + "menulvl3, " + "menuauth4, " + "menulvl4, " + "menuauth5, " + "menulvl5" + ") VALUES('" + super.user.JDPSystem + "','" + (String)this.valuemenuname.elementAt(this.menuname.getSelectedIndex()) + "', " + "" + this.menunum.getText() + ", " + "'" + super.user.u.replace(this.menudesc.getText(), "'", "''") + "', " + "'P', " + "'" + this.appName + "', " + "'','Black','LightGray','A','*ALL',0,'',0,'',0,'',0,'',0)";
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var1 = this.jaggSQL.execSQL(var3, var2);
      if (var1 == -1) {
         super.user.u.setSqlMessage(this.jaggSQL, var3);
         return false;
      } else {
         if (var1 == 1) {
            super.user.mainmsg.setStatusMsg("You must now exit JDesignerPro and log in again for the changes to take effect.", 20);
         } else {
            super.user.u.setSqlMessage(this.jaggSQL, var3);
         }

         this.insertRequested = false;
         return true;
      }
   }

   boolean checkFields() {
      Vector var1 = new Vector();
      if (!super.user.u.isfloat(this.menunum, super.user.mainmsg)) {
         return false;
      } else {
         String var2;
         if (super.user.JDesignerPro.NDSPath != null) {
            var2 = "SELECT JDP:menunum FROM JDesignerPro Menu Option " + "WHERE JDP:menunum = " + this.menunum.getText() + " PARENT=" + this.systemOU + "\\" + (String)this.valuemenuname.elementAt(this.menuname.getSelectedIndex());
         } else {
            var2 = "SELECT * FROM JDPMenu WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND menuname = '" + (String)this.valuemenuname.elementAt(this.menuname.getSelectedIndex()) + "' " + "AND menunum = " + this.menunum.getText();
         }

         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         int var3 = this.jaggSQL.execSQL(var2, var1);
         if (var3 > 0) {
            this.menunum.selectAll();
            this.menunum.requestFocus();
            super.user.mainmsg.setStatusMsg("A menu option with this number already exists.", 20);
            return false;
         } else {
            super.user.mainmsg.clearStatusMsg();
            return true;
         }
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               this.retrieveHandle();
               return false;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.menuname)) {
                     super.user.u.cursor(this.menunum);
                     return true;
                  }

                  if (var1.target.equals(this.menunum)) {
                     super.user.u.cursor(this.menudesc);
                     return true;
                  }

                  if (var1.target.equals(this.menudesc)) {
                     super.user.u.cursor(this.menuname);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.menunum)) {
                     super.user.u.cursor(this.menuname);
                     return true;
                  }

                  if (var1.target.equals(this.menudesc)) {
                     super.user.u.cursor(this.menunum);
                     return true;
                  }

                  if (var1.target.equals(this.menuname)) {
                     super.user.u.cursor(this.menudesc);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2.trim().compareTo("Add New Option") == 0) {
                  this.insertRequested = true;
                  if (this.checkFields()) {
                     this.saveData();
                  }

                  return true;
               }

               return true;
            } else if (var1.target instanceof JDPChoice) {
               return true;
            } else {
               if (var1.target instanceof TextField) {
                  this.checkFields();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   void loadSystemOU() {
      String var1 = "SELECT OU FROM JDesignerPro System WHERE JDP:JDPSystem = '" + super.user.JDPSystem + "'";
      Vector var2 = new Vector();
      this.jaggSQL.execSQL(var1, var2);
      StringTokenizer var3 = new StringTokenizer((String)var2.elementAt(0));
      this.systemOU = var3.nextToken(this.jaggSQL.getSEP()).trim();
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.setNULL("space");
      this.jaggSQL.setMRW("100");
      this.jaggSQL.loadSettings(var1);
      if (var1.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         this.loadSystemOU();
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      this.menuname = new JDPChoice();
      this.menunum = new TextField("", 12);
      this.menudesc = new TextField("", 32);
      this.loadChoices();
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Add to Menu:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "New option number:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Tab description:", Color.black));
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new JDPLineLayout(3));
      ((Container)var8).add("Left", this.menuname);
      ((Container)var7).add("Right", var8);
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new JDPLineLayout(3));
      ((Container)var9).add("Left", this.menunum);
      ((Container)var7).add("Right", var9);
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new JDPLineLayout(3));
      ((Container)var10).add("Left", this.menudesc);
      ((Container)var7).add("Right", var10);
      ((Container)var6).add("Center", var7);
      this.menuname.setForeground(Color.black);
      this.menunum.setForeground(Color.black);
      this.menudesc.setForeground(Color.black);
      this.popuppanel.addComponent(this.menuname, "Menu Name", "Name of the menu to which this new option will be added");
      this.popuppanel.addComponent(this.menunum, "Menu Option Number", "The option number for this new menu item");
      this.popuppanel.addComponent(this.menudesc, "Menu tab description", "Enter the description for the menu tab");
      if (var3.compareTo("Inquiry") == 0) {
         this.menunum.setEditable(false);
         this.menudesc.setEditable(false);
      } else {
         String[] var11 = new String[]{"Add New Option"};
         int[] var12 = new int[]{0};
         JDPButtons var13 = new JDPButtons(var1, var11, var12, JDPButtons.HORIZONTAL);
         ((Container)var6).add("South", var13);
         this.popuppanel.addComponent(var13.button[0], "Add option", "Add the new option to the menu");
      }

      ((Container)var4).add("Center", var6);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Add a new Menu Option", var4, "North"));
      ((Component)var2).paintAll(((Component)var2).getGraphics());
      this.retrieveHandle();
      var1.gParm.addElement(this);
      this.clearFields();
   }
}
