import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Window;
import java.util.StringTokenizer;

public class JDPMessageDialog extends JDPDialog {
   JDPUser user;
   Container parent;
   String title;
   String message;
   String[] buttons;
   int[] icons;
   int button = -1;
   // $FF: renamed from: b JDPButtons
   JDPButtons field_0;

   public String getButtonText(int var1) {
      return var1 < this.buttons.length ? this.buttons[var1] : null;
   }

   public int getPressedButton() {
      return this.button;
   }

   void createDialog(JDPUser var1, Container var2, String var3, String var4, String[] var5, int[] var6) {
      ((Container)this).removeAll();
      this.user = var1;
      this.parent = var2;
      this.title = var3;
      this.message = var4;
      this.buttons = var5;
      this.icons = var6;
      ((Dialog)this).setTitle(var3);
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout(20, 2));
      ((Container)this).add("Center", var7);
      StringTokenizer var8 = new StringTokenizer(var4, "\n|");
      if (var8.countTokens() > 1) {
         JDPScrollPanel var9 = new JDPScrollPanel();

         while(var8.hasMoreTokens()) {
            ((Container)var9).add("Left", new Label(var8.nextToken(), 1));
         }

         ((Container)var7).add("North", var9);
      } else {
         ((Container)var7).add("North", new Label(var4, 1));
      }

      if (var5 != null) {
         if (var6 != null && var6.length != 0 && var6[0] != -1) {
            this.field_0 = new JDPButtons(var1, var5, var6, JDPButtons.HORIZONTAL);
         } else {
            this.field_0 = new JDPButtons(var1, var5, JDPButtons.HORIZONTAL);
         }

         Panel var10 = new Panel();
         ((Container)var10).setLayout(new FlowLayout());
         ((Container)var10).add(this.field_0);
         ((Container)var7).add("South", var10);
      }

   }

   public void setButtonCount(int var1) {
      this.buttons = new String[var1];
      this.icons = new int[var1];

      for(int var2 = 0; var2 < var1; ++var2) {
         this.buttons[var2] = Integer.toString(var2);
         this.icons[var2] = -1;
      }

      this.title = ((Dialog)this).getTitle();
      this.createDialog(this.user, this.parent, this.title, this.message, this.buttons, this.icons);
   }

   public int getButtonCount() {
      return this.buttons.length;
   }

   public void setMessage(String var1) {
      this.message = var1;
      this.title = ((Dialog)this).getTitle();
      this.createDialog(this.user, this.parent, this.title, this.message, this.buttons, this.icons);
   }

   public void setButtonIcon(int var1, int var2) {
      if (var1 < this.icons.length) {
         this.icons[var1] = var2;
      }

      this.title = ((Dialog)this).getTitle();
      this.createDialog(this.user, this.parent, this.title, this.message, this.buttons, this.icons);
   }

   public int getButtonIcon(int var1) {
      return var1 < this.icons.length ? this.icons[var1] : -1;
   }

   public JDPMessageDialog(JDPUser var1, Container var2) {
      super(var1, "", var2);
      this.createDialog(var1, var2, "", "", (String[])null, (int[])null);
   }

   public JDPMessageDialog(JDPUser var1, Container var2, String var3, String var4, String[] var5) {
      super(var1, var3, var2);
      this.createDialog(var1, var2, var3, var4, var5, (int[])null);
   }

   public JDPMessageDialog(JDPUser var1, Container var2, String var3, String var4, String[] var5, int[] var6) {
      super(var1, var3, var2);
      this.createDialog(var1, var2, var3, var4, var5, var6);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 201:
            ((Window)this).dispose();
            return true;
         case 1001:
            if (var1.target instanceof JDPButton) {
               for(int var2 = 0; var2 < this.field_0.button.length; ++var2) {
                  if (var1.target.equals(this.field_0.button[var2])) {
                     this.button = var2;
                  }
               }

               ((Window)this).dispose();
            }

            return true;
         default:
            if (this.parent != null) {
               this.parent.handleEvent(var1);
            }

            return false;
      }
   }

   public void setButtonText(int var1, String var2) {
      if (var1 < this.buttons.length) {
         this.buttons[var1] = var2;
      }

      this.title = ((Dialog)this).getTitle();
      this.createDialog(this.user, this.parent, this.title, this.message, this.buttons, this.icons);
   }
}
