import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPMessageSvr extends JDPServerJob {
   public void runJob() {
      String var1 = (String)super.params.restoreObject("messageFunction", "");
      if (var1.equals("sendBulkMail")) {
         this.sendBulkMail();
      } else if (var1.equals("sendSingleMessage")) {
         this.sendSingleMessage();
      } else if (var1.equals("sendBulkAlphaPage")) {
         this.sendBulkAlphaPage();
      } else if (var1.equals("sendLoadedAlphaPages")) {
         this.sendLoadedAlphaPages();
      } else if (var1.equals("sendSingleAlphaPage")) {
         this.sendSingleAlphaPage();
      } else {
         super.user.mainmsg.setStatusMsg("Unsupported function: " + var1, 30);
      }
   }

   void sendSingleMessage() {
      String var1 = (String)super.params.restoreObject("mailServer", "");
      String var2 = (String)super.params.restoreObject("returnAddress", "");
      String var3 = (String)super.params.restoreObject("messageSubject", "");
      String var4 = (String)super.params.restoreObject("message", "");
      String var5 = (String)super.params.restoreObject("toAddress", "");
      String var6 = (String)super.params.restoreObject("attachment", "");
      if (var1 != null && !var1.equals("")) {
         if (var2 != null && !var2.equals("")) {
            if (var3 != null && !var3.equals("")) {
               if (var4 != null && !var4.equals("")) {
                  if (var5 != null && !var5.equals("")) {
                     if (var6 != null && var6.equals("")) {
                        var6 = "";
                     }

                     String[] var7 = new String[0];
                     Vector var8 = new Vector();
                     var8.addElement(var5);
                     this.sendMail(var1, var2, var3, var4, var7, var8, var6);
                     System.runFinalization();
                     System.gc();
                  } else {
                     this.paramReqd("toAddress");
                  }
               } else {
                  this.paramReqd("message");
               }
            } else {
               this.paramReqd("messageSubject");
            }
         } else {
            this.paramReqd("returnAddress");
         }
      } else {
         this.paramReqd("mailServer");
      }
   }

   void sendBulkMail() {
      String var1 = (String)super.params.restoreObject("mailServer", "");
      String var2 = (String)super.params.restoreObject("returnAddress", "");
      String var3 = (String)super.params.restoreObject("messageSubject", "");
      String var4 = (String)super.params.restoreObject("message", "");
      String var5 = (String)super.params.restoreObject("attachment", "");
      String var6 = (String)super.params.restoreObject("SQL", "");
      String var7 = (String)super.params.restoreObject("whereClause", "");
      String[] var8 = new String[0];
      var8 = (String[])super.params.restoreObject("columns", var8);
      if (var1 != null && !var1.equals("")) {
         if (var2 != null && !var2.equals("")) {
            if (var3 != null && !var3.equals("")) {
               if (var4 != null && !var4.equals("")) {
                  if (var6 == null) {
                     this.paramReqd("SQL");
                  } else if (var8 == null) {
                     this.paramReqd("columns");
                  } else {
                     if (var5 != null && var5.equals("")) {
                        var5 = "";
                     }

                     super.user.mainmsg.setStatusMsg("Extracting names from database...", 0);
                     Vector var9 = new Vector();
                     super.jaggSQL.execSQL(var6 + var7, var9);
                     this.sendMail(var1, var2, var3, var4, var8, var9, var5);
                     System.runFinalization();
                     System.gc();
                  }
               } else {
                  this.paramReqd("message");
               }
            } else {
               this.paramReqd("messageSubject");
            }
         } else {
            this.paramReqd("returnAddress");
         }
      } else {
         this.paramReqd("mailServer");
      }
   }

   void sendSingleAlphaPage() {
      int var1 = super.params.restoreObject("commPort", 0);
      int var2 = super.params.restoreObject("baudRate", 0);
      String var3 = (String)super.params.restoreObject("serviceProvider", "");
      String var4 = (String)super.params.restoreObject("pagerPINNumber", "");
      String var5 = (String)super.params.restoreObject("message", "");
      if (var1 == 0) {
         this.paramReqd("commPort");
      } else if (var2 == 0) {
         this.paramReqd("baudRate");
      } else if (var3 != null && !var3.equals("")) {
         if (var4 != null && !var4.equals("")) {
            if (var5 != null && !var5.equals("")) {
               this.sendAlphaPage(var1, var2, var3, var4, var5, (String[])null, (Vector)null, (String[][])null);
            } else {
               this.paramReqd("message");
            }
         } else {
            this.paramReqd("pagerPINNumber");
         }
      } else {
         this.paramReqd("serviceProvider");
      }
   }

   void sendLoadedAlphaPages() {
      int var1 = super.params.restoreObject("commPort", 0);
      int var2 = super.params.restoreObject("baudRate", 0);
      if (var1 == 0) {
         this.paramReqd("commPort");
      } else if (var2 == 0) {
         this.paramReqd("baudRate");
      } else {
         String[][] var3 = new String[1][1];
         var3 = (String[][])super.params.restoreObject("messageArray", var3);
         if (var3 == null) {
            this.paramReqd("messages");
         } else {
            this.sendAlphaPage(var1, var2, (String)null, (String)null, (String)null, (String[])null, (Vector)null, var3);
         }
      }
   }

   void sendBulkAlphaPage() {
      int var1 = super.params.restoreObject("commPort", 0);
      int var2 = super.params.restoreObject("baudRate", 0);
      String var3 = (String)super.params.restoreObject("message", "");
      String var4 = (String)super.params.restoreObject("SQL", "");
      String var5 = (String)super.params.restoreObject("whereClause", "");
      String[] var6 = new String[0];
      var6 = (String[])super.params.restoreObject("columns", var6);
      if (var1 == 0) {
         this.paramReqd("commPort");
      } else if (var2 == 0) {
         this.paramReqd("baudRate");
      } else if (var3 != null && !var3.equals("")) {
         if (var4 == null) {
            this.paramReqd("SQL");
         } else if (var6 == null) {
            this.paramReqd("columns");
         } else {
            super.user.mainmsg.setStatusMsg("Extracting names from database...", 0);
            Vector var7 = new Vector();
            super.jaggSQL.execSQL(var4 + var5, var7);
            this.sendAlphaPage(var1, var2, (String)null, (String)null, var3, var6, var7, (String[][])null);
         }
      } else {
         this.paramReqd("message");
      }
   }

   boolean sendMail(String var1, String var2, String var3, String var4, String[] var5, Vector var6, String var7) {
      int var9 = 0;
      int var10 = 0;
      String var11 = "";
      String var12 = "";
      int var13 = 0;
      int var14 = 0;
      JDPSendMail var8 = new JDPSendMail(var1);
      int var16 = var6.size();
      if (var16 > 1) {
         super.user.mainmsg.setStatusMsg("Preparing to send " + Integer.toString(var16) + " messages...", 10);
      } else {
         super.user.mainmsg.setStatusMsg("Preparing to send message...", 10);
      }

      for(int var17 = 0; var17 < var16; ++var17) {
         StringTokenizer var15 = new StringTokenizer((String)var6.elementAt(var17), "\u0003");
         String var18 = var15.nextToken().trim();
         if (var18.toUpperCase().equals(var12) && !var12.equals("")) {
            ++var10;
         } else {
            int var19 = var18.indexOf("@");
            if (var19 < 0) {
               super.user.mainmsg.setStatusMsg("Invalid Email address: " + var18, 10);
            } else {
               ++var9;
               var11 = this.mailInsert(var4, var15, var5);
               if (var14++ >= 99) {
                  super.user.mainmsg.setStatusMsg("Sending message " + Integer.toString(var9) + " of " + Integer.toString(var16) + "...", 0);
                  var14 = 0;
               }

               if (!var8.mailMessage(var18, var2, var3, var11, var7)) {
                  super.user.mainmsg.setStatusMsg(var8.result, 10);
                  ++var13;
               }
            }

            var12 = var18.toUpperCase();
         }
      }

      super.user.mainmsg.setStatusMsg(Integer.toString(var9 - var13) + " sent. " + Integer.toString(var13) + " not sent. " + Integer.toString(var10) + " duplicates.", 0);
      var8.closePort();
      return true;
   }

   boolean sendAlphaPage(int var1, int var2, String var3, String var4, String var5, String[] var6, Vector var7, String[][] var8) {
      String var9 = "pagingfile.txt ";
      String var10 = "Bin\\JDPAlphaPage ";
      var10 = var10 + var9 + " ";
      var10 = var10 + Integer.toString(var1) + " ";
      var10 = var10 + Integer.toString(var2);
      String var11 = "";
      String var12 = "";
      String var13 = "";
      String var14 = "";
      String var15 = "";
      Object var16 = null;
      int var17 = 0;
      int var18 = 0;
      if (var5 == null) {
         for(int var19 = 0; var19 < var8.length; ++var19) {
            var14 = var8[var19][0].trim();
            var15 = super.user.u.replace(var8[var19][1].trim(), " ", "");
            if (!var14.equals("") && !var15.equals("")) {
               ++var17;
               var11 = var11 + var14 + "\u0002" + var15 + "\u0002" + var8[var19][2] + "\u0001";
            }
         }
      } else if (var7 != null) {
         int var35 = var7.size();

         for(int var20 = 0; var20 < var35; ++var20) {
            StringTokenizer var34 = new StringTokenizer((String)var7.elementAt(var20), "\u0003");
            var14 = var34.nextToken().trim();
            var15 = super.user.u.replace(var34.nextToken().trim(), " ", "");
            var12 = var14 + "\u0002" + var15 + "\u0002";
            if (!var14.equals("") && !var15.equals("")) {
               if (!var12.toUpperCase().equals(var13) || var13.equals("")) {
                  var13 = var12.toUpperCase();
                  ++var17;
                  var12 = var12 + this.mailInsert(var5, var34, var6) + "\u0001";
                  var11 = var11 + var12;
               }
            } else {
               ++var18;
            }
         }
      } else {
         var14 = var3.trim();
         var15 = super.user.u.replace(var4.trim(), " ", "");
         if (!var14.equals("") && !var15.equals("")) {
            ++var17;
            var11 = var14 + "\u0002" + var15 + "\u0002" + var5 + "\u0001";
         }
      }

      if (var17 != 0 && !var11.equals("")) {
         try {
            FileOutputStream var36 = new FileOutputStream(var9);
            int var37 = var11.length();
            byte[] var21 = new byte[var37];
            var11.getBytes(0, var37, var21, 0);
            var36.write(var21);
            var36.close();
         } catch (Exception var22) {
            ((Throwable)var22).printStackTrace();
            return false;
         }

         if (var17 > 1) {
            super.user.mainmsg.setStatusMsg("Preparing to send " + Integer.toString(var17) + " messages.", 15);
         } else {
            super.user.mainmsg.setStatusMsg("Preparing to send 1 message.", 15);
         }

         this.execCommand(var10);
         return true;
      } else {
         return true;
      }
   }

   String mailInsert(String var1, StringTokenizer var2, String[] var3) {
      int var5 = var2.countTokens();

      for(int var7 = 0; var7 < var5; ++var7) {
         String var8 = var2.nextToken().trim();
         if (var3.length > var7 && var3[var7] != null) {
            int var6 = ("@" + var3[var7]).length();

            for(int var4 = var1.indexOf("@" + var3[var7]); var4 >= 0; var4 = var1.indexOf("@" + var3[var7], var4)) {
               var1 = var1.substring(0, var4) + var8 + var1.substring(var4 + var6);
            }
         }
      }

      return var1;
   }

   void paramReqd(String var1) {
      super.user.mainmsg.setStatusMsg("Required parameter not supplied: " + var1, 20);
   }

   int execCommand(String var1) {
      int var2 = 0;
      String[] var3 = new String[]{var1};
      Object var4 = null;
      Object var5 = null;
      char[] var6 = null;
      char[] var7 = var6;
      if (var6 == null) {
         var7 = var6 = new char[128];
      }

      int var8 = var7.length;
      int var9 = 0;
      boolean var10 = false;

      try {
         Runtime var11 = Runtime.getRuntime();
         Process var12 = var11.exec(var1);
         InputStream var15 = var12.getInputStream();
         InputStream var16 = var12.getErrorStream();
         var2 = var12.waitFor();
         if (var15 != null) {
            for(int var17 = var15.read(); var17 > -1; var17 = var15.read()) {
               --var8;
               if (var8 < 0) {
                  var7 = new char[var9 + 128];
                  var8 = var7.length - var9 - 1;
                  System.arraycopy(var6, 0, var7, 0, var9);
                  var6 = var7;
               }

               var7[var9++] = (char)var17;
            }

            if (var9 > 0) {
               super.user.mainmsg.setStatusMsg(String.copyValueOf(var7, 0, var9), 0);
               Thread.sleep(2L);
            }

            var15.close();
         }

         if (var16 != null) {
            for(int var18 = var16.read(); var18 > -1; var18 = var16.read()) {
               --var8;
               if (var8 < 0) {
                  var7 = new char[var9 + 128];
                  var8 = var7.length - var9 - 1;
                  System.arraycopy(var6, 0, var7, 0, var9);
                  var6 = var7;
               }

               var7[var9++] = (char)var18;
            }

            if (var9 > 0) {
               super.user.mainmsg.setStatusMsg(String.copyValueOf(var7, 0, var9), 0);
               Thread.sleep(2L);
            }

            var16.close();
         }

         var12.destroy();
      } catch (Exception var13) {
         super.user.mainmsg.setStatusMsg("Call to paging program failed. See JaggServer console.", 20);
         System.out.println("Call to paging program failed: " + var1);
         ((Throwable)var13).printStackTrace();
         var2 = -1;
      }

      return var2;
   }
}
