import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Panel;
import java.awt.Toolkit;
import java.awt.Window;

public class JDPPopupWindow extends Window {
   JDPUser user;
   Container targetPanel;
   Component listener;

   public void paint(Graphics var1) {
      this.update(var1);
   }

   public void setEventListener(Component var1) {
      this.listener = var1;
   }

   public Component getEventListener() {
      return this.listener;
   }

   public void update(Graphics var1) {
   }

   public JDPPopupWindow(JDPUser var1, Panel var2) {
      super(new Frame());
      this.user = var1;
      this.targetPanel = var2;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(((Component)var2).getFont());
      if (!JDPButton.activated) {
         System.out.println("Software Violation - this class may only be used in conjunction with JDesignerPro.");
      } else {
         ((Component)this).hide();
      }
   }

   public JDPPopupWindow(JDPUser var1, Container var2) {
      super(new Frame());
      this.user = var1;
      this.targetPanel = var2;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(((Component)var2).getFont());
      if (!JDPButton.activated) {
         System.out.println("Software Violation - this class may only be used in conjunction with JDesignerPro.");
      } else {
         ((Component)this).hide();
      }
   }

   public void display(int var1, int var2) {
      this.display(var1, var2, -1);
   }

   public void display(int var1, int var2, int var3) {
      ((Component)this).move(var1, var2);
      ((Window)this).show();
      int var4 = ((Container)this).preferredSize().height;
      int var5 = ((Container)this).preferredSize().width;
      Dimension var6 = Toolkit.getDefaultToolkit().getScreenSize();
      int var10000 = var1 + var5;
      int var7 = var2 + var4;
      if (var3 == -1) {
         while(var7 > var6.height) {
            var2 -= 5;
            var7 = var2 + var4;
         }
      } else if (var7 > var6.height - 30 || var6.height - 10 - var2 < 40) {
         var4 = var6.height - 30 - var2;
         if (var4 < 80) {
            var4 = ((Container)this).preferredSize().height;
            var2 = var3 - var4;
            if (var2 < 10) {
               var2 = 10;
               var4 = var3 - var2;
            }
         }
      }

      if (var1 < 0) {
         var1 = 0;
      }

      if (var2 < 0) {
         var2 = 0;
      }

      ((Component)this).reshape(var1, var2, var5, var4);
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   public boolean handleEvent(Event var1) {
      if (this.listener != null) {
         this.listener.postEvent(var1);
         return true;
      } else {
         return false;
      }
   }
}
