import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSQLSelector extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel3;
   Panel Panel1;
   JDPCardPanel CardPanel1;
   JDPSQLDelete Delete;
   JDPSQLInsert Insert;
   JDPSQLSelect Select;
   JDPSQLUpdate Update;
   JDPSQLStoredProc StoredProcedure;
   Panel Panel2;
   Label Label1;
   JDPChoice Choice1;
   Vector valueChoice1;
   JDPButtons JDPButtons1;
   boolean SQLOnly = false;
   String prevDSNString;
   JDPSelectDSN targetDSN;
   JDPList prevColumns;
   String prevTableString;
   String alphabet = "abcdefghijklmnopqrstuvwxyz";
   StringBuffer thisEntry;
   StringTokenizer stok;
   JDPInteractionMgr InteractionMgr;
   JDPSourceItem classHeader;
   Vector lastFunction;
   Vector lastResults;
   String prevDSNStringSP;
   String prevProcName;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Define the SQL Statement");
      this.Panel3 = new Panel();
      this.Panel1 = new Panel();
      this.CardPanel1 = new JDPCardPanel();
      this.Delete = new JDPSQLDelete();
      this.Delete.InitClass(var1, var2, var3);
      this.Insert = new JDPSQLInsert();
      this.Insert.InitClass(var1, var2, var3);
      this.Select = new JDPSQLSelect();
      this.Select.InitClass(var1, var2, var3);
      this.Update = new JDPSQLUpdate();
      this.Update.InitClass(var1, var2, var3);
      this.StoredProcedure = new JDPSQLStoredProc();
      this.StoredProcedure.InitClass(var1, var2, var3);
      this.Panel2 = new Panel();
      this.Label1 = new Label("Choose the type of SQL to perform:", 0);
      this.Choice1Main();
      String[] var4 = new String[]{"Done", "Run SQL", "Cancel"};
      int[] var5 = new int[]{JDPButton.getIconValue("Go"), JDPButton.getIconValue("Arrow"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel3);
      this.Panel3.setLayout(new BorderLayout());
      this.Panel3.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.CardPanel1);
      this.CardPanel1.add("Delete", this.Delete);
      this.CardPanel1.add("Insert", this.Insert);
      this.CardPanel1.add("Select", this.Select);
      this.CardPanel1.add("Update", this.Update);
      this.CardPanel1.add("StoredProcedure", this.StoredProcedure);
      this.Panel3.add("North", this.Panel2);
      this.Panel2.setLayout(new JDPLineLayout());
      this.Panel2.add("Left", this.Label1);
      this.Panel2.add("Left", this.Choice1);
      this.Panel3.add("South", this.JDPButtons1);
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target.equals(this.Delete)) {
               String var16 = this.Delete.whereColumns.getSelectedKey();
               if (var16 != null) {
                  var16 = var16.substring(var16.indexOf(":") + 1);
                  this.loadGlobalVarMethods(Integer.parseInt(var16), this.Delete.getWhereSettingsHandle());
               }

               return true;
            } else if (var1.target.equals(this.Insert)) {
               String var15 = (String)var1.arg;
               if (var15.equals("insertColumns")) {
                  String var34 = this.Insert.insertColumns.getSelectedKey();
                  if (var34 != null) {
                     var34 = var34.substring(var34.indexOf(":") + 1);
                     this.loadGlobalVarMethods(Integer.parseInt(var34), this.Insert.getInsertValueHandle());
                     String[] var40 = this.Insert.getSelectFromHandle().getSelectedItems();
                     this.loadColumnsFromTable(var40, Integer.parseInt(var34), this.Insert.getInsertValueHandle());
                  }
               } else if (var15.equals("whereColumns")) {
                  String var36 = this.Insert.whereColumns.getSelectedKey();
                  if (var36 != null) {
                     var36 = var36.substring(var36.indexOf(":") + 1);
                     this.loadGlobalVarMethods(Integer.parseInt(var36), this.Insert.getWhereSettingsHandle());
                     String[] var41 = this.Insert.getSelectFromHandle().getSelectedItems();
                     this.loadColumnsFromTable(var41, Integer.parseInt(var36), this.Insert.getWhereSettingsHandle());
                  }
               }

               ((Container)this).layout();
               ((Component)this).paintAll(((Component)this).getGraphics());
               return true;
            } else if (var1.target.equals(this.Select)) {
               String var14 = (String)var1.arg;
               if (var14.equals("selectColumns")) {
                  String var30 = this.Select.selectColumns.getSelectedKey();
                  if (var30 != null) {
                     var30 = var30.substring(var30.indexOf(":") + 1);
                     this.loadPlaceIntoVars(Integer.parseInt(var30), this.Select.getPlaceIntoHandle());
                  }
               } else if (var14.equals("whereColumns")) {
                  String var32 = this.Select.whereColumns.getSelectedKey();
                  if (var32 != null) {
                     var32 = var32.substring(var32.indexOf(":") + 1);
                     this.loadGlobalVarMethods(Integer.parseInt(var32), this.Select.getWhereSettingsHandle());
                     String[] var39 = this.Select.getSelectFromHandle().getSelectedItems();
                     this.loadColumnsFromTable(var39, Integer.parseInt(var32), this.Select.getWhereSettingsHandle());
                  }
               }

               ((Container)this).layout();
               ((Component)this).paintAll(((Component)this).getGraphics());
               return true;
            } else if (var1.target.equals(this.Update)) {
               String var13 = (String)var1.arg;
               if (var13.equals("updateColumns")) {
                  String var26 = this.Update.updateColumns.getSelectedKey();
                  if (var26 != null) {
                     var26 = var26.substring(var26.indexOf(":") + 1);
                     this.loadGlobalVarMethods(Integer.parseInt(var26), this.Update.getUpdateValueHandle());
                     String[] var4 = this.Update.getSelectFromHandle().getSelectedItems();
                     this.loadColumnsFromTable(var4, Integer.parseInt(var26), this.Update.getUpdateValueHandle());
                  }
               } else if (var13.equals("whereColumns")) {
                  String var28 = this.Update.whereColumns.getSelectedKey();
                  if (var28 != null) {
                     var28 = var28.substring(var28.indexOf(":") + 1);
                     this.loadGlobalVarMethods(Integer.parseInt(var28), this.Update.getWhereSettingsHandle());
                     String[] var38 = this.Update.getSelectFromHandle().getSelectedItems();
                     this.loadColumnsFromTable(var38, Integer.parseInt(var28), this.Update.getWhereSettingsHandle());
                  }
               }

               ((Container)this).layout();
               ((Component)this).paintAll(((Component)this).getGraphics());
               return true;
            } else {
               if (var1.target.equals(this.StoredProcedure)) {
                  String var12 = (String)var1.arg;
                  if (var12.equals("paramColumns")) {
                     String var22 = this.StoredProcedure.paramColumns.getSelectedKey();
                     if (var22 != null) {
                        var22 = var22.substring(var22.indexOf(":") + 1);
                        this.loadGlobalVarMethods(Integer.parseInt(var22), this.StoredProcedure.getParamSettingsHandle());
                     }
                  } else if (var12.equals("returnedColumns")) {
                     String var24 = this.StoredProcedure.returnedColumns.getSelectedKey();
                     if (var24 != null) {
                        var24 = var24.substring(var24.indexOf(":") + 1);
                        this.loadPlaceIntoVars(Integer.parseInt(var24), this.StoredProcedure.getPlaceIntoHandle());
                     }
                  }

                  ((Container)this).layout();
                  ((Component)this).paintAll(((Component)this).getGraphics());
                  return true;
               }

               return false;
            }
         case 1001:
            if (var1.target.equals(this.Delete)) {
               String[] var11 = new String[]{this.Delete.getTableHandle().getSelectedItem()};
               this.loadColumns(var11, this.Delete.getWhereColumnsHandle());
               return true;
            } else if (var1.target.equals(this.Insert)) {
               String var10 = (String)var1.arg;
               if (var10.equals("Tables")) {
                  String[] var20 = new String[]{this.Insert.getTableHandle().getSelectedItem()};
                  this.loadColumns(var20, this.Insert.getInsertColumnsHandle());
               } else if (var10.equals("SelectFrom")) {
                  String[] var21 = this.Insert.getSelectFromHandle().getSelectedItems();
                  this.loadColumns(var21, this.Insert.getWhereColumnsHandle());
               }

               return true;
            } else if (var1.target.equals(this.Select)) {
               String var9 = (String)var1.arg;
               if (var9.equals("SelectFrom")) {
                  String[] var19 = this.Select.getSelectFromHandle().getSelectedItems();
                  this.loadColumns(var19, this.Select.getSelectColumnsHandle());
                  this.loadColumns(var19, this.Select.getWhereColumnsHandle());
               }

               return true;
            } else if (var1.target.equals(this.Update)) {
               String var8 = (String)var1.arg;
               if (var8.equals("Tables")) {
                  String[] var18 = new String[]{this.Update.getTableHandle().getSelectedItem()};
                  this.loadColumns(var18, this.Update.getUpdateColumnsHandle());
                  this.loadColumns(var18, this.Update.getWhereColumnsHandle());
               }

               return true;
            } else if (var1.target.equals(this.StoredProcedure)) {
               String var7 = (String)var1.arg;
               if (var7.equals("StoredProcedures")) {
                  String var3 = this.StoredProcedure.getStoredProceduresHandle().getSelectedItem();
                  this.loadProcedureColumns(var3, this.StoredProcedure.getParamColumnsHandle(), this.StoredProcedure.getReturnedColumnsHandle());
               }

               return true;
            } else if (var1.target.equals(this.Choice1)) {
               this.CardPanel1.setSelectedComp(this.user.u.replace(this.Choice1.getSelectedKey(), " ", ""));
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[0])) {
               Event var6 = new Event(this, 1001, "SQLWizardDone");
               ((Container)this).deliverEvent(var6);
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               Event var5 = new Event(this, 1001, "SQLWizardRun");
               ((Container)this).deliverEvent(var5);
               return true;
            } else {
               if (var1.target.equals(this.JDPButtons1.button[2])) {
                  Event var2 = new Event(this, 1001, "SQLWizardCancel");
                  ((Container)this).deliverEvent(var2);
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
      this.CardPanel1.setSelectedComp(this.Choice1.getSelectedKey());
      this.lastFunction = new Vector();
      this.lastResults = new Vector();
   }

   void loadTables() {
      if (this.targetDSN != null) {
         String var1 = this.targetDSN.datasource.getText().trim() + this.targetDSN.userid.getText() + this.targetDSN.password.getText();
         if (this.prevDSNString == null || !var1.equals(this.prevDSNString)) {
            this.prevDSNString = var1;
            JDPList var2 = this.Delete.getTableHandle();
            JDPList var3 = this.Insert.getTableHandle();
            JDPList var4 = this.Insert.getSelectFromHandle();
            JDPList var5 = this.Select.getSelectFromHandle();
            JDPList var6 = this.Update.getTableHandle();
            JDPList var7 = this.Update.getSelectFromHandle();
            this.Delete.clear();
            this.Insert.clear();
            this.Select.clear();
            this.Update.clear();
            int var9 = 0;
            String var11 = this.jaggSQL.getSEP();
            int var12 = 0;
            String var14 = "";
            this.targetDSN.datasource.getText().trim();
            this.user.mainmsg.setStatusMsg("Loading Table definitions, please wait...", 0);
            this.jaggSQL.loadSettings(this.targetDSN);
            this.jaggSQL.setFCTN("SQLTables");
            this.jaggSQL.setMRW("100000");
            var12 = (boolean)1000;
            String[] var15 = new String[]{"TABLE", "VIEW"};

            for(int var16 = 0; var16 < var15.length; ++var16) {
               this.jaggSQL.setFCTNP(";;;" + var15[var16] + ";");
               Vector var10 = new Vector();
               var9 = this.jaggSQL.execSQL(var14, var10);
               if (var9 == -1) {
                  this.user.mainmsg.setStatusMsg("Could not connect to datasource. Please check the Connect String.", 20);
                  return;
               }

               this.jaggSQL.getColumnCount();
               var12 = this.jaggSQL.getRowCount();

               for(int var20 = 0; var20 < var12; ++var20) {
                  String var13 = (String)var10.elementAt(var20);
                  if (var13 != null && var13.trim().compareTo("") != 0) {
                     StringTokenizer var8 = new StringTokenizer(var13, var11);
                     var8.nextToken();
                     String var17 = var8.nextToken().trim();
                     String var18;
                     if (var17.length() > 0) {
                        var18 = var17 + "." + var8.nextToken().trim();
                     } else {
                        var18 = var8.nextToken().trim();
                     }

                     if (var18.indexOf(" ") >= 0) {
                        var18 = "`" + var18 + "`";
                     }

                     String var19 = var8.nextToken().trim();
                     if (var19.equals("TABLE") || var19.equals("VIEW")) {
                        var2.addItem(var18, 1);
                        var3.addItem(var18, 1);
                        var4.addItem(var18, 1);
                        var5.addItem(var18, 1);
                        var6.addItem(var18, 1);
                        var7.addItem(var18, 1);
                     }
                  }
               }
            }

            this.user.mainmsg.clearStatusMsg();
         }
      }
   }

   public void refresh() {
      this.loadTables();
      this.loadProcedures();
   }

   public void loadColumns(String[] var1, JDPList var2) {
      int var4 = 0;
      new Vector();
      String var6 = this.jaggSQL.getSEP();
      boolean var7 = false;
      String var9 = "";
      if (var1 != null && var1.length > 0) {
         int var10 = var1.length;
         String var11 = "";

         for(int var12 = 0; var12 < var1.length; ++var12) {
            var11 = var11 + var1[var12];
         }

         if (this.prevColumns == null || !this.prevColumns.equals(var2) || this.prevTableString == null || !var11.equals(this.prevTableString)) {
            this.user.mainmsg.setStatusMsg("Loading Column definitions, please wait...", 0);
            this.prevTableString = var11;
            this.prevColumns = var2;
            var2.clear();
            this.jaggSQL.loadSettings(this.targetDSN);
            this.jaggSQL.setFCTN("SQLColumns");
            this.jaggSQL.setMRW("100000");
            var7 = true;
            String var13 = "";
            String var14 = "";
            String var15 = "";
            String var16 = "";
            int var17 = 0;

            for(int var18 = 0; var18 < var10; ++var18) {
               String var19 = ";;" + var1[var18] + ";;";
               int var20 = var1[var18].indexOf(".");
               if (var20 >= 0) {
                  var19 = ";" + var1[var18].substring(0, var20) + ";" + var1[var18].substring(var20 + 1) + ";;";
               }

               this.jaggSQL.setFCTNP(var19);
               int var21 = this.lastFunction.indexOf(var19);
               Vector var5;
               if (var21 < 0) {
                  var5 = new Vector();
                  var4 = this.jaggSQL.execSQL(var9, var5);
                  this.lastFunction.addElement(var19);
                  this.lastResults.addElement(var5);
               } else {
                  var5 = (Vector)this.lastResults.elementAt(var21);
               }

               if (var4 == -1) {
                  this.user.u.setSqlMessage(this.jaggSQL, var9);
                  return;
               }

               this.jaggSQL.getColumnCount();

               for(int var22 = 0; var22 < var5.size(); ++var22) {
                  String var8 = (String)var5.elementAt(var22);
                  if (var8 != null && var8.trim().compareTo("") != 0) {
                     StringTokenizer var3 = new StringTokenizer(var8, var6);
                     if (var3.hasMoreTokens()) {
                        var13 = var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        var14 = var3.nextToken().trim();
                     }

                     if (var14.length() > 0) {
                        if (var3.hasMoreTokens()) {
                           (new StringBuffer(String.valueOf(var14))).append(".").append(var3.nextToken().trim()).toString();
                        }
                     } else if (var3.hasMoreTokens()) {
                        var15 = var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        String var10000 = var1[var18];
                     }

                     if (var3.hasMoreTokens()) {
                        var16 = var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        var17 = Integer.parseInt(var3.nextToken().trim());
                     }

                     if (var10 > 1) {
                        var16 = this.alphabet.substring(var18, var18 + 1) + "." + var16;
                     }

                     if (var16.indexOf(" ") > 0) {
                        var16 = "`" + var16 + "`";
                     }

                     if (var2.equals(this.Select.selectColumns)) {
                        var2.addItem(var16, "stok.nextToken():" + Integer.toString(var17), 15);
                     } else if (JDPUtils.isOdbcNum(var17)) {
                        var2.addItem(var16, "0:" + Integer.toString(var17), 15);
                     } else {
                        var2.addItem(var16, "' ':" + Integer.toString(var17), 15);
                     }
                  }
               }
            }

            this.user.mainmsg.clearStatusMsg();
         }
      }
   }

   public void loadGlobalVarMethods(int var1, JDPComboBox var2) {
      String var4 = var2.getText();
      var2.clear();
      if (JDPUtils.isOdbcNum(var1)) {
         var2.addItem("0");
      } else {
         var2.addItem("' '");
      }

      if (this.classHeader != null) {
         if (this.classHeader.components != null) {
            for(int var5 = 0; var5 < this.classHeader.components.size(); ++var5) {
               JDPSourceItem var3 = (JDPSourceItem)this.classHeader.components.elementAt(var5);
               if (var3.type == 3) {
                  if (var3.varType.equals("int") && JDPUtils.isOdbcNum(var1)) {
                     var2.addItem("\" + " + var3.name + " + \"");
                  } else if (var3.varType.equals("String") && JDPUtils.isOdbcChar(var1)) {
                     var2.addItem("'\" + " + var3.name + " + \"'");
                  } else {
                     this.loadMethodsForVar(var2, var3, var1);
                  }
               } else if (var3.type == 2) {
                  if (var3.returnType.equals("int") && JDPUtils.isOdbcNum(var1)) {
                     var2.addItem("\" + " + var3.name + " + \"");
                  } else if (var3.returnType.equals("String") && JDPUtils.isOdbcChar(var1)) {
                     var2.addItem("'\" + " + var3.name + " + \"'");
                  }
               }
            }
         }
      } else if (this.InteractionMgr != null) {
         this.InteractionMgr.loadMethodsForVisualApp(var2, var1);
      }

      var2.layoutChoice();
      var2.sortItems();
      var2.setText(var4);
   }

   public void loadMethodsForVar(JDPComboBox var1, JDPSourceItem var2, int var3) {
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      String var7 = this.jaggSQL.getSEP();
      String[] var8 = new String[]{var2.varType, var2.name, Integer.toString(5)};
      Vector var9 = this.InteractionMgr.getClassMethods(var8);

      for(int var10 = 0; var10 < var9.size(); ++var10) {
         Vector var11 = (Vector)var9.elementAt(var10);
         Vector var12 = (Vector)var11.elementAt(1);
         String var13 = "";

         for(int var14 = 0; var14 < var12.size(); ++var14) {
            var13 = (String)var12.elementAt(var14);
            if (!var13.equals(" ")) {
               this.stok = new StringTokenizer(var13, var7);
               this.stok.nextToken();
               this.stok.nextToken();
               String var5 = this.stok.nextToken();
               String var6 = this.stok.nextToken();
               String var4 = this.stok.nextToken();
               if (!this.stok.hasMoreTokens()) {
                  this.thisEntry.setLength(0);
                  if (var4.equals("int") && JDPUtils.isOdbcNum(var3)) {
                     this.thisEntry.append("\" + Integer.toString(" + var2.name + "." + var5 + "(");
                     this.thisEntry.append(")) + \"");
                     var1.addItem(this.thisEntry.toString());
                  } else if (var4.equals("long") && JDPUtils.isOdbcNum(var3)) {
                     this.thisEntry.append("\" + Long.toString(" + var2.name + "." + var5 + "(");
                     this.thisEntry.append(")) + \"");
                     var1.addItem(this.thisEntry.toString());
                  } else if (var4.equals("float") && JDPUtils.isOdbcNum(var3)) {
                     this.thisEntry.append("\" + Float.toString(" + var2.name + "." + var5 + "(");
                     this.thisEntry.append(")) + \"");
                     var1.addItem(this.thisEntry.toString());
                  } else if (var4.equals("java.lang.String") && JDPUtils.isOdbcChar(var3)) {
                     this.thisEntry.append("'\" + " + var2.name + "." + var5 + "(");
                     this.thisEntry.append(") + \"'");
                     var1.addItem(this.thisEntry.toString());
                  }
               }
            }
         }
      }

   }

   public void setInteractionMgr(JDPInteractionMgr var1) {
      this.InteractionMgr = var1;
   }

   public void setClassHeader(JDPSourceItem var1) {
      this.classHeader = var1;
   }

   public String getCompleteSource() {
      if (this.Choice1.getSelectedItem().equals("Select")) {
         return this.Select.constructSQL();
      } else if (this.Choice1.getSelectedItem().equals("Delete")) {
         return this.Delete.constructSQL();
      } else if (this.Choice1.getSelectedItem().equals("Insert")) {
         return this.Insert.constructSQL();
      } else if (this.Choice1.getSelectedItem().equals("Update")) {
         return this.Update.constructSQL();
      } else {
         return this.Choice1.getSelectedItem().equals("Stored Procedure") ? this.StoredProcedure.constructSQL() : "";
      }
   }

   public void loadColumnsFromTable(String[] var1, int var2, JDPComboBox var3) {
      int var5 = 0;
      new Vector();
      String var7 = this.jaggSQL.getSEP();
      String var9 = "";
      String var10 = var3.getText();
      if (var1 != null && var1.length > 0) {
         int var11 = var1.length;
         String var12 = "";

         for(int var13 = 0; var13 < var1.length; ++var13) {
            var12 = var12 + var1[var13];
         }

         if (((Component)this).isShowing()) {
            this.user.mainmsg.setStatusMsg("Loading Column definitions, please wait...", 0);
         }

         this.jaggSQL.loadSettings(this.targetDSN);
         this.jaggSQL.setFCTN("SQLColumns");
         this.jaggSQL.setMRW("100000");
         String var14 = "";
         String var15 = "";
         String var16 = "";
         String var17 = "";
         int var18 = 0;

         for(int var19 = 0; var19 < var11; ++var19) {
            String var20 = ";;" + var1[var19] + ";;";
            int var21 = var1[var19].indexOf(".");
            if (var21 >= 0) {
               var20 = ";" + var1[var19].substring(0, var21) + ";" + var1[var19].substring(var21 + 1) + ";;";
            }

            this.jaggSQL.setFCTNP(var20);
            int var22 = this.lastFunction.indexOf(var20);
            Vector var6;
            if (var22 < 0) {
               var6 = new Vector();
               var5 = this.jaggSQL.execSQL(var9, var6);
               this.lastFunction.addElement(var20);
               this.lastResults.addElement(var6);
            } else {
               var6 = (Vector)this.lastResults.elementAt(var22);
            }

            if (var5 == -1) {
               this.user.u.setSqlMessage(this.jaggSQL, var9);
               return;
            }

            this.jaggSQL.getColumnCount();

            for(int var23 = 0; var23 < var6.size(); ++var23) {
               String var8 = (String)var6.elementAt(var23);
               if (var8 != null && var8.trim().compareTo("") != 0) {
                  StringTokenizer var4 = new StringTokenizer(var8, var7);
                  if (var4.hasMoreTokens()) {
                     var14 = var4.nextToken().trim();
                  }

                  if (var4.hasMoreTokens()) {
                     var15 = var4.nextToken().trim();
                  }

                  if (var15.length() > 0) {
                     if (var4.hasMoreTokens()) {
                        (new StringBuffer(String.valueOf(var15))).append(".").append(var4.nextToken().trim()).toString();
                     }
                  } else if (var4.hasMoreTokens()) {
                     var16 = var4.nextToken().trim();
                  }

                  if (var4.hasMoreTokens()) {
                     String var10000 = var1[var19];
                  }

                  if (var4.hasMoreTokens()) {
                     var17 = var4.nextToken().trim();
                  }

                  if (var4.hasMoreTokens()) {
                     var18 = Integer.parseInt(var4.nextToken().trim());
                  }

                  if (var11 > 1 || var3.equals(this.Update.getUpdateValueHandle()) || var3.equals(this.Update.getWhereSettingsHandle())) {
                     var17 = this.alphabet.substring(var19, var19 + 1) + "." + var17;
                  }

                  if (var17.indexOf(" ") > 0) {
                     var17 = "`" + var17 + "`";
                  }

                  if (JDPUtils.isOdbcEqual(var18, var2)) {
                     var3.addItem(var17);
                  }
               }
            }
         }

         if (((Component)this).isShowing()) {
            this.user.mainmsg.clearStatusMsg();
         }

         var3.layoutChoice();
         var3.setText(var10);
      }
   }

   public void loadPlaceIntoVars(int var1, JDPComboBox var2) {
      String var4 = var2.getText();
      var2.clear();
      if (this.classHeader != null) {
         if (this.classHeader.components != null) {
            for(int var5 = 0; var5 < this.classHeader.components.size(); ++var5) {
               JDPSourceItem var3 = (JDPSourceItem)this.classHeader.components.elementAt(var5);
               if (var3.type == 3) {
                  if (var3.varType.equals("int") && JDPUtils.isOdbcNum(var1)) {
                     var2.addItem(var3.name + " = Integer.parseInt(stok.nextToken())");
                  } else if (var3.varType.equals("long") && JDPUtils.isOdbcNum(var1)) {
                     var2.addItem(var3.name + " = Long.valueOf(stok.nextToken()).longValue()");
                  } else if (var3.varType.equals("float") && JDPUtils.isOdbcNum(var1)) {
                     var2.addItem(var3.name + " = Float.valueOf(stok.nextToken()).floatValue()");
                  } else if (var3.varType.equals("String") && JDPUtils.isOdbcChar(var1)) {
                     var2.addItem(var3.name + " = stok.nextToken()");
                  } else {
                     this.loadSetMethods(var2, var3, var1);
                  }
               }
            }
         }
      } else if (this.InteractionMgr != null) {
         this.InteractionMgr.loadPlaceIntoForVisualApp(var2, var1);
      }

      var2.sortItems();
      var2.setText(var4);
   }

   public void loadSetMethods(JDPComboBox var1, JDPSourceItem var2, int var3) {
      if (this.thisEntry == null) {
         this.thisEntry = new StringBuffer();
      }

      String var7 = this.jaggSQL.getSEP();
      String[] var9 = new String[]{var2.varType, var2.name, Integer.toString(5)};
      Vector var10 = this.InteractionMgr.getClassMethods(var9);

      for(int var11 = 0; var11 < var10.size(); ++var11) {
         Vector var12 = (Vector)var10.elementAt(var11);
         Vector var13 = (Vector)var12.elementAt(1);
         String var14 = "";

         for(int var15 = 0; var15 < var13.size(); ++var15) {
            var14 = (String)var13.elementAt(var15);
            if (!var14.equals(" ")) {
               this.stok = new StringTokenizer(var14, var7);
               this.stok.nextToken();
               this.stok.nextToken();
               String var5 = this.stok.nextToken();
               String var6 = this.stok.nextToken();
               String var4 = this.stok.nextToken();
               if (this.stok.hasMoreTokens()) {
                  String var8 = this.stok.nextToken();
                  if (!this.stok.hasMoreTokens() && var5.startsWith("set")) {
                     if (var8.equals("int") && JDPUtils.isOdbcNum(var3)) {
                        this.thisEntry.setLength(0);
                        this.thisEntry.append(var2.name + "." + var5 + "(");
                        this.thisEntry.append("Integer.parseInt(stok.nextToken())");
                        this.thisEntry.append(")");
                        var1.addItem(this.thisEntry.toString());
                     } else if (var8.equals("long") && JDPUtils.isOdbcNum(var3)) {
                        this.thisEntry.setLength(0);
                        this.thisEntry.append(var2.name + "." + var5 + "(");
                        this.thisEntry.append("Long.valueOf(stok.nextToken()).longValue()");
                        this.thisEntry.append(")");
                        var1.addItem(this.thisEntry.toString());
                     } else if (var8.equals("float") && JDPUtils.isOdbcNum(var3)) {
                        this.thisEntry.setLength(0);
                        this.thisEntry.append(var2.name + "." + var5 + "(");
                        this.thisEntry.append("Float.valueOf(stok.nextToken()).floatValue()");
                        this.thisEntry.append(")");
                        var1.addItem(this.thisEntry.toString());
                     } else if (var8.equals("java.lang.String") && JDPUtils.isOdbcChar(var3)) {
                        this.thisEntry.setLength(0);
                        this.thisEntry.append(var2.name + "." + var5 + "(");
                        this.thisEntry.append("stok.nextToken()");
                        this.thisEntry.append(")");
                        var1.addItem(this.thisEntry.toString());
                     }
                  }
               }
            }
         }
      }

   }

   void loadProcedures() {
      if (this.targetDSN != null) {
         String var1 = this.targetDSN.datasource.getText().trim() + this.targetDSN.userid.getText() + this.targetDSN.password.getText();
         if (this.prevDSNStringSP == null || !var1.equals(this.prevDSNStringSP)) {
            this.prevDSNStringSP = var1;
            JDPList var2 = this.StoredProcedure.getStoredProceduresHandle();
            this.StoredProcedure.clear();
            int var4 = 0;
            String var6 = this.jaggSQL.getSEP();
            int var7 = 0;
            String var9 = "";
            this.targetDSN.datasource.getText().trim();
            this.user.mainmsg.setStatusMsg("Loading Stored Procedure definitions, please wait...", 0);
            this.jaggSQL.loadSettings(this.targetDSN);
            this.jaggSQL.setFCTN("getProcedures");
            this.jaggSQL.setMRW("100000");
            var7 = (boolean)1000;
            this.jaggSQL.setFCTNP(";;;");
            Vector var5 = new Vector();
            var4 = this.jaggSQL.execSQL(var9, var5);
            if (var4 == -1) {
               this.user.mainmsg.setStatusMsg("Could not connect to datasource. Please check the Connect String.", 20);
            } else {
               this.jaggSQL.getColumnCount();
               var7 = this.jaggSQL.getRowCount();

               for(int var13 = 0; var13 < var7; ++var13) {
                  String var8 = (String)var5.elementAt(var13);
                  if (var8 != null && var8.trim().compareTo("") != 0) {
                     StringTokenizer var3 = new StringTokenizer(var8, var6);
                     var3.nextToken();
                     String var10 = var3.nextToken().trim();
                     String var11;
                     if (var10.length() > 0) {
                        var11 = var10 + "." + var3.nextToken().trim();
                     } else {
                        var11 = var3.nextToken().trim();
                     }

                     int var14 = var11.indexOf(";");
                     if (var14 > 0) {
                        var11 = var11.substring(0, var14);
                     }

                     if (var11.indexOf(" ") >= 0) {
                        var11 = "`" + var11 + "`";
                     }

                     if (var3.hasMoreTokens()) {
                        var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        var3.nextToken().trim();
                     }

                     if (var3.hasMoreTokens()) {
                        int var12 = Integer.parseInt(var3.nextToken().trim());
                     }

                     var2.addItem(var11, 1);
                  }
               }

               this.user.mainmsg.clearStatusMsg();
            }
         }
      }
   }

   public void loadProcedureColumns(String var1, JDPList var2, JDPList var3) {
      int var5 = 0;
      new Vector();
      String var7 = this.jaggSQL.getSEP();
      String var9 = "";
      if (var1 != null) {
         if (this.prevProcName == null || !var1.equals(this.prevProcName)) {
            this.user.mainmsg.setStatusMsg("Loading Procedure definition, please wait...", 0);
            this.prevProcName = var1;
            var2.clear();
            var3.clear();
            this.jaggSQL.loadSettings(this.targetDSN);
            this.jaggSQL.setFCTN("getProcedureColumns");
            this.jaggSQL.setMRW("100000");
            String var10 = ";;" + var1 + ";;";
            int var11 = var1.indexOf(".");
            if (var11 >= 0) {
               var10 = ";" + var1.substring(0, var11) + ";" + var1.substring(var11 + 1) + ";;";
            }

            this.jaggSQL.setFCTNP(var10);
            Vector var6 = new Vector();
            var5 = this.jaggSQL.execSQL(var9, var6);
            if (var5 == -1) {
               this.user.u.setSqlMessage(this.jaggSQL, var9);
            } else {
               this.jaggSQL.getColumnCount();
               String var12 = "";
               String var13 = "";
               String var14 = "";
               int var15 = 0;
               int var16 = 0;

               for(int var17 = 0; var17 < var5; ++var17) {
                  String var8 = (String)var6.elementAt(var17);
                  if (var8 != null && var8.trim().compareTo("") != 0) {
                     StringTokenizer var4 = new StringTokenizer(var8, var7);
                     var4.nextToken();
                     if (var4.hasMoreTokens()) {
                        var12 = var4.nextToken().trim();
                     }

                     if (var12.length() > 0) {
                        if (var4.hasMoreTokens()) {
                           (new StringBuffer(String.valueOf(var12))).append(".").append(var4.nextToken().trim()).toString();
                        }
                     } else if (var4.hasMoreTokens()) {
                        var13 = var4.nextToken().trim();
                     }

                     if (var4.hasMoreTokens()) {
                        var14 = var4.nextToken().trim();
                     }

                     if (var4.hasMoreTokens()) {
                        var15 = Integer.parseInt(var4.nextToken().trim());
                     }

                     if (var4.hasMoreTokens()) {
                        var16 = Integer.parseInt(var4.nextToken().trim());
                     }

                     if (var15 == 1) {
                        if (JDPUtils.isOdbcNum(var16)) {
                           var2.addItem(var14, "0:" + Integer.toString(var16), 15);
                        } else {
                           var2.addItem(var14, "' ':" + Integer.toString(var16), 15);
                        }
                     }

                     if (var15 == 2 || var15 == 4) {
                        if (JDPUtils.isOdbcNum(var16)) {
                           var3.addItem(var14, "stok.nextToken():" + Integer.toString(var16), 15);
                        } else {
                           var3.addItem(var14, "stok.nextToken():" + Integer.toString(var16), 15);
                        }
                     }
                  }
               }

               this.user.mainmsg.clearStatusMsg();
            }
         }
      }
   }

   public void setSQLOnly(boolean var1) {
      this.SQLOnly = var1;
      this.Delete.setSQLOnly(var1);
      this.Insert.setSQLOnly(var1);
      this.Select.setSQLOnly(var1);
      this.Update.setSQLOnly(var1);
      this.StoredProcedure.setSQLOnly(var1);
   }

   public String getSQL() {
      if (this.Choice1.getSelectedItem().equals("Select")) {
         return this.Select.getSQL();
      } else if (this.Choice1.getSelectedItem().equals("Delete")) {
         return this.Delete.getSQL();
      } else if (this.Choice1.getSelectedItem().equals("Insert")) {
         return this.Insert.getSQL();
      } else if (this.Choice1.getSelectedItem().equals("Update")) {
         return this.Update.getSQL();
      } else {
         return this.Choice1.getSelectedItem().equals("Stored Procedure") ? this.StoredProcedure.getSQL() : "";
      }
   }

   public void Choice1Main() {
      if (this.Choice1 == null) {
         this.Choice1 = new JDPChoice();
      }

      String[] var1 = new String[]{"Select", "Insert", "Update", "Delete", "Stored Procedure", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      String[] var2 = new String[]{"Select", "Insert", "Update", "Delete", "StoredProcedure", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.Choice1.loadChoice(var1, var2);
   }
}
