import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSQLWizard extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPTabSelectPanel TabPanel1;
   JDPSelectDSN JDPSelectDSN1;
   JDPSQLSelector JDPSQLSelector1;
   Panel Panel1;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel2;
   JDPButtons JDPButtons1;
   Panel Panel4;
   Label Label1;
   TextField sqlReturnValue;
   JDPTextGrid GridPanel1;
   boolean SQLOnly = false;
   boolean warningDisplayed = false;
   JDPLayoutMgr LayoutMgr;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      String[] var4 = new String[3];
      Panel[] var5 = new Panel[]{new Panel(), null, null};
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Select Database";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "Define SQL Statement";
      var5[2] = new Panel();
      var5[2].setLayout(new BorderLayout());
      var4[2] = "Show SQL Results";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.JDPSelectDSN1 = new JDPSelectDSN();
      this.JDPSelectDSN1.InitClass(var1, var2, var3);
      this.JDPSQLSelector1 = new JDPSQLSelector();
      this.JDPSQLSelector1.InitClass(var1, var2, var3);
      this.Panel1 = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "SQL Results");
      this.Panel2 = new Panel();
      String[] var6 = new String[]{"Back", "Cancel"};
      int[] var7 = new int[]{JDPButton.getIconValue("Undo"), JDPButton.getIconValue("Delete")};
      this.JDPButtons1 = new JDPButtons(var1, var6, var7, JDPButtons.getAlignmentValue("Horizontal"));
      this.Panel4 = new Panel();
      this.Label1 = new Label("SQL Return Value:", 0);
      this.sqlReturnValue = new TextField("", 20);
      this.GridPanel1 = new JDPTextGrid(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.TabPanel1);
      var5[0].add("Center", this.JDPSelectDSN1);
      var5[1].add("Center", this.JDPSQLSelector1);
      var5[2].add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("South", this.JDPButtons1);
      this.Panel2.add("North", this.Panel4);
      this.Panel4.setLayout(new JDPLineLayout());
      this.Panel4.add("Left", this.Label1);
      this.Panel4.add("Left", this.sqlReturnValue);
      this.Panel2.add("Center", this.GridPanel1);
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(1, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(2, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPSQLSelector1)) {
               String var4 = (String)var1.arg;
               if (!var4.equals("SQLWizardRun")) {
                  return !var4.equals("SQLWizardDone") && !var4.equals("SQLWizardCancel");
               } else {
                  String var3 = "Caution, all SQLs are run without the chance of rollback. Press again to confirm.";
                  if (!this.warningDisplayed && !this.user.mainmsg.getStatusMsg().equals(var3)) {
                     this.warningDisplayed = true;
                     this.user.mainmsg.setStatusMsg(var3, 25);
                  } else {
                     this.runSQL(this.JDPSQLSelector1.getSQL());
                  }

                  return true;
               }
            } else if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.TabPanel1.select(1);
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               this.TabPanel1.select(1);
               Event var2 = new Event(this.JDPSQLSelector1, 1001, "SQLWizardCancel");
               ((Component)this).postEvent(var2);
               return true;
            } else {
               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
      this.JDPSelectDSN1.setComponentName("Wizard");
      this.JDPSQLSelector1.targetDSN = this.JDPSelectDSN1;
      if (this.moduleParameter.equals("SQLOnly")) {
         this.SQLOnly = true;
         this.JDPSQLSelector1.setSQLOnly(true);
      }

   }

   public void setInteractionMgr(JDPInteractionMgr var1) {
      this.JDPSQLSelector1.setInteractionMgr(var1);
   }

   public void setClassHeader(JDPSourceItem var1) {
      this.JDPSQLSelector1.setClassHeader(var1);
   }

   public String getCompleteSource(String var1) {
      return this.JDPSelectDSN1.jdbcdirect.getText().equals("No") ? this.getCompleteNonDirect(var1) : this.getCompleteDirect(var1);
   }

   public void setLayoutMgr(JDPLayoutMgr var1) {
      this.LayoutMgr = var1;
   }

   public String getFunction() {
      return this.JDPSQLSelector1.Choice1.getSelectedKey();
   }

   public String getCompleteNonDirect(String var1) {
      StringBuffer var2 = new StringBuffer();
      var2.append(this.LayoutMgr.gSource.createJaggPrefs(this.JDPSelectDSN1, var1));
      var2.append("\n");
      var2.append(var1);
      var2.append("Vector results = new Vector();\n");
      var2.append(var1);
      var2.append("String SQL = ");
      var2.append(this.user.u.replace(this.JDPSQLSelector1.getCompleteSource(), "\n", "\n" + var1 + "\t\t"));
      var2.append(";\n");
      var2.append(var1);
      var2.append("int returnVal = jaggSQL.execSQL(SQL, results);");
      if (this.getFunction().equals("Select")) {
         var2.append("\n\n");
         var2.append(var1);
         var2.append("StringTokenizer stok;\n");
         var2.append(var1);
         var2.append("for (int ix=0; ix<results.size(); ix++) {\n");
         var2.append(var1);
         var2.append("\tstok = new StringTokenizer((String)results.elementAt(ix),jaggSQL.getSEP());\n");
         int[] var3 = this.JDPSQLSelector1.Select.selectColumns.getSelectedIndexes();

         for(int var4 = 0; var4 < var3.length; ++var4) {
            var2.append(var1 + "\t");
            String var5 = this.JDPSQLSelector1.Select.selectColumns.getItemKey(var3[var4]);
            var5 = var5.substring(0, var5.indexOf(":"));
            var2.append(var5);
            var2.append(";\n");
         }

         var2.append(var1);
         var2.append("}");
      }

      if (this.getFunction().equals("StoredProcedure")) {
         var2.append("\n\n");
         var2.append(var1);
         var2.append("StringTokenizer stok;\n");
         var2.append(var1);
         var2.append("for (int ix=0; ix<results.size(); ix++) {\n");
         var2.append(var1);
         var2.append("\tstok = new StringTokenizer((String)results.elementAt(ix),jaggSQL.getSEP());\n");

         for(int var6 = 0; var6 < this.JDPSQLSelector1.StoredProcedure.returnedColumns.countItems(); ++var6) {
            var2.append(var1 + "\t");
            String var7 = this.JDPSQLSelector1.StoredProcedure.returnedColumns.getItemKey(var6);
            var7 = var7.substring(0, var7.indexOf(":"));
            var2.append(var7);
            var2.append(";\n");
         }

         var2.append(var1);
         var2.append("}");
      }

      return var2.toString();
   }

   public String getCompleteDirect(String var1) {
      StringBuffer var2 = new StringBuffer();
      var2.append(var1);
      var2.append("JDPJdbcDirect jdbcDirect = new JDPJdbcDirect();\n");
      var2.append(var1);
      var2.append("jdbcDirect.setJdbcDriver(\"" + this.JDPSelectDSN1.jdbcdriver.getText() + "\");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setJdbcPrefix(\"" + this.JDPSelectDSN1.jdbcprefix.getText() + "\");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setJdbcSuffix(\"" + this.JDPSelectDSN1.jdbcsuffix.getText() + "\");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setUID(\"" + this.JDPSelectDSN1.userid.getText() + "\");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setPWD(\"" + this.JDPSelectDSN1.password.getText() + "\");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setCSTR(\"" + this.JDPSelectDSN1.connectstring.getText() + "\");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setMaxRows(" + this.JDPSelectDSN1.maxRows.getText() + ");\n");
      var2.append(var1);
      var2.append("jdbcDirect.setTimeOut(" + this.JDPSelectDSN1.timeOut.getText() + ");\n");
      var2.append(var1);
      var2.append("Vector results = new Vector();\n");
      var2.append(var1);
      var2.append("int returnVal = -1;\n");
      var2.append(var1);
      var2.append("try {\n");
      var2.append(var1 + "\t");
      var2.append("java.sql.Connection con = jdbcDirect.connect();\n");
      var2.append(var1 + "\t");
      var2.append("con.setAutoCommit(false);\n");
      var2.append(var1 + "\t");
      var2.append("String SQL = ");
      var2.append(this.user.u.replace(this.JDPSQLSelector1.getCompleteSource(), "\n", "\n" + var1 + "\t\t"));
      var2.append(";\n");
      var2.append(var1 + "\t");
      var2.append("returnVal = jdbcDirect.execute(SQL, results);\n");
      var2.append(var1 + "\t");
      var2.append("con.commit();\n");
      var2.append(var1);
      var2.append("} catch (Exception e) {\n");
      var2.append(var1);
      var2.append("}\n");
      if (this.getFunction().equals("Select")) {
         var2.append("\n\n");
         var2.append(var1);
         var2.append("StringTokenizer stok;\n");
         var2.append(var1);
         var2.append("for (int ix=0; ix<results.size(); ix++) {\n");
         var2.append(var1);
         var2.append("\tstok = new StringTokenizer((String)results.elementAt(ix),jaggSQL.getSEP());\n");
         int[] var3 = this.JDPSQLSelector1.Select.selectColumns.getSelectedIndexes();

         for(int var4 = 0; var4 < var3.length; ++var4) {
            var2.append(var1 + "\t");
            String var5 = this.JDPSQLSelector1.Select.selectColumns.getItemKey(var3[var4]);
            var5 = var5.substring(0, var5.indexOf(":"));
            var2.append(var5);
            var2.append(";\n");
         }

         var2.append(var1);
         var2.append("}");
      }

      if (this.getFunction().equals("StoredProcedure")) {
         var2.append("\n\n");
         var2.append(var1);
         var2.append("StringTokenizer stok;\n");
         var2.append(var1);
         var2.append("for (int ix=0; ix<results.size(); ix++) {\n");
         var2.append(var1);
         var2.append("\tstok = new StringTokenizer((String)results.elementAt(ix),jaggSQL.getSEP());\n");

         for(int var6 = 0; var6 < this.JDPSQLSelector1.StoredProcedure.returnedColumns.countItems(); ++var6) {
            var2.append(var1 + "\t");
            String var7 = this.JDPSQLSelector1.StoredProcedure.returnedColumns.getItemKey(var6);
            var7 = var7.substring(0, var7.indexOf(":"));
            var2.append(var7);
            var2.append(";\n");
         }

         var2.append(var1);
         var2.append("}");
      }

      return var2.toString();
   }

   public void runSQL(String var1) {
      JDPTextGrid var2 = this.GridPanel1;
      int var4 = 0;
      Vector var5 = new Vector();
      String var6 = this.jaggSQL.getSEP();
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      this.jaggSQL.loadSettings(this.JDPSelectDSN1);
      var4 = this.jaggSQL.execSQL(var1, var5);
      this.sqlReturnValue.setText(Integer.toString(var4));
      if (var4 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var1);
         var2.currentText = new String[50][50];
         var2.newTable();
      } else {
         this.TabPanel1.select(2);
         int var8 = this.jaggSQL.getColumnCount();
         var2.totalDataRows = this.jaggSQL.getRowCount();
         int var9 = this.jaggSQL.getRowCount();
         var2.currentText = new String[var8][var9];

         for(int var11 = 0; var11 < var9; ++var11) {
            String var7 = (String)var5.elementAt(var11);
            if (var7 != null && var7.trim().compareTo("") != 0) {
               StringTokenizer var3 = new StringTokenizer(var7, var6);

               for(int var12 = 0; var12 < var8; ++var12) {
                  String var10 = var3.nextToken().trim();
                  var2.currentText[var12][var11] = var10;
               }
            }
         }

         var2.newTable();
         this.user.mainmsg.clearStatusMsg();
      }
   }
}
