import java.awt.Choice;
import java.awt.Color;
import java.awt.List;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.TextField;
import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.StringBufferInputStream;
import java.util.Properties;
import java.util.Vector;

public class JDPSaveProps {
   JDPUser user;
   // $FF: renamed from: p java.util.Properties
   Properties field_0;
   String saveVal;
   String restoreVal;
   int nextIndex = 1;
   int fileSize;

   public boolean saveObject(String var1, Object var2) {
      return this.saveObject(var2, "", var1, 0);
   }

   public boolean saveObject(Object var1, String var2, String var3) {
      return this.saveObject(var1, var2, var3, 0);
   }

   public boolean saveObject(int var1, String var2, String var3, int var4) {
      return this.saveObject(new Integer(var1), var2, var3, var4);
   }

   public boolean saveObject(String var1, int var2) {
      return this.saveObject(new Integer(var2), "", var1, 0);
   }

   public int getFileSize() {
      return this.fileSize;
   }

   public boolean saveObject(boolean var1, String var2, String var3, int var4) {
      return this.saveObject(new Boolean(var1), var2, var3, var4);
   }

   public boolean saveObject(String var1, boolean var2) {
      return this.saveObject(new Boolean(var2), "", var1, 0);
   }

   public Object removeObject(Object var1, String var2, String var3) {
      if (this.field_0 == null) {
         return var1;
      } else {
         this.restoreVal = "";
         String var4 = var2 + "|" + var3;
         if (var4.indexOf(" ") > 0) {
            var4 = this.user.u.replace(var4, " ", "");
         }

         String var5 = (String)this.field_0.remove(var4);
         if (var5 == null) {
            try {
               Integer.parseInt(var2);
               this.field_0.remove(var2);
               var5 = var4;
            } catch (Exception var11) {
            }
         }

         if (var5 == null) {
            return null;
         } else if (var1 instanceof TextField) {
            return this.field_0.remove(var5);
         } else if (var1 instanceof JDPComboBox) {
            return this.field_0.remove(var5);
         } else if (var1 instanceof Choice) {
            return this.field_0.remove(var5);
         } else if (var1 instanceof JDPChoice) {
            return this.field_0.remove(var5);
         } else if (!(var1 instanceof List) && !(var1 instanceof JDPList)) {
            if (var1 instanceof TextArea) {
               return this.field_0.remove(var5);
            } else if (var1 instanceof String) {
               return this.field_0.remove(var5);
            } else if (var1 instanceof String[]) {
               String var20 = (String)this.field_0.remove(var5 + "|x");
               if (var20 == null) {
                  return null;
               } else {
                  int var28 = Integer.parseInt(var20);

                  for(int var38 = 0; var38 < var28 && this.field_0.remove(var5 + "|" + Integer.toString(var38)) != null; ++var38) {
                  }

                  return null;
               }
            } else if (var1 instanceof String[][]) {
               String var18 = (String)this.field_0.remove(var5 + "|x");
               if (var18 == null) {
                  return null;
               } else {
                  int var27 = Integer.parseInt(var18);
                  var18 = (String)this.field_0.remove(var5 + "|y");
                  if (var18 == null) {
                     return null;
                  } else {
                     int var37 = Integer.parseInt(var18);
                     boolean var44 = false;
                     boolean var49 = false;

                     for(int var45 = 0; var45 < var27; ++var45) {
                        for(int var50 = 0; var50 < var37 && this.field_0.remove(var5 + "|" + Integer.toString(var45) + "|" + Integer.toString(var50)) != null; ++var50) {
                        }
                     }

                     return null;
                  }
               }
            } else if (var1 instanceof Integer) {
               return this.field_0.remove(var5);
            } else if (var1 instanceof int[]) {
               String var17 = (String)this.field_0.remove(var5 + "|x");
               if (var17 == null) {
                  return null;
               } else {
                  int var26 = Integer.parseInt(var17);
                  boolean var35 = false;

                  for(int var36 = 0; var36 < var26 && this.field_0.remove(var5 + "|" + Integer.toString(var36)) != null; ++var36) {
                  }

                  return null;
               }
            } else if (var1 instanceof int[][]) {
               String var15 = (String)this.field_0.remove(var5 + "|x");
               if (var15 == null) {
                  return null;
               } else {
                  int var25 = Integer.parseInt(var15);
                  var15 = (String)this.field_0.remove(var5 + "|y");
                  if (var15 == null) {
                     return null;
                  } else {
                     int var34 = Integer.parseInt(var15);
                     boolean var42 = false;
                     boolean var47 = false;

                     for(int var43 = 0; var43 < var25; ++var43) {
                        for(int var48 = 0; var48 < var34 && this.field_0.remove(var5 + "|" + Integer.toString(var43) + "|" + Integer.toString(var48)) != null; ++var48) {
                        }
                     }

                     return null;
                  }
               }
            } else if (var1 instanceof Boolean) {
               return this.field_0.remove(var5);
            } else if (var1 instanceof boolean[]) {
               String var14 = (String)this.field_0.remove(var5 + "|x");
               if (var14 == null) {
                  return null;
               } else {
                  int var24 = Integer.parseInt(var14);
                  boolean var32 = false;

                  for(int var33 = 0; var33 < var24 && this.field_0.remove(var5 + "|" + Integer.toString(var33)) != null; ++var33) {
                  }

                  return null;
               }
            } else if (var1 instanceof Color[]) {
               String var13 = (String)this.field_0.remove(var5 + "|x");
               if (var13 == null) {
                  return null;
               } else {
                  int var23 = Integer.parseInt(var13);
                  boolean var30 = false;

                  for(int var31 = 0; var31 < var23 && this.field_0.remove(var5 + "|" + Integer.toString(var31)) != null; ++var31) {
                  }

                  return null;
               }
            } else if (var1 instanceof JDPTreeBranch) {
               JDPTreeBranch var12 = (JDPTreeBranch)var1;
               if (var12 == null) {
                  return null;
               } else {
                  this.removeObject("", var5, "n");
                  this.removeObject(false, var5, "s");
                  this.removeObject(false, var5, "e");
                  this.removeObject(0, var5, "i");
                  this.removeObject(false, var5, "d");
                  this.removeObject("", var5, "k");
                  this.removeObject("", var5, "m");
                  this.removeObject("", var5, "t");
                  this.removeObject("", var5, "p");
                  this.removeObject("", var5, "x");
                  this.removeObject("", var5, "r");
                  if (var12.relatedComps != null) {
                     for(int var7 = 0; var7 < var12.relatedComps.length; ++var7) {
                        if (var12.relatedComps[var7] instanceof JDPClassLayout) {
                           ((JDPClassLayout)var12.relatedComps[var7]).removeSelections();
                        }
                     }
                  }

                  if (var12.thisObject != null && var12.thisObject instanceof JDPClassLayout) {
                     ((JDPClassLayout)var12.thisObject).removeSelections();
                  }

                  String var21 = (String)this.field_0.remove(var5 + "|w");
                  int var8 = Integer.parseInt(var21);
                  String[] var9 = new String[var8];
                  var9 = (String[])this.restoreObject(var9, var5, "b", 0);
                  this.removeObject(var9, var5, "b");
                  if (var12.treeVector != null) {
                     for(int var10 = 0; var10 < var8; ++var10) {
                        this.removeObject(var12, var5, var9[var10]);
                     }
                  }

                  var21 = (String)this.field_0.remove(var5 + "|v");
                  var8 = Integer.parseInt(var21);
                  var9 = new String[var8];
                  var9 = (String[])this.restoreObject(var9, var5, "a", 0);
                  this.removeObject(var9, var5, "a");
                  if (var12.leaves != null) {
                     for(int var46 = 0; var46 < var8; ++var46) {
                        this.removeObject(var12, var5, var9[var46]);
                     }
                  }

                  return var12;
               }
            } else {
               return var1;
            }
         } else {
            this.field_0.remove(var5 + "|" + 0 + "|0");
            this.field_0.remove(var5 + "|" + 1 + "|0");
            int var6 = 0;

            do {
               this.field_0.remove(var5 + "|" + 0 + "|" + Integer.toString(var6));
               if (this.field_0.remove(var5 + "|" + 1 + "|" + Integer.toString(var6)) == null) {
                  break;
               }

               ++var6;
            } while(var6 < 1000);

            return null;
         }
      }
   }

   public Object removeObject(String var1, Object var2) {
      return this.removeObject(var2, "", var1);
   }

   public Object removeObject(int var1, String var2, String var3) {
      return this.removeObject(new Integer(var1), var2, var3);
   }

   public Object removeObject(boolean var1, String var2, String var3) {
      return this.removeObject(new Boolean(var1), var2, var3);
   }

   public Object restoreObject(Object var1, String var2, String var3, int var4) {
      if (this.field_0 == null) {
         return var1;
      } else {
         this.restoreVal = "";
         String var5 = var2 + "|" + var3;
         if (var5.indexOf(" ") > 0) {
            var5 = this.user.u.replace(var5, " ", "");
         }

         String var6 = (String)this.field_0.get(var5);
         if (var6 == null) {
            try {
               Integer.parseInt(var2);
               var6 = var5;
            } catch (Exception var13) {
            }
         }

         if (var6 == null) {
            return var1;
         } else if (var1 instanceof TextField) {
            this.restoreVal = (String)this.field_0.get(var6);
            TextField var30 = (TextField)var1;
            if (this.restoreVal != null) {
               if (this.restoreVal.equals("<null>")) {
                  this.restoreVal = null;
               }

               ((TextComponent)var30).setText(this.restoreVal);
            }

            return var1;
         } else if (var1 instanceof JDPComboBox) {
            this.restoreVal = (String)this.field_0.get(var6);
            JDPComboBox var29 = (JDPComboBox)var1;
            if (this.restoreVal != null) {
               if (this.restoreVal.equals("<null>")) {
                  this.restoreVal = null;
               }

               var29.setText(this.restoreVal);
            }

            return var1;
         } else if (var1 instanceof Choice) {
            this.restoreVal = (String)this.field_0.get(var6);
            if (this.restoreVal != null) {
               if (this.restoreVal.equals("<null>")) {
                  this.restoreVal = null;
               }

               if (this.restoreVal != null) {
                  Choice var28 = (Choice)var1;
                  var28.select(this.restoreVal);
               }
            }

            return var1;
         } else if (var1 instanceof JDPChoice) {
            this.restoreVal = (String)this.field_0.get(var6);
            if (this.restoreVal != null) {
               if (this.restoreVal.equals("<null>")) {
                  this.restoreVal = null;
               }

               if (this.restoreVal != null) {
                  JDPChoice var27 = (JDPChoice)var1;
                  var27.select(this.restoreVal);
               }
            }

            return var1;
         } else if (var1 instanceof List) {
            List var26 = (List)var1;
            if (var4 == 0) {
               for(int var40 = 0; var40 < var26.countItems(); ++var40) {
                  var26.deselect(var40);
               }
            }

            if (var4 == 1) {
               var26.clear();
            }

            int var41 = var26.countItems();
            this.restoreVal = (String)this.field_0.get(var6 + "|" + var4 + "|0");
            if (this.restoreVal == null) {
               return var1;
            } else {
               if (var4 == 1) {
                  var41 = 1000;
               }

               for(int var53 = 0; var53 < var41; ++var53) {
                  this.restoreVal = (String)this.field_0.get(var6 + "|" + var4 + "|" + Integer.toString(var53));
                  if (this.restoreVal == null) {
                     break;
                  }

                  if (this.restoreVal != null) {
                     if (this.restoreVal.equals("<null>")) {
                        this.restoreVal = null;
                     }

                     if (this.restoreVal != null) {
                        if (var4 == 0) {
                           this.user.u.listSelect(var26, this.restoreVal);
                           if (var26.getSelectedIndex() >= 0) {
                              var26.makeVisible(var26.getSelectedIndex());
                           }
                        } else if (var4 == 1) {
                           var26.addItem(this.restoreVal);
                           var26.makeVisible(0);
                        }
                     }
                  }
               }

               return var1;
            }
         } else if (var1 instanceof JDPList) {
            JDPList var25 = (JDPList)var1;
            if (var4 == 0) {
               for(int var38 = 0; var38 < var25.countItems(); ++var38) {
                  var25.deselect(var38);
               }
            }

            if (var4 == 1) {
               var25.clear();
            }

            int var39 = var25.countItems();
            this.restoreVal = (String)this.field_0.get(var6 + "|" + var4 + "|0");
            if (this.restoreVal == null) {
               return var1;
            } else {
               if (var4 == 1) {
                  var39 = 1000;
               }

               for(int var52 = 0; var52 < var39; ++var52) {
                  this.restoreVal = (String)this.field_0.get(var6 + "|" + var4 + "|" + Integer.toString(var52));
                  if (this.restoreVal == null) {
                     break;
                  }

                  if (this.restoreVal.equals("<null>")) {
                     this.restoreVal = null;
                  }

                  if (this.restoreVal != null) {
                     if (var4 == 0) {
                        if (var25.getItem(this.restoreVal) >= 0) {
                           var25.select(this.restoreVal);
                        } else {
                           for(int var69 = 0; var69 < var25.countItems(); ++var69) {
                              if (var25.getItem(var69).toUpperCase().equals(this.restoreVal.toUpperCase())) {
                                 ((JDPTreePicker)var25).select(var69);
                              }
                           }
                        }

                        if (((JDPTreePicker)var25).getSelectedIndex() >= 0) {
                           ((JDPTreePicker)var25).makeVisible(((JDPTreePicker)var25).getSelectedIndex());
                        }
                     } else if (var4 == 1) {
                        var25.addItem(this.restoreVal);
                        ((JDPTreePicker)var25).makeVisible(0);
                     }
                  }
               }

               return var1;
            }
         } else if (var1 instanceof TextArea) {
            this.restoreVal = (String)this.field_0.get(var6);
            TextArea var24 = (TextArea)var1;
            if (this.restoreVal == null) {
               return var1;
            } else {
               if (this.restoreVal != null) {
                  if (this.restoreVal.equals("<null>")) {
                     this.restoreVal = null;
                  }

                  if (this.restoreVal != null) {
                     ((TextComponent)var24).setText(this.restoreVal);
                  } else {
                     ((TextComponent)var24).setText("");
                  }
               }

               return var1;
            }
         } else if (var1 instanceof String) {
            this.restoreVal = (String)this.field_0.get(var6);
            if (this.restoreVal == null) {
               return null;
            } else {
               if (this.restoreVal != null) {
                  if (this.restoreVal.equals("<null>")) {
                     this.restoreVal = null;
                  }

                  var1 = this.restoreVal;
               }

               return var1;
            }
         } else if (var1 instanceof String[]) {
            String var23 = (String)this.field_0.get(var6 + "|x");
            if (var23 == null) {
               return null;
            } else {
               int var37 = Integer.parseInt(var23);
               String[] var51 = new String[var37];
               boolean var67 = false;

               for(int var68 = 0; var68 < var37; ++var68) {
                  this.restoreVal = (String)this.field_0.get(var6 + "|" + Integer.toString(var68));
                  if (this.restoreVal != null) {
                     if (this.restoreVal.equals("<null>")) {
                        this.restoreVal = null;
                     }

                     var51[var68] = this.restoreVal.replace('\u0004', ' ');
                  }
               }

               return var51;
            }
         } else if (var1 instanceof String[][]) {
            String var21 = (String)this.field_0.get(var6 + "|x");
            if (var21 == null) {
               return null;
            } else {
               int var36 = Integer.parseInt(var21);
               var21 = (String)this.field_0.get(var6 + "|y");
               if (var21 == null) {
                  return null;
               } else {
                  int var50 = Integer.parseInt(var21);
                  String[][] var65 = (String[][])var1;
                  var65 = new String[var36][var50];
                  boolean var73 = false;
                  boolean var76 = false;

                  for(int var74 = 0; var74 < var65.length; ++var74) {
                     for(int var77 = 0; var77 < var65[0].length; ++var77) {
                        this.restoreVal = (String)this.field_0.get(var6 + "|" + Integer.toString(var74) + "|" + Integer.toString(var77));
                        if (this.restoreVal != null) {
                           if (this.restoreVal.equals("<null>")) {
                              this.restoreVal = null;
                           }

                           var65[var74][var77] = this.restoreVal.replace('\u0004', ' ');
                        }
                     }
                  }

                  return var65;
               }
            }
         } else if (var1 instanceof Integer) {
            int var20 = 0;
            this.restoreVal = (String)this.field_0.get(var6);
            if (this.restoreVal != null) {
               var20 = Integer.parseInt(this.restoreVal);
            }

            return new Integer(var20);
         } else if (var1 instanceof int[]) {
            String var19 = (String)this.field_0.get(var6 + "|x");
            if (var19 == null) {
               return var1;
            } else {
               int var35 = Integer.parseInt(var19);
               int[] var48 = (int[])var1;
               var48 = new int[var35];
               boolean var63 = false;

               for(int var64 = 0; var64 < var48.length; ++var64) {
                  this.restoreVal = (String)this.field_0.get(var6 + "|" + Integer.toString(var64));
                  if (this.restoreVal == null) {
                     break;
                  }

                  var48[var64] = Integer.parseInt(this.restoreVal);
               }

               return var48;
            }
         } else if (var1 instanceof int[][]) {
            String var17 = (String)this.field_0.get(var6 + "|x");
            if (var17 == null) {
               return var1;
            } else {
               int var34 = Integer.parseInt(var17);
               var17 = (String)this.field_0.get(var6 + "|y");
               if (var17 == null) {
                  return var1;
               } else {
                  int var47 = Integer.parseInt(var17);
                  int[][] var61 = (int[][])var1;
                  var61 = new int[var34][var47];
                  boolean var71 = false;
                  boolean var12 = false;

                  for(int var72 = 0; var72 < var61.length; ++var72) {
                     for(int var75 = 0; var75 < var61[0].length; ++var75) {
                        this.restoreVal = (String)this.field_0.get(var6 + "|" + Integer.toString(var72) + "|" + Integer.toString(var75));
                        if (this.restoreVal != null) {
                           if (this.restoreVal.equals("<null>")) {
                              this.restoreVal = "0";
                           }

                           var61[var72][var75] = Integer.parseInt(this.restoreVal);
                        }
                     }
                  }

                  return var61;
               }
            }
         } else if (var1 instanceof Boolean) {
            boolean var16 = false;
            this.restoreVal = (String)this.field_0.get(var6);
            if (this.restoreVal != null) {
               var16 = false;
               if (this.restoreVal.equals("true")) {
                  var16 = true;
               }
            }

            return new Boolean(var16);
         } else if (var1 instanceof boolean[]) {
            String var15 = (String)this.field_0.get(var6 + "|x");
            if (var15 == null) {
               return var1;
            } else {
               int var33 = Integer.parseInt(var15);
               boolean[] var45 = (boolean[])var1;
               var45 = new boolean[var33];
               boolean var59 = false;

               for(int var60 = 0; var60 < var45.length; ++var60) {
                  this.restoreVal = (String)this.field_0.get(var6 + "|" + Integer.toString(var60));
                  if (this.restoreVal == null) {
                     break;
                  }

                  var45[var60] = false;
                  if (this.restoreVal.equals("true")) {
                     var45[var60] = true;
                  }
               }

               return var45;
            }
         } else if (var1 instanceof Color[]) {
            String var14 = (String)this.field_0.get(var6 + "|x");
            if (var14 == null) {
               return var1;
            } else {
               int var32 = Integer.parseInt(var14);
               Color[] var43 = (Color[])var1;
               var43 = new Color[var32];
               boolean var57 = false;

               for(int var58 = 0; var58 < var43.length; ++var58) {
                  this.restoreVal = (String)this.field_0.get(var6 + "|" + Integer.toString(var58));
                  if (this.restoreVal == null) {
                     break;
                  }

                  var43[var58] = this.user.u._cvtcolor(this.restoreVal);
               }

               return var43;
            }
         } else if (!(var1 instanceof JDPTreeBranch)) {
            if (var1 == null) {
               System.out.println("JDPSaveProps/restoreObject: Data type not supported. (" + var2 + ":" + var3 + ")");
            } else {
               System.out.println("JDPSaveProps/restoreObject: Data type not supported. (" + var2 + ":" + var3 + "): " + var1.toString());
            }

            return var1;
         } else {
            JDPTreeBranch var7 = (JDPTreeBranch)var1;
            if (var7 == null) {
               return var1;
            } else {
               var7.name = "";
               var7.dropKey = "";
               var7.dropMessage = "";
               var7.compType = "";
               var7.compPosition = "";
               var7.text = new String[0];
               var7.properties = new String[0][0];
               var7.name = (String)this.restoreObject(var7.name, var6, "n", 0);
               var7.selected = this.restoreObject(var7.selected, var6, "s", 0);
               var7.expanded = this.restoreObject(var7.expanded, var6, "e", 0);
               var7.icon = this.restoreObject(var7.icon, var6, "i", 0);
               var7.branchIndex = this.restoreObject(var7.branchIndex, var6, "bi", 0);
               var7.dragAndDrop = this.restoreObject(var7.dragAndDrop, var6, "d", 0);
               var7.dropKey = (String)this.restoreObject(var7.dropKey, var6, "k", 0);
               var7.dropMessage = (String)this.restoreObject(var7.dropMessage, var6, "m", 0);
               var7.compType = (String)this.restoreObject(var7.compType, var6, "t", 0);
               if (var7.compType != null && var7.compType.equals("JDPEmailDbase")) {
                  var7.compType = "JDPWizEmail";
               }

               if (var7.compType != null && var7.compType.equals("JDPAlphaDbase")) {
                  var7.compType = "JDPWizAlphaPaging";
               }

               var7.compPosition = (String)this.restoreObject(var7.compPosition, var6, "p", 0);
               var7.text = (String[])this.restoreObject(var7.text, var6, "x", 0);
               var7.properties = (String[][])this.restoreObject(var7.properties, var6, "r", 0);
               if (var7.thisObject != null && var7.thisObject instanceof JDPClassLayout) {
               }

               String var8 = (String)this.field_0.get(var6 + "|w");
               if (var8 != null) {
                  int var9 = Integer.parseInt(var8);
                  var7.treeVector = new Vector();
                  String[] var10 = new String[var9];
                  var10 = (String[])this.restoreObject(var10, var6, "b", 0);
                  if (var10 != null) {
                     for(int var11 = 0; var11 < var9; ++var11) {
                        var7.treeVector.addElement(new JDPTreeBranch());
                        this.restoreObject((JDPTreeBranch)var7.treeVector.elementAt(var11), var6, var10[var11], 0);
                     }
                  }
               }

               var8 = (String)this.field_0.get(var6 + "|v");
               if (var8 == null) {
                  return var1;
               } else {
                  int var42 = Integer.parseInt(var8);
                  var7.leaves = new Vector();
                  String[] var55 = new String[0];
                  var55 = (String[])this.restoreObject(var55, var6, "a", 0);
                  if (var7.leaves != null) {
                     for(int var70 = 0; var70 < var42; ++var70) {
                        var7.leaves.addElement(new JDPTreeBranch());
                        this.restoreObject((JDPTreeBranch)var7.leaves.elementAt(var70), var6, var55[var70], 0);
                     }
                  } else {
                     var7.leaves = new Vector();
                  }

                  return var7;
               }
            }
         }
      }
   }

   public Object restoreObject(String var1, Object var2) {
      return this.restoreObject(var2, "", var1, 0);
   }

   public Object restoreObject(Object var1, String var2, String var3) {
      return this.restoreObject(var1, var2, var3, 0);
   }

   public int restoreObject(int var1, String var2, String var3, int var4) {
      return (Integer)this.restoreObject(new Integer(var1), var2, var3, var4);
   }

   public int restoreObject(String var1, int var2) {
      return (Integer)this.restoreObject(new Integer(var2), "", var1, 0);
   }

   public boolean restoreObject(boolean var1, String var2, String var3, int var4) {
      return (Boolean)this.restoreObject(new Boolean(var1), var2, var3, var4);
   }

   public boolean restoreObject(String var1, boolean var2) {
      return (Boolean)this.restoreObject(new Boolean(var2), "", var1, 0);
   }

   public boolean load(String var1) {
      this.clear();
      if (this.user.mainmsg != null) {
         this.user.mainmsg.setStatusMsg("Loading file...", 0);
      }

      String var2 = this.user.u.readFromFile(var1);
      if (this.user.mainmsg != null) {
         this.user.mainmsg.setStatusMsg("Loading settings...", 0);
      }

      try {
         if (var2 != null) {
            this.field_0 = new Properties();
            StringBufferInputStream var3 = new StringBufferInputStream(var2);
            this.fileSize = var2.length();
            this.field_0.load(var3);
         }
      } catch (Exception var5) {
         ((Throwable)var5).printStackTrace();
      }

      if (var2 != null) {
         if (this.user.mainmsg != null) {
            this.user.mainmsg.setStatusMsg("File successfully loaded.", 10);
         }

         return true;
      } else {
         if (this.user.mainmsg != null) {
            this.user.mainmsg.setStatusMsg("File load failed. See Java console for details.", 20);
         }

         System.out.println("Failed reading file: " + var1);
         return false;
      }
   }

   public boolean save(String var1) {
      if (this.field_0 == null) {
         return false;
      } else {
         if (this.user.mainmsg != null) {
            this.user.mainmsg.setStatusMsg("Saving settings...", 0);
         }

         ByteArrayOutputStream var2 = new ByteArrayOutputStream();
         this.field_0.save((OutputStream)var2, var1);
         String var3 = var2.toString();
         return this.user.u.writeToFile(var1, var3, "w+");
      }
   }

   public void setProperties(Properties var1) {
      this.field_0 = var1;
   }

   public Properties getProperties() {
      return this.field_0;
   }

   public void clear() {
      this.field_0 = new Properties();
   }

   public JDPSaveProps(JDPUser var1) {
      this.user = var1;
      if (this.field_0 == null) {
         this.field_0 = new Properties();
      }

   }

   public boolean saveObject(Object var1, String var2, String var3, int var4) {
      if (this.field_0 == null) {
         return false;
      } else {
         this.saveVal = "";
         String var5 = var2 + "|" + var3;
         if (var5.indexOf(" ") > 0) {
            var5 = this.user.u.replace(var5, " ", "");
         }

         String var6 = (String)this.field_0.get(var5);
         if (var1 == null) {
            return false;
         } else {
            if (var6 == null) {
               String var7 = (String)this.field_0.get("nextIndex");
               if (var7 == null) {
                  this.nextIndex = 1;
               } else {
                  this.nextIndex = Integer.parseInt(var7);
                  ++this.nextIndex;
                  this.field_0.remove("nextIndex");
               }

               this.field_0.put("nextIndex", Integer.toString(this.nextIndex));
               var6 = Integer.toString(this.nextIndex);
               this.field_0.put(var5, var6);
            }

            if (var1 instanceof TextField) {
               TextField var27 = (TextField)var1;
               this.saveVal = ((TextComponent)var27).getText();
               if (this.saveVal != null) {
                  this.field_0.remove(var6);
                  this.field_0.put(var6, this.saveVal);
               }

               return true;
            } else if (var1 instanceof JDPComboBox) {
               JDPComboBox var26 = (JDPComboBox)var1;
               this.saveVal = var26.getText();
               if (this.saveVal != null) {
                  this.field_0.remove(var6);
                  this.field_0.put(var6, this.saveVal);
               }

               return true;
            } else if (var1 instanceof Choice) {
               Choice var25 = (Choice)var1;
               this.saveVal = var25.getSelectedItem();
               if (this.saveVal != null) {
                  this.field_0.remove(var6);
                  this.field_0.put(var6, this.saveVal);
               }

               return true;
            } else if (var1 instanceof JDPChoice) {
               JDPChoice var24 = (JDPChoice)var1;
               this.saveVal = var24.getSelectedItem();
               if (this.saveVal != null) {
                  this.field_0.remove(var6);
                  this.field_0.put(var6, this.saveVal);
               }

               return true;
            } else if (var1 instanceof List) {
               List var23 = (List)var1;
               String[] var38 = var23.getSelectedItems();
               if (var4 == 0) {
                  for(int var49 = 0; var49 < var23.countItems() + 10; ++var49) {
                     this.field_0.remove(var6 + "|" + var4 + "|" + Integer.toString(var49));
                  }

                  for(int var50 = 0; var50 < var38.length; ++var50) {
                     this.saveVal = var38[var50];
                     this.field_0.put(var6 + "|" + var4 + "|" + Integer.toString(var50), this.saveVal);
                  }
               } else if (var4 == 1) {
                  for(int var51 = 0; var51 < var23.countItems() + 10; ++var51) {
                     this.field_0.remove(var6 + "|" + var4 + "|" + Integer.toString(var51));
                  }

                  for(int var52 = 0; var52 < var23.countItems(); ++var52) {
                     this.saveVal = var23.getItem(var52);
                     this.field_0.put(var6 + "|" + var4 + "|" + Integer.toString(var52), this.saveVal);
                  }
               }

               return true;
            } else if (var1 instanceof JDPList) {
               JDPList var22 = (JDPList)var1;
               String[] var37 = ((JDPTreePicker)var22).getSelectedItems();
               if (var4 == 0) {
                  for(int var45 = 0; var45 < var22.countItems() + 10; ++var45) {
                     this.field_0.remove(var6 + "|" + var4 + "|" + Integer.toString(var45));
                  }

                  for(int var46 = 0; var46 < var37.length; ++var46) {
                     this.saveVal = var37[var46];
                     this.field_0.put(var6 + "|" + var4 + "|" + Integer.toString(var46), this.saveVal);
                  }
               } else if (var4 == 1) {
                  for(int var47 = 0; var47 < var22.countItems() + 10; ++var47) {
                     this.field_0.remove(var6 + "|" + var4 + "|" + Integer.toString(var47));
                  }

                  for(int var48 = 0; var48 < var22.countItems(); ++var48) {
                     this.saveVal = var22.getItem(var48);
                     this.field_0.put(var6 + "|" + var4 + "|" + Integer.toString(var48), this.saveVal);
                  }
               }

               return true;
            } else if (var1 instanceof TextArea) {
               TextArea var21 = (TextArea)var1;
               this.saveVal = ((TextComponent)var21).getText();
               if (this.saveVal != null) {
                  this.field_0.remove(var6);
                  this.field_0.put(var6, this.saveVal);
               }

               return true;
            } else if (var1 instanceof String) {
               this.saveVal = (String)var1;
               if (this.saveVal != null) {
                  this.field_0.remove(var6);
                  this.field_0.put(var6, this.saveVal);
               }

               return true;
            } else if (var1 instanceof String[]) {
               String[] var20 = (String[])var1;
               this.field_0.remove(var6 + "|x");
               this.field_0.put(var6 + "|x", Integer.toString(var20.length));

               for(int var36 = 0; var36 < var20.length; ++var36) {
                  this.saveVal = var20[var36];
                  if (this.saveVal != null) {
                     this.field_0.remove(var6 + "|" + Integer.toString(var36));
                     if (this.saveVal.startsWith(" ")) {
                        this.field_0.put(var6 + "|" + Integer.toString(var36), this.saveVal.replace(' ', '\u0004'));
                     } else {
                        this.field_0.put(var6 + "|" + Integer.toString(var36), this.saveVal);
                     }
                  }
               }

               return true;
            } else if (var1 instanceof String[][]) {
               String[][] var19 = (String[][])var1;
               this.field_0.remove(var6 + "|x");
               this.field_0.put(var6 + "|x", Integer.toString(var19.length));
               this.field_0.remove(var6 + "|y");
               if (var19.length > 0) {
                  this.field_0.put(var6 + "|y", Integer.toString(var19[0].length));

                  for(int var35 = 0; var35 < var19.length; ++var35) {
                     for(int var44 = 0; var44 < var19[0].length; ++var44) {
                        this.saveVal = var19[var35][var44];
                        if (this.saveVal != null) {
                           this.field_0.remove(var6 + "|" + Integer.toString(var35) + "|" + Integer.toString(var44));
                           if (this.saveVal.startsWith(" ")) {
                              this.field_0.put(var6 + "|" + Integer.toString(var35) + "|" + Integer.toString(var44), this.saveVal.replace(' ', '\u0004'));
                           } else {
                              this.field_0.put(var6 + "|" + Integer.toString(var35) + "|" + Integer.toString(var44), this.saveVal);
                           }
                        }
                     }
                  }
               }

               return true;
            } else if (var1 instanceof Integer) {
               Integer var18 = (Integer)var1;
               this.saveVal = var18.toString();
               this.field_0.remove(var6);
               this.field_0.put(var6, this.saveVal);
               return true;
            } else if (var1 instanceof int[]) {
               int[] var17 = (int[])var1;
               this.field_0.remove(var6 + "|x");
               this.field_0.put(var6 + "|x", Integer.toString(var17.length));

               for(int var34 = 0; var34 < var17.length; ++var34) {
                  this.saveVal = Integer.toString(var17[var34]);
                  this.field_0.remove(var6 + "|" + Integer.toString(var34));
                  this.field_0.put(var6 + "|" + Integer.toString(var34), this.saveVal);
               }

               return true;
            } else if (var1 instanceof int[][]) {
               int[][] var16 = (int[][])var1;
               if (var16.length > 0) {
                  this.field_0.remove(var6 + "|x");
                  this.field_0.put(var6 + "|x", Integer.toString(var16.length));
                  this.field_0.remove(var6 + "|y");
                  this.field_0.put(var6 + "|y", Integer.toString(var16[0].length));

                  for(int var33 = 0; var33 < var16.length; ++var33) {
                     for(int var43 = 0; var43 < var16[0].length; ++var43) {
                        this.saveVal = Integer.toString(var16[var33][var43]);
                        if (this.saveVal != null) {
                           this.field_0.remove(var6 + "|" + Integer.toString(var33) + "|" + Integer.toString(var43));
                           this.field_0.put(var6 + "|" + Integer.toString(var33) + "|" + Integer.toString(var43), this.saveVal);
                        }
                     }
                  }
               }

               return true;
            } else if (var1 instanceof Boolean) {
               Boolean var15 = (Boolean)var1;
               this.saveVal = "false";
               if (var15) {
                  this.saveVal = "true";
               }

               this.field_0.remove(var6);
               this.field_0.put(var6, this.saveVal);
               return true;
            } else if (var1 instanceof boolean[]) {
               boolean[] var14 = (boolean[])var1;
               this.field_0.remove(var6 + "|x");
               this.field_0.put(var6 + "|x", Integer.toString(var14.length));

               for(int var32 = 0; var32 < var14.length; ++var32) {
                  this.saveVal = "false";
                  if (var14[var32]) {
                     this.saveVal = "true";
                  }

                  this.field_0.remove(var6 + "|" + Integer.toString(var32));
                  this.field_0.put(var6 + "|" + Integer.toString(var32), this.saveVal);
               }

               return true;
            } else if (var1 instanceof Color[]) {
               Color[] var13 = (Color[])var1;
               this.field_0.remove(var6 + "|x");
               this.field_0.put(var6 + "|x", Integer.toString(var13.length));
               int var31 = var13.length;

               for(int var42 = 0; var42 < var31; ++var42) {
                  if (var13[var42] != null) {
                     this.saveVal = JDPUtils._cvtbcolor(var13[var42]);
                     this.field_0.remove(var6 + "|" + Integer.toString(var42));
                     this.field_0.put(var6 + "|" + Integer.toString(var42), this.saveVal);
                  }
               }

               return true;
            } else if (var1 instanceof JDPTreeBranch) {
               JDPTreeBranch var12 = (JDPTreeBranch)var1;
               if (var12.name != null) {
                  this.saveObject(var12.name, var6, "n", 0);
               }

               this.saveObject(var12.expanded, var6, "e", 0);
               this.saveObject(var12.icon, var6, "i", 0);
               this.saveObject(var12.branchIndex, var6, "bi", 0);
               this.saveObject(var12.dragAndDrop, var6, "d", 0);
               if (var12.dropKey != null && !var12.dropKey.equals("")) {
                  this.saveObject(var12.dropKey, var6, "k", 0);
               }

               if (var12.dropMessage != null && !var12.dropMessage.equals("")) {
                  this.saveObject(var12.dropMessage, var6, "m", 0);
               }

               if (var12.compType != null && !var12.compType.equals("")) {
                  this.saveObject(var12.compType, var6, "t", 0);
               }

               if (var12.compPosition != null && !var12.compPosition.equals("")) {
                  this.saveObject(var12.compPosition, var6, "p", 0);
               }

               if (var12.text != null && var12.text.length > 0) {
                  this.saveObject(var12.text, var6, "x", 0);
               }

               if (var12.properties != null && var12.properties.length > 0) {
                  this.saveObject(var12.properties, var6, "r", 0);
               }

               if (var12.relatedComps != null && var12.relatedComps.length > 0) {
                  for(int var8 = 0; var8 < var12.relatedComps.length; ++var8) {
                     String var9 = ((JDPClassLayout)var12.relatedComps[var8]).getComponentName();
                     if (!var9.equals(var12.name)) {
                        ((JDPClassLayout)var12.relatedComps[var8]).setComponentName(var12.name);
                        ((JDPClassLayout)var12.relatedComps[var8]).setThisBranch(var12);
                        ((JDPClassLayout)var12.relatedComps[var8]).refresh();
                     }
                  }

                  for(int var28 = 0; var28 < var12.relatedComps.length; ++var28) {
                     if (var12.relatedComps[var28] instanceof JDPClassLayout) {
                        ((JDPClassLayout)var12.relatedComps[var28]).saveSelections();
                     }
                  }
               }

               if (var12.thisObject != null && var12.thisObject instanceof JDPClassLayout) {
               }

               this.field_0.remove(var6 + "|w");
               if (var12.treeVector != null && var12.treeVector.size() > 0) {
                  JDPTreeBranch var29 = (JDPTreeBranch)var12.treeVector.elementAt(0);
                  if (var29.leaves != null) {
                     for(int var39 = 0; var39 < var29.leaves.size(); ++var39) {
                        JDPTreeBranch var10 = (JDPTreeBranch)var29.leaves.elementAt(var39);
                        if (var10.leaves == null || var10.leaves.size() == 0) {
                           var29.leaves.removeElementAt(var39);
                           --var39;
                        }
                     }

                     this.field_0.put(var6 + "|w", Integer.toString(var12.treeVector.size()));
                     String[] var40 = new String[var12.treeVector.size()];

                     for(int var53 = 0; var53 < var12.treeVector.size(); ++var53) {
                        if (var12.treeVector.elementAt(var53) instanceof JDPTreeBranch) {
                           JDPTreeBranch var11 = (JDPTreeBranch)var12.treeVector.elementAt(var53);
                           this.saveObject(var11, var6, var11.name, 0);
                           var40[var53] = var11.name;
                        }
                     }

                     this.saveObject(var40, var6, "b", 0);
                  }
               }

               this.field_0.remove(var6 + "|v");
               if (var12.leaves != null && var12.leaves.size() > 0) {
                  this.field_0.put(var6 + "|v", Integer.toString(var12.leaves.size()));
                  if (var12.leaves != null) {
                     String[] var30 = new String[var12.leaves.size()];

                     for(int var41 = 0; var41 < var12.leaves.size(); ++var41) {
                        JDPTreeBranch var54 = (JDPTreeBranch)var12.leaves.elementAt(var41);
                        String var55 = var54.name + Integer.toString(var54.branchIndex);
                        this.saveObject(var54, var6, var55, 0);
                        var30[var41] = var55;
                     }

                     this.saveObject(var30, var6, "a", 0);
                  }
               }

               return true;
            } else {
               System.out.println("JDPSaveProps/saveObject: Data type not supported: " + var1.toString());
               return false;
            }
         }
      }
   }
}
