import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;

public class JDPServerConsole extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   JDPTabSelectPanel TabPanel1;
   JDPSubsystemMaint JDPSubsystemMaint1;
   JDPJobQueueMaint JDPJobQueueMaint1;
   JDPActiveUserMaint JDPActiveUserMaint1;
   JDPActiveJdbcMaint JDPActiveJdbcMaint1;
   JDPServerPropMaint JDPServerPropMaint1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Enterprise Server Console");
      String[] var4 = new String[5];
      Panel[] var5 = new Panel[5];
      var5[0] = new Panel();
      var5[0].setLayout(new BorderLayout());
      var4[0] = "Subsystems";
      var5[1] = new Panel();
      var5[1].setLayout(new BorderLayout());
      var4[1] = "Job Queues";
      var5[2] = new Panel();
      var5[2].setLayout(new BorderLayout());
      var4[2] = "Users";
      var5[3] = new Panel();
      var5[3].setLayout(new BorderLayout());
      var4[3] = "Database Connections";
      var5[4] = new Panel();
      var5[4].setLayout(new BorderLayout());
      var4[4] = "Server Properties";
      this.TabPanel1 = new JDPTabSelectPanel(var1, var4, var5, "North");
      this.JDPSubsystemMaint1 = new JDPSubsystemMaint();
      this.JDPSubsystemMaint1.InitClass(var1, var2, var3);
      this.JDPJobQueueMaint1 = new JDPJobQueueMaint();
      this.JDPJobQueueMaint1.InitClass(var1, var2, var3);
      this.JDPActiveUserMaint1 = new JDPActiveUserMaint();
      this.JDPActiveUserMaint1.InitClass(var1, var2, var3);
      this.JDPActiveJdbcMaint1 = new JDPActiveJdbcMaint();
      this.JDPActiveJdbcMaint1.InitClass(var1, var2, var3);
      this.JDPServerPropMaint1 = new JDPServerPropMaint();
      this.JDPServerPropMaint1.InitClass(var1, var2, var3);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.TabPanel1);
      var5[0].add("Center", this.JDPSubsystemMaint1);
      var5[1].add("Center", this.JDPJobQueueMaint1);
      var5[2].add("Center", this.JDPActiveUserMaint1);
      var5[3].add("Center", this.JDPActiveJdbcMaint1);
      var5[4].add("Center", this.JDPServerPropMaint1);
      this.TabPanel1.setTabcolor(0, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(1, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(2, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(3, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      this.TabPanel1.setTabcolor(4, var1.u._cvtcolor("Black"), var1.u._cvtcolor("LightGray"));
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target.equals(this.TabPanel1)) {
               if (this.TabPanel1.getSelectedIndex() == 0) {
                  this.JDPSubsystemMaint1.LoadGridWithSubsystemData();
               }

               if (this.TabPanel1.getSelectedIndex() == 1) {
                  this.JDPJobQueueMaint1.LoadGridWithJobQueueData();
               }

               if (this.TabPanel1.getSelectedIndex() == 2) {
                  this.JDPActiveUserMaint1.LoadGridWithUserData();
               }

               if (this.TabPanel1.getSelectedIndex() == 3) {
                  this.JDPActiveJdbcMaint1.LoadGridWithJdbcData();
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
      this.user.mainmsg.clearStatusMsg();
      if (!JDPJagg.useJaggServer) {
         this.user.mainmsg.setStatusMsg("The Enterprise Server console will not operate in when using CGI.", 20);
      }

   }
}
