import java.util.Vector;

public class JDPSetupJedi {
   JDPUser user;
   String sourcetype;

   public JDPSetupJedi(JDPUser var1) {
      this.user = var1;
      this.createTemplateTables();
   }

   boolean createJediTables() {
      Vector var2 = new Vector();
      int var3 = 1;
      String var4 = "date";
      String var5 = this.user.u.getDataSourceType(this.user.jaggSQL);
      if (var5.indexOf(JDPJagg.MSSQLSERVER) >= 0) {
         var4 = "datetime";
      } else if (var5.indexOf(JDPJagg.SYBASE) < 0 && var5.indexOf(JDPJagg.SYBASE10) < 0) {
         if (var5.indexOf(JDPJagg.ANYWHERE) >= 0) {
            var4 = "datetime";
         }
      } else {
         var4 = "datetime";
      }

      if (JDPUtils.check4Table(this.user.jaggSQL, var5, "JediSystemDef")) {
         return true;
      } else {
         this.user.loginMessage.setStatusMsg("Creating Jedi table " + Integer.toString(var3++) + " of 4...", 0);
         String var1 = "CREATE TABLE JediSystemDef (" + "JDPSystem char (5) ," + "instatus char (1) ," + "outstatus char (1) ," + "hldingdsn char (30) ," + "hldingcstr char (70) ," + "dftxfrmode char (1) )";
         if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
            this.user.u.setSqlMessage(this.user.jaggSQL, var1);
            return false;
         } else {
            this.user.loginMessage.setStatusMsg("Creating Jedi table " + Integer.toString(var3++) + " of 4...", 0);
            var1 = "CREATE TABLE JediSiteDef\t(" + "JDPSystem char (5) , " + "sitename char (30) , " + "siteaddr char (70) ," + "siteport char (5) ,\t" + "username char (20) , " + "password char (20) ) ";
            if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var1);
               return false;
            } else {
               this.user.loginMessage.setStatusMsg("Creating Jedi table " + Integer.toString(var3++) + " of 4...", 0);
               var1 = "CREATE TABLE JediXferDef\t(" + "JDPSystem char (5) , " + "xfername char (20) , " + "xferdesc char (50) ," + "localsite char (30) ,\t" + "remotesite char (30) ,\t" + "encryptdta char (1) ,\t" + "templname char (20) ,\t" + "xferdir char (1) ) ";
               if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
                  this.user.u.setSqlMessage(this.user.jaggSQL, var1);
                  return false;
               } else {
                  this.user.loginMessage.setStatusMsg("Creating Jedi table " + Integer.toString(var3++) + " of 4...", 0);
                  var1 = "CREATE TABLE JediHolding\t(" + "JDPSystem char (5) , " + "localsite char (30) ,\t" + "remotesite char (30) ,\t" + "lcltemplnm char (20) ,\t" + "rmttemplnm char (20) ,\t" + "extractdte " + var4 + " ," + "extracttim int ," + "xmitdate " + var4 + " ," + "xmittime int ," + "totalrows int ," + "status char (1) )";
                  if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
                     this.user.u.setSqlMessage(this.user.jaggSQL, var1);
                     return false;
                  } else {
                     var1 = "INSERT INTO JDPTmpType (JDPSystem, templtype, typedesc )" + " VALUES('" + this.user.JDesignerPro.JDPSystem.trim() + "','E','EDI Data Transfer Templates')";
                     if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
                        this.user.u.setSqlMessage(this.user.jaggSQL, var1);
                        return false;
                     } else {
                        return true;
                     }
                  }
               }
            }
         }
      }
   }

   boolean createTemplateTables() {
      Vector var2 = new Vector();
      int var3 = 1;
      String var4 = "date";
      this.sourcetype = this.user.u.getDataSourceType(this.user.jaggSQL);
      if (this.sourcetype.indexOf(JDPJagg.MSSQLSERVER) >= 0) {
         var4 = "datetime";
      } else if (this.sourcetype.indexOf(JDPJagg.SYBASE) < 0 && this.sourcetype.indexOf(JDPJagg.SYBASE10) < 0) {
         if (this.sourcetype.indexOf(JDPJagg.ANYWHERE) >= 0) {
            var4 = "datetime";
         }
      } else {
         var4 = "datetime";
      }

      if (JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPTmpType")) {
         return true;
      } else {
         this.user.loginMessage.setStatusMsg("Creating Template table " + Integer.toString(var3++) + " of 4...", 0);
         String var1 = "CREATE TABLE JDPTmpType (" + "JDPSystem char (5) ," + "templtype char (1) ," + "typedesc char (50) )";
         if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
            this.user.u.setSqlMessage(this.user.jaggSQL, var1);
            return false;
         } else {
            this.user.loginMessage.setStatusMsg("Creating Template table " + Integer.toString(var3++) + " of 4...", 0);
            var1 = "CREATE TABLE JDPTmpGrp (" + "JDPSystem char (5) ," + "templtype char (1) ," + "groupname char (20) ," + "groupdesc char (50) )";
            if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var1);
               return false;
            } else {
               this.user.loginMessage.setStatusMsg("Creating Template table " + Integer.toString(var3++) + " of 4...", 0);
               var1 = "CREATE TABLE JDPTmpTable\t(" + "JDPSystem char (5) , " + "templtype char (1) ,\t" + "groupname char (20) , " + "templname char (20) , " + "templdesc char (50) ," + "templdsn char (20) , " + "templcstr char (70) , " + "templtbls char (80) , " + "templjoin char (254) )";
               if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
                  this.user.u.setSqlMessage(this.user.jaggSQL, var1);
                  return false;
               } else {
                  this.user.loginMessage.setStatusMsg("Creating Template table " + Integer.toString(var3++) + " of 4...", 0);
                  var1 = "CREATE TABLE JDPTmpDetail\t(" + "JDPSystem char (5) , " + "templtype char (1) ,\t" + "groupname char (20) , " + "templname char (20) , " + "seqno int ,\t" + "columnname char (20) ,\t" + "columntype int ,\t" + "columnsize int ,\t" + "columnprec int ,\t" + "columnsql char (50) , " + "columnkey char (1) , " + "columnnull char (1), " + "columndft char (50) ) ";
                  if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
                     this.user.u.setSqlMessage(this.user.jaggSQL, var1);
                     return false;
                  } else {
                     var1 = "INSERT INTO JDPTmpType (JDPSystem, templtype, typedesc )" + " VALUES('" + this.user.JDesignerPro.JDPSystem.trim() + "','D','Database Wizard Templates')";
                     if (this.user.jaggSQL.execSQL(var1, var2) == -1) {
                        this.user.u.setSqlMessage(this.user.jaggSQL, var1);
                        return false;
                     } else {
                        return true;
                     }
                  }
               }
            }
         }
      }
   }
}
