import java.awt.Color;
import java.awt.SystemColor;
import java.awt.Toolkit;
import java.awt.image.ColorModel;

public class JDPSystemColor {
   public static Color getSystemColor() {
      return getControlColor();
   }

   public static Color getTextHighlightText() {
      SystemColor var0 = null;
      if ((!System.getProperty("java.vendor").startsWith("Netscape") || System.getProperty("java.version").compareTo("1.1.2") > 0) && !System.getProperty("os.name").startsWith("Mac") && !System.getProperty("java.version").startsWith("1.0")) {
         try {
            var0 = SystemColor.textHighlightText;
            JDPUtils.textHighlightText = var0;
         } catch (Exception var1) {
         }
      }

      return var0;
   }

   public static Color getControlColor() {
      Object var0 = Color.lightGray;
      if ((!System.getProperty("java.vendor").startsWith("Netscape") || System.getProperty("java.version").compareTo("1.1.2") > 0) && !System.getProperty("os.name").startsWith("Mac") && !System.getProperty("java.version").startsWith("1.0")) {
         try {
            var0 = SystemColor.control;
            JDPUtils.controlColor = (Color)var0;
         } catch (Exception var1) {
         }
      }

      return (Color)var0;
   }

   public static void loadColors() {
      getNumColors();
      getControlColor();
      getTextHighlightText();
      getTextHighlight();
   }

   public static int getNumColors() {
      int var0 = 8;
      if ((!System.getProperty("java.vendor").startsWith("Netscape") || System.getProperty("java.version").compareTo("1.1.2") > 0) && !System.getProperty("os.name").startsWith("Mac") && !System.getProperty("java.version").startsWith("1.0")) {
         try {
            ColorModel var1 = Toolkit.getDefaultToolkit().getColorModel();
            var0 = var1.getPixelSize();
            JDPUtils.numColors = var0;
         } catch (Exception var2) {
         }
      }

      if (var0 > 8) {
         JDPUtils.setColorFactor(0.83);
      }

      return var0;
   }

   public static Color getTextHighlight() {
      SystemColor var0 = null;
      if ((!System.getProperty("java.vendor").startsWith("Netscape") || System.getProperty("java.version").compareTo("1.1.2") > 0) && !System.getProperty("os.name").startsWith("Mac") && !System.getProperty("java.version").startsWith("1.0")) {
         try {
            var0 = SystemColor.textHighlight;
            JDPUtils.textHighlight = var0;
         } catch (Exception var1) {
         }
      }

      return var0;
   }
}
