import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPTemplDtlMaint extends Panel {
   JDPUser user;
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   JDPTextGrid tableContents;
   JDPTemplateMaint target;
   JDPJagg jaggSQL;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   String pfromWhereClause;
   String[][] rowKey;
   int keyCount;
   int prevColumnCount;
   int columnCount = 5;
   String currentType = "D";
   String templdsn;
   String templcstr;
   String templtbls;
   String templjoin;
   int totalRows;
   String prevtempltbls;
   TextField c_templname;
   TextField c_templdesc;
   Vector[] pullDownListV;
   List[] pullDownList;

   void loadChoices() {
   }

   void newSearch() {
      String var1 = this.pfromWhereClause;
      if (this.jdpWhereClause != null) {
         var1 = var1 + " AND " + this.jdpWhereClause.whereClause;
      }

      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
   }

   void clearFields() {
      this.c_templname.setText("");
      this.c_templdesc.setText("");
      this.loadEmptyGrid();
   }

   void loadEmptyGrid() {
      this.tableContents.currentText = new String[this.columnCount][50];
      this.tableContents.cellChanged = null;
      this.tableContents.rowChanged = null;
      this.tableContents.columnSelected = null;
      this.rowKey = new String[50][this.keyCount];
      this.tableContents.newTable();
      this.totalRows = 0;
   }

   void setGridSettings() {
      this.columnCount = 7;
      if (this.currentType.equals("E")) {
         this.columnCount = 5;
      }

      this.tableContents.columnHeader = new String[this.columnCount];
      this.tableContents.columnHeaderStyle = new int[this.columnCount];
      this.tableContents.columnStyle = new int[this.columnCount];
      this.tableContents.columnHeaderColor = new Color[this.columnCount];
      this.tableContents.columnColor = new Color[this.columnCount];
      this.tableContents.columnBGColor = new Color[this.columnCount];
      this.tableContents.columnProtected = new boolean[this.columnCount];
      this.tableContents.columnWidth = new int[this.columnCount];
      this.tableContents.rightJustify = new boolean[this.columnCount];
      this.tableContents.rowHeader = null;
      this.tableContents.columnHeight = null;
      this.tableContents.isPullDownCol = new boolean[this.columnCount];
      this.tableContents.pullDownList = new List[this.columnCount][1];

      for(int var1 = 0; var1 < this.columnCount; ++var1) {
         this.tableContents.columnHeaderStyle[var1] = 1;
         this.tableContents.columnStyle[var1] = 0;
         this.tableContents.columnHeaderColor[var1] = Color.black;
         this.tableContents.columnColor[var1] = Color.black;
         this.tableContents.columnBGColor[var1] = Color.white;
         this.tableContents.columnStyle[var1] = 0;
      }

      this.tableContents.columnHeader[0] = "Column Name";
      this.tableContents.columnHeader[1] = "Data Type";
      this.tableContents.columnHeader[2] = "Size";
      this.tableContents.columnHeader[3] = "Dec";
      this.pullDownListV = new Vector[this.columnCount];
      this.pullDownList = new List[this.columnCount];
      this.tableContents.isPullDownCol[1] = true;
      this.tableContents.pullDownList[1][0] = new List();
      JDPUtils.loadODBCList(this.tableContents.pullDownList[1][0]);
      this.tableContents.columnProtected[1] = true;
      this.tableContents.isPullDownCol[4] = true;
      this.pullDownList[4] = new List();
      if (this.columnCount == 7) {
         this.pullDownList[5] = new List();
         this.pullDownList[5].addItem("No");
         this.pullDownList[5].addItem("Yes");
         this.pullDownListV[5] = new Vector();
         this.pullDownListV[5].addElement("N");
         this.pullDownListV[5].addElement("Y");
         this.tableContents.isPullDownCol[5] = true;
         this.pullDownList[6] = new List();
         this.pullDownList[6].addItem("No");
         this.pullDownList[6].addItem("Yes");
         this.pullDownListV[6] = new Vector();
         this.pullDownListV[6].addElement("N");
         this.pullDownListV[6].addElement("Y");
      }

      this.tableContents.columnWidth[0] = 83;
      this.tableContents.columnWidth[1] = 58;
      this.tableContents.columnWidth[2] = 36;
      this.tableContents.columnWidth[3] = 36;
      this.tableContents.rightJustify[2] = true;
      this.tableContents.rightJustify[3] = true;
      if (this.currentType.equals("E")) {
         this.tableContents.columnHeader[4] = "Column SQL";
         this.tableContents.columnProtected[4] = false;
         this.tableContents.pullDownList[4][0] = this.pullDownList[4];
         this.tableContents.columnWidth[4] = 92;
      } else {
         this.tableContents.columnHeader[4] = "Key";
         this.tableContents.columnProtected[4] = true;
         this.tableContents.pullDownList[4][0] = this.pullDownList[5];
         this.tableContents.columnWidth[4] = 36;
         this.tableContents.columnHeader[5] = "Nulls";
         this.tableContents.columnWidth[5] = 36;
         this.tableContents.columnProtected[5] = true;
         this.tableContents.pullDownList[5][0] = this.pullDownList[6];
         this.tableContents.columnHeader[6] = "Default";
         this.tableContents.columnWidth[6] = 100;
      }
   }

   void retrieveHandle() {
      for(int var1 = 0; var1 < this.user.gParm.size(); ++var1) {
      }

   }

   void loadData(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      String[] var7;
      if (var1 != null) {
         var7 = var1;
      } else {
         if ((this.itemIndex = this.target.target.tree.getSelectedIndex()) < 0) {
            this.clearFields();
            return;
         }

         var7 = this.target.target.tree.getSelectedBranch();
      }

      String var8 = "SELECT c.templname," + "c.templdesc," + "c.templtype, " + "c.templdsn, " + "c.templcstr, " + "c.templtbls, " + "c.templjoin " + " FROM JDPTmpGrp b,JDPTmpTable c,JDPTmpType d" + " WHERE b.JDPSystem = c.JDPSystem AND b.JDPSystem = d.JDPSystem AND c.templtype = d.templtype AND c.groupname = b.groupname AND c.JDPSystem='" + this.user.JDPSystem + "'" + " AND b.groupdesc='" + var7[2] + "' AND c.templname='" + var7[3] + "'";
      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      this.jaggSQL.loadSettings(this.user);
      var3 = this.jaggSQL.execSQL(var8, var4);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var8);
      } else if (var3 >= 1) {
         String var6 = (String)var4.elementAt(0);
         if (var6 != null && var6.trim().compareTo("") != 0) {
            StringTokenizer var2 = new StringTokenizer(var6);
            this.c_templname.setText(var2.nextToken(var5).trim());
            this.c_templdesc.setText(var2.nextToken(var5).trim());
            this.currentType = var2.nextToken(var5).trim();
            this.templdsn = var2.nextToken(var5).trim();
            this.templcstr = var2.nextToken(var5).trim();
            this.templtbls = var2.nextToken(var5).trim();
            this.templjoin = var2.nextToken(var5).trim();
            this.columnCount = 7;
            if (this.currentType.equals("E")) {
               this.columnCount = 5;
            }

            if (this.columnCount != this.prevColumnCount) {
               this.prevColumnCount = this.columnCount;
               this.setGridSettings();
            }

            if (this.currentType.equals("E")) {
               this.loadColumns();
            }
         }

         this.loadGrid(var1);
         this.user.mainmsg.clearStatusMsg();
      } else {
         this.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
         this.clearFields();
      }
   }

   boolean saveData(int var1) {
      int var2 = 0;
      Vector var3 = new Vector();
      this.jaggSQL.getSEP();
      String var4 = "";
      String var5 = Integer.toString(JDPUtils.getODBCValue(this.tableContents.currentText[1][var1]));
      String var6;
      String var7;
      String var8;
      String var9;
      if (this.currentType.equals("E")) {
         var6 = this.tableContents.currentText[4][var1];
         var7 = "";
         var8 = "";
         var9 = "";
      } else {
         var7 = this.tableContents.currentText[4][var1];
         var8 = this.tableContents.currentText[5][var1];
         var9 = this.tableContents.currentText[6][var1];
         var6 = "";
      }

      String[] var10 = this.target.target.tree.getSelectedBranch();
      if (this.insertRequested) {
         var4 = "INSERT INTO JDPTmpDetail (JDPSystem, " + "templtype, " + "groupname, " + "templname, " + "seqno, " + "columnname, " + "columntype, " + "columnsize, " + "columnprec, " + "columnsql, " + "columnkey, " + "columnnull, " + "columndft) VALUES('" + this.user.JDPSystem + "', " + "'" + var10[1].substring(0, 1) + "', " + "'" + (String)this.target.valuea_groupname.elementAt(this.target.a_groupname.getSelectedIndex()) + "', " + "'" + this.target.a_templname.getText() + "', " + "" + Integer.toString(this.totalRows++) + ", " + "'" + this.user.u.replace(this.tableContents.currentText[0][var1], " ", "") + "', " + "" + var5 + ", " + "" + JDPUtils.tonum(this.tableContents.currentText[2][var1]) + ", " + "" + JDPUtils.tonum(this.tableContents.currentText[3][var1]) + ", " + "'" + var6 + "', " + "'" + var7 + "', " + "'" + var8 + "', " + "'" + var9 + "')";
      } else if (this.deleteRequested) {
         var4 = "DELETE FROM JDPTmpDetail" + " WHERE JDPSystem='" + this.rowKey[var1][0] + "'" + " AND templtype='" + var10[1].substring(0, 1) + "'" + " AND groupname='" + (String)this.target.valuea_groupname.elementAt(this.target.a_groupname.getSelectedIndex()) + "'" + " AND templname='" + this.target.a_templname.getText() + "'" + " AND seqno=" + this.rowKey[var1][2];
      } else {
         var4 = "UPDATE JDPTmpDetail SET columnname = '" + this.tableContents.currentText[0][var1] + "', " + "columntype = " + var5 + ", " + "columnsize = " + JDPUtils.tonum(this.tableContents.currentText[2][var1]) + ", " + "columnprec = " + JDPUtils.tonum(this.tableContents.currentText[3][var1]) + ", " + "columnsql = '" + var6 + "', " + "columnkey = '" + var7 + "', " + "columnnull = '" + var8 + "', " + "columndft = '" + var9 + "'" + " WHERE JDPSystem='" + this.user.JDPSystem + "'" + " AND templtype='" + var10[1].substring(0, 1) + "'" + " AND groupname='" + (String)this.target.valuea_groupname.elementAt(this.target.a_groupname.getSelectedIndex()) + "'" + " AND templname='" + this.target.a_templname.getText() + "'" + " AND seqno=" + this.rowKey[var1][2];
      }

      this.jaggSQL.loadSettings(this.user);
      var2 = this.jaggSQL.execSQL(var4, var3);
      if (this.user.DEBUG) {
         System.out.println("saveData CNT: " + Integer.toString(var2));
      }

      if (var2 == -1) {
         System.out.println("saveData SQL: " + var4);
         this.user.u.setSqlMessage(this.jaggSQL, var4);
         return false;
      } else {
         if (var2 == 1) {
            if (this.insertRequested) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (this.deleteRequested) {
               var4 = "UPDATE JDPTmpDetail" + " SET seqno = seqno-1" + " WHERE JDPSystem='" + this.user.JDPSystem + "'" + " AND templtype='" + var10[1].substring(0, 1) + "'" + " AND groupname='" + var10[2] + "'" + " AND templname='" + var10[3] + "'" + " AND seqno>" + this.rowKey[var1][2];
               this.jaggSQL.execSQL(var4, var3);

               for(int var11 = var1; var11 < this.rowKey.length; ++var11) {
                  int var12 = Integer.parseInt(this.rowKey[var11][2]);
                  --var12;
                  this.rowKey[var11][2] = Integer.toString(var12);
               }

               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var4);
         }

         return true;
      }
   }

   public JDPTemplDtlMaint(JDPUser var1, String var2, JDPTemplateMaint var3) {
      this.user = var1;
      this.target = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.pfromWhereClause = "FROM JDPTmpGrp b,JDPTmpTable c,JDPTmpType d WHERE b.JDPSystem = c.JDPSystem AND b.JDPSystem = d.JDPSystem AND c.templtype = d.templtype AND c.groupname = b.groupname AND (1=1)";
      this.psortChoice = new String[1];
      this.psortChoice[0] = "d.typedesc";
      this.pdisplayChoice = this.psortChoice;
      this.c_templname = new TextField("", 22);
      this.c_templdesc = new TextField("", 40);
      this.loadChoices();
      this.tableContents = new JDPTextGrid(var1);
      ((Container)this).add("Center", this.tableContents);
      var1.gParm.addElement(this);
      this.setGridSettings();
      this.loadEmptyGrid();
   }

   void checkRows() {
      int var1 = 0;
      int var2 = 0;
      int var3 = 0;
      int var4 = 1;
      int var5 = 1;

      for(int var6 = 0; var6 < this.tableContents.rowChanged.length; ++var6) {
         if (this.tableContents.rowChanged[var6]) {
            if (var6 >= this.totalRows) {
               ++var2;
            } else if (this.tableContents.currentText[0][var6].trim().equals("")) {
               ++var3;
            } else {
               ++var1;
            }
         }
      }

      for(int var7 = 0; var7 < this.tableContents.rowChanged.length; ++var7) {
         if (this.tableContents.rowChanged[var7]) {
            this.deleteRequested = false;
            this.insertRequested = false;
            if (var7 >= this.totalRows) {
               this.insertRequested = true;
               this.user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(var5++) + " of " + Integer.toString(var2) + "...", 0);
            } else if (this.tableContents.currentText[0][var7].trim().equals("")) {
               this.deleteRequested = true;
               this.user.mainmsg.setStatusMsg("Deleting row " + Integer.toString(var5++) + " of " + Integer.toString(var3) + "...", 0);
            } else {
               this.user.mainmsg.setStatusMsg("Updating row " + Integer.toString(var4++) + " of " + Integer.toString(var1) + "...", 0);
            }

            this.saveData(var7);
            this.tableContents.rowChanged[var7] = false;
         }
      }

      if (var3 > 0) {
         this.loadGrid((String[])null);
      }

   }

   void loadColumns() {
      if (this.prevtempltbls == null || !this.templtbls.equals(this.prevtempltbls)) {
         this.prevtempltbls = this.templtbls;
         int var2 = 0;
         int var4 = 0;
         String var6 = "";
         String var7 = this.jaggSQL.getSEP();
         String var8 = "abcdefghijklmnopqrstuvwxyz";
         int var9 = 0;
         if (this.templcstr.length() != 0) {
            this.pullDownList[4].clear();
            this.user.mainmsg.setStatusMsg("Loading Column definitions, please wait...", 0);
            this.jaggSQL.setDSN(this.templdsn);
            this.jaggSQL.setCSTR(this.templcstr);
            this.jaggSQL.setFCTN("SQLColumns");

            for(StringTokenizer var10 = new StringTokenizer(this.templtbls, ";"); var10.hasMoreElements(); ++var9) {
               String var11 = var10.nextToken().trim();
               int var12 = var11.indexOf(".");
               if (var12 >= 0) {
                  var11 = var11.substring(var12 + 1);
               }

               String var13 = ";;" + var11 + ";;";
               this.jaggSQL.setFCTNP(var13);
               Vector var3 = new Vector();
               var2 = this.jaggSQL.execSQL(var6, var3);
               if (var2 == -1) {
                  this.user.u.setSqlMessage(this.jaggSQL, var6);
                  return;
               }

               String var14 = var8.substring(var9, var9 + 1);
               var4 = this.jaggSQL.getRowCount();
               this.jaggSQL.getColumnCount();

               for(int var15 = 0; var15 < var4; ++var15) {
                  String var5 = (String)var3.elementAt(var15);
                  if (var5 != null && var5.trim().compareTo("") != 0) {
                     StringTokenizer var1 = new StringTokenizer(var5, var7);
                     if (var1.countTokens() >= 12) {
                        var1.nextToken().trim();
                        var1.nextToken().trim();
                        var1.nextToken().trim();
                        this.pullDownList[4].addItem(var14 + "." + var1.nextToken().trim());
                     }
                  }
               }
            }

            this.user.mainmsg.clearStatusMsg();
         }
      }
   }

   boolean checkFields() {
      return true;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectTopPanel) {
               return false;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.c_templname)) {
                     this.user.u.cursor(this.c_templdesc);
                     return true;
                  }

                  if (var1.target.equals(this.c_templdesc)) {
                     this.user.u.cursor(this.c_templname);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.c_templdesc)) {
                     this.user.u.cursor(this.c_templname);
                     return true;
                  }

                  if (var1.target.equals(this.c_templname)) {
                     this.user.u.cursor(this.c_templdesc);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target.equals(this.searchResults.resultList)) {
               this.loadData((String[])null);
               return true;
            } else if (var1.target instanceof JDPTreePicker && var1.target.equals(this.searchResults.tree)) {
               this.loadData((String[])null);
               return true;
            } else if (var1.target instanceof Button) {
               String var4 = (String)var1.arg;
               if (var4.trim().compareTo("Apply") == 0) {
                  if (this.checkFields()) {
                     this.checkRows();
                  }

                  return true;
               } else if (var4.trim().compareTo("Reset") == 0) {
                  this.loadData((String[])null);
                  return true;
               } else if (var4.trim().compareTo("Remove") == 0) {
                  this.insertRequested = false;
                  this.deleteRequested = true;
                  this.checkRows();
                  return true;
               } else {
                  if (var4.trim().compareTo("Search") == 0) {
                     this.insertRequested = false;
                     this.newSearch();
                     return true;
                  }

                  return true;
               }
            } else if (var1.target instanceof Choice) {
               return true;
            } else {
               if (var1.target instanceof TextField) {
                  if (this.jdpWhereClause != null && var1.target.equals(this.jdpWhereClause.matchConstant)) {
                     this.insertRequested = false;
                     this.deleteRequested = false;
                     this.newSearch();
                     return true;
                  }

                  this.checkFields();
                  return true;
               }

               return false;
            }
         case 1005:
            if (!(var1.target instanceof JDPTextGrid)) {
               return false;
            } else {
               int var2 = this.tableContents.getPrevRow();
               if (this.tableContents.currentText[0][var2] != null && !this.tableContents.currentText[0][var2].equals("")) {
                  if (this.tableContents.getPrevColumn() != 1 && this.tableContents.currentText[1][var2].equals("")) {
                     this.tableContents.currentText[1][var2] = "Char";
                     if (this.tableContents.currentText[2][var2].equals("")) {
                        this.tableContents.currentText[2][var2] = "10";
                     }

                     this.tableContents.currentText[3][var2] = "";
                     this.tableContents.fieldProtected[3][var2] = true;
                     this.tableContents.repaint();
                  }

                  if (this.tableContents.getPrevColumn() == 1) {
                     this.tableContents.nothingChanged = false;
                     int var3 = JDPUtils.getODBCValue(this.tableContents.currentText[1][var2]);
                     if (JDPUtils.isOdbcChar(var3) && !JDPUtils.isOdbcMemo(var3)) {
                        if (this.tableContents.currentText[2][var2].equals("")) {
                           this.tableContents.currentText[2][var2] = "10";
                        }

                        this.tableContents.currentText[3][var2] = "";
                        this.tableContents.fieldProtected[3][var2] = true;
                        this.tableContents.repaint();
                     } else if (!JDPUtils.isOdbcMemo(var3) && !JDPUtils.isOdbcInt(var3) && !JDPUtils.isOdbcDate(var3) && !JDPUtils.isOdbcBinary(var3)) {
                        if (this.tableContents.currentText[2][var2].equals("")) {
                           this.tableContents.currentText[2][var2] = "10";
                        }

                        if (this.tableContents.currentText[3][var2].equals("")) {
                           this.tableContents.currentText[3][var2] = "2";
                        }

                        this.tableContents.fieldProtected[2][var2] = false;
                        this.tableContents.fieldProtected[3][var2] = false;
                        this.tableContents.repaint();
                     } else {
                        this.tableContents.currentText[2][var2] = "";
                        this.tableContents.fieldProtected[2][var2] = true;
                        this.tableContents.currentText[3][var2] = "";
                        this.tableContents.fieldProtected[3][var2] = true;
                        this.tableContents.repaint();
                     }
                  }

                  return true;
               }

               return true;
            }
         default:
            return false;
      }
   }

   void loadGrid(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      int var6 = 0;
      new Vector();
      new Vector();
      String[] var8;
      if (var1 != null) {
         var8 = var1;
      } else {
         var8 = this.target.target.tree.getSelectedBranch();
      }

      String var9;
      if (this.currentType.equals("E")) {
         this.tableContents.columnHeader[4] = "Column SQL";
         this.tableContents.columnProtected[4] = false;
         this.tableContents.pullDownList[4][0] = this.pullDownList[4];
         this.tableContents.columnWidth[4] = 92;
         var9 = "SELECT a.JDPSystem, " + "a.templname, " + "a.seqno, " + "a.columnname, " + "a.columntype, " + "a.columnsize, " + "a.columnprec, " + "a.columnsql FROM JDPTmpDetail a,JDPTmpGrp b,JDPTmpTable c,JDPTmpType d WHERE (1=1)  AND b.JDPSystem = c.JDPSystem AND b.JDPSystem = d.JDPSystem AND a.templname = c.templname AND c.templtype = d.templtype AND a.groupname = b.groupname AND c.groupname = b.groupname " + " AND a.JDPSystem='" + this.user.JDPSystem + "'" + " AND b.groupdesc='" + var8[2] + "' AND c.templname='" + var8[3] + "'" + " ORDER BY a.JDPSystem, a.templname, a.seqno";
      } else {
         this.tableContents.columnHeader[4] = "Key";
         this.tableContents.columnProtected[4] = true;
         this.tableContents.pullDownList[4][0] = this.pullDownList[5];
         this.tableContents.columnWidth[4] = 36;
         this.tableContents.columnHeader[5] = "Nulls";
         this.tableContents.columnWidth[5] = 36;
         this.tableContents.columnProtected[5] = true;
         this.tableContents.pullDownList[5][0] = this.pullDownList[6];
         this.tableContents.columnHeader[6] = "Default";
         this.tableContents.columnWidth[6] = 100;
         var9 = "SELECT a.JDPSystem, " + "a.templname, " + "a.seqno, " + "a.columnname, " + "a.columntype, " + "a.columnsize, " + "a.columnprec, " + "a.columnkey, " + "a.columnnull, " + "a.columndft FROM JDPTmpDetail a,JDPTmpGrp b,JDPTmpTable c,JDPTmpType d WHERE (1=1)  AND b.JDPSystem = c.JDPSystem AND b.JDPSystem = d.JDPSystem AND a.templname = c.templname AND c.templtype = d.templtype AND a.groupname = b.groupname AND c.groupname = b.groupname " + " AND a.JDPSystem='" + this.user.JDPSystem + "'" + " AND b.groupdesc='" + var8[2] + "' AND c.templname='" + var8[3] + "'" + " ORDER BY a.JDPSystem, a.templname, a.seqno";
      }

      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      this.jaggSQL.loadSettings(this.user);
      var3 = this.jaggSQL.execSQL(var9, var4);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var9);
      } else {
         this.totalRows = this.jaggSQL.getRowCount();
         var6 = this.jaggSQL.getRowCount() + 20;
         this.tableContents.currentText = new String[this.columnCount][var6];
         this.tableContents.fieldProtected = new boolean[this.columnCount][var6];
         this.tableContents.cellChanged = null;
         this.tableContents.rowChanged = null;
         this.tableContents.columnSelected = null;
         this.keyCount = 3;
         this.rowKey = new String[var6][this.keyCount];

         for(int var10 = 0; var10 < var6 - 20; ++var10) {
            String var7 = (String)var4.elementAt(var10);
            if (var7 != null && var7.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var7);

               for(int var11 = 0; var11 < this.keyCount; ++var11) {
                  this.rowKey[var10][var11] = var2.nextToken(var5).trim();
               }

               for(int var15 = 0; var15 < this.columnCount; ++var15) {
                  this.tableContents.currentText[var15][var10] = var2.nextToken(var5).trim();
                  if (var15 == 1) {
                     this.user.u.listSelect(this.tableContents.pullDownList[var15][0], JDPUtils.getODBCValue(Integer.parseInt(this.tableContents.currentText[var15][var10])));
                     this.tableContents.currentText[var15][var10] = this.tableContents.pullDownList[var15][0].getSelectedItem();
                  }

                  if (this.currentType.equals("D") && var15 == 4) {
                     this.tableContents.pullDownList[var15][0].select(this.pullDownListV[5].indexOf(this.tableContents.currentText[var15][var10]));
                     this.tableContents.currentText[var15][var10] = this.tableContents.pullDownList[var15][0].getSelectedItem();
                  }

                  if (this.currentType.equals("D") && var15 == 5) {
                     this.tableContents.pullDownList[var15][0].select(this.pullDownListV[6].indexOf(this.tableContents.currentText[var15][var10]));
                     this.tableContents.currentText[var15][var10] = this.tableContents.pullDownList[var15][0].getSelectedItem();
                  }
               }

               int var16 = JDPUtils.getODBCValue(this.tableContents.currentText[1][var10]);
               if (JDPUtils.isOdbcChar(var16) && !JDPUtils.isOdbcMemo(var16)) {
                  if (this.tableContents.currentText[2][var10].equals("")) {
                     this.tableContents.currentText[2][var10] = "10";
                  }

                  this.tableContents.currentText[3][var10] = "";
                  this.tableContents.fieldProtected[3][var10] = true;
                  this.tableContents.repaint();
               } else if (!JDPUtils.isOdbcMemo(var16) && !JDPUtils.isOdbcInt(var16) && !JDPUtils.isOdbcDate(var16) && !JDPUtils.isOdbcBinary(var16)) {
                  if (this.tableContents.currentText[2][var10].equals("")) {
                     this.tableContents.currentText[2][var10] = "10";
                  }

                  if (this.tableContents.currentText[3][var10].equals("")) {
                     this.tableContents.currentText[3][var10] = "2";
                  }

                  this.tableContents.fieldProtected[2][var10] = false;
                  this.tableContents.fieldProtected[3][var10] = false;
                  this.tableContents.repaint();
               } else {
                  this.tableContents.currentText[2][var10] = "";
                  this.tableContents.fieldProtected[2][var10] = true;
                  this.tableContents.currentText[3][var10] = "";
                  this.tableContents.fieldProtected[3][var10] = true;
                  this.tableContents.repaint();
               }

               if (this.currentType.equals("D") && (this.tableContents.currentText[5][var10] == null || this.tableContents.currentText[5][var10].equals(""))) {
                  this.tableContents.currentText[5][var10] = "No";
               }
            }
         }

         for(int var14 = var6 - 20; var14 < var6; ++var14) {
            for(int var17 = 0; var17 < this.keyCount; ++var17) {
               this.rowKey[var14][var17] = this.rowKey[0][var17];
            }
         }

         this.tableContents.newTable();
         this.user.mainmsg.clearStatusMsg();
      }
   }
}
