import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPUserAuth extends JDPClassLayout {
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   JDPPopupMessage popuppanel;
   TextField username;
   TextField firstname;
   TextField lastname;
   TextField userstatus;
   TextField initmenu;
   TextField menuauth1;
   TextField menuauth2;
   TextField menuauth3;
   TextField menuauth4;
   TextField menuauth5;
   TextField menuauthlvl1;
   TextField menuauthlvl2;
   TextField menuauthlvl3;
   TextField menuauthlvl4;
   TextField menuauthlvl5;
   TextField jdpsystem0;
   String pfromWhereClause;

   void loadUser() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = super.user.jaggSQL.getSEP();
      this.insertRequested = false;
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      String var6 = this.searchResults.recordKey0[this.itemIndex];
      this.username.setText(this.searchResults.recordKey1[this.itemIndex]);
      this.firstname.setText(this.searchResults.recordKey2[this.itemIndex]);
      this.lastname.setText(this.searchResults.recordKey3[this.itemIndex]);
      String var7 = this.searchResults.recordKey4[this.itemIndex];
      if (var7.compareTo("A") == 0) {
         this.userstatus.setText("Active");
      }

      if (var7.compareTo("P") == 0) {
         this.userstatus.setText("Pending");
      }

      if (var7.compareTo("S") == 0) {
         this.userstatus.setText("Suspended");
      }

      if (var7.compareTo("C") == 0) {
         this.userstatus.setText("Cancelled");
      }

      if (var7.compareTo("X") == 0) {
         this.userstatus.setText("Deleted");
      }

      if (var7.compareTo("F") == 0) {
         this.userstatus.setText("Free");
      }

      if (var7.compareTo("G") == 0) {
         this.userstatus.setText("Guest");
      }

      String var8 = "SELECT initmenu,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5," + "menulvl1,menulvl2,menulvl3,menulvl4,menulvl5 " + "FROM JDPMenuAuth WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND userid = " + var6;
      if (super.user.DEBUG) {
         System.out.println("JDPUserAuth/loadUser SQL: " + var8);
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var2 = super.user.jaggSQL.execSQL(var8, var3);
      if (super.user.DEBUG) {
         System.out.println("JDPUserAuth/loadUser CNT: " + Integer.toString(var2));
      }

      if (var2 == -1) {
         super.user.u.setSqlMessage(super.user.jaggSQL, var8);
      } else if (var2 == 1) {
         String var5 = (String)var3.elementAt(0);
         if (var5 != null && var5.trim().compareTo("") != 0) {
            StringTokenizer var1 = new StringTokenizer(var5);
            this.initmenu.setText(var1.nextToken(var4).trim());
            this.menuauth1.setText(var1.nextToken(var4).trim());
            this.menuauth2.setText(var1.nextToken(var4).trim());
            this.menuauth3.setText(var1.nextToken(var4).trim());
            this.menuauth4.setText(var1.nextToken(var4).trim());
            this.menuauth5.setText(var1.nextToken(var4).trim());
            this.menuauthlvl1.setText(var1.nextToken(var4).trim());
            this.menuauthlvl2.setText(var1.nextToken(var4).trim());
            this.menuauthlvl3.setText(var1.nextToken(var4).trim());
            this.menuauthlvl4.setText(var1.nextToken(var4).trim());
            this.menuauthlvl5.setText(var1.nextToken(var4).trim());
         }

         super.user.mainmsg.clearStatusMsg();
      } else {
         super.user.mainmsg.setStatusMsg("No authorities exist for this user.", 10);
         this.initmenu.setText("Main");
         this.menuauth1.setText("");
         this.menuauth2.setText("");
         this.menuauth3.setText("");
         this.menuauth4.setText("");
         this.menuauth5.setText("");
         this.menuauthlvl1.setText("0");
         this.menuauthlvl2.setText("0");
         this.menuauthlvl3.setText("0");
         this.menuauthlvl4.setText("0");
         this.menuauthlvl5.setText("0");
         this.insertRequested = true;
      }
   }

   void newSearch() {
      String var1 = this.pfromWhereClause + " AND " + this.jdpWhereClause.whereClause;
      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
   }

   boolean saveUser() {
      int var1 = 0;
      Vector var2 = new Vector();
      super.user.jaggSQL.getSEP();
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      if (this.itemIndex < 0) {
         super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
         return false;
      } else {
         String var3 = this.searchResults.recordKey0[this.itemIndex];
         String var4 = this.initmenu.getText().trim();
         String var5 = "";
         if (this.insertRequested) {
            var5 = "INSERT INTO JDPMenuAuth (JDPSystem,userid,initmenu,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + super.user.JDPSystem + "'," + var3 + ",'" + var4 + "'," + "'" + this.menuauth1.getText() + "','" + this.menuauth2.getText() + "', " + "'" + this.menuauth3.getText() + "','" + this.menuauth4.getText() + "', " + "'" + this.menuauth5.getText() + "'," + this.menuauthlvl1.getText() + ", " + this.menuauthlvl2.getText() + "," + this.menuauthlvl3.getText() + ", " + this.menuauthlvl4.getText() + "," + this.menuauthlvl5.getText() + ")";
         } else {
            var5 = "UPDATE JDPMenuAuth SET initmenu = '" + var4 + "', " + "menuauth1 = '" + this.menuauth1.getText() + "',menuauth2 = '" + this.menuauth2.getText() + "', " + "menuauth3 = '" + this.menuauth3.getText() + "',menuauth4 = '" + this.menuauth4.getText() + "', " + "menuauth5 = '" + this.menuauth5.getText() + "',menulvl1 = " + this.menuauthlvl1.getText() + ", " + "menulvl2 = " + this.menuauthlvl2.getText() + ",menulvl3 = " + this.menuauthlvl3.getText() + ", " + "menulvl4 = " + this.menuauthlvl4.getText() + ",menulvl5 = " + this.menuauthlvl5.getText() + " " + "WHERE JDPSystem = '" + super.user.JDPSystem + "' " + "AND userid = " + var3;
         }

         if (super.user.DEBUG) {
            System.out.println("JDPUserAuth/saveUser SQL: " + var5);
         }

         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var1 = super.user.jaggSQL.execSQL(var5, var2);
         if (super.user.DEBUG) {
            System.out.println("JDPUserAuth/saveUser CNT: " + Integer.toString(var1));
         }

         if (var1 == -1) {
            super.user.u.setSqlMessage(super.user.jaggSQL, var5);
            return false;
         } else {
            if (var1 == 1) {
               if (this.insertRequested) {
                  super.user.mainmsg.setStatusMsg("User authorities successfully added.", 3);
               } else {
                  super.user.mainmsg.setStatusMsg("User authorities successfully updated.", 3);
               }

               this.insertRequested = false;
            } else {
               super.user.mainmsg.setStatusMsg("User authority update failed", 10);
            }

            return true;
         }
      }
   }

   boolean checkFields() {
      if (!super.user.u.isnumeric(this.menuauthlvl1, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl2, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl3, super.user.mainmsg)) {
         return false;
      } else if (!super.user.u.isnumeric(this.menuauthlvl4, super.user.mainmsg)) {
         return false;
      } else {
         return super.user.u.isnumeric(this.menuauthlvl5, super.user.mainmsg);
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (var1.target.equals(this.initmenu)) {
                  super.user.u.cursor(this.menuauth1);
                  return true;
               }

               if (var1.target.equals(this.menuauth1)) {
                  super.user.u.cursor(this.menuauthlvl1);
                  return true;
               }

               if (var1.target.equals(this.menuauthlvl1)) {
                  super.user.u.cursor(this.menuauth2);
                  return true;
               }

               if (var1.target.equals(this.menuauth2)) {
                  super.user.u.cursor(this.menuauthlvl2);
                  return true;
               }

               if (var1.target.equals(this.menuauthlvl2)) {
                  super.user.u.cursor(this.menuauth3);
                  return true;
               }

               if (var1.target.equals(this.menuauth3)) {
                  super.user.u.cursor(this.menuauthlvl3);
                  return true;
               }

               if (var1.target.equals(this.menuauthlvl3)) {
                  super.user.u.cursor(this.menuauth4);
                  return true;
               }

               if (var1.target.equals(this.menuauth4)) {
                  super.user.u.cursor(this.menuauthlvl4);
                  return true;
               }

               if (var1.target.equals(this.menuauthlvl4)) {
                  super.user.u.cursor(this.menuauth5);
                  return true;
               }

               if (var1.target.equals(this.menuauth5)) {
                  super.user.u.cursor(this.menuauthlvl5);
                  return true;
               }

               if (var1.target.equals(this.menuauthlvl5)) {
                  super.user.u.cursor(this.initmenu);
                  return true;
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.searchResults.resultList)) {
               this.loadUser();
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Apply") == 0) {
                     if (this.checkFields()) {
                        this.saveUser();
                     }

                     return true;
                  }

                  if (var2.compareTo("Reset") == 0) {
                     this.loadUser();
                     return true;
                  }

                  if (var2.compareTo("Search") == 0) {
                     this.newSearch();
                     return true;
                  }
               }

               if (var1.target instanceof Choice) {
                  return true;
               }

               if (var1.target instanceof TextField) {
                  this.checkFields();
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      String var8 = "userid,username,firstname,lastname,status";
      this.pfromWhereClause = "FROM JDPUser WHERE (jdpsystem0 = '" + var1.JDPSystem + "' " + "OR jdpsystem1 = '" + var1.JDPSystem + "' " + "OR jdpsystem2 = '" + var1.JDPSystem + "' " + "OR jdpsystem3 = '" + var1.JDPSystem + "' " + "OR jdpsystem4 = '" + var1.JDPSystem + "' " + "OR jdpsystem5 = '" + var1.JDPSystem + "' " + "OR jdpsystem6 = '" + var1.JDPSystem + "' " + "OR jdpsystem7 = '" + var1.JDPSystem + "' " + "OR jdpsystem8 = '" + var1.JDPSystem + "' " + "OR jdpsystem9 = '" + var1.JDPSystem + "')";
      this.psortChoice = new String[3];
      this.psortChoice[0] = "username";
      this.psortChoice[1] = "firstname";
      this.psortChoice[2] = "lastname";
      String[] var9 = new String[]{"Sort by User Name", "Sort by First Name", "Sort by Last Name"};
      this.pdisplayChoice = this.psortChoice;
      String var10 = var9[0];
      boolean var11 = true;
      String var12 = "Total Entries:";
      this.username = new TextField("", 20);
      this.firstname = new TextField("", 20);
      this.lastname = new TextField("", 20);
      this.userstatus = new TextField("", 10);
      this.initmenu = new TextField("", 20);
      this.username.setEditable(false);
      this.firstname.setEditable(false);
      this.lastname.setEditable(false);
      this.userstatus.setEditable(false);
      this.menuauth1 = new TextField("", 13);
      this.menuauth2 = new TextField("", 13);
      this.menuauth3 = new TextField("", 13);
      this.menuauth4 = new TextField("", 13);
      this.menuauth5 = new TextField("", 13);
      this.menuauthlvl1 = new TextField("", 3);
      this.menuauthlvl2 = new TextField("", 3);
      this.menuauthlvl3 = new TextField("", 3);
      this.menuauthlvl4 = new TextField("", 3);
      this.menuauthlvl5 = new TextField("", 3);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Username:"));
      ((Container)var7).add("Right", this.username);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "First Name:"));
      ((Container)var7).add("Right", this.firstname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Last Name:"));
      ((Container)var7).add("Right", this.lastname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Status:"));
      ((Container)var7).add("Right", this.userstatus);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Initial Menu:"));
      ((Container)var7).add("Right", this.initmenu);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Authorization Codes/Levels:"));
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new JDPLineLayout(1));
      ((Container)var13).add("Left", this.menuauth1);
      ((Container)var13).add("Left", this.menuauthlvl1);
      ((Container)var7).add("Right", var13);
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout(1));
      ((Container)var14).add("Left", this.menuauth2);
      ((Container)var14).add("Left", this.menuauthlvl2);
      ((Container)var7).add("Right", var14);
      Panel var15 = new Panel();
      ((Container)var15).setLayout(new JDPLineLayout(1));
      ((Container)var15).add("Left", this.menuauth3);
      ((Container)var15).add("Left", this.menuauthlvl3);
      ((Container)var7).add("Right", var15);
      Panel var16 = new Panel();
      ((Container)var16).setLayout(new JDPLineLayout(1));
      ((Container)var16).add("Left", this.menuauth4);
      ((Container)var16).add("Left", this.menuauthlvl4);
      ((Container)var7).add("Right", var16);
      Panel var17 = new Panel();
      ((Container)var17).setLayout(new JDPLineLayout(1));
      ((Container)var17).add("Left", this.menuauth5);
      ((Container)var17).add("Left", this.menuauthlvl5);
      ((Container)var7).add("Right", var17);
      ((Container)var6).add("Center", var7);
      String[] var18 = new String[]{"Apply", "Reset"};
      int[] var19 = new int[]{0, 6};
      JDPButtons var20 = new JDPButtons(var1, var18, var19, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", var20);
      this.popuppanel.addComponent(var20.button[0], "Apply Changes", "Save changes to the database");
      this.popuppanel.addComponent(var20.button[1], "Undo Changes", "Undo changes by reloading the record");
      ((Container)var4).add("Center", var6);
      String[] var21 = new String[]{"Account Name", "First Name", "Last Name", "User Status"};
      String[] var22 = new String[]{"username", "firstname", "lastname", "status"};
      String[][] var23 = new String[4][7];
      var23[0][0] = "Begins with";
      var23[0][1] = "Contains";
      var23[1][0] = "Begins with";
      var23[1][1] = "Contains";
      var23[2][0] = "Begins with";
      var23[2][1] = "Contains";
      var23[3][0] = "is Active";
      var23[3][1] = "is Pending";
      var23[3][2] = "is Suspended";
      var23[3][3] = "is Cancelled";
      var23[3][4] = "is Deleted";
      var23[3][5] = "is Free";
      var23[3][6] = "is a Guest";
      String[][] var24 = new String[4][7];
      var24[0][0] = " like ";
      var24[0][1] = " like ";
      var24[1][0] = " like ";
      var24[1][1] = " like ";
      var24[2][0] = " like ";
      var24[2][1] = " like ";
      var24[3][0] = "='A'";
      var24[3][1] = "='P'";
      var24[3][2] = "='S'";
      var24[3][3] = "='C'";
      var24[3][4] = "='X'";
      var24[3][5] = "='F'";
      var24[3][6] = "='G'";
      boolean[] var25 = new boolean[]{true, true, true, false};
      int[] var26 = new int[]{20, 20, 20, 0};
      this.jdpWhereClause = new JDPWhereClause(var1, var2, "UserAuth", true, var21[0], var21, var22, var23, var24, (String[][])null, (String[][])null, var26, var25);
      this.searchResults = new JDPSearchResults(var1, (Container)var2, false, var1.jaggSQL, false, var8, (String[])null, this.pfromWhereClause, var9, this.psortChoice, this.pdisplayChoice, var10, var11, var12);
      this.searchResults.setIcon(5);
      Panel var27 = new Panel();
      ((Container)var27).setLayout(new BorderLayout());
      ((Container)var27).add("North", this.jdpWhereClause);
      ((Container)var27).add("Center", this.searchResults);
      ((Container)var4).add("West", var27);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "User Menu Authorization", var4, "North"));
      this.searchResults.loadList();
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
