import java.awt.BorderLayout;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.List;
import java.awt.Panel;
import java.util.StringTokenizer;
import java.util.Vector;

public class LoadGridPrice extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPTextGrid DetailGrid1;
   String prevProdid;
   int prevTablerow = -1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      new CheckboxGroup();
      this.Main = new Panel();
      this.DetailGrid1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.DetailGrid1);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1005:
            if (var1.target.equals(this.DetailGrid1)) {
               this.DetailGrid1FetchPrice();
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
   }

   public void DetailGrid1Main() {
      this.DetailGrid1SetGridSettings();
   }

   public void DetailGrid1LoadGrid(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var4 = 0;
         Vector var5 = new Vector();
         String var6 = this.jaggSQL.getSEP();
         int var7 = 0;
         byte var9 = 3;
         new Vector();
         new Vector();
         String var10 = "SELECT title_id, title_id, title, price FROM dbo_titles WHERE (1=1)  ";
         if (var1.length > 0 && var1[0] != null) {
            var10 = var10 + " AND title_id='" + var1[0] + "'";
         }

         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         var4 = this.jaggSQL.execSQL(var10, var5);
         if (var4 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var10);
         } else {
            var2.totalDataRows = this.jaggSQL.getRowCount();
            var7 = this.jaggSQL.getRowCount() + 20;
            var2.currentText = new String[var9][var7];
            var2.cellChanged = null;
            var2.rowChanged = null;
            var2.columnSelected = null;
            byte var11 = 1;
            var2.rowKey = new String[var7][var11];
            var2.recordLockValue = new String[var7];

            for(int var13 = 0; var13 < var7 - 20; ++var13) {
               String var8 = (String)var5.elementAt(var13);
               if (var8 != null && var8.trim().compareTo("") != 0) {
                  StringTokenizer var3 = new StringTokenizer(var8);

                  for(int var14 = 0; var14 < var11; ++var14) {
                     var2.rowKey[var13][var14] = var3.nextToken(var6).trim();
                  }

                  for(int var15 = 0; var15 < var9; ++var15) {
                     String var12 = var3.nextToken(var6).trim();
                     var2.currentText[var15][var13] = var12;
                     if (var15 == 1 && var2.pullDownValue[1][0].indexOf(var12) >= 0) {
                        var2.currentText[var15][var13] = var2.pullDownList[1][0].getItem(var2.pullDownValue[1][0].indexOf(var12));
                     }
                  }
               }
            }

            for(int var18 = var7 - 20; var18 < var7; ++var18) {
               for(int var19 = 0; var19 < var1.length; ++var19) {
                  var2.rowKey[var18][var19] = var1[var19];
               }
            }

            var2.newTable();
            this.user.mainmsg.clearStatusMsg();
         }
      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   public void DetailGrid1UpdateRows(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var3 = 0;
         int var4 = 0;
         int var5 = 1;
         int var6 = 1;
         boolean var7 = false;

         for(int var8 = 0; var8 < var2.rowChanged.length; ++var8) {
            if (var2.rowChanged[var8]) {
               if (var8 >= var2.totalDataRows) {
                  ++var4;
               } else {
                  ++var3;
               }
            }
         }

         for(int var9 = 0; var9 < var2.rowChanged.length; ++var9) {
            if (var2.rowChanged[var9]) {
               if (var9 >= var2.totalDataRows) {
                  this.user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(var6++) + " of " + Integer.toString(var4) + "...", 0);
                  this.DetailGrid1SaveData(var9, "I");
               } else {
                  this.user.mainmsg.setStatusMsg("Updating row " + Integer.toString(var5++) + " of " + Integer.toString(var3) + "...", 0);
                  if (this.DetailGrid1SaveData(var9, "U")) {
                     var7 = true;
                  }
               }

               var2.rowChanged[var9] = false;
            }
         }

         if (var4 > 0 || var7) {
            this.DetailGrid1LoadGrid(var1);
         }

      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   public void DetailGrid1DeleteRows(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var3 = 0;
         int var4 = 1;

         for(int var5 = 0; var5 < var2.rowChanged.length; ++var5) {
            if (var2.rowSelected[var5]) {
               ++var3;
            }
         }

         for(int var6 = 0; var6 < var2.rowChanged.length; ++var6) {
            if (var2.rowSelected[var6]) {
               this.user.mainmsg.setStatusMsg("Deleting row " + Integer.toString(var4++) + " of " + Integer.toString(var3) + "...", 0);
               this.DetailGrid1SaveData(var6, "D");
            }
         }

         if (var3 > 0) {
            this.DetailGrid1LoadGrid(var1);
         }

      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   boolean DetailGrid1SaveData(int var1, String var2) {
      JDPTextGrid var3 = this.DetailGrid1;
      int var4 = 0;
      Vector var5 = new Vector();
      this.jaggSQL.getSEP();
      String var6 = "";
      String var7 = null;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      if (var2.equals("I")) {
         var6 = "INSERT INTO dbo_titles (title_id, title, price, type, pub_id, advance, royalty, ytd_sales, notes, pubdate) VALUES('" + this.user.u.replace(var3.currentText[0][var1], "'", "''") + "', " + "'" + (String)var3.pullDownValue[1][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[1][0], var3.currentText[1][var1])) + "', " + "" + JDPUtils.tonum(var3.currentText[2][var1]) + ", " + "'', " + "'', " + "0, " + "0, " + "0, " + "'', " + "'')";
      } else if (var2.equals("D")) {
         var6 = "DELETE FROM dbo_titles WHERE title_id='" + var3.rowKey[var1][0] + "'";
         if (var3.recordLockValue[var1] != null) {
            var7 = var6;
         }
      } else {
         var6 = "UPDATE dbo_titles SET title = '" + (String)var3.pullDownValue[1][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[1][0], var3.currentText[1][var1])) + "', " + "price = " + JDPUtils.tonum(var3.currentText[2][var1]) + "" + " WHERE title_id='" + var3.rowKey[var1][0] + "'";
         if (var3.recordLockValue[var1] != null) {
            var7 = var6;
         }
      }

      var4 = this.jaggSQL.execSQL(var6, var5);
      if (this.user.DEBUG) {
         System.out.println("saveData CNT: " + Integer.toString(var4));
      }

      if (var4 == 0 && var7 != null) {
         String[] var8 = new String[]{"Reload", "Update"};
         int[] var9 = new int[]{6, 0};
         JDPMessageDialog var10 = new JDPMessageDialog(this.user, this.user.jdpMainWindow, "Update failed...", "The record has been changed by another user...", var8, var9);
         ((JDPDialog)var10).display();
         if (var10.getPressedButton() != 1) {
            return true;
         }

         var5 = new Vector();
         var4 = this.jaggSQL.execSQL(var7, var5);
      }

      if (var4 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var6);
         return false;
      } else {
         if (var4 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var6);
         }

         return var7 != null;
      }
   }

   public void DetailGrid1LoadEmptyGrid() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 3;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void DetailGrid1SetGridSettings() {
      if (this.DetailGrid1 == null) {
         this.DetailGrid1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 3;
      var1.columnHeader = new String[var2];
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[1] = true;
      var1.columnWidth[0] = 56;
      var1.columnWidth[1] = 358;
      var1.columnWidth[2] = 92;
      var1.rightJustify[2] = true;
      var1.columnHeader[0] = "Title Id";
      var1.columnHeader[1] = "Title";
      var1.columnHeader[2] = "Price";
      this.DetailGrid1LoadEmptyGrid();
      this.DetailGrid1LoadChoices();
   }

   void DetailGrid1LoadChoices() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 3;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      var1.isPullDownCol = new boolean[var2];
      var1.pullDownList = new List[var2][1];
      var1.isPullDownCol[1] = true;
      var1.pullDownList[1][0] = new List();
      var1.pullDownValue[1][0] = new Vector();
      new JDPLoadChoice(this.user, this.jaggSQL, var1.pullDownList[1][0], "title", "title", "dbo_titles", "(1=1)", var1.pullDownValue[1][0]);
   }

   public void DetailGrid1Method() {
   }

   public void DetailGrid1FetchPrice() {
      JDPTextGrid var1 = this.DetailGrid1;
      int var2 = var1.getPrevRow();
      String var3 = var1.currentText[1][var2];
      if (this.prevProdid == null || !this.prevProdid.equals(var3) || var2 != this.prevTablerow) {
         this.prevProdid = var3;
         this.prevTablerow = var2;
         int var5 = 0;
         Vector var6 = new Vector();
         this.jaggSQL.getSEP();
         new Vector();
         new Vector();
         String var8 = "SELECT price FROM dbo_titles WHERE title = '";
         var8 = var8 + var3;
         var8 = var8 + "'";
         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         var5 = this.jaggSQL.execSQL(var8, var6);
         if (var5 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var8);
         } else if (var5 != 0) {
            String var7 = (String)var6.elementAt(0);
            if (var7 != null && var7.trim().compareTo("") != 0) {
               StringTokenizer var4 = new StringTokenizer(var7);
               var1.currentText[2][var2] = var4.nextToken();
               this.JDPMaskEditMain.formatFloat(var1, 2, var2, "$999,999,999,999.00");
            }

            this.user.mainmsg.clearStatusMsg();
         }
      }
   }
}
