import java.util.Date;

public class NextAvailableNumberEntity {
   JDPJagg jaggSQL;
   JDPSubsystemMgr manager;
   int nextAvailableNumber;
   JDPJob thisJob;

   public NextAvailableNumberEntity(JDPSubsystemMgr var1, JDPJob var2) {
      this.manager = var1;
      this.thisJob = var2;
      var2.setInstance(this);
      var2.appendJobLog("Job started on " + (new Date()).toString());

      while(!var1.shutdownRequested && this.nextAvailableNumber < 20) {
         try {
            Thread.sleep(10000L);
         } catch (Exception var3) {
         }
      }

      var2.appendJobLog("Next available number reached " + Integer.toString(this.nextAvailableNumber));
      var2.appendJobLog("Job completed on " + (new Date()).toString());
   }

   public int getNextAvailableNumber() {
      return this.nextAvailableNumber++;
   }

   public void setNextAvailableNumber(int var1) {
      this.nextAvailableNumber = var1;
   }
}
