import java.awt.BorderLayout;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Panel;
import java.util.StringTokenizer;
import java.util.Vector;

public class PublisherTitles extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPTextGrid ReportLayout1;
   JDPSearchResults ResultList1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      new CheckboxGroup();
      this.Main = new Panel();
      this.ReportLayout1Main();
      this.ResultList1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ReportLayout1);
      this.Main.add("West", this.ResultList1);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.ResultList1)) {
               this.ReportLayout1LoadGrid(this.ResultList1.getSelectedKey());
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
   }

   public void ReportLayout1Main() {
      this.ReportLayout1SetGridSettings();
   }

   public void ReportLayout1LoadGrid(String[] var1) {
      JDPTextGrid var2 = this.ReportLayout1;
      if (var1 != null && var1.length >= 0) {
         int var4 = 0;
         Vector var5 = new Vector();
         String var6 = this.jaggSQL.getSEP();
         int var7 = 0;
         byte var11 = 9;
         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
         this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
         this.jaggSQL.setJdbcSuffix("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setCSTR(" ");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         new Vector();
         new Vector();
         String var12 = "SELECT pub_id, title_id, title, type, price, advance, royalty, ytd_sales, format(pubdate, 'mm/dd/yy') FROM dbo_titles WHERE (1=1)  ";
         if (var1.length > 0 && var1[0] != null) {
            var12 = var12 + " AND pub_id='" + var1[0] + "'" + " ORDER BY pub_id";
         }

         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var4 = this.jaggSQL.execSQL(var12, var5);
         if (var4 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var12);
         } else {
            var7 = this.jaggSQL.getRowCount();
            var2.currentText = new String[var11][var7 + 30];
            var2.cellFont = new Font[var11][var7 + 30];
            var2.gridColor = Color.white;
            boolean[] var13 = new boolean[var11];
            String[] var14 = new String[var11];
            boolean[] var15 = new boolean[9];
            boolean[] var16 = new boolean[9];
            byte var17 = 1;
            var16[0] = true;
            var13[4] = true;
            var13[5] = true;
            var13[7] = true;
            float[][] var9 = new float[1][1];
            float[][] var10 = new float[1][1];
            int var18 = 0;
            int var19 = var11 / 2 - 1;
            if (var19 < 0) {
               var19 = 0;
            }

            var2.currentText[var19][1] = "Publisher Titles Report";
            var2.cellFont[var19][1] = new Font(this.user.plainFont.getName(), 1, this.user.plainFont.getSize() + 4);

            for(int var20 = 0; var20 < var11; ++var20) {
               var2.cellFont[var20][3] = this.user.boldFont;
            }

            var2.currentText[0][3] = "Pub Id";
            var2.currentText[1][3] = "Title Id";
            var2.currentText[2][3] = "Title";
            var2.currentText[3][3] = "Type";
            var2.currentText[4][3] = "Price";
            var2.currentText[5][3] = "Advance";
            var2.currentText[6][3] = "Royalty";
            var2.currentText[7][3] = "Ytd Sales";
            var2.currentText[8][3] = "Pubdate";
            var18 = 4;
            var9 = new float[var17][var11];
            var10 = new float[var17][var11];

            int var21;
            for(var21 = 0; var21 < var7; ++var21) {
               String var8 = (String)var5.elementAt(var21);
               if (var8 != null && var8.trim().compareTo("") != 0) {
                  StringTokenizer var3 = new StringTokenizer(var8);

                  for(int var22 = 0; var22 < var11; ++var22) {
                     var2.currentText[var22][var21 + var18] = var3.nextToken(var6).trim();
                     if (var2.maskEdit[var22] != null) {
                        if (var2.maskType[var22] == "Float") {
                           var2.currentText[var22][var21 + var18] = this.JDPMaskEditMain.formatFloat(var2.currentText[var22][var21 + var18], var2.maskEdit[var22]);
                        } else {
                           var2.currentText[var22][var21 + var18] = this.JDPMaskEditMain.formatString(var2.currentText[var22][var21 + var18], var2.maskEdit[var22]);
                        }
                     }
                  }

                  for(int var23 = var11 - 1; var23 >= 0; --var23) {
                     String var24 = var2.currentText[var23][var21 + var18];
                     if (var17 > var23 && var21 > 0) {
                        if (var24.equals(var14[var23])) {
                           var2.currentText[var23][var21 + var18] = "";
                        } else {
                           if (var15[var23]) {
                              for(int var25 = 0; var25 < var11; ++var25) {
                                 var2.currentText[var25][var21 + var18 + 1] = var2.currentText[var25][var21 + var18];
                                 var2.currentText[var25][var21 + var18] = "";
                                 var2.cellFont[var25][var21 + var18 + 1] = var2.cellFont[var25][var21 + var18];
                                 var2.cellFont[var25][var21 + var18] = null;
                              }

                              var2.currentText[var23][var21 + var18] = "Subtotal";
                              var2.cellFont[var23][var21 + var18] = this.user.boldFont;

                              for(int var26 = var23 + 1; var26 < var11; ++var26) {
                                 if (var13[var26]) {
                                    var2.currentText[var26][var21 + var18] = this.JDPMaskEditMain.formatFloat(var9[var23][var26], var2.maskEdit[var26]);
                                    var2.cellFont[var26][var21 + var18] = this.user.boldFont;
                                 }

                                 var9[var23][var26] = 0.0F;
                              }

                              ++var18;
                           }

                           var2.currentText[var23][var21 + var18] = var24;
                        }
                     }

                     if (var17 > 0 && var21 > 0) {
                        try {
                           float var40 = Float.valueOf(this.JDPMaskEditMain.stripFloat(var14[var23]));

                           for(int var42 = 0; var42 < var17; ++var42) {
                              var9[var42][var23] += var40;
                              var10[var42][var23] += var40;
                           }
                        } catch (Exception var28) {
                        }
                     }

                     var14[var23] = var24;
                  }
               }
            }

            for(int var34 = 0; var34 < var11; ++var34) {
               try {
                  float var35 = Float.valueOf(this.JDPMaskEditMain.stripFloat(var14[var34]));

                  for(int var37 = 0; var37 < var17; ++var37) {
                     var9[var37][var34] += var35;
                     var10[var37][var34] += var35;
                  }
               } catch (Exception var27) {
               }
            }

            for(int var36 = var11 - 1; var36 >= 0; --var36) {
               if (var17 > var36 && var15[var36]) {
                  var2.currentText[var36][var21 + var18] = "Subtotal";
                  var2.cellFont[var36][var21 + var18] = this.user.boldFont;

                  for(int var38 = var36 + 1; var38 < var11; ++var38) {
                     if (var13[var38]) {
                        var2.currentText[var38][var21 + var18] = this.JDPMaskEditMain.formatFloat(var9[var36][var38], var2.maskEdit[var38]);
                        var2.cellFont[var38][var21 + var18] = this.user.boldFont;
                     }
                  }

                  ++var18;
               }
            }

            for(int var39 = var11 - 1; var39 >= 0; --var39) {
               if (var17 > var39 && var16[var39]) {
                  var2.currentText[var39][var21 + var18] = "Total";
                  var2.cellFont[var39][var21 + var18] = this.user.boldFont;

                  for(int var41 = var39 + 1; var41 < var11; ++var41) {
                     if (var13[var41]) {
                        var2.currentText[var41][var21 + var18] = this.JDPMaskEditMain.formatFloat(var10[var39][var41], var2.maskEdit[var41]);
                        var2.cellFont[var41][var21 + var18] = this.user.boldFont;
                     }
                  }

                  ++var18;
               }
            }

            var2.newTable();
            this.user.mainmsg.clearStatusMsg();
         }
      } else {
         this.ReportLayout1LoadEmptyGrid();
      }
   }

   public void ReportLayout1LoadEmptyGrid() {
      JDPTextGrid var1 = this.ReportLayout1;
      byte var2 = 9;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void ReportLayout1SetGridSettings() {
      if (this.ReportLayout1 == null) {
         this.ReportLayout1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.ReportLayout1;
      byte var2 = 9;
      var1.columnHeader = null;
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;
      var1.maskEdit = new String[var2];
      var1.maskType = new String[var2];

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[0] = true;
      var1.columnProtected[1] = true;
      var1.columnProtected[2] = true;
      var1.columnProtected[3] = true;
      var1.columnProtected[4] = true;
      var1.columnProtected[5] = true;
      var1.columnProtected[6] = true;
      var1.columnProtected[7] = true;
      var1.columnProtected[8] = true;
      var1.columnWidth[0] = 44;
      var1.columnWidth[1] = 56;
      var1.columnWidth[2] = 210;
      var1.columnWidth[3] = 73;
      var1.columnWidth[4] = 77;
      var1.columnWidth[5] = 83;
      var1.columnWidth[6] = 51;
      var1.columnWidth[7] = 62;
      var1.columnWidth[8] = 126;
      var1.rightJustify[4] = true;
      var1.rightJustify[5] = true;
      var1.rightJustify[6] = true;
      var1.rightJustify[7] = true;
      var1.maskEdit[4] = "$999,999,999,999.00";
      var1.maskEdit[5] = "$999,999,999,999.00";
      var1.maskEdit[6] = "99%";
      var1.maskEdit[7] = "$999,999,999,999";
      var1.maskType[4] = "Float";
      var1.maskType[5] = "Float";
      var1.maskType[6] = "Float";
      var1.maskType[7] = "Float";
      this.ReportLayout1LoadEmptyGrid();
   }

   public void ResultList1Main() {
      String var1 = "pub_id";
      String[] var2 = new String[0];
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Pub name"};
      String[] var5 = new String[]{"pub_name"};
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, this.jaggSQL, false, var1, var2, var3, var4, var5, var5, "", true, "Total Entries:");
      int[] var6 = new int[7];
      var6[0] = 3;
      var6[1] = 5;
      this.ResultList1.setMinWidth(130);
      this.ResultList1.setIcons(var6);
      this.ResultList1.setFromWhereClause(" FROM dbo_publishers WHERE (1=1)");
      this.ResultList1.clearList("");
      this.ResultList1.loadList();
   }
}
