import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class SalesChartByStore extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Chart1;
   Panel Panel1;
   JDPWhereClause Chart1SP1;
   JDPChart Chart1CL1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Sales Chart by Store");
      this.Chart1 = new Panel();
      this.Panel1 = new Panel();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Chart1);
      this.Chart1.setLayout(new BorderLayout());
      this.Chart1Main();
      this.Chart1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("North", this.Chart1SP1);
      this.Panel1.add("Center", this.Chart1CL1);
      this.Chart1SP1.setHorizontalLayout(true);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.Chart1SP1)) {
               this.Chart1LoadDataFromWhereClause(this.Chart1SP1.getFromWhereClause());
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void Chart1Main() {
      this.Chart1SetChartParms();
      this.Chart1LoadData((String[])null);
      this.Chart1WhereClauseMain();
      this.Chart1SearchResultsMain();
   }

   public void Chart1LoadDataFromWhereClause(String var1) {
      int var2 = var1.indexOf("WHERE ");
      var1 = " AND" + var1.substring(var2 + 5);
      String[] var3 = new String[0];
      this.Chart1LoadDataMain(var3, var1);
   }

   public void Chart1LoadData(String[] var1) {
      this.Chart1LoadDataMain(var1, (String)null);
   }

   void Chart1LoadDataMain(String[] var1, String var2) {
      JDPChartParms var3 = this.Chart1CL1.p;
      int var5 = 0;
      Vector var6 = new Vector();
      String var7 = this.jaggSQL.getSEP();
      int var8 = 0;
      String var10 = "(1=1)";
      byte var11 = 1;
      byte var12 = 0;
      if (var1 != null && var1.length > 0 && var1[0] != null) {
         var10 = var10 + " AND stor_id='" + var1[0] + "'";
      }

      if (var2 != null) {
         var10 = var10 + var2;
      }

      String var13 = "SELECT LEFT(format(ord_date, 'yy/mm/dd'),5),SUM(qty) FROM dbo_sales  WHERE " + var10 + " GROUP BY LEFT(format(ord_date, 'yy/mm/dd'),5) ORDER BY SUM(qty) DESC";
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      var5 = this.jaggSQL.execSQL(var13, var6);
      if (var5 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var13);
      } else if (var5 == 0) {
         this.user.mainmsg.setStatusMsg(JDPLang.get("Message10"), 10);
         this.Chart1CL1.hide();
      } else {
         this.Chart1CL1.show();
         int var14 = this.jaggSQL.getColumnCount();
         var8 = this.jaggSQL.getRowCount();
         if (var12 <= 0) {
            var3.chartData = new float[var14 - var11][var8];
            var3.xaxisLabel = new String[var8];
            var3.piechartData = new float[var8];
            var3.pieSplitSegment = new boolean[var8];
            var3.pieLabel = new String[var8];
            if (var3.chartType == JDPChart.PIE || var3.chartType == JDPChart.GANTT) {
               var3.elementColor = new Color[var8];
               var3.elementBorderColor = new Color[var8];
               var3.elementLegend = new String[var8];
            }

            for(int var15 = 0; var15 < var8; ++var15) {
               String var9 = (String)var6.elementAt(var15);
               StringTokenizer var4 = new StringTokenizer(var9, var7);
               var3.xaxisLabel[var15] = "";
               if (var11 > 0) {
                  var3.xaxisLabel[var15] = var4.nextToken().trim();
               }

               for(int var16 = 0; var16 < var14 - var11; ++var16) {
                  if (var3.chartType == JDPChart.GANTT) {
                     String var17 = var4.nextToken();
                     Date var18 = new Date(Integer.parseInt(var17.substring(2, 4)), Integer.parseInt(var17.substring(5, 7)) - 1, Integer.parseInt(var17.substring(8, 10)));
                     long var19 = var18.getTime() / 86400000L;
                     var3.chartData[var16][var15] = (float)var19;
                  } else {
                     var3.chartData[var16][var15] = Float.valueOf(var4.nextToken().trim());
                  }
               }

               var3.pieLabel[var15] = var3.xaxisLabel[var15];
               var3.piechartData[var15] = var3.chartData[0][var15];
               if (var3.chartType == JDPChart.PIE || var3.chartType == JDPChart.GANTT) {
                  var3.elementColor[var15] = JDPUtils.colorList[var15 % 12];
                  var3.elementBorderColor[var15] = Color.black;
                  var3.elementLegend[var15] = var3.pieLabel[var15];
               }
            }
         } else {
            float[][] var26 = new float[1000][var8];
            var3.xaxisLabel = new String[var8];
            Vector var27 = new Vector();
            if (var11 == 0) {
               var27.addElement("");
            }

            Vector var28 = new Vector();

            for(int var29 = 0; var29 < var8; ++var29) {
               String var25 = (String)var6.elementAt(var29);
               StringTokenizer var22 = new StringTokenizer(var25, var7);
               var3.xaxisLabel[var29] = "";
               int var30 = 0;
               if (var11 > 0) {
                  String var20 = var22.nextToken().trim();
                  var30 = var27.indexOf(var20);
                  if (var30 < 0) {
                     var27.addElement(var20);
                     var30 = var27.indexOf(var20);
                     var3.xaxisLabel[var30] = var20;
                  }
               }

               String var32 = var22.nextToken().trim();
               int var21 = var28.indexOf(var32);
               if (var21 < 0) {
                  var28.addElement(var32);
                  var21 = var28.indexOf(var32);
               }

               var26[var21][var30] = Float.valueOf(var22.nextToken().trim());
            }

            int var31 = var28.size();
            var3.chartData = new float[var31][var27.size()];

            for(int var33 = 0; var33 < var31; ++var33) {
               for(int var34 = 0; var34 < var27.size(); ++var34) {
                  var3.chartData[var33][var34] = var26[var33][var34];
               }
            }

            var3.elementColor = new Color[var31];
            var3.elementBorderColor = new Color[var31];
            var3.elementLegend = new String[var31];

            for(int var35 = 0; var35 < var31; ++var35) {
               var3.elementColor[var35] = JDPUtils.colorList[var35 % 12];
               var3.elementBorderColor[var35] = Color.black;
               var3.elementLegend[var35] = (String)var28.elementAt(var35);
            }
         }

         this.Chart1CL1.calculateScaling();
         this.Chart1CL1.repaint();
         this.user.mainmsg.clearStatusMsg();
      }
   }

   public void Chart1SetChartParms() {
      JDPChartParms var1;
      if (this.Chart1CL1 == null) {
         var1 = new JDPChartParms();
         this.Chart1CL1 = new JDPChart(this.user, var1);
      } else {
         var1 = this.Chart1CL1.p;
      }

      var1.chartType = 5;
      var1.autoscale = true;
      var1.autozoom = true;
      var1.chartTitle = "Sales Chart by Store";
      var1.chartTitleFont = this.user.boldFont.getName();
      var1.chartTitleColor = this.user.u._cvtcolor("Black");
      var1.xaxisTitle = "";
      var1.xaxisTitleFont = this.user.boldFont.getName();
      var1.xaxisTitleColor = this.user.u._cvtcolor("Black");
      var1.yaxisLabel = new String[10];
      var1.elementLegendFont = this.user.boldFont.getName();
      var1.xaxisLabelColor = this.user.u._cvtcolor("Black");
      var1.yaxisLabelColor = this.user.u._cvtcolor("Black");
      var1.chartFrameColor = this.user.u._cvtcolor("Black");
      var1.elementLegend = new String[1];
      var1.elementColor = new Color[1];
      var1.elementBorderColor = new Color[1];
      var1.elementLegend[0] = "Qty";
      var1.elementColor[0] = this.user.u._cvtcolor("Magenta");
      var1.elementBorderColor[0] = this.user.u._cvtcolor("Black");
      var1.gridLineSetting = JDPChart.HORIZONTAL + JDPChart.VERTICAL + JDPChart.FOREGROUND + JDPChart.BACKGROUND;
      var1.gridColor = this.user.u._cvtcolor("Gray");
      var1.maxPlotValue = 100.0F;
      var1.minPlotValue = 0.0F;
      if (var1.chartType == JDPChart.COLUMN || var1.chartType == JDPChart.BAR || var1.chartType == JDPChart.AREA) {
         var1.autozoom = false;
      }

      var1.pieLabel = var1.elementLegend;
      var1.pieLabelColor = var1.xaxisTitleColor;
   }

   public void Chart1WhereClauseMain() {
      String[] var1 = new String[1];
      String[] var2 = new String[1];
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      var1[0] = "Store Name";
      var2[0] = "stor_id";
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      JDPLoadChoice var5 = new JDPLoadChoice(this.user, this.jaggSQL, (Object)null, "", "", "", "", -1);
      var5.loadChoice((Vector)var3.elementAt(0), "stor_name", "stor_id", "dbo_stores", "(1=1)", (Vector)var4.elementAt(0), 12);
      int[] var6 = new int[1];
      boolean[] var7 = new boolean[1];
      var6[0] = 0;
      var7[0] = true;
      this.Chart1SP1 = new JDPWhereClause(this.user, super.targetPanel, "", true, "", var1, var2, var3, var4, (String[][])null, (String[][])null, var6, var7, "FROM dbo_sales WHERE (1=1)");
      this.Chart1SP1.setDSNType("ACCESS");
      this.Chart1SP1.setDataType(0, 12);
   }

   public void Chart1SearchResultsMain() {
   }
}
