import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class SalesInquiry extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPSearchResults ResultList1;
   JDPFormatDoc Formatter1;
   Panel Panel1;
   Panel Columns1;
   JDPScrollPanel ScrollPanel1;
   Label stor_idLabel1;
   TextField stor_id1;
   Label ord_numLabel1;
   JDPComboBox ord_num1;
   Vector valueord_num1;
   Label ord_dateLabel1;
   JDPDate ord_date1;
   Label qtyLabel1;
   JDPSpinner qty1;
   Label paytermsLabel1;
   Panel paytermsLine1;
   Checkbox payterms1;
   Checkbox payterms11;
   Checkbox payterms12;
   Label title_idLabel1;
   TextField title_id1;
   JDPButtons JDPButtons1;
   JDPTextGrid ReportLayout1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      CheckboxGroup var4 = new CheckboxGroup();
      this.Main = new Panel();
      this.ResultList1Main();
      this.Formatter1 = new JDPFormatDoc(var1);
      this.Panel1 = new Panel();
      this.Columns1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.stor_idLabel1 = new Label("Stor Id:", 0);
      this.stor_id1 = new TextField("stor_id", 6);
      this.ord_numLabel1 = new Label("Ord Num:", 0);
      this.ord_num1 = new JDPComboBox(var1);
      this.ord_dateLabel1 = new Label("Ord Date:", 0);
      this.ord_date1 = new JDPDate(var1, "", 18);
      this.qtyLabel1 = new Label("Qty:", 0);
      this.qty1 = new JDPSpinner(var1, "", 4);
      this.paytermsLabel1 = new Label("Payterms:", 0);
      this.paytermsLine1 = new Panel();
      this.payterms1 = new Checkbox("Net 30", var4, true);
      this.payterms11 = new Checkbox("Net 60", var4, false);
      this.payterms12 = new Checkbox("ON invoice", var4, false);
      this.title_idLabel1 = new Label("Title Id:", 0);
      this.title_id1 = new TextField("title_id", 8);
      String[] var5 = new String[]{"Print"};
      int[] var6 = new int[]{JDPButton.getIconValue("Printer")};
      this.JDPButtons1 = new JDPButtons(var1, var5, var6, JDPButtons.getAlignmentValue("Horizontal"));
      this.ReportLayout1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.ResultList1);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("North", this.Columns1);
      this.Columns1.setLayout(new BorderLayout());
      this.Columns1Main();
      this.Columns1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.stor_idLabel1);
      this.ScrollPanel1.add("Right", this.stor_id1);
      this.ScrollPanel1.add("Left", this.ord_numLabel1);
      this.ScrollPanel1.add("Right", this.ord_num1);
      this.ScrollPanel1.add("Left", this.ord_dateLabel1);
      this.ScrollPanel1.add("Right", this.ord_date1);
      this.ScrollPanel1.add("Left", this.qtyLabel1);
      this.ScrollPanel1.add("Right", this.qty1);
      this.ScrollPanel1.add("Left", this.paytermsLabel1);
      this.ScrollPanel1.add("Right", this.paytermsLine1);
      this.paytermsLine1.setLayout(new JDPLineLayout());
      this.paytermsLine1.add("Left", this.payterms1);
      this.paytermsLine1.add("Left", this.payterms11);
      this.paytermsLine1.add("Left", this.payterms12);
      this.ScrollPanel1.add("Left", this.title_idLabel1);
      this.ScrollPanel1.add("Right", this.title_id1);
      this.Panel1.add("South", this.JDPButtons1);
      this.Panel1.add("Center", this.ReportLayout1);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.ResultList1)) {
               this.Columns1Load(this.ResultList1.getSelectedKey());
               this.ReportLayout1LoadGrid(this.ResultList1.getSelectedKey());
               return true;
            } else {
               if (var1.target.equals(this.JDPButtons1.button[0])) {
                  this.Formatter1.initDocument(0);
                  this.Formatter1.setBody("");
                  this.Formatter1.addComponent(this.Columns1);
                  this.Formatter1.addReport(this.ReportLayout1);
                  this.Formatter1.finishOutput();
                  this.Formatter1.loadDocument();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
   }

   public void ResultList1Main() {
      String var1 = "stor_id,ord_num,title_id";
      String[] var2 = new String[]{"ord_num", "title_id"};
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Stor Id"};
      String[] var5 = new String[]{"stor_id"};
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, this.jaggSQL, false, var1, var2, var3, var4, var5, var5, "", true, "Total Entries:");
      int[] var6 = new int[8];
      var6[0] = 3;
      var6[1] = 5;
      var6[2] = 1;
      var6[3] = 8;
      this.ResultList1.setMinWidth(130);
      this.ResultList1.setIcons(var6);
      this.ResultList1.setFromWhereClause(" FROM dbo_sales WHERE (1=1)");
      this.ResultList1.clearList("");
      this.ResultList1.loadList();
   }

   public void Columns1Main() {
      this.Columns1LoadChoices();
      this.Columns1ClearFields();
   }

   public void Columns1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var8 = "SELECT stor_id,ord_num,format(ord_date, 'mm/dd/yy'),qty,payterms,title_id FROM dbo_sales WHERE (1=1)";
         if (var1.length > 0 && var1[0] != null) {
            var8 = var8 + " AND stor_id='" + var1[0] + "'";
         }

         if (var1.length > 1 && var1[1] != null) {
            var8 = var8 + " AND ord_num='" + var1[1] + "'";
         }

         if (var1.length > 2 && var1[2] != null) {
            var8 = var8 + " AND title_id='" + var1[2] + "'";
         }

         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
         this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
         this.jaggSQL.setJdbcSuffix("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setCSTR(" ");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var3 = this.jaggSQL.execSQL(var8, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var8);
         } else if (var3 >= 1) {
            String var6 = (String)var4.elementAt(0);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var6);
               this.stor_id1.setText(var2.nextToken(var5).trim());
               this.ord_num1.setText(var2.nextToken(var5).trim());
               this.ord_date1.setText(var2.nextToken(var5).trim());
               this.qty1.setText(var2.nextToken(var5).trim());
               String var7 = var2.nextToken(var5).trim();
               this.payterms1.setState(var7.equals("Net 30"));
               this.payterms11.setState(var7.equals("Net 60"));
               this.payterms12.setState(var7.equals("ON invoice"));
               this.title_id1.setText(var2.nextToken(var5).trim());
            }

            if (var3 > 1) {
               this.user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
            } else {
               this.user.mainmsg.clearStatusMsg();
            }
         } else {
            this.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
            this.Columns1ClearFields();
         }
      } else {
         this.Columns1ClearFields();
      }
   }

   public boolean Columns1updateRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "U") : false;
   }

   public boolean Columns1insertRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "I") : false;
   }

   public boolean Columns1removeRow(String[] var1) {
      return this.Columns1Save(var1, "D");
   }

   boolean Columns1Save(String[] var1, String var2) {
      int var3 = 0;
      Vector var4 = new Vector();
      this.jaggSQL.getSEP();
      String var5 = "";
      if (var2.equals("I")) {
         var5 = "INSERT INTO dbo_sales (stor_id, ord_num, ord_date, qty, payterms, title_id) VALUES('" + this.user.u.replace(this.stor_id1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.ord_num1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.ord_date1.getText(), "'", "''") + "', " + "" + JDPUtils.tonum(this.qty1.getText()) + ", " + "'" + (this.payterms1.getState() ? "Net 30" : (this.payterms11.getState() ? "Net 60" : (this.payterms12.getState() ? "ON invoice" : " "))) + "', " + "'" + this.user.u.replace(this.title_id1.getText(), "'", "''") + "')";
      } else {
         if (var1 == null || var1.length == 0) {
            this.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         if (var2.equals("D")) {
            var5 = "DELETE FROM dbo_sales WHERE stor_id='" + var1[0] + "'" + " AND ord_num='" + var1[1] + "'" + " AND title_id='" + var1[2] + "'";
         } else {
            var5 = "UPDATE dbo_sales SET ord_date = '" + this.user.u.replace(this.ord_date1.getText(), "'", "''") + "', " + "qty = " + JDPUtils.tonum(this.qty1.getText()) + ", " + "payterms = '" + (this.payterms1.getState() ? "Net 30" : (this.payterms11.getState() ? "Net 60" : (this.payterms12.getState() ? "ON invoice" : " "))) + "'" + " WHERE stor_id='" + var1[0] + "'" + " AND ord_num='" + var1[1] + "'" + " AND title_id='" + var1[2] + "'";
         }
      }

      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var3 = this.jaggSQL.execSQL(var5, var4);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var5);
         return false;
      } else {
         if (var3 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var5);
         }

         return true;
      }
   }

   public void Columns1ClearFields() {
      this.stor_id1.setText("");
      this.ord_num1.setText("");
      this.ord_date1.setText("");
      this.qty1.setText("");
      this.payterms1.setState(false);
      this.payterms11.setState(false);
      this.payterms12.setState(false);
      this.title_id1.setText("");
   }

   void Columns1LoadChoices() {
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      new JDPLoadChoice(this.user, this.jaggSQL, this.ord_num1, "ord_num", "ord_num", "dbo_sales", "(1=1)", (Vector)null);
   }

   public boolean Columns1CheckFields() {
      return true;
   }

   public void ReportLayout1Main() {
      this.ReportLayout1SetGridSettings();
   }

   public void ReportLayout1LoadGrid(String[] var1) {
      JDPTextGrid var2 = this.ReportLayout1;
      if (var1 != null && var1.length >= 0) {
         int var4 = 0;
         Vector var5 = new Vector();
         String var6 = this.jaggSQL.getSEP();
         int var7 = 0;
         byte var11 = 6;
         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         new Vector();
         new Vector();
         String var12 = "SELECT stor_id, ord_num, format(ord_date, 'mm/dd/yy'), qty, payterms, title_id FROM dbo_sales WHERE (1=1)  ";
         if (var1.length > 0 && var1[0] != null) {
            var12 = var12 + " AND stor_id='" + var1[0] + "'" + " ORDER BY stor_id,ord_num";
         }

         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var4 = this.jaggSQL.execSQL(var12, var5);
         if (var4 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var12);
         } else {
            var7 = this.jaggSQL.getRowCount();
            var2.currentText = new String[var11][var7 + 30];
            var2.cellFont = new Font[var11][var7 + 30];
            var2.gridColor = Color.white;
            boolean[] var13 = new boolean[var11];
            String[] var14 = new String[var11];
            boolean[] var15 = new boolean[6];
            boolean[] var16 = new boolean[6];
            byte var17 = 2;
            var15[1] = true;
            var16[0] = true;
            var13[3] = true;
            float[][] var9 = new float[1][1];
            float[][] var10 = new float[1][1];
            int var18 = 0;
            int var19 = var11 / 2 - 1;
            if (var19 < 0) {
               var19 = 0;
            }

            var2.currentText[var19][1] = " REPORT";
            var2.cellFont[var19][1] = new Font(this.user.plainFont.getName(), 1, this.user.plainFont.getSize() + 4);

            for(int var20 = 0; var20 < var11; ++var20) {
               var2.cellFont[var20][3] = this.user.boldFont;
            }

            var2.currentText[0][3] = "Stor Id";
            var2.currentText[1][3] = "Ord Num";
            var2.currentText[2][3] = "Ord Date";
            var2.currentText[3][3] = "Qty";
            var2.currentText[4][3] = "Payterms";
            var2.currentText[5][3] = "Title Id";
            var18 = 4;
            var9 = new float[var17][var11];
            var10 = new float[var17][var11];

            int var21;
            for(var21 = 0; var21 < var7; ++var21) {
               String var8 = (String)var5.elementAt(var21);
               if (var8 != null && var8.trim().compareTo("") != 0) {
                  StringTokenizer var3 = new StringTokenizer(var8);

                  for(int var22 = 0; var22 < var11; ++var22) {
                     var2.currentText[var22][var21 + var18] = var3.nextToken(var6).trim();
                     if (var2.maskEdit[var22] != null) {
                        if (var2.maskType[var22] == "Float") {
                           var2.currentText[var22][var21 + var18] = this.JDPMaskEditMain.formatFloat(var2.currentText[var22][var21 + var18], var2.maskEdit[var22]);
                        } else {
                           var2.currentText[var22][var21 + var18] = this.JDPMaskEditMain.formatString(var2.currentText[var22][var21 + var18], var2.maskEdit[var22]);
                        }
                     }
                  }

                  for(int var23 = var11 - 1; var23 >= 0; --var23) {
                     String var24 = var2.currentText[var23][var21 + var18];
                     if (var17 > var23 && var21 > 0) {
                        if (var24.equals(var14[var23])) {
                           var2.currentText[var23][var21 + var18] = "";
                        } else {
                           if (var15[var23]) {
                              for(int var25 = 0; var25 < var11; ++var25) {
                                 var2.currentText[var25][var21 + var18 + 1] = var2.currentText[var25][var21 + var18];
                                 var2.currentText[var25][var21 + var18] = "";
                                 var2.cellFont[var25][var21 + var18 + 1] = var2.cellFont[var25][var21 + var18];
                                 var2.cellFont[var25][var21 + var18] = null;
                              }

                              var2.currentText[var23][var21 + var18] = "Subtotal";
                              var2.cellFont[var23][var21 + var18] = this.user.boldFont;

                              for(int var26 = var23 + 1; var26 < var11; ++var26) {
                                 if (var13[var26]) {
                                    var2.currentText[var26][var21 + var18] = this.JDPMaskEditMain.formatFloat(var9[var23][var26], var2.maskEdit[var26]);
                                    var2.cellFont[var26][var21 + var18] = this.user.boldFont;
                                 }

                                 var9[var23][var26] = 0.0F;
                              }

                              ++var18;
                           }

                           var2.currentText[var23][var21 + var18] = var24;
                        }
                     }

                     if (var17 > 0 && var21 > 0) {
                        try {
                           float var40 = Float.valueOf(this.JDPMaskEditMain.stripFloat(var14[var23]));

                           for(int var42 = 0; var42 < var17; ++var42) {
                              var9[var42][var23] += var40;
                              var10[var42][var23] += var40;
                           }
                        } catch (Exception var28) {
                        }
                     }

                     var14[var23] = var24;
                  }
               }
            }

            for(int var34 = 0; var34 < var11; ++var34) {
               try {
                  float var35 = Float.valueOf(this.JDPMaskEditMain.stripFloat(var14[var34]));

                  for(int var37 = 0; var37 < var17; ++var37) {
                     var9[var37][var34] += var35;
                     var10[var37][var34] += var35;
                  }
               } catch (Exception var27) {
               }
            }

            for(int var36 = var11 - 1; var36 >= 0; --var36) {
               if (var17 > var36 && var15[var36]) {
                  var2.currentText[var36][var21 + var18] = "Subtotal";
                  var2.cellFont[var36][var21 + var18] = this.user.boldFont;

                  for(int var38 = var36 + 1; var38 < var11; ++var38) {
                     if (var13[var38]) {
                        var2.currentText[var38][var21 + var18] = this.JDPMaskEditMain.formatFloat(var9[var36][var38], var2.maskEdit[var38]);
                        var2.cellFont[var38][var21 + var18] = this.user.boldFont;
                     }
                  }

                  ++var18;
               }
            }

            for(int var39 = var11 - 1; var39 >= 0; --var39) {
               if (var17 > var39 && var16[var39]) {
                  var2.currentText[var39][var21 + var18] = "Total";
                  var2.cellFont[var39][var21 + var18] = this.user.boldFont;

                  for(int var41 = var39 + 1; var41 < var11; ++var41) {
                     if (var13[var41]) {
                        var2.currentText[var41][var21 + var18] = this.JDPMaskEditMain.formatFloat(var10[var39][var41], var2.maskEdit[var41]);
                        var2.cellFont[var41][var21 + var18] = this.user.boldFont;
                     }
                  }

                  ++var18;
               }
            }

            var2.newTable();
            this.user.mainmsg.clearStatusMsg();
         }
      } else {
         this.ReportLayout1LoadEmptyGrid();
      }
   }

   public void ReportLayout1LoadEmptyGrid() {
      JDPTextGrid var1 = this.ReportLayout1;
      byte var2 = 6;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void ReportLayout1SetGridSettings() {
      if (this.ReportLayout1 == null) {
         this.ReportLayout1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.ReportLayout1;
      byte var2 = 6;
      var1.columnHeader = null;
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;
      var1.maskEdit = new String[var2];
      var1.maskType = new String[var2];

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[0] = true;
      var1.columnProtected[1] = true;
      var1.columnProtected[2] = true;
      var1.columnProtected[3] = true;
      var1.columnProtected[4] = true;
      var1.columnProtected[5] = true;
      var1.columnWidth[0] = 46;
      var1.columnWidth[1] = 150;
      var1.columnWidth[2] = 126;
      var1.columnWidth[3] = 32;
      var1.columnWidth[4] = 98;
      var1.columnWidth[5] = 56;
      var1.rightJustify[3] = true;
      this.ReportLayout1LoadEmptyGrid();
   }
}
