import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class SalesOrder extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   Panel Panel1;
   JDPTextGrid DetailGrid1;
   Panel Columns1;
   JDPScrollPanel ScrollPanel1;
   Label stor_idLabel1;
   TextField stor_id1;
   Label stor_nameLabel1;
   TextField stor_name1;
   Label stor_addressLabel1;
   TextField stor_address1;
   Label cityLabel1;
   Panel cityLine1;
   TextField city1;
   TextField state1;
   TextField zip1;
   JDPButtons JDPButtons1;
   Panel Panel2;
   JDPSearchResults ResultList1;
   JDPWhereClause SearchPanel1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.Panel1 = new Panel();
      this.DetailGrid1Main();
      this.Columns1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.stor_idLabel1 = new Label("Store Id:", 0);
      this.stor_id1 = new TextField("stor_id", 6);
      this.stor_nameLabel1 = new Label("Name:", 0);
      this.stor_name1 = new TextField("stor_name", 42);
      this.stor_addressLabel1 = new Label("Address:", 0);
      this.stor_address1 = new TextField("stor_address", 42);
      this.cityLabel1 = new Label("", 0);
      this.cityLine1 = new Panel();
      this.city1 = new TextField("city", 22);
      this.state1 = new TextField("state", 4);
      this.zip1 = new TextField("zip", 7);
      String[] var4 = new String[]{"Save", "Delete", "Reset"};
      int[] var5 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("Delete"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Panel2 = new Panel();
      this.ResultList1Main();
      this.SearchPanel1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.DetailGrid1);
      this.Panel1.add("North", this.Columns1);
      this.Columns1.setLayout(new BorderLayout());
      this.Columns1Main();
      this.Columns1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.stor_idLabel1);
      this.ScrollPanel1.add("Right", this.stor_id1);
      this.ScrollPanel1.add("Left", this.stor_nameLabel1);
      this.ScrollPanel1.add("Right", this.stor_name1);
      this.ScrollPanel1.add("Left", this.stor_addressLabel1);
      this.ScrollPanel1.add("Right", this.stor_address1);
      this.ScrollPanel1.add("Left", this.cityLabel1);
      this.ScrollPanel1.add("Right", this.cityLine1);
      this.cityLine1.setLayout(new JDPLineLayout());
      this.cityLine1.add("Left", this.city1);
      this.cityLine1.add("Left", this.state1);
      this.cityLine1.add("Left", this.zip1);
      this.Panel1.add("South", this.JDPButtons1);
      this.Main.add("West", this.Panel2);
      this.Panel2.setLayout(new BorderLayout());
      this.Panel2.add("Center", this.ResultList1);
      this.Panel2.add("North", this.SearchPanel1);
      this.popuppanel.addComponent(this.stor_id1, "Stor Id", "");
      this.popuppanel.addComponent(this.stor_name1, "Stor  name", "");
      this.popuppanel.addComponent(this.stor_address1, "Stor Address", "");
      this.popuppanel.addComponent(this.city1, "City", "");
      this.popuppanel.addComponent(this.state1, "State", "");
      this.popuppanel.addComponent(this.zip1, "Zip", "");
      this.popuppanel.addComponent(this.JDPButtons1.button[0], "Save Changes", "Save changes to the database");
      this.popuppanel.addComponent(this.JDPButtons1.button[1], "Delete Rows", "Remove the selected rows from this order");
      this.popuppanel.addComponent(this.JDPButtons1.button[2], "Restore", "Restore this order from the database");
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.DetailGrid1UpdateRows(this.ResultList1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[1])) {
               this.DetailGrid1DeleteRows(this.ResultList1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[2])) {
               this.DetailGrid1LoadGrid(this.ResultList1.getSelectedKey());
               return true;
            } else if (var1.target.equals(this.ResultList1)) {
               this.Columns1Load(this.ResultList1.getSelectedKey());
               this.DetailGrid1LoadGrid(this.ResultList1.getSelectedKey());
               return true;
            } else {
               if (var1.target.equals(this.SearchPanel1)) {
                  this.ResultList1.clearList();
                  this.ResultList1.setFromWhereClause(this.SearchPanel1.getFromWhereClause());
                  this.ResultList1.loadList();
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
   }

   public void DetailGrid1Main() {
      this.DetailGrid1SetGridSettings();
   }

   public void DetailGrid1LoadGrid(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var4 = 0;
         Vector var5 = new Vector();
         String var6 = this.jaggSQL.getSEP();
         int var7 = 0;
         byte var9 = 3;
         new Vector();
         new Vector();
         String var10 = "SELECT stor_id, ord_num, title_id, title_id, qty, payterms FROM dbo_sales WHERE (1=1)  ";
         if (var1.length > 0 && var1[0] != null) {
            var10 = var10 + " AND stor_id='" + var1[0] + "'";
         }

         if (var1.length > 1 && var1[1] != null) {
            var10 = var10 + " AND ord_num='" + var1[1] + "'";
         }

         if (var1.length > 2 && var1[2] != null) {
            var10 = var10 + " AND title_id='" + var1[2] + "'";
         }

         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         var4 = this.jaggSQL.execSQL(var10, var5);
         if (var4 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var10);
         } else {
            var2.totalDataRows = this.jaggSQL.getRowCount();
            var7 = this.jaggSQL.getRowCount() + 20;
            var2.currentText = new String[var9][var7];
            var2.cellChanged = null;
            var2.rowChanged = null;
            var2.columnSelected = null;
            byte var11 = 3;
            var2.rowKey = new String[var7][var11];

            for(int var13 = 0; var13 < var7 - 20; ++var13) {
               String var8 = (String)var5.elementAt(var13);
               if (var8 != null && var8.trim().compareTo("") != 0) {
                  StringTokenizer var3 = new StringTokenizer(var8);

                  for(int var14 = 0; var14 < var11; ++var14) {
                     var2.rowKey[var13][var14] = var3.nextToken(var6).trim();
                  }

                  for(int var15 = 0; var15 < var9; ++var15) {
                     String var12 = var3.nextToken(var6).trim();
                     var2.currentText[var15][var13] = var12;
                     if (var15 == 0 && var2.pullDownValue[0][0].indexOf(var12) >= 0) {
                        var2.currentText[var15][var13] = var2.pullDownList[0][0].getItem(var2.pullDownValue[0][0].indexOf(var12));
                     }

                     if (var15 == 2 && var2.pullDownValue[2][0].indexOf(var12) >= 0) {
                        var2.currentText[var15][var13] = var2.pullDownList[2][0].getItem(var2.pullDownValue[2][0].indexOf(var12));
                     }
                  }
               }
            }

            for(int var18 = var7 - 20; var18 < var7; ++var18) {
               for(int var19 = 0; var19 < var1.length; ++var19) {
                  var2.rowKey[var18][var19] = var1[var19];
               }
            }

            var2.newTable();
            this.user.mainmsg.clearStatusMsg();
         }
      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   public void DetailGrid1UpdateRows(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var3 = 0;
         int var4 = 0;
         int var5 = 1;
         int var6 = 1;

         for(int var7 = 0; var7 < var2.rowChanged.length; ++var7) {
            if (var2.rowChanged[var7]) {
               if (var7 >= var2.totalDataRows) {
                  ++var4;
               } else {
                  ++var3;
               }
            }
         }

         for(int var8 = 0; var8 < var2.rowChanged.length; ++var8) {
            if (var2.rowChanged[var8]) {
               if (var8 >= var2.totalDataRows) {
                  this.user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(var6++) + " of " + Integer.toString(var4) + "...", 0);
                  this.DetailGrid1SaveData(var8, "I");
               } else {
                  this.user.mainmsg.setStatusMsg("Updating row " + Integer.toString(var5++) + " of " + Integer.toString(var3) + "...", 0);
                  this.DetailGrid1SaveData(var8, "U");
               }

               var2.rowChanged[var8] = false;
            }
         }

         if (var4 > 0) {
            this.DetailGrid1LoadGrid(var1);
         }

      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   public void DetailGrid1DeleteRows(String[] var1) {
      JDPTextGrid var2 = this.DetailGrid1;
      if (var1 != null && var1.length >= 0) {
         int var3 = 0;
         int var4 = 1;

         for(int var5 = 0; var5 < var2.rowChanged.length; ++var5) {
            if (var2.rowSelected[var5]) {
               ++var3;
            }
         }

         for(int var6 = 0; var6 < var2.rowChanged.length; ++var6) {
            if (var2.rowSelected[var6]) {
               this.user.mainmsg.setStatusMsg("Deleting row " + Integer.toString(var4++) + " of " + Integer.toString(var3) + "...", 0);
               this.DetailGrid1SaveData(var6, "D");
            }
         }

         if (var3 > 0) {
            this.DetailGrid1LoadGrid(var1);
         }

      } else {
         this.DetailGrid1LoadEmptyGrid();
      }
   }

   boolean DetailGrid1SaveData(int var1, String var2) {
      JDPTextGrid var3 = this.DetailGrid1;
      int var4 = 0;
      Vector var5 = new Vector();
      this.jaggSQL.getSEP();
      String var6 = "";
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      if (var2.equals("I")) {
         var6 = "INSERT INTO dbo_sales (stor_id, ord_num, title_id, qty, payterms) VALUES('" + var3.rowKey[var1][0] + "', " + "'" + var3.rowKey[var1][1] + "', " + "'" + (String)var3.pullDownValue[0][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[0][0], var3.currentText[0][var1])) + "', " + "" + var3.currentText[1][var1] + ", " + "'" + (String)var3.pullDownValue[2][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[2][0], var3.currentText[2][var1])) + "')";
      } else if (var2.equals("D")) {
         var6 = "DELETE FROM dbo_sales WHERE stor_id='" + var3.rowKey[var1][0] + "'" + " AND ord_num='" + var3.rowKey[var1][1] + "'" + " AND title_id='" + var3.rowKey[var1][2] + "'";
      } else {
         var6 = "UPDATE dbo_sales SET qty = " + var3.currentText[1][var1] + ", " + "payterms = '" + (String)var3.pullDownValue[2][0].elementAt(this.user.u.listIndexOf(var3.pullDownList[2][0], var3.currentText[2][var1])) + "'" + " WHERE stor_id='" + var3.rowKey[var1][0] + "'" + " AND ord_num='" + var3.rowKey[var1][1] + "'" + " AND title_id='" + var3.rowKey[var1][2] + "'";
      }

      var4 = this.jaggSQL.execSQL(var6, var5);
      if (this.user.DEBUG) {
         System.out.println("saveData CNT: " + Integer.toString(var4));
      }

      if (var4 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var6);
         return false;
      } else {
         if (var4 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var6);
         }

         return true;
      }
   }

   public void DetailGrid1LoadEmptyGrid() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 3;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void DetailGrid1SetGridSettings() {
      if (this.DetailGrid1 == null) {
         this.DetailGrid1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 3;
      var1.columnHeader = new String[var2];
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[0] = true;
      var1.columnProtected[2] = true;
      var1.columnWidth[0] = 265;
      var1.columnWidth[1] = 32;
      var1.columnWidth[2] = 98;
      var1.rightJustify[1] = true;
      var1.columnHeader[0] = "Title Id";
      var1.columnHeader[1] = "Qty";
      var1.columnHeader[2] = "Payterms";
      this.DetailGrid1LoadEmptyGrid();
      this.DetailGrid1LoadChoices();
   }

   void DetailGrid1LoadChoices() {
      JDPTextGrid var1 = this.DetailGrid1;
      byte var2 = 3;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      var1.isPullDownCol = new boolean[var2];
      var1.pullDownList = new List[var2][1];
      var1.isPullDownCol[0] = true;
      var1.isPullDownCol[2] = true;
      var1.pullDownList[0][0] = new List();
      var1.pullDownList[2][0] = new List();
      var1.pullDownValue[2][0] = new Vector();
      var1.pullDownList[2][0].addItem("Net 30");
      var1.pullDownValue[2][0].addElement("Net 30");
      var1.pullDownList[2][0].addItem("Net 60");
      var1.pullDownValue[2][0].addElement("Net 60");
      var1.pullDownList[2][0].addItem("ON invoice");
      var1.pullDownValue[2][0].addElement("ON invoice");
      var1.pullDownValue[0][0] = new Vector();
      new JDPLoadChoice(this.user, this.jaggSQL, var1.pullDownList[0][0], "title", "title_id", "dbo_titles", "(1=1)", var1.pullDownValue[0][0]);
   }

   public void Columns1Main() {
      this.Columns1LoadChoices();
      this.Columns1ClearFields();
   }

   public void Columns1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var7 = "SELECT stor_id,stor_name,stor_address,city,state,zip FROM dbo_stores WHERE (1=1)";
         if (var1.length > 0 && var1[0] != null) {
            var7 = var7 + " AND stor_id='" + var1[0] + "'";
         }

         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setJdbcDriver("");
         this.jaggSQL.setJdbcPrefix("");
         this.jaggSQL.setJdbcSuffix("");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var3 = this.jaggSQL.execSQL(var7, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var7);
         } else if (var3 >= 1) {
            String var6 = (String)var4.elementAt(0);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var6);
               this.stor_id1.setText(var2.nextToken(var5).trim());
               this.stor_name1.setText(var2.nextToken(var5).trim());
               this.stor_address1.setText(var2.nextToken(var5).trim());
               this.city1.setText(var2.nextToken(var5).trim());
               this.state1.setText(var2.nextToken(var5).trim());
               this.zip1.setText(var2.nextToken(var5).trim());
            }

            if (var3 > 1) {
               this.user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
            } else {
               this.user.mainmsg.clearStatusMsg();
            }
         } else {
            this.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
            this.Columns1ClearFields();
         }
      } else {
         this.Columns1ClearFields();
      }
   }

   public boolean Columns1updateRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "U") : false;
   }

   public boolean Columns1insertRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "I") : false;
   }

   public boolean Columns1removeRow(String[] var1) {
      return this.Columns1Save(var1, "D");
   }

   boolean Columns1Save(String[] var1, String var2) {
      int var3 = 0;
      Vector var4 = new Vector();
      this.jaggSQL.getSEP();
      String var5 = "";
      if (var2.equals("I")) {
         var5 = "INSERT INTO dbo_stores (stor_id, stor_name, stor_address, city, state, zip) VALUES('" + this.user.u.replace(this.stor_id1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.stor_name1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.stor_address1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.city1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.state1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.zip1.getText(), "'", "''") + "')";
      } else {
         if (var1 == null || var1.length == 0) {
            this.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         if (var2.equals("D")) {
            var5 = "DELETE FROM dbo_stores WHERE stor_id='" + var1[0] + "'";
         } else {
            var5 = "UPDATE dbo_stores SET stor_name = '" + this.user.u.replace(this.stor_name1.getText(), "'", "''") + "', " + "stor_address = '" + this.user.u.replace(this.stor_address1.getText(), "'", "''") + "', " + "city = '" + this.user.u.replace(this.city1.getText(), "'", "''") + "', " + "state = '" + this.user.u.replace(this.state1.getText(), "'", "''") + "', " + "zip = '" + this.user.u.replace(this.zip1.getText(), "'", "''") + "'" + " WHERE stor_id='" + var1[0] + "'";
         }
      }

      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("");
      this.jaggSQL.setJdbcPrefix("");
      this.jaggSQL.setJdbcSuffix("");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var3 = this.jaggSQL.execSQL(var5, var4);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var5);
         return false;
      } else {
         if (var3 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var5);
         }

         return true;
      }
   }

   public void Columns1ClearFields() {
      this.stor_id1.setText("");
      this.stor_name1.setText("");
      this.stor_address1.setText("");
      this.city1.setText("");
      this.state1.setText("");
      this.zip1.setText("");
   }

   void Columns1LoadChoices() {
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("");
      this.jaggSQL.setJdbcPrefix("");
      this.jaggSQL.setJdbcSuffix("");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
   }

   public boolean Columns1CheckFields() {
      return true;
   }

   public void ResultList1Main() {
      String var1 = "a.stor_id,a.ord_num";
      String[] var2 = new String[]{"a.ord_num"};
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Store  name", "Store Address"};
      String[] var5 = new String[]{"b.stor_name", "b.stor_address"};
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, this.jaggSQL, false, var1, var2, var3, var4, var5, var5, "", true, "Total Entries:");
      int[] var6 = new int[]{3, 5, 8, 0, 0};
      this.ResultList1.setMinWidth(170);
      this.ResultList1.setIcons(var6);
      this.ResultList1.setFromWhereClause(" FROM dbo_sales a,dbo_stores b WHERE a.stor_id = b.stor_id AND (1=1)");
      this.ResultList1.clearList("");
      this.ResultList1.loadList();
   }

   public void SearchPanel1Main() {
      String[] var1 = new String[6];
      String[] var2 = new String[6];
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      var1[0] = "Order Num";
      var2[0] = "a.ord_num";
      var1[1] = "Quantity";
      var2[1] = "a.qty";
      var1[2] = "Store name";
      var2[2] = "b.stor_name";
      var1[3] = "Store Address";
      var2[3] = "b.stor_address";
      var1[4] = "City";
      var2[4] = "b.city";
      var1[5] = "State";
      var2[5] = "b.state";
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      ((Vector)var3.elementAt(0)).addElement("Begins with");
      ((Vector)var4.elementAt(0)).addElement("like");
      ((Vector)var3.elementAt(0)).addElement("Contains");
      ((Vector)var4.elementAt(0)).addElement("like");
      ((Vector)var3.elementAt(1)).addElement("Greater than");
      ((Vector)var4.elementAt(1)).addElement(">");
      ((Vector)var3.elementAt(1)).addElement("Less than");
      ((Vector)var4.elementAt(1)).addElement("<");
      ((Vector)var3.elementAt(1)).addElement("Equal to");
      ((Vector)var4.elementAt(1)).addElement("=");
      ((Vector)var3.elementAt(2)).addElement("Begins with");
      ((Vector)var4.elementAt(2)).addElement("like");
      ((Vector)var3.elementAt(2)).addElement("Contains");
      ((Vector)var4.elementAt(2)).addElement("like");
      ((Vector)var3.elementAt(3)).addElement("Begins with");
      ((Vector)var4.elementAt(3)).addElement("like");
      ((Vector)var3.elementAt(3)).addElement("Contains");
      ((Vector)var4.elementAt(3)).addElement("like");
      ((Vector)var3.elementAt(4)).addElement("Begins with");
      ((Vector)var4.elementAt(4)).addElement("like");
      ((Vector)var3.elementAt(4)).addElement("Contains");
      ((Vector)var4.elementAt(4)).addElement("like");
      ((Vector)var3.elementAt(5)).addElement("Begins with");
      ((Vector)var4.elementAt(5)).addElement("like");
      ((Vector)var3.elementAt(5)).addElement("Contains");
      ((Vector)var4.elementAt(5)).addElement("like");
      int[] var5 = new int[6];
      boolean[] var6 = new boolean[6];
      var5[0] = 8;
      var6[0] = true;
      var5[1] = 24;
      var6[1] = false;
      var5[2] = 20;
      var6[2] = true;
      var5[3] = 6;
      var6[3] = true;
      var5[4] = 16;
      var6[4] = true;
      var5[5] = 10;
      var6[5] = true;
      this.SearchPanel1 = new JDPWhereClause(this.user, super.targetPanel, "", true, "Stor name", var1, var2, var3, var4, (String[][])null, (String[][])null, var5, var6, "FROM dbo_sales a,dbo_stores b WHERE a.stor_id = b.stor_id AND (1=1)");
   }
}
