import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Panel;
import java.util.StringTokenizer;
import java.util.Vector;

public class SalesSummaryReport extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Report1;
   Panel Panel1;
   JDPWhereClause Report1SP1;
   JDPTextGrid Report1GL1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Sales Summary Report");
      this.Report1 = new Panel();
      this.Panel1 = new Panel();
      this.Report1GL1 = new JDPTextGrid(var1);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Report1);
      this.Report1.setLayout(new BorderLayout());
      this.Report1Main();
      this.Report1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("North", this.Report1SP1);
      this.Panel1.add("Center", this.Report1GL1);
      this.Report1SP1.setHorizontalLayout(true);
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.Report1SP1)) {
               this.Report1LoadGridFromWhereClause(this.Report1SP1.getFromWhereClause());
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.jaggSQL.setKeepConnectionOpen(false);
   }

   public void Report1Main() {
      this.Report1SetGridSettings();
      this.Report1WhereClauseMain();
      this.Report1SearchResultsMain();
   }

   public void Report1LoadGridFromWhereClause(String var1) {
      int var2 = var1.indexOf("WHERE ");
      var1 = " AND" + var1.substring(var2 + 5);
      String[] var3 = new String[0];
      this.Report1LoadGridMain(var3, var1);
   }

   public void Report1LoadGrid(String[] var1) {
      this.Report1LoadGridMain(var1, (String)null);
   }

   void Report1LoadGridMain(String[] var1, String var2) {
      JDPTextGrid var3 = this.Report1GL1;
      int var5 = 0;
      Vector var6 = new Vector();
      String var7 = this.jaggSQL.getSEP();
      int var8 = 0;
      byte var12 = 5;
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      new Vector();
      new Vector();
      String var13 = "SELECT b.stor_name, a.ord_num, a.ord_date, a.title_id, a.qty FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)  ";
      if (var1.length > 0 && var1[0] != null) {
         var13 = var13 + " AND a.stor_id='" + var1[0] + "'";
      }

      if (var1.length > 1 && var1[1] != null) {
         var13 = var13 + " AND a.ord_num='" + var1[1] + "'";
      }

      if (var1.length > 2 && var1[2] != null) {
         var13 = var13 + " AND a.title_id='" + var1[2] + "'";
      }

      if (var2 != null) {
         var13 = var13 + var2;
      }

      var13 = var13 + " ORDER BY b.stor_name,a.ord_num";
      this.user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);
      var5 = this.jaggSQL.execSQL(var13, var6);
      if (var5 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var13);
      } else {
         var8 = this.jaggSQL.getRowCount();
         var3.currentText = new String[var12][var8 * 3 + 20];
         var3.cellFont = new Font[var12][var8 * 3 + 20];
         var3.gridColor = Color.white;
         boolean[] var14 = new boolean[var12];
         String[] var15 = new String[var12];
         boolean[] var16 = new boolean[5];
         boolean[] var17 = new boolean[5];
         byte var18 = 2;
         var16[1] = true;
         var17[0] = true;
         var14[4] = true;
         double[][] var10 = new double[1][1];
         double[][] var11 = new double[1][1];
         int var19 = 0;
         int var20 = var12 / 2 - 1;
         if (var20 < 0) {
            var20 = 0;
         }

         var3.currentText[var20][1] = "Sales Summary Report";
         var3.cellFont[var20][1] = new Font(this.user.plainFont.getName(), 1, this.user.plainFont.getSize() + 4);

         for(int var21 = 0; var21 < var12; ++var21) {
            var3.cellFont[var21][3] = this.user.boldFont;
         }

         var3.currentText[0][3] = "Store name";
         var3.currentText[1][3] = "Order Number";
         var3.currentText[2][3] = "Order Date";
         var3.currentText[3][3] = "Title Id";
         var3.currentText[4][3] = "Quantity";
         var19 = 4;
         var10 = new double[var18][var12];
         var11 = new double[var18][var12];

         int var22;
         for(var22 = 0; var22 < var8; ++var22) {
            String var9 = (String)var6.elementAt(var22);
            if (var9 != null && var9.trim().compareTo("") != 0) {
               StringTokenizer var4 = new StringTokenizer(var9, var7);

               for(int var24 = 0; var24 < var12; ++var24) {
                  String var23 = var4.nextToken().trim();
                  var3.currentText[var24][var22 + var19] = var23;
                  if (var24 == 2) {
                     var3.currentText[var24][var22 + var19] = JDPDate.format(Long.valueOf(var23));
                  }

                  if (var3.maskEdit[var24] != null) {
                     if (var3.maskType[var24] == "Float") {
                        var3.currentText[var24][var22 + var19] = this.JDPMaskEditMain.formatFloat(var3.currentText[var24][var22 + var19], var3.maskEdit[var24]);
                     } else {
                        var3.currentText[var24][var22 + var19] = this.JDPMaskEditMain.formatString(var3.currentText[var24][var22 + var19], var3.maskEdit[var24]);
                     }
                  }
               }

               for(int var25 = var12 - 1; var25 >= 0; --var25) {
                  String var26 = var3.currentText[var25][var22 + var19];
                  if (var18 > var25 && var22 > 0) {
                     if (var26.equals(var15[var25])) {
                        var3.currentText[var25][var22 + var19] = "";
                     } else {
                        if (var16[var25]) {
                           for(int var27 = 0; var27 < var12; ++var27) {
                              var3.currentText[var27][var22 + var19 + 1] = var3.currentText[var27][var22 + var19];
                              var3.currentText[var27][var22 + var19] = "";
                              var3.cellFont[var27][var22 + var19 + 1] = var3.cellFont[var27][var22 + var19];
                              var3.cellFont[var27][var22 + var19] = null;
                           }

                           var3.currentText[var25][var22 + var19] = JDPLang.get("Report0");
                           var3.cellFont[var25][var22 + var19] = this.user.boldFont;

                           for(int var28 = var25 + 1; var28 < var12; ++var28) {
                              if (var14[var28]) {
                                 var3.currentText[var28][var22 + var19] = this.JDPMaskEditMain.formatFloat(var10[var25][var28], var3.maskEdit[var28]);
                                 var3.cellFont[var28][var22 + var19] = this.user.boldFont;
                              }

                              var10[var25][var28] = (double)0.0F;
                           }

                           ++var19;
                        }

                        var3.currentText[var25][var22 + var19] = var26;
                     }
                  }

                  if (var18 > 0 && var22 > 0) {
                     try {
                        double var43 = Double.valueOf(this.JDPMaskEditMain.stripFloat(var15[var25]));

                        for(int var29 = 0; var29 < var18; ++var29) {
                           var10[var29][var25] += var43;
                           var11[var29][var25] += var43;
                        }
                     } catch (Exception var31) {
                     }
                  }

                  var15[var25] = var26;
               }
            }
         }

         for(int var38 = 0; var38 < var12; ++var38) {
            try {
               double var39 = Double.valueOf(this.JDPMaskEditMain.stripFloat(var15[var38]));

               for(int var44 = 0; var44 < var18; ++var44) {
                  var10[var44][var38] += var39;
                  var11[var44][var38] += var39;
               }
            } catch (Exception var30) {
            }
         }

         for(int var40 = var12 - 1; var40 >= 0; --var40) {
            if (var18 > var40 && var16[var40]) {
               var3.currentText[var40][var22 + var19] = JDPLang.get("Report0");
               var3.cellFont[var40][var22 + var19] = this.user.boldFont;

               for(int var41 = var40 + 1; var41 < var12; ++var41) {
                  if (var14[var41]) {
                     var3.currentText[var41][var22 + var19] = this.JDPMaskEditMain.formatFloat(var10[var40][var41], var3.maskEdit[var41]);
                     var3.cellFont[var41][var22 + var19] = this.user.boldFont;
                  }
               }

               ++var19;
            }
         }

         for(int var42 = var12 - 1; var42 >= 0; --var42) {
            if (var18 > var42 && var17[var42]) {
               var3.currentText[var42][var22 + var19] = JDPLang.get("Report1");
               var3.cellFont[var42][var22 + var19] = this.user.boldFont;

               for(int var45 = var42 + 1; var45 < var12; ++var45) {
                  if (var14[var45]) {
                     var3.currentText[var45][var22 + var19] = this.JDPMaskEditMain.formatFloat(var11[var42][var45], var3.maskEdit[var45]);
                     var3.cellFont[var45][var22 + var19] = this.user.boldFont;
                  }
               }

               ++var19;
            }
         }

         var3.newTable();
         this.user.mainmsg.clearStatusMsg();
      }
   }

   public void Report1LoadEmptyGrid() {
      JDPTextGrid var1 = this.Report1GL1;
      byte var2 = 5;
      var1.currentText = new String[var2][50];
      var1.cellChanged = null;
      var1.rowChanged = null;
      var1.columnSelected = null;
      var1.rowKey = new String[50][1];
      var1.newTable();
      var1.totalDataRows = 0;
   }

   void Report1SetGridSettings() {
      if (this.Report1 == null) {
         this.Report1 = new JDPTextGrid(this.user);
      }

      JDPTextGrid var1 = this.Report1GL1;
      byte var2 = 5;
      var1.columnHeader = null;
      var1.columnHeaderStyle = new int[var2];
      var1.columnStyle = new int[var2];
      var1.columnHeaderColor = new Color[var2];
      var1.columnColor = new Color[var2];
      var1.columnBGColor = new Color[var2];
      var1.gridColor = Color.white;
      var1.columnProtected = new boolean[var2];
      var1.columnWidth = new int[var2];
      var1.rightJustify = new boolean[var2];
      var1.rowHeader = null;
      var1.columnHeight = null;
      var1.maskEdit = new String[var2];
      var1.maskType = new String[var2];

      for(int var3 = 0; var3 < var2; ++var3) {
         var1.columnHeaderStyle[var3] = 1;
         var1.columnStyle[var3] = 0;
         var1.columnHeaderColor[var3] = Color.black;
         var1.columnColor[var3] = Color.black;
         var1.columnBGColor[var3] = Color.white;
         var1.columnStyle[var3] = 0;
      }

      var1.columnProtected[0] = true;
      var1.columnProtected[1] = true;
      var1.columnProtected[2] = true;
      var1.columnProtected[3] = true;
      var1.columnProtected[4] = true;
      var1.columnWidth[0] = 205;
      var1.columnWidth[1] = 88;
      var1.columnWidth[2] = 133;
      var1.columnWidth[3] = 56;
      var1.columnWidth[4] = 72;
      var1.rightJustify[4] = true;
      var1.maskEdit[4] = "999,999,999,999";
      var1.maskType[4] = "Float";
      this.Report1LoadEmptyGrid();
   }

   public void Report1WhereClauseMain() {
      String[] var1 = new String[2];
      String[] var2 = new String[2];
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      var1[0] = "Order Date";
      var2[0] = "format(a.ord_date, 'yyyy/mm/dd')";
      var1[1] = "Store Name";
      var2[1] = "b.stor_id";
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      var3.addElement(new Vector());
      var4.addElement(new Vector());
      ((Vector)var3.elementAt(0)).addElement("Equal to");
      ((Vector)var4.elementAt(0)).addElement("=");
      ((Vector)var3.elementAt(0)).addElement("Greater than");
      ((Vector)var4.elementAt(0)).addElement(">");
      ((Vector)var3.elementAt(0)).addElement("Less than");
      ((Vector)var4.elementAt(0)).addElement("<");
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      JDPLoadChoice var5 = new JDPLoadChoice(this.user, this.jaggSQL, (Object)null, "", "", "", "", -1);
      var5.loadChoice((Vector)var3.elementAt(1), "stor_name", "stor_id", "dbo_stores", "(1=1)", (Vector)var4.elementAt(1), 12);
      int[] var6 = new int[2];
      boolean[] var7 = new boolean[2];
      var6[0] = 21;
      var7[0] = true;
      var6[1] = 0;
      var7[1] = true;
      this.Report1SP1 = new JDPWhereClause(this.user, super.targetPanel, "", true, "Store Name", var1, var2, var3, var4, (String[][])null, (String[][])null, var6, var7, "FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)");
      this.Report1SP1.setDSNType("ACCESS");
      this.Report1SP1.setDataType(0, 11);
      this.Report1SP1.setDataType(1, 12);
   }

   public void Report1SearchResultsMain() {
   }
}
