import java.awt.BorderLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class StoreInquiry extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   Panel Columns1;
   JDPScrollPanel ScrollPanel1;
   Label stor_idLabel1;
   TextField stor_id1;
   Label stor_nameLabel1;
   TextField stor_name1;
   Label stor_addressLabel1;
   TextField stor_address1;
   Label cityLabel1;
   JDPChoice city1;
   Vector valuecity1;
   Label stateLabel1;
   Panel stateLine1;
   Checkbox state1;
   Checkbox state11;
   Checkbox state12;
   Label zipLabel1;
   JDPComboBox zip1;
   Vector valuezip1;
   JDPSearchResults ResultList1;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      CheckboxGroup var4 = new CheckboxGroup();
      this.Main = new Panel();
      this.Columns1 = new Panel();
      this.ScrollPanel1 = new JDPScrollPanel();
      this.stor_idLabel1 = new Label("Stor Id:", 0);
      this.stor_id1 = new TextField("stor_id", 6);
      this.stor_nameLabel1 = new Label("Stor name:", 0);
      this.stor_name1 = new TextField("stor_name", 42);
      this.stor_addressLabel1 = new Label("Stor Address:", 0);
      this.stor_address1 = new TextField("stor_address", 42);
      this.cityLabel1 = new Label("City:", 0);
      this.city1 = new JDPChoice();
      this.stateLabel1 = new Label("State:", 0);
      this.stateLine1 = new Panel();
      this.state1 = new Checkbox("CA", var4, false);
      this.state11 = new Checkbox("WA", var4, false);
      this.state12 = new Checkbox("OR", var4, false);
      this.zipLabel1 = new Label("Zip:", 0);
      this.zip1 = new JDPComboBox(var1);
      this.ResultList1Main();
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.Columns1);
      this.Columns1.setLayout(new BorderLayout());
      this.Columns1Main();
      this.Columns1.add("Center", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.stor_idLabel1);
      this.ScrollPanel1.add("Right", this.stor_id1);
      this.ScrollPanel1.add("Left", this.stor_nameLabel1);
      this.ScrollPanel1.add("Right", this.stor_name1);
      this.ScrollPanel1.add("Left", this.stor_addressLabel1);
      this.ScrollPanel1.add("Right", this.stor_address1);
      this.ScrollPanel1.add("Left", this.cityLabel1);
      this.ScrollPanel1.add("Right", this.city1);
      this.ScrollPanel1.add("Left", this.stateLabel1);
      this.ScrollPanel1.add("Right", this.stateLine1);
      this.stateLine1.setLayout(new JDPLineLayout());
      this.stateLine1.add("Left", this.state1);
      this.stateLine1.add("Left", this.state11);
      this.stateLine1.add("Left", this.state12);
      this.ScrollPanel1.add("Left", this.zipLabel1);
      this.ScrollPanel1.add("Right", this.zip1);
      this.Main.add("West", this.ResultList1);
      this.popuppanel.addComponent(this.stor_id1, "Stor Id", "");
      this.popuppanel.addComponent(this.stor_name1, "Stor name", "");
      this.popuppanel.addComponent(this.stor_address1, "Stor Address", "");
      this.popuppanel.addComponent(this.city1, "City", "");
      this.popuppanel.addComponent(this.state1, "State", "");
      this.popuppanel.addComponent(this.state11, "State", "");
      this.popuppanel.addComponent(this.state12, "State", "");
      this.popuppanel.addComponent(this.zip1, "Zip", "");
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.ResultList1)) {
               this.Columns1Load(this.ResultList1.getSelectedKey());
               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
   }

   public void Columns1Main() {
      this.Columns1LoadChoices();
      this.Columns1ClearFields();
   }

   public void Columns1Load(String[] var1) {
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = this.jaggSQL.getSEP();
      if (var1 != null && var1.length >= 0) {
         String var8 = "SELECT stor_id,stor_name,stor_address,city,state,zip FROM dbo_stores WHERE (1=1)";
         if (var1.length > 0 && var1[0] != null) {
            var8 = var8 + " AND stor_id='" + var1[0] + "'";
         }

         this.jaggSQL.setDSN("JDP Tutorial");
         this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
         this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
         this.jaggSQL.setJdbcSuffix("JDP Tutorial");
         this.jaggSQL.setUID("");
         this.jaggSQL.setPWD("");
         this.jaggSQL.setCSTR(" ");
         this.jaggSQL.setMRW("1000");
         this.jaggSQL.setTOUT("60");
         this.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var3 = this.jaggSQL.execSQL(var8, var4);
         if (var3 == -1) {
            this.user.u.setSqlMessage(this.jaggSQL, var8);
         } else if (var3 >= 1) {
            String var6 = (String)var4.elementAt(0);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var2 = new StringTokenizer(var6);
               this.stor_id1.setText(var2.nextToken(var5).trim());
               this.stor_name1.setText(var2.nextToken(var5).trim());
               this.stor_address1.setText(var2.nextToken(var5).trim());
               String var7 = var2.nextToken(var5).trim();
               if (this.valuecity1.indexOf(var7) >= 0) {
                  this.city1.select(this.valuecity1.indexOf(var7));
               }

               var7 = var2.nextToken(var5).trim();
               this.state1.setState(var7.equals("CA"));
               this.state11.setState(var7.equals("WA"));
               this.state12.setState(var7.equals("OR"));
               this.zip1.setText(var2.nextToken(var5).trim());
            }

            if (var3 > 1) {
               this.user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
            } else {
               this.user.mainmsg.clearStatusMsg();
            }
         } else {
            this.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
            this.Columns1ClearFields();
         }
      } else {
         this.Columns1ClearFields();
      }
   }

   public boolean Columns1updateRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "U") : false;
   }

   public boolean Columns1insertRow(String[] var1) {
      return this.Columns1CheckFields() ? this.Columns1Save(var1, "I") : false;
   }

   public boolean Columns1removeRow(String[] var1) {
      return this.Columns1Save(var1, "D");
   }

   boolean Columns1Save(String[] var1, String var2) {
      int var3 = 0;
      Vector var4 = new Vector();
      this.jaggSQL.getSEP();
      String var5 = "";
      if (var2.equals("I")) {
         var5 = "INSERT INTO dbo_stores (stor_id, stor_name, stor_address, city, state, zip) VALUES('" + this.user.u.replace(this.stor_id1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.stor_name1.getText(), "'", "''") + "', " + "'" + this.user.u.replace(this.stor_address1.getText(), "'", "''") + "', " + "'" + (String)this.valuecity1.elementAt(this.city1.getSelectedIndex()) + "', " + "'" + (this.state1.getState() ? "CA" : (this.state11.getState() ? "WA" : (this.state12.getState() ? "OR" : " "))) + "', " + "'" + this.user.u.replace(this.zip1.getText(), "'", "''") + "')";
      } else {
         if (var1 == null || var1.length == 0) {
            this.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         if (var2.equals("D")) {
            var5 = "DELETE FROM dbo_stores WHERE stor_id='" + var1[0] + "'";
         } else {
            var5 = "UPDATE dbo_stores SET stor_name = '" + this.user.u.replace(this.stor_name1.getText(), "'", "''") + "', " + "stor_address = '" + this.user.u.replace(this.stor_address1.getText(), "'", "''") + "', " + "city = '" + (String)this.valuecity1.elementAt(this.city1.getSelectedIndex()) + "', " + "state = '" + (this.state1.getState() ? "CA" : (this.state11.getState() ? "WA" : (this.state12.getState() ? "OR" : " "))) + "', " + "zip = '" + this.user.u.replace(this.zip1.getText(), "'", "''") + "'" + " WHERE stor_id='" + var1[0] + "'";
         }
      }

      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var3 = this.jaggSQL.execSQL(var5, var4);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.jaggSQL, var5);
         return false;
      } else {
         if (var3 == 1) {
            if (var2.equals("I")) {
               this.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (var2.equals("D")) {
               this.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               this.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            this.user.u.setSqlMessage(this.jaggSQL, var5);
         }

         return true;
      }
   }

   public void Columns1ClearFields() {
      this.stor_id1.setText("");
      this.stor_name1.setText("");
      this.stor_address1.setText("");
      this.city1.select(0);
      this.state1.setState(false);
      this.state11.setState(false);
      this.state12.setState(false);
      this.zip1.setText("");
   }

   void Columns1LoadChoices() {
      this.jaggSQL.setDSN("JDP Tutorial");
      this.jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
      this.jaggSQL.setJdbcPrefix("jdbc:odbc:");
      this.jaggSQL.setJdbcSuffix("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setCSTR(" ");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      this.valuecity1 = new Vector();
      new JDPLoadChoice(this.user, this.jaggSQL, this.city1, "city", "city", "dbo_stores", "(1=1)", this.valuecity1);
      new JDPLoadChoice(this.user, this.jaggSQL, this.zip1, "zip", "zip", "dbo_stores", "(1=1)", (Vector)null);
   }

   public boolean Columns1CheckFields() {
      return true;
   }

   public void ResultList1Main() {
      String var1 = "stor_id";
      String[] var2 = new String[0];
      String var3 = "(1=1)";
      String[] var4 = new String[]{"Stor name"};
      String[] var5 = new String[]{"stor_name"};
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.setDSN("JDP Tutorial");
      var6.setUID("");
      var6.setPWD("");
      var6.setMRW("1000");
      var6.setTOUT("60");
      this.ResultList1 = new JDPSearchResults(this.user, super.targetPanel, true, var6, false, var1, var2, var3, var4, var5, var5, "", true, "Total Entries:");
      int[] var7 = new int[8];
      var7[0] = 3;
      var7[1] = 5;
      this.ResultList1.setMinWidth(130);
      this.ResultList1.setIcons(var7);
      this.ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
      this.ResultList1.clearList("");
      this.ResultList1.loadList();
   }
}
