package javax.ejb;

import java.security.Identity;
import java.util.Properties;
import javax.jts.UserTransaction;

public interface EJBContext {
   EJBHome getEJBHome();

   Properties getEnvironment();

   Identity getCallerIdentity();

   boolean isCallerInRole(Identity var1);

   UserTransaction getUserTransaction() throws IllegalStateException;

   void setRollbackOnly();

   boolean getRollbackOnly();
}
