package javax.ejb.deployment;

public class SessionDescriptor extends DeploymentDescriptor {
   public static final int STATELESS_SESSION = 0;
   public static final int STATEFUL_SESSION = 1;
   private int sessionTimeout;
   private int stateManagementType = 1;

   public int getSessionTimeout() {
      return this.sessionTimeout;
   }

   public void setSessionTimeout(int var1) {
      this.sessionTimeout = var1;
   }

   public int getStateManagementType() {
      return this.stateManagementType;
   }

   public void setStateManagementType(int var1) {
      if (var1 != 1 && var1 != 0) {
         throw new IllegalArgumentException("Illegal value of session stateManagementType");
      } else {
         this.stateManagementType = var1;
      }
   }
}
