package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class Oclose extends TTIfun {
   private final boolean DEBUG = false;
   private int cursor_id;
   private final int metaDataSize = 5;
   private final int ptrDataSize;

   public Oclose(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv, TTCStatement stmt, byte code) throws IOException, SQLException {
      super(types, sqlnet, conv);
      this.cursor_id = stmt.getCursor();
      super.ttcCode = 3;
      super.funCode = code;
      super.seqNumber = 0;
      ((TTIMsg)this).initBuffers(7, 0);
      this.marshal();
   }

   public void receive() throws SQLException, IOException {
      boolean cursor_closed = false;

      while(!cursor_closed) {
         byte code = ((TTIMsg)this).unmarshalSB1();
         switch (code) {
            case 4:
               TTIoer oer = new TTIoer(super.types, super.sqlnet, super.conv);
               oer.unmarshal();
               oer.processError();
            default:
               DBError.check_error((short)1);
               break;
            case 9:
               cursor_closed = true;
         }
      }

   }

   private void marshal() throws IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB1((short)super.funCode, false);
      ((TTIMsg)this).marshalUB1((short)super.seqNumber, false);
      ((TTIMsg)this).marshalSWORD(this.cursor_id, false);
   }
}
