package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class Ocommoncall extends TTIfun {
   private final boolean DEBUG = false;
   private final int metaDataSize = 10;
   private final int ptrDataSize;

   public Ocommoncall(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv, byte messagecode) throws IOException, SQLException {
      super(types, sqlnet, conv);
      super.ttcCode = 3;
      super.funCode = messagecode;
      super.seqNumber = 0;
      ((TTIMsg)this).initBuffers(12, 0);
      this.marshal();
   }

   public void receive() throws SQLException, IOException {
      boolean rpaProcessed = false;

      while(true) {
         byte code = ((TTIMsg)this).unmarshalSB1();
         switch (code) {
            case 4:
               TTIoer oer = new TTIoer(super.types, super.sqlnet, super.conv);
               oer.unmarshal();
               oer.processError();
               return;
            case 9:
               return;
            default:
               DBError.check_error((short)1);
         }
      }
   }

   private void marshal() throws IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB1((short)super.funCode, false);
      ((TTIMsg)this).marshalUB1((short)super.seqNumber, false);
   }
}
